# DAMASK - The Düsseldorf Advanced Material Simulation Kit

- Usage, installation, and support: https://damask.mpie.de
- Code development: https://git.damask.mpie.de
- General inquiries: damask@mpie.de


## Repository Locations

### [git.damask.mpie.de](https://git.damask.mpie.de)

All code development is centralized in the principal DAMASK code repository hosted at [git.damask.mpie.de](https://git.damask.mpie.de).
Access to this GitLab instance requires registration and is granted to anyone with an interest in actively supporting the development of DAMASK.

### [github.com](https://github.com)

GitHub hosts the publicly accessible, but read-only, mirror of the principal DAMASK code repository and replicates its three top-level branches from [git.damask.mpie.de](https://git.damask.mpie.de).

The site is primarily meant to provide a forum for [Discussions](https://github.com/eisenforschung/DAMASK/discussions) and [Issues](https://github.com/eisenforschung/DAMASK/issues).


## Contact Information

Max-Planck-Institut für Eisenforschung GmbH  
Max-Planck-Str. 1  
40237 Düsseldorf  
Germany  

## Version Information

Revision v3.0.0-alpha8  
Exported on Tue 14 Nov 2023 17:07:40 CET  

DAMASK - The Düsseldorf Advanced Material Simulation Kit
Visit damask.mpie.de for installation and usage instructions

CONTACT INFORMATION

Max-Planck-Institut für Eisenforschung GmbH
Max-Planck-Str. 1
40237 Düsseldorf
Germany

damask@mpie.de
https://damask.mpie.de
https://magit1.mpie.de

# DAMASK - The Düsseldorf Advanced Material Simulation Kit

- Usage, installation, and support: https://damask-multiphysics.org
- Code development: https://git.damask-multiphysics.org
- General inquiries: support@damask-multiphysics.org


## Repository Locations

### [git.damask-multiphysics.org](https://git.damask-multiphysics.org)

All code development is centralized in the principal DAMASK code repository hosted at [git.damask-multiphysics.org](https://git.damask-multiphysics.org).
Access to this GitLab instance requires registration and is granted to anyone with an interest in actively supporting the development of DAMASK.

### [github.com](https://github.com/damask-multiphysics/DAMASK)

GitHub hosts the publicly accessible, but read-only, mirror of the principal DAMASK code repository and replicates its most relevant branches from [git.damask-multiphysics.org](https://git.damask-multiphysics.org).

The site is primarily meant to provide a forum for [Discussions](https://github.com/damask-multiphysics/DAMASK/discussions) and [Issues](https://github.com/damask-multiphysics/DAMASK/issues).


## Contact Information

Max-Planck-Institut für Nachhaltige Materialien GmbH  
Max-Planck-Str. 1  
40237 Düsseldorf  
Germany

## Version Information

Revision v3.1.0  
Exported on Thu 09 Jul 2026 23:29:22 CEST  

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, KU Leuven
!> @brief Polynomial representation for variable data.
!--------------------------------------------------------------------------------------------------
module polynomials
  use prec
  use IO
  use YAML
  use types

  implicit none(type,external)
  private

  type, public :: tPolynomial
    real(pREAL), dimension(:), allocatable :: coef
    real(pREAL) :: x_ref = huge(0.0_pREAL)
    contains
    procedure, public :: at => eval
  end type tPolynomial

  interface polynomial
    module procedure polynomial_from_coef
    module procedure polynomial_from_dict
  end interface polynomial

  public :: &
    polynomial, &
    polynomials_init, &
    polynomials_selfTest

contains


!--------------------------------------------------------------------------------------------------
!> @brief Run self-test.
!--------------------------------------------------------------------------------------------------
subroutine polynomials_init()

  print'(/,1x,a)', '<<<+-  polynomials init  -+>>>'; flush(IO_STDOUT)

  call polynomials_selfTest()

end subroutine polynomials_init


!--------------------------------------------------------------------------------------------------
!> @brief Initialize a polynomial from coefficients.
!--------------------------------------------------------------------------------------------------
pure function polynomial_from_coef(coef,x_ref) result(p)

  real(pREAL), dimension(0:), intent(in) :: coef
  real(pREAL), intent(in) :: x_ref
  type(tPolynomial) :: p


  p%coef = coef
  p%x_ref = x_ref

end function polynomial_from_coef


!--------------------------------------------------------------------------------------------------
!> @brief Initialize a polynomial from a dictionary with coefficients.
!> @details Coefficients up to order 8 are considered.
!> Not thread-safe on GFortran due to string concatenation.
!--------------------------------------------------------------------------------------------------
function polynomial_from_dict(dict,y,x) result(p)

  type(tDict), intent(in) :: dict
  character(len=*), intent(in) :: y, x
  type(tPolynomial) :: p

  real(pREAL), dimension(:), allocatable :: coef
  integer :: i, o
  character :: o_s


  allocate(coef(1),source=dict%get_asReal(y))

  if (dict%contains(y//','//x)) coef = [coef,dict%get_asReal(y//','//x)]
  do o = 2,8
    write(o_s,'(I0.0)') o
    if (dict%contains(y//','//x//'^'//o_s)) &
      coef = [coef,[(0.0_pREAL,i=size(coef),o-1)],dict%get_asReal(y//','//x//'^'//o_s)]
  end do

  if (size(coef) > 1) then
    p = polynomial(coef,dict%get_asReal(x//'_ref'))
  else
    p = polynomial(coef,-huge(1.0_pREAL))
  end if

end function polynomial_from_dict


!--------------------------------------------------------------------------------------------------
!> @brief Evaluate a polynomial.
!> @details https://nvlpubs.nist.gov/nistpubs/jres/71b/jresv71bn1p11_a1b.pdf (eq. 1.2)
!--------------------------------------------------------------------------------------------------
pure function eval(self,x) result(y)

  class(tPolynomial), intent(in) :: self
  real(pREAL), intent(in) :: x
  real(pREAL) :: y

  integer :: o


  y = self%coef(ubound(self%coef,1))
  do o = ubound(self%coef,1)-1, 0, -1
    y = y*(x-self%x_ref) + self%coef(o)
  end do

end function eval


!--------------------------------------------------------------------------------------------------
!> @brief Check correctness of polynomical functionality.
!--------------------------------------------------------------------------------------------------
subroutine polynomials_selfTest()

  type(tPolynomial) :: p1, p2
  real(pREAL), dimension(5) :: coef
  integer :: i
  real(pREAL) :: x_ref, x, y
  type(tDict), pointer :: dict
  character(len=pSTRLEN), dimension(size(coef)) :: coef_s
  character(len=pSTRLEN) :: x_ref_s, x_s, YAML_s


  call random_number(coef)
  call random_number(x_ref)
  call random_number(x)

  coef = 10_pREAL*(coef-0.5_pREAL)
  x_ref = 10_pREAL*(x_ref-0.5_pREAL)
  x = 10_pREAL*(x-0.5_pREAL)

  p1 = polynomial([coef(1)],x_ref)
  if (dNeq(p1%at(x),coef(1)))      error stop 'polynomial: eval(constant)'

  p1 = polynomial(coef,x_ref)
  if (dNeq(p1%at(x_ref),coef(1)))  error stop 'polynomial: @ref'

  do i = 1, size(coef_s)
    write(coef_s(i),*) coef(i)
  end do
  write(x_ref_s,*) x_ref
  write(x_s,*) x
  YAML_s = 'C: '//trim(adjustl(coef_s(1)))//IO_EOL//&
           'C,T: '//trim(adjustl(coef_s(2)))//IO_EOL//&
           'C,T^2: '//trim(adjustl(coef_s(3)))//IO_EOL//&
           'C,T^3: '//trim(adjustl(coef_s(4)))//IO_EOL//&
           'C,T^4: '//trim(adjustl(coef_s(5)))//IO_EOL//&
           'T_ref: '//trim(adjustl(x_ref_s))//IO_EOL
  dict => YAML_str_asDict(trim(YAML_s))
  p2 = polynomial(dict,'C','T')
  if (dNeq(p1%at(x),p2%at(x),1.0e-6_pREAL))                      error stop 'polynomials: init'
  y = coef(1)*(x-x_ref)**0 &
    + coef(2)*(x-x_ref)**1 &
    + coef(3)*(x-x_ref)**2 &
    + coef(4)*(x-x_ref)**3 &
    + coef(5)*(x-x_ref)**4
  if (dNeq(p1%at(x),y,1.0e-6_pREAL))                             error stop 'polynomials: eval(full)'

  YAML_s = 'C: 0.0'//IO_EOL//&
           'C,T: '//trim(adjustl(coef_s(2)))//IO_EOL//&
           'T_ref: '//trim(adjustl(x_ref_s))//IO_EOL
  dict => YAML_str_asDict(trim(YAML_s))
  p1 = polynomial(dict,'C','T')
  if (dNeq(p1%at(x_ref+x),-p1%at(x_ref-x),1.0e-10_pREAL))         error stop 'polynomials: eval(linear)'

  YAML_s = 'C: 0.0'//IO_EOL//&
           'C,T^2: '//trim(adjustl(coef_s(3)))//IO_EOL//&
           'T_ref: '//trim(adjustl(x_ref_s))//IO_EOL
  dict => YAML_str_asDict(trim(YAML_s))
  p1 = polynomial(dict,'C','T')
  if (dNeq(p1%at(x_ref+x),p1%at(x_ref-x),1e-10_pREAL))            error stop 'polynomials: eval(quadratic)'

  YAML_s = 'Y: '//trim(adjustl(coef_s(1)))//IO_EOL//&
           'Y,X^3: '//trim(adjustl(coef_s(2)))//IO_EOL//&
           'X_ref: '//trim(adjustl(x_ref_s))//IO_EOL
  dict => YAML_str_asDict(trim(YAML_s))
  p1 = polynomial(dict,'Y','X')
  if (dNeq(p1%at(x_ref+x)-coef(1),-(p1%at(x_ref-x)-coef(1)),1.0e-8_pREAL)) error stop 'polynomials: eval(cubic)'

  YAML_s = 'Y: '//trim(adjustl(coef_s(1)))//IO_EOL//&
           'Y,X^4: '//trim(adjustl(coef_s(2)))//IO_EOL//&
           'X_ref: '//trim(adjustl(x_ref_s))//IO_EOL
  dict => YAML_str_asDict(trim(YAML_s))
  p1 = polynomial(dict,'Y','X')
  if (dNeq(p1%at(x_ref+x),p1%at(x_ref-x),1.0e-6_pREAL))           error stop 'polynomials: eval(quartic)'


end subroutine polynomials_selfTest

end module polynomials

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
! ###################################################################
! Copyright (c) 2013-2014, Marc De Graef/Carnegie Mellon University
! Modified      2017-2020, Martin Diehl/Max-Planck-Institut für Eisenforschung GmbH
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without modification, are
! permitted provided that the following conditions are met:
!
!     - Redistributions of source code must retain the above copyright notice, this list
!        of conditions and the following disclaimer.
!     - Redistributions in binary form must reproduce the above copyright notice, this
!        list of conditions and the following disclaimer in the documentation and/or
!        other materials provided with the distribution.
!     - Neither the names of Marc De Graef, Carnegie Mellon University nor the names
!        of its contributors may be used to endorse or promote products derived from
!        this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
! ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
! LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
! OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
! USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
! ###################################################################

!--------------------------------------------------------------------------------------------------
!> @author Marc De Graef, Carnegie Mellon University
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief rotation storage and conversion
!> @details: rotation is internally stored as quaternion. It can be inialized from different
!> representations and also returns itself in different representations.
!
!  All methods and naming conventions based on Rowenhorst et al. 2015
!    Convention 1: coordinate frames are right-handed
!    Convention 2: a rotation angle ω is taken to be positive for a counterclockwise rotation
!                  when viewing from the end point of the rotation axis towards the origin
!    Convention 3: rotations will be interpreted in the passive sense
!    Convention 4: Euler angle triplets are implemented using the Bunge convention,
!                  with the angular ranges as [0, 2π],[0, π],[0, 2π]
!    Convention 5: the rotation angle ω is limited to the interval [0, π]
!    Convention 6: the real part of a quaternion is positive, Re(q) > 0
!    Convention 7: P = -1
!--------------------------------------------------------------------------------------------------

module rotations
  use IO
  use math

  implicit none(type,external)
  private

  real(pREAL), parameter :: P = -1.0_pREAL                                                          !< parameter for orientation conversion.

  type, public :: tRotation
    real(pREAL), dimension(4) :: q
    contains
      procedure, public :: asQuaternion
      procedure, public :: asEulers
      procedure, public :: asAxisAngle
      procedure, public :: asMatrix
      !------------------------------------------
      procedure, public :: fromQuaternion
      procedure, public :: fromEulers
      procedure, public :: fromAxisAngle
      procedure, public :: fromMatrix
      !------------------------------------------
      procedure, private :: rotRot__
      generic,   public  :: operator(*) => rotRot__
      generic,   public  :: rotate => rotVector,rotTensor2,rotTensor4
      procedure, public  :: rotVector
      procedure, public  :: rotTensor2
      procedure, public  :: rotTensor4
      procedure, public  :: rotStiffness
      procedure, public  :: misorientation
      procedure, public  :: standardize
  end type tRotation

  real(pREAL), parameter :: &
    PREF = sqrt(6.0_pREAL/PI), &
    A    = PI**(5.0_pREAL/6.0_pREAL)/6.0_pREAL**(1.0_pREAL/6.0_pREAL), &
    AP   = PI**(2.0_pREAL/3.0_pREAL), &
    SC   = A/AP, &
    BETA = A/2.0_pREAL, &
    R1   = (3.0_pREAL*PI/4.0_pREAL)**(1.0_pREAL/3.0_pREAL), &
    R2   = sqrt(2.0_pREAL), &
    PI12 = PI/12.0_pREAL, &
    PREK = R1 * 2.0_pREAL**(1.0_pREAL/4.0_pREAL)/BETA

  public :: &
    rotations_init, &
    rotations_selfTest, &
    eu2om

contains

!--------------------------------------------------------------------------------------------------
!> @brief Do self test.
!--------------------------------------------------------------------------------------------------
subroutine rotations_init()

  print'(/,1x,a)', '<<<+-  rotations init  -+>>>'; flush(IO_STDOUT)

  print'(/,1x,a)', 'D. Rowenhorst et al., Modelling and Simulation in Materials Science and Engineering 23:083501, 2015'
  print'(  1x,a)', 'https://doi.org/10.1088/0965-0393/23/8/083501'

  call rotations_selfTest()

end subroutine rotations_init


!--------------------------------------------------------------------------------------------------
! Return rotation in different representations.
!--------------------------------------------------------------------------------------------------
pure function asQuaternion(self)

  class(tRotation), intent(in) :: self
  real(pREAL), dimension(4)    :: asQuaternion


  asQuaternion = self%q

end function asQuaternion
!--------------------------------------------------------------------------------------------------
pure function asEulers(self)

  class(tRotation), intent(in) :: self
  real(pREAL), dimension(3)    :: asEulers


  asEulers = qu2eu(self%q)

end function asEulers
!--------------------------------------------------------------------------------------------------
pure function asAxisAngle(self)

  class(tRotation), intent(in) :: self
  real(pREAL), dimension(4)    :: asAxisAngle


  asAxisAngle = qu2ax(self%q)

end function asAxisAngle
!--------------------------------------------------------------------------------------------------
pure function asMatrix(self)

  class(tRotation), intent(in) :: self
  real(pREAL), dimension(3,3)  :: asMatrix


  asMatrix = qu2om(self%q)

end function asMatrix

!--------------------------------------------------------------------------------------------------
! Initialize rotation from different representations.
!--------------------------------------------------------------------------------------------------
! recursive: workaround for https://gcc.gnu.org/bugzilla/show_bug.cgi?id=115348, but seems to cause no harm
recursive subroutine fromQuaternion(self,qu)

  class(tRotation), intent(out)         :: self
  real(pREAL), dimension(4), intent(in) :: qu


  if (dNeq(norm2(qu),1.0_pREAL,1.0e-8_pREAL)) call IO_error(402_pI16,'fromQuaternion')

  self%q = qu

end subroutine fromQuaternion
!--------------------------------------------------------------------------------------------------
recursive subroutine fromEulers(self,eu,degrees)

  class(tRotation), intent(out)         :: self
  real(pREAL), dimension(3), intent(in) :: eu
  logical, intent(in), optional         :: degrees

  real(pREAL), dimension(3)             :: Eulers


  Eulers = merge(eu*INRAD,eu,misc_optional(degrees,.false.))

  if (any(Eulers<0.0_pREAL) .or. any(Eulers>TAU) .or. Eulers(2) > PI) &
    call IO_error(402_pI16,'fromEulers')

  self%q = eu2qu(Eulers)

end subroutine fromEulers
!--------------------------------------------------------------------------------------------------
recursive subroutine fromAxisAngle(self,ax,degrees,P)

  class(tRotation), intent(out)         :: self
  real(pREAL), dimension(4), intent(in) :: ax
  logical, intent(in), optional         :: degrees
  integer, intent(in), optional         :: P

  real(pREAL)                           :: angle
  real(pREAL),dimension(3)              :: axis


  angle = merge(ax(4)*INRAD,ax(4),misc_optional(degrees,.false.))
  axis = ax(1:3) * merge(-1.0_pREAL,1.0_pREAL,misc_optional(P,-1) == 1)

  if (abs(misc_optional(P,-1)) /= 1) &
    call IO_error(402_pI16,'fromAxisAngle (P)')
  if (dNeq(norm2(axis),1.0_pREAL) .or. angle < 0.0_pREAL .or. angle > PI) &
    call IO_error(402_pI16,'fromAxisAngle')

  self%q = ax2qu([axis,angle])

end subroutine fromAxisAngle
!--------------------------------------------------------------------------------------------------
recursive subroutine fromMatrix(self,om)

  class(tRotation), intent(out)           :: self
  real(pREAL), dimension(3,3), intent(in) :: om


  if (dNeq(math_det33(om),1.0_pREAL,tol=1.0e-5_pREAL)) &
    call IO_error(402_pI16,'fromMatrix')

  self%q = om2qu(om)

end subroutine fromMatrix
!--------------------------------------------------------------------------------------------------


!--------------------------------------------------------------------------------------------------
!> @brief: Compose rotations.
!--------------------------------------------------------------------------------------------------
pure elemental function rotRot__(self,R) result(rRot)

  type(tRotation)              :: rRot
  class(tRotation), intent(in) :: self,R


  rRot = tRotation(multiplyQuaternion(self%q,R%q))
  call rRot%standardize()

end function rotRot__


!--------------------------------------------------------------------------------------------------
!> @brief Convert to quaternion representation with positive q(1).
!--------------------------------------------------------------------------------------------------
pure elemental subroutine standardize(self)

  class(tRotation), intent(inout) :: self


  if (sign(1.0_pREAL,self%q(1)) < 0.0_pREAL) self%q = - self%q

end subroutine standardize


!--------------------------------------------------------------------------------------------------
!> @brief Rotate a vector passively (default) or actively.
!> @details: Apply Rodrigues formula.
!--------------------------------------------------------------------------------------------------
pure function rotVector(self,v,active) result(vRot)

  real(pREAL),                 dimension(3) :: vRot
  class(tRotation), intent(in)              :: self
  real(pREAL),     intent(in), dimension(3) :: v
  logical,         intent(in), optional     :: active

  real(pREAL), dimension(4) :: q


  q = merge(conjugateQuaternion(self%q), self%q, misc_optional(active,.false.))
  vRot = rotate_vector(v, q)

end function rotVector


!--------------------------------------------------------------------------------------------------
!> @brief Rotate a rank-2 tensor passively (default) or actively.
!> @details: Apply Rodrigues formula to each index sequentially.
!--------------------------------------------------------------------------------------------------
pure function rotTensor2(self,T,active) result(tRot)

  real(pREAL),                 dimension(3,3) :: tRot
  class(tRotation), intent(in)                :: self
  real(pREAL),     intent(in), dimension(3,3) :: T
  logical,         intent(in), optional       :: active

  real(pREAL), dimension(4) :: q
  integer :: i,j


  q = merge(conjugateQuaternion(self%q), self%q, misc_optional(active,.false.))

  do i = 1,3
    tRot(i,:) = rotate_vector(T(i,:), q)
  end do

  do j = 1,3
    tRot(:,j) = rotate_vector(tRot(:,j), q)
  end do

end function rotTensor2


!--------------------------------------------------------------------------------------------------
!> @brief Rotate a rank-4 tensor passively (default) or actively.
!> @details: Apply Rodrigues formula to each index sequentially.
!--------------------------------------------------------------------------------------------------
pure function rotTensor4(self,T,active) result(tRot)

  real(pREAL),                 dimension(3,3,3,3) :: tRot
  class(tRotation), intent(in)                    :: self
  real(pREAL),     intent(in), dimension(3,3,3,3) :: T
  logical,         intent(in), optional           :: active

  real(pREAL), dimension(4) :: q
  integer :: i,j,k,l


  q = merge(conjugateQuaternion(self%q), self%q, misc_optional(active,.false.))

  do i = 1,3; do j = 1,3; do k = 1,3
    tRot(i,j,k,:) = rotate_vector(T(i,j,k,:), q)
  end do; end do; end do

  do i = 1,3; do j = 1,3; do l = 1,3
    tRot(i,j,:,l) = rotate_vector(tRot(i,j,:,l), q)
  end do; end do; end do

  do i = 1,3; do k = 1,3; do l = 1,3
    tRot(i,:,k,l) = rotate_vector(tRot(i,:,k,l), q)
  end do; end do; end do

  do j = 1,3; do k = 1,3; do l = 1,3
    tRot(:,j,k,l) = rotate_vector(tRot(:,j,k,l), q)
  end do; end do; end do

end function rotTensor4


!--------------------------------------------------------------------------------------------------
!> @brief Rotate a rank-4 stiffness tensor in Voigt 6x6 notation passively (default) or actively.
!> @details: https://scicomp.stackexchange.com/questions/35600
!! ToDo: Need to check active/passive !!!
!--------------------------------------------------------------------------------------------------
pure function rotStiffness(self,C,active) result(cRot)

  real(pREAL),                 dimension(6,6) :: cRot
  class(tRotation), intent(in)                :: self
  real(pREAL),     intent(in), dimension(6,6) :: C
  logical,         intent(in), optional       :: active

  real(pREAL), dimension(3,3) :: R
  real(pREAL), dimension(6,6) :: M


  R = merge(transpose(self%asMatrix()),self%asMatrix(),misc_optional(active,.false.))

  M = reshape([R(1,1)**2,                   R(2,1)**2,                   R(3,1)**2, &
               R(2,1)*R(3,1),               R(1,1)*R(3,1),               R(1,1)*R(2,1), &
               R(1,2)**2,                   R(2,2)**2,                   R(3,2)**2, &
               R(2,2)*R(3,2),               R(1,2)*R(3,2),               R(1,2)*R(2,2), &
               R(1,3)**2,                   R(2,3)**2,                   R(3,3)**2, &
               R(2,3)*R(3,3),               R(1,3)*R(3,3),               R(1,3)*R(2,3), &
               2.0_pREAL*R(1,2)*R(1,3),     2.0_pREAL*R(2,2)*R(2,3),     2.0_pREAL*R(3,2)*R(3,3), &
               R(2,2)*R(3,3)+R(2,3)*R(3,2), R(1,2)*R(3,3)+R(1,3)*R(3,2), R(1,2)*R(2,3)+R(1,3)*R(2,2), &
               2.0_pREAL*R(1,3)*R(1,1),     2.0_pREAL*R(2,3)*R(2,1),     2.0_pREAL*R(3,3)*R(3,1), &
               R(2,3)*R(3,1)+R(2,1)*R(3,3), R(1,3)*R(3,1)+R(1,1)*R(3,3), R(1,3)*R(2,1)+R(1,1)*R(2,3), &
               2.0_pREAL*R(1,1)*R(1,2),     2.0_pREAL*R(2,1)*R(2,2),     2.0_pREAL*R(3,1)*R(3,2), &
               R(2,1)*R(3,2)+R(2,2)*R(3,1), R(1,1)*R(3,2)+R(1,2)*R(3,1), R(1,1)*R(2,2)+R(1,2)*R(2,1)],[6,6])

  cRot = matmul(M,matmul(C,transpose(M)))

end function rotStiffness


!--------------------------------------------------------------------------------------------------
!> @brief Calculate misorientation.
!--------------------------------------------------------------------------------------------------
pure elemental function misorientation(self,other)

  type(tRotation)              :: misorientation
  class(tRotation), intent(in) :: self, other


  misorientation%q = multiplyQuaternion(other%q, conjugateQuaternion(self%q))

end function misorientation


!--------------------------------------------------------------------------------------------------
!> @author Marc De Graef, Carnegie Mellon University
!> @brief Convert unit quaternion to rotation matrix.
!--------------------------------------------------------------------------------------------------
pure function qu2om(qu) result(om)

  real(pREAL), intent(in), dimension(4)   :: qu
  real(pREAL),             dimension(3,3) :: om

  real(pREAL)                             :: qq


  qq = qu(1)**2-sum(qu(2:4)**2)

  om(1,1) = qq+2.0_pREAL*qu(2)**2
  om(2,2) = qq+2.0_pREAL*qu(3)**2
  om(3,3) = qq+2.0_pREAL*qu(4)**2

  om(1,2) = 2.0_pREAL*(qu(2)*qu(3)-qu(1)*qu(4))
  om(2,3) = 2.0_pREAL*(qu(3)*qu(4)-qu(1)*qu(2))
  om(3,1) = 2.0_pREAL*(qu(4)*qu(2)-qu(1)*qu(3))
  om(2,1) = 2.0_pREAL*(qu(3)*qu(2)+qu(1)*qu(4))
  om(3,2) = 2.0_pREAL*(qu(4)*qu(3)+qu(1)*qu(2))
  om(1,3) = 2.0_pREAL*(qu(2)*qu(4)+qu(1)*qu(3))

  if (sign(1.0_pREAL,P) < 0.0_pREAL) om = transpose(om)
  om = om/math_det33(om)**(1.0_pREAL/3.0_pREAL)

end function qu2om


!--------------------------------------------------------------------------------------------------
!> @author Marc De Graef, Carnegie Mellon University
!> @brief Convert unit quaternion to Bunge Euler angles.
!--------------------------------------------------------------------------------------------------
pure function qu2eu(qu) result(eu)

  real(pREAL), intent(in), dimension(4) :: qu
  real(pREAL),             dimension(3) :: eu

  real(pREAL)                           :: q12, q03, chi


  q03 = qu(1)**2+qu(4)**2
  q12 = qu(2)**2+qu(3)**2
  chi = sqrt(q03*q12)

  degenerated: if (dEq0(q12)) then
    eu = [atan2(-P*2.0_pREAL*qu(1)*qu(4),qu(1)**2-qu(4)**2), 0.0_pREAL, 0.0_pREAL]
  elseif          (dEq0(q03)) then
    eu = [atan2(   2.0_pREAL*qu(2)*qu(3),qu(2)**2-qu(3)**2), PI,        0.0_pREAL]
  else degenerated
    eu = [atan2((-P*qu(1)*qu(3)+qu(2)*qu(4))*chi, (-P*qu(1)*qu(2)-qu(3)*qu(4))*chi ), &
          atan2( 2.0_pREAL*chi, q03-q12 ), &
          atan2(( P*qu(1)*qu(3)+qu(2)*qu(4))*chi, (-P*qu(1)*qu(2)+qu(3)*qu(4))*chi )]
  end if degenerated
  where(sign(1.0_pREAL,eu)<0.0_pREAL) eu = mod(eu+TAU,[TAU,PI,TAU])

end function qu2eu


!--------------------------------------------------------------------------------------------------
!> @author Marc De Graef, Carnegie Mellon University
!> @brief Convert unit quaternion to axis-angle pair.
!--------------------------------------------------------------------------------------------------
pure function qu2ax(qu) result(ax)

  real(pREAL), intent(in), dimension(4) :: qu
  real(pREAL),             dimension(4) :: ax

  real(pREAL)                           :: omega, s


  if (dEq0(sum(qu(2:4)**2))) then
    ax = [ 0.0_pREAL, 0.0_pREAL, 1.0_pREAL, 0.0_pREAL ]                                             ! axis = [001]
  elseif (dNeq0(qu(1))) then
    s =  sign(1.0_pREAL,qu(1))/norm2(qu(2:4))
    omega = 2.0_pREAL * acos(math_clip(qu(1),-1.0_pREAL,1.0_pREAL))
    ax = [ qu(2)*s, qu(3)*s, qu(4)*s, omega ]
  else
    ax = [ qu(2),   qu(3),   qu(4),   PI ]
  end if

end function qu2ax


!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Convert rotation matrix to unit quaternion.
!> @details the original formulation (direct conversion) had (numerical?) issues
!--------------------------------------------------------------------------------------------------
pure function om2qu(om) result(qu)

  real(pREAL), intent(in), dimension(3,3) :: om
  real(pREAL),             dimension(4)   :: qu

  real(pREAL) :: trace,s
  trace = math_trace33(om)


  if (trace > 0.0_pREAL) then
    s = 0.5_pREAL / sqrt(trace+1.0_pREAL)
    qu = [0.25_pREAL/s, (om(3,2)-om(2,3))*s,(om(1,3)-om(3,1))*s,(om(2,1)-om(1,2))*s]
  else
      if ( om(1,1) > om(2,2) .and. om(1,1) > om(3,3) ) then
          s = 2.0_pREAL * sqrt( 1.0_pREAL + om(1,1) - om(2,2) - om(3,3))
          qu = [ (om(3,2) - om(2,3)) /s,0.25_pREAL * s,(om(1,2) + om(2,1)) / s,(om(1,3) + om(3,1)) / s]
      elseif (om(2,2) > om(3,3)) then
          s = 2.0_pREAL * sqrt( 1.0_pREAL + om(2,2) - om(1,1) - om(3,3))
          qu = [ (om(1,3) - om(3,1)) /s,(om(1,2) + om(2,1)) / s,0.25_pREAL * s,(om(2,3) + om(3,2)) / s]
      else
          s = 2.0_pREAL * sqrt( 1.0_pREAL + om(3,3) - om(1,1) - om(2,2) )
          qu = [ (om(2,1) - om(1,2)) /s,(om(1,3) + om(3,1)) / s,(om(2,3) + om(3,2)) / s,0.25_pREAL * s]
      end if
  end if
  if (sign(1.0_pREAL,qu(1))<0.0_pREAL) qu =-1.0_pREAL * qu
  qu(2:4) = merge(qu(2:4),qu(2:4)*P,dEq0(qu(2:4)))
  qu = qu/norm2(qu)

end function om2qu


!--------------------------------------------------------------------------------------------------
!> @author Marc De Graef, Carnegie Mellon University
!> @brief Convert orientation matrix to Bunge Euler angles.
!> @details Two step check for special cases to avoid invalid operations (not needed for python)
!--------------------------------------------------------------------------------------------------
pure function om2eu(om) result(eu)

  real(pREAL), intent(in), dimension(3,3) :: om
  real(pREAL),             dimension(3)   :: eu
  real(pREAL)                             :: zeta


  if    (dNeq(abs(om(3,3)),1.0_pREAL,1.e-8_pREAL)) then
    zeta = 1.0_pREAL/sqrt(math_clip(1.0_pREAL-om(3,3)**2,1e-64_pREAL,1.0_pREAL))
    eu = [atan2(om(3,1)*zeta,-om(3,2)*zeta), &
          acos(math_clip(om(3,3),-1.0_pREAL,1.0_pREAL)), &
          atan2(om(1,3)*zeta, om(2,3)*zeta)]
  else
    eu = [atan2(om(1,2),om(1,1)), 0.5_pREAL*PI*(1.0_pREAL-om(3,3)),0.0_pREAL ]
  end if
  where(abs(eu) < 1.e-8_pREAL) eu = 0.0_pREAL
  where(sign(1.0_pREAL,eu)<0.0_pREAL) eu = mod(eu+TAU,[TAU,PI,TAU])

end function om2eu


!--------------------------------------------------------------------------------------------------
!> @author Marc De Graef, Carnegie Mellon University
!> @brief Convert orientation matrix to axis-angle pair.
!--------------------------------------------------------------------------------------------------
function om2ax(om) result(ax)

  real(pREAL), intent(in), dimension(3,3) :: om
  real(pREAL),             dimension(4)   :: ax

  real(pREAL)                      :: t
  real(pREAL), dimension(3)        :: Wr, Wi
  real(pREAL), dimension((64+2)*3) :: work
  real(pREAL), dimension(3,3)      :: VR, devNull, om_
  integer                          :: ierr, i


  om_ = om

  ! first get the rotation angle
  t = 0.5_pREAL * (math_trace33(om) - 1.0_pREAL)
  ax(4) = acos(math_clip(t,-1.0_pREAL,1.0_pREAL))

  if (dEq0(ax(4))) then
    ax(1:3) = [ 0.0_pREAL, 0.0_pREAL, 1.0_pREAL ]
  else
    call dgeev('N','V',3,om_,3,Wr,Wi,devNull,3,VR,3,work,size(work,1),ierr)
    if (ierr /= 0) error stop 'LAPACK error'
    i = findloc(cEq(cmplx(Wr,Wi,pREAL),cmplx(1.0_pREAL,0.0_pREAL,pREAL),tol=1.0e-14_pREAL),.true.,dim=1) !find eigenvalue (1,0)
    if (i == 0) error stop 'om2ax conversion failed'
    ax(1:3) = VR(1:3,i)
    where (                dNeq0([om(2,3)-om(3,2), om(3,1)-om(1,3), om(1,2)-om(2,1)])) &
      ax(1:3) = sign(ax(1:3),-P *[om(2,3)-om(3,2), om(3,1)-om(1,3), om(1,2)-om(2,1)])
  end if

end function om2ax


!--------------------------------------------------------------------------------------------------
!> @author Marc De Graef, Carnegie Mellon University
!> @brief Convert Bunge Euler angles to unit quaternion.
!--------------------------------------------------------------------------------------------------
pure function eu2qu(eu) result(qu)

  real(pREAL), intent(in), dimension(3) :: eu
  real(pREAL),             dimension(4) :: qu
  real(pREAL),             dimension(3) :: ee
  real(pREAL)                           :: cPhi, sPhi


  ee = 0.5_pREAL*eu

  cPhi = cos(ee(2))
  sPhi = sin(ee(2))

  qu = [   cPhi*cos(ee(1)+ee(3)), &
        -P*sPhi*cos(ee(1)-ee(3)), &
        -P*sPhi*sin(ee(1)-ee(3)), &
        -P*cPhi*sin(ee(1)+ee(3))]
  if (sign(1.0_pREAL,qu(1)) < 0.0_pREAL) qu = qu * (-1.0_pREAL)

end function eu2qu


!--------------------------------------------------------------------------------------------------
!> @author Marc De Graef, Carnegie Mellon University
!> @brief Convert Euler angles to orientation matrix.
!--------------------------------------------------------------------------------------------------
pure function eu2om(eu) result(om)

  real(pREAL), intent(in), dimension(3)   :: eu
  real(pREAL),             dimension(3,3) :: om

  real(pREAL),             dimension(3)   :: c, s


  c = cos(eu)
  s = sin(eu)

  om(1,1) =  c(1)*c(3)-s(1)*s(3)*c(2)
  om(2,1) = -c(1)*s(3)-s(1)*c(3)*c(2)
  om(3,1) =  s(1)*s(2)
  om(1,2) =  s(1)*c(3)+c(1)*s(3)*c(2)
  om(2,2) = -s(1)*s(3)+c(1)*c(3)*c(2)
  om(3,2) = -c(1)*s(2)
  om(1,3) =  s(3)*s(2)
  om(2,3) =  c(3)*s(2)
  om(3,3) =  c(2)

  where(abs(om)<1.0e-12_pREAL) om = 0.0_pREAL

end function eu2om


!--------------------------------------------------------------------------------------------------
!> @author Marc De Graef, Carnegie Mellon University
!> @brief Convert Bunge Euler angles to axis-angle pair.
!--------------------------------------------------------------------------------------------------
pure function eu2ax(eu) result(ax)

  real(pREAL), intent(in), dimension(3) :: eu
  real(pREAL),             dimension(4) :: ax

  real(pREAL)                           :: t, delta, tau, alpha, sigma


  t     = tan(eu(2)*0.5_pREAL)
  sigma = 0.5_pREAL*(eu(1)+eu(3))
  delta = 0.5_pREAL*(eu(1)-eu(3))
  tau   = sqrt(t**2+sin(sigma)**2)

  alpha = merge(PI, 2.0_pREAL*atan(tau/cos(sigma)), dEq(sigma,PI*0.5_pREAL,tol=1.0e-15_pREAL))

  if (dEq0(alpha)) then                                                                             ! return a default identity axis-angle pair
    ax = [ 0.0_pREAL, 0.0_pREAL, 1.0_pREAL, 0.0_pREAL ]
  else
    ax(1:3) = -P/tau * [ t*cos(delta), t*sin(delta), sin(sigma) ]                                   ! passive axis-angle pair so a minus sign in front
    ax(4) = alpha
    if (sign(1.0_pREAL,alpha) < 0.0_pREAL) ax = -ax                                                 ! ensure alpha is positive
  end if

end function eu2ax


!--------------------------------------------------------------------------------------------------
!> @author Marc De Graef, Carnegie Mellon University
!> @brief Convert axis-angle pair to unit quaternion.
!--------------------------------------------------------------------------------------------------
pure function ax2qu(ax) result(qu)

  real(pREAL), intent(in), dimension(4) :: ax
  real(pREAL),             dimension(4) :: qu

  real(pREAL)                           :: c, s


  if (dEq0(ax(4))) then
    qu = [ 1.0_pREAL, 0.0_pREAL, 0.0_pREAL, 0.0_pREAL ]
  else
    c = cos(ax(4)*0.5_pREAL)
    s = sin(ax(4)*0.5_pREAL)
    qu = [ c, ax(1)*s, ax(2)*s, ax(3)*s ]
  end if

end function ax2qu


!--------------------------------------------------------------------------------------------------
!> @author Marc De Graef, Carnegie Mellon University
!> @brief Convert axis-angle pair to orientation matrix.
!--------------------------------------------------------------------------------------------------
pure function ax2om(ax) result(om)

  real(pREAL), intent(in), dimension(4)   :: ax
  real(pREAL),             dimension(3,3) :: om

  real(pREAL)                             :: q, c, s, omc


  c = cos(ax(4))
  s = sin(ax(4))
  omc = 1.0_pREAL-c

  om(1,1) = ax(1)**2*omc + c
  om(2,2) = ax(2)**2*omc + c
  om(3,3) = ax(3)**2*omc + c

  q = omc*ax(1)*ax(2)
  om(1,2) = q + s*ax(3)
  om(2,1) = q - s*ax(3)

  q = omc*ax(2)*ax(3)
  om(2,3) = q + s*ax(1)
  om(3,2) = q - s*ax(1)

  q = omc*ax(3)*ax(1)
  om(3,1) = q + s*ax(2)
  om(1,3) = q - s*ax(2)

  if (P > 0.0_pREAL) om = transpose(om)

end function ax2om


!--------------------------------------------------------------------------------------------------
!> @author Marc De Graef, Carnegie Mellon University
!> @brief Convert axis-angle pair to Bunge Euler angles.
!--------------------------------------------------------------------------------------------------
pure function ax2eu(ax) result(eu)

  real(pREAL), intent(in), dimension(4) :: ax
  real(pREAL),             dimension(3) :: eu


  eu = om2eu(ax2om(ax))

end function ax2eu


!--------------------------------------------------------------------------------------------------
!> @brief Multiply two quaternions.
!--------------------------------------------------------------------------------------------------
pure function multiplyQuaternion(qu1,qu2)

  real(pREAL), dimension(4), intent(in) :: qu1, qu2
  real(pREAL), dimension(4) :: multiplyQuaternion


  multiplyQuaternion(1) = qu1(1)*qu2(1) - qu1(2)*qu2(2) -      qu1(3)*qu2(3) - qu1(4)*qu2(4)
  multiplyQuaternion(2) = qu1(1)*qu2(2) + qu1(2)*qu2(1) + P * (qu1(3)*qu2(4) - qu1(4)*qu2(3))
  multiplyQuaternion(3) = qu1(1)*qu2(3) + qu1(3)*qu2(1) + P * (qu1(4)*qu2(2) - qu1(2)*qu2(4))
  multiplyQuaternion(4) = qu1(1)*qu2(4) + qu1(4)*qu2(1) + P * (qu1(2)*qu2(3) - qu1(3)*qu2(2))

end function multiplyQuaternion


!--------------------------------------------------------------------------------------------------
!> @brief Calculate conjugate complex of a quaternion.
!--------------------------------------------------------------------------------------------------
pure function conjugateQuaternion(qu)

  real(pREAL), dimension(4), intent(in) :: qu
  real(pREAL), dimension(4) :: conjugateQuaternion


  conjugateQuaternion = [qu(1), -qu(2), -qu(3), -qu(4)]

end function conjugateQuaternion


!--------------------------------------------------------------------------------------------------
!> @brief Apply Rodrigues rotation formula to a vector.
!> @details http://dx.doi.org/10.1088/0965-0393/23/8/083501, eq. (24)
!--------------------------------------------------------------------------------------------------
pure function rotate_vector(v, q) result(vRot)

  real(pREAL), dimension(3) :: vRot
  real(pREAL), dimension(3), intent(in) :: v
  real(pREAL), dimension(4), intent(in) :: q

  real(pREAL) :: A, B, C


  A = q(1)**2 - sum(q(2:4)**2)
  B = 2.0_pREAL*sum(q(2:4)*v)
  C = 2.0_pREAL*P*q(1)

  vRot = A*v + B*q(2:4) + C*math_cross(q(2:4),v)

end function rotate_vector


!--------------------------------------------------------------------------------------------------
!> @brief Check correctness of some rotations functions.
!--------------------------------------------------------------------------------------------------
subroutine rotations_selfTest()

  type(tRotation)                 :: R
  real(pREAL)                     :: x
  real(pREAL), dimension(4)       :: qu
  real(pREAL), dimension(3)       :: eu, v3, v3_rot
  real(pREAL), dimension(3,3)     :: om, t33, t33_rot
  real(pREAL), dimension(3,3,3,3) :: t3333, t3333_rot
  real(pREAL), dimension(6,6)     :: C
  integer :: i,j,k,l,m,n,o,p
  logical :: active


  do i = 1, 20

    if (i==1) then
      qu = [1.0_pREAL, 0.0_pREAL, 0.0_pREAL, 0.0_pREAL]
    elseif (i==2) then
      qu = [1.0_pREAL,-0.0_pREAL,-0.0_pREAL,-0.0_pREAL]
    elseif (i==3) then
      qu = [0.0_pREAL, 1.0_pREAL, 0.0_pREAL, 0.0_pREAL]
    elseif (i==4) then
      qu = [0.0_pREAL,0.0_pREAL,1.0_pREAL,0.0_pREAL]
    elseif (i==5) then
      qu = [0.0_pREAL, 0.0_pREAL, 0.0_pREAL, 1.0_pREAL]
    else
      qu = random_quaternion()
    end if


    if (.not. quaternion_equal(om2qu(qu2om(qu)),qu)) error stop 'om2qu2om'
    if (.not. quaternion_equal(eu2qu(qu2eu(qu)),qu)) error stop 'eu2qu2eu'
    if (.not. quaternion_equal(ax2qu(qu2ax(qu)),qu)) error stop 'ax2qu2ax'

    om = qu2om(qu)
    if (.not. quaternion_equal(om2qu(eu2om(om2eu(om))),qu)) error stop 'eu2om2eu'
    if (.not. quaternion_equal(om2qu(ax2om(om2ax(om))),qu)) error stop 'ax2om2ax'

    eu = qu2eu(qu)
    if (.not. quaternion_equal(eu2qu(ax2eu(eu2ax(eu))),qu)) error stop 'ax2eu2ax'

    call R%fromMatrix(om)

    call random_number(v3)
    if (any(dNeq(R%rotVector(R%rotVector(v3),active=.true.),v3,1.0e-12_pREAL))) &
      error stop 'rotVector'

    call random_number(t33)
    if (any(dNeq(R%rotTensor2(R%rotTensor2(t33),active=.true.),t33,1.0e-12_pREAL))) &
      error stop 'rotTensor2'

    call random_number(t3333)
    if (any(dNeq(R%rotTensor4(R%rotTensor4(t3333),active=.true.),t3333,1.0e-12_pREAL))) &
      error stop 'rotTensor4'

    call random_number(C)
    C = C+transpose(C)
    if (any(dNeq(R%rotStiffness(C), &
                 math_3333toVoigt66_stiffness(R%rotate(math_Voigt66to3333_stiffness(C))),1.0e-12_pREAL))) &
      error stop 'rotStiffness'

    call R%fromQuaternion(qu * (1.0_pREAL + merge(+5.e-9_pREAL,-5.e-9_pREAL, mod(i,2) == 0)))       ! allow reasonable tolerance for ASCII/YAML

  end do

  call R%fromQuaternion(qu)
  call random_number(x)
  active = x > 0.5_pREAL


  om = merge(transpose(R%asMatrix()),R%asMatrix(),active)

  v3_rot = 0.0_pREAL
  do i = 1,3;do j = 1,3
    v3_rot(i) = v3_rot(i) &
              + om(i,j) * v3(j)
  end do; end do
  if (any(dNeq(R%rotate(v3,active),v3_rot,1.0e-14_pREAL)))       error stop 'rotate vector'


  t33_rot = 0.0_pREAL
  do i = 1,3;do j = 1,3;do k = 1,3;do l = 1,3
    t33_rot(i,j) = t33_rot(i,j) &
                 + om(i,k) * om(j,l) * t33(k,l)
  end do; end do; end do; end do
  if (any(dNeq(R%rotate(t33,active),t33_rot,1.0e-14_pREAL)))     error stop 'rotate 2nd order tensor'

  t3333_rot = 0.0_pREAL
  do i = 1,3;do j = 1,3;do k = 1,3;do l = 1,3
  do m = 1,3;do n = 1,3;do o = 1,3;do p = 1,3
    t3333_rot(i,j,k,l) = t3333_rot(i,j,k,l) &
                       + om(i,m) * om(j,n) * om(k,o) * om(l,p) * t3333(m,n,o,p)
  end do; end do; end do; end do; end do; end do; end do; end do
  if (any(dNeq(R%rotate(t3333,active),t3333_rot,1.0e-14_pREAL))) error stop 'rotate 4th order tensor'

  contains

  pure recursive function quaternion_equal(qu1,qu2) result(ok)
#ifndef __GFORTRAN__
    use prec
    use math
    import, none
#endif
    real(pREAL), intent(in), dimension(4) :: qu1,qu2
    logical :: ok

    ok = all(dEq(qu1,qu2,1.0e-7_pREAL))
    if (dEq0(qu1(1),1.0e-12_pREAL)) &
      ok = ok .or. all(dEq(-1.0_pREAL*qu1,qu2,1.0e-7_pREAL))

  end function quaternion_equal


  function random_quaternion() result(qu)
#ifndef __GFORTRAN__
    use prec
    use math
    import, none
#endif
    real(pREAL), dimension(4) :: qu

    real(pREAL), dimension(3):: x
    real(pREAL) :: A,B

    call random_number(x)
    A = sqrt(x(3))
    B = sqrt(1-0_pREAL -x(3))
    qu = [cos(TAU*x(1))*A,&
          sin(TAU*x(2))*B,&
          cos(TAU*x(2))*B,&
          sin(TAU*x(1))*A]

    if (qu(1)<0.0_pREAL) qu = qu * (-1.0_pREAL)

   end function random_quaternion

end subroutine rotations_selfTest


end module rotations

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
submodule(homogenization) chemical

  interface

    module subroutine pass_init
    end subroutine pass_init

  end interface

  type :: tDataContainer
    real(pREAL), dimension(:,:), allocatable :: comp                                                ! Average composition
    real(pREAL), dimension(:,:), allocatable :: mu                                                  ! Diffusion potential
  end type tDataContainer

!  integer, dimension(:), allocatable :: &
!    homogenization_chemical_Ncomponents
!  integer :: &
!    homogenization_chemical_maxNcomponents
!
  type(tDataContainer), dimension(:), allocatable :: current

  type :: tParameters
    character(len=pSTRLEN), allocatable, dimension(:) :: &
      output
  end type tParameters

  type(tparameters), dimension(:), allocatable :: &
    param


contains

!--------------------------------------------------------------------------------------------------
!> @brief Allocate variables and set parameters.
!--------------------------------------------------------------------------------------------------
module subroutine chemical_init()

  class(tDict), pointer :: &
    configHomogenizations, &
    configHomogenization, &
    configHomogenizationChemical
  integer :: ho, Nmembers


  print'(/,1x,a)', '<<<+-  homogenization:chemical init  -+>>>'


  configHomogenizations => config_material%get_dict('homogenization')
  allocate(param(size(configHomogenizations)))
  allocate(current(size(configHomogenizations)))
  allocate(homogenization_chemical_Ncomponents(size(configHomogenizations)))

  do ho = 1, size(configHomogenizations)
    Nmembers = count(material_ID_homogenization == ho)
    configHomogenization => configHomogenizations%get_dict(ho)
    associate(prm => param(ho))
      if (configHomogenization%contains('chemical')) then
        configHomogenizationChemical => configHomogenization%get_dict('chemical')
        homogenization_chemical_Ncomponents(ho) = configHomogenizationChemical%get_asInt('N_components',defaultVal=0) ! should probably not be defined in homogenization?
#if defined (__GFORTRAN__)
        prm%output = output_as1dStr(configHomogenizationChemical)
#else
        prm%output = configHomogenizationChemical%get_as1dStr('output',defaultVal=emptyStrArray)
#endif
        allocate(current(ho)%comp(homogenization_chemical_Ncomponents(ho), Nmembers),source=0.0_pREAL)
        allocate(current(ho)%mu(homogenization_chemical_Ncomponents(ho)-1, Nmembers),source=0.0_pREAL)

      end if
    end associate
  end do

  homogenization_chemical_maxNcomponents = maxval(homogenization_chemical_Ncomponents)

  call pass_init()

end subroutine chemical_init


!--------------------------------------------------------------------------------------------------
!> @brief Check if chemical homogemization description is present in the configuration file
!--------------------------------------------------------------------------------------------------
module function homogenization_chemical_active() result(active)

  logical :: active

  active = any(chemical_active(:))

end function homogenization_chemical_active


!--------------------------------------------------------------------------------------------------
!> @brief Partition chemical composition onto the individual constituents.
!--------------------------------------------------------------------------------------------------
module subroutine chemical_partition(Delta_t, ce)

  real(pREAL), intent(in) :: Delta_t
  integer,     intent(in) :: ce

  real(pREAL), dimension(:),allocatable :: comp, mu
  integer :: co

  mu    = current(material_ID_homogenization(ce))%mu(:,material_entry_homogenization(ce))
  do co = 1, homogenization_Nconstituents(material_ID_homogenization(ce))
    comp =  phase_calculate_composition(mu,co,ce)   ! need to calculate composition for each constituent for given diffusion potential
    call phase_chemical_setField(comp,Delta_t,co,ce)
  end do

end subroutine chemical_partition

!--------------------------------------------------------------------------------------------------
!> @brief Calculate average composition at material point.
!--------------------------------------------------------------------------------------------------
module function homogenization_composition(mu,Delta_t,ce) result(comp)

  real(pREAL), dimension(:), intent(in) :: mu
  integer,     intent(in) :: ce
  real(pREAL), intent(in) :: Delta_t

  real(pREAL), dimension(:), allocatable :: comp
  integer :: co, N_components


  N_components = homogenization_chemical_Ncomponents(material_ID_homogenization(ce))
  allocate(comp(N_components),source = 0.0_pREAL)
  do co = 1, homogenization_Nconstituents(material_ID_homogenization(ce))
    comp = comp + phase_calculate_composition(mu,co,ce)
  end do

  comp = comp/real(homogenization_Nconstituents(material_ID_homogenization(ce)),pREAL)

end function homogenization_composition


!--------------------------------------------------------------------------------------------------
!> @brief Calculate composition tangent at material point.
!--------------------------------------------------------------------------------------------------
module function homogenization_compositionTangent(mu,Delta_t,ce) result(comp_tangent)

  real(pREAL), dimension(:), intent(in) :: mu
  integer,     intent(in) :: ce
  real(pREAL), intent(in) :: Delta_t

  real(pREAL), dimension(:,:),allocatable :: comp_tangent
  integer :: co, N_components

  N_components = homogenization_chemical_Ncomponents(material_ID_homogenization(ce))
  allocate(comp_tangent(N_components-1,N_components-1),source = 0.0_pREAL)

  do co = 1, homogenization_Nconstituents(material_ID_homogenization(ce))
    comp_tangent = comp_tangent + phase_compositionTangent(mu,co,ce)
  end do

  comp_tangent = comp_tangent/real(homogenization_Nconstituents(material_ID_homogenization(ce)),pREAL)

end function homogenization_compositionTangent


!--------------------------------------------------------------------------------------------------
!> @brief Retrieve mobility at each material point.
!--------------------------------------------------------------------------------------------------
module function homogenization_mobility(ce) result(mobility)

  integer, intent(in) :: ce
  real(pREAL), dimension(:,:), allocatable :: mobility

  integer :: co,N_components

  N_components = homogenization_chemical_Ncomponents(material_ID_homogenization(ce))
  allocate(mobility(N_components-1,N_components-1),source = 0.0_pREAL)
  do co = 1, homogenization_Nconstituents(material_ID_homogenization(ce))
    mobility = mobility + phase_get_mobility(co,ce)
  end do

  mobility = mobility/homogenization_Nconstituents(material_ID_homogenization(ce))

end function homogenization_mobility


!--------------------------------------------------------------------------------------------------
!> @brief Set chemical field (mu).
!--------------------------------------------------------------------------------------------------
module subroutine homogenization_chemical_setField(mu, comp, Delta_t, ce)

  real(pREAL), dimension(:),  intent(in) :: mu
  real(pREAL), dimension(:),  intent(in) :: comp
  real(pREAL), intent(in) :: Delta_t
  integer, intent(in) :: ce


  current(material_ID_homogenization(ce))%mu(:,material_entry_homogenization(ce)) = mu
  current(material_ID_homogenization(ce))%comp(:,material_entry_homogenization(ce)) = comp  !NOTE: Average composition

  call chemical_partition(Delta_t,ce)

end subroutine homogenization_chemical_setField


!--------------------------------------------------------------------------------------------------
!> @brief Write result to HDF5 output file.
!--------------------------------------------------------------------------------------------------
module subroutine chemical_result(ho,group)

  integer,          intent(in) :: ho
  character(len=*), intent(in) :: group

  integer :: o


 ! ToDo (MD): replace hard-coded "systems" with appropriate name in HDF5/result.
 !            I belive we call it "component" because "constituent" has already a different meaning
  associate(prm => param(ho))
    outputsLoop: do o = 1,size(prm%output)
      select case(trim(prm%output(o)))
        case('x')
          call result_writeDataset(current(ho)%comp,group,'x','mole fraction','1', &
                                   material_name_species)
        case('mu')
          call result_writeDataset(current(ho)%mu,group,'mu','total potential','J', &
                                   material_name_species(:size(material_name_species)-1))
      end select
    end do outputsLoop
  end associate

end subroutine chemical_result


end submodule chemical

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @brief materialpoint engine
!--------------------------------------------------------------------------------------------------
module materialpoint_Marc
  use DAMASK_interface
  use prec
  use IO
  use types
  use YAML
  use HDF5_utilities
  use result
  use config
  use math
  use rotations
  use polynomials
  use tables
  use crystal
  use material
  use phase
  use homogenization
  use constants

  use discretization
  use discretization_Marc

  implicit none(type,external)
  private

  real(pREAL), dimension (:,:,:),   allocatable :: &
    materialpoint_cs                                                                                !< Cauchy stress
  real(pREAL), dimension (:,:,:,:), allocatable :: &
    materialpoint_dcsdE, &                                                                          !< Cauchy stress tangent
    materialpoint_F                                                                                 !< deformation gradient
  real(pREAL), dimension (:,:,:,:), allocatable :: &
    materialpoint_dcsdE_knownGood                                                                   !< known good tangent

  integer,                                       public :: &
    cycleCounter = 0                                                                                !< needs description
  integer(kind(STATUS_OK)) :: &
    status

  integer, parameter,                            public :: &
    materialpoint_CALCRESULTS     = 2**0, &
    materialpoint_AGERESULTS      = 2**1, &
    materialpoint_BACKUPJACOBIAN  = 2**2, &
    materialpoint_RESTOREJACOBIAN = 2**3

  type, private :: tNumerics
    integer :: &
      iJacoStiffness                                                                                !< frequency of stiffness update
  end type tNumerics

  type(tNumerics), private :: num

  integer, dimension (2,6), parameter, private :: &
    MAPMARC = reshape([&
      1,1, &
      2,2, &
      3,3, &
      1,2, &
      2,3, &
      1,3  &
      ],shape(MAPMARC))                                                                             !< arrangement in MSC.Marc notation.

  public :: &
    materialpoint_general, &
    materialpoint_initAll, &
    materialpoint_result

contains


!--------------------------------------------------------------------------------------------------
!> @brief Initialize all modules.
!--------------------------------------------------------------------------------------------------
subroutine materialpoint_initAll()

  call DAMASK_interface_init()
  call prec_init()
  call IO_init()
  call types_init()
  call YAML_init()
  call HDF5_utilities_init()
  call result_init(.false.)
  call config_init()
  call math_init()
  call rotations_init()
  call polynomials_init()
  call tables_init()
  call crystal_init()
  call discretization_Marc_init()
  call material_init()
  call phase_init()
  call homogenization_init()
  call materialpoint_init()
  call config_material_deallocate()
  call config_numerics_deallocate()


end subroutine materialpoint_initAll


!--------------------------------------------------------------------------------------------------
!> @brief Allocate the arrays defined in module materialpoint and initialize them.
!--------------------------------------------------------------------------------------------------
subroutine materialpoint_init()

  print'(/,1x,a)', '<<<+-  materialpoint init  -+>>>'; flush(IO_STDOUT)

  allocate(materialpoint_F(              3,3,discretization_nIPs,discretization_Nelems), source= 0.0_pREAL)
  allocate(materialpoint_cs(               6,discretization_nIPs,discretization_Nelems), source= 0.0_pREAL)
  allocate(materialpoint_dcsdE(          6,6,discretization_nIPs,discretization_Nelems), source= 0.0_pREAL)
  allocate(materialpoint_dcsdE_knownGood(6,6,discretization_nIPs,discretization_Nelems), source= 0.0_pREAL)


end subroutine materialpoint_init


!--------------------------------------------------------------------------------------------------
!> @brief Convert symmetric 3x3 matrix into 6 vector using MSC.Marc convention (no weights).
!--------------------------------------------------------------------------------------------------
pure function sym33to6(m33)

  real(pREAL), dimension(6)               :: sym33to6
  real(pREAL), dimension(3,3), intent(in) :: m33                                                    !< symmetric 3x3 matrix (no internal check)

  integer :: i


  sym33to6 = [(m33(MAPMARC(1,i),MAPMARC(2,i)),i=1,6)]

end function sym33to6


!--------------------------------------------------------------------------------------------------
!> @brief Convert symmetric 3x3x3x3 matrix into 6x6 matrix using MSC.Marc convention (no weights).
!--------------------------------------------------------------------------------------------------
pure function sym3333to66(m3333)

  real(pREAL), dimension(6,6)                 :: sym3333to66
  real(pREAL), dimension(3,3,3,3), intent(in) :: m3333                                              !< symmetric 3x3x3x3 matrix (no internal check)

  integer :: i,j


  forall(i=1:6, j=1:6) sym3333to66(i,j) = m3333(MAPMARC(1,i),MAPMARC(2,i),MAPMARC(1,j),MAPMARC(2,j))

end function sym3333to66


!--------------------------------------------------------------------------------------------------
!> @brief Update variables and call the material model.
!--------------------------------------------------------------------------------------------------
subroutine materialpoint_general(mode, ffn, ffn1, temperature_inp, dt, elFE, ip, cauchyStress, jacobian)

  integer, intent(in) ::                              elFE, &                                       !< FE element number
                                                      ip                                            !< integration point number
  real(pREAL), intent(in) ::                          dt                                            !< time increment
  real(pREAL), dimension (3,3), intent(in) ::         ffn, &                                        !< deformation gradient for t=t0
                                                      ffn1                                          !< deformation gradient for t=t1
  integer, intent(in) ::                              mode                                          !< computation mode  1: regular computation plus aging of results
  real(pREAL), intent(in) ::                          temperature_inp                               !< temperature
  real(pREAL), dimension(6), intent(out) ::           cauchyStress                                  !< stress as 6 vector
  real(pREAL), dimension(6,6), intent(out) ::         jacobian                                      !< jacobian as 66 tensor (Consistent tangent dcs/dE)

  real(pREAL)                                         J_inverse, &                                  ! inverse of Jacobian
                                                      rnd
  real(pREAL), dimension (3,3) ::                     Kirchhoff                                     ! Piola-Kirchhoff stress
  real(pREAL), dimension (3,3,3,3) ::                 H_sym, &
                                                      H

  integer                                             elCP, &                                       ! crystal plasticity element number
                                                      i, j, k, l, m, n, ph, homog, mySource,ce

  real(pREAL), parameter ::                          ODD_STRESS    = 1e15_pREAL, &                  !< return value for stress if broken
                                                     ODD_JACOBIAN  = 1e50_pREAL                     !< return value for jacobian if broken

  elCP = discretization_Marc_FEM2DAMASK_elem(elFE)
  ce   = discretization_Marc_FEM2DAMASK_cell(ip,elFE)


  if (iand(mode, materialpoint_BACKUPJACOBIAN) /= 0) &
    materialpoint_dcsde_knownGood = materialpoint_dcsde
  if (iand(mode, materialpoint_RESTOREJACOBIAN) /= 0) &
    materialpoint_dcsde = materialpoint_dcsde_knownGood

  if (iand(mode, materialpoint_AGERESULTS) /= 0) call materialpoint_forward()

    homogenization_F(1:3,1:3,ce) = ffn1
    materialpoint_F(1:3,1:3,ip,elCP) = ffn1

  if (iand(mode, materialpoint_CALCRESULTS) /= 0) then

    validCalculation: if (status /= STATUS_OK) then
      call random_number(rnd)
      if (rnd < 0.5_pREAL) rnd = rnd - 1.0_pREAL
      materialpoint_cs(1:6,ip,elCP)        = ODD_STRESS * rnd
      materialpoint_dcsde(1:6,1:6,ip,elCP) = ODD_JACOBIAN * math_eye(6)

    else validCalculation
      call homogenization_mechanical_response(status, &
                                              dt,(elCP-1)*discretization_nIPs + ip, (elCP-1)*discretization_nIPs + ip)

      terminalIllness: if (status /= STATUS_OK) then

        call random_number(rnd)
        if (rnd < 0.5_pREAL) rnd = rnd - 1.0_pREAL
        materialpoint_cs(1:6,ip,elCP)        = ODD_STRESS * rnd
        materialpoint_dcsde(1:6,1:6,ip,elCP) = ODD_JACOBIAN * math_eye(6)

      else terminalIllness

        ! translate from P to sigma
        Kirchhoff = matmul(homogenization_P(1:3,1:3,ce), transpose(materialpoint_F(1:3,1:3,ip,elCP)))
        J_inverse  = 1.0_pREAL / math_det33(materialpoint_F(1:3,1:3,ip,elCP))
        materialpoint_cs(1:6,ip,elCP) = sym33to6(J_inverse * Kirchhoff)

        !  translate from dP/dF to dCS/dE
        H = 0.0_pREAL
        do i=1,3; do j=1,3; do k=1,3; do l=1,3; do m=1,3; do n=1,3
          H(i,j,k,l) = H(i,j,k,l) &
                     +  materialpoint_F(j,m,ip,elCP) * materialpoint_F(l,n,ip,elCP) &
                                                     * homogenization_dPdF(i,m,k,n,ce) &
                     -  math_delta(j,l) * materialpoint_F(i,m,ip,elCP) * homogenization_P(k,m,ce) &
                     +  0.5_pREAL * (  Kirchhoff(j,l)*math_delta(i,k) + Kirchhoff(i,k)*math_delta(j,l) &
                                     + Kirchhoff(j,k)*math_delta(i,l) + Kirchhoff(i,l)*math_delta(j,k))
        end do; end do; end do; end do; end do; end do

        forall(i=1:3, j=1:3,k=1:3,l=1:3) &
          H_sym(i,j,k,l) = 0.25_pREAL * (H(i,j,k,l) + H(j,i,k,l) + H(i,j,l,k) + H(j,i,l,k))

        materialpoint_dcsde(1:6,1:6,ip,elCP) = sym3333to66(J_inverse * H_sym)

      end if terminalIllness
    end if validCalculation

  end if

  if (all(abs(materialpoint_dcsdE(1:6,1:6,ip,elCP)) < 1e-10_pREAL)) &
    call IO_warning(601,'integration point', ip, 'of element (CP)', elCP, 'has stiffness close to 0.0', &
                    emph = [2,4] )

  cauchyStress = materialpoint_cs   (1:6,    ip,elCP)
  jacobian     = materialpoint_dcsdE(1:6,1:6,ip,elCP)

end subroutine materialpoint_general


!--------------------------------------------------------------------------------------------------
!> @brief Forward data for new time increment.
!--------------------------------------------------------------------------------------------------
subroutine materialpoint_forward

  call homogenization_forward()
  call phase_forward()

end subroutine materialpoint_forward


!--------------------------------------------------------------------------------------------------
!> @brief Trigger writing of results.
!--------------------------------------------------------------------------------------------------
subroutine materialpoint_result(inc,time)

  integer,     intent(in) :: inc
  real(pREAL), intent(in) :: time

  call result_openJobFile()
  call result_addIncrement(inc,time)
  call phase_result()
  call homogenization_result()
  call discretization_result()
  call result_finalizeIncrement()
  call result_closeJobFile()

end subroutine materialpoint_result

end module materialpoint_Marc

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, KU Leuven
!> @author Philip Eisenlohr, Michigan State University
!> @brief Tabular representation of variable data.
!--------------------------------------------------------------------------------------------------
module tables
  use prec
  use IO
  use YAML
  use types

  implicit none(type,external)
  private

  type, public :: tTable
    real(pREAL), dimension(:), allocatable :: x,y
    contains
    procedure, public :: at => eval
  end type tTable

  interface table
    module procedure table_from_values
    module procedure table_from_dict
  end interface table

  public :: &
    table, &
    tables_init, &
    tables_selfTest

contains


!--------------------------------------------------------------------------------------------------
!> @brief Run self-test.
!--------------------------------------------------------------------------------------------------
subroutine tables_init()

  print'(/,1x,a)', '<<<+-  tables init  -+>>>'; flush(IO_STDOUT)

  call tables_selfTest()

end subroutine tables_init


!--------------------------------------------------------------------------------------------------
!> @brief Initialize a table from values.
!--------------------------------------------------------------------------------------------------
function table_from_values(x,y) result(t)

  real(pREAL), dimension(:), intent(in) :: x,y
  type(tTable) :: t


  if (size(x) < 1)         call IO_error(603,ext_msg='missing tabulated x data')
  if (size(y) < 1)         call IO_error(603,ext_msg='missing tabulated y data')
  if (size(x) /= size(y))  call IO_error(603,ext_msg='shape mismatch in tabulated data')
  if (size(x) /= 1) then
    if (any(x(2:size(x))-x(1:size(x)-1) <= 0.0_pREAL)) &
                           call IO_error(603,ext_msg='ordinate data does not increase monotonically')
  end if

  t%x = x
  t%y = y

end function table_from_values


!--------------------------------------------------------------------------------------------------
!> @brief Initialize a table from a dictionary with values.
!--------------------------------------------------------------------------------------------------
function table_from_dict(dict,x_label,y_label) result(t)

  type(tDict), intent(in) :: dict
  character(len=*), intent(in) :: x_label, y_label
  type(tTable) :: t


  t = tTable(dict%get_as1dReal(x_label),dict%get_as1dReal(y_label))

end function table_from_dict


!--------------------------------------------------------------------------------------------------
!> @brief Linearly interpolate/extrapolate tabular data.
!--------------------------------------------------------------------------------------------------
pure function eval(self,x) result(y)

  class(tTable), intent(in) :: self
  real(pREAL), intent(in) :: x
  real(pREAL) :: y

  integer :: i


  if (size(self%x) == 1) then
    y = self%y(1)
  else
    i = max(1,min(findloc(self%x<x,.true.,dim=1,back=.true.),size(self%x)-1))
    y = self%y(i) &
      + (x-self%x(i)) * (self%y(i+1)-self%y(i)) / (self%x(i+1)-self%x(i))
  end if

end function eval


!--------------------------------------------------------------------------------------------------
!> @brief Check correctness of table functionality.
!--------------------------------------------------------------------------------------------------
subroutine tables_selfTest()

  type(tTable) :: t
  real(pREAL), dimension(*), parameter :: &
    x = real([ 1., 2., 3., 4.],pREAL), &
    y = real([ 1., 3., 2.,-2.],pREAL), &
    x_eval = real([ 0.0, 0.5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5, 5.0],pREAL), &
    y_true = real([-1.0, 0.0, 1.0, 2.0, 3.0, 2.5 ,2.0, 0.0,-2.0,-4.0,-6.0],pREAL)
  integer :: i
  type(tDict), pointer :: dict
  type(tList), pointer :: l_x, l_y
  real(pREAL) :: r


  call random_number(r)
  t = table(real([0.],pREAL),real([r],pREAL))
  if (dNeq(r,t%at(r),1.0e-9_pREAL)) error stop 'table eval/mono'

  r = r-0.5_pREAL
  t = table(x+r,y)
  do i = 1, size(x_eval)
    if (dNeq(y_true(i),t%at(x_eval(i)+r),1.0e-9_pREAL)) error stop 'table eval/values'
  end do

  l_x => YAML_str_asList('[1, 2, 3, 4]'//IO_EOL)
  l_y => YAML_str_asList('[1, 3, 2,-2]'//IO_EOL)
  allocate(dict)
  call dict%set('t',l_x)
  call dict%set('T',l_y)
  t = table(dict,'t','T')
  do i = 1, size(x_eval)
    if (dNeq(y_true(i),t%at(x_eval(i)))) error stop 'table eval/dict'
  end do

end subroutine tables_selfTest

end module tables

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Inquires variables related to parallelization (openMP, MPI)
!--------------------------------------------------------------------------------------------------
#ifdef PETSC
#include <petsc/finclude/petscsys.h>
#endif
module parallelization
  use, intrinsic :: ISO_Fortran_env, only: &
    OUTPUT_UNIT, &
    ERROR_UNIT

#ifdef PETSC
  use PETScSys
#ifndef PETSC_EXPOSES_MPI
  use MPI_f08
#endif
!$ use OMP_LIB
#endif

  use constants
  use prec

#ifndef PETSC_EXPOSES_MPIF90
  implicit none(type,external)
#else
  implicit none
#endif
  private

#ifndef PETSC
  integer, parameter, public :: &
    MPI_INTEGER_KIND = pI64                                                                         !< needed for MSC.Marc
  integer(MPI_INTEGER_KIND), parameter, public :: &
#else
  integer(MPI_INTEGER_KIND), protected, public :: &
#endif
    worldrank = 0_MPI_INTEGER_KIND, &                                                               !< MPI worldrank (/=0 for MPI simulations only)
    worldsize = 1_MPI_INTEGER_KIND                                                                  !< MPI worldsize (/=1 for MPI simulations only)

#ifndef PETSC
public :: parallelization_bcast_str

contains
subroutine parallelization_bcast_str(str)
  character(len=:), allocatable, intent(inout) :: str
end subroutine parallelization_bcast_str

#else
  public :: &
    parallelization_init, &
    parallelization_chkerr, &
    parallelization_bcast_str

contains

!--------------------------------------------------------------------------------------------------
!> @brief Initialize shared memory (openMP) and distributed memory (MPI) parallelization.
!--------------------------------------------------------------------------------------------------
subroutine parallelization_init()

  integer(MPI_INTEGER_KIND) :: err_MPI, typeSize, version, subversion, devNull
  character(len=4) :: rank_str, logfile
  character(len=MPI_MAX_LIBRARY_VERSION_STRING) :: MPI_library_version
  integer :: got_env
!$ integer :: threadLevel
!$ integer(pI32) :: OMP_NUM_THREADS
!$ character(len=6) NumThreadsString
  PetscErrorCode :: err_PETSc
  integer(kind(STATUS_OK)) :: status
  integer, dimension(8) :: date_time


#ifdef _OPENMP
  ! If openMP is enabled, check if the MPI libary supports it and initialize accordingly.
  call MPI_Init_Thread(MPI_THREAD_FUNNELED,threadLevel,err_MPI)
  if (err_MPI /= 0_MPI_INTEGER_KIND)   error stop 'MPI init failed'
  if (threadLevel<MPI_THREAD_FUNNELED) error stop 'MPI library does not support OpenMP'
#else
  call MPI_Init(err_MPI)
  if (err_MPI /= 0_MPI_INTEGER_KIND)   error stop 'MPI init failed'
#endif

  call PetscInitializeNoArguments(err_PETSc)
  CHKERRQ(err_PETSc)

  call PetscOptionsClear(PETSC_NULL_OPTIONS,err_PETSc)
  CHKERRQ(err_PETSc)

  call MPI_Comm_rank(MPI_COMM_WORLD,worldrank,err_MPI)
  if (err_MPI /= 0_MPI_INTEGER_KIND) &
    error stop 'Could not determine worldrank'

  call get_environment_variable(name='DAMASK_LOGFILE',value=logfile,status=got_env)
  if (got_env == 0 .and. any(trim(logfile) == ['1   ', 'TRUE', 'True', 'true'])) then
    write(rank_str,'(i4.4)') worldrank
    open(OUTPUT_UNIT,file='out.'//rank_str,status='replace')
    open(ERROR_UNIT,file='err.'//rank_str,status='replace')
  else
    if (worldrank /= 0) open(OUTPUT_UNIT,file='/dev/null',status='replace')
  end if

  call date_and_time(values = date_time)
  write(OUTPUT_UNIT,'(/,a)') ' DAMASK started on:'
  print'(3x,a,1x,2(i2.2,a),i4.4)', 'Date:',date_time(3),'/',date_time(2),'/',date_time(1)
  print'(3x,a,1x,2(i2.2,a),i2.2)', 'Time:',date_time(5),':',date_time(6),':',date_time(7)

  print'(/,1x,a)', '<<<+-  parallelization init  -+>>>'

  call MPI_Get_library_version(MPI_library_version,devNull,err_MPI)
  print'(/,1x,a)', trim(MPI_library_version)
  call MPI_Get_version(version,subversion,err_MPI)
  print'(1x,a,i0,a,i0)', 'MPI standard: ',version,'.',subversion
#if defined(_OPENMP) && (__INTEL_COMPILER < 20250200)
  print'(1x,a,i0)',      'OpenMP version: ',openmp_version
#endif

  call MPI_Comm_size(MPI_COMM_WORLD,worldsize,err_MPI)
  call parallelization_chkerr(err_MPI)
  print'(/,1x,a,i0)', 'MPI worldrank: ',worldrank
  print'(1x,a,i0)',   'MPI worldsize: ',worldsize

  call MPI_Type_size(MPI_INTEGER,typeSize,err_MPI)
  call parallelization_chkerr(err_MPI)
  if (typeSize*8_MPI_INTEGER_KIND /= int(bit_size(0),MPI_INTEGER_KIND)) &
    error stop 'Mismatch between MPI_INTEGER and DAMASK default integer'

  call MPI_Type_size(MPI_INTEGER8,typeSize,err_MPI)
  call parallelization_chkerr(err_MPI)
  if (typeSize*8_MPI_INTEGER_KIND /= int(bit_size(0_pI64),MPI_INTEGER_KIND)) &
    error stop 'Mismatch between MPI_INTEGER8 and DAMASK pI64'

  call MPI_Type_size(MPI_DOUBLE,typeSize,err_MPI)
  call parallelization_chkerr(err_MPI)
  if (typeSize*8_MPI_INTEGER_KIND /= int(storage_size(0.0_pREAL),MPI_INTEGER_KIND)) &
    error stop 'Mismatch between MPI_DOUBLE and DAMASK pREAL'

  call MPI_Type_size(MPI_INTEGER,typeSize,err_MPI)
  call parallelization_chkerr(err_MPI)
  if (typeSize*8_MPI_INTEGER_KIND /= int(bit_size(status),MPI_INTEGER_KIND)) &
    error stop 'Mismatch between MPI_INTEGER and DAMASK status'

!$ call get_environment_variable(name='OMP_NUM_THREADS',value=NumThreadsString,status=got_env)
!$ if (got_env /= 0) then
!$   print'(1x,a)', 'Could not get $OMP_NUM_THREADS, using default'
!$   OMP_NUM_THREADS = 4_pI32
!$ else
!$   read(NumThreadsString,'(i6)') OMP_NUM_THREADS
!$   if (OMP_NUM_THREADS < 1_pI32) then
!$     print'(1x,a)', 'Invalid OMP_NUM_THREADS: "'//trim(NumThreadsString)//'", using default'
!$     OMP_NUM_THREADS = 4_pI32
!$   end if
!$ end if
!$ print'(1x,a,i0)',   'OMP_NUM_THREADS: ',OMP_NUM_THREADS
!$ call omp_set_num_threads(OMP_NUM_THREADS)

end subroutine parallelization_init


!--------------------------------------------------------------------------------------------------
!> @brief Check for MPI error.
!--------------------------------------------------------------------------------------------------
subroutine parallelization_chkerr(e)

  integer(MPI_INTEGER_KIND), intent(in) :: e


  if (e/=0_MPI_INTEGER_KIND) error stop 'MPI error'

end subroutine parallelization_chkerr


!--------------------------------------------------------------------------------------------------
!> @brief Broadcast a string from process 0.
!--------------------------------------------------------------------------------------------------
subroutine parallelization_bcast_str(str)

  character(len=:), allocatable, intent(inout) :: str

  integer(MPI_INTEGER_KIND) :: strlen, err_MPI


  if (worldrank == 0) strlen = len(str,MPI_INTEGER_KIND)
  call MPI_Bcast(strlen,1_MPI_INTEGER_KIND,MPI_INTEGER,0_MPI_INTEGER_KIND,MPI_COMM_WORLD, err_MPI)
  if (worldrank /= 0) allocate(character(len=strlen)::str)

  call MPI_Bcast(str,strlen,MPI_CHARACTER,0_MPI_INTEGER_KIND,MPI_COMM_WORLD, err_MPI)


end subroutine parallelization_bcast_str

#endif

end module parallelization

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, KU Leuven
!> @brief Utilities used by the grid solver variants
!--------------------------------------------------------------------------------------------------
#include <petsc/finclude/petscsys.h>
module grid_utilities
  use PETScSys
#ifndef PETSC_EXPOSES_MPI
  use MPI_f08
#endif

  use prec
  use parallelization
  use math
  use rotations
  use IO
  use discretization_grid
  use discretization
  use spectral_utilities
  use homogenization
  use constants

#ifndef PETSC_EXPOSES_MPIF90
  implicit none(type,external)
#else
  implicit none
#endif
  private

!--------------------------------------------------------------------------------------------------
! derived types
  type, public :: tBCmech                                                                !< set of parameters defining a boundary condition
    real(pREAL), dimension(3,3)   :: values = 0.0_pREAL
    logical,     dimension(3,3)   :: mask   = .true.
    character(len=:), allocatable :: myType
  end type tBCmech

  type, public :: tBCthermal                                                                        !< thermal boundary condition parameters
    real(pREAL)                   :: value = 0.0_pREAL                                              !< temperature [K] or rate [K/s]
    character(len=:), allocatable :: thermostat                                                     !< 'shift' or 'scale'
    character(len=:), allocatable :: myType                                                         !< 'T' or 'dot_T'; unallocated = free
  end type tBCthermal

  type, public :: tSolutionParams
    real(pREAL), dimension(3,3) :: stress_BC
    logical, dimension(3,3)     :: stress_mask
    type(tRotation)             :: rotation_BC
    real(pREAL) :: Delta_t
  end type tSolutionParams

  public :: &
    utilities_maskedCompliance, &
    utilities_constitutiveResponse, &
    utilities_calculateRate, &
    utilities_forwardTensorField, &
    utilities_forwardScalarField

contains


!--------------------------------------------------------------------------------------------------
!> @brief Calculate masked compliance tensor used to adjust F to fullfill stress BC.
!--------------------------------------------------------------------------------------------------
function utilities_maskedCompliance(rot_BC,mask_stress,C)

  real(pREAL),                dimension(3,3,3,3) :: utilities_maskedCompliance                      !< masked compliance
  real(pREAL),    intent(in), dimension(3,3,3,3) :: C                                               !< current average stiffness
  type(tRotation), intent(in)                    :: rot_BC                                          !< rotation of load frame
  logical,        intent(in), dimension(3,3)     :: mask_stress                                     !< mask of stress BC

  integer :: i, j
  logical, dimension(9)   :: mask_stressVector
  logical, dimension(9,9) :: mask
  real(pREAL), dimension(9,9) :: temp99_real
  integer :: size_reduced = 0
  real(pREAL),              dimension(:,:), allocatable ::  &
    s_reduced, &                                                                                    !< reduced compliance matrix (depending on number of stress BC)
    c_reduced, &                                                                                    !< reduced stiffness (depending on number of stress BC)
    sTimesC                                                                                         !< temp variable to check inversion
  logical :: errmatinv
  character(len=pSTRLEN):: formatString


  mask_stressVector = .not. reshape(transpose(mask_stress), [9])
  size_reduced = count(mask_stressVector)
  if (size_reduced > 0) then
    temp99_real = math_3333to99(rot_BC%rotate(C))

    do i = 1,9; do j = 1,9
      mask(i,j) = mask_stressVector(i) .and. mask_stressVector(j)
    end do; end do
    c_reduced = reshape(pack(temp99_Real,mask),[size_reduced,size_reduced])

    allocate(s_reduced,mold = c_reduced)
    call math_invert(s_reduced, errmatinv, c_reduced)                                               ! invert reduced stiffness
    if (any(IEEE_is_NaN(s_reduced))) errmatinv = .true.

!--------------------------------------------------------------------------------------------------
! check if inversion was successful
    sTimesC = matmul(c_reduced,s_reduced)
    errmatinv = errmatinv .or. any(dNeq(sTimesC,math_eye(size_reduced),1.0e-12_pREAL))
    if (errmatinv) then
      write(formatString, '(i2)') size_reduced
      formatString = '(/,1x,a,/,'//trim(formatString)//'('//trim(formatString)//'(2x,es9.2,1x)/))'
      print trim(formatString), 'C * S (load) ', transpose(matmul(c_reduced,s_reduced))
      print trim(formatString), 'C (load) ', transpose(c_reduced)
      print trim(formatString), 'S (load) ', transpose(s_reduced)
      if (errmatinv) error stop 'matrix inversion error'
    end if
    temp99_real = reshape(unpack(reshape(s_reduced,[size_reduced**2]),reshape(mask,[81]),0.0_pREAL),[9,9])
  else
    temp99_real = 0.0_pREAL
  end if

  utilities_maskedCompliance = math_99to3333(temp99_Real)

end function utilities_maskedCompliance


!--------------------------------------------------------------------------------------------------
!> @brief Calculate constitutive response.
!--------------------------------------------------------------------------------------------------
subroutine utilities_constitutiveResponse(status, P,P_av,C_volAvg,C_minmaxAvg,&
                                          F,Delta_t,rotation_BC)

  integer(kind(STATUS_OK)),  intent(out)                            :: status
  real(pREAL),    intent(out), dimension(3,3,3,3)                   :: C_volAvg, C_minmaxAvg        !< average stiffness
  real(pREAL),    intent(out), dimension(3,3)                       :: P_av                         !< average PK stress
  real(pREAL),    intent(out), dimension(3,3,cells(1),cells(2),cells3) :: P                         !< PK stress
  real(pREAL),    intent(in),  dimension(3,3,cells(1),cells(2),cells3) :: F                         !< deformation gradient target
  real(pREAL),    intent(in)                                        :: Delta_t                      !< loading time
  type(tRotation), intent(in),  optional                            :: rotation_BC                  !< rotation of load frame

  integer :: ce
  integer(MPI_INTEGER_KIND) :: err_MPI
  real(pREAL), dimension(3,3,3,3) :: dPdF_max,      dPdF_min
  real(pREAL)                     :: dPdF_norm_max, dPdF_norm_min
  real(pREAL), dimension(2) :: valueAndRank                                                         !< pair of min/max norm of dPdF to synchronize min/max of dPdF


  print'(/,1x,a)', '... evaluating constitutive response ......................................'
  flush(IO_STDOUT)

  homogenization_F  = reshape(F,[3,3,product(cells(1:2))*cells3])                                   ! set materialpoint target F to estimated field

  call homogenization_mechanical_response(status,Delta_t,1,product(cells(1:2))*cells3)              ! calculate P field

  P = reshape(homogenization_P, [3,3,cells(1),cells(2),cells3])
  P_av = sum(sum(sum(P,dim=5),dim=4),dim=3) * wgt
  call MPI_Allreduce(MPI_IN_PLACE,P_av,9_MPI_INTEGER_KIND,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  if (present(rotation_BC)) then
    if (any(dNeq(rotation_BC%asQuaternion(), real([1.0, 0.0, 0.0, 0.0],pREAL)))) &
      print'(/,1x,a,/,2(3(2x,f12.4,1x)/),3(2x,f12.4,1x))', &
      'Piola--Kirchhoff stress (lab) / MPa =', transpose(P_av)*1.e-6_pREAL
    P_av = rotation_BC%rotate(P_av)
  end if
  print'(/,1x,a,/,2(3(2x,f12.4,1x)/),3(2x,f12.4,1x))', &
    'Piola--Kirchhoff stress       / MPa =', transpose(P_av)*1.e-6_pREAL
  flush(IO_STDOUT)

  dPdF_max = 0.0_pREAL
  dPdF_norm_max = 0.0_pREAL
  dPdF_min = huge(1.0_pREAL)
  dPdF_norm_min = huge(1.0_pREAL)
  do ce = 1, product(cells(1:2))*cells3
    if (dPdF_norm_max < sum(homogenization_dPdF(1:3,1:3,1:3,1:3,ce)**2)) then
      dPdF_max = homogenization_dPdF(1:3,1:3,1:3,1:3,ce)
      dPdF_norm_max = sum(homogenization_dPdF(1:3,1:3,1:3,1:3,ce)**2)
    end if
    if (dPdF_norm_min > sum(homogenization_dPdF(1:3,1:3,1:3,1:3,ce)**2)) then
      dPdF_min = homogenization_dPdF(1:3,1:3,1:3,1:3,ce)
      dPdF_norm_min = sum(homogenization_dPdF(1:3,1:3,1:3,1:3,ce)**2)
    end if
  end do

  valueAndRank = [dPdF_norm_max,real(worldrank,pREAL)]
  call MPI_Allreduce(MPI_IN_PLACE,valueAndRank,1_MPI_INTEGER_KIND,MPI_2DOUBLE_PRECISION,MPI_MAXLOC,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  call MPI_Bcast(dPdF_max,81_MPI_INTEGER_KIND,MPI_DOUBLE,int(valueAndRank(2),MPI_INTEGER_KIND),MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)

  valueAndRank = [dPdF_norm_min,real(worldrank,pREAL)]
  call MPI_Allreduce(MPI_IN_PLACE,valueAndRank,1_MPI_INTEGER_KIND,MPI_2DOUBLE_PRECISION,MPI_MINLOC,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  call MPI_Bcast(dPdF_min,81_MPI_INTEGER_KIND,MPI_DOUBLE,int(valueAndRank(2),MPI_INTEGER_KIND),MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)

  C_minmaxAvg = 0.5_pREAL*(dPdF_max + dPdF_min)

  C_volAvg = sum(homogenization_dPdF,dim=5)
  call MPI_Allreduce(MPI_IN_PLACE,C_volAvg,81_MPI_INTEGER_KIND,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  C_volAvg = C_volAvg * wgt


end subroutine utilities_constitutiveResponse


!--------------------------------------------------------------------------------------------------
!> @brief Calculate forward rate, either as local guess or as homogeneous add on.
!--------------------------------------------------------------------------------------------------
pure function utilities_calculateRate(heterogeneous,field0,field,dt,avRate)

  real(pREAL), intent(in), dimension(3,3) :: &
    avRate                                                                                          !< homogeneous addon
  real(pREAL), intent(in) :: &
    dt                                                                                              !< Delta_t between field0 and field
  logical, intent(in) :: &
    heterogeneous                                                                                   !< calculate field of rates
  real(pREAL), intent(in), dimension(3,3,cells(1),cells(2),cells3) :: &
    field0, &                                                                                       !< data of previous step
    field                                                                                           !< data of current step
  real(pREAL),             dimension(3,3,cells(1),cells(2),cells3) :: &
    utilities_calculateRate


  utilities_calculateRate = merge((field-field0) / dt, &
                                  spread(spread(spread(avRate,3,cells(1)),4,cells(2)),5,cells3), &
                                  heterogeneous)

end function utilities_calculateRate


!--------------------------------------------------------------------------------------------------
!> @brief forwards a field with a pointwise given rate, if aim is given,
!> ensures that the average matches the aim
!--------------------------------------------------------------------------------------------------
function utilities_forwardTensorField(Delta_t,field_lastinc,rate,aim)

  real(pREAL), intent(in) :: &
    Delta_t                                                                                         !< Delta_t of current step
  real(pREAL), intent(in),           dimension(3,3,cells(1),cells(2),cells3) :: &
    field_lastinc, &                                                                                !< initial field
    rate                                                                                            !< rate by which to forward
  real(pREAL), intent(in), optional, dimension(3,3) :: &
    aim                                                                                             !< average field value aim

  real(pREAL),                       dimension(3,3,cells(1),cells(2),cells3) :: &
    utilities_forwardTensorField
  real(pREAL),                       dimension(3,3) :: fieldDiff                                    !< <a + adot*t> - aim
  integer(MPI_INTEGER_KIND) :: err_MPI


  utilities_forwardTensorField = field_lastinc + rate*Delta_t
  if (present(aim)) then                                                                            !< correct to match average
    fieldDiff = sum(sum(sum(utilities_forwardTensorField,dim=5),dim=4),dim=3)*wgt
    call MPI_Allreduce(MPI_IN_PLACE,fieldDiff,9_MPI_INTEGER_KIND,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,err_MPI)
    call parallelization_chkerr(err_MPI)
    fieldDiff = fieldDiff - aim
    utilities_forwardTensorField = utilities_forwardTensorField &
                                 - spread(spread(spread(fieldDiff,3,cells(1)),4,cells(2)),5,cells3)
  end if

end function utilities_forwardTensorField


!--------------------------------------------------------------------------------------------------
!> @brief Forward a scalar field with a pointwise given rate; if aim and thermostat are given,
!> ensures that the average matches the aim.
!--------------------------------------------------------------------------------------------------
function utilities_forwardScalarField(Delta_t,field_lastinc,rate,aim,method)

  real(pREAL), intent(in) :: &
    Delta_t                                                                                         !< Delta_t of current step
  real(pREAL), intent(in), dimension(cells(1),cells(2),cells3) :: &
    field_lastinc, &                                                                                !< initial field
    rate                                                                                            !< rate by which to forward
  real(pREAL),     intent(in), optional :: aim                                                      !< average field value aim
  character(*),    intent(in), optional :: method                                                   !< 'shift' or 'scale'

  real(pREAL), dimension(cells(1),cells(2),cells3) :: &
    utilities_forwardScalarField
  real(pREAL) :: fieldMean                                                                          !< global mean of forwarded field
  integer(MPI_INTEGER_KIND) :: err_MPI


  utilities_forwardScalarField = field_lastinc + rate*Delta_t
  if (present(aim)) then
    fieldMean = sum(utilities_forwardScalarField)*wgt
    call MPI_Allreduce(MPI_IN_PLACE,fieldMean,1_MPI_INTEGER_KIND,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,err_MPI)
    call parallelization_chkerr(err_MPI)
    select case (method)
      case ('shift')
        utilities_forwardScalarField = utilities_forwardScalarField + (aim - fieldMean)
      case ('scale')
        utilities_forwardScalarField = utilities_forwardScalarField * (aim/fieldMean)
    end select
  end if

end function utilities_forwardScalarField

end module grid_utilities

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author Christoph Kords, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Basic IO functions for parsing MSC.Marc input file(s)
!--------------------------------------------------------------------------------------------------
module IO_Marc

  use prec
  use IO

  public :: &
    strPos, &
    strValue, &
    realValue, &
    continuousIntValues, &
    containsRange

contains

!--------------------------------------------------------------------------------------------------
!> @brief Locate all whitespace-separated chunks in the given string and
!! return array containing their number and each left/right position
!! for later use in IO_xxxVal.
!! Array size is dynamically adjusted to number of chunks found in string
!! IMPORTANT: first element contains number of chunks!
!--------------------------------------------------------------------------------------------------
pure function strPos(str)

  character(len=*),                  intent(in) :: str                                              !< string in which chunk positions are searched for
  integer, dimension(:), allocatable            :: strPos

  integer :: left, right


  allocate(strPos(1), source=0)
  right = 0

  do while (verify(str(right+1:),IO_WHITESPACE)>0)
    left  = right + verify(str(right+1:),IO_WHITESPACE)
    right = left + scan(str(left:),IO_WHITESPACE) - 2
    strPos = [strPos,left,right]
    strPos(1) = strPos(1)+1
    endOfStr: if (right < left) then
      strPos(strPos(1)*2+1) = len_trim(str)
      exit
    end if endOfStr
  end do

end function strPos

!--------------------------------------------------------------------------------------------------
!> @brief Read string value at myChunk from string.
!--------------------------------------------------------------------------------------------------
function strValue(str,chunkPos,myChunk)

  character(len=*),             intent(in) :: str                                                   !< raw input with known start and end of each chunk
  integer,   dimension(:),      intent(in) :: chunkPos                                              !< positions of start and end of each tag/chunk in given string
  integer,                      intent(in) :: myChunk                                               !< position number of desired chunk
  character(len=:), allocatable            :: strValue


  validChunk: if (myChunk > chunkPos(1) .or. myChunk < 1) then
    strValue = ''
    call IO_error(110,'strValue: "'//trim(str)//'"',label1='chunk',ID1=myChunk)
  else validChunk
    strValue = str(chunkPos(myChunk*2):chunkPos(myChunk*2+1))
  end if validChunk

end function strValue

!--------------------------------------------------------------------------------------------------
!> @brief Read integer value at myChunk from string.
!--------------------------------------------------------------------------------------------------
integer function intValue(str,chunkPos,myChunk)

  character(len=*),      intent(in) :: str                                                          !< raw input with known start and end of each chunk
  integer, dimension(:), intent(in) :: chunkPos                                                     !< positions of start and end of each tag/chunk in given string
  integer,               intent(in) :: myChunk                                                      !< position number of desired chunk


  intValue = IO_strAsInt(strValue(str,chunkPos,myChunk))

end function intValue


!--------------------------------------------------------------------------------------------------
!> @brief Read real value at myChunk from string.
!--------------------------------------------------------------------------------------------------
real(pREAL) function realValue(str,chunkPos,myChunk)

  character(len=*),        intent(in) :: str                                                        !< raw input with known start and end of each chunk
  integer,   dimension(:), intent(in) :: chunkPos                                                   !< positions of start and end of each tag/chunk in given string
  integer,                 intent(in) :: myChunk                                                    !< position number of desired chunk


  realValue = IO_strAsReal(strValue(str,chunkPos,myChunk))

end function realValue


!--------------------------------------------------------------------------------------------------
!> @brief return integer list corresponding to items in consecutive lines.
!! First integer in array is counter
!> @details ints concatenated by "c" as last char, range of a "to" b, or named set
!--------------------------------------------------------------------------------------------------
function continuousIntValues(fileContent,maxN,lookupName,lookupMap,lookupMaxN)

  character(len=*), dimension(:),   intent(in) :: fileContent                                       !< file content, separated per lines
  integer,                          intent(in) :: maxN
  integer,                          intent(in) :: lookupMaxN
  integer,          dimension(:,:), intent(in) :: lookupMap
  character(len=*), dimension(:),   intent(in) :: lookupName

  integer,           dimension(1+maxN)         :: continuousIntValues

  integer :: l,i,first,last
  integer, allocatable, dimension(:) :: chunkPos
  logical :: rangeGeneration

  continuousIntValues = 0
  rangeGeneration = .false.

  do l = 1, size(fileContent)
    chunkPos = strPos(fileContent(l))
    if (chunkPos(1) < 1) then                                                                       ! empty line
      exit
    elseif (verify(strValue(fileContent(l),chunkPos,1),'0123456789') > 0) then                   ! a non-int, i.e. set name
      do i = 1, lookupMaxN                                                                          ! loop over known set names
        if (strValue(fileContent(l),chunkPos,1) == lookupName(i)) then                           ! found matching name
          continuousIntValues = lookupMap(:,i)                                                      ! return resp. entity list
          exit
        end if
      end do
      exit
    elseif (containsRange(fileContent(l),chunkPos)) then
      first = intValue(fileContent(l),chunkPos,1)
      last  = intValue(fileContent(l),chunkPos,3)
      do i = first, last, sign(1,last-first)
        continuousIntValues(1) = continuousIntValues(1) + 1
        continuousIntValues(1+continuousIntValues(1)) = i
      end do
      exit
    else
      do i = 1,chunkPos(1)-1                                                                        ! interpret up to second to last value
        continuousIntValues(1) = continuousIntValues(1) + 1
        continuousIntValues(1+continuousIntValues(1)) = intValue(fileContent(l),chunkPos,i)
      end do
      if ( IO_lc(strValue(fileContent(l),chunkPos,chunkPos(1))) /= 'c' ) then                    ! line finished, read last value
        continuousIntValues(1) = continuousIntValues(1) + 1
        continuousIntValues(1+continuousIntValues(1)) = intValue(fileContent(l),chunkPos,chunkPos(1))
        exit
      end if
    end if
  end do

end function continuousIntValues


!--------------------------------------------------------------------------------------------------
!> @brief return whether a line contains a range ('X to Y')
!--------------------------------------------------------------------------------------------------
logical function containsRange(str,chunkPos)

  character(len=*),      intent(in) :: str
  integer, dimension(:), intent(in) :: chunkPos                                                     !< positions of start and end of each tag/chunk in given string


  containsRange = .False.
  if (chunkPos(1) == 3) then
    if (IO_lc(strValue(str,chunkPos,2)) == 'to') containsRange = .True.
  end if

end function containsRange

end module IO_Marc

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, KU Leuven
!> @brief Partition F and homogenize P/dPdF
!--------------------------------------------------------------------------------------------------
submodule(homogenization) mechanical


  interface

    module subroutine pass_init()
    end subroutine pass_init

    module subroutine isostrain_init()
    end subroutine isostrain_init

    module subroutine RGC_init()
    end subroutine RGC_init


    module subroutine isostrain_partitionDeformation(F,avgF)
      real(pREAL),   dimension (:,:,:), intent(out) :: F                                            !< partitioned deformation gradient
      real(pREAL),   dimension (3,3),   intent(in)  :: avgF                                         !< average deformation gradient at material point
    end subroutine isostrain_partitionDeformation

    module subroutine RGC_partitionDeformation(F,avgF,ce)
      real(pREAL),   dimension (:,:,:), intent(out) :: F                                            !< partitioned deformation gradient
      real(pREAL),   dimension (3,3),   intent(in)  :: avgF                                         !< average deformation gradient at material point
      integer,                          intent(in)  :: &
        ce
    end subroutine RGC_partitionDeformation


    module function RGC_updateState(P,F,avgF,dt,dPdF,ce) result(doneAndHappy)
      logical, dimension(2) :: doneAndHappy
      real(pREAL), dimension(:,:,:),     intent(in)    :: &
        P,&                                                                                         !< partitioned stresses
        F                                                                                           !< partitioned deformation gradients
      real(pREAL), dimension(:,:,:,:,:), intent(in) :: dPdF                                         !< partitioned stiffnesses
      real(pREAL), dimension(3,3),       intent(in) :: avgF                                         !< average F
      real(pREAL),                       intent(in) :: dt                                           !< time increment
      integer,                           intent(in) :: &
        ce                                                                                          !< cell
    end function RGC_updateState


    module subroutine RGC_result(ho,group)
      integer,          intent(in) :: ho                                                            !< homogenization type
      character(len=*), intent(in) :: group                                                         !< group name in HDF5 file
    end subroutine RGC_result

  end interface

  type :: tOutput                                                                                   !< requested output (per phase)
    character(len=pSTRLEN), allocatable, dimension(:) :: &
      label
  end type tOutput
  type(tOutput), allocatable, dimension(:) :: output_mechanical

  enum, bind(c); enumerator :: &
    MECHANICAL_UNDEFINED_ID, &
    MECHANICAL_PASS_ID, &
    MECHANICAL_ISOSTRAIN_ID, &
    MECHANICAL_RGC_ID
  end enum
  integer(kind(MECHANICAL_UNDEFINED_ID)), dimension(:),   allocatable :: &
    mechanical_type                                                                                 !< type of each homogenization

contains

!--------------------------------------------------------------------------------------------------
!> @brief Allocate variables and set parameters.
!--------------------------------------------------------------------------------------------------
module subroutine mechanical_init()

  print'(/,1x,a)', '<<<+-  homogenization:mechanical init  -+>>>'

  call parseMechanical()

  allocate(homogenization_dPdF(3,3,3,3,discretization_Ncells), source=0.0_pREAL)
  homogenization_F = spread(math_I3,3,discretization_Ncells)
  allocate(homogenization_P(3,3,discretization_Ncells),source=0.0_pREAL)

  if (any(mechanical_type == MECHANICAL_PASS_ID))      call pass_init()
  if (any(mechanical_type == MECHANICAL_ISOSTRAIN_ID)) call isostrain_init()
  if (any(mechanical_type == MECHANICAL_RGC_ID))       call RGC_init()

end subroutine mechanical_init


!--------------------------------------------------------------------------------------------------
!> @brief Partition F onto the individual constituents.
!--------------------------------------------------------------------------------------------------
module subroutine mechanical_partition(subF,ce)

  real(pREAL), intent(in), dimension(3,3) :: &
    subF
  integer,     intent(in) :: &
    ce

  integer :: co
  real(pREAL), dimension (3,3,homogenization_Nconstituents(material_ID_homogenization(ce))) :: Fs


  chosenHomogenization: select case(mechanical_type(material_ID_homogenization(ce)))

    case (MECHANICAL_PASS_ID) chosenHomogenization
      Fs(1:3,1:3,1) = subF

    case (MECHANICAL_ISOSTRAIN_ID) chosenHomogenization
      call isostrain_partitionDeformation(Fs,subF)

    case (MECHANICAL_RGC_ID) chosenHomogenization
      call RGC_partitionDeformation(Fs,subF,ce)

  end select chosenHomogenization

  do co = 1,homogenization_Nconstituents(material_ID_homogenization(ce))
    call phase_set_F(Fs(1:3,1:3,co),co,ce)
  end do


end subroutine mechanical_partition


!--------------------------------------------------------------------------------------------------
!> @brief Average P and dPdF from the individual constituents.
!--------------------------------------------------------------------------------------------------
module subroutine mechanical_homogenize(Delta_t,ce)

  real(pREAL), intent(in) :: Delta_t
  integer, intent(in) :: ce

  integer :: co


  homogenization_P(1:3,1:3,ce)            = phase_P(1,ce)*material_v(1,ce)
  homogenization_dPdF(1:3,1:3,1:3,1:3,ce) = phase_mechanical_dPdF(Delta_t,1,ce)*material_v(1,ce)
  do co = 2, homogenization_Nconstituents(material_ID_homogenization(ce))
    homogenization_P(1:3,1:3,ce)            = homogenization_P(1:3,1:3,ce) &
                                            + phase_P(co,ce)*material_v(co,ce)
    homogenization_dPdF(1:3,1:3,1:3,1:3,ce) = homogenization_dPdF(1:3,1:3,1:3,1:3,ce) &
                                            + phase_mechanical_dPdF(Delta_t,co,ce)*material_v(co,ce)
  end do

end subroutine mechanical_homogenize


!--------------------------------------------------------------------------------------------------
!> @brief update the internal state of the homogenization scheme and tell whether "done" and
!> "happy" with result
!--------------------------------------------------------------------------------------------------
module function mechanical_updateState(subdt,subF,ce) result(doneAndHappy)

  real(pREAL), intent(in) :: &
    subdt                                                                                           !< current time step
  real(pREAL), intent(in), dimension(3,3) :: &
    subF
  integer,     intent(in) :: &
    ce
  logical, dimension(2) :: doneAndHappy

  integer :: co
  real(pREAL) :: dPdFs(3,3,3,3,homogenization_Nconstituents(material_ID_homogenization(ce)))
  real(pREAL) :: Fs(3,3,homogenization_Nconstituents(material_ID_homogenization(ce)))
  real(pREAL) :: Ps(3,3,homogenization_Nconstituents(material_ID_homogenization(ce)))


  if (mechanical_type(material_ID_homogenization(ce)) == MECHANICAL_RGC_ID) then
      do co = 1, homogenization_Nconstituents(material_ID_homogenization(ce))
        dPdFs(:,:,:,:,co) = phase_mechanical_dPdF(subdt,co,ce)
        Fs(:,:,co)        = phase_F(co,ce)
        Ps(:,:,co)        = phase_P(co,ce)
      end do
      doneAndHappy = RGC_updateState(Ps,Fs,subF,subdt,dPdFs,ce)
  else
    doneAndHappy = .true.
  end if

end function mechanical_updateState


!--------------------------------------------------------------------------------------------------
!> @brief Write results to file.
!--------------------------------------------------------------------------------------------------
module subroutine mechanical_result(group_base,ho)

  character(len=*), intent(in) :: group_base
  integer, intent(in)          :: ho

  integer :: ou
  character(len=:), allocatable :: group


  group = trim(group_base)//'/mechanical'
  call result_closeGroup(result_addGroup(group))

  select case(mechanical_type(ho))

    case(MECHANICAL_RGC_ID)
      call RGC_result(ho,group)

  end select

  do ou = 1, size(output_mechanical(1)%label)

    select case (output_mechanical(ho)%label(ou))
      case('F')
        call result_writeDataset(reshape(homogenization_F,[3,3,discretization_nCells]),group,'F', &
                                 'deformation gradient','1')
      case('P')
        call result_writeDataset(reshape(homogenization_P,[3,3,discretization_nCells]),group,'P', &
                                 'first Piola-Kirchhoff stress','Pa')
    end select
  end do

end subroutine mechanical_result


!--------------------------------------------------------------------------------------------------
!> @brief parses the homogenization part from the material configuration
!--------------------------------------------------------------------------------------------------
subroutine parseMechanical()

  type(tDict), pointer :: &
    material_homogenization, &
    homog, &
    mechanical

  integer :: ho


  material_homogenization => config_material%get_dict('homogenization')

  allocate(mechanical_type(size(material_name_homogenization)), source=MECHANICAL_UNDEFINED_ID)
  allocate(output_mechanical(size(material_name_homogenization)))

  do ho=1, size(material_name_homogenization)
    homog => material_homogenization%get_dict(ho)
    mechanical => homog%get_dict('mechanical')
#if defined(__GFORTRAN__)
    output_mechanical(ho)%label = output_as1dStr(mechanical)
#else
    output_mechanical(ho)%label = mechanical%get_as1dStr('output',defaultVal=emptyStrArray)
#endif
    select case (mechanical%get_asStr('type'))
      case('pass')
        mechanical_type(ho) = MECHANICAL_PASS_ID
      case('isostrain')
        mechanical_type(ho) = MECHANICAL_ISOSTRAIN_ID
      case('RGC')
        mechanical_type(ho) = MECHANICAL_RGC_ID
      case default
        call IO_error(500,ext_msg=mechanical%get_asStr('type'))
    end select
  end do

end subroutine parseMechanical


end submodule mechanical

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @author Pratheek Shanthraj, Max-Planck-Institut für Eisenforschung GmbH
!> @author Shaokang Zhang, Max-Planck-Institut für Eisenforschung GmbH
!> @author Fotios Tsiolis, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Spectral solver for thermal conduction
!--------------------------------------------------------------------------------------------------
#include <petsc/finclude/petscsnes.h>
#include <petsc/finclude/petscdmda.h>
module grid_thermal_spectral
  use PETScDMDA
  use PETScSNES
#ifndef PETSC_EXPOSES_MPI
  use MPI_f08
#endif
  use HDF5

  use prec
  use parallelization
  use IO
  use misc
  use CLI
  use HDF5_utilities
  use spectral_utilities
  use grid_utilities
  use discretization_grid
  use homogenization
  use types
  use config
  use constants

#ifndef PETSC_EXPOSES_MPIF90
  implicit none(type,external)
#else
  implicit none
#endif
  private

  type :: tNumerics
    integer :: &
      itmax                                                                                         !< maximum number of iterations
    real(pREAL) :: &
      eps_thermal_atol, &                                                                           !< absolute tolerance for thermal equilibrium
      eps_thermal_rtol                                                                              !< relative tolerance for thermal equilibrium
  end type tNumerics

  type(tNumerics) :: num

!--------------------------------------------------------------------------------------------------
! PETSc data
  SNES :: SNES_thermal
  Vec :: T_vec
  real(pREAL), dimension(:,:,:), allocatable :: &
    T_lastinc, &                                                                                    !< field of previous temperature
    T_staginc, &                                                                                    !< field of staggered temperature
    T_dot_lastinc
!--------------------------------------------------------------------------------------------------
! reference diffusion tensor, mobility etc.
  integer                     :: totalIter = 0                                                      !< total iteration in current increment
  real(pREAL), dimension(3,3) :: K_ref
  real(pREAL)                 :: mu_ref, Delta_t_
  real(pREAL) :: &
    T_aim         = 0.0_pREAL, &                                                                    !< prescribed mean temperature
    T_aim_lastinc = 0.0_pREAL, &                                                                    !< mean temperature at start of increment
    T_aimDot      = 0.0_pREAL                                                                       !< rate of mean temperature
  type(tBCthermal) :: T_BC_current                                                                  !< thermal BC for current load step; unallocated = undefined
  integer(kind(STATUS_OK))    :: status

  public :: &
    grid_thermal_spectral_init, &
    grid_thermal_spectral_solution, &
    grid_thermal_spectral_restartWrite, &
    grid_thermal_spectral_forward

contains

!--------------------------------------------------------------------------------------------------
!> @brief Allocate all necessary fields and fill them with data, potentially from restart info.
!--------------------------------------------------------------------------------------------------
subroutine grid_thermal_spectral_init(num_grid_thermal)

  type(tDict), pointer, intent(in) :: num_grid_thermal

  integer(MPI_INTEGER_KIND), dimension(0:worldsize-1) :: cells3_global
  integer :: ce
  DM :: DM_thermal
  real(pREAL), dimension(:,:,:), pointer :: T                                                       ! 0-indexed
  integer(MPI_INTEGER_KIND) :: err_MPI
  PetscErrorCode :: err_PETSc
  integer(HID_T) :: fileHandle, groupHandle
  real(pREAL), dimension(1,product(cells(1:2))*cells3) :: tempN
  real(pREAL), dimension(1) :: tmp
  character(len=:), allocatable :: &
    extmsg, &
    petsc_options


  print'(/,1x,a)', '<<<+-  grid_thermal_spectral init  -+>>>'

  print'(/,1x,a)', 'P. Shanthraj et al., Handbook of Mechanics of Materials, 2019'
  print'(  1x,a)', 'https://doi.org/10.1007/978-981-10-6884-3_80'

  if (.not. homogenization_thermal_active()) call IO_error(501,ext_msg='thermal')

!-------------------------------------------------------------------------------------------------
! read numerical parameters and do sanity checks
  num%itmax            = num_grid_thermal%get_asInt('N_iter_max', defaultVal=100)
  num%eps_thermal_atol = num_grid_thermal%get_asReal('eps_abs_T', defaultVal=1.0e-2_pREAL)
  num%eps_thermal_rtol = num_grid_thermal%get_asReal('eps_rel_T', defaultVal=1.0e-6_pREAL)

  extmsg = ''
  if (num%eps_thermal_atol <= 0.0_pREAL)        extmsg = trim(extmsg)//' eps_abs_T'
  if (num%eps_thermal_rtol <= 0.0_pREAL)        extmsg = trim(extmsg)//' eps_rel_T'
  if (num%itmax < 1)                            extmsg = trim(extmsg)//' N_iter_max'

  if (extmsg /= '') call IO_error(301,ext_msg=trim(extmsg))
!--------------------------------------------------------------------------------------------------
! set default and user defined options for PETSc
  petsc_options = misc_prefixOptions('-snes_type newtonls -snes_mf -snes_ksp_ew -ksp_type fgmres '// &
                                     num_grid_thermal%get_asStr('PETSc_options',defaultVal=''), 'thermal_')
  call PetscOptionsInsertString(PETSC_NULL_OPTIONS,petsc_options,err_PETSc)
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! initialize solver specific parts of PETSc
  call SNESCreate(PETSC_COMM_WORLD,SNES_thermal,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESSetOptionsPrefix(SNES_thermal,'thermal_',err_PETSc)
  CHKERRQ(err_PETSc)
  call MPI_Allgather(int(cells3,pPETSCINT),1_MPI_INTEGER_KIND,MPI_INTEGER,&
                     cells3_global,1_MPI_INTEGER_KIND,MPI_INTEGER,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  call DMDACreate3D(PETSC_COMM_WORLD, &
         DM_BOUNDARY_NONE, DM_BOUNDARY_NONE, DM_BOUNDARY_NONE, &                                    ! cut off stencil at boundary
         DMDA_STENCIL_BOX, &                                                                        ! Moore (26) neighborhood around central point
         int(cells(1),pPETSCINT),int(cells(2),pPETSCINT),int(cells(3),pPETSCINT), &                 ! global cells
         1_pPETSCINT, 1_pPETSCINT, int(worldsize,pPETSCINT), &
         1_pPETSCINT, 0_pPETSCINT, &                                                                ! #dof (T, scalar), ghost boundary width (domain overlap)
         [int(cells(1),pPETSCINT)],[int(cells(2),pPETSCINT)],int(cells3_global,pPETSCINT), &        ! local cells
         DM_thermal,err_PETSc)                                                                      ! handle, error
  CHKERRQ(err_PETSc)
  call DMsetFromOptions(DM_thermal,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMsetUp(DM_thermal,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMCreateGlobalVector(DM_thermal,T_vec,err_PETSc)                                             ! global solution vector (cells x 1, i.e. every def grad tensor)
  CHKERRQ(err_PETSc)
  call DMDASNESSetFunctionLocal(DM_thermal,INSERT_VALUES,form_residual,PETSC_NULL_SNES,err_PETSc)   ! residual vector of same shape as solution vector
  CHKERRQ(err_PETSc)
  call SNESSetDM(SNES_thermal,DM_thermal,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESSetFromOptions(SNES_thermal,err_PETSc)                                                   ! pull it all together with additional CLI arguments
  CHKERRQ(err_PETSc)

  call DMDAVecGetArray(DM_thermal,T_vec,T,err_PETSc)                                                ! returns 0-indexed T
  CHKERRQ(err_PETSc)

  restartRead: if (CLI_restartInc /= -1) then
    print'(/,1x,a,1x,i0)', 'loading restart data of increment', CLI_restartInc

    fileHandle  = HDF5_openFile(CLI_jobName//'_restart.hdf5','r')
    groupHandle = HDF5_openGroup(fileHandle,'solver')

    call HDF5_read(tempN,groupHandle,'T',.false.)
    T = reshape(tempN,[cells(1),cells(2),cells3])
    call HDF5_read(tempN,groupHandle,'T_lastinc',.false.)                                           ! ToDo 4.0: rename dataset name
    T_lastinc = reshape(tempN,[cells(1),cells(2),cells3])
    T_staginc = T_lastinc
    call HDF5_read(tempN,groupHandle,'dotT_lastinc',.false.)
    T_dot_lastinc = reshape(tempN,[cells(1),cells(2),cells3])                                       ! ToDo 4.0: rename dataset name
    call HDF5_read(tmp,groupHandle,'T_aim',.false.)
    T_aim = tmp(1)
    call HDF5_read(tmp,groupHandle,'T_aim_lastinc',.false.)
    T_aim_lastinc = tmp(1)
  else
    T = discretization_grid_getScalarInitialCondition('T')
    T_lastinc = T(0:,0:,lbound(T,3):)
    T_staginc = T_lastinc
    T_dot_lastinc = 0.0_pREAL * T_lastinc
    T_aim = sum(T_lastinc)*wgt
    call MPI_Allreduce(MPI_IN_PLACE,T_aim,1_MPI_INTEGER_KIND,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,err_MPI)
    call parallelization_chkerr(err_MPI)
    T_aim_lastinc = T_aim
  end if restartRead

  call homogenization_thermal_setField(reshape(T,[product(cells(1:2))*cells3]), &
                                       [(0.0_pREAL, ce = 1,product(cells(1:2))*cells3)])

  call DMDAVecRestoreArray(DM_thermal,T_vec,T,err_PETSc)
  CHKERRQ(err_PETSc)

  call updateReference()

end subroutine grid_thermal_spectral_init


!--------------------------------------------------------------------------------------------------
!> @brief solution for the spectral thermal scheme with internal iterations
!--------------------------------------------------------------------------------------------------
function grid_thermal_spectral_solution(Delta_t) result(solution)

  real(pREAL), intent(in) ::  Delta_t                                                               !< increment in time for current solution

  type(tSolutionState) :: solution
  PetscInt  :: devNull
  PetscReal :: T_min, T_max, stagNorm
  real(pREAL) :: T_mean
  DM :: DM_thermal
  real(pREAL), dimension(:,:,:), pointer :: T                                                       ! 0-indexed
  integer(MPI_INTEGER_KIND) :: err_MPI
  PetscErrorCode :: err_PETSc
  SNESConvergedReason :: reason


!--------------------------------------------------------------------------------------------------
! set module wide availabe data
  Delta_t_ = Delta_t

  call SNESSolve(SNES_thermal,PETSC_NULL_VEC,T_vec,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESGetConvergedReason(SNES_thermal,reason,err_PETSc)
  CHKERRQ(err_PETSc)

  call SNESGetDM(SNES_thermal,DM_thermal,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecGetArray(DM_thermal,T_vec,T,err_PETSc)
  CHKERRQ(err_PETSc)
  T_mean = sum(T)*wgt
  call MPI_Allreduce(MPI_IN_PLACE,T_mean,1_MPI_INTEGER_KIND,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  if (allocated(T_BC_current%myType)) then
    select case (T_BC_current%thermostat)
      case ('shift')
        T = T + (T_aim - T_mean)
      case ('scale')
        T = T*(T_aim/T_mean)
    end select
  else
    T_aim = T_mean
  end if
  call DMDAVecRestoreArray(DM_thermal,T_vec,T,err_PETSc)
  CHKERRQ(err_PETSc)

#if PETSC_VERSION_MINOR<23
  solution%converged = reason > SNES_CONVERGED_ITERATING .and. status == STATUS_OK
#else
  solution%converged = reason%v > SNES_CONVERGED_ITERATING%v .and. status == STATUS_OK
#endif
  solution%iterationsNeeded = merge(totalIter,num%itmax,solution%converged)

  call VecMin(T_vec,devNull,T_min,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecMax(T_vec,devNull,T_max,err_PETSc)
  CHKERRQ(err_PETSc)

  call SNESGetDM(SNES_thermal,DM_thermal,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecGetArrayRead(DM_thermal,T_vec,T,err_PETSc)                                            ! returns 0-indexed T
  CHKERRQ(err_PETSc)

  stagNorm = maxval(abs(T - T_staginc))
  call MPI_Allreduce(MPI_IN_PLACE,stagNorm,1_MPI_INTEGER_KIND,MPI_DOUBLE,MPI_MAX,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  solution%stagConverged = stagNorm < max(num%eps_thermal_atol, num%eps_thermal_rtol*T_max)
  call MPI_Allreduce(MPI_IN_PLACE,solution%stagConverged,1_MPI_INTEGER_KIND,MPI_LOGICAL,MPI_LAND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  T_staginc = T

  call homogenization_thermal_setField(reshape(T,[product(cells(1:2))*cells3]), &
                                       reshape(T-T_lastinc,[product(cells(1:2))*cells3])/Delta_t_)

  call DMDAVecRestoreArrayRead(DM_thermal,T_vec,T,err_PETSc)
  CHKERRQ(err_PETSc)

  if (solution%converged) &
    print'(/,1x,a)', '... thermal conduction converged ..................................'
  print'(/,1x,a,f8.3,2x,f8.3,2x,f8.4)', 'Minimum|Maximum|Delta Temperature / K = ', T_min, T_max, stagNorm
  print'(/,1x,a)', '==========================================================================='
  flush(IO_STDOUT)

end function grid_thermal_spectral_solution


!--------------------------------------------------------------------------------------------------
!> @brief Set DAMASK data to current solver status.
!--------------------------------------------------------------------------------------------------
subroutine grid_thermal_spectral_forward(cutBack, guess, Delta_t, Delta_t_prev, t_remaining, &
                                         thermal_BC)

  logical,          intent(in)           :: cutBack, guess
  real(pREAL),      intent(in)           :: Delta_t, Delta_t_prev, t_remaining
  type(tBCthermal), intent(in), optional :: thermal_BC

  DM :: DM_thermal
  real(pREAL),  dimension(:,:,:), pointer :: T
  PetscErrorCode :: err_PETSc


  call SNESGetDM(SNES_thermal,DM_thermal,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecGetArray(DM_thermal,T_vec,T,err_PETSc)
  CHKERRQ(err_PETSc)

  if (cutBack) then
    call homogenization_thermal_setField(reshape(T_lastinc,[product(cells(1:2))*cells3]), &
                                         reshape(T_dot_lastinc,[product(cells(1:2))*cells3]))
    T = T_lastinc
    T_staginc = T_lastinc
    T_aim = T_aim_lastinc
  else
    T_dot_lastinc = (T - T_lastinc)/Delta_t
    T_lastinc = T
    T_aim_lastinc = T_aim
    if (present(thermal_BC)) then
      T_BC_current = thermal_BC
      select case (thermal_BC%myType)
        case ('dot_T')
          T_aimDot = thermal_BC%value
        case ('T')
          T_aimDot = (thermal_BC%value - T_aim_lastinc)/t_remaining
      end select
    else
      if (allocated(T_BC_current%myType))     deallocate(T_BC_current%myType)
      if (allocated(T_BC_current%thermostat)) deallocate(T_BC_current%thermostat)
      T_aimDot = merge(0.0_pREAL,(T_aim - T_aim_lastinc)/Delta_t_prev,guess)
    end if
    T_aim = T_aim_lastinc + T_aimDot*Delta_t
    T = utilities_forwardScalarField(Delta_t, T_lastinc, T_dot_lastinc)
    call updateReference()
  end if

  call DMDAVecRestoreArray(DM_thermal,T_vec,T,err_PETSc)
  CHKERRQ(err_PETSc)

end subroutine grid_thermal_spectral_forward


!--------------------------------------------------------------------------------------------------
!> @brief Write current solver and constitutive data for restart to file.
!--------------------------------------------------------------------------------------------------
subroutine grid_thermal_spectral_restartWrite()

  PetscErrorCode :: err_PETSc
  DM :: DM_thermal
  integer(HID_T) :: fileHandle, groupHandle
  real(pREAL), dimension(:,:,:), pointer :: T                                                       ! 0-indexed


  call SNESGetDM(SNES_thermal,DM_thermal,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecGetArrayRead(DM_thermal,T_vec,T,err_PETSc)                                            ! returns 0-indexed T
  CHKERRQ(err_PETSc)

  print'(1x,a)', 'saving thermal solver data required for restart'; flush(IO_STDOUT)

  fileHandle  = HDF5_openFile(CLI_jobName//'_restart.hdf5','a')
  groupHandle = HDF5_openGroup(fileHandle,'solver')
  call HDF5_write(reshape(T,[1,product(shape(T))]),groupHandle,'T')
  call HDF5_write(reshape(T_lastinc,[1,product(shape(T_lastinc))]),groupHandle,'T_lastinc')         ! ToDo 4.0: rename dataset name
  call HDF5_write(reshape(T_dot_lastinc,[1,product(shape(T_dot_lastinc))]),groupHandle,'dotT_lastinc') ! ToDo 4.0: rename dataset name
  call HDF5_write([T_aim],        groupHandle,'T_aim')
  call HDF5_write([T_aim_lastinc],groupHandle,'T_aim_lastinc')
  call HDF5_closeGroup(groupHandle)
  call HDF5_closeFile(fileHandle)

  call DMDAVecRestoreArrayRead(DM_thermal,T_vec,T,err_PETSc);
  CHKERRQ(err_PETSc)

end subroutine grid_thermal_spectral_restartWrite


!--------------------------------------------------------------------------------------------------
!> @brief Construct the residual vector.
!--------------------------------------------------------------------------------------------------
subroutine form_residual(residual_subdomain,T,r,dummy,err_PETSc)

#if PETSC_VERSION_MINOR<22
  DMDALocalInfo, dimension(DMDA_LOCAL_INFO_SIZE) :: &
#else
  DMDALocalInfo :: &
#endif
    residual_subdomain
  real(pREAL), dimension(cells(1),cells(2),cells3), intent(in) :: &
    T                                                                                               !< temperature
  real(pREAL), dimension(cells(1),cells(2),cells3), intent(out) :: &
    r                                                                                               !< residual
  PetscObject :: dummy
  PetscErrorCode, intent(out) :: err_PETSc

  integer :: i, j, k, ce
  real(pREAL), dimension(3,cells(1),cells(2),cells3) :: vector_field


  call homogenization_thermal_response(status,Delta_t_,1,product(cells(1:2))*cells3)

  vector_field = utilities_ScalarGradient(T)
  ce = 0
  do k = 1, cells3;  do j = 1, cells(2);  do i = 1,cells(1)
    ce = ce + 1
    vector_field(1:3,i,j,k) = matmul(homogenization_K_T(ce) - K_ref, vector_field(1:3,i,j,k))
  end do; end do; end do
  r = utilities_VectorDivergence(vector_field)
  ce = 0
  do k = 1, cells3;  do j = 1, cells(2);  do i = 1,cells(1)
    ce = ce + 1
    r(i,j,k) = Delta_t_*(r(i,j,k) + homogenization_f_T(ce)) &
             + homogenization_mu_T(ce) * (T_lastinc(i,j,k) - T(i,j,k)) &
             + mu_ref*T(i,j,k)
  end do; end do; end do

  r = T &
    - utilities_GreenConvolution(r, K_ref, mu_ref, Delta_t_)
  err_PETSc = 0_pPETSCERRORCODE

end subroutine form_residual


!--------------------------------------------------------------------------------------------------
!> @brief Update reference viscosity and conductivity.
!--------------------------------------------------------------------------------------------------
subroutine updateReference()

  integer :: ce
  integer(MPI_INTEGER_KIND) :: err_MPI


  K_ref = 0.0_pREAL
  mu_ref = 0.0_pREAL
  do ce = 1, product(cells(1:2))*cells3
    K_ref  = K_ref  + homogenization_K_T(ce)
    mu_ref = mu_ref + homogenization_mu_T(ce)
  end do

  K_ref = K_ref*wgt
  call MPI_Allreduce(MPI_IN_PLACE,K_ref,9_MPI_INTEGER_KIND,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  mu_ref = mu_ref*wgt
  call MPI_Allreduce(MPI_IN_PLACE,mu_ref,1_MPI_INTEGER_KIND,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)

end subroutine updateReference


end module grid_thermal_spectral

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Pratheek Shanthraj, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author Fotios Tsiolis, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Driver controlling inner and outer load case looping of the various spectral solvers
!> @details doing cutbacking, forwarding in case of restart, reporting statistics, writing
!> results
!--------------------------------------------------------------------------------------------------
#include <petsc/finclude/petscsys.h>
program DAMASK_grid
  use PETScSys
#ifndef PETSC_EXPOSES_MPI
  use MPI_f08
#endif

  use prec
  use parallelization
  use signal
  use CLI
  use HDF5_utilities
  use IO
  use config
  use math
  use discretization_grid
  use materialpoint
  use material
  use spectral_utilities
  use grid_utilities
  use grid_mechanical_spectral_basic
  use grid_mech_spectral_polarization
  use grid_mechanical_spectral_Galerkin
  use grid_mechanical_FEM
  use grid_chemical_FDM
  use grid_damage_spectral
  use grid_thermal_spectral
  use result

#ifndef PETSC_EXPOSES_MPIF90
  implicit none(type,external)
#else
  implicit none
#endif

  type :: tLoadCase
    type(tRotation)          :: rot                                                                 !< rotation of BC
    type(tBCmech) :: stress, &                                                           !< stress BC
                                deformation                                                         !< deformation BC (dot_F, F, or L)
    type(tBCthermal) ::         temperature                                                         !< thermal BC; unallocated = free
    real(pREAL) ::              t, &                                                                !< length of increment
                                r                                                                   !< ratio of geometric progression
    integer ::                  N, &                                                                !< number of increments
                                f_out, &                                                            !< frequency of result writes
                                f_restart                                                           !< frequency of restart writes
    logical ::                  estimate_rate                                                       !< follow trajectory of former loadcase
  end type tLoadCase

!--------------------------------------------------------------------------------------------------
! field labels information
  enum, bind(c); enumerator :: &
    FIELD_UNDEFINED_ID, &
    FIELD_MECH_ID, &
    FIELD_THERMAL_ID, &
    FIELD_DAMAGE_ID, &
    FIELD_CHEMICAL_ID
  end enum

  integer(kind(FIELD_UNDEFINED_ID)), allocatable :: ID(:)

!--------------------------------------------------------------------------------------------------
! loop variables, convergence etc.
  integer, parameter :: &
    subStepFactor = 2                                                                               !< for each substep, divide the last time increment by 2.0
  real(pREAL) :: &
    t = 0.0_pREAL, &                                                                                !< elapsed time
    t_0 = 0.0_pREAL, &                                                                              !< begin of interval
    Delta_t = 1.0_pREAL, &                                                                          !< current time interval
    Delta_t_prev = 0.0_pREAL, &                                                                     !< previous time interval
    t_remaining = 0.0_pREAL                                                                         !< remaining time of current load case
  logical :: &
    guess, &                                                                                        !< guess along former trajectory
    stagIterate, &
    cutBack = .false.,&
    sig
  integer :: &
    field, &
    cutBackLevel = 0, &                                                                             !< cut back level \f$ t = \frac{t_{inc}}{2^l} \f$
    stepFraction = 0, &                                                                             !< fraction of current time interval
    l = 0, &                                                                                        !< current load case
    inc, &                                                                                          !< current increment in current load case
    totalIncsCounter = 0, &                                                                         !< total # of increments
    unit_stat = 0, &                                                                                !< file unit for statistics output
    stagIter, &
    nActiveFields = 0, &
    maxCutBack, &                                                                                   !< max number of cut backs
    stagItMax                                                                                       !< max number of field level staggered iterations
  logical :: active_Gamma = .false., active_G = .false., active_parabolic = .false., exists
  integer(MPI_INTEGER_KIND) :: err_MPI
  character(len=pSTRLEN) :: &
    incInfo

  type(tLoadCase), allocatable, dimension(:) :: loadCases                                           !< array of all load cases
  type(tSolutionState), allocatable, dimension(:) :: solres
  procedure(grid_mechanical_spectral_basic_init), pointer :: &
    grid_mechanical_init
  procedure(grid_mechanical_spectral_basic_forward), pointer :: &
    grid_mechanical_forward
  procedure(grid_mechanical_spectral_basic_solution), pointer :: &
    grid_mechanical_solution
  procedure(grid_mechanical_spectral_basic_updateCoords), pointer :: &
    grid_mechanical_updateCoords
  procedure(grid_mechanical_spectral_basic_restartWrite), pointer :: &
    grid_mechanical_restartWrite

  type(tDict), pointer :: &
    load, &
    num_solver, &
    num_grid, &
    solver
  character(len=:), allocatable :: &
    fileContent, fname
  integer(HID_T) :: fileHandle


!--------------------------------------------------------------------------------------------------
! init DAMASK (all modules)

  call materialpoint_initAll()
  print'(/,1x,a)', '<<<+-  DAMASK_grid init  -+>>>'; flush(IO_STDOUT)

  print'(/,1x,a)', 'P. Shanthraj et al., Handbook of Mechanics of Materials, 2019'
  print'(  1x,a)', 'https://doi.org/10.1007/978-981-10-6884-3_80'


!-------------------------------------------------------------------------------------------------
! read (and check) field parameters from numerics file

  num_solver => config_numerics%get_dict('solver',defaultVal=emptyDict)
  num_grid => num_solver%get_dict('grid',defaultVal=emptyDict)

  stagItMax  = num_grid%get_asInt('N_staggered_iter_max',defaultVal=10)
  maxCutBack = num_grid%get_asInt('N_cutback_max',defaultVal=3)

  if (stagItMax < 0)    call IO_error(301,ext_msg='N_staggered_iter_max')
  if (maxCutBack < 0)   call IO_error(301,ext_msg='N_cutback_max')


  if (worldrank == 0) then
    fileContent = IO_read(CLI_loadFile)
    fname = CLI_loadFile
    if (scan(fname,'/') /= 0) fname = fname(scan(fname,'/',.true.)+1:)
    call result_openJobFile(parallel=.false.)
    call result_addSetupFile(fileContent,fname,'load case definition (grid solver)')
    call result_closeJobFile()
  end if

  call parallelization_bcast_str(fileContent)
  load => YAML_str_asDict(fileContent)
  solver => load%get_dict('solver')

!--------------------------------------------------------------------------------------------------
! assign mechanics solver depending on selected type

  nActiveFields = 1
  select case (solver%get_asStr('mechanical'))
    case ('spectral_basic')
      grid_mechanical_init         => grid_mechanical_spectral_basic_init
      grid_mechanical_forward      => grid_mechanical_spectral_basic_forward
      grid_mechanical_solution     => grid_mechanical_spectral_basic_solution
      grid_mechanical_updateCoords => grid_mechanical_spectral_basic_updateCoords
      grid_mechanical_restartWrite => grid_mechanical_spectral_basic_restartWrite
      active_Gamma = .true.

    case ('spectral_polarization')
      grid_mechanical_init         => grid_mech_spectral_polarization_init
      grid_mechanical_forward      => grid_mech_spectral_polarization_forward
      grid_mechanical_solution     => grid_mech_spectral_polarization_solution
      grid_mechanical_updateCoords => grid_mech_spectral_polarization_updateCoords
      grid_mechanical_restartWrite => grid_mech_spectral_polarization_restartWrite
      active_Gamma = .true.

    case ('spectral_Galerkin')
      grid_mechanical_init         => grid_mechanical_spectral_Galerkin_init
      grid_mechanical_forward      => grid_mechanical_spectral_Galerkin_forward
      grid_mechanical_solution     => grid_mechanical_spectral_Galerkin_solution
      grid_mechanical_updateCoords => grid_mechanical_spectral_Galerkin_updateCoords
      grid_mechanical_restartWrite => grid_mechanical_spectral_Galerkin_restartWrite
      active_G = .true.

    case ('FEM')
      grid_mechanical_init         => grid_mechanical_FEM_init
      grid_mechanical_forward      => grid_mechanical_FEM_forward
      grid_mechanical_solution     => grid_mechanical_FEM_solution
      grid_mechanical_updateCoords => grid_mechanical_FEM_updateCoords
      grid_mechanical_restartWrite => grid_mechanical_FEM_restartWrite

    case default
      call IO_error(601_pI16,trim(solver%get_asStr('mechanical')), 'is not a valid grid solver type', emph=[1])

  end select

!--------------------------------------------------------------------------------------------------
! initialize field solver information
  if (solver%get_asStr('thermal',defaultVal = 'n/a') == 'spectral') nActiveFields = nActiveFields + 1
  if (solver%get_asStr('damage', defaultVal = 'n/a') == 'spectral') nActiveFields = nActiveFields + 1
  if (solver%get_asStr('chemical', defaultVal = 'n/a') == 'FDM')    nActiveFields = nActiveFields + 1

  allocate(solres(nActiveFields))
  allocate(    ID(nActiveFields))

  field = 1
  ID(field) = FIELD_MECH_ID                                                                         ! mechanical active by default
  thermalActive: if (solver%get_asStr('thermal',defaultVal = 'n/a') == 'spectral') then
    field = field + 1
    ID(field) = FIELD_THERMAL_ID
    active_parabolic = .true.
  end if thermalActive
  damageActive: if (solver%get_asStr('damage',defaultVal = 'n/a') == 'spectral') then
    field = field + 1
    ID(field) = FIELD_DAMAGE_ID
    active_parabolic = .true.
  end if damageActive
  chemicalActive: if (solver%get_asStr('chemical',defaultVal = 'n/a') == 'FDM') then
    field = field + 1
    ID(field) = FIELD_CHEMICAL_ID
    active_parabolic = .true.
  end if chemicalActive

!--------------------------------------------------------------------------------------------------
! doing initialization depending on active solvers
  call spectral_utilities_init(active_Gamma, active_G, active_parabolic)

  do field = 2, nActiveFields
    select case (ID(field))

      case (FIELD_THERMAL_ID)
        call grid_thermal_spectral_init(num_grid%get_dict('thermal',defaultVal=emptyDict))

      case (FIELD_DAMAGE_ID)
        call grid_damage_spectral_init(num_grid%get_dict('damage',defaultVal=emptyDict))

      case (FIELD_CHEMICAL_ID)
        call grid_chemical_FDM_init(num_grid%get_dict('chemical',defaultVal=emptyDict))

    end select
  end do

  call grid_mechanical_init(num_grid%get_dict('mechanical',defaultVal=emptyDict))
  call discretization_grid_finalize()
  call config_numerics_deallocate()

!--------------------------------------------------------------------------------------------------
! open/create statistics file
  if (worldrank == 0) then
    fname = trim(CLI_jobName)//'.sta'
    inquire(file=fname,exist=exists)
    writeHeader: if (CLI_restartInc == -1 .or. .not. exists) then
      open(newunit=unit_stat,file=fname,form='FORMATTED',status='REPLACE')
      write(unit_stat,'(a)') 'Increment Time CutbackLevel Converged IterationsNeeded StagIterationsNeeded'
    else writeHeader
      open(newunit=unit_stat,file=fname,form='FORMATTED', position='APPEND', status='OLD')
    end if writeHeader
  end if

  writeUndeformed: if (CLI_restartInc == -1) then
    print'(/,1x,a)', '... saving initial configuration ..........................................'
    flush(IO_STDOUT)
    call materialpoint_result(0,0.0_pREAL)
  end if writeUndeformed

  loadCases = parse_and_print_load_cases(load%get_list('loadstep'), solver)

  loadCaseLooping: do l = 1, size(loadCases)
    t_0 = t                                                                                         ! load case start time
    guess = loadCases(l)%estimate_rate                                                              ! change of load case? homogeneous guess for the first inc

    incLooping: do inc = 1, loadCases(l)%N
      totalIncsCounter = totalIncsCounter + 1

!--------------------------------------------------------------------------------------------------
! forwarding time
      Delta_t_prev = Delta_t                                                                        ! last time intervall that brought former inc to an end
      if (dEq(loadCases(l)%r,1.0_pREAL,1.e-9_pREAL)) then                                           ! linear scale
        Delta_t = loadCases(l)%t/real(loadCases(l)%N,pREAL)
      else
        Delta_t = loadCases(l)%t * (loadCases(l)%r**(inc-1)-loadCases(l)%r**inc) &
                                 / (1.0_pREAL-loadCases(l)%r**loadCases(l)%N)
      end if
      Delta_t = Delta_t * real(subStepFactor,pREAL)**real(-cutBackLevel,pREAL)                      ! depending on cut back level, decrease time step

      skipping: if (totalIncsCounter <= CLI_restartInc) then                                        ! not yet at restart inc?
        t = t + Delta_t                                                                             ! just advance time, skip already performed calculation
        guess = .true.                                                                              ! QUESTION:why forced guessing instead of inheriting loadcase preference
      else skipping
        stepFraction = 0                                                                            ! fraction scaled by stepFactor**cutLevel

        subStepLooping: do while (stepFraction < subStepFactor**cutBackLevel)
          t_remaining = loadCases(l)%t + t_0 - t
          t = t + Delta_t                                                                           ! forward target time
          stepFraction = stepFraction + 1                                                           ! count step

!--------------------------------------------------------------------------------------------------
! report beginning of new step
          print'(/,1x,a)', '###########################################################################'
          print'(1x,a,1x,es12.5,6(a,i0))', &
                  'Time', t, &
                  's: Increment ', inc,'/',loadCases(l)%N,&
                  '-', stepFraction,'/',subStepFactor**cutBackLevel,&
                  ' of load case ', l,'/',size(loadCases)
          write(incInfo,'(4(a,i0))') &
                  'Increment ',totalIncsCounter,'/',sum(loadCases%N),&
                  '-', stepFraction,'/',subStepFactor**cutBackLevel
          flush(IO_STDOUT)

!--------------------------------------------------------------------------------------------------
! forward fields
          do field = 1, nActiveFields
            select case(ID(field))
              case(FIELD_MECH_ID)
                call grid_mechanical_forward (&
                        cutBack,guess,Delta_t,Delta_t_prev,t_remaining, &
                        deformation_BC = loadCases(l)%deformation, &
                        stress_BC      = loadCases(l)%stress, &
                        rotation_BC    = loadCases(l)%rot)

              case(FIELD_THERMAL_ID)
                if (allocated(loadCases(l)%temperature%myType)) then
                  call grid_thermal_spectral_forward(cutBack, guess, Delta_t, Delta_t_prev, t_remaining, &
                                                     loadCases(l)%temperature)
                else
                  call grid_thermal_spectral_forward(cutBack, guess, Delta_t, Delta_t_prev, t_remaining)
                end if
              case(FIELD_DAMAGE_ID); call grid_damage_spectral_forward(cutBack)
              case(FIELD_CHEMICAL_ID); call grid_chemical_FDM_forward(cutBack)
            end select
          end do
          if (.not. cutBack) call materialpoint_forward

!--------------------------------------------------------------------------------------------------
! solve fields
          stagIter = 1
          stagIterate = .true.
          do while (stagIterate)

            if (nActiveFields > 1) print'(/,1x,a,i0)', 'Staggered Iteration ',stagIter
            do field = 1, nActiveFields
              select case(ID(field))
                case(FIELD_MECH_ID)
                  solres(field) = grid_mechanical_solution(incInfo)
                case(FIELD_THERMAL_ID)
                  solres(field) = grid_thermal_spectral_solution(Delta_t)
                case(FIELD_DAMAGE_ID)
                  solres(field) = grid_damage_spectral_solution(Delta_t)
                case(FIELD_CHEMICAL_ID)
                  solres(field) = grid_chemical_FDM_solution(Delta_t)
              end select

              if (.not. solres(field)%converged) exit                                               ! no solution found

            end do
            stagIter = stagIter + 1
            stagIterate =            stagIter <= stagItMax &
                         .and.       all(solres(:)%converged) &
                         .and. .not. all(solres(:)%stagConverged)                                   ! stationary with respect to staggered iteration
          end do

!--------------------------------------------------------------------------------------------------
! check solution and either advance or retry with smaller timestep

          if (all(solres(:)%converged .and. solres(:)%stagConverged)) then                          ! converged and acceptable solution found
            call grid_mechanical_updateCoords()
            Delta_t_prev = Delta_t
            cutBack = .false.
            guess = .true.                                                                          ! start guessing after first converged (sub)inc
            if (worldrank == 0) then
              write(unit_stat,*) totalIncsCounter, t, cutBackLevel, &
                                solres(1)%converged, solres(1)%iterationsNeeded, StagIter - 1
              flush(unit_stat)
            end if
          elseif (cutBackLevel < maxCutBack) then                                                   ! further cutbacking tolerated?
            cutBack = .true.
            stepFraction = (stepFraction - 1) * subStepFactor                                       ! adjust to new denominator
            cutBackLevel = cutBackLevel + 1
            t = t - Delta_t
            Delta_t = Delta_t/real(subStepFactor,pREAL)                                             ! cut timestep
            print'(/,1x,a)', 'cutting back '
          else                                                                                      ! no more options to continue
            if (worldrank == 0) close(unit_stat)
            call IO_error(950)
          end if

        end do subStepLooping

        cutBackLevel = max(0, cutBackLevel - 1)                                                     ! try half number of subincs next inc

        if (all(solres(:)%converged)) then
          print'(/,1x,a,1x,i0,1x,a)', 'increment', totalIncsCounter, 'converged'
        else
          print'(/,1x,a,1x,i0,1x,a)', 'increment', totalIncsCounter, 'NOT converged'
        end if; flush(IO_STDOUT)

        call MPI_Allreduce(logical(signal_SIGUSR1),sig,1_MPI_INTEGER_KIND,MPI_LOGICAL,MPI_LOR,MPI_COMM_WORLD,err_MPI)
        call parallelization_chkerr(err_MPI)
        if (mod(inc,loadCases(l)%f_out) == 0 .or. sig) then
          print'(/,1x,a)', '... saving results ........................................................'
          flush(IO_STDOUT)
          call materialpoint_result(totalIncsCounter,t)
        end if
        if (sig) call signal_setSIGUSR1(.false.)

        call MPI_Allreduce(logical(signal_SIGUSR2),sig,1_MPI_INTEGER_KIND,MPI_LOGICAL,MPI_LOR,MPI_COMM_WORLD,err_MPI)
        call parallelization_chkerr(err_MPI)
        if (mod(inc,loadCases(l)%f_restart) == 0 .or. sig) then
          fileHandle = HDF5_openFile(CLI_jobName//'_restart.hdf5','w')
          call HDF5_addAttribute(fileHandle,'increment',totalIncsCounter)
          call HDF5_closeFile(fileHandle)
          do field = 1, nActiveFields
            select case (ID(field))
              case(FIELD_MECH_ID)
                call grid_mechanical_restartWrite()
              case(FIELD_THERMAL_ID)
                call grid_thermal_spectral_restartWrite()
              case(FIELD_DAMAGE_ID)
                call grid_damage_spectral_restartWrite()
              case(FIELD_CHEMICAL_ID)
                call grid_chemical_FDM_restartWrite()
            end select
          end do
          call materialpoint_restartWrite()
        end if
        if (sig) call signal_setSIGUSR2(.false.)

        call MPI_Allreduce(logical(signal_SIGINT),sig,1_MPI_INTEGER_KIND,MPI_LOGICAL,MPI_LOR,MPI_COMM_WORLD,err_MPI)
        call parallelization_chkerr(err_MPI)
        if (sig) exit loadCaseLooping
      end if skipping

    end do incLooping

  end do loadCaseLooping

!--------------------------------------------------------------------------------------------------
! report summary of whole calculation
  print'(/,1x,a)', '###########################################################################'
  if (worldrank == 0) close(unit_stat)

  call quit(0)                                                                                      ! no complains ;)

contains


function parse_and_print_load_cases(load_steps, solver) result(load_cases)

#ifndef __GFORTRAN__
  use prec
  use types
  use IO
  use math
  use parallelization

  import, only: tLoadCase, get_masked_tensor
#endif

  type(tList), intent(in), target :: load_steps
  type(tDict), pointer, intent(in) :: solver
  type(tLoadCase), allocatable, dimension(:) :: load_cases                                          !< array of all load cases

  integer :: i,j, l,m
  type(tDict), pointer :: &
    load_step, &
    step_bc, &
    step_mech, &
    step_therm, &
    step_discretization


  allocate(load_cases(size(load_steps)))
  do l = 1, size(load_steps)
    load_step => load_steps%get_dict(l)
    if (load_step%contains('boundary_condition')) then
      step_bc => load_step%get_dict('boundary_condition')
    else
      step_bc => load_step%get_dict('boundary_conditions')
    end if
    step_mech => step_bc%get_dict('mechanical')
    load_cases(l)%stress%myType=''
    readMech: do m = 1, size(step_mech)
      select case (step_mech%key(m))
        case ('L','dot_F','F_dot','F')                                                              ! assign values for the deformation BC matrix
          if (allocated(load_cases(l)%deformation%myType)) &
            call IO_error(830_pI16, 'load case', l, 'only one of L, dot_F, or F allowed in mechanical BC', emph=[2])
          load_cases(l)%deformation%myType = step_mech%key(m)
          if (load_cases(l)%deformation%myType == 'F_dot') load_cases(l)%deformation%myType = 'dot_F'
          call get_masked_tensor(load_cases(l)%deformation%values,load_cases(l)%deformation%mask,step_mech%get_list(m))
        case ('dot_P','P','P_dot')
          if (load_cases(l)%stress%myType /= '') &
            call IO_error(830_pI16, 'load case', l, 'only one of P or dot_P allowed in mechanical BC', emph=[2])
          load_cases(l)%stress%myType = step_mech%key(m)
          if (load_cases(l)%stress%myType == 'P_dot') load_cases(l)%stress%myType = 'dot_P'
          call get_masked_tensor(load_cases(l)%stress%values,load_cases(l)%stress%mask,step_mech%get_list(m))
      end select
      call load_cases(l)%rot%fromAxisAngle(step_mech%get_as1dReal('R',defaultVal = real([0.0,0.0,1.0,0.0],pREAL)),degrees=.true.)
    end do readMech
    if (.not. allocated(load_cases(l)%deformation%myType)) &
      call IO_error(830_pI16, 'load case', l, 'is incomplete: L, F_dot/dot_F, or F missing', emph=[2])

    if (step_bc%contains('thermal')) then
      step_therm => step_bc%get_dict('thermal')
      readTherm: do m = 1, size(step_therm)
        select case (step_therm%key(m))
          case ('T','dot_T')
            if (allocated(load_cases(l)%temperature%myType)) &
              call IO_error(830_pI16, 'load case', l, 'only one of T or dot_T allowed in thermal BC', emph=[2])
            load_cases(l)%temperature%myType = step_therm%key(m)
            load_cases(l)%temperature%value  = step_therm%get_asReal(m)
          case ('thermostat')
            load_cases(l)%temperature%thermostat = step_therm%get_asStr(m)
            if (load_cases(l)%temperature%thermostat /= 'shift' .and. &
                load_cases(l)%temperature%thermostat /= 'scale') &
              call IO_error(830_pI16, 'load case', l, 'thermal BC thermostat must be shift or scale', emph=[2])
        end select
      end do readTherm
      if (allocated(load_cases(l)%temperature%myType) .and. .not. allocated(load_cases(l)%temperature%thermostat)) &
        call IO_error(830_pI16, 'load case', l, 'thermal BC requires thermostat: shift or scale', emph=[2])
    end if

    step_discretization => load_step%get_dict('discretization')
    load_cases(l)%t = step_discretization%get_asReal('t')
    load_cases(l)%N = step_discretization%get_asInt  ('N')
    load_cases(l)%r = step_discretization%get_asReal('r',defaultVal= 1.0_pREAL)

    load_cases(l)%f_restart = load_step%get_asInt('f_restart', defaultVal=huge(0))
    if (load_step%get_asStr('f_out',defaultVal='n/a') == 'none') then
      load_cases(l)%f_out = huge(0)
    else
      load_cases(l)%f_out = load_step%get_asInt('f_out', defaultVal=1)
    end if
    load_cases(l)%estimate_rate = load_step%get_asBool('estimate_rate',defaultVal=.true.)

    reportAndCheck: if (worldrank == 0) then
      print'(/,1x,a,1x,i0)', 'load case:', l
      print'(2x,a,1x,l1)', 'estimate_rate:', load_cases(l)%estimate_rate
      if (load_cases(l)%deformation%myType == 'F') then
        print'(2x,a)', 'F:'
      else
        print'(2x,a)', load_cases(l)%deformation%myType//' / 1/s:'
      end if
      do i = 1, 3; do j = 1, 3
        if (load_cases(l)%deformation%mask(i,j)) then
          write(IO_STDOUT,'(2x,12a)',advance='no') '     x      '
        else
          write(IO_STDOUT,'(2x,f12.7)',advance='no') load_cases(l)%deformation%values(i,j)
        end if
        end do; write(IO_STDOUT,'(/)',advance='no')
      end do
      if (any(load_cases(l)%stress%mask .eqv. load_cases(l)%deformation%mask)) &
        call IO_error(830_pI16, 'mask consistency violated in load case', l, emph=[2])
      if (any(.not.(load_cases(l)%stress%mask .or. transpose(load_cases(l)%stress%mask)) .and. (math_I3<1))) &
        call IO_error(830_pI16, 'mixed boundary conditions allow rotation in load case', l, emph=[2])

      if (load_cases(l)%stress%myType == 'P')     print'(2x,a)', 'P / MPa:'
      if (load_cases(l)%stress%myType == 'dot_P') print'(2x,a)', 'dot_P / MPa/s:'

      if (load_cases(l)%stress%myType /= '') then
        do i = 1, 3; do j = 1, 3
          if (load_cases(l)%stress%mask(i,j)) then
            write(IO_STDOUT,'(2x,12a)',advance='no') '     x      '
          else
            write(IO_STDOUT,'(2x,f12.4)',advance='no') load_cases(l)%stress%values(i,j)*1e-6_pREAL
          end if
          end do; write(IO_STDOUT,'(/)',advance='no')
        end do
      end if
      if (any(dNeq(load_cases(l)%rot%asMatrix(), math_I3))) &
        write(IO_STDOUT,'(2x,a,/,3(3(3x,f12.7,1x)/))',advance='no') 'R:',&
                 transpose(load_cases(l)%rot%asMatrix())

      if (allocated(load_cases(l)%temperature%myType)) then
        if (load_cases(l)%temperature%myType == 'T') then
          print'(2x,a,1x,f0.3)', 'T / K:', load_cases(l)%temperature%value
        else
          print'(2x,a,1x,f0.3)', 'dot_T / K/s:', load_cases(l)%temperature%value
        end if
        print'(2x,a,1x,a)', 'thermal BC thermostat:', load_cases(l)%temperature%thermostat
      end if

      if (solver%get_asStr('mechanical') == 'spectral_Galerkin' .and. step_mech%contains('R')) &
        call IO_error(830_pI16, 'load case', l, 'contains rotation', 'R', &
                      'which is not supported when using the Galerkin solver', emph=[2,4])
      if (load_cases(l)%r <= 0.0_pREAL) &
        call IO_error(830_pI16, 'non-positive ratio for geometric progression in load case', l, emph=[2])
      if (load_cases(l)%t <= 0.0_pREAL) &
        call IO_error(830_pI16, 'negative time increment in load case', l, emph=[2])
      if (load_cases(l)%N < 1) &
        call IO_error(830_pI16, 'non-positive number of increments in load case', l, emph=[2])
      if (load_cases(l)%f_out < 1) &
        call IO_error(830_pI16, 'non-positive result frequency in load case', l, emph=[2])
      if (load_cases(l)%f_restart < 1) &
        call IO_error(830_pI16, 'non-positive restart frequency in load case', l, emph=[2])

      if (dEq(load_cases(l)%r,1.0_pREAL,1.e-9_pREAL)) then
        print'(2x,a)', 'r: 1 (constant step width)'
      else
        print'(2x,a,1x,f0.3)', 'r:', load_cases(l)%r
      end if
      print'(2x,a,1x,f0.3)',   't:', load_cases(l)%t
      print'(2x,a,1x,i0)',     'N:', load_cases(l)%N
      if (load_cases(l)%f_out < huge(0)) &
        print'(2x,a,1x,i0)',   'f_out:', load_cases(l)%f_out
      if (load_cases(l)%f_restart < huge(0)) &
        print'(2x,a,1x,i0)',   'f_restart:', load_cases(l)%f_restart

    end if reportAndCheck
  end do
end function parse_and_print_load_cases


subroutine get_masked_tensor(values,mask,tensor)

#ifndef __GFORTRAN__
  use prec
  use types

  import, none
#endif

  real(pREAL), intent(out), dimension(3,3) :: values
  logical,     intent(out), dimension(3,3) :: mask
  type(tList), pointer, intent(in) :: tensor

  type(tList), pointer :: row
  integer :: i,j


  values = 0.0_pREAL
  do i = 1,3
    row => tensor%get_list(i)
    do j = 1,3
      mask(i,j) = row%get_asStr(j) == 'x'
      if (.not. mask(i,j)) values(i,j) = row%get_asReal(j)
    end do
  end do

end subroutine get_masked_tensor

end program DAMASK_grid

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author Christoph Kords, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Sets up the mesh for the solver MSC.Marc
!--------------------------------------------------------------------------------------------------
module discretization_Marc
  use IO
  use prec
  use math
  use DAMASK_interface
  use IO_Marc
  use config
  use element
  use discretization
  use geometry_plastic_nonlocal
  use result

  implicit none(type,external)
  private

  real(pREAL),                         public, protected :: &
    mesh_unitlength                                                                                 !< physical length of one unit in mesh MD: needs systematic_name

  integer,  dimension(:), allocatable, public, protected :: &
    discretization_Marc_FEM2DAMASK_elem, &                                                          !< DAMASK element ID for Marc element ID
    discretization_Marc_FEM2DAMASK_node                                                             !< DAMASK node ID for Marc node ID


  type tCellNodeDefinition
    integer, dimension(:,:), allocatable :: parents
    integer, dimension(:,:), allocatable :: weights
  end type tCellNodeDefinition

  type(tCellNodeDefinition), dimension(:), allocatable :: cellNodeDefinition

  integer, dimension(:,:,:), allocatable :: &
    connectivity_cell                                                                               !< cell connectivity for each element,ip/cell

  public :: &
    discretization_Marc_init, &
    discretization_Marc_updateNodeAndIpCoords, &
    discretization_Marc_FEM2DAMASK_cell

contains

!--------------------------------------------------------------------------------------------------
!> @brief initializes the mesh by calling all necessary private routines the mesh module
!! Order and routines strongly depend on type of solver
!--------------------------------------------------------------------------------------------------
subroutine discretization_Marc_init

  real(pREAL), dimension(:,:),     allocatable :: &
   node0_elem, &                                                                                    !< node x,y,z coordinates (initially!)
   node0_cell
  type(tElement) :: elem

  integer,     dimension(:),       allocatable :: &
    materialAt
  integer:: &
    Nelems                                                                                          !< total number of elements in the mesh

  real(pREAL), dimension(:,:),     allocatable :: &
    IP_reshaped
  integer,     dimension(:,:),     allocatable :: &
    connectivity_elem
  real(pREAL), dimension(:,:,:,:), allocatable :: &
    unscaledNormals

  type(tDict), pointer :: &
    num_solver, &
    num_commercialFEM


  print'(/,a)', ' <<<+-  discretization_Marc init  -+>>>'; flush(6)

  num_solver => config_numerics%get_dict('solver',defaultVal=emptyDict)
  num_commercialFEM => num_solver%get_dict('Marc',defaultVal=emptyDict)
  mesh_unitlength = num_commercialFEM%get_asReal('unit_length',defaultVal=1.0_pREAL)                 ! set physical extent of a length unit in mesh
  if (mesh_unitlength <= 0.0_pREAL) call IO_error(301,'unit_length')

  call inputRead(elem,node0_elem,connectivity_elem,materialAt)
  nElems = size(connectivity_elem,2)

  allocate(cellNodeDefinition(elem%nNodes-1))
  allocate(connectivity_cell(elem%NcellNodesPerCell,elem%nIPs,nElems))

  call buildCells(connectivity_cell,cellNodeDefinition,&
                  elem,connectivity_elem)
  node0_cell  = buildCellNodes(node0_elem)

  IP_reshaped = buildIPcoordinates(node0_cell)

  call discretization_init(materialAt, IP_reshaped, node0_cell)

  call writeGeometry(elem,connectivity_elem,&
                     reshape(connectivity_cell,[elem%NcellNodesPerCell,elem%nIPs*nElems]),&
                     node0_cell,IP_reshaped)

!--------------------------------------------------------------------------------------------------
! geometry information required by the nonlocal CP model
  call geometry_plastic_nonlocal_setIPvolume(IPvolume(elem,node0_cell))
  unscaledNormals = IPareaNormal(elem,nElems,node0_cell)
  call geometry_plastic_nonlocal_setIParea(norm2(unscaledNormals,1))
  call geometry_plastic_nonlocal_setIPareaNormal(unscaledNormals/spread(norm2(unscaledNormals,1),1,3))
  call geometry_plastic_nonlocal_setIPneighborhood(IPneighborhood(elem))
  call geometry_plastic_nonlocal_result()

end subroutine discretization_Marc_init


!--------------------------------------------------------------------------------------------------
!> @brief Calculate and set current nodal and IP positions (including cell nodes)
!--------------------------------------------------------------------------------------------------
subroutine discretization_Marc_updateNodeAndIpCoords(d_n)

  real(pREAL), dimension(:,:), intent(in)  :: d_n

  real(pREAL), dimension(:,:), allocatable :: node_cell


  node_cell = buildCellNodes(discretization_NodeCoords0(1:3,1:maxval(discretization_Marc_FEM2DAMASK_node)) + d_n)

  call discretization_setNodeCoords(node_cell)
  call discretization_setIPcoords(buildIPcoordinates(node_cell))

end subroutine discretization_Marc_updateNodeAndIpCoords


!--------------------------------------------------------------------------------------------------
!> @brief Calculate and set current nodal and IP positions (including cell nodes)
!--------------------------------------------------------------------------------------------------
function discretization_Marc_FEM2DAMASK_cell(IP_FEM,elem_FEM) result(cell)

  integer, intent(in) :: IP_FEM, elem_FEM
  integer :: cell

  real(pREAL), dimension(:,:), allocatable :: node_cell


  cell = (discretization_Marc_FEM2DAMASK_elem(elem_FEM)-1)*discretization_nIPs + IP_FEM


end function discretization_Marc_FEM2DAMASK_cell


!--------------------------------------------------------------------------------------------------
!> @brief Write all information needed for the DADF5 geometry
!--------------------------------------------------------------------------------------------------
subroutine writeGeometry(elem, &
                         connectivity_elem,connectivity_cell_reshaped, &
                         coordinates_nodes,coordinates_points)

  type(tElement),              intent(in) :: &
    elem
  integer, dimension(:,:),     intent(in) :: &
    connectivity_elem, &
    connectivity_cell_reshaped
  real(pREAL), dimension(:,:), intent(in) :: &
    coordinates_nodes, &
    coordinates_points


  call result_openJobFile()
  call result_closeGroup(result_addGroup('geometry'))

  call result_writeDataset(connectivity_elem,'geometry','T_e',&
                           'connectivity of the elements','-')

  call result_writeDataset(connectivity_cell_reshaped,'geometry','T_c', &
                           'connectivity of the cells','-')
  call result_addAttribute('VTK_TYPE',elem%vtkType,'geometry/T_c')

  call result_writeDataset(coordinates_nodes,'geometry','x_n', &
                           'initial coordinates of the nodes','m')

  call result_writeDataset(coordinates_points,'geometry','x_p', &
                           'initial coordinates of the materialpoints (cell centers)','m')

  call result_closeJobFile()

end subroutine writeGeometry


!--------------------------------------------------------------------------------------------------
!> @brief Read mesh from marc input file
!--------------------------------------------------------------------------------------------------
subroutine inputRead(elem,node0_elem,connectivity_elem,materialAt)

  type(tElement), intent(out) :: elem
  real(pREAL), dimension(:,:), allocatable, intent(out) :: &
    node0_elem                                                                                      !< node x,y,z coordinates (initially!)
  integer, dimension(:,:),     allocatable, intent(out) :: &
    connectivity_elem
  integer,     dimension(:),   allocatable, intent(out) :: &
    materialAt

  integer :: &
    fileFormatVersion, &
    hypoelasticTableStyle, &
    initialcondTableStyle, &
    nNodes, &
    nElems
  integer, dimension(:), allocatable :: &
    matNumber                                                                                       !< material numbers for hypoelastic material
  character(len=pSTRLEN), dimension(:), allocatable :: &
    inputFile, &                                                                                    !< file content, separated per lines
    nameElemSet
  integer, dimension(:,:), allocatable :: &
    mapElemSet                                                                                      !< list of elements in elementSet


  call result_openJobFile()
  call result_addSetupFile(IO_read(trim(CLI_jobName)//InputFileExtension), &
                                   trim(CLI_jobName)//InputFileExtension, &
                                   'MSC.Marc input deck')
  call result_closeJobFile()

  inputFile = readlines(trim(CLI_jobName)//InputFileExtension)
  call inputRead_fileFormat(fileFormatVersion, &
                            inputFile)
  call inputRead_tableStyles(initialcondTableStyle,hypoelasticTableStyle, &
                             inputFile)
  if (fileFormatVersion > 12) &
    call inputRead_matNumber(matNumber, &
                             hypoelasticTableStyle,inputFile)
  call inputRead_NnodesAndElements(nNodes,nElems,&
                                   inputFile)


  call inputRead_mapElemSets(nameElemSet,mapElemSet,&
                             inputFile)

  call inputRead_elemType(elem, &
                          nElems,inputFile)

  call inputRead_mapElems(discretization_Marc_FEM2DAMASK_elem,&
                          nElems,elem%nNodes,inputFile)

  call inputRead_mapNodes(discretization_Marc_FEM2DAMASK_node,&
                          nNodes,inputFile)

  call inputRead_elemNodes(node0_elem, &
                           Nnodes,inputFile)

  connectivity_elem = inputRead_connectivityElem(nElems,elem%nNodes,inputFile)

  call inputRead_material(materialAt, &
                          nElems,elem%nNodes,nameElemSet,mapElemSet,&
                          initialcondTableStyle,inputFile)

contains
!--------------------------------------------------------------------------------------------------
!> @brief Read ASCII file and split at EOL.
!--------------------------------------------------------------------------------------------------
function readlines(fileName) result(fileContent)

  character(len=*),       intent(in)                :: fileName
  character(len=pSTRLEN), dimension(:), allocatable :: fileContent                                  !< file content, separated per lines

  character(len=pSTRLEN)                            :: line
  character(len=:),                     allocatable :: rawData
  integer ::  &
    startPos, endPos, &
    N_lines, &                                                                                      !< # lines in file
    l
  logical :: warned


  rawData = IO_read(fileName)

  N_lines = count([(rawData(l:l) == IO_EOL,l=1,len(rawData))])
  allocate(fileContent(N_lines))

!--------------------------------------------------------------------------------------------------
! split raw data at end of line
  warned = .false.
  startPos = 1
  l = 1
  do while (l <= N_lines)
    endPos = startPos + scan(rawData(startPos:),IO_EOL) - 2
    if (endPos - startPos > pSTRLEN-1) then
      line = rawData(startPos:startPos+pSTRLEN-1)
      if (.not. warned) then
        call IO_warning(207,'line', l, 'in file', trim(fileName), emph =[2,4])
        warned = .true.
      end if
    else
      line = rawData(startPos:endpos)
    end if
    startPos = endPos + 2                                                                           ! jump to next line start

    fileContent(l) = trim(line)//''
    l = l + 1
  end do

end function readlines

end subroutine inputRead



!--------------------------------------------------------------------------------------------------
!> @brief Figures out version of Marc input file format
!--------------------------------------------------------------------------------------------------
subroutine inputRead_fileFormat(fileFormat,fileContent)

  integer,                        intent(out) :: fileFormat
  character(len=*), dimension(:), intent(in)  :: fileContent                                        !< file content, separated per lines

  integer, allocatable, dimension(:) :: chunkPos
  integer :: l

  do l = 1, size(fileContent)
    chunkPos = strPos(fileContent(l))
    if (chunkPos(1) < 2) cycle
    if (IO_lc(strValue(fileContent(l),chunkPos,1)) == 'version') then
      fileFormat = intValue(fileContent(l),chunkPos,2)
      exit
    end if
  end do

end subroutine inputRead_fileFormat


!--------------------------------------------------------------------------------------------------
!> @brief Figures out table styles for initial cond and hypoelastic
!--------------------------------------------------------------------------------------------------
subroutine inputRead_tableStyles(initialcond,hypoelastic,fileContent)

  integer,                        intent(out) :: initialcond, hypoelastic
  character(len=*), dimension(:), intent(in)  :: fileContent                                        !< file content, separated per lines

  integer, allocatable, dimension(:) :: chunkPos
  integer :: l

  initialcond = 0
  hypoelastic = 0

  do l = 1, size(fileContent)
    chunkPos = strPos(fileContent(l))
    if (chunkPos(1) < 6) cycle
    if (IO_lc(strValue(fileContent(l),chunkPos,1)) == 'table') then
      initialcond = intValue(fileContent(l),chunkPos,4)
      hypoelastic = intValue(fileContent(l),chunkPos,5)
      exit
    end if
  end do

end subroutine inputRead_tableStyles


!--------------------------------------------------------------------------------------------------
!> @brief Figures out material number of hypoelastic material
!--------------------------------------------------------------------------------------------------
subroutine inputRead_matNumber(matNumber, &
                               tableStyle,fileContent)

  integer, allocatable, dimension(:), intent(out) :: matNumber
  integer,                            intent(in)  :: tableStyle
  character(len=*),     dimension(:), intent(in)  :: fileContent                                    !< file content, separated per lines

  integer, allocatable, dimension(:) :: chunkPos
  integer :: i, j, data_blocks, l


  do l = 1, size(fileContent)
    chunkPos = strPos(fileContent(l))
    if (chunkPos(1) < 1) cycle
    if (IO_lc(strValue(fileContent(l),chunkPos,1)) == 'hypoelastic') then
      if (len_trim(fileContent(l+1))/=0) then
        chunkPos = strPos(fileContent(l+1))
        data_blocks = intValue(fileContent(l+1),chunkPos,1)
      else
        data_blocks = 1
      end if
      allocate(matNumber(data_blocks), source = 0)
      do i = 0, data_blocks - 1
        j = i*(2+tableStyle) + 1
        chunkPos = strPos(fileContent(l+1+j))
        matNumber(i+1) = intValue(fileContent(l+1+j),chunkPos,1)
      end do
      exit
    end if
  end do

end subroutine inputRead_matNumber


!--------------------------------------------------------------------------------------------------
!> @brief Count overall number of nodes and elements
!--------------------------------------------------------------------------------------------------
subroutine inputRead_NnodesAndElements(nNodes,nElems,&
                                       fileContent)

  integer,                        intent(out) :: nNodes, nElems
  character(len=*), dimension(:), intent(in)  :: fileContent                                        !< file content, separated per lines

  integer, allocatable, dimension(:) :: chunkPos
  integer :: l

  nNodes = 0
  nElems = 0

  do l = 1, size(fileContent)
    chunkPos = strPos(fileContent(l))
    if (chunkPos(1) < 1) cycle
    if    (IO_lc(strValue(fileContent(l),chunkPos,1)) == 'sizing') then
      nElems = intValue (fileContent(l),chunkPos,3)
    elseif (IO_lc(strValue(fileContent(l),chunkPos,1)) == 'coordinates') then
      chunkPos = strPos(fileContent(l+1))
      nNodes = intValue (fileContent(l+1),chunkPos,2)
    end if
  end do

end subroutine inputRead_NnodesAndElements


!--------------------------------------------------------------------------------------------------
!> @brief Count overall number of element sets in mesh.
!--------------------------------------------------------------------------------------------------
subroutine inputRead_NelemSets(nElemSets,maxNelemInSet,&
                               fileContent)

  integer,                            intent(out) :: nElemSets, maxNelemInSet
  character(len=*),     dimension(:), intent(in)  :: fileContent                                    !< file content, separated per lines

  integer, allocatable, dimension(:) :: chunkPos
  integer                            :: i,l,elemInCurrentSet


  nElemSets     = 0
  maxNelemInSet = 0

  do l = 1, size(fileContent)
    chunkPos = strPos(fileContent(l))
    if (chunkPos(1) < 2) cycle
    if (IO_lc(strValue(fileContent(l),chunkPos,1)) == 'define' .and. &
       IO_lc(strValue(fileContent(l),chunkPos,2)) == 'element') then
      chunkPos = strPos(fileContent(l+1))
      if (chunkPos(1) == 0) cycle
      nElemSets = nElemSets + 1

      if (containsRange(fileContent(l+1),chunkPos)) then
        elemInCurrentSet = 1 + abs( intValue(fileContent(l+1),chunkPos,3) &
                                   -intValue(fileContent(l+1),chunkPos,1))
      else
        elemInCurrentSet = 0
        i = 0
        do while (.true.)
          i = i + 1
          chunkPos = strPos(fileContent(l+i))
          elemInCurrentSet = elemInCurrentSet + chunkPos(1) - 1                                     ! add line's count when assuming 'c'
          if (IO_lc(strValue(fileContent(l+i),chunkPos,chunkPos(1))) /= 'c') then                   ! line finished, read last value
            elemInCurrentSet = elemInCurrentSet + 1                                                 ! data ended
            exit
          end if
        end do
      end if
      maxNelemInSet = max(maxNelemInSet, elemInCurrentSet)
    end if
  end do

end subroutine inputRead_NelemSets


!--------------------------------------------------------------------------------------------------
!> @brief map element sets
!--------------------------------------------------------------------------------------------------
subroutine inputRead_mapElemSets(nameElemSet,mapElemSet,&
                                 fileContent)

  character(len=pSTRLEN), dimension(:),   allocatable, intent(out) :: nameElemSet
  integer,                   dimension(:,:), allocatable, intent(out) :: mapElemSet
  character(len=*),          dimension(:),                intent(in)  :: fileContent                !< file content, separated per lines

  integer, allocatable, dimension(:) :: chunkPos
  integer :: elemSet, NelemSets, maxNelemInSet,l


  call inputRead_NelemSets(NelemSets,maxNelemInSet,fileContent)
  allocate(nameElemSet(NelemSets)); nameElemSet = 'n/a'
  allocate(mapElemSet(1+maxNelemInSet,NelemSets),source=0)
  elemSet = 0

  do l = 1, size(fileContent)
    chunkPos = strPos(fileContent(l))
    if (chunkPos(1) < 2) cycle
    if (IO_lc(strValue(fileContent(l),chunkPos,1)) == 'define' .and. &
       IO_lc(strValue(fileContent(l),chunkPos,2)) == 'element') then
      chunkPos = strPos(fileContent(l+1))
      if (chunkPos(1) == 0) cycle
      chunkPos = strPos(fileContent(l))
      elemSet = elemSet+1
      nameElemSet(elemSet)  = trim(strValue(fileContent(l),chunkPos,4))
      mapElemSet(:,elemSet) = continuousIntValues(fileContent(l+1:),size(mapElemSet,1)-1,nameElemSet,mapElemSet,size(nameElemSet))
    end if
  end do

end subroutine inputRead_mapElemSets


!--------------------------------------------------------------------------------------------------
!> @brief Maps elements from FE ID to internal (consecutive) representation.
!--------------------------------------------------------------------------------------------------
subroutine inputRead_mapElems(FEM2DAMASK, &
                              nElems,nNodesPerElem,fileContent)

  integer, allocatable, dimension(:), intent(out) :: FEM2DAMASK

  integer,                            intent(in)  :: nElems, &                                      !< number of elements
                                                     nNodesPerElem                                  !< number of nodes per element
  character(len=*),     dimension(:), intent(in)  :: fileContent                                    !< file content, separated per lines

  integer, dimension(2,nElems)       :: map_unsorted
  integer, allocatable, dimension(:) :: chunkPos
  integer :: i,j,l,nNodesAlreadyRead,readStatus,nElem,itotal
  character(:), allocatable :: field

  itotal = 0
  do l = 1, size(fileContent)
    chunkPos = strPos(fileContent(l))
    if (chunkPos(1) < 1) cycle
    if (IO_lc(strValue(fileContent(l),chunkPos,1)) == 'connectivity') then
      j = 0
      i = 1
      do while (itotal < nElems)
        chunkPos = strPos(fileContent(l+1+i+j))
        field = strValue(fileContent(l+1+i+j),chunkPos,1)
        read(field,*,iostat = readStatus) nElem
        if (readStatus /= 0) exit
        itotal = itotal + 1
        map_unsorted(:,itotal) = [nElem,itotal]
        nNodesAlreadyRead = chunkPos(1) - 2
        do while(nNodesAlreadyRead < nNodesPerElem)                                                 ! read on if not all nodes in one line
          j = j + 1
          chunkPos = strPos(fileContent(l+1+i+j))
          nNodesAlreadyRead = nNodesAlreadyRead + chunkPos(1)
        end do
        i = i + 1
      end do
      if (itotal == nElems) exit
    end if
  end do

  allocate(FEM2DAMASK(minval(map_unsorted(1,:)):maxval(map_unsorted(1,:))),source=-1)
  do i = 1, nElems
    FEM2DAMASK(map_unsorted(1,i)) = map_unsorted(2,i)
  end do

end subroutine inputRead_mapElems


!--------------------------------------------------------------------------------------------------
!> @brief Maps node from FE ID to internal (consecutive) representation.
!--------------------------------------------------------------------------------------------------
subroutine inputRead_mapNodes(FEM2DAMASK, &
                              nNodes,fileContent)

  integer, allocatable, dimension(:), intent(out) :: FEM2DAMASK

  integer,                            intent(in)  :: nNodes                                         !< number of nodes
  character(len=*),     dimension(:), intent(in)  :: fileContent                                    !< file content, separated per lines

  integer, dimension(2,nNodes)       :: map_unsorted
  integer, allocatable, dimension(:) :: chunkPos
  integer :: i, l


  do l = 1, size(fileContent)
    chunkPos = strPos(fileContent(l))
    if (chunkPos(1) < 1) cycle
    if (IO_lc(strValue(fileContent(l),chunkPos,1)) == 'coordinates') then
      chunkPos = [1,1,10]
      do i = 1,nNodes
        map_unsorted(:,i) = [intValue(fileContent(l+1+i),chunkPos,1),i]
      end do
      exit
    end if
  end do

  call math_sort(map_unsorted)
  allocate(FEM2DAMASK(minval(map_unsorted(1,:)):maxval(map_unsorted(1,:))),source=-1)
  do i = 1, nNodes
    FEM2DAMASK(map_unsorted(1,i)) = map_unsorted(2,i)
  end do

end subroutine inputRead_mapNodes


!--------------------------------------------------------------------------------------------------
!> @brief store x,y,z coordinates of all nodes in mesh.
!--------------------------------------------------------------------------------------------------
subroutine inputRead_elemNodes(nodes, &
                               nNode,fileContent)

  real(pREAL), allocatable,  dimension(:,:), intent(out) :: nodes
  integer,                                   intent(in)  :: nNode
  character(len=*),            dimension(:), intent(in)  :: fileContent                             !< file content, separated per lines

  integer, allocatable, dimension(:) :: chunkPos
  integer :: i,j,m,l


  allocate(nodes(3,nNode))

  do l = 1, size(fileContent)
    chunkPos = strPos(fileContent(l))
    if (chunkPos(1) < 1) cycle
    if (IO_lc(strValue(fileContent(l),chunkPos,1)) == 'coordinates') then
      chunkPos = [4,1,10,11,30,31,50,51,70]
      do i=1,nNode
        m = discretization_Marc_FEM2DAMASK_node(intValue(fileContent(l+1+i),chunkPos,1))
        nodes(1:3,m) = [(mesh_unitlength * realValue(fileContent(l+1+i),chunkPos,j+1),j=1,3)]
      end do
      exit
    end if
  end do

end subroutine inputRead_elemNodes


!--------------------------------------------------------------------------------------------------
!> @brief Gets element type (and checks if the whole mesh comprises of only one type)
!--------------------------------------------------------------------------------------------------
subroutine inputRead_elemType(elem, &
                              nElems,fileContent)

  type(tElement),                 intent(out) :: elem
  integer,                        intent(in)  :: nElems
  character(len=*), dimension(:), intent(in)  :: fileContent                                        !< file content, separated per lines

  integer, allocatable, dimension(:) :: chunkPos
  integer :: i,j,t,t_,l,remainingChunks,readStatus,nElem,itotal
  character(:), allocatable :: field

  itotal = 0
  t = -1
  do l = 1, size(fileContent)
    chunkPos = strPos(fileContent(l))
    if (chunkPos(1) < 1) cycle
    if (IO_lc(strValue(fileContent(l),chunkPos,1)) == 'connectivity') then
      j = 0
      i = 1
      do while (itotal < nElems)
        chunkPos = strPos(fileContent(l+1+i+j))
        if (t == -1) then
          t = mapElemtype(strValue(fileContent(l+1+i+j),chunkPos,2))
          call elem%init(t)
        else
          field = strValue(fileContent(l+1+i+j),chunkPos,1)
          read(field,*,iostat = readStatus) nElem
          if (readStatus /= 0) exit
          field = strValue(fileContent(l+1+i+j),chunkPos,2)
          t_ = mapElemtype(field)
          if (t /= t_) call IO_error(191,field,label1='type',ID1=t)
        end if
        remainingChunks = elem%nNodes - (chunkPos(1) - 2)
        do while(remainingChunks > 0)
          j = j + 1
          chunkPos = strPos(fileContent(l+1+i+j))
          remainingChunks = remainingChunks - chunkPos(1)
        end do
        i = i + 1
        itotal = itotal + 1
      end do
      if (itotal == nElems) exit
    end if
  end do

  contains

  !--------------------------------------------------------------------------------------------------
  !> @brief mapping of Marc element types to internal representation
  !--------------------------------------------------------------------------------------------------
  integer function mapElemtype(what)
#ifndef __GFORTRAN__
   use IO
   import, none
#endif

   character(len=*), intent(in) :: what


   select case (what)
      case (   '6')
        mapElemtype = 1            ! Two-dimensional Plane Strain Triangle
      case ( '125')                ! 155, 128 (need test)
        mapElemtype = 2            ! Two-dimensional Plane Strain triangle (155: cubic shape function, 125/128: second order isoparametric)
      case ( '11')
        mapElemtype = 3            ! Arbitrary Quadrilateral Plane-strain
      case ( '27')
        mapElemtype = 4            ! Plane Strain, Eight-node Distorted Quadrilateral
      case ( '54')
        mapElemtype = 5            ! Plane Strain, Eight-node Distorted Quadrilateral with reduced integration
      case ( '134')
        mapElemtype = 6            ! Three-dimensional Four-node Tetrahedron
      !case ( '157')               ! need test
      !  mapElemtype = 7           ! Three-dimensional, Low-order, Tetrahedron, Herrmann Formulations
      case ( '127')
        mapElemtype = 8            ! Three-dimensional Ten-node Tetrahedron
      case ( '136')
        mapElemtype = 9            ! Three-dimensional Arbitrarily Distorted Pentahedral
      case ( '117')                ! 123 (need test)
        mapElemtype = 10           ! Three-dimensional Arbitrarily Distorted linear hexahedral with reduced integration
      case ( '7')
        mapElemtype = 11           ! Three-dimensional Arbitrarily Distorted Brick
      case ( '57')
        mapElemtype = 12           ! Three-dimensional Arbitrarily Distorted quad hexahedral with reduced integration
      case ( '21')
        mapElemtype = 13           ! Three-dimensional Arbitrarily Distorted quadratic hexahedral
      case default
        call IO_error(190,what)
   end select

  end function mapElemtype


end subroutine inputRead_elemType


!--------------------------------------------------------------------------------------------------
!> @brief Stores node IDs
!--------------------------------------------------------------------------------------------------
function inputRead_connectivityElem(nElems,nNodes,fileContent)

  integer, intent(in) :: &
    nElems, &
    nNodes                                                                                          !< number of nodes per element
  character(len=*), dimension(:), intent(in) :: fileContent                                         !< file content, separated per lines

  integer, dimension(nNodes,nElems) :: &
    inputRead_connectivityElem

  integer, allocatable, dimension(:) :: chunkPos

  integer, dimension(1+nElems) :: contInts
  integer :: i,k,j,t,e,l,nNodesAlreadyRead,num,nElem,itotal
  character(:), allocatable :: field

  itotal = 0
  do l = 1, size(fileContent)
    chunkPos = strPos(fileContent(l))
    if (chunkPos(1) < 1) cycle
    if (IO_lc(strValue(fileContent(l),chunkPos,1)) == 'connectivity') then
      j = 0
      i = 1
      do while (itotal < nElems)
        chunkPos = strPos(fileContent(l+1+i+j))
        field = strValue(fileContent(l+1+i+j),chunkPos,1)
        read(field,*,iostat = num) nElem
        if (num /= 0) exit
        e = discretization_Marc_FEM2DAMASK_elem(nElem)
        if (e /= 0) then                                                                            ! disregard non CP elems
          do k = 1,chunkPos(1)-2
            inputRead_connectivityElem(k,e) = &
              discretization_Marc_FEM2DAMASK_node(intValue(fileContent(l+1+i+j),chunkPos,k+2))
          end do
          nNodesAlreadyRead = chunkPos(1) - 2
          do while(nNodesAlreadyRead < nNodes)                                                      ! read on if not all nodes in one line
            j = j + 1
            chunkPos = strPos(fileContent(l+1+i+j))
            do k = 1,chunkPos(1)
              inputRead_connectivityElem(nNodesAlreadyRead+k,e) = &
                discretization_Marc_FEM2DAMASK_node(intValue(fileContent(l+1+i+j),chunkPos,k))
            end do
            nNodesAlreadyRead = nNodesAlreadyRead + chunkPos(1)
          end do
          i = i + 1
          itotal = itotal + 1
        end if
      end do
      if (itotal == nElems) exit
    end if
  end do

end function inputRead_connectivityElem


!--------------------------------------------------------------------------------------------------
!> @brief Store material ID
!> @details 0-based ID in file is converted to 1-based ID used in DAMASK
!--------------------------------------------------------------------------------------------------
subroutine inputRead_material(materialAt,&
                              nElem,nNodes,nameElemSet,mapElemSet,initialcondTableStyle,fileContent)

  integer, dimension(:), allocatable, intent(out) :: &
    materialAt
  integer, intent(in) :: &
    nElem, &
    nNodes, &                                                                                       !< number of nodes per element
    initialcondTableStyle
  character(len=*), dimension(:), intent(in) :: nameElemSet
  integer, dimension(:,:),        intent(in) :: mapElemSet                                          !< list of elements in elementSet
  character(len=*), dimension(:), intent(in) :: fileContent                                         !< file content, separated per lines

  integer, allocatable, dimension(:) :: chunkPos

  integer, dimension(1+nElem) :: contInts
  integer :: i,j,t,sv,ID,e,nNodesAlreadyRead,l,k,m


  allocate(materialAt(nElem), source=0)

  do l = 1, size(fileContent)
    chunkPos = strPos(fileContent(l))
    if (chunkPos(1) < 2) cycle
    if (IO_lc(strValue(fileContent(l),chunkPos,1)) == 'initial' .and. &
       IO_lc(strValue(fileContent(l),chunkPos,2)) == 'state') then
      k = merge(2,1,initialcondTableStyle == 2)
      chunkPos = strPos(fileContent(l+k))
      sv = intValue(fileContent(l+k),chunkPos,1)                                                 ! # of state variable
      if (sv == 2) then                                                                             ! state var 2 gives material ID
        m = 1
        chunkPos = strPos(fileContent(l+k+m))
        do while (scan(strValue(fileContent(l+k+m),chunkPos,1),'+-',back=.true.)>1)              ! is no Efloat value?
          ID = nint(realValue(fileContent(l+k+m),chunkPos,1))
          if (initialcondTableStyle == 2) m = m + 2
          contInts = continuousIntValues(fileContent(l+k+m+1:),nElem,nameElemSet,mapElemSet,size(nameElemSet)) ! get affected elements
          do i = 1,contInts(1)
            e = discretization_Marc_FEM2DAMASK_elem(contInts(1+i))
            materialAt(e) = ID + 1
          end do
          if (initialcondTableStyle == 0) m = m + 1
        end do
      end if
    end if
  end do

  if (any(materialAt < 1)) call IO_error(180)

end subroutine inputRead_material


!--------------------------------------------------------------------------------------------------
!> @brief Calculates cell node coordinates from element node coordinates
!--------------------------------------------------------------------------------------------------
pure subroutine buildCells(connectivity,definition, &
                           elem,connectivity_elem)

  type(tCellNodeDefinition), dimension(:),    intent(out) :: definition                             ! definition of cell nodes for increasing number of parents
  integer,                   dimension(:,:,:),intent(out) :: connectivity

  type(tElement),                             intent(in)  :: elem                                   ! element definition
  integer,                   dimension(:,:),  intent(in)  :: connectivity_elem                      ! connectivity of the elements

  integer,dimension(:),     allocatable :: candidates_local
  integer,dimension(:,:),   allocatable :: parentsAndWeights,candidates_global

  integer :: e, n, c, p, s,i,m,j,nParentNodes,nCellNode,Nelem,candidateID

  Nelem = size(connectivity_elem,2)

!---------------------------------------------------------------------------------------------------
! initialize global connectivity to negative local connectivity
  connectivity = -spread(elem%cell,3,Nelem)                                                         ! local cell node ID

!---------------------------------------------------------------------------------------------------
! set connectivity of cell nodes that coincide with FE nodes (defined by 1 parent node)
! and renumber local (negative) to global (positive) node ID
  do e = 1, Nelem
    do c = 1, elem%NcellNodes
      realNode: if (count(elem%cellNodeParentNodeWeights(:,c) /= 0) == 1) then
        where(connectivity(:,:,e) == -c) connectivity(:,:,e) = connectivity_elem(c,e)
      end if realNode
    end do
  end do

  nCellNode = maxval(connectivity_elem)

!---------------------------------------------------------------------------------------------------
! set connectivity of cell nodes that are defined by 2,...,nNodes real nodes
  do nParentNodes = 2, elem%nNodes

    ! get IDs of local cell nodes that are defined by the current number of parent nodes
    candidates_local = [integer::]
    do c = 1, elem%NcellNodes
      if (count(elem%cellNodeParentNodeWeights(:,c) /= 0) == nParentNodes) &
        candidates_local = [candidates_local,c]
    end do
    s = size(candidates_local)

    if (allocated(candidates_global)) deallocate(candidates_global)
    allocate(candidates_global(nParentNodes*2+2,s*Nelem))                                           ! stores parent node ID + weight together with element ID and cellnode id (local)
    parentsAndWeights = reshape([(0, i = 1,2*nParentNodes)],[nParentNodes,2])                       ! (re)allocate

    do e = 1, Nelem
      do i = 1, size(candidates_local)
        candidateID = (e-1)*size(candidates_local)+i                                                ! including duplicates, runs to (Nelem*size(candidates_local))
        c = candidates_local(i)                                                                     ! c is local cellnode ID for connectivity
        p = 0
        do j = 1, size(elem%cellNodeParentNodeWeights(:,c))
          if (elem%cellNodeParentNodeWeights(j,c) /= 0) then                                        ! real node 'j' partly defines cell node 'c'
            p = p + 1
            parentsAndWeights(p,1:2) = [connectivity_elem(j,e),elem%cellNodeParentNodeWeights(j,c)]
          end if
        end do
        ! store (and order) real node IDs and their weights together with the element number and local ID
        do p = 1, nParentNodes
          m = maxloc(parentsAndWeights(:,1),1)

          candidates_global(p,                                candidateID) = parentsAndWeights(m,1)
          candidates_global(p+nParentNodes,                   candidateID) = parentsAndWeights(m,2)
          candidates_global(nParentNodes*2+1:nParentNodes*2+2,candidateID) = [e,c]

          parentsAndWeights(m,1) = -huge(parentsAndWeights(m,1))                                    ! out of the competition
        end do
      end do
    end do

    ! sort according to real node IDs + weight (from left to right)
    call math_sort(candidates_global,sortDim=1)                                                     ! sort according to first column

    do p = 2, nParentNodes*2
      n = 1
      do while(n <= size(candidates_local)*Nelem)
        j=0
        do while (n+j<= size(candidates_local)*Nelem)
          if (candidates_global(p-1,n+j)/=candidates_global(p-1,n)) exit
          j = j + 1
        end do
        e = n+j-1
        if (any(candidates_global(p,n:e)/=candidates_global(p,n))) &
          call math_sort(candidates_global(:,n:e),sortDim=p)
        n = e+1
      end do
    end do

    i = uniqueRows(candidates_global(1:2*nParentNodes,:))
    allocate(definition(nParentNodes-1)%parents(i,nParentNodes))
    allocate(definition(nParentNodes-1)%weights(i,nParentNodes))

    i = 1
    n = 1
    do while(n <= size(candidates_local)*Nelem)
      j=0
      parentsAndWeights(:,1) = candidates_global(1:nParentNodes,n+j)
      parentsAndWeights(:,2) = candidates_global(nParentNodes+1:nParentNodes*2,n+j)

      e = candidates_global(nParentNodes*2+1,n+j)
      c = candidates_global(nParentNodes*2+2,n+j)

      do while (n+j<= size(candidates_local)*Nelem)
        if (any(candidates_global(1:2*nParentNodes,n+j)/=candidates_global(1:2*nParentNodes,n))) exit
        where (connectivity(:,:,candidates_global(nParentNodes*2+1,n+j)) == -candidates_global(nParentNodes*2+2,n+j)) ! still locally defined
          connectivity(:,:,candidates_global(nParentNodes*2+1,n+j)) = nCellNode + 1                                   ! get current new cell node id
        end where

        j = j+1
      end do
      nCellNode = nCellNode + 1
      definition(nParentNodes-1)%parents(i,:) = parentsAndWeights(:,1)
      definition(nParentNodes-1)%weights(i,:) = parentsAndWeights(:,2)
      i = i + 1
      n = n+j
    end do

  end do

  contains
  !------------------------------------------------------------------------------------------------
  !> @brief count unique rows (same rows need to be stored consecutively)
  !------------------------------------------------------------------------------------------------
  pure function uniqueRows(A) result(u)
#ifndef __GFORTRAN__
    import, none
#endif

    integer, dimension(:,:), intent(in) :: A                                                        !< array, rows need to be sorted

    integer :: &
      u, &                                                                                          !< # of unique rows
      r, &                                                                                          !< row counter
      d                                                                                             !< duplicate counter

    u = 0
    r = 1
    do while(r <= size(A,2))
      d = 0
      do while (r+d<= size(A,2))
        if (any(A(:,r)/=A(:,r+d))) exit
        d = d+1
      end do
      u = u+1
      r = r+d
    end do

  end function uniqueRows

end subroutine buildCells


!--------------------------------------------------------------------------------------------------
!> @brief Calculates cell node coordinates from element node coordinates
!--------------------------------------------------------------------------------------------------
pure function buildCellNodes(node_elem)

  real(pREAL),               dimension(:,:), intent(in)  :: node_elem                               !< element nodes
  real(pREAL),               dimension(:,:), allocatable :: buildCellNodes                          !< cell node coordinates

  integer :: i, j, k, n


  allocate(buildCellNodes(3,maxval(connectivity_cell)))
  n = size(node_elem,2)
  buildCellNodes(:,1:n) = node_elem                                                                 !< initial nodes coincide with element nodes

  do i = 1, size(cellNodeDefinition)
    do j = 1, size(cellNodeDefinition(i)%parents,1)
      n = n+1
      buildCellNodes(:,n) = 0.0_pREAL
      do k = 1, size(cellNodeDefinition(i)%parents,2)
        buildCellNodes(:,n) = buildCellNodes(:,n) &
                            + buildCellNodes(:,cellNodeDefinition(i)%parents(j,k)) &
                            * real(cellNodeDefinition(i)%weights(j,k),pREAL)
      end do
      buildCellNodes(:,n) = buildCellNodes(:,n)/real(sum(cellNodeDefinition(i)%weights(j,:)),pREAL)
    end do
  end do

end function buildCellNodes


!--------------------------------------------------------------------------------------------------
!> @brief Calculates IP coordinates as center of cell
!--------------------------------------------------------------------------------------------------
pure function buildIPcoordinates(node_cell)

  real(pREAL), dimension(:,:), intent(in)  :: node_cell                                             !< cell node coordinates
  real(pREAL), dimension(:,:), allocatable :: buildIPcoordinates                                    !< cell-center/IP coordinates

  integer, dimension(:,:), allocatable :: connectivity_cell_reshaped
  integer :: i, n, NcellNodesPerCell,Ncells


  NcellNodesPerCell = size(connectivity_cell,1)
  Ncells = size(connectivity_cell,2)*size(connectivity_cell,3)
  connectivity_cell_reshaped = reshape(connectivity_cell,[NcellNodesPerCell,Ncells])

  allocate(buildIPcoordinates(3,Ncells))

  do i = 1, size(connectivity_cell_reshaped,2)
    buildIPcoordinates(:,i) = 0.0_pREAL
    do n = 1, size(connectivity_cell_reshaped,1)
      buildIPcoordinates(:,i) = buildIPcoordinates(:,i) &
                              + node_cell(:,connectivity_cell_reshaped(n,i))
    end do
    buildIPcoordinates(:,i) = buildIPcoordinates(:,i)/real(size(connectivity_cell_reshaped,1),pREAL)
  end do

end function buildIPcoordinates


!---------------------------------------------------------------------------------------------------
!> @brief Calculates IP volume.
!> @details The IP volume is calculated differently depending on the cell type.
!> 2D cells assume an element depth of 1.0
!---------------------------------------------------------------------------------------------------
pure function IPvolume(elem,node)

  type(tElement),                intent(in) :: elem
  real(pREAL), dimension(:,:),   intent(in) :: node

  real(pREAL), dimension(elem%nIPs,size(connectivity_cell,3)) :: IPvolume
  real(pREAL), dimension(3) :: x0,x1,x2,x3,x4,x5,x6,x7

  integer :: e,i


  do e = 1,size(connectivity_cell,3)
    do i = 1,elem%nIPs

      select case (elem%cellType)
        case (1)                                                                                    ! 2D 3node
          IPvolume(i,e) = math_areaTriangle(node(1:3,connectivity_cell(1,i,e)), &
                                            node(1:3,connectivity_cell(2,i,e)), &
                                            node(1:3,connectivity_cell(3,i,e)))

        case (2)                                                                                    ! 2D 4node
          IPvolume(i,e) = math_areaTriangle(node(1:3,connectivity_cell(1,i,e)), &                   ! assume planar shape, division in two triangles suffices
                                            node(1:3,connectivity_cell(2,i,e)), &
                                            node(1:3,connectivity_cell(3,i,e))) &
                        + math_areaTriangle(node(1:3,connectivity_cell(3,i,e)), &
                                            node(1:3,connectivity_cell(4,i,e)), &
                                            node(1:3,connectivity_cell(1,i,e)))
        case (3)                                                                                    ! 3D 4node
          IPvolume(i,e) = math_volTetrahedron(node(1:3,connectivity_cell(1,i,e)), &
                                              node(1:3,connectivity_cell(2,i,e)), &
                                              node(1:3,connectivity_cell(3,i,e)), &
                                              node(1:3,connectivity_cell(4,i,e)))
        case (4)                                                                                    ! 3D 8node
          ! J. Grandy, Efficient Calculation of Volume of Hexahedral Cells
          ! Lawrence Livermore National Laboratory
          ! https://www.osti.gov/servlets/purl/632793
          x0 = node(1:3,connectivity_cell(1,i,e))
          x1 = node(1:3,connectivity_cell(2,i,e))
          x2 = node(1:3,connectivity_cell(4,i,e))
          x3 = node(1:3,connectivity_cell(3,i,e))
          x4 = node(1:3,connectivity_cell(5,i,e))
          x5 = node(1:3,connectivity_cell(6,i,e))
          x6 = node(1:3,connectivity_cell(8,i,e))
          x7 = node(1:3,connectivity_cell(7,i,e))
          IPvolume(i,e) = dot_product((x7-x1)+(x6-x0),math_cross((x7-x2),        (x3-x0))) &
                        + dot_product((x6-x0),        math_cross((x7-x2)+(x5-x0),(x7-x4))) &
                        + dot_product((x7-x1),        math_cross((x5-x0),        (x7-x4)+(x3-x0)))
          IPvolume(i,e) = IPvolume(i,e)/12.0_pREAL
      end select
    end do
  end do

end function IPvolume


!--------------------------------------------------------------------------------------------------
!> @brief calculation of IP interface areas
!--------------------------------------------------------------------------------------------------
pure function IPareaNormal(elem,nElem,node)

  type(tElement),                intent(in) :: elem
  integer,                       intent(in) :: nElem
  real(pREAL), dimension(:,:),   intent(in) :: node

  real(pREAL), dimension(3,elem%nIPneighbors,elem%nIPs,nElem) :: ipAreaNormal

  real(pREAL), dimension (3,size(elem%cellFace,1)) :: nodePos
  integer :: e,i,f,n,m

  m = size(elem%cellFace,1)

  do e = 1,nElem
    do i = 1,elem%nIPs
      do f = 1,elem%nIPneighbors
        nodePos = node(1:3,connectivity_cell(elem%cellface(1:m,f),i,e))

        select case (elem%cellType)
          case (1,2)                                                                                ! 2D 3 or 4 node
            IPareaNormal(1,f,i,e) =   nodePos(2,2) - nodePos(2,1)                                   ! x_normal =  y_connectingVector
            IPareaNormal(2,f,i,e) = -(nodePos(1,2) - nodePos(1,1))                                  ! y_normal = -x_connectingVector
            IPareaNormal(3,f,i,e) = 0.0_pREAL
          case (3)                                                                                  ! 3D 4node
            IPareaNormal(1:3,f,i,e) = math_cross(nodePos(1:3,2) - nodePos(1:3,1), &
                                                 nodePos(1:3,3) - nodePos(1:3,1))
          case (4)                                                                                  ! 3D 8node
            ! Get the normal of the quadrilateral face as the average of four normals of triangular
            ! subfaces. Since the face consists only of two triangles, the sum has to be divided
            ! by two. This procedure tries to compensate for probable non-planar cell surfaces
            IPareaNormal(1:3,f,i,e) = 0.0_pREAL
            do n = 1, m
              IPareaNormal(1:3,f,i,e) = IPareaNormal(1:3,f,i,e) &
                                      + math_cross(nodePos(1:3,mod(n+0,m)+1) - nodePos(1:3,n), &
                                                   nodePos(1:3,mod(n+1,m)+1) - nodePos(1:3,n)) * 0.5_pREAL
            end do
        end select
      end do
    end do
  end do

end function IPareaNormal


!--------------------------------------------------------------------------------------------------
!> @brief IP neighborhood
!--------------------------------------------------------------------------------------------------
function IPneighborhood(elem)

  type(tElement),            intent(in) :: elem                                                     ! definition of the element in use
  integer, dimension(3,size(elem%cellFace,2), &
                     size(connectivity_cell,2),size(connectivity_cell,3)) :: IPneighborhood                   ! neighboring IPs as [element ID, IP ID, face ID]

  integer, dimension(size(elem%cellFace,1)+3,&
                     size(elem%cellFace,2)*size(connectivity_cell,2)*size(connectivity_cell,3)) :: face
  integer, dimension(size(connectivity_cell,1))  :: myConnectivity
  integer, dimension(size(elem%cellFace,1))      :: face_unordered
  integer :: e,i,f,n,c,s

  c = 0
  do e = 1, size(connectivity_cell,3)
    do i = 1, size(connectivity_cell,2)
      myConnectivity = connectivity_cell(:,i,e)
      do f = 1, size(elem%cellFace,2)
        c = c + 1
        face_unordered = myConnectivity(elem%cellFace(:,f))
        do n = 1, size(face_unordered)
          face(n,c) = minval(face_unordered)
          face_unordered(minloc(face_unordered)) = huge(face_unordered)
        end do
        face(n:n+3,c) = [e,i,f]
      end do
  end do; end do

!--------------------------------------------------------------------------------------------------
! sort face definitions
  call math_sort(face,sortDim=1)
  do c=2, size(face,1)-4
    s = 1
    e = 1
    do while (e < size(face,2))
      e = e + 1
      if (any(face(:c,s) /= face(:c,e))) then
        if (e-1/=s) call math_sort(face(:,s:e-1),sortDim=c)
        s = e
      end if
    end do
  end do

  IPneighborhood = 0
  do c=1, size(face,2) - 1
    if (all(face(:n-1,c) == face(:n-1,c+1))) then
      IPneighborhood(:,face(n+2,c+1),face(n+1,c+1),face(n+0,c+1)) = face(n:n+3,c+0)
      IPneighborhood(:,face(n+2,c+0),face(n+1,c+0),face(n+0,c+0)) = face(n:n+3,c+1)
    end if
  end do

end function IPneighborhood

end module discretization_Marc

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Philip Eisenlohr, Michigan State University
!> @author Zhuowen Zhao, Michigan State University
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief  Phenomenological crystal plasticity using a power-law formulation for the shear rates
!! and a Voce-type kinematic hardening rule.
!--------------------------------------------------------------------------------------------------
submodule(phase:plastic) kinehardening

  type :: tParameters
    real(pREAL),              allocatable, dimension(:) :: &
      dot_gamma_0, &                                                                                !< reference shear strain rate for slip
      n, &                                                                                          !< stress exponent for slip
      h_0_xi, &                                                                                     !< initial hardening rate of forest stress per slip family
                                                                                                    !! θ_0,for
      h_0_chi, &                                                                                    !< initial hardening rate of back stress per slip family
                                                                                                    !! θ_0,bs
      h_inf_xi, &                                                                                   !< asymptotic hardening rate of forest stress per slip family
                                                                                                    !! θ_1,for
      h_inf_chi, &                                                                                  !< asymptotic hardening rate of back stress per slip family
                                                                                                    !! θ_1,bs
      xi_inf, &                                                                                     !< back-extrapolated forest stress from terminal linear hardening
      chi_inf                                                                                       !< back-extrapolated back stress from terminal linear hardening
    real(pREAL),              allocatable, dimension(:,:) :: &
      h_sl_sl                                                                                       !< slip resistance change per slip activity
    real(pREAL),              allocatable, dimension(:,:,:) :: &
      P, &
      P_nS_pos, &
      P_nS_neg
    integer :: &
      sum_N_sl
    character(len=pSTRLEN), allocatable, dimension(:) :: &
      output
    character(len=:),       allocatable, dimension(:) :: &
      systems_sl
  end type tParameters

  type :: tIndexDotState
    integer, dimension(2) :: &
      xi, &
      chi, &
      gamma
  end type tIndexDotState

  type :: tKinehardeningState
    real(pREAL), pointer, dimension(:,:) :: &
      xi, &                                                                                         !< forest stress
                                                                                                    !! τ_for
      chi, &                                                                                        !< back stress
                                                                                                    !! τ_bs
      chi_flip, &                                                                                   !< back stress at last reversal of stress sense
                                                                                                    !! χ_0
      gamma, &                                                                                      !< accumulated (absolute) shear
      gamma_flip, &                                                                                 !< accumulated shear at last reversal of stress sense
                                                                                                    !! γ_0
      sgn_gamma                                                                                     !< sense of acting shear stress (-1 or +1)
  end type tKinehardeningState

!--------------------------------------------------------------------------------------------------
! containers for parameters and state
  type(tParameters),         allocatable, dimension(:) :: param
  type(tIndexDotState),      allocatable, dimension(:) :: indexDotState
  type(tKinehardeningState), allocatable, dimension(:) :: state, deltaState

contains


!--------------------------------------------------------------------------------------------------
!> @brief Perform module initialization.
!> @details reads in material parameters, allocates arrays, and does sanity checks
!--------------------------------------------------------------------------------------------------
module function plastic_kinehardening_init() result(myPlasticity)

  logical, dimension(:), allocatable :: myPlasticity
  integer :: &
    ph, o,  &
    Nmembers, &
    sizeState, sizeDeltaState, sizeDotState, &
    startIndex, endIndex
  integer,     dimension(:), allocatable :: &
    N_sl
  real(pREAL), dimension(:), allocatable :: &
    xi_0                                                                                            !< initial forest stress
                                                                                                    !! τ_for,0
  real(pREAL), dimension(:,:), allocatable :: &
    a_nS                                                                                            !< non-Schmid coefficients
  character(len=:), allocatable :: &
    refs, &
    extmsg
  type(tDict), pointer :: &
    phases, &
    phase, &
    mech, &
    pl


  myPlasticity = plastic_active('kinehardening')
  if (count(myPlasticity) == 0) return

  print'(/,1x,a)', '<<<+-  phase:mechanical:plastic:kinehardening init  -+>>>'

  print'(/,1x,a)', 'J.A. Wollmershauser et al., International Journal of Fatigue 36:181–193, 2012'
  print'(  1x,a)', 'https://doi.org/10.1016/j.ijfatigue.2011.07.008'

  print'(/,1x,a,1x,i0)', '# phases:',count(myPlasticity); flush(IO_STDOUT)

  phases => config_material%get_dict('phase')
  allocate(param(size(phases)))
  allocate(indexDotState(size(phases)))
  allocate(state(size(phases)))
  allocate(deltaState(size(phases)))
  extmsg = ''

  do ph = 1, size(phases)
    if (.not. myPlasticity(ph)) cycle

    associate(prm => param(ph), &
              stt => state(ph), dlt => deltaState(ph), &
              idx_dot => indexDotState(ph))

    phase => phases%get_dict(ph)
    mech => phase%get_dict('mechanical')
    pl => mech%get_dict('plastic')

    print'(/,1x,a,1x,i0,a)', 'phase',ph,': '//phases%key(ph)
    refs = config_listReferences(pl,indent=3)
    if (len(refs) > 0) print'(/,1x,a)', refs

#if defined (__GFORTRAN__)
    prm%output = output_as1dStr(pl)
#else
    prm%output = pl%get_as1dStr('output',defaultVal=emptyStrArray)
#endif

!--------------------------------------------------------------------------------------------------
! slip related parameters
    N_sl = pl%get_as1dInt('N_sl',defaultVal=emptyIntArray)
    prm%sum_N_sl = sum(abs(N_sl))
    slipActive: if (prm%sum_N_sl > 0) then
      prm%P = crystal_SchmidMatrix_slip(N_sl,phase_lattice(ph),phase_cOverA(ph))
      prm%systems_sl = crystal_labels_slip(N_sl,phase_lattice(ph))

      a_nS = pl%get_as2dReal('a_non-Schmid',defaultVal=reshape(emptyRealArray,[0,0]))
      prm%P_nS_pos = crystal_SchmidMatrix_slip(N_sl,phase_lattice(ph),phase_cOverA(ph), &
                                               nonSchmidCoefficients=a_nS,sense=+1)
      prm%P_nS_neg = crystal_SchmidMatrix_slip(N_sl,phase_lattice(ph),phase_cOverA(ph), &
                                               nonSchmidCoefficients=a_nS,sense=-1)

      prm%h_sl_sl = crystal_interaction_SlipBySlip(N_sl,pl%get_as1dReal('h_sl-sl'),phase_lattice(ph))

      xi_0            = math_expand(pl%get_as1dReal('xi_0',        requiredSize=size(N_sl)),N_sl)
      prm%dot_gamma_0 = math_expand(pl%get_as1dReal('dot_gamma_0', requiredSize=size(N_sl)),N_sl)
      prm%n           = math_expand(pl%get_as1dReal('n',           requiredSize=size(N_sl)),N_sl)
      prm%xi_inf      = math_expand(pl%get_as1dReal('xi_inf',      requiredSize=size(N_sl)),N_sl)
      prm%chi_inf     = math_expand(pl%get_as1dReal('chi_inf',     requiredSize=size(N_sl)),N_sl)
      prm%h_0_xi      = math_expand(pl%get_as1dReal('h_0_xi',      requiredSize=size(N_sl)),N_sl)
      prm%h_0_chi     = math_expand(pl%get_as1dReal('h_0_chi',     requiredSize=size(N_sl)),N_sl)
      prm%h_inf_xi    = math_expand(pl%get_as1dReal('h_inf_xi',    requiredSize=size(N_sl)),N_sl)
      prm%h_inf_chi   = math_expand(pl%get_as1dReal('h_inf_chi',   requiredSize=size(N_sl)),N_sl)

!--------------------------------------------------------------------------------------------------
!  sanity checks
      if (any(prm%dot_gamma_0  <= 0.0_pREAL))  extmsg = trim(extmsg)//' dot_gamma_0'
      if (any(prm%n            <= 0.0_pREAL))  extmsg = trim(extmsg)//' n'
      if (any(xi_0             <= 0.0_pREAL))  extmsg = trim(extmsg)//' xi_0'
      if (any(prm%xi_inf       <= 0.0_pREAL))  extmsg = trim(extmsg)//' xi_inf'
      if (any(prm%chi_inf      <= 0.0_pREAL))  extmsg = trim(extmsg)//' chi_inf'

    else slipActive
      xi_0 = emptyRealArray
      allocate(prm%dot_gamma_0, &
               prm%n, &
               prm%xi_inf, &
               prm%chi_inf, &
               prm%h_0_xi, &
               prm%h_0_chi, &
               prm%h_inf_xi, &
               prm%h_inf_chi, &
               source=emptyRealArray)
      allocate(prm%h_sl_sl(0,0))
    end if slipActive

!--------------------------------------------------------------------------------------------------
! allocate state arrays
    Nmembers = count(material_ID_phase == ph)
    sizeDotState   = prm%sum_N_sl * size(['xi   ',&
                                          'chi  ',&
                                          'gamma'])
    sizeDeltaState = prm%sum_N_sl * size(['sgn_gamma ',&
                                          'chi_flip  ',&
                                          'gamma_flip'])
    sizeState = sizeDotState + sizeDeltaState

    call phase_allocateState(plasticState(ph),Nmembers,sizeState,sizeDotState,sizeDeltaState)
    deallocate(plasticState(ph)%dotState) ! ToDo: remove dotState completely

!--------------------------------------------------------------------------------------------------
! state aliases and initialization
    startIndex = 1
    endIndex   = prm%sum_N_sl
    idx_dot%xi = [startIndex,endIndex]
    stt%xi => plasticState(ph)%state(startIndex:endIndex,:)
    stt%xi = spread(xi_0, 2, Nmembers)
    plasticState(ph)%atol(startIndex:endIndex) = pl%get_asReal('atol_xi',defaultVal=1.0_pREAL)
    if (any(plasticState(ph)%atol(startIndex:endIndex) < 0.0_pREAL)) extmsg = trim(extmsg)//' atol_xi'

    startIndex = endIndex + 1
    endIndex   = endIndex + prm%sum_N_sl
    idx_dot%chi = [startIndex,endIndex]
    stt%chi => plasticState(ph)%state(startIndex:endIndex,:)
    plasticState(ph)%atol(startIndex:endIndex) = pl%get_asReal('atol_xi',defaultVal=1.0_pREAL)

    startIndex = endIndex + 1
    endIndex   = endIndex + prm%sum_N_sl
    idx_dot%gamma = [startIndex,endIndex]
    stt%gamma => plasticState(ph)%state(startIndex:endIndex,:)
    plasticState(ph)%atol(startIndex:endIndex) = pl%get_asReal('atol_gamma',defaultVal=1.0e-6_pREAL)
    if (any(plasticState(ph)%atol(startIndex:endIndex) < 0.0_pREAL)) extmsg = trim(extmsg)//' atol_gamma'

    o = plasticState(ph)%offsetDeltaState
    startIndex = endIndex + 1
    endIndex   = endIndex + prm%sum_N_sl
    stt%sgn_gamma => plasticState(ph)%state     (startIndex  :endIndex  ,:)
    dlt%sgn_gamma => plasticState(ph)%deltaState(startIndex-o:endIndex-o,:)

    startIndex = endIndex + 1
    endIndex   = endIndex +  prm%sum_N_sl
    stt%chi_flip => plasticState(ph)%state     (startIndex  :endIndex  ,:)
    dlt%chi_flip => plasticState(ph)%deltaState(startIndex-o:endIndex-o,:)

    startIndex = endIndex + 1
    endIndex   = endIndex +  prm%sum_N_sl
    stt%gamma_flip => plasticState(ph)%state     (startIndex  :endIndex  ,:)
    dlt%gamma_flip => plasticState(ph)%deltaState(startIndex-o:endIndex-o,:)

    end associate

!--------------------------------------------------------------------------------------------------
!  exit if any parameter is out of range
    if (extmsg /= '') call IO_error(211,ext_msg=trim(extmsg))

  end do


end function plastic_kinehardening_init


!--------------------------------------------------------------------------------------------------
!> @brief Calculate plastic velocity gradient and its tangent.
!--------------------------------------------------------------------------------------------------
pure module subroutine kinehardening_LpAndItsTangent(Lp,dLp_dMp, Mp,ph,en)

  real(pREAL), dimension(3,3),     intent(out) :: &
    Lp                                                                                              !< plastic velocity gradient
  real(pREAL), dimension(3,3,3,3), intent(out) :: &
    dLp_dMp                                                                                         !< derivative of Lp with respect to the Mandel stress

  real(pREAL), dimension(3,3),     intent(in) :: &
    Mp                                                                                              !< Mandel stress
  integer,                         intent(in) :: &
    ph, &
    en

  integer :: &
    i,k,l,m,n
  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    dot_gamma, ddot_gamma_dtau
  real(pREAL), dimension(3,3,param(ph)%sum_N_sl) :: &
    P_nS


  Lp = 0.0_pREAL
  dLp_dMp = 0.0_pREAL

  associate(prm => param(ph))

    call kinetics(Mp,ph,en, dot_gamma,ddot_gamma_dtau)
    P_nS = merge(prm%P_nS_pos,prm%P_nS_neg, spread(spread(dot_gamma,1,3),2,3)>0.0_pREAL)            ! faster than 'merge' in loop
    do i = 1, prm%sum_N_sl
      Lp = Lp + dot_gamma(i)*prm%P(1:3,1:3,i)
      forall (k=1:3,l=1:3,m=1:3,n=1:3) &
        dLp_dMp(k,l,m,n) = dLp_dMp(k,l,m,n) &
                         + ddot_gamma_dtau(i) * prm%P(k,l,i) * P_nS(m,n,i)
    end do

  end associate

end subroutine kinehardening_LpAndItsTangent


!--------------------------------------------------------------------------------------------------
!> @brief Calculate the rate of change of microstructure.
!--------------------------------------------------------------------------------------------------
module function plastic_kinehardening_dotState(Mp,ph,en) result(dotState)

  real(pREAL), dimension(3,3),  intent(in) :: &
    Mp                                                                                              !< Mandel stress
  integer,                      intent(in) :: &
    ph, &
    en
  real(pREAL), dimension(plasticState(ph)%sizeDotState) :: &
    dotState

  real(pREAL) :: &
    sumGamma


  associate(prm => param(ph), stt => state(ph), &
            dot_xi => dotState(IndexDotState(ph)%xi(1):IndexDotState(ph)%xi(2)),&
            dot_chi => dotState(IndexDotState(ph)%chi(1):IndexDotState(ph)%chi(2)),&
            dot_gamma => dotState(IndexDotState(ph)%gamma(1):IndexDotState(ph)%gamma(2)))

    call kinetics(Mp,ph,en, dot_gamma)
    sumGamma = sum(stt%gamma(:,en))
    dot_gamma = abs(dot_gamma)


    dot_xi = matmul(prm%h_sl_sl,dot_gamma) &
           * ( prm%h_inf_xi &
               + ( prm%h_0_xi  &
                 - prm%h_inf_xi * (1_pREAL -sumGamma*prm%h_0_xi/prm%xi_inf) ) &
               *                       exp(-sumGamma*prm%h_0_xi/prm%xi_inf) &
             )

    dot_chi = stt%sgn_gamma(:,en)*dot_gamma &
            * ( prm%h_inf_chi &
               + ( prm%h_0_chi &
                 - prm%h_inf_chi*(1_pREAL -(stt%gamma(:,en)-stt%gamma_flip(:,en))*prm%h_0_chi/(prm%chi_inf+stt%chi_flip(:,en))) ) &
               *                      exp(-(stt%gamma(:,en)-stt%gamma_flip(:,en))*prm%h_0_chi/(prm%chi_inf+stt%chi_flip(:,en))) &
              )

  end associate

end function plastic_kinehardening_dotState


!--------------------------------------------------------------------------------------------------
!> @brief Calculate (instantaneous) incremental change of microstructure.
!--------------------------------------------------------------------------------------------------
module subroutine plastic_kinehardening_deltaState(Mp,ph,en)

  real(pREAL), dimension(3,3),  intent(in) :: &
    Mp                                                                                              !< Mandel stress
  integer,                      intent(in) :: &
    ph, &
    en

  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    dot_gamma, &
    sgn_gamma


  associate(prm => param(ph), stt => state(ph), dlt => deltaState(ph))

    call kinetics(Mp,ph,en, dot_gamma)
    sgn_gamma = merge(state(ph)%sgn_gamma(:,en), &
                      sign(1.0_pREAL,dot_gamma), &
                      dEq0(dot_gamma,1e-10_pREAL))

    where(dNeq(sgn_gamma,stt%sgn_gamma(:,en),0.1_pREAL)) ! ToDo sgn_gamma*stt%sgn_gamma(:,en)<0
      dlt%sgn_gamma (:,en) = sgn_gamma            - stt%sgn_gamma (:,en)
      dlt%chi_flip  (:,en) = abs(stt%chi  (:,en)) - stt%chi_flip  (:,en)
      dlt%gamma_flip(:,en) =     stt%gamma(:,en)  - stt%gamma_flip(:,en)
    else where
      dlt%sgn_gamma (:,en) = 0.0_pREAL
      dlt%chi_flip  (:,en) = 0.0_pREAL
      dlt%gamma_flip(:,en) = 0.0_pREAL
    end where

  end associate

end subroutine plastic_kinehardening_deltaState


!--------------------------------------------------------------------------------------------------
!> @brief Write results to HDF5 output file.
!--------------------------------------------------------------------------------------------------
module subroutine plastic_kinehardening_result(ph,group)

  integer,          intent(in) :: ph
  character(len=*), intent(in) :: group

  integer :: ou


  associate(prm => param(ph), stt => state(ph))

    do ou = 1,size(prm%output)

      select case(trim(prm%output(ou)))

        case ('xi')
          call result_writeDataset(stt%xi,group,trim(prm%output(ou)), &
                                   'forest stress','Pa',prm%systems_sl)
        case ('chi')
          call result_writeDataset(stt%chi,group,trim(prm%output(ou)), &
                                   'back stress','Pa',prm%systems_sl)
        case ('sgn(gamma)')
          call result_writeDataset(int(stt%sgn_gamma),group,trim(prm%output(ou)), &
                                   'sense of shear','1',prm%systems_sl)
        case ('chi_flip')
          call result_writeDataset(stt%chi_flip,group,trim(prm%output(ou)), &
                                   'back stress at last reversal of stress sense','Pa',prm%systems_sl)
        case ('gamma_flip')
          call result_writeDataset(stt%gamma_flip,group,trim(prm%output(ou)), &
                                   'plastic shear at last reversal of stress sense','1',prm%systems_sl)
        case ('gamma')
          call result_writeDataset(stt%gamma,group,trim(prm%output(ou)), &
                                   'plastic shear','1',prm%systems_sl)
      end select

    end do

  end associate

end subroutine plastic_kinehardening_result


!--------------------------------------------------------------------------------------------------
!> @brief Calculate shear rates on slip systems and their derivatives with respect to resolved
!         stress.
!> @details: Derivatives are calculated only optionally.
! NOTE: Contrary to common convention, here the result (i.e. intent(out)) variables have to be put
! at the end since some of them are optional.
!--------------------------------------------------------------------------------------------------
pure subroutine kinetics(Mp,ph,en, &
                         dot_gamma,ddot_gamma_dtau)

  real(pREAL), dimension(3,3),                           intent(in) :: &
    Mp                                                                                              !< Mandel stress
  integer,                                               intent(in) :: &
    ph, &
    en

  real(pREAL), dimension(param(ph)%sum_N_sl),           intent(out) :: &
    dot_gamma
  real(pREAL), dimension(param(ph)%sum_N_sl), optional, intent(out) :: &
    ddot_gamma_dtau

  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    tau_pos, &
    tau_neg
  integer :: i


  associate(prm => param(ph), stt => state(ph))

    tau_pos = [(math_tensordot(Mp,prm%P_nS_pos(1:3,1:3,i)) - stt%chi(i,en),i=1,prm%sum_N_sl)]
    tau_neg = [(math_tensordot(Mp,prm%P_nS_neg(1:3,1:3,i)) + stt%chi(i,en),i=1,prm%sum_N_sl)]

    dot_gamma = merge(+1.0_pREAL,-1.0_pREAL, tau_pos>tau_neg) &
              * prm%dot_gamma_0  &
              * (max(tau_pos,tau_neg)/stt%xi(:,en))**prm%n

    if (present(ddot_gamma_dtau)) then
      where(dNeq0(dot_gamma))
        ddot_gamma_dtau = dot_gamma*prm%n/max(tau_pos,tau_neg)
      else where
        ddot_gamma_dtau = 0.0_pREAL
      end where
    end if

  end associate

end subroutine kinetics

end submodule kinehardening

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Jaeyong Jung, Max-Planck-Institut für Eisenforschung GmbH
!> @author Pratheek Shanthraj, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Parse command line interface for PETSc-based solvers
!--------------------------------------------------------------------------------------------------
module CLI
  use, intrinsic :: ISO_Fortran_env
  use, intrinsic :: ISO_C_binding

  use PETScSys

  use prec
  use parallelization
  use OS
  use IO

  implicit none(type,external)
  private
  integer,                       public, protected :: &
    CLI_restartInc = -1                                                                             !< increment at which calculation starts
  character(len=:), allocatable, public, protected :: &
    CLI_geomFile, &                                                                                 !< location of the geometry file
    CLI_loadFile, &                                                                                 !< location of the load case file
    CLI_materialFile, &                                                                             !< location of the material configuration file
    CLI_numericsFile, &                                                                             !< location of the numerics configuration file
    CLI_jobName, &                                                                                  !< name of the job (will be used for DADF5 result file)
    CLI_jobID                                                                                       !< unique job ID (UUID)

#ifdef BOOST
   type :: tCLIBuffer
      character(len=:, kind=C_CHAR), pointer :: buf
   end type tCLIBuffer

   type :: tCLIArgs
      integer(C_INT)                              :: argc = 0
      type(C_PTR),      allocatable, dimension(:) :: argv
      type(tCLIBuffer), allocatable, dimension(:) :: cliBuffer
   contains
      procedure :: copyCommandLineArgs
   end type tCLIArgs

interface
  function C_CLI_new(argc, argv, worldrank) result(this) bind(C, name='C_CLI_new')
    use, intrinsic :: ISO_C_binding, only: C_INT, C_PTR
    integer(C_INT), intent(in) :: argc
    type(C_PTR),    intent(in) :: argv(*) ! MD I think this should be dimension(:), but wait for working ifx
    integer(C_INT), intent(in) :: worldrank
    type(C_PTR)                :: this
  end function C_CLI_new

  subroutine C_CLI_getParsedArgs(cli, geom, load, material, numerics, jobname, uuid, restart, stat) &
      bind(C, name='C_CLI_getParsedArgs')
    use ISO_C_binding
    type(C_PTR), value :: cli
    character(kind=C_CHAR,len=:), allocatable, intent(out) :: geom, load, material, numerics, jobname, uuid
    integer(C_INT), intent(out) :: restart, stat
  end subroutine C_CLI_getParsedArgs
end interface

#endif

public :: &
  CLI_init

contains

!--------------------------------------------------------------------------------------------------
!> @brief Initialize the solver by interpreting the command line arguments and write
!!        information on computation to screen.
!--------------------------------------------------------------------------------------------------
subroutine CLI_init()
#include <petsc/finclude/petscsys.h>

#if PETSC_VERSION_MAJOR!=3 || PETSC_VERSION_MINOR<PETSC_MINOR_MIN || PETSC_VERSION_MINOR>PETSC_MINOR_MAX
--  UNSUPPORTED PETSc VERSION --- UNSUPPORTED PETSc VERSION --- UNSUPPORTED PETSc VERSION ---
#endif
#if   PETSC_VERSION_MINOR==19
#define PETSC_DOI '10.2172/1968587'
#elif PETSC_VERSION_MINOR==20
#define PETSC_DOI '10.2172/2205494'
#elif PETSC_VERSION_MINOR==21
#define PETSC_DOI '10.2172/2337606'
#elif PETSC_VERSION_MINOR==22
#define PETSC_DOI '10.2172/2476320'
#elif PETSC_VERSION_MINOR==23
#define PETSC_DOI '10.2172/2565610'
#elif PETSC_VERSION_MINOR==24
#define PETSC_DOI '10.2172/2998643'
#elif PETSC_VERSION_MINOR==25
#define PETSC_DOI '10.2172/3025790'
#endif
#ifdef BOOST
  type(C_PTR) :: CLI_ = C_NULL_PTR
  type(tCLIArgs) :: cliArgs
  integer(C_INT) :: stat
#else
  character(len=:), allocatable :: &
    commandLine, &                                                                                  !< command line call as string
    flag, &                                                                                         !< individual flag
    val, &
    geomArg, &                                                                                      !< -g CLI argument
    loadArg, &                                                                                      !< -l CLI argument
    materialArg, &                                                                                  !< -m CLI argument
    numericsArg, &                                                                                  !< -n CLI argument
    workingDirArg                                                                                   !< -w CLI argument
  integer :: &
    i, s
#endif
#ifdef PETSC_DOI
  character(len=*), parameter :: PETSc_DOI = PETSC_DOI
#endif

  print'(/,1x,a)', '<<<+-  CLI init  -+>>>'

#ifdef BOOST
  print'(/,1x,a)', 'Using C++ parser'

  call cliArgs%copyCommandLineArgs()
  ! https://fortran-lang.discourse.group/t/c-interoperability-command-line-arguments/5773/7
  CLI_ = C_CLI_new(cliArgs%argc, cliArgs%argv, worldrank)
  call C_CLI_getParsedArgs(CLI_, CLI_geomFile, CLI_loadFile, CLI_materialFile, &
                           CLI_numericsFile, CLI_jobID, CLI_jobName, CLI_restartInc, stat)
  if (stat /= 0) error stop 'could not collect parsed args from CLI.cpp'
  call parallelization_bcast_str(CLI_jobID)
#else
  print'(/,1x,a)', 'Using Fortran parser'
  workingDirArg = OS_getCWD()
 ! http://patorjk.com/software/taag/#p=display&f=Lean&t=DAMASK%203
#ifdef DEBUG
  print'(a)', IO_color([255,0,0])
  print'(1x,a)', 'debug version - debug version - debug version - debug version - debug version'
#endif
  print'(a)', IO_color([67,128,208])
  print'(1x,a)', '    _/_/_/      _/_/    _/      _/    _/_/      _/_/_/  _/    _/    _/_/_/'
  print'(1x,a)', '   _/    _/  _/    _/  _/_/  _/_/  _/    _/  _/        _/  _/            _/'
  print'(1x,a)', '  _/    _/  _/_/_/_/  _/  _/  _/  _/_/_/_/    _/_/    _/_/          _/_/'
  print'(1x,a)', ' _/    _/  _/    _/  _/      _/  _/    _/        _/  _/  _/            _/'
  print'(1x,a)', '_/_/_/    _/    _/  _/      _/  _/    _/  _/_/_/    _/    _/    _/_/_/'
#if   defined(GRID)
  print'(a)', IO_color([123,207,68])
  print'(1x,a)', 'Grid solver'
#elif defined(MESH)
  print'(a)', IO_color([230,150,68])
  print'(1x,a)', 'Mesh solver'
#endif
#ifdef DEBUG
  print'(a)', IO_color([255,0,0])
  print'(1x,a)', 'debug version - debug version - debug version - debug version - debug version'
#endif
  print'(a)', IO_color()

  print'(1x,a)',           'F. Roters et al., Computational Materials Science 158:420–478, 2019'
  print'(1x,a)',           'https://doi.org/10.1016/j.commatsci.2018.04.030'
  print'(/,1x,a,i0,a,i0)', 'S. Balay et al., PETSc/TAO User Manual Revision ',PETSC_VERSION_MAJOR,'.',PETSC_VERSION_MINOR
#ifdef PETSC_DOI
  print'(1x,a)',           'https://doi.org/'//PETSc_DOI
#endif
  print'(/,1x,a)', 'Version: '//DAMASK_VERSION

  ! https://github.com/jeffhammond/HPCInfo/blob/master/docs/Preprocessor-Macros.md
  print'(/,1x,a)', 'Compiled with: '//compiler_version()
  call printCompileOptions()
  print'(1x,a,1x,i0,a,i0,a,i0)', &
                   'PETSc version:',PETSC_VERSION_MAJOR,'.',PETSC_VERSION_MINOR,'.',PETSC_VERSION_SUBMINOR

  print'(/,1x,a)', 'Released at: Jul  9 2026 at 23:29:22'

  if (command_argument_count() == 0) call help()
  do i = 1, command_argument_count()
    flag = getArg(i)
    if (flag == '-h' .or. flag == '--help') call help()
  end do

  i = 1
  do while (i <= command_argument_count())
    flag = getArg(i)
    i = i + 1
    s = scan(flag,'=')
    if (s /= 0) then
      val = flag(s+1:)
      flag = flag(:s-1)
    else
      if (i > command_argument_count()) &
        call IO_error(610_pI16,'missing value for flag', flag, emph=[2])
      val = getArg(i)
      i = i + 1
    end if

    select case(flag)
      case ('-g', '--geom', '--geometry')
        geomArg = val
      case ('-l', '--load', '--loadcase')
        loadArg = val
      case ('-m', '--material', '--materialconfig')
        materialArg = val
      case ('-n', '--numerics', '--numericsconfig')
        numericsArg = val
      case ('-j', '--job', '--jobname')
        CLI_jobName = val
      case ('-w', '--wd', '--workingdir', '--workingdirectory')
        workingDirArg = val
#if defined(GRID)
      case ('-r', '--rs', '--restart')
        if (IO_strAsInt(val) < 0) then
          call IO_error(610_pI16, 'invalid value', val, 'for flag', flag, emph=[2,4])
        else
          CLI_restartInc = IO_strAsInt(val)
        end if
#endif
      case default
        call IO_error(610_pI16, 'invalid flag', flag, emph=[2])
    end select
  end do

  if (.not. allocated(geomArg))     call IO_error(610_pI16, 'missing flag', '--geom', emph=[2])
  if (.not. allocated(loadArg))     call IO_error(610_pI16, 'missing flag', '--load', emph=[2])
  if (.not. allocated(materialArg)) call IO_error(610_pI16, 'missing flag', '--material', emph=[2])

  call setWorkingDirectory(trim(workingDirArg))
  CLI_geomFile = getPathRelCWD(geomArg)
  CLI_loadFile = getPathRelCWD(loadArg)
  CLI_materialFile = getPathRelCWD(materialArg)
  if (allocated(numericsArg)) &
    CLI_numericsFile = getPathRelCWD(numericsArg)

  if (.not. allocated(CLI_jobName)) then
    CLI_jobName = jobname(CLI_geomFile,CLI_loadFile,CLI_materialFile,CLI_numericsFile)
  elseif (scan(CLI_jobName,'/') > 0) then
    call IO_error(610_pI16, 'path separator in jobname', CLI_jobName, emph=[2])
  endif

  commandLine = getArg(-1)

  print'(/,1x,a)',      'Host name: '//OS_getHostName()
  print'(1x,a)',        'User name: '//OS_getUserName()

  print'(/,1x,a,/)',    'Command line call:  '//trim(commandLine)
  print'(1x,a)',        'Working directory:  '//IO_glueDiffering(OS_getCWD(),workingDirArg)
  print'(1x,a)',        'Geometry:           '//IO_glueDiffering(CLI_geomFile,geomArg)
  print'(1x,a)',        'Load case:          '//IO_glueDiffering(CLI_loadFile,loadArg)
  print'(1x,a)',        'Material config:    '//IO_glueDiffering(CLI_materialFile,materialArg)
  if (allocated(numericsArg)) &
    print'(1x,a)',      'Numerics config:    '//IO_glueDiffering(CLI_numericsFile,numericsArg)
  print'(1x,a)',        'Job name:           '//CLI_jobName
#ifdef BOOST
  print'(1x,a)',        'Job ID:             '//CLI_jobID
#endif
  if (CLI_restartInc /= -1) &
    print'(1x,a,i0)',   'Restart increment:  ', CLI_restartInc
#endif

end subroutine CLI_init


!--------------------------------------------------------------------------------------------------
!> @brief Get argument from command line.
!--------------------------------------------------------------------------------------------------
function getArg(n)

  integer, intent(in) :: n                                                                          !< number of the argument
  character(len=:), allocatable :: getArg

  integer :: l,err


  allocate(character(len=0)::getArg)
  if (n<0) then
    call get_command(getArg, length=l)
  else
    call get_command_argument(n,getArg,length=l)
  endif
  deallocate(getArg)
  allocate(character(len=l)::getArg)
  if (n<0) then
    call get_command(getArg, status=err)
  else
    call get_command_argument(n,getArg,status=err)
  endif
  if (err /= 0) error stop 'getting command arguments failed'

end function getArg


!--------------------------------------------------------------------------------------------------
!> @brief Extract working directory from given argument or from location of geometry file,
!!        possibly converting relative arguments to absolut path.
!--------------------------------------------------------------------------------------------------
subroutine setWorkingDirectory(workingDirectoryArg)

  character(len=*), intent(in)  :: workingDirectoryArg                                              !< working directory argument
  character(len=:), allocatable :: workingDirectory


  absolutePath: if (workingDirectoryArg(1:1) == '/') then
    workingDirectory = workingDirectoryArg
  else absolutePath
    workingDirectory = OS_getCWD()
    workingDirectory = trim(workingDirectory)//'/'//workingDirectoryArg
  end if absolutePath

  workingDirectory = trim(normpath(workingDirectory))
  if (OS_setCWD(trim(workingDirectory))) call IO_error(640,ext_msg=workingDirectory)

end subroutine setWorkingDirectory


!--------------------------------------------------------------------------------------------------
!> @brief Print fortran compiler options to stdout.
!--------------------------------------------------------------------------------------------------
subroutine printCompileOptions() bind(C, name="F_printCompileOptions")

  print'(1x,a)', 'Compiler options: '//compiler_options()
  print'(1x,a)', 'Compiled for: '//CMAKE_SYSTEM_NAME//' on '//CMAKE_SYSTEM_PROCESSOR

end subroutine printCompileOptions

#ifdef BOOST
!--------------------------------------------------------------------------------------------------
!> @brief Copy command line args to c strings for boost-processing,
!         allocate one extra element for the NULL termination.
!--------------------------------------------------------------------------------------------------
subroutine copyCommandLineArgs(this)

  class(tCLIArgs), intent(out) :: this

  integer :: n_args, i, len_arg


  n_args = command_argument_count() + 1
  this%argc = n_args
  allocate(this%argv(n_args))
  allocate(this%cliBuffer(n_args))

  do i = 0, n_args-1
    call get_command_argument(i, length=len_arg)
    allocate(character(len=len_arg+1, kind=C_CHAR) :: this%cliBuffer(i+1)%buf)
    if (len_arg > 0) &
      call get_command_argument(i, value=this%cliBuffer(i+1)%buf(1:len_arg))
    this%cliBuffer(i+1)%buf(len_arg+1:len_arg+1) = C_NULL_CHAR                                      !< need to use substring syntax because buf is defined as a fixed-length character
    this%argv(i+1) = c_loc(this%cliBuffer(i+1)%buf)
  end do

end subroutine copyCommandLineArgs
#endif

!--------------------------------------------------------------------------------------------------
!> @brief Determine solver job name.
!--------------------------------------------------------------------------------------------------
function jobname(geomFile,LoadFile,materialsFile,numericsFile)

  character(len=:), allocatable :: jobname
  character(len=*), intent(in)  :: geomFile,loadFile,materialsFile
  character(len=:), allocatable, intent(in) :: numericsFile


  jobname = stem(geomFile)//'_'//stem(loadFile)//'_'//stem(materialsFile)
  if (allocated(numericsFile)) jobname = jobname//'_'//stem(numericsFile)

  contains

  pure function stem(fullname)
#ifndef __GFORTRAN__
    import, none
#endif
    character(len=:), allocatable :: stem
    character(len=*), intent(in)  :: fullname


    stem = fullname(scan(fullname,'/',back=.true.)+1:scan(fullname,'.',back=.true.)-1)

  end function stem

end function jobname


!--------------------------------------------------------------------------------------------------
!> @brief Translate path as relative to CWD and check for existence.
!--------------------------------------------------------------------------------------------------
function getPathRelCWD(path)

  character(len=:), allocatable :: getPathRelCWD
  character(len=*),  intent(in) :: path

  logical                       :: file_exists


  getPathRelCWD = trim(path)
  if (scan(getPathRelCWD,'/') /= 1) getPathRelCWD = OS_getCWD()//'/'//trim(getPathRelCWD)
  getPathRelCWD = trim(relpath(getPathRelCWD,OS_getCWD()))

  inquire(file=getPathRelCWD, exist=file_exists)
  if (.not. file_exists) call IO_error(100_pI16, 'file does not exist',getPathRelCWD,emph=[2])

end function getPathRelCWD


!--------------------------------------------------------------------------------------------------
!> @brief Remove ../, /./, and // from path.
!> @details Works only if absolute path is given.
!--------------------------------------------------------------------------------------------------
function normpath(path)

  character(len=*), intent(in)  :: path
  character(len=:), allocatable :: normpath

  integer :: i,j,k,l


!--------------------------------------------------------------------------------------------------
! remove /./ from path
  normpath = trim(path)
  l = len_trim(normpath)
  do i = l,3,-1
    if (normpath(i-2:i) == '/./') normpath(i-1:l) = normpath(i+1:l)//'  '
  end do

!--------------------------------------------------------------------------------------------------
! remove // from path
  l = len_trim(normpath)
  do i = l,2,-1
    if (normpath(i-1:i) == '//') normpath(i-1:l) = normpath(i:l)//' '
  end do

!--------------------------------------------------------------------------------------------------
! remove ../ and corresponding directory from path
  l = len_trim(normpath)
  i = index(normpath(i:l),'../')
  j = 0
  do while (i > j)
     j = scan(normpath(1:i-2),'/',back=.true.)
     normpath(j+1:l) = normpath(i+3:l)//repeat(' ',2+i-j)
     if (normpath(j+1:j+1) == '/') then                                                             !search for '//' that appear in case of XXX/../../XXX
       k = len_trim(normpath)
       normpath(j+1:k-1) = normpath(j+2:k)
       normpath(k:k) = ' '
     end if
     i = j+index(normpath(j+1:l),'../')
  end do
  if (len_trim(normpath) == 0) normpath = '/'

  normpath = trim(normpath)

end function normpath


!--------------------------------------------------------------------------------------------------
!> @brief Determine relative path.
!--------------------------------------------------------------------------------------------------
function relpath(path,start)

  character(len=*), intent(in)  :: start,path
  character(len=:), allocatable :: relpath

  character(len=:), allocatable :: start_cleaned,path_cleaned
  integer :: i,posLastCommonSlash,remainingSlashes


  posLastCommonSlash = 0
  remainingSlashes = 0
  start_cleaned = normpath(trim(start)//'/')
  path_cleaned = normpath(path)

  do i = 1, min(len_trim(start_cleaned),len_trim(path_cleaned))
    if (start_cleaned(i:i) /= path_cleaned(i:i)) exit
    if (start_cleaned(i:i) == '/') posLastCommonSlash = i
  end do
  do i = posLastCommonSlash+1,len_trim(start_cleaned)
    if (start_cleaned(i:i) == '/') remainingSlashes = remainingSlashes + 1
  end do

  relpath = repeat('..'//'/',remainingSlashes)//path_cleaned(posLastCommonSlash+1:len_trim(path_cleaned))

end function relpath

!--------------------------------------------------------------------------------------------------
!> @brief Print usage instructions to STDOUT and terminate program.
!--------------------------------------------------------------------------------------------------
subroutine help()


  print'(/,1x,a)','#######################################################################'
  print'(1x,a)',  'DAMASK Command Line Interface:'
  print'(1x,a)',  'Düsseldorf Advanced Material Simulation Kit with PETSc-based solvers'
  print'(1x,a,/)','#######################################################################'
  print'(1x,a,/)','Valid command line flags:'
  print'(1x,a)',  '   --geom         (-g, --geometry)'
  print'(1x,a)',  '   --load         (-l, --loadcase)'
  print'(1x,a)',  '   --material     (-m, --materialconfig)'
  print'(1x,a)',  '   --numerics     (-n, --numericsconfig)'
  print'(1x,a)',  '   --jobname      (-j, --job)'
  print'(1x,a)',  '   --workingdir   (-w, --wd, --workingdirectory)'
#if defined(GRID)
  print'(1x,a)',  '   --restart      (-r, --rs)'
#endif
  print'(1x,a)',  '   --help         (-h)'
  print'(/,1x,a)','-----------------------------------------------------------------------'
  print'(1x,a)',  'Mandatory flags:'
  print'(/,1x,a)','  --geom GEOMFILE'
#if defined(GRID)
  print'(1x,a)',  '       Relative or absolute path to a VTK image data file (*.vti)'
  print'(1x,a)',  '       with mandatory "material" field variable.'
#elif defined(MESH)
  print'(1x,a)',  '       Relative or absolute path to a Gmsh file (*.msh)'
  print'(1x,a)',  '       with definitions of physical groups/tags for material IDs'
  print'(1x,a)',  '       and boundary conditions.'
#endif
  print'(/,1x,a)','  --load LOADFILE'
  print'(1x,a)',  '       Relative or absolute path to a load case definition'
  print'(1x,a)',  '       in YAML format.'
  print'(/,1x,a)','  --material MATERIALFILE'
  print'(1x,a)',  '       Relative or absolute path to a material configuration'
  print'(1x,a)',  '       in YAML format.'
  print'(/,1x,a)','-----------------------------------------------------------------------'
  print'(1x,a)',  'Optional flags:'
  print'(/,1x,a)','  --numerics NUMERICSFILE'
  print'(1x,a)',  '       Relative or absolute path to a numerics configuration'
  print'(1x,a)',  '       in YAML format.'
  print'(/,1x,a)','  --jobname JOBNAME'
  print'(1x,a)',  '       Job name, defaults to GEOM_LOAD_MATERIAL[_NUMERICS].'
  print'(/,1x,a)','  --workingdir WORKINGDIRECTORY'
  print'(1x,a)',  '       Working directory, defaults to current directory and'
  print'(1x,a)',  '       serves as base directory of relative paths.'
#if defined(GRID)
  print'(/,1x,a)','  --restart N'
  print'(1x,a)',  '       Restart simulation from given increment.'
  print'(1x,a)',  '       Read in increment N and, based on this, continue with'
  print'(1x,a)',  '       calculating increments N+1, N+2, ...'
  print'(1x,a)',  '       Requires restart information for increment N to be present in'
  print'(1x,a)',  '       JOBNAME_restart.hdf5 and will append subsequent results to'
  print'(1x,a)',  '       existing file JOBNAME.hdf5.'
#endif
  print'(/,1x,a)','-----------------------------------------------------------------------'
  print'(1x,a)',  'Help:'
  print'(/,1x,a)','  --help'
  print'(1x,a,/)','       Display help and exit.'

  call quit(0)

end subroutine help

end module CLI

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @brief spatial discretization
!> @details serves as an abstraction layer between the different solvers and DAMASK
!--------------------------------------------------------------------------------------------------
module discretization

  use prec
  use result

  implicit none(type,external)
  private

  integer,     public, protected :: &
    discretization_nIPs, &
    discretization_Nelems, &
    discretization_Ncells

  integer,     public, protected, dimension(:),   allocatable :: &
    discretization_materialAt                                                                       !ToDo: discretization_ID_material

  real(pREAL), public, protected, dimension(:,:), allocatable :: &
    discretization_IPcoords0, &
    discretization_IPcoords, &
    discretization_NodeCoords0, &
    discretization_NodeCoords

  integer :: &
    discretization_sharedNodesBegin

  public :: &
    discretization_init, &
    discretization_result, &
    discretization_setIPcoords, &
    discretization_setNodeCoords

contains

!--------------------------------------------------------------------------------------------------
!> @brief Initialize global discretization variables.
!--------------------------------------------------------------------------------------------------
subroutine discretization_init(materialAt,&
                               IPcoords0,NodeCoords0,&
                               sharedNodesBegin)

  integer,     dimension(:),   intent(in) :: &
    materialAt
  real(pREAL), dimension(:,:), intent(in) :: &
    IPcoords0, &
    NodeCoords0
  integer, optional,           intent(in) :: &
    sharedNodesBegin                                                                                !< index of first node shared among different processes (MPI)


  print'(/,1x,a)', '<<<+-  discretization init  -+>>>'; flush(6)

  discretization_Nelems = size(materialAt,1)
  discretization_nIPs   = size(IPcoords0,2)/discretization_Nelems
  discretization_Ncells = discretization_Nelems*discretization_nIPs

  discretization_materialAt = materialAt

  discretization_IPcoords0   = IPcoords0
  discretization_IPcoords    = IPcoords0

  discretization_NodeCoords0 = NodeCoords0
  discretization_NodeCoords  = NodeCoords0

  if (present(sharedNodesBegin)) then
    discretization_sharedNodesBegin = sharedNodesBegin
  else
    discretization_sharedNodesBegin = size(discretization_NodeCoords0,2)
  end if

end subroutine discretization_init


!--------------------------------------------------------------------------------------------------
!> @brief Write the displacements to DADF5.
!--------------------------------------------------------------------------------------------------
subroutine discretization_result()

  real(pREAL), dimension(:,:), allocatable :: u


  call result_closeGroup(result_addGroup('current/geometry'))

  u = discretization_NodeCoords (:,:discretization_sharedNodesBegin) &
    - discretization_NodeCoords0(:,:discretization_sharedNodesBegin)
  call result_writeDataset(u,'current/geometry','u_n','displacements of the nodes','m')

  u = discretization_IPcoords &
    - discretization_IPcoords0
  call result_writeDataset(u,'current/geometry','u_p','displacements of the materialpoints (cell centers)','m')

end subroutine discretization_result


!--------------------------------------------------------------------------------------------------
!> @brief Store current IP coordinates.
!--------------------------------------------------------------------------------------------------
subroutine discretization_setIPcoords(IPcoords)

  real(pREAL), dimension(:,:), intent(in) :: IPcoords


  discretization_IPcoords = IPcoords

end subroutine discretization_setIPcoords


!--------------------------------------------------------------------------------------------------
!> @brief Store current nodal coordinates.
!--------------------------------------------------------------------------------------------------
subroutine discretization_setNodeCoords(NodeCoords)

  real(pREAL), dimension(:,:), intent(in) :: NodeCoords


  discretization_NodeCoords = NodeCoords

end subroutine discretization_setNodeCoords


end module discretization

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Christoph Kords, Max-Planck-Institut für Eisenforschung GmbH
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @brief material subroutine for plasticity including dislocation flux
!--------------------------------------------------------------------------------------------------
submodule(phase:plastic) nonlocal
  use geometry_plastic_nonlocal, only: &
    nCellNeighbors  => geometry_plastic_nonlocal_nIPneighbors, &
    IPneighborhood  => geometry_plastic_nonlocal_IPneighborhood, &
    IPvolume0       => geometry_plastic_nonlocal_IPvolume0, &
    IParea0         => geometry_plastic_nonlocal_IParea0, &
    IPareaNormal0   => geometry_plastic_nonlocal_IPareaNormal0, &
    geometry_plastic_nonlocal_disable

  type :: tGeometry
    real(pREAL), dimension(:), allocatable :: v_0
    real(pREAL), dimension(:,:), allocatable :: a_0, x_0
    real(pREAL), dimension(:,:,:), allocatable :: n_0
    integer, dimension(:,:,:), allocatable :: IPneighborhood
  end type tGeometry

  type(tGeometry), dimension(:), allocatable :: geom

  ! storage order of dislocation types
  integer, dimension(*), parameter :: &
    sgl = [1,2,3,4,5,6,7,8]                                                                         !< signed (single)
  integer, dimension(*), parameter :: &
    edg = [1,2,5,6,9], &                                                                            !< edge
    scr = [3,4,7,8,10]                                                                              !< screw
  integer, dimension(*), parameter :: &
    mob = [1,2,3,4], &                                                                              !< mobile
    imm = [5,6,7,8]                                                                                 !< immobile (blocked)
  integer, dimension(*), parameter :: &
    dip = [9,10], &                                                                                 !< dipole
    imm_edg = imm(1:2), &                                                                           !< immobile edge
    imm_scr = imm(3:4)                                                                              !< immobile screw
  integer, parameter :: &
    mob_edg_pos = 1, &                                                                              !< mobile edge positive
    mob_edg_neg = 2, &                                                                              !< mobile edge negative
    mob_scr_pos = 3, &                                                                              !< mobile screw positive
    mob_scr_neg = 4                                                                                 !< mobile screw positive

  real(pREAL), dimension(:,:,:,:,:,:), allocatable :: &
    compatibility                                                                                   !< slip system compatibility between en and my neighbors

  type :: tInitialParameters                                                                        !< container type for internal constitutive parameters
    real(pREAL) :: &
      sigma_rho_u, &                                                                                !< standard deviation of scatter in initial dislocation density
      random_rho_u, &
      random_rho_u_binning
    real(pREAL), dimension(:), allocatable :: &
      rho_u_ed_pos_0, &                                                                             !< initial edge_pos dislocation density
      rho_u_ed_neg_0, &                                                                             !< initial edge_neg dislocation density
      rho_u_sc_pos_0, &                                                                             !< initial screw_pos dislocation density
      rho_u_sc_neg_0, &                                                                             !< initial screw_neg dislocation density
      rho_d_ed_0, &                                                                                 !< initial edge dipole dislocation density
      rho_d_sc_0                                                                                    !< initial screw dipole dislocation density
    integer,     dimension(:), allocatable :: &
      N_sl
  end type tInitialParameters

  type :: tParameters                                                                               !< container type for internal constitutive parameters
    real(pREAL) :: &
      V_at, &                                                                                       !< atomic volume
      D_0, &                                                                                        !< prefactor for self-diffusion coefficient
      Q_cl, &                                                                                       !< activation enthalpy for diffusion
      atol_rho, &                                                                                   !< absolute tolerance for dislocation density in state integration
      rho_significant, &                                                                            !< density considered significant
      rho_min, &                                                                                    !< number of dislocations considered significant
      w, &                                                                                          !< width of a doubkle kink in multiples of the Burgers vector length b
      Q_sol, &                                                                                      !< activation energy for solid solution in J
      f_sol, &                                                                                      !< solid solution obstacle size in multiples of the Burgers vector length
      c_sol, &                                                                                      !< concentration of solid solution in atomic parts
      p, &                                                                                          !< parameter for kinetic law (Kocks,Argon,Ashby)
      q, &                                                                                          !< parameter for kinetic law (Kocks,Argon,Ashby)
      B, &                                                                                          !< drag coefficient in Pa s
      nu_a, &                                                                                       !< attack frequency in Hz
      chi_surface, &                                                                                !< transmissivity at free surface
      chi_GB, &                                                                                     !< transmissivity at grain boundary (identified by different texture)
      C_CFL, &                                                                                      !< safety factor for CFL flux condition
      f_ed_mult, &                                                                                  !< factor that determines how much edge dislocations contribute to multiplication (0...1)
      f_F, &
      f_ed, &
      mu, &
      nu
    real(pREAL), dimension(:),      allocatable :: &
      i_sl, &                                                                                       !< mean free path prefactor for each
      b_sl                                                                                          !< absolute length of Burgers vector [m]
    real(pREAL), dimension(:,:),   allocatable :: &
      slip_normal, &
      slip_direction, &
      slip_transverse, &
      minDipoleHeight, &                                                                            ! minimum stable dipole height edge and screw
      peierlsstress, &                                                                              ! edge and screw
      h_sl_sl ,&                                                                                    !< coefficients for slip-slip interaction
      forestProjection_Edge, &                                                                      !< matrix of forest projections of edge dislocations
      forestProjection_Screw                                                                        !< matrix of forest projections of screw dislocations
    real(pREAL), dimension(:,:,:), allocatable :: &
      P_sl, &                                                                                       !< Schmid contribution
      P_nS_pos, &
      P_nS_neg                                                                                      !< combined projection of Schmid and non-Schmid contributions to the resolved shear stress (only for screws)
    integer :: &
      sum_N_sl = 0
    integer,     dimension(:),     allocatable :: &
      colinearSystem                                                                                !< colinear system to the active slip system (only valid for fcc!)
    character(len=:),              allocatable :: &
      isotropic_bound
    character(len=pSTRLEN), dimension(:), allocatable :: &
      output
    logical :: &
      shortRangeStressCorrection                                                                    !< use of short range stress correction by excess density gradient term
    character(len=:),          allocatable, dimension(:) :: &
      systems_sl
  end type tParameters

  type :: tNonlocalDependentState
    real(pREAL), allocatable, dimension(:,:) :: &
      tau_pass, &
      tau_back, &
      rho_forest, &
      max_dipole_height
    real(pREAL), allocatable, dimension(:,:,:,:,:) :: &
      compatibility
  end type tNonlocalDependentState

  type :: tNonlocalState
    real(pREAL), pointer, dimension(:,:) :: &
      rho, &                                                                                        ! < all dislocations
        rho_sgl, &
          rho_sgl_mob, &
            rho_sgl_mob_edg_pos, &
            rho_sgl_mob_edg_neg, &
            rho_sgl_mob_scr_pos, &
            rho_sgl_mob_scr_neg, &
          rho_sgl_imm, &
            rho_sgl_imm_edg_pos, &
            rho_sgl_imm_edg_neg, &
            rho_sgl_imm_scr_pos, &
            rho_sgl_imm_scr_neg, &
        rho_dip, &
          rho_dip_edg, &
          rho_dip_scr, &
      gamma, &
      v, &
        v_edg_pos, &
        v_edg_neg, &
        v_scr_pos, &
        v_scr_neg
  end type tNonlocalState

 type(tNonlocalState), allocatable, dimension(:) :: &
    deltaState, &
    dotState, &
    state, &
    state0

  type(tParameters), dimension(:), allocatable :: param                                             !< containers of constitutive parameters
  type(tNonlocalDependentState), dimension(:), allocatable :: dependentState

contains


!--------------------------------------------------------------------------------------------------
!> @brief Perform module initialization.
!> @details reads in material parameters, allocates arrays, and does sanity checks
!--------------------------------------------------------------------------------------------------
module function plastic_nonlocal_init() result(myPlasticity)

  logical, dimension(:), allocatable :: myPlasticity
  integer :: &
    ph, &
    Nmembers, &
    sizeState, sizeDotState, sizeDeltaState, &
    s1, s2
  real(pREAL), dimension(:,:), allocatable :: &
    a_nS                                                                                            !< non-Schmid coefficients
  character(len=:), allocatable :: &
    refs, &
    extmsg
  type(tInitialParameters) :: &
    ini
  type(tDict), pointer :: &
    phases, &
    phase, &
    mech, &
    pl

  myPlasticity = plastic_active('nonlocal')
  if (count(myPlasticity) == 0) then
    call geometry_plastic_nonlocal_disable()
    return
  end if

  print'(/,1x,a)', '<<<+-  phase:mechanical:plastic:nonlocal init  -+>>>'

  print'(/,1x,a)', 'C. Reuber et al., Acta Materialia 71:333–348, 2014'
  print'(  1x,a)', 'https://doi.org/10.1016/j.actamat.2014.03.012'

  print'(/,1x,a)', 'C. Kords, Dissertation RWTH Aachen, 2014'
  print'(  1x,a)', 'http://publications.rwth-aachen.de/record/229993'

  print'(/,1x,a,1x,i0)', '# phases:',count(myPlasticity); flush(IO_STDOUT)

  phases => config_material%get_dict('phase')
  allocate(geom(size(phases)))
  allocate(param(size(phases)))
  allocate(state(size(phases)))
  allocate(state0(size(phases)))
  allocate(dotState(size(phases)))
  allocate(deltaState(size(phases)))
  allocate(dependentState(size(phases)))
  extmsg = ''

  do ph = 1, size(phases)
    if (.not. myPlasticity(ph)) cycle

    associate(prm => param(ph),  dot => dotState(ph),   stt => state(ph), &
              st0 => state0(ph), del => deltaState(ph), dst => dependentState(ph))

    phase => phases%get_dict(ph)
    mech => phase%get_dict('mechanical')
    pl => mech%get_dict('plastic')

    print'(/,1x,a,1x,i0,a)', 'phase',ph,': '//phases%key(ph)
    refs = config_listReferences(pl,indent=3)
    if (len(refs) > 0) print'(/,1x,a)', refs

#if defined (__GFORTRAN__)
    prm%output = output_as1dStr(pl)
#else
    prm%output = pl%get_as1dStr('output',defaultVal=emptyStrArray)
#endif

    plasticState(ph)%nonlocal = pl%get_asBool('flux',defaultVal=.True.)
    prm%isotropic_bound = pl%get_asStr('isotropic_bound',defaultVal='isostrain')
    prm%atol_rho = pl%get_asReal('atol_rho',defaultVal=1.0_pREAL)

    ini%N_sl = pl%get_as1dInt('N_sl',defaultVal=emptyIntArray)
    prm%sum_N_sl = sum(abs(ini%N_sl))
    slipActive: if (prm%sum_N_sl > 0) then
      prm%P_sl = crystal_SchmidMatrix_slip(ini%N_sl,phase_lattice(ph), phase_cOverA(ph))
      prm%systems_sl = crystal_labels_slip(ini%N_sl,phase_lattice(ph))


      a_nS = pl%get_as2dReal('a_non-Schmid',defaultVal=reshape(emptyRealArray,[0,0]))
      prm%P_nS_pos = crystal_SchmidMatrix_slip(ini%N_sl,phase_lattice(ph),phase_cOverA(ph), &
                                               nonSchmidCoefficients=a_nS,sense=+1)
      prm%P_nS_neg = crystal_SchmidMatrix_slip(ini%N_sl,phase_lattice(ph),phase_cOverA(ph), &
                                               nonSchmidCoefficients=a_nS,sense=-1)

      prm%h_sl_sl = crystal_interaction_SlipBySlip(ini%N_sl,pl%get_as1dReal('h_sl-sl'),phase_lattice(ph))

      prm%forestProjection_edge  = crystal_forestProjection_edge (ini%N_sl,phase_lattice(ph),&
                                                                  phase_cOverA(ph))
      prm%forestProjection_screw = crystal_forestProjection_screw(ini%N_sl,phase_lattice(ph),&
                                                                  phase_cOverA(ph))

      prm%slip_direction  = crystal_slip_direction (ini%N_sl,phase_lattice(ph),phase_cOverA(ph))
      prm%slip_transverse = crystal_slip_transverse(ini%N_sl,phase_lattice(ph),phase_cOverA(ph))
      prm%slip_normal     = crystal_slip_normal    (ini%N_sl,phase_lattice(ph),phase_cOverA(ph))

      ! collinear systems (only for octahedral slip systems in fcc)
      allocate(prm%colinearSystem(prm%sum_N_sl), source = -1)
      do s1 = 1, prm%sum_N_sl
        do s2 = 1, prm%sum_N_sl
           if (all(dEq0 (math_cross(prm%slip_direction(1:3,s1),prm%slip_direction(1:3,s2)))) .and. &
               any(dNeq0(math_cross(prm%slip_normal   (1:3,s1),prm%slip_normal   (1:3,s2))))) &
             prm%colinearSystem(s1) = s2
        end do
      end do

      ini%rho_u_ed_pos_0  = pl%get_as1dReal('rho_u_ed_pos_0',   requiredSize=size(ini%N_sl))
      ini%rho_u_ed_neg_0  = pl%get_as1dReal('rho_u_ed_neg_0',   requiredSize=size(ini%N_sl))
      ini%rho_u_sc_pos_0  = pl%get_as1dReal('rho_u_sc_pos_0',   requiredSize=size(ini%N_sl))
      ini%rho_u_sc_neg_0  = pl%get_as1dReal('rho_u_sc_neg_0',   requiredSize=size(ini%N_sl))
      ini%rho_d_ed_0      = pl%get_as1dReal('rho_d_ed_0',       requiredSize=size(ini%N_sl))
      ini%rho_d_sc_0      = pl%get_as1dReal('rho_d_sc_0',       requiredSize=size(ini%N_sl))

      prm%i_sl            = math_expand(pl%get_as1dReal('i_sl', requiredSize=size(ini%N_sl)),ini%N_sl)
      prm%b_sl            = math_expand(pl%get_as1dReal('b_sl', requiredSize=size(ini%N_sl)),ini%N_sl)

      allocate(prm%minDipoleHeight(prm%sum_N_sl,2))
      prm%minDipoleHeight(:,1) = math_expand(pl%get_as1dReal('d_ed', requiredSize=size(ini%N_sl)),ini%N_sl)
      prm%minDipoleHeight(:,2) = math_expand(pl%get_as1dReal('d_sc', requiredSize=size(ini%N_sl)),ini%N_sl)

      allocate(prm%peierlsstress(prm%sum_N_sl,2))
      prm%peierlsstress(:,1)   = math_expand(pl%get_as1dReal('tau_Peierls_ed', requiredSize=size(ini%N_sl)),ini%N_sl)
      prm%peierlsstress(:,2)   = math_expand(pl%get_as1dReal('tau_Peierls_sc', requiredSize=size(ini%N_sl)),ini%N_sl)

      prm%rho_significant = pl%get_asReal('rho_significant')
      prm%rho_min         = pl%get_asReal('rho_min', 0.0_pREAL)
      prm%C_CFL           = pl%get_asReal('C_CFL',defaultVal=2.0_pREAL)

      prm%V_at            = pl%get_asReal('V_at')
      prm%D_0             = pl%get_asReal('D_0')
      prm%Q_cl            = pl%get_asReal('Q_cl')
      prm%f_F             = pl%get_asReal('f_F')
      prm%f_ed            = pl%get_asReal('f_ed')
      prm%w               = pl%get_asReal('w')
      prm%Q_sol           = pl%get_asReal('Q_sol')
      prm%f_sol           = pl%get_asReal('f_sol')
      prm%c_sol           = pl%get_asReal('c_sol')

      prm%p               = pl%get_asReal('p_sl')
      prm%q               = pl%get_asReal('q_sl')
      prm%B               = pl%get_asReal('B')
      prm%nu_a            = pl%get_asReal('nu_a')

      ! ToDo: discuss logic
      ini%sigma_rho_u     = pl%get_asReal('sigma_rho_u')
      ini%random_rho_u    = pl%get_asReal('random_rho_u',defaultVal= 0.0_pREAL)
      if (pl%contains('random_rho_u')) &
        ini%random_rho_u_binning = pl%get_asReal('random_rho_u_binning',defaultVal=0.0_pREAL) !ToDo: useful default?
     ! if (rhoSglRandom(instance) < 0.0_pREAL) &
     ! if (rhoSglRandomBinning(instance) <= 0.0_pREAL) &

      prm%chi_surface                 = pl%get_asReal('chi_surface',defaultVal=1.0_pREAL)
      prm%chi_GB                      = pl%get_asReal('chi_GB',     defaultVal=-1.0_pREAL)
      prm%f_ed_mult                   = pl%get_asReal('f_ed_mult')
      prm%shortRangeStressCorrection  = pl%get_asBool('short_range_stress_correction', defaultVal = .false.)


!--------------------------------------------------------------------------------------------------
!  sanity checks
      if (any(prm%b_sl             <  0.0_pREAL)) extmsg = trim(extmsg)//' b_sl'
      if (any(prm%i_sl             <= 0.0_pREAL)) extmsg = trim(extmsg)//' i_sl'

      if (any(ini%rho_u_ed_pos_0   <  0.0_pREAL)) extmsg = trim(extmsg)//' rho_u_ed_pos_0'
      if (any(ini%rho_u_ed_neg_0   <  0.0_pREAL)) extmsg = trim(extmsg)//' rho_u_ed_neg_0'
      if (any(ini%rho_u_sc_pos_0   <  0.0_pREAL)) extmsg = trim(extmsg)//' rho_u_sc_pos_0'
      if (any(ini%rho_u_sc_neg_0   <  0.0_pREAL)) extmsg = trim(extmsg)//' rho_u_sc_neg_0'
      if (any(ini%rho_d_ed_0       <  0.0_pREAL)) extmsg = trim(extmsg)//' rho_d_ed_0'
      if (any(ini%rho_d_sc_0       <  0.0_pREAL)) extmsg = trim(extmsg)//' rho_d_sc_0'

      if (any(prm%peierlsstress    <  0.0_pREAL)) extmsg = trim(extmsg)//' tau_peierls'
      if (any(prm%minDipoleHeight  <  0.0_pREAL)) extmsg = trim(extmsg)//' d_ed or d_sc'

      if (prm%B                    <  0.0_pREAL)  extmsg = trim(extmsg)//' B'
      if (prm%Q_cl                 <  0.0_pREAL)  extmsg = trim(extmsg)//' Q_cl'
      if (prm%nu_a                <=  0.0_pREAL)  extmsg = trim(extmsg)//' nu_a'
      if (prm%w                   <=  0.0_pREAL)  extmsg = trim(extmsg)//' w'
      if (prm%D_0                 <   0.0_pREAL)  extmsg = trim(extmsg)//' D_0'
      if (prm%V_at                <=  0.0_pREAL)  extmsg = trim(extmsg)//' V_at'                   ! ToDo: in dislotungsten, the atomic volume is given as a factor

      if (prm%rho_min             <   0.0_pREAL)  extmsg = trim(extmsg)//' rho_min'
      if (prm%rho_significant     <   0.0_pREAL)  extmsg = trim(extmsg)//' rho_significant'
      if (prm%atol_rho            <   0.0_pREAL)  extmsg = trim(extmsg)//' atol_rho'
      if (prm%C_CFL               <   0.0_pREAL)  extmsg = trim(extmsg)//' C_CFL'

      if (prm%p    <= 0.0_pREAL .or. prm%p > 1.0_pREAL) extmsg = trim(extmsg)//' p_sl'
      if (prm%q    <  1.0_pREAL .or. prm%q > 2.0_pREAL) extmsg = trim(extmsg)//' q_sl'

      if (prm%f_F  < 0.0_pREAL  .or. prm%f_F  > 1.0_pREAL) &
                                                  extmsg = trim(extmsg)//' f_F'
      if (prm%f_ed <  0.0_pREAL .or. prm%f_ed > 1.0_pREAL) &
                                                  extmsg = trim(extmsg)//' f_ed'

      if (prm%Q_sol               <=  0.0_pREAL)  extmsg = trim(extmsg)//' Q_sol'
      if (prm%f_sol               <=  0.0_pREAL)  extmsg = trim(extmsg)//' f_sol'
      if (prm%c_sol               <=  0.0_pREAL)  extmsg = trim(extmsg)//' c_sol'

      if (prm%chi_GB              >   1.0_pREAL)  extmsg = trim(extmsg)//' chi_GB'
      if (prm%chi_surface  < 0.0_pREAL .or. prm%chi_surface  > 1.0_pREAL) &
                                                  extmsg = trim(extmsg)//' chi_surface'

      if (prm%f_ed_mult    < 0.0_pREAL .or. prm%f_ed_mult    > 1.0_pREAL) &
                                                  extmsg = trim(extmsg)//' f_ed_mult'

    end if slipActive

!--------------------------------------------------------------------------------------------------
! allocate state arrays
    Nmembers  = count(material_ID_phase == ph)
    sizeDotState = size(['rho_sgl_mob_edg_pos', 'rho_sgl_mob_edg_neg', &
                         'rho_sgl_mob_scr_pos', 'rho_sgl_mob_scr_neg', &
                         'rho_sgl_imm_edg_pos', 'rho_sgl_imm_edg_neg', &
                         'rho_sgl_imm_scr_pos', 'rho_sgl_imm_scr_neg', &
                         'rho_dip_edg        ', 'rho_dip_scr        ', &
                         'gamma              ' ]) * prm%sum_N_sl                                    !< "basic" microstructural state variables that are independent from other state variables
    sizeState          = sizeDotState &
                       + size([ 'velocityEdgePos     ','velocityEdgeNeg     ', &
                                'velocityScrewPos    ','velocityScrewNeg    ']) * prm%sum_N_sl      !< other dependent state variables that are not updated by microstructure
    sizeDeltaState            = sizeDotState

    call phase_allocateState(plasticState(ph),Nmembers,sizeState,sizeDotState,sizeDeltaState,0)     ! ToDo: state structure does not follow convention

    allocate(geom(ph)%v_0(Nmembers))
    allocate(geom(ph)%a_0(nCellNeighbors,Nmembers))
    allocate(geom(ph)%x_0(3,Nmembers))
    allocate(geom(ph)%n_0(3,nCellNeighbors,Nmembers))
    allocate(geom(ph)%IPneighborhood(3,nCellNeighbors,Nmembers))
    call storeGeometry(ph)

    if (plasticState(ph)%nonlocal .and. .not. allocated(IPneighborhood)) &
      call IO_error(212,ext_msg='IPneighborhood does not exist')

    st0%rho => plasticState(ph)%state0                             (0*prm%sum_N_sl+1:10*prm%sum_N_sl,:)
    stt%rho => plasticState(ph)%state                              (0*prm%sum_N_sl+1:10*prm%sum_N_sl,:)
    dot%rho => plasticState(ph)%dotState                           (0*prm%sum_N_sl+1:10*prm%sum_N_sl,:)
    del%rho => plasticState(ph)%deltaState                         (0*prm%sum_N_sl+1:10*prm%sum_N_sl,:)
    plasticState(ph)%atol(1:10*prm%sum_N_sl) = prm%atol_rho

      stt%rho_sgl => plasticState(ph)%state                        (0*prm%sum_N_sl+1: 8*prm%sum_N_sl,:)
      dot%rho_sgl => plasticState(ph)%dotState                     (0*prm%sum_N_sl+1: 8*prm%sum_N_sl,:)
      del%rho_sgl => plasticState(ph)%deltaState                   (0*prm%sum_N_sl+1: 8*prm%sum_N_sl,:)

        st0%rho_sgl_mob => plasticState(ph)%state0                 (0*prm%sum_N_sl+1: 4*prm%sum_N_sl,:)
        stt%rho_sgl_mob => plasticState(ph)%state                  (0*prm%sum_N_sl+1: 4*prm%sum_N_sl,:)
        dot%rho_sgl_mob => plasticState(ph)%dotState               (0*prm%sum_N_sl+1: 4*prm%sum_N_sl,:)
        del%rho_sgl_mob => plasticState(ph)%deltaState             (0*prm%sum_N_sl+1: 4*prm%sum_N_sl,:)

            stt%rho_sgl_mob_edg_pos => plasticState(ph)%state      (0*prm%sum_N_sl+1: 1*prm%sum_N_sl,:)
            dot%rho_sgl_mob_edg_pos => plasticState(ph)%dotState   (0*prm%sum_N_sl+1: 1*prm%sum_N_sl,:)
            del%rho_sgl_mob_edg_pos => plasticState(ph)%deltaState (0*prm%sum_N_sl+1: 1*prm%sum_N_sl,:)

            stt%rho_sgl_mob_edg_neg => plasticState(ph)%state      (1*prm%sum_N_sl+1: 2*prm%sum_N_sl,:)
            dot%rho_sgl_mob_edg_neg => plasticState(ph)%dotState   (1*prm%sum_N_sl+1: 2*prm%sum_N_sl,:)
            del%rho_sgl_mob_edg_neg => plasticState(ph)%deltaState (1*prm%sum_N_sl+1: 2*prm%sum_N_sl,:)

            stt%rho_sgl_mob_scr_pos => plasticState(ph)%state      (2*prm%sum_N_sl+1: 3*prm%sum_N_sl,:)
            dot%rho_sgl_mob_scr_pos => plasticState(ph)%dotState   (2*prm%sum_N_sl+1: 3*prm%sum_N_sl,:)
            del%rho_sgl_mob_scr_pos => plasticState(ph)%deltaState (2*prm%sum_N_sl+1: 3*prm%sum_N_sl,:)

            stt%rho_sgl_mob_scr_neg => plasticState(ph)%state      (3*prm%sum_N_sl+1: 4*prm%sum_N_sl,:)
            dot%rho_sgl_mob_scr_neg => plasticState(ph)%dotState   (3*prm%sum_N_sl+1: 4*prm%sum_N_sl,:)
            del%rho_sgl_mob_scr_neg => plasticState(ph)%deltaState (3*prm%sum_N_sl+1: 4*prm%sum_N_sl,:)

        stt%rho_sgl_imm => plasticState(ph)%state                  (4*prm%sum_N_sl+1: 8*prm%sum_N_sl,:)
        dot%rho_sgl_imm => plasticState(ph)%dotState               (4*prm%sum_N_sl+1: 8*prm%sum_N_sl,:)
        del%rho_sgl_imm => plasticState(ph)%deltaState             (4*prm%sum_N_sl+1: 8*prm%sum_N_sl,:)

            stt%rho_sgl_imm_edg_pos => plasticState(ph)%state      (4*prm%sum_N_sl+1: 5*prm%sum_N_sl,:)
            dot%rho_sgl_imm_edg_pos => plasticState(ph)%dotState   (4*prm%sum_N_sl+1: 5*prm%sum_N_sl,:)
            del%rho_sgl_imm_edg_pos => plasticState(ph)%deltaState (4*prm%sum_N_sl+1: 5*prm%sum_N_sl,:)

            stt%rho_sgl_imm_edg_neg => plasticState(ph)%state      (5*prm%sum_N_sl+1: 6*prm%sum_N_sl,:)
            dot%rho_sgl_imm_edg_neg => plasticState(ph)%dotState   (5*prm%sum_N_sl+1: 6*prm%sum_N_sl,:)
            del%rho_sgl_imm_edg_neg => plasticState(ph)%deltaState (5*prm%sum_N_sl+1: 6*prm%sum_N_sl,:)

            stt%rho_sgl_imm_scr_pos => plasticState(ph)%state      (6*prm%sum_N_sl+1: 7*prm%sum_N_sl,:)
            dot%rho_sgl_imm_scr_pos => plasticState(ph)%dotState   (6*prm%sum_N_sl+1: 7*prm%sum_N_sl,:)
            del%rho_sgl_imm_scr_pos => plasticState(ph)%deltaState (6*prm%sum_N_sl+1: 7*prm%sum_N_sl,:)

            stt%rho_sgl_imm_scr_neg => plasticState(ph)%state      (7*prm%sum_N_sl+1: 8*prm%sum_N_sl,:)
            dot%rho_sgl_imm_scr_neg => plasticState(ph)%dotState   (7*prm%sum_N_sl+1: 8*prm%sum_N_sl,:)
            del%rho_sgl_imm_scr_neg => plasticState(ph)%deltaState (7*prm%sum_N_sl+1: 8*prm%sum_N_sl,:)

      stt%rho_dip => plasticState(ph)%state                        (8*prm%sum_N_sl+1:10*prm%sum_N_sl,:)
      dot%rho_dip => plasticState(ph)%dotState                     (8*prm%sum_N_sl+1:10*prm%sum_N_sl,:)
      del%rho_dip => plasticState(ph)%deltaState                   (8*prm%sum_N_sl+1:10*prm%sum_N_sl,:)

        stt%rho_dip_edg => plasticState(ph)%state                  (8*prm%sum_N_sl+1: 9*prm%sum_N_sl,:)
        dot%rho_dip_edg => plasticState(ph)%dotState               (8*prm%sum_N_sl+1: 9*prm%sum_N_sl,:)
        del%rho_dip_edg => plasticState(ph)%deltaState             (8*prm%sum_N_sl+1: 9*prm%sum_N_sl,:)

        stt%rho_dip_scr => plasticState(ph)%state                  (9*prm%sum_N_sl+1:10*prm%sum_N_sl,:)
        dot%rho_dip_scr => plasticState(ph)%dotState               (9*prm%sum_N_sl+1:10*prm%sum_N_sl,:)
        del%rho_dip_scr => plasticState(ph)%deltaState             (9*prm%sum_N_sl+1:10*prm%sum_N_sl,:)

    stt%gamma => plasticState(ph)%state                      (10*prm%sum_N_sl + 1:11*prm%sum_N_sl,1:Nmembers)
    dot%gamma => plasticState(ph)%dotState                   (10*prm%sum_N_sl + 1:11*prm%sum_N_sl,1:Nmembers)
    del%gamma => plasticState(ph)%deltaState                 (10*prm%sum_N_sl + 1:11*prm%sum_N_sl,1:Nmembers)
    plasticState(ph)%atol(10*prm%sum_N_sl+1:11*prm%sum_N_sl )  = pl%get_asReal('atol_gamma', defaultVal = 1.0e-6_pREAL)
    if (any(plasticState(ph)%atol(10*prm%sum_N_sl+1:11*prm%sum_N_sl) < 0.0_pREAL)) &
      extmsg = trim(extmsg)//' atol_gamma'

    stt%v          => plasticState(ph)%state                 (11*prm%sum_N_sl + 1:15*prm%sum_N_sl,1:Nmembers)
    st0%v          => plasticState(ph)%state0                (11*prm%sum_N_sl + 1:15*prm%sum_N_sl,1:Nmembers)
        stt%v_edg_pos  => plasticState(ph)%state             (11*prm%sum_N_sl + 1:12*prm%sum_N_sl,1:Nmembers)
        stt%v_edg_neg  => plasticState(ph)%state             (12*prm%sum_N_sl + 1:13*prm%sum_N_sl,1:Nmembers)
        stt%v_scr_pos  => plasticState(ph)%state             (13*prm%sum_N_sl + 1:14*prm%sum_N_sl,1:Nmembers)
        stt%v_scr_neg  => plasticState(ph)%state             (14*prm%sum_N_sl + 1:15*prm%sum_N_sl,1:Nmembers)

    allocate(dst%tau_pass(prm%sum_N_sl,Nmembers),source=0.0_pREAL)
    allocate(dst%tau_back(prm%sum_N_sl,Nmembers),source=0.0_pREAL)
    allocate(dst%rho_forest(prm%sum_N_sl,Nmembers),source=0.0_pREAL)
    allocate(dst%max_dipole_height(2*prm%sum_N_sl,Nmembers),source=0.0_pREAL)                       ! edge and screw
    allocate(dst%compatibility(2,maxval(param%sum_N_sl),maxval(param%sum_N_sl),nCellNeighbors,Nmembers),source=0.0_pREAL)
    end associate

    if (Nmembers > 0) call stateInit(ini,ph,Nmembers)

!--------------------------------------------------------------------------------------------------
!  exit if any parameter is out of range
    if (extmsg /= '') call IO_error(211,ext_msg=trim(extmsg))

  end do

  allocate(compatibility(2,maxval(param%sum_N_sl),maxval(param%sum_N_sl),nCellNeighbors,&
                         discretization_nIPs,discretization_Nelems), source=0.0_pREAL)

end function plastic_nonlocal_init


!--------------------------------------------------------------------------------------------------
!> @brief Calculate quantities characterizing the microstructure
!--------------------------------------------------------------------------------------------------
module subroutine nonlocal_dependentState(ph, en)

  integer, intent(in) :: &
    ph, &
    en

  integer :: &
    en_nbr, &                                                                                       ! neighbor phase entry
    el_nbr, &                                                                                       ! element number of neighboring material point
    ip_nbr, &                                                                                       ! integration point of neighboring material point
    c, &                                                                                            ! index of dilsocation character (edge, screw)
    s, &                                                                                            ! slip system index
    dir, &
    n
  real(pREAL) :: &
    FVsize, &
    nRealNeighbors, &                                                                               ! number of really existing neighbors
    mu, &
    nu
  integer, dimension(2) :: &
    neighbors
  real(pREAL), dimension(2) :: &
    rhoExcessGradient, &
    rhoExcessGradient_over_rho, &
    rho_sum
  real(pREAL), dimension(3) :: &
    rhoExcessDifferences, &
    normal_latticeConf
  real(pREAL), dimension(3,3) :: &
    invFe, &                                                                                        !< inverse of elastic deformation gradient
    invFp, &                                                                                        !< inverse of plastic deformation gradient
    connections, &
    invConnections
  real(pREAL), dimension(3,nCellNeighbors) :: &
    connection_latticeConf
  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    rho_edg_delta, &
    rho_scr_delta
  real(pREAL), dimension(param(ph)%sum_N_sl,10) :: &
    rho, &
    rho_0, &
    rho_0_nbr
  real(pREAL), dimension(param(ph)%sum_N_sl,param(ph)%sum_N_sl) :: &
    myInteractionMatrix                                                                             ! corrected slip interaction matrix
  real(pREAL), dimension(param(ph)%sum_N_sl,nCellNeighbors) :: &
    rho_edg_delta_nbr, &
    rho_scr_delta_nbr
  real(pREAL), dimension(2,maxval(param%sum_N_sl),nCellNeighbors) :: &
    rho_delta_nbr, &                                                                                ! excess density at neighboring material point
    rho_sum_nbr                                                                                     ! total density at neighboring material point
  real(pREAL), dimension(3,param(ph)%sum_N_sl,2) :: &
    m                                                                                               ! direction of dislocation motion

  associate(prm => param(ph),dst => dependentState(ph), stt => state(ph))

  mu = elastic_mu(ph,en,prm%isotropic_bound)
  nu = elastic_nu(ph,en,prm%isotropic_bound)
  rho = getRho(ph,en)

  dst%rho_forest(:,en) = matmul(prm%forestProjection_Edge, sum(abs(rho(:,edg)),2)) &
                       + matmul(prm%forestProjection_Screw,sum(abs(rho(:,scr)),2))


  ! coefficients are corrected for the line tension effect
  ! (see Kubin,Devincre,Hoc; 2008; Modeling dislocation storage rates and mean free paths in face-centered cubic crystals)
  if (any(phase_lattice(ph) == ['cI','cF'])) then
    myInteractionMatrix = prm%h_sl_sl &
                        * spread((  1.0_pREAL - prm%f_F &
                                   + prm%f_F &
                                   * log(0.35_pREAL * prm%b_sl * sqrt(max(dst%rho_forest(:,en),prm%rho_significant))) &
                                   / log(0.35_pREAL * prm%b_sl * 1e6_pREAL))**2,2,prm%sum_N_sl)
  else
    myInteractionMatrix = prm%h_sl_sl
  end if

  dst%tau_pass(:,en) = mu * prm%b_sl &
                     * sqrt(matmul(myInteractionMatrix,sum(abs(rho),2)))

!*** calculate the dislocation stress of the neighboring excess dislocation densities
!*** zero for material points of local plasticity

  !#################################################################################################
  ! ToDo: MD: this is most likely only correct for F_i = I
  !#################################################################################################

  rho_0 = getRho0(ph,en)
  if (plasticState(ph)%nonlocal .and. prm%shortRangeStressCorrection) then
    invFp = math_inv33(phase_mechanical_Fp(ph)%data(1:3,1:3,en))
    invFe = math_inv33(phase_mechanical_Fe(ph)%data(1:3,1:3,en))

    rho_edg_delta = rho_0(:,mob_edg_pos) - rho_0(:,mob_edg_neg)
    rho_scr_delta = rho_0(:,mob_scr_pos) - rho_0(:,mob_scr_neg)

    FVsize = geom(ph)%v_0(en)**(1.0_pREAL/3.0_pREAL)

    !* loop through my neighborhood and get the connection vectors (in lattice frame) and the excess densities

    nRealNeighbors = 0.0_pREAL
    rho_sum_nbr = 0.0_pREAL
    do n = 1,nCellNeighbors
      el_nbr = geom(ph)%IPneighborhood(1,n,en)
      ip_nbr = geom(ph)%IPneighborhood(2,n,en)

      if (el_nbr > 0 .and. ip_nbr > 0) then
        if (material_ID_phase(1,(el_nbr-1)*discretization_nIPs + ip_nbr) == ph) then
            en_nbr = material_entry_phase(1,(el_nbr-1)*discretization_nIPs + ip_nbr)
            nRealNeighbors = nRealNeighbors + 1.0_pREAL
            rho_0_nbr = getRho0(ph,en_nbr)

            rho_edg_delta_nbr(:,n) = rho_0_nbr(:,mob_edg_pos) - rho_0_nbr(:,mob_edg_neg)
            rho_scr_delta_nbr(:,n) = rho_0_nbr(:,mob_scr_pos) - rho_0_nbr(:,mob_scr_neg)

            rho_sum_nbr(1,:,n) = sum(abs(rho_0_nbr(:,edg)),2)
            rho_sum_nbr(2,:,n) = sum(abs(rho_0_nbr(:,scr)),2)

            connection_latticeConf(1:3,n) = matmul(invFe, geom(ph)%x_0(1:3,en_nbr) &
                                          - geom(ph)%x_0(1:3,en))
            normal_latticeConf = matmul(transpose(invFp), geom(ph)%n_0(1:3,n,en))
            if (math_inner(normal_latticeConf,connection_latticeConf(1:3,n)) < 0.0_pREAL) &         ! neighboring connection points in opposite direction to face normal: must be periodic image
              connection_latticeConf(1:3,n) = normal_latticeConf * geom(ph)%v_0(en)/geom(ph)%a_0(n,en)  ! instead take the surface normal scaled with the diameter of the cell
        else
          ! local neighbor or different lattice structure or different constitution instance -> use central values instead
          connection_latticeConf(1:3,n) = 0.0_pREAL
          rho_edg_delta_nbr(:,n) = rho_edg_delta
          rho_scr_delta_nbr(:,n) = rho_scr_delta
        end if
      else
        ! free surface -> use central values instead
        connection_latticeConf(1:3,n) = 0.0_pREAL
        rho_edg_delta_nbr(:,n) = rho_edg_delta
        rho_scr_delta_nbr(:,n) = rho_scr_delta
      end if
    end do

    rho_delta_nbr(1,:,:) = rho_edg_delta_nbr
    rho_delta_nbr(2,:,:) = rho_scr_delta_nbr

    !* loop through the slip systems and calculate the dislocation gradient by
    !* 1. interpolation of the excess density in the neighorhood
    !* 2. interpolation of the dead dislocation density in the central volume
    m(1:3,:,1) =  prm%slip_direction
    m(1:3,:,2) = -prm%slip_transverse

    do s = 1,prm%sum_N_sl

      ! gradient from interpolation of neighboring excess density ...
      do c = 1,2
        do dir = 1,3
          neighbors(1) = 2 * dir - 1
          neighbors(2) = 2 * dir
          connections(dir,1:3) = connection_latticeConf(1:3,neighbors(1)) &
                               - connection_latticeConf(1:3,neighbors(2))
          rhoExcessDifferences(dir) = rho_delta_nbr(c,s,neighbors(1)) &
                                    - rho_delta_nbr(c,s,neighbors(2))
        end do
        invConnections = math_inv33(connections)
        if (all(dEq0(invConnections))) error stop 'back stress calculation: inversion error'

        rhoExcessGradient(c) = math_inner(m(1:3,s,c), matmul(invConnections,rhoExcessDifferences))
      end do

        ! ... plus gradient from deads ...
      rhoExcessGradient(1) = rhoExcessGradient(1) + sum(rho(s,imm_edg)) / FVsize
      rhoExcessGradient(2) = rhoExcessGradient(2) + sum(rho(s,imm_scr)) / FVsize

        ! ... normalized with the total density ...
      rho_sum(1) = (sum(abs(rho(s,edg))) + sum(rho_sum_nbr(1,s,:))) / (1.0_pREAL + nRealNeighbors)
      rho_sum(2) = (sum(abs(rho(s,scr))) + sum(rho_sum_nbr(2,s,:))) / (1.0_pREAL + nRealNeighbors)

      rhoExcessGradient_over_rho = 0.0_pREAL
      where(rho_sum > 0.0_pREAL) rhoExcessGradient_over_rho = rhoExcessGradient / rho_sum

        ! ... gives the local stress correction when multiplied with a factor
      dst%tau_back(s,en) = - mu * prm%b_sl(s) / (2.0_pREAL * PI) &
                         * (  rhoExcessGradient_over_rho(1) / (1.0_pREAL - nu) &
                            + rhoExcessGradient_over_rho(2))
    end do
  end if

 end associate

end subroutine nonlocal_dependentState


!--------------------------------------------------------------------------------------------------
!> @brief calculates plastic velocity gradient and its tangent
!--------------------------------------------------------------------------------------------------
module subroutine nonlocal_LpAndItsTangent(Lp,dLp_dMp, &
                                                   Mp,ph,en)
  real(pREAL), dimension(3,3), intent(out) :: &
    Lp                                                                                              !< plastic velocity gradient
  real(pREAL), dimension(3,3,3,3), intent(out) :: &
    dLp_dMp
  integer, intent(in) :: &
    ph, &
    en
  real(pREAL), dimension(3,3), intent(in) :: &
    Mp
                                                                                                    !< derivative of Lp with respect to Mp
  integer :: &
    i, j, k, l, &
    t, &                                                                                            !< dislocation type
    s                                                                                               !< index of my current slip system
  real(pREAL), dimension(param(ph)%sum_N_sl,8) :: &
    rho_sgl                                                                                          !< single dislocation densities (including blocked)
  real(pREAL), dimension(param(ph)%sum_N_sl,10) :: &
    rho
  real(pREAL), dimension(param(ph)%sum_N_sl,4) :: &
    v, &                                                                                            !< velocity
    tauNS, &                                                                                        !< resolved shear stress including non Schmid and backstress terms
    dv_dtau, &                                                                                      !< velocity derivative with respect to the shear stress
    dv_dtauNS                                                                                       !< velocity derivative with respect to the shear stress
  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    tau, &                                                                                          !< resolved shear stress including backstress terms
    dot_gamma                                                                                       !< shear rate
  real(pREAL) :: &
    Temperature                                                                                     !< temperature


  Temperature = thermal_T(ph,en)
  Lp = 0.0_pREAL
  dLp_dMp = 0.0_pREAL

  associate(prm => param(ph),dst=>dependentState(ph),stt=>state(ph))

    !*** shortcut to state variables
    rho = getRho(ph,en)
    rho_sgl = rho(:,sgl)

    do s = 1,prm%sum_N_sl
      tau(s) = math_tensordot(Mp, prm%P_sl(1:3,1:3,s))
      tauNS(s,1) = tau(s)
      tauNS(s,2) = tau(s)
      if (tau(s) > 0.0_pREAL) then
        tauNS(s,3) = math_tensordot(Mp, +prm%P_nS_pos(1:3,1:3,s))
        tauNS(s,4) = math_tensordot(Mp, -prm%P_nS_neg(1:3,1:3,s))
      else
        tauNS(s,3) = math_tensordot(Mp, +prm%P_nS_neg(1:3,1:3,s))
        tauNS(s,4) = math_tensordot(Mp, -prm%P_nS_pos(1:3,1:3,s))
      end if
    end do
    tauNS = tauNS + spread(dst%tau_back(:,en),2,4)
    tau   = tau   + dst%tau_back(:,en)

    ! edges
    call kinetics(v(:,1), dv_dtau(:,1), dv_dtauNS(:,1), &
                  tau, tauNS(:,1), dst%tau_pass(:,en),1,Temperature, ph)
    v(:,2)         = v(:,1)
    dv_dtau(:,2)   = dv_dtau(:,1)
    dv_dtauNS(:,2) = dv_dtauNS(:,1)

    !screws
    do t = 3,4
      call kinetics(v(:,t), dv_dtau(:,t), dv_dtauNS(:,t), &
                    tau, tauNS(:,t), dst%tau_pass(:,en),2,Temperature, ph)
    end do

    stt%v(:,en) = pack(v,.true.)

    !*** Bauschinger effect
    forall (s = 1:prm%sum_N_sl, t = 5:8, rho_sgl(s,t) * v(s,t-4) < 0.0_pREAL) &
      rho_sgl(s,t-4) = rho_sgl(s,t-4) + abs(rho_sgl(s,t))

    dot_gamma = sum(rho_sgl(:,1:4) * v, 2) * prm%b_sl

    do s = 1,prm%sum_N_sl
      Lp = Lp + dot_gamma(s) * prm%P_sl(1:3,1:3,s)
      forall (i=1:3,j=1:3,k=1:3,l=1:3) &
        dLp_dMp(i,j,k,l) = dLp_dMp(i,j,k,l) &
            + prm%P_sl(i,j,s) * prm%P_sl(k,l,s) &
            * sum(rho_sgl(s,1:4) * dv_dtau(s,1:4)) * prm%b_sl(s) &
            + prm%P_sl(i,j,s) &
            * (+ prm%P_nS_pos(k,l,s) * rho_sgl(s,3) * dv_dtauNS(s,3) &
               - prm%P_nS_neg(k,l,s) * rho_sgl(s,4) * dv_dtauNS(s,4))  * prm%b_sl(s)
    end do

  end associate

end subroutine nonlocal_LpAndItsTangent


!--------------------------------------------------------------------------------------------------
!> @brief (instantaneous) incremental change of microstructure
!--------------------------------------------------------------------------------------------------
module subroutine plastic_nonlocal_deltaState(Mp,ph,en)

  real(pREAL), dimension(3,3), intent(in) :: &
    Mp                                                                                              !< MandelStress
  integer, intent(in) :: &
    ph, &
    en

  integer :: &
    c, &                                                                                            ! character of dislocation
    t, &                                                                                            ! type of dislocation
    s                                                                                               ! index of my current slip system
  real(pREAL) :: &
    mu, &
    nu
  real(pREAL), dimension(param(ph)%sum_N_sl,10) :: &
    deltaRhoRemobilization, &                                                                       ! density increment by remobilization
    deltaRhoDipole2SingleStress                                                                     ! density increment by dipole dissociation (by stress change)
  real(pREAL), dimension(param(ph)%sum_N_sl,10) :: &
    rho                                                                                             ! current  dislocation densities
  real(pREAL), dimension(param(ph)%sum_N_sl,4) :: &
    v                                                                                               ! dislocation glide velocity
  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    tau                                                                                             ! current resolved shear stress
  real(pREAL), dimension(param(ph)%sum_N_sl,2) :: &
    rho_dip, &                                                                                      ! current dipole dislocation densities (screw and edge dipoles)
    dUpper, &                                                                                       ! current maximum stable dipole distance for edges and screws
    dUpperOld, &                                                                                    ! old maximum stable dipole distance for edges and screws
    deltaDUpper                                                                                     ! change in maximum stable dipole distance for edges and screws


  associate(prm => param(ph),dst => dependentState(ph),del => deltaState(ph), stt=>state(ph))

  mu = elastic_mu(ph,en,prm%isotropic_bound)
  nu = elastic_nu(ph,en,prm%isotropic_bound)

  !*** shortcut to state variables
  v = reshape(stt%v(:,en),[prm%sum_N_sl,4])
  dUpperOld = reshape(dst%max_dipole_height(:,en),[prm%sum_N_sl,2])

  rho =  getRho(ph,en)
  rho_dip = rho(:,dip)

  !****************************************************************************
  !*** dislocation remobilization (bauschinger effect)
  where(rho(:,imm) * v < 0.0_pREAL)
    deltaRhoRemobilization(:,mob) = abs(rho(:,imm))
    deltaRhoRemobilization(:,imm) =   - rho(:,imm)
    rho(:,mob) = rho(:,mob) + abs(rho(:,imm))
    rho(:,imm) = 0.0_pREAL
  elsewhere
    deltaRhoRemobilization(:,mob) = 0.0_pREAL
    deltaRhoRemobilization(:,imm) = 0.0_pREAL
  endwhere
  deltaRhoRemobilization(:,dip) = 0.0_pREAL

  !****************************************************************************
  !*** calculate dipole formation and dissociation by stress change

  !*** calculate limits for stable dipole height
  do s = 1,prm%sum_N_sl
    tau(s) = math_tensordot(Mp, prm%P_sl(1:3,1:3,s)) +dst%tau_back(s,en)
    if (abs(tau(s)) < 1.0e-15_pREAL) tau(s) = 1.0e-15_pREAL
  end do

  dUpper(:,1) = mu * prm%b_sl/(8.0_pREAL * PI * (1.0_pREAL - nu) * abs(tau))
  dUpper(:,2) = mu * prm%b_sl/(4.0_pREAL * PI * abs(tau))

  where(dNeq0(sqrt(sum(abs(rho(:,edg)),2)))) &
    dUpper(:,1) = min(1.0_pREAL/sqrt(sum(abs(rho(:,edg)),2)),dUpper(:,1))
  where(dNeq0(sqrt(sum(abs(rho(:,scr)),2)))) &
    dUpper(:,2) = min(1.0_pREAL/sqrt(sum(abs(rho(:,scr)),2)),dUpper(:,2))

  dUpper = max(dUpper,prm%minDipoleHeight)
  deltaDUpper = dUpper - dUpperOld


  !*** dissociation by stress increase
  deltaRhoDipole2SingleStress = 0.0_pREAL
  forall (c=1:2, s=1:prm%sum_N_sl, deltaDUpper(s,c) < 0.0_pREAL .and. &
                                          dNeq0(dUpperOld(s,c) - prm%minDipoleHeight(s,c))) &
    deltaRhoDipole2SingleStress(s,8+c) = rho_dip(s,c) * deltaDUpper(s,c) &
                                       / (dUpperOld(s,c) - prm%minDipoleHeight(s,c))

  forall (t=1:4) deltaRhoDipole2SingleStress(:,t) = -0.5_pREAL * deltaRhoDipole2SingleStress(:,(t-1)/2+9)
  dst%max_dipole_height(:,en) = pack(dUpper,.true.)

  plasticState(ph)%deltaState(:,en) = 0.0_pREAL
  del%rho(:,en) = reshape(deltaRhoRemobilization + deltaRhoDipole2SingleStress, [10*prm%sum_N_sl])

  end associate

end subroutine plastic_nonlocal_deltaState


!---------------------------------------------------------------------------------------------------
!> @brief calculates the rate of change of microstructure
!---------------------------------------------------------------------------------------------------
module subroutine nonlocal_dotState(Mp,Delta_t, &
                                    ph,en)

  real(pREAL), dimension(3,3), intent(in) :: &
    Mp                                                                                              !< MandelStress
  real(pREAL), intent(in) :: &
    Delta_T                                                                                        !< substepped crystallite time increment
  integer, intent(in) :: &
    ph, &
    en

  integer ::  &
    c, &                                                                                            !< character of dislocation
    s                                                                                               !< index of my current slip system
  real(pREAL), dimension(param(ph)%sum_N_sl,10) :: &
    rho, &
    rhoDot, &                                                                                       !< density evolution
    rhoDotMultiplication, &                                                                         !< density evolution by multiplication
    rhoDotSingle2DipoleGlide, &                                                                     !< density evolution by dipole formation (by glide)
    rhoDotAthermalAnnihilation, &                                                                   !< density evolution by athermal annihilation
    rhoDotThermalAnnihilation                                                                       !< density evolution by thermal annihilation
  real(pREAL), dimension(param(ph)%sum_N_sl,8) :: &
    rho_sgl                                                                                         !< current single dislocation densities (positive/negative screw and edge without dipoles)
  real(pREAL), dimension(param(ph)%sum_N_sl,4) :: &
    v, &                                                                                            !< current dislocation glide velocity
    dot_gamma                                                                                       !< shear rates
  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    tau, &                                                                                          !< current resolved shear stress
    v_climb                                                                                         !< climb velocity of edge dipoles
  real(pREAL), dimension(param(ph)%sum_N_sl,2) :: &
    rho_dip, &                                                                                      !< current dipole dislocation densities (screw and edge dipoles)
    dLower, &                                                                                       !< minimum stable dipole distance for edges and screws
    dUpper                                                                                          !< current maximum stable dipole distance for edges and screws
  real(pREAL) :: &
    D_SD, &
    mu, &
    nu, Temperature

  if (Delta_T <= 0.0_pREAL) then
    plasticState(ph)%dotState = 0.0_pREAL
    return
  end if

  associate(prm => param(ph), dst => dependentState(ph), dot => dotState(ph), &
            stt => state(ph), st0 => state0(ph))

  mu = elastic_mu(ph,en,prm%isotropic_bound)
  nu = elastic_nu(ph,en,prm%isotropic_bound)
  Temperature = thermal_T(ph,en)

  tau = 0.0_pREAL
  dot_gamma = 0.0_pREAL

  rho = getRho(ph,en)
  rho_sgl = rho(:,sgl)
  rho_dip = rho(:,dip)

  v = reshape(stt%v(:,en),[prm%sum_N_sl,4])
  dot_gamma = rho_sgl(:,1:4) * v * spread(prm%b_sl,2,4)


  ! limits for stable dipole height
  do s = 1,prm%sum_N_sl
    tau(s) = math_tensordot(Mp, prm%P_sl(1:3,1:3,s)) + dst%tau_back(s,en)
    if (abs(tau(s)) < 1.0e-15_pREAL) tau(s) = 1.0e-15_pREAL
  end do

  dLower = prm%minDipoleHeight
  dUpper(:,1) = mu * prm%b_sl/(8.0_pREAL * PI * (1.0_pREAL - nu) * abs(tau))
  dUpper(:,2) = mu * prm%b_sl/(4.0_pREAL * PI * abs(tau))

  where(dNeq0(sqrt(sum(abs(rho(:,edg)),2)))) &
    dUpper(:,1) = min(1.0_pREAL/sqrt(sum(abs(rho(:,edg)),2)),dUpper(:,1))
  where(dNeq0(sqrt(sum(abs(rho(:,scr)),2)))) &
    dUpper(:,2) = min(1.0_pREAL/sqrt(sum(abs(rho(:,scr)),2)),dUpper(:,2))

  dUpper = max(dUpper,dLower)


  ! dislocation multiplication
  rhoDotMultiplication = 0.0_pREAL
  isBCC: if (phase_lattice(ph) == 'cI') then
    forall (s = 1:prm%sum_N_sl, sum(abs(v(s,1:4))) > 0.0_pREAL)
      rhoDotMultiplication(s,1:2) = sum(abs(dot_gamma(s,3:4))) / prm%b_sl(s) &                      ! assuming double-cross-slip of screws to be decisive for multiplication
                                  * sqrt(dst%rho_forest(s,en)) / prm%i_sl(s) ! &                    ! mean free path
                                  ! * 2.0_pREAL * sum(abs(v(s,3:4))) / sum(abs(v(s,1:4)))           ! ratio of screw to overall velocity determines edge generation
      rhoDotMultiplication(s,3:4) = sum(abs(dot_gamma(s,3:4))) /prm%b_sl(s) &                       ! assuming double-cross-slip of screws to be decisive for multiplication
                                  * sqrt(dst%rho_forest(s,en)) / prm%i_sl(s) ! &                    ! mean free path
                                  ! * 2.0_pREAL * sum(abs(v(s,1:2))) / sum(abs(v(s,1:4)))           ! ratio of edge to overall velocity determines screw generation
    endforall

  else isBCC
    rhoDotMultiplication(:,1:4) = spread( &
          (sum(abs(dot_gamma(:,1:2)),2) * prm%f_ed_mult + sum(abs(dot_gamma(:,3:4)),2)) &
        * sqrt(dst%rho_forest(:,en)) / prm%i_sl / prm%b_sl, 2, 4)                                   ! eq. 3.26
  end if isBCC


  !****************************************************************************
  ! dipole formation and annihilation

  ! formation by glide
  do c = 1,2
    rhoDotSingle2DipoleGlide(:,2*c-1) = -2.0_pREAL * dUpper(:,c) / prm%b_sl &
                                                   * (      rho_sgl(:,2*c-1)  * abs(dot_gamma(:,2*c)) &   ! negative mobile --> positive mobile
                                                      +     rho_sgl(:,2*c)    * abs(dot_gamma(:,2*c-1)) & ! positive mobile --> negative mobile
                                                      + abs(rho_sgl(:,2*c+4)) * abs(dot_gamma(:,2*c-1)))  ! positive mobile --> negative immobile

    rhoDotSingle2DipoleGlide(:,2*c) = -2.0_pREAL * dUpper(:,c) / prm%b_sl &
                                                 * (      rho_sgl(:,2*c-1)  * abs(dot_gamma(:,2*c)) &     ! negative mobile --> positive mobile
                                                    +     rho_sgl(:,2*c)    * abs(dot_gamma(:,2*c-1)) &   ! positive mobile --> negative mobile
                                                    + abs(rho_sgl(:,2*c+3)) * abs(dot_gamma(:,2*c)))      ! negative mobile --> positive immobile

    rhoDotSingle2DipoleGlide(:,2*c+3) = -2.0_pREAL * dUpper(:,c) / prm%b_sl &
                                                   * rho_sgl(:,2*c+3) * abs(dot_gamma(:,2*c))             ! negative mobile --> positive immobile

    rhoDotSingle2DipoleGlide(:,2*c+4) = -2.0_pREAL * dUpper(:,c) / prm%b_sl &
                                                   * rho_sgl(:,2*c+4) * abs(dot_gamma(:,2*c-1))           ! positive mobile --> negative immobile

    rhoDotSingle2DipoleGlide(:,c+8) = abs(rhoDotSingle2DipoleGlide(:,2*c+3)) &
                                    + abs(rhoDotSingle2DipoleGlide(:,2*c+4)) &
                                    - rhoDotSingle2DipoleGlide(:,2*c-1) &
                                    - rhoDotSingle2DipoleGlide(:,2*c)
  end do


  ! athermal annihilation
  rhoDotAthermalAnnihilation = 0.0_pREAL
  forall (c=1:2) &
    rhoDotAthermalAnnihilation(:,c+8) = -2.0_pREAL * dLower(:,c) / prm%b_sl &
       * (  2.0_pREAL * (rho_sgl(:,2*c-1) * abs(dot_gamma(:,2*c)) + rho_sgl(:,2*c) * abs(dot_gamma(:,2*c-1))) & ! was single hitting single
          + 2.0_pREAL * (abs(rho_sgl(:,2*c+3)) * abs(dot_gamma(:,2*c)) + abs(rho_sgl(:,2*c+4)) * abs(dot_gamma(:,2*c-1))) & ! was single hitting immobile single or was immobile single hit by single
          + rho_dip(:,c) * (abs(dot_gamma(:,2*c-1)) + abs(dot_gamma(:,2*c))))                                  ! single knocks dipole constituent

  ! annihilated screw dipoles leave edge jogs behind on the colinear system
  if (phase_lattice(ph) == 'cF') &
    forall (s = 1:prm%sum_N_sl, prm%colinearSystem(s) > 0) &
      rhoDotAthermalAnnihilation(prm%colinearSystem(s),1:2) = - rhoDotAthermalAnnihilation(s,10) &
        * 0.25_pREAL * sqrt(dst%rho_forest(s,en)) * (dUpper(s,2) + dLower(s,2)) * prm%f_ed


  ! thermally activated annihilation of edge dipoles by climb
  rhoDotThermalAnnihilation = 0.0_pREAL
  D_SD = prm%D_0 * exp(-prm%Q_cl / (K_B * Temperature))                                              ! eq. 3.53
  v_climb = D_SD * mu * prm%V_at &
          / (PI * (1.0_pREAL-nu) * (dUpper(:,1) + dLower(:,1)) * K_B * Temperature)              ! eq. 3.54
  forall (s = 1:prm%sum_N_sl, dUpper(s,1) > dLower(s,1)) &
    rhoDotThermalAnnihilation(s,9) = max(- 4.0_pREAL * rho_dip(s,1) * v_climb(s) / (dUpper(s,1) - dLower(s,1)), &
                                         - rho_dip(s,1) / Delta_T - rhoDotAthermalAnnihilation(s,9) &
                                                                  - rhoDotSingle2DipoleGlide(s,9))  ! make sure that we do not annihilate more dipoles than we have

  rhoDot = rhoDotFlux(Delta_T, ph,en) &
         + rhoDotMultiplication &
         + rhoDotSingle2DipoleGlide &
         + rhoDotAthermalAnnihilation &
         + rhoDotThermalAnnihilation


  if (    any(rho(:,mob) + rhoDot(:,1:4)  * Delta_T < -prm%atol_rho) &
     .or. any(rho(:,dip) + rhoDot(:,9:10) * Delta_T < -prm%atol_rho)) then
    plasticState(ph)%dotState = IEEE_value(1.0_pREAL,IEEE_quiet_NaN)
  else
    dot%rho(:,en) = pack(rhoDot,.true.)
    dot%gamma(:,en) = sum(dot_gamma,2)
  end if

  end associate

end subroutine nonlocal_dotState


!---------------------------------------------------------------------------------------------------
!> @brief calculates the rate of change of microstructure
!---------------------------------------------------------------------------------------------------
#if __INTEL_COMPILER >= 2020
non_recursive function rhoDotFlux(Delta_T,ph,en)
#else
function rhoDotFlux(Delta_T,ph,en)
#endif
  real(pREAL), intent(in) :: &
    Delta_T                                                                                        !< substepped crystallite time increment
  integer, intent(in) :: &
    ph, &
    en

  integer ::  &
    ns, &                                                                                           !< short notation for the total number of active slip systems
    c, &                                                                                            !< character of dislocation
    n, &                                                                                            !< index of my current neighbor
    el_nbr, &                                                                                       !< element number of my neighbor
    ip_nbr, &                                                                                       !< integration point of my neighbor
    n_nbr, &                                                                                        !< neighbor index pointing to en when looking from my neighbor
    opposite_neighbor, &                                                                            !< index of my opposite neighbor
    opposite_ip, &                                                                                  !< ip of my opposite neighbor
    opposite_el, &                                                                                  !< element index of my opposite neighbor
    opposite_n, &                                                                                   !< neighbor index pointing to en when looking from my opposite neighbor
    t, &                                                                                            !< type of dislocation
    en_nbr,&                                                                                        !< neighbor phase entry
    ph_nbr,&                                                                                        !< neighbor phase ID
    topp, &                                                                                         !< type of dislocation with opposite sign to t
    s                                                                                               !< index of my current slip system
  real(pREAL), dimension(param(ph)%sum_N_sl,10) :: &
    rho, &
    rho_0, &                                                                                        !< dislocation density at beginning of time step
    rhoDotFlux                                                                                      !< density evolution by flux
  real(pREAL), dimension(param(ph)%sum_N_sl,4) :: &
    rho_0_sgl_mob, &                                                                                !< mobile dislocation densities of neighboring ip (positive/negative screw and edge)
    rho_0_sgl_mob_nbr, &                                                                            !< mobile dislocation densities of neighboring ip (positive/negative screw and edge)
    v, &                                                                                            !< dislocation glide velocity
    v_0, &
    v_0_nbr, &                                                                                      !< dislocation glide velocity of enighboring ip
    dot_gamma                                                                                       !< shear rates
  real(pREAL), dimension(3,param(ph)%sum_N_sl,4) :: &
    m                                                                                               !< direction of dislocation motion
  real(pREAL), dimension(3,3) :: &
    my_F, &                                                                                         !< my total deformation gradient
    F_nbr, &                                                                                        !< total deformation gradient of my neighbor
    my_Fe, &                                                                                        !< my elastic deformation gradient
    F_e_nbr, &                                                                                      !< elastic deformation gradient of my neighbor
    Favg                                                                                            !< average total deformation gradient of en and my neighbor
  real(pREAL), dimension(3) :: &
    normal_neighbor2me, &                                                                           !< interface normal pointing from my neighbor to en in neighbor's lattice configuration
    normal_neighbor2me_defConf, &                                                                   !< interface normal pointing from my neighbor to en in shared deformed configuration
    normal_me2neighbor, &                                                                           !< interface normal pointing from en to my neighbor in my lattice configuration
    normal_me2neighbor_defConf                                                                      !< interface normal pointing from en to my neighbor in shared deformed configuration
  real(pREAL) :: &
    a, &                                                                                            !< area of the current interface
    transmissivity, &                                                                               !< overall transmissivity of dislocation flux to neighboring material point
    lineLength                                                                                      !< dislocation line length leaving the current interface


  associate(prm => param(ph), &
            dst => dependentState(ph), &
            stt => state(ph), &
            st0 => state0(ph))

  ns = prm%sum_N_sl

  dot_gamma = 0.0_pREAL

  rho = getRho(ph,en)
  rho_0 = getRho0(ph,en)
  rho_0_sgl_mob = rho_0(:,mob)

  v = reshape(stt%v(:,en),[prm%sum_N_sl,4])                                                         !ToDo: MD: I think we should use state0 here
  dot_gamma = rho(:,mob) * v * spread(prm%b_sl,2,4)

  v_0 = reshape(st0%v(:,en),[prm%sum_N_sl,4])

  !****************************************************************************
  !*** calculate dislocation fluxes (only for nonlocal plasticity)
  rhoDotFlux = 0.0_pREAL
  if (plasticState(ph)%nonlocal) then

    !*** check CFL (Courant-Friedrichs-Lewy) condition for flux
    if (any( abs(dot_gamma) > 0.0_pREAL &                                                           ! any active slip system ...
            .and. prm%C_CFL * abs(v_0) * Delta_T &
                > geom(ph)%v_0(en)/ maxval(geom(ph)%a_0(:,en)))) then                               ! ...with velocity above critical value (we use the reference volume and area for simplicity here)
      rhoDotFlux = IEEE_value(1.0_pREAL,IEEE_quiet_NaN)                                             ! enforce cutback
      return
    end if


    !*** be aware of the definition of slip_transverse = slip_direction x slip_normal !!!
    !*** opposite sign to our t vector in the (s,t,n) triplet !!!

    m(1:3,:,1) =  prm%slip_direction
    m(1:3,:,2) = -prm%slip_direction
    m(1:3,:,3) = -prm%slip_transverse
    m(1:3,:,4) =  prm%slip_transverse

    my_F = phase_mechanical_F(ph)%data(1:3,1:3,en)
    my_Fe = matmul(my_F, math_inv33(phase_mechanical_Fp(ph)%data(1:3,1:3,en)))

    neighbors: do n = 1,nCellNeighbors

      el_nbr = geom(ph)%IPneighborhood(1,n,en)
      ip_nbr = geom(ph)%IPneighborhood(2,n,en)
      n_nbr  = geom(ph)%IPneighborhood(3,n,en)
      ph_nbr = material_ID_phase(1,(el_nbr-1)*discretization_nIPs + ip_nbr)
      en_nbr = material_entry_phase(1,(el_nbr-1)*discretization_nIPs + ip_nbr)

      opposite_neighbor = n + mod(n,2) - mod(n+1,2)
      opposite_el = geom(ph)%IPneighborhood(1,opposite_neighbor,en)
      opposite_ip = geom(ph)%IPneighborhood(2,opposite_neighbor,en)
      opposite_n  = geom(ph)%IPneighborhood(3,opposite_neighbor,en)

      if (n_nbr > 0) then                                                                           ! if neighbor exists, average deformation gradient
        F_nbr = phase_mechanical_F(ph_nbr)%data(1:3,1:3,en_nbr)
        F_e_nbr = matmul(F_nbr, math_inv33(phase_mechanical_Fp(ph_nbr)%data(1:3,1:3,en_nbr)))
        Favg = 0.5_pREAL * (my_F + F_nbr)
      else                                                                                          ! if no neighbor, take my value as average
        Favg = my_F
      end if

      v_0_nbr = 0.0_pREAL        ! needed for check of sign change in flux density below

      !* FLUX FROM MY NEIGHBOR TO ME
      !* This is only considered, if I have a neighbor of nonlocal plasticity
      !* (also nonlocal constitutive law with local properties) that is at least a little bit
      !* compatible.
      !* If it's not at all compatible, no flux is arriving, because everything is dammed in front of
      !* my neighbor's interface.
      !* The entering flux from my neighbor will be distributed on my slip systems according to the
      !* compatibility
      if (n_nbr > 0) then
      if (mechanical_plasticity_type(ph_nbr) == MECHANICAL_PLASTICITY_NONLOCAL .and. &
          any(dependentState(ph)%compatibility(:,:,:,n,en) > 0.0_pREAL)) then

        ! ToDo MD: Not sure if ns is correct here, but I think that compatibility is 0 if different phase
        v_0_nbr = reshape(state0(ph_nbr)%v(:,en_nbr),[ns,4])
        rho_0_sgl_mob_nbr = max(reshape(state0(ph_nbr)%rho_sgl_mob(:,en_nbr),[ns,4]),0.0_pREAL)

        where (rho_0_sgl_mob_nbr * geom(ph_nbr)%v_0(en_nbr) ** 0.667_pREAL < prm%rho_min &
          .or. rho_0_sgl_mob_nbr < prm%rho_significant) &
          rho_0_sgl_mob_nbr = 0.0_pREAL
        normal_neighbor2me_defConf = math_det33(Favg) * matmul(math_inv33(transpose(Favg)), &
                                     geom(ph_nbr)%n_0(1:3,n_nbr,en_nbr))                            ! normal of the interface in (average) deformed configuration (pointing neighbor => en)
        normal_neighbor2me = matmul(transpose(F_e_nbr), normal_neighbor2me_defConf) &
                           / math_det33(F_e_nbr)                                                    ! interface normal in the lattice configuration of my neighbor
        a = geom(ph_nbr)%a_0(n_nbr,en_nbr) * norm2(normal_neighbor2me)
        normal_neighbor2me = normal_neighbor2me / norm2(normal_neighbor2me)                         ! normalize the surface normal to unit length
        do s = 1,ns
          do t = 1,4
            c = (t + 1) / 2
            topp = t + mod(t,2) - mod(t+1,2)
            if (v_0_nbr(s,t) * math_inner(m(1:3,s,t), normal_neighbor2me) > 0.0_pREAL &             ! flux from my neighbor to en == entering flux for en
                .and. v_0(s,t) * v_0_nbr(s,t) >= 0.0_pREAL ) then                                   ! ... only if no sign change in flux density
              lineLength = rho_0_sgl_mob_nbr(s,t) * v_0_nbr(s,t) &
                         * math_inner(m(1:3,s,t), normal_neighbor2me) * a                           ! positive line length that wants to enter through this interface
              where (dependentState(ph)%compatibility(c,:,s,n,en) > 0.0_pREAL) &
                rhoDotFlux(:,t) = rhoDotFlux(1:ns,t) &
                                + lineLength/geom(ph)%v_0(en)*dependentState(ph)%compatibility(c,:,s,n,en)**2        ! transferring to equally signed mobile dislocation type
              where (dependentState(ph)%compatibility(c,:,s,n,en) < 0.0_pREAL) &
                rhoDotFlux(:,topp) = rhoDotFlux(:,topp) &
                                   + lineLength/geom(ph)%v_0(en)*dependentState(ph)%compatibility(c,:,s,n,en)**2     ! transferring to opposite signed mobile dislocation type

            end if
          end do
        end do
      end if; end if


      !* FLUX FROM ME TO MY NEIGHBOR
      !* This is not considered, if my opposite neighbor has a different constitutive law than nonlocal (still considered for nonlocal law with local properties).
      !* Then, we assume, that the opposite(!) neighbor sends an equal amount of dislocations to en.
      !* So the net flux in the direction of my neighbor is equal to zero:
      !*    leaving flux to neighbor == entering flux from opposite neighbor
      !* In case of reduced transmissivity, part of the leaving flux is stored as dead dislocation density.
      !* That means for an interface of zero transmissivity the leaving flux is fully converted to dead dislocations.
      if (opposite_n > 0) then
      if (mechanical_plasticity_type(ph_nbr) == MECHANICAL_PLASTICITY_NONLOCAL) then

        normal_me2neighbor_defConf = math_det33(Favg) &
                                   * matmul(math_inv33(transpose(Favg)),geom(ph)%n_0(1:3,n,en))  ! normal of the interface in (average) deformed configuration (pointing en => neighbor)
        normal_me2neighbor = matmul(transpose(my_Fe), normal_me2neighbor_defConf) &
                           / math_det33(my_Fe)                                                      ! interface normal in my lattice configuration
        a = geom(ph)%a_0(n,en) * norm2(normal_me2neighbor)
        normal_me2neighbor = normal_me2neighbor / norm2(normal_me2neighbor)                         ! normalize the surface normal to unit length
        do s = 1,ns
          do t = 1,4
            c = (t + 1) / 2
            if (v_0(s,t) * math_inner(m(1:3,s,t), normal_me2neighbor) > 0.0_pREAL ) then             ! flux from en to my neighbor == leaving flux for en (might also be a pure flux from my mobile density to dead density if interface not at all transmissive)
              if (v_0(s,t) * v_0_nbr(s,t) >= 0.0_pREAL) then                                         ! no sign change in flux density
                transmissivity = sum(dependentState(ph)%compatibility(c,:,s,n,en)**2)               ! overall transmissivity from this slip system to my neighbor
              else                                                                                  ! sign change in flux density means sign change in stress which does not allow for dislocations to arive at the neighbor
                transmissivity = 0.0_pREAL
              end if
              lineLength = rho_0_sgl_mob(s,t) * v_0(s,t) &
                         * math_inner(m(1:3,s,t), normal_me2neighbor) * a                           ! positive line length of mobiles that wants to leave through this interface
              rhoDotFlux(s,t) = rhoDotFlux(s,t) - lineLength / geom(ph)%v_0(en)                     ! subtract dislocation flux from current type
              rhoDotFlux(s,t+4) = rhoDotFlux(s,t+4) &
                                + lineLength / geom(ph)%v_0(en) * (1.0_pREAL - transmissivity) &
                                * sign(1.0_pREAL, v_0(s,t))                                          ! dislocation flux that is not able to leave through interface (because of low transmissivity) will remain as immobile single density at the material point
            end if
          end do
        end do
      end if; end if

    end do neighbors
  end if

  end associate

end function rhoDotFlux


!--------------------------------------------------------------------------------------------------
!> @brief Compatibility update
!> @detail Compatibility is defined as normalized product of signed cosine of the angle between the slip
! plane normals and signed cosine of the angle between the slip directions. Only the largest values
! that sum up to a total of 1 are considered, all others are set to zero.
!--------------------------------------------------------------------------------------------------
module subroutine plastic_nonlocal_updateCompatibility(orientation,ph,en)

  type(tRotationContainer), dimension(:), intent(in) :: &
    orientation                                                                                     ! crystal orientation
  integer, intent(in) :: &
    ph, en

  integer :: &
    n, &                                                                                            ! neighbor index
    el_nbr, &                                                                                   ! element index of my neighbor
    ip_nbr, &                                                                                   ! integration point index of my neighbor
    ce_nbr, &
    en_nbr, &
    ph_nbr, &
    ns, &                                                                                           ! number of active slip systems
    s1, &                                                                                           ! slip system index (en)
    s2                                                                                              ! slip system index (my neighbor)
  real(pREAL), dimension(2,param(ph)%sum_N_sl,param(ph)%sum_N_sl,nCellNeighbors) :: &
    my_compatibility                                                                                ! my_compatibility for current element and ip
  real(pREAL) :: &
    my_compatibilitySum, &
    thresholdValue, &
    nThresholdValues
  logical, dimension(param(ph)%sum_N_sl) :: &
    belowThreshold
  type(tRotation) :: mis


  associate(prm => param(ph))
    ns = prm%sum_N_sl

    !*** start out fully compatible
    my_compatibility = 0.0_pREAL
    forall(s1 = 1:ns) my_compatibility(:,s1,s1,:) = 1.0_pREAL

    neighbors: do n = 1,nCellNeighbors
      el_nbr = geom(ph)%IPneighborhood(1,n,en)
      ip_nbr = geom(ph)%IPneighborhood(2,n,en)
      ce_nbr = (el_nbr-1)*discretization_nIPs + ip_nbr
      en_nbr = material_entry_phase(1,ce_nbr)
      ph_nbr = material_ID_phase(1,ce_nbr)

      if (ce_nbr <= 0) then                                                                         ! free surface
        forall(s1 = 1:ns) my_compatibility(:,s1,s1,n) = sqrt(prm%chi_surface)
      elseif (ph_nbr /= ph) then                                                                    ! phase boundary
        if (plasticState(ph_nbr)%nonlocal .and. plasticState(ph)%nonlocal) &
          forall(s1 = 1:ns) my_compatibility(:,s1,s1,n) = 0.0_pREAL
      elseif (prm%chi_GB >= 0.0_pREAL) then                                                         ! grain boundary
        if (any(dNeq(phase_O_0(ph)%data(en)%asQuaternion(), &
                     phase_O_0(ph_nbr)%data(en_nbr)%asQuaternion())) .and. &
            plasticState(ph_nbr)%nonlocal) &
          forall(s1 = 1:ns) my_compatibility(:,s1,s1,n) = sqrt(prm%chi_GB)
      else
        !* GRAIN BOUNDARY ?
        !* Compatibility defined by relative orientation of slip systems:
        !* The my_compatibility value is defined as the product of the slip normal projection and the slip direction projection.
        !* Its sign is always positive for screws, for edges it has the same sign as the slip normal projection.
        !* Since the sum for each slip system can easily exceed one (which would result in a transmissivity larger than one),
        !* only values above or equal to a certain threshold value are considered. This threshold value is chosen, such that
        !* the number of compatible slip systems is minimized with the sum of the original compatibility values exceeding one.
        !* Finally the smallest compatibility value is decreased until the sum is exactly equal to one.
        !* All values below the threshold are set to zero.
        mis = orientation(ph)%data(en)%misorientation(orientation(ph_nbr)%data(en_nbr))
        mySlipSystems: do s1 = 1,ns
          neighborSlipSystems: do s2 = 1,ns
            my_compatibility(1,s2,s1,n) =     math_inner(prm%slip_normal(1:3,s1), &
                                                         mis%rotate(prm%slip_normal(1:3,s2))) &
                                        * abs(math_inner(prm%slip_direction(1:3,s1), &
                                                         mis%rotate(prm%slip_direction(1:3,s2))))
            my_compatibility(2,s2,s1,n) = abs(math_inner(prm%slip_normal(1:3,s1), &
                                                         mis%rotate(prm%slip_normal(1:3,s2)))) &
                                        * abs(math_inner(prm%slip_direction(1:3,s1), &
                                                         mis%rotate(prm%slip_direction(1:3,s2))))
          end do neighborSlipSystems

          my_compatibilitySum = 0.0_pREAL
          belowThreshold = .true.
          do while (my_compatibilitySum < 1.0_pREAL .and. any(belowThreshold))
            thresholdValue = maxval(my_compatibility(2,:,s1,n), belowThreshold)                     ! screws always positive
            nThresholdValues = real(count(my_compatibility(2,:,s1,n) >= thresholdValue),pREAL)
            where (my_compatibility(2,:,s1,n) >= thresholdValue) belowThreshold = .false.
            if (my_compatibilitySum + thresholdValue * nThresholdValues > 1.0_pREAL) &
              where (abs(my_compatibility(:,:,s1,n)) >= thresholdValue) &
                my_compatibility(:,:,s1,n) = sign((1.0_pREAL - my_compatibilitySum)/nThresholdValues,&
                                                   my_compatibility(:,:,s1,n))
            my_compatibilitySum = my_compatibilitySum + nThresholdValues * thresholdValue
          end do

          where(belowThreshold) my_compatibility(1,:,s1,n) = 0.0_pREAL
          where(belowThreshold) my_compatibility(2,:,s1,n) = 0.0_pREAL

        end do mySlipSystems
      end if

    end do neighbors

    dependentState(ph)%compatibility(:,:,:,:,en) = my_compatibility

  end associate

end subroutine plastic_nonlocal_updateCompatibility


!--------------------------------------------------------------------------------------------------
!> @brief Write results to HDF5 output file.
!--------------------------------------------------------------------------------------------------
module subroutine plastic_nonlocal_result(ph,group)

  integer,         intent(in) :: ph
  character(len=*),intent(in) :: group

  integer :: ou

  associate(prm => param(ph),dst => dependentState(ph),stt=>state(ph))

    do ou = 1,size(prm%output)

      select case(trim(prm%output(ou)))

        case('rho_u_ed_pos')
          call result_writeDataset(stt%rho_sgl_mob_edg_pos,group,trim(prm%output(ou)), &
                                   'positive mobile edge density','1/m²', prm%systems_sl)
        case('rho_b_ed_pos')
          call result_writeDataset(stt%rho_sgl_imm_edg_pos,group,trim(prm%output(ou)), &
                                   'positive immobile edge density','1/m²', prm%systems_sl)
        case('rho_u_ed_neg')
          call result_writeDataset(stt%rho_sgl_mob_edg_neg,group,trim(prm%output(ou)), &
                                   'negative mobile edge density','1/m²', prm%systems_sl)
        case('rho_b_ed_neg')
          call result_writeDataset(stt%rho_sgl_imm_edg_neg,group,trim(prm%output(ou)), &
                                   'negative immobile edge density','1/m²', prm%systems_sl)
        case('rho_d_ed')
          call result_writeDataset(stt%rho_dip_edg,group,trim(prm%output(ou)), &
                                   'edge dipole density','1/m²', prm%systems_sl)
        case('rho_u_sc_pos')
          call result_writeDataset(stt%rho_sgl_mob_scr_pos,group,trim(prm%output(ou)), &
                                   'positive mobile screw density','1/m²', prm%systems_sl)
        case('rho_b_sc_pos')
          call result_writeDataset(stt%rho_sgl_imm_scr_pos,group,trim(prm%output(ou)), &
                                   'positive immobile screw density','1/m²', prm%systems_sl)
        case('rho_u_sc_neg')
          call result_writeDataset(stt%rho_sgl_mob_scr_neg,group,trim(prm%output(ou)), &
                                   'negative mobile screw density','1/m²', prm%systems_sl)
        case('rho_b_sc_neg')
          call result_writeDataset(stt%rho_sgl_imm_scr_neg,group,trim(prm%output(ou)), &
                                   'negative immobile screw density','1/m²', prm%systems_sl)
        case('rho_d_sc')
          call result_writeDataset(stt%rho_dip_scr,group,trim(prm%output(ou)), &
                                   'screw dipole density','1/m²', prm%systems_sl)
        case('rho_f')
          call result_writeDataset(dst%rho_forest,group,trim(prm%output(ou)), &
                                   'forest density','1/m²', prm%systems_sl)
        case('v_ed_pos')
          call result_writeDataset(stt%v_edg_pos,group,trim(prm%output(ou)), &
                                   'positive edge velocity','m/s', prm%systems_sl)
        case('v_ed_neg')
          call result_writeDataset(stt%v_edg_neg,group,trim(prm%output(ou)), &
                                   'negative edge velocity','m/s', prm%systems_sl)
        case('v_sc_pos')
          call result_writeDataset(stt%v_scr_pos,group,trim(prm%output(ou)), &
                                   'positive srew velocity','m/s', prm%systems_sl)
        case('v_sc_neg')
          call result_writeDataset(stt%v_scr_neg,group,trim(prm%output(ou)), &
                                   'negative screw velocity','m/s', prm%systems_sl)
        case('gamma')
          call result_writeDataset(stt%gamma,group,trim(prm%output(ou)), &
                                   'plastic shear','1', prm%systems_sl)
        case('tau_pass')
          call result_writeDataset(dst%tau_pass,group,trim(prm%output(ou)), &
                                   'passing stress for slip','Pa', prm%systems_sl)
      end select

    end do

  end associate

end subroutine plastic_nonlocal_result


!--------------------------------------------------------------------------------------------------
!> @brief populates the initial dislocation density
!--------------------------------------------------------------------------------------------------
subroutine stateInit(ini,phase,Nentries)

  type(tInitialParameters) :: &
    ini
  integer,intent(in) :: &
    phase, &
    Nentries

  integer :: &
    e, &
    f, &
    from, &
    upto, &
    s
  real(pREAL), dimension(2) :: &
    rnd
  real(pREAL) :: &
    meanDensity, &
    totalVolume, &
    densityBinning, &
    minimumIpVolume


  associate(stt => state(phase))

    if (ini%random_rho_u > 0.0_pREAL) then ! randomly distribute dislocation segments on random slip system and of random type in the volume
      totalVolume     = sum(geom(phase)%v_0)
      minimumIPVolume = minval(geom(phase)%v_0)
      densityBinning  = ini%random_rho_u_binning / minimumIpVolume ** (2.0_pREAL / 3.0_pREAL)

      ! fill random material points with dislocation segments until the desired overall density is reached
      meanDensity = 0.0_pREAL
      do while(meanDensity < ini%random_rho_u)
        call random_number(rnd)
        e = nint(rnd(1)*real(Nentries,pREAL) + 0.5_pREAL)
        s = nint(rnd(2)*real(sum(ini%N_sl),pREAL)*4.0_pREAL + 0.5_pREAL)
        meanDensity = meanDensity + densityBinning * geom(phase)%v_0(e) / totalVolume
        stt%rho_sgl_mob(s,e) = densityBinning
      end do
    else                                ! homogeneous distribution with noise
      do f = 1,size(ini%N_sl,1)
        from = 1 + sum(ini%N_sl(1:f-1))
        upto = sum(ini%N_sl(1:f))
        call math_normal(stt%rho_sgl_mob_edg_pos(from:upto,:),ini%rho_u_ed_pos_0(f),ini%sigma_rho_u)
        call math_normal(stt%rho_sgl_mob_edg_neg(from:upto,:),ini%rho_u_ed_neg_0(f),ini%sigma_rho_u)
        call math_normal(stt%rho_sgl_mob_scr_pos(from:upto,:),ini%rho_u_sc_pos_0(f),ini%sigma_rho_u)
        call math_normal(stt%rho_sgl_mob_scr_neg(from:upto,:),ini%rho_u_sc_neg_0(f),ini%sigma_rho_u)
        stt%rho_dip_edg(from:upto,:) = ini%rho_d_ed_0(f)
        stt%rho_dip_scr(from:upto,:) = ini%rho_d_sc_0(f)
      end do
    end if

  end associate

end subroutine stateInit


!--------------------------------------------------------------------------------------------------
!> @brief calculates kinetics
!--------------------------------------------------------------------------------------------------
pure subroutine kinetics(v, dv_dtau, dv_dtauNS, tau, tauNS, tauThreshold, c, T, ph)

  integer, intent(in) :: &
    c, &                                                                                            !< dislocation character (1:edge, 2:screw)
    ph
  real(pREAL), dimension(param(ph)%sum_N_sl), intent(in) :: &
    tau, &                                                                                          !< resolved external shear stress (without non Schmid effects)
    tauNS, &                                                                                        !< resolved external shear stress (including non Schmid effects)
    tauThreshold                                                                                    !< threshold shear stress
  real(pREAL), intent(in) :: &
    T                                                                                               !< T
  real(pREAL), dimension(param(ph)%sum_N_sl), intent(out) ::  &
    v, &                                                                                            !< velocity
    dv_dtau, &                                                                                      !< velocity derivative with respect to resolved shear stress (without non Schmid contributions)
    dv_dtauNS                                                                                       !< velocity derivative with respect to resolved shear stress (including non Schmid contributions)

  integer :: &
    s                                                                                               !< index of my current slip system
  real(pREAL) :: &
    tauRel_P, &
    tauRel_S, &
    tauEff, &                                                                                       !< effective shear stress
    tPeierls, &                                                                                     !< waiting time in front of a peierls barriers
    tSolidSolution, &                                                                               !< waiting time in front of a solid solution obstacle
    dtPeierls_dtau, &                                                                               !< derivative with respect to resolved shear stress
    dtSolidSolution_dtau, &                                                                         !< derivative with respect to resolved shear stress
    lambda_S, &                                                                                     !< mean free distance between two solid solution obstacles
    lambda_P, &                                                                                     !< mean free distance between two Peierls barriers
    activationVolume_P, &                                                                           !< volume that needs to be activated to overcome barrier
    activationVolume_S, &                                                                           !< volume that needs to be activated to overcome barrier
    activationEnergy_P, &                                                                           !< energy that is needed to overcome barrier
    criticalStress_P, &                                                                             !< maximum obstacle strength
    criticalStress_S                                                                                !< maximum obstacle strength


  v = 0.0_pREAL
  dv_dtau = 0.0_pREAL
  dv_dtauNS = 0.0_pREAL

  associate(prm => param(ph))

    do s = 1,prm%sum_N_sl
      if (abs(tau(s)) > tauThreshold(s)) then

        !* Peierls contribution
        tauEff = max(0.0_pREAL, abs(tauNS(s)) - tauThreshold(s))
        lambda_P = prm%b_sl(s)
        activationVolume_P = prm%w * prm%b_sl(s)**3
        criticalStress_P = prm%peierlsStress(s,c)
        activationEnergy_P = criticalStress_P * activationVolume_P
        tauRel_P = min(1.0_pREAL, tauEff / criticalStress_P)
        tPeierls = 1.0_pREAL / prm%nu_a &
                 * exp(activationEnergy_P / (K_B * T) &
                       * (1.0_pREAL - tauRel_P**prm%p)**prm%q)
        dtPeierls_dtau = merge(tPeierls * prm%p * prm%q * activationVolume_P / (K_B * T) &
                               * (1.0_pREAL - tauRel_P**prm%p)**(prm%q-1.0_pREAL) * tauRel_P**(prm%p-1.0_pREAL), &
                               0.0_pREAL, &
                               tauEff < criticalStress_P)

        ! Contribution from solid solution strengthening
        tauEff = abs(tau(s)) - tauThreshold(s)
        lambda_S = prm%b_sl(s) / sqrt(prm%c_sol)
        activationVolume_S = prm%f_sol * prm%b_sl(s)**3 / sqrt(prm%c_sol)
        criticalStress_S = prm%Q_sol / activationVolume_S
        tauRel_S = min(1.0_pREAL, tauEff / criticalStress_S)
        tSolidSolution = 1.0_pREAL /  prm%nu_a &
                       * exp(prm%Q_sol / (K_B * T)* (1.0_pREAL - tauRel_S**prm%p)**prm%q)
        dtSolidSolution_dtau = merge(tSolidSolution * prm%p * prm%q * activationVolume_S / (K_B * T) &
                                     * (1.0_pREAL - tauRel_S**prm%p)**(prm%q-1.0_pREAL)* tauRel_S**(prm%p-1.0_pREAL), &
                                     0.0_pREAL, &
                                     tauEff < criticalStress_S)

        !* viscous glide velocity
        tauEff = abs(tau(s)) - tauThreshold(s)


        v(s) = sign(1.0_pREAL,tau(s)) &
             / (tPeierls / lambda_P + tSolidSolution / lambda_S + prm%B /(prm%b_sl(s) * tauEff))
        dv_dtau(s)   = v(s)**2 * (dtSolidSolution_dtau / lambda_S + prm%B / (prm%b_sl(s) * tauEff**2))
        dv_dtauNS(s) = v(s)**2 * dtPeierls_dtau / lambda_P

      end if
    end do

  end associate

end subroutine kinetics


!--------------------------------------------------------------------------------------------------
!> @brief returns copy of current dislocation densities from state
!> @details raw values is rectified
!--------------------------------------------------------------------------------------------------
pure function getRho(ph,en) result(rho)

  integer, intent(in) :: ph, en
  real(pREAL), dimension(param(ph)%sum_N_sl,10) :: rho


  associate(prm => param(ph))

    rho = reshape(state(ph)%rho(:,en),[prm%sum_N_sl,10])

    ! ensure positive densities (not for imm, they have a sign)
    rho(:,mob) = max(rho(:,mob),0.0_pREAL)
    rho(:,dip) = max(rho(:,dip),0.0_pREAL)

    where(abs(rho) < max(prm%rho_min/geom(ph)%v_0(en)**(2.0_pREAL/3.0_pREAL),prm%rho_significant)) &
      rho = 0.0_pREAL

  end associate

end function getRho


!--------------------------------------------------------------------------------------------------
!> @brief returns copy of current dislocation densities from state
!> @details raw values is rectified
!--------------------------------------------------------------------------------------------------
pure function getRho0(ph,en) result(rho_0)

  integer, intent(in) :: ph, en
  real(pREAL), dimension(param(ph)%sum_N_sl,10) :: rho_0


  associate(prm => param(ph))

    rho_0 = reshape(state0(ph)%rho(:,en),[prm%sum_N_sl,10])

    ! ensure positive densities (not for imm, they have a sign)
    rho_0(:,mob) = max(rho_0(:,mob),0.0_pREAL)
    rho_0(:,dip) = max(rho_0(:,dip),0.0_pREAL)

    where (abs(rho_0) < max(prm%rho_min/geom(ph)%v_0(en)**(2.0_pREAL/3.0_pREAL),prm%rho_significant)) &
      rho_0 = 0.0_pREAL

  end associate

end function getRho0


!--------------------------------------------------------------------------------------------------
!--------------------------------------------------------------------------------------------------
subroutine storeGeometry(ph)

  integer, intent(in) :: ph

  integer :: ce, nCell
  real(pREAL), dimension(:), allocatable :: v_0
  real(pREAL), dimension(:,:), allocatable :: a_0, x_0
  real(pREAL), dimension(:,:,:), allocatable :: n_0
  integer, dimension(:,:,:), allocatable :: neighborhood


  nCell = product(shape(IPVolume0))

  v_0 = reshape(IPVolume0,[nCell])
  a_0 = reshape(IPArea0,[nCellNeighbors,nCell])
  x_0 = reshape(discretization_IPcoords,[3,nCell])
  n_0 = reshape(IPAreaNormal0,[3,nCellNeighbors,nCell])
  neighborhood = reshape(IPneighborhood,[3,nCellNeighbors,nCell])

  do ce = 1, size(material_entry_homogenization,1)
    if (material_ID_phase(1,ce) == ph) then
      geom(ph)%v_0(material_entry_phase(1,ce)) = v_0(ce)
      geom(ph)%a_0(:,material_entry_phase(1,ce)) = a_0(:,ce)
      geom(ph)%x_0(:,material_entry_phase(1,ce)) = x_0(:,ce)
      geom(ph)%n_0(:,:,material_entry_phase(1,ce)) = n_0(:,:,ce)
      geom(ph)%IPneighborhood(:,:,material_entry_phase(1,ce)) = neighborhood(:,:,ce)
    end if
  end do

end subroutine storeGeometry

end submodule nonlocal

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Vitesh Shah, Max-Planck-Institut für Eisenforschung GmbH
!> @author Yi-Chin Yang, Max-Planck-Institut für Eisenforschung GmbH
!> @author Jennifer Nastola, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!--------------------------------------------------------------------------------------------------
#ifdef PETSC
#include <petsc/finclude/petscsys.h>
#endif
module result
  use, intrinsic :: ISO_Fortran_env

  use HDF5
#ifdef PETSC
  use PETScSys
#ifndef PETSC_EXPOSES_MPI
  use MPI_f08
#endif
#endif

  use prec
  use misc
  use parallelization
  use IO
  use HDF5_utilities
#ifdef PETSC
  use CLI
  use OS
#else
  use DAMASK_interface
#endif

#ifndef PETSC_EXPOSES_MPIF90
  implicit none(type,external)
#else
  implicit none
#endif
  private

  integer(HID_T) :: resultFile

  interface result_closeGroup
    module procedure HDF5_closeGroup
  end interface result_closeGroup

  interface result_writeDataset
    module procedure result_writeScalarDataset_real
    module procedure result_writeVectorDataset_real
    module procedure result_writeTensorDataset_real

    module procedure result_writeVectorDataset_int
  end interface result_writeDataset

  interface result_addAttribute
    module procedure result_addAttribute_str
    module procedure result_addAttribute_int
    module procedure result_addAttribute_real

    module procedure result_addAttribute_str_array
    module procedure result_addAttribute_int_array
    module procedure result_addAttribute_real_array
  end interface result_addAttribute

  public :: &
    result_init, &
    result_openJobFile, &
    result_closeJobFile, &
    result_addIncrement, &
    result_finalizeIncrement, &
    result_openGroup, &
    result_addGroup, &
    result_closeGroup, &
    result_objectExists, &
    result_writeDataset, &
    result_writeDataset_str, &
    result_setLink, &
    result_addSetupFile, &
    result_addAttribute, &
    result_removeLink, &
    result_mapping_phase, &
    result_mapping_homogenization
contains

subroutine result_init(restart)

  logical, intent(in) :: restart

  character(len=pPATHLEN) :: commandLine
  integer :: hdferr
  logical :: file_exists
  character(len=:), allocatable :: date


  print'(/,1x,a)', '<<<+-  result init  -+>>>'; flush(IO_STDOUT)

  print'(/,1x,a)', 'M. Diehl et al., Integrating Materials and Manufacturing Innovation 6(1):83–91, 2017'
  print'(  1x,a)', 'https://doi.org/10.1007/s40192-017-0084-5'


  inquire(file=CLI_jobName//'.hdf5',exist=file_exists)

  if (.not. file_exists .or. .not. restart) then
    call result_createJobFile()
    call result_addAttribute('DADF5_version_major',1)
    call result_addAttribute('DADF5_version_minor',3)
    call get_command_argument(0,commandLine)
    call result_addAttribute('creator',trim(commandLine)//' '//DAMASK_VERSION)
    call result_addAttribute('created',now())
    call get_command(commandLine)
    call result_addAttribute('call',trim(commandLine))
#ifdef GRID
    call result_addAttribute('solver','grid')
#endif
#ifdef MESH
    call result_addAttribute('solver','mesh')
#endif
#ifdef MARC_SOURCE
    call result_addAttribute('solver','Marc')
#endif
    call result_addAttribute('compiler',compiler_version())
    call result_addAttribute('compiler_options',compiler_options())

    call result_addAttribute('DAMASK_version_major',IO_strAsInt(DAMASK_VERSION_MAJOR))
    call result_addAttribute('DAMASK_version_minor',IO_strAsInt(DAMASK_VERSION_MINOR))
    call result_addAttribute('DAMASK_version_patch',IO_strAsInt(DAMASK_VERSION_PATCH))
#ifdef DAMASK_VERSION_HASH
    call result_addAttribute('DAMASK_version_hash',DAMASK_VERSION_HASH)
#endif

#ifdef PETSC
    call result_addAttribute('PETSc_version_major',PETSC_VERSION_MAJOR)
    call result_addAttribute('PETSc_version_minor',PETSC_VERSION_MINOR)
    call result_addAttribute('PETSc_version_subminor',PETSC_VERSION_SUBMINOR)
    call result_addAttribute('user',OS_getUserName())
    call result_addAttribute('host',OS_getHostName())
#endif
#ifdef BOOST
    call result_addAttribute('job_id',CLI_jobID)
#endif
    call result_addAttribute('job_name',CLI_jobName)
    call result_closeGroup(result_addGroup('cell_to'))
    call result_addAttribute('description','mappings to place data in space','cell_to')
    call result_closeGroup(result_addGroup('setup'))
    call result_addAttribute('description','input data used to run the simulation','setup')
  else
    date = now()
    call result_openJobFile()
    call get_command(commandLine)
    call result_addAttribute('call (restart at '//date//')',trim(commandLine))
    call H5Gmove_f(resultFile,'setup','tmp',hdferr)
    call result_addAttribute('description','input data used to run the simulation up to restart at '//date,'tmp')
    call result_closeGroup(result_addGroup('setup'))
    call result_addAttribute('description','input data used to run the simulation','setup')
    call H5Gmove_f(resultFile,'tmp','setup/previous',hdferr)
  end if

  call result_closeJobFile()

end subroutine result_init


!--------------------------------------------------------------------------------------------------
!> @brief Open the result file to append data.
!--------------------------------------------------------------------------------------------------
subroutine result_createJobFile(parallel)

  logical, intent(in), optional :: parallel


  resultFile = HDF5_openFile(CLI_jobName//'.hdf5','w',parallel)

end subroutine result_createJobFile


!--------------------------------------------------------------------------------------------------
!> @brief Open the result file to append data.
!--------------------------------------------------------------------------------------------------
subroutine result_openJobFile(parallel)

  logical, intent(in), optional :: parallel


  resultFile = HDF5_openFile(CLI_jobName//'.hdf5','a',parallel)

end subroutine result_openJobFile


!--------------------------------------------------------------------------------------------------
!> @brief Close the result file.
!--------------------------------------------------------------------------------------------------
subroutine result_closeJobFile

  call HDF5_closeFile(resultFile)

end subroutine result_closeJobFile


!--------------------------------------------------------------------------------------------------
!> @brief Creates a group for the increment and add time as attribute to the file.
!--------------------------------------------------------------------------------------------------
subroutine result_addIncrement(inc,time)

  integer,       intent(in) :: inc
  real(pREAL),   intent(in) :: time

  character(len=pSTRLEN) :: incChar


  write(incChar,'(i10)') inc
  call result_closeGroup(result_addGroup(trim('increment_'//trim(adjustl(incChar)))))
  call result_setLink(trim('increment_'//trim(adjustl(incChar))),'current')
  call result_addAttribute('t/s',time,trim('increment_'//trim(adjustl(incChar))))

end subroutine result_addIncrement


!--------------------------------------------------------------------------------------------------
!> @brief Finalize increment.
!> @details Remove soft link.
!--------------------------------------------------------------------------------------------------
subroutine result_finalizeIncrement

  call result_removeLink('current')

end subroutine result_finalizeIncrement


!--------------------------------------------------------------------------------------------------
!> @brief Open a group from the result file.
!--------------------------------------------------------------------------------------------------
integer(HID_T) function result_openGroup(groupName)

  character(len=*), intent(in) :: groupName


  result_openGroup = HDF5_openGroup(resultFile,groupName)

end function result_openGroup


!--------------------------------------------------------------------------------------------------
!> @brief Add a new group to the result file.
!--------------------------------------------------------------------------------------------------
integer(HID_T) function result_addGroup(groupName)

  character(len=*), intent(in) :: groupName


  result_addGroup = HDF5_addGroup(resultFile,groupName)

end function result_addGroup


!--------------------------------------------------------------------------------------------------
!> @brief Check whether a group or a dataset exists in the result file.
!--------------------------------------------------------------------------------------------------
logical function result_objectExists(path)

  character(len=*), intent(in) :: path


  result_objectExists = HDF5_objectExists(resultFile,path)

end function result_objectExists


!--------------------------------------------------------------------------------------------------
!> @brief Set link to object in result file.
!--------------------------------------------------------------------------------------------------
subroutine result_setLink(path,link)

  character(len=*), intent(in) :: path, link


  call HDF5_setLink(resultFile,path,link)

end subroutine result_setLink


!--------------------------------------------------------------------------------------------------
!> @brief Add file to setup folder and ensure unique name.
!--------------------------------------------------------------------------------------------------
subroutine result_addSetupFile(content,fname,description)

  character(len=*), intent(in) :: content, fname, description

  integer(HID_T) :: groupHandle
  character(len=:), allocatable :: name,suffix
  integer :: i

  groupHandle = result_openGroup('setup')
  name = fname(scan(fname,'/',.true.)+1:)
  suffix = ''
  i = 0

  do while (HDF5_objectExists(groupHandle,name//suffix))
    i = i+1
    suffix = '.'//IO_intAsStr(i)
  end do
  call result_writeDataset_str(content,'setup',name//suffix,description)
  call result_closeGroup(groupHandle)

end subroutine result_addSetupFile


!--------------------------------------------------------------------------------------------------
!> @brief Add a string attribute to an object in the result file.
!--------------------------------------------------------------------------------------------------
subroutine result_addAttribute_str(attrLabel,attrValue,path)

  character(len=*), intent(in)           :: attrLabel, attrValue
  character(len=*), intent(in), optional :: path


  call HDF5_addAttribute(resultFile,attrLabel, attrValue, path)

end subroutine result_addAttribute_str


!--------------------------------------------------------------------------------------------------
!> @brief Add an integer attribute to an object in the result file.
!--------------------------------------------------------------------------------------------------
subroutine result_addAttribute_int(attrLabel,attrValue,path)

  character(len=*), intent(in)           :: attrLabel
  integer,          intent(in)           :: attrValue
  character(len=*), intent(in), optional :: path


  call HDF5_addAttribute(resultFile,attrLabel, attrValue, path)

end subroutine result_addAttribute_int


!--------------------------------------------------------------------------------------------------
!> @brief Add a real (float) attribute to an object in the result file.
!--------------------------------------------------------------------------------------------------
subroutine result_addAttribute_real(attrLabel,attrValue,path)

  character(len=*), intent(in)           :: attrLabel
  real(pREAL),      intent(in)           :: attrValue
  character(len=*), intent(in), optional :: path


  call HDF5_addAttribute(resultFile,attrLabel, attrValue, path)

end subroutine result_addAttribute_real


!--------------------------------------------------------------------------------------------------
!> @brief Add a string array attribute to an object in the result file.
!--------------------------------------------------------------------------------------------------
subroutine result_addAttribute_str_array(attrLabel,attrValue,path)

  character(len=*), intent(in)               :: attrLabel
  character(len=*), intent(in), dimension(:) :: attrValue
  character(len=*), intent(in), optional     :: path


  call HDF5_addAttribute(resultFile,attrLabel, attrValue, path)

end subroutine result_addAttribute_str_array


!--------------------------------------------------------------------------------------------------
!> @brief Add an integer array attribute to an object in the result file.
!--------------------------------------------------------------------------------------------------
subroutine result_addAttribute_int_array(attrLabel,attrValue,path)

  character(len=*), intent(in)               :: attrLabel
  integer,          intent(in), dimension(:) :: attrValue
  character(len=*), intent(in), optional     :: path


  call HDF5_addAttribute(resultFile,attrLabel, attrValue, path)

end subroutine result_addAttribute_int_array


!--------------------------------------------------------------------------------------------------
!> @brief Add a real (float) array attribute to an object in the result file.
!--------------------------------------------------------------------------------------------------
subroutine result_addAttribute_real_array(attrLabel,attrValue,path)

  character(len=*), intent(in)               :: attrLabel
  real(pREAL),      intent(in), dimension(:) :: attrValue
  character(len=*), intent(in), optional     :: path


  call HDF5_addAttribute(resultFile,attrLabel, attrValue, path)

end subroutine result_addAttribute_real_array


!--------------------------------------------------------------------------------------------------
!> @brief remove link to an object
!--------------------------------------------------------------------------------------------------
subroutine result_removeLink(link)

  character(len=*), intent(in) :: link
  integer                      :: hdferr


  call H5Ldelete_f(resultFile,link, hdferr)
  if (hdferr < 0) call IO_error(1,ext_msg = 'result_removeLink: H5Ldelete_soft_f ('//trim(link)//')')

end subroutine result_removeLink


!--------------------------------------------------------------------------------------------------
!> @brief Store string dataset.
!> @details Not collective, must be called by one process at at time.
!--------------------------------------------------------------------------------------------------
subroutine result_writeDataset_str(dataset,group,label,description)

  character(len=*), intent(in) :: label,group,description,dataset

  integer(HID_T) :: groupHandle


  groupHandle = result_openGroup(group)
  call HDF5_write_str(dataset,groupHandle,label)
  call executionStamp(group//'/'//label,description)
  call HDF5_closeGroup(groupHandle)

end subroutine result_writeDataset_str

!--------------------------------------------------------------------------------------------------
!> @brief Store real scalar dataset with associated metadata.
!--------------------------------------------------------------------------------------------------
subroutine result_writeScalarDataset_real(dataset,group,label,description,SIunit)

  character(len=*), intent(in)                  :: label,group,description
  character(len=*), intent(in),    optional     :: SIunit
  real(pREAL),      intent(in),    dimension(:) :: dataset

  integer(HID_T) :: groupHandle


  groupHandle = result_openGroup(group)
  call HDF5_write(dataset,groupHandle,label)
  call executionStamp(group//'/'//label,description,SIunit)
  call HDF5_closeGroup(groupHandle)

end subroutine result_writeScalarDataset_real


!--------------------------------------------------------------------------------------------------
!> @brief Store real vector dataset with associated metadata.
!--------------------------------------------------------------------------------------------------
subroutine result_writeVectorDataset_real(dataset,group,label,description,SIunit,systems)

  character(len=*), intent(in)                    :: label,group,description
  character(len=*), intent(in),    optional       :: SIunit
  character(len=*), intent(in),    dimension(:), optional :: systems
  real(pREAL),      intent(in),    dimension(:,:) :: dataset

  integer(HID_T) :: groupHandle


  groupHandle = result_openGroup(group)
  call HDF5_write(dataset,groupHandle,label)
  call executionStamp(group//'/'//label,description,SIunit)
  if (present(systems) .and. HDF5_objectExists(groupHandle,label)) &
    call HDF5_addAttribute(resultFile,'systems',systems,group//'/'//label)
  call HDF5_closeGroup(groupHandle)

end subroutine result_writeVectorDataset_real


!--------------------------------------------------------------------------------------------------
!> @brief Store real tensor dataset with associated metadata.
!> @details Data is transposed to compenstate transposed storage order.
!--------------------------------------------------------------------------------------------------
subroutine result_writeTensorDataset_real(dataset,group,label,description,SIunit,transposed)

  character(len=*), intent(in)                   :: label,group,description
  character(len=*), intent(in), optional         :: SIunit
  logical,          intent(in), optional         :: transposed
  real(pREAL),      intent(in), dimension(:,:,:) :: dataset

  integer :: i
  integer(HID_T) :: groupHandle
  real(pREAL), dimension(:,:,:), allocatable :: dataset_transposed


  groupHandle = result_openGroup(group)
  if (misc_optional(transposed,.true.)) then
    if (size(dataset,1) /= size(dataset,2)) error stop 'transpose non-symmetric tensor'
    allocate(dataset_transposed,mold=dataset)
    do i=1,size(dataset_transposed,3)
      dataset_transposed(:,:,i) = transpose(dataset(:,:,i))
    end do
    call HDF5_write(dataset_transposed,groupHandle,label)
  else
    call HDF5_write(dataset,groupHandle,label)
  end if
  call executionStamp(group//'/'//label,description,SIunit)
  call HDF5_closeGroup(groupHandle)

end subroutine result_writeTensorDataset_real


!--------------------------------------------------------------------------------------------------
!> @brief Store integer vector dataset with associated metadata.
!--------------------------------------------------------------------------------------------------
subroutine result_writeVectorDataset_int(dataset,group,label,description,SIunit,systems)

  character(len=*), intent(in)                 :: label,group,description
  character(len=*), intent(in), optional       :: SIunit
  character(len=*), intent(in),    dimension(:), optional :: systems
  integer,          intent(in), dimension(:,:) :: dataset

  integer(HID_T) :: groupHandle


  groupHandle = result_openGroup(group)
  call HDF5_write(dataset,groupHandle,label)
  call executionStamp(group//'/'//label,description,SIunit)
  if (present(systems) .and. HDF5_objectExists(groupHandle,label)) &
    call HDF5_addAttribute(resultFile,'systems',systems,group//'/'//label)
  call HDF5_closeGroup(groupHandle)

end subroutine result_writeVectorDataset_int


!--------------------------------------------------------------------------------------------------
!> @brief Add the unique mapping from spatial position and constituent ID to results.
!--------------------------------------------------------------------------------------------------
subroutine result_mapping_phase(ID,entry,label)

  integer,          dimension(:,:), intent(in) :: ID                                                !< phase ID at (co,ce)
  integer,          dimension(:,:), intent(in) :: entry                                             !< phase entry at (co,ce)
  character(len=*), dimension(:),   intent(in) :: label                                             !< label of each phase section

  integer(pI64), dimension(size(entry,1),size(entry,2)) :: entryGlobal
  integer(pI64), dimension(size(label),0:worldsize-1) :: entryOffset                                !< offset in entry counting per process
  integer(MPI_INTEGER_KIND), dimension(0:worldsize-1) :: writeSize                                  !< amount of data written per process
  integer(HSIZE_T), dimension(2) :: &
    myShape, &                                                                                      !< shape of the dataset (this process)
    myOffset, &
    totalShape                                                                                      !< shape of the dataset (all processes)

  integer(HID_T) :: &
    pI64_t, &                                                                                       !< HDF5 type for pI64 (8 bit integer)
    loc_id, &                                                                                       !< identifier of group in file
    dtype_id, &                                                                                     !< identifier of compound data type
    label_id, &                                                                                     !< identifier of label (string) in compound data type
    entry_id, &                                                                                     !< identifier of entry (integer) in compound data type
    dset_id, &
    memspace_id, &
    filespace_id, &
    plist_id, &
    dt_id

  integer(SIZE_T) :: type_size_str, type_size_int
  integer         :: hdferr, ce, co
  integer(MPI_INTEGER_KIND) :: err_MPI


  call H5Pcreate_f(H5P_DATASET_XFER_F, plist_id, hdferr)
  call HDF5_chkerr(hdferr)

#ifndef PETSC
  entryGlobal = int(entry-1,pI64)                                                                   ! 0-based
  writeSize(0) = size(entry,dim=2,kind=MPI_INTEGER_KIND)                                                         ! total number of entries of this process
#else
!--------------------------------------------------------------------------------------------------
! MPI settings and communication
  call H5Pset_dxpl_mpio_f(plist_id, H5FD_MPIO_COLLECTIVE_F, hdferr)
  call HDF5_chkerr(hdferr)
  call MPI_Allgather(size(entry,dim=2,kind=MPI_INTEGER_KIND),1_MPI_INTEGER_KIND,MPI_INTEGER,&
                     writeSize,1_MPI_INTEGER_KIND,MPI_INTEGER,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)

  entryOffset = 0_pI64
  do co = 1, size(ID,1)
    do ce = 1, size(ID,2)
      entryOffset(ID(co,ce),worldrank) = entryOffset(ID(co,ce),worldrank) +1_pI64
    end do
  end do
  call MPI_Allreduce(MPI_IN_PLACE,entryOffset,size(entryOffset),MPI_INTEGER8,MPI_SUM,MPI_COMM_WORLD,err_MPI)! get offset at each process
  call parallelization_chkerr(err_MPI)
  entryOffset(:,worldrank) = sum(entryOffset(:,0:worldrank-1),2)
  do co = 1, size(ID,1)
    do ce = 1, size(ID,2)
      entryGlobal(co,ce) = int(entry(co,ce),pI64) -1_pI64 + entryOffset(ID(co,ce),worldrank)
    end do
  end do
#endif

  myShape = int([size(ID,1,MPI_INTEGER_KIND),writeSize(worldrank)], HSIZE_T)
  myOffset = int([0_MPI_INTEGER_KIND,sum(writeSize(0:worldrank-1))], HSIZE_T)
  totalShape = int([size(ID,1,MPI_INTEGER_KIND),sum(writeSize)], HSIZE_T)

!---------------------------------------------------------------------------------------------------
! compound type: label(ID) + entry
  call H5Tcopy_f(H5T_NATIVE_CHARACTER, dt_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tset_size_f(dt_id, int(len(label(1)),SIZE_T), hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tget_size_f(dt_id, type_size_str, hdferr)
  call HDF5_chkerr(hdferr)

  pI64_t = h5kind_to_type(kind(entryGlobal),H5_INTEGER_KIND)
  call H5Tget_size_f(pI64_t, type_size_int, hdferr)
  call HDF5_chkerr(hdferr)

  call H5Tcreate_f(H5T_COMPOUND_F, type_size_str + type_size_int, dtype_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tinsert_f(dtype_id, 'label', 0_SIZE_T, dt_id,hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tinsert_f(dtype_id, 'entry', type_size_str, pI64_t, hdferr)
  call HDF5_chkerr(hdferr)

!--------------------------------------------------------------------------------------------------
! create memory types for each component of the compound type
  call H5Tcreate_f(H5T_COMPOUND_F, type_size_str, label_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tinsert_f(label_id, 'label', 0_SIZE_T, dt_id, hdferr)
  call HDF5_chkerr(hdferr)

  call H5Tcreate_f(H5T_COMPOUND_F, type_size_int, entry_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tinsert_f(entry_id, 'entry', 0_SIZE_T, pI64_t, hdferr)
  call HDF5_chkerr(hdferr)

  call H5Tclose_f(dt_id, hdferr)
  call HDF5_chkerr(hdferr)

!--------------------------------------------------------------------------------------------------
! create dataspace in memory (local shape = hyperslab) and in file (global shape)
  call H5Screate_simple_f(2,myShape,memspace_id,hdferr,myShape)
  call HDF5_chkerr(hdferr)

  call H5Screate_simple_f(2,totalShape,filespace_id,hdferr,totalShape)
  call HDF5_chkerr(hdferr)

  call H5Sselect_hyperslab_f(filespace_id, H5S_SELECT_SET_F, myOffset, myShape, hdferr)
  call HDF5_chkerr(hdferr)

!--------------------------------------------------------------------------------------------------
! write the components of the compound type individually
  call H5Pset_preserve_f(plist_id, .true., hdferr)
  call HDF5_chkerr(hdferr)

  loc_id = result_openGroup('/cell_to')
  call H5Dcreate_f(loc_id, 'phase', dtype_id, filespace_id, dset_id, hdferr)
  call HDF5_chkerr(hdferr)

  call H5Dwrite_f(dset_id, label_id, reshape(label(pack(ID,.true.)),myShape), &
                  myShape, hdferr, file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
  call HDF5_chkerr(hdferr)
  call H5Dwrite_f(dset_id, entry_id, reshape(pack(entryGlobal,.true.),myShape), &
                  myShape, hdferr, file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
  call HDF5_chkerr(hdferr)

!--------------------------------------------------------------------------------------------------
! close all
  call HDF5_closeGroup(loc_id)
  call H5Pclose_f(plist_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Sclose_f(filespace_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Sclose_f(memspace_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Dclose_f(dset_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tclose_f(dtype_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tclose_f(label_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tclose_f(entry_id, hdferr)

  call executionStamp('cell_to/phase','cell ID and constituent ID to phase results')

end subroutine result_mapping_phase


!--------------------------------------------------------------------------------------------------
!> @brief Add the unique mapping from spatial position and constituent ID to results.
!--------------------------------------------------------------------------------------------------
subroutine result_mapping_homogenization(ID,entry,label)

  integer,          dimension(:), intent(in) :: ID                                                  !< homogenization ID at (ce)
  integer,          dimension(:), intent(in) :: entry                                               !< homogenization entry at (ce)
  character(len=*), dimension(:), intent(in) :: label                                               !< label of each homogenization section

  integer(pI64), dimension(size(entry,1)) :: entryGlobal
  integer(pI64), dimension(size(label),0:worldsize-1) :: entryOffset                                !< offset in entry counting per process
  integer(MPI_INTEGER_KIND), dimension(0:worldsize-1) :: writeSize                                  !< amount of data written per process
  integer(HSIZE_T), dimension(1) :: &
    myShape, &                                                                                      !< shape of the dataset (this process)
    myOffset, &
    totalShape                                                                                      !< shape of the dataset (all processes)

  integer(HID_T) :: &
    pI64_t, &                                                                                       !< HDF5 type for pI64 (8 bit integer)
    loc_id, &                                                                                       !< identifier of group in file
    dtype_id, &                                                                                     !< identifier of compound data type
    label_id, &                                                                                     !< identifier of label (string) in compound data type
    entry_id, &                                                                                     !< identifier of entry (integer) in compound data type
    dset_id, &
    memspace_id, &
    filespace_id, &
    plist_id, &
    dt_id

  integer(SIZE_T) :: type_size_str, type_size_int
  integer         :: hdferr, ce
  integer(MPI_INTEGER_KIND) :: err_MPI


  call H5Pcreate_f(H5P_DATASET_XFER_F, plist_id, hdferr)
  call HDF5_chkerr(hdferr)

#ifndef PETSC
  entryGlobal = int(entry-1,pI64)
  writeSize(0) = size(entry,kind=MPI_INTEGER_KIND)                                                         ! total number of entries of this process                                                            ! 0-based
#else
!--------------------------------------------------------------------------------------------------
! MPI settings and communication
  call H5Pset_dxpl_mpio_f(plist_id, H5FD_MPIO_COLLECTIVE_F, hdferr)
  call HDF5_chkerr(hdferr)
  call MPI_Allgather(size(entry,kind=MPI_INTEGER_KIND),1_MPI_INTEGER_KIND,MPI_INTEGER,&
                     writeSize,1_MPI_INTEGER_KIND,MPI_INTEGER,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)

  entryOffset = 0_pI64
  do ce = 1, size(ID)
    entryOffset(ID(ce),worldrank) = entryOffset(ID(ce),worldrank) +1_pI64
  end do
  call MPI_Allreduce(MPI_IN_PLACE,entryOffset,size(entryOffset),MPI_INTEGER8,MPI_SUM,MPI_COMM_WORLD,err_MPI)! get offset at each process
  call parallelization_chkerr(err_MPI)
  entryOffset(:,worldrank) = sum(entryOffset(:,0:worldrank-1),2)
  do ce = 1, size(ID)
    entryGlobal(ce) = int(entry(ce),pI64) -1_pI64 + entryOffset(ID(ce),worldrank)
  end do
#endif

  myShape = int([writeSize(worldrank)], HSIZE_T)
  myOffset = int([sum(writeSize(0:worldrank-1))], HSIZE_T)
  totalShape = int([sum(writeSize)], HSIZE_T)

!---------------------------------------------------------------------------------------------------
! compound type: label(ID) + entry
  call H5Tcopy_f(H5T_NATIVE_CHARACTER, dt_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tset_size_f(dt_id, int(len(label(1)),SIZE_T), hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tget_size_f(dt_id, type_size_str, hdferr)
  call HDF5_chkerr(hdferr)

  pI64_t = h5kind_to_type(kind(entryGlobal),H5_INTEGER_KIND)
  call H5Tget_size_f(pI64_t, type_size_int, hdferr)
  call HDF5_chkerr(hdferr)

  call H5Tcreate_f(H5T_COMPOUND_F, type_size_str + type_size_int, dtype_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tinsert_f(dtype_id, 'label', 0_SIZE_T, dt_id,hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tinsert_f(dtype_id, 'entry', type_size_str, pI64_t, hdferr)
  call HDF5_chkerr(hdferr)

!--------------------------------------------------------------------------------------------------
! create memory types for each component of the compound type
  call H5Tcreate_f(H5T_COMPOUND_F, type_size_str, label_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tinsert_f(label_id, 'label', 0_SIZE_T, dt_id, hdferr)
  call HDF5_chkerr(hdferr)

  call H5Tcreate_f(H5T_COMPOUND_F, type_size_int, entry_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tinsert_f(entry_id, 'entry', 0_SIZE_T, pI64_t, hdferr)
  call HDF5_chkerr(hdferr)

  call H5Tclose_f(dt_id, hdferr)
  call HDF5_chkerr(hdferr)

!--------------------------------------------------------------------------------------------------
! create dataspace in memory (local shape = hyperslab) and in file (global shape)
  call H5Screate_simple_f(1,myShape,memspace_id,hdferr,myShape)
  call HDF5_chkerr(hdferr)

  call H5Screate_simple_f(1,totalShape,filespace_id,hdferr,totalShape)
  call HDF5_chkerr(hdferr)

  call H5Sselect_hyperslab_f(filespace_id, H5S_SELECT_SET_F, myOffset, myShape, hdferr)
  call HDF5_chkerr(hdferr)

!--------------------------------------------------------------------------------------------------
! write the components of the compound type individually
  call H5Pset_preserve_f(plist_id, .true., hdferr)
  call HDF5_chkerr(hdferr)

  loc_id = result_openGroup('/cell_to')
  call H5Dcreate_f(loc_id, 'homogenization', dtype_id, filespace_id, dset_id, hdferr)
  call HDF5_chkerr(hdferr)

  call H5Dwrite_f(dset_id, label_id, reshape(label(pack(ID,.true.)),myShape), &
                  myShape, hdferr, file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
  call HDF5_chkerr(hdferr)
  call H5Dwrite_f(dset_id, entry_id, reshape(pack(entryGlobal,.true.),myShape), &
                  myShape, hdferr, file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
  call HDF5_chkerr(hdferr)

!--------------------------------------------------------------------------------------------------
! close all
  call HDF5_closeGroup(loc_id)
  call H5Pclose_f(plist_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Sclose_f(filespace_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Sclose_f(memspace_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Dclose_f(dset_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tclose_f(dtype_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tclose_f(label_id, hdferr)
  call HDF5_chkerr(hdferr)
  call H5Tclose_f(entry_id, hdferr)
  call HDF5_chkerr(hdferr)

  call executionStamp('cell_to/homogenization','cell ID to homogenization results')

end subroutine result_mapping_homogenization


!--------------------------------------------------------------------------------------------------
!> @brief Add default information to a dataset.
!--------------------------------------------------------------------------------------------------
subroutine executionStamp(path,description,SIunit)

  character(len=*), intent(in)           :: path,description
  character(len=*), intent(in), optional :: SIunit


  if (HDF5_objectExists(resultFile,path)) &
    call HDF5_addAttribute(resultFile,'creator','DAMASK '//DAMASK_VERSION,path)
  if (HDF5_objectExists(resultFile,path)) &
    call HDF5_addAttribute(resultFile,'created',now(),path)
  if (HDF5_objectExists(resultFile,path)) &
    call HDF5_addAttribute(resultFile,'description',description,path)
  if (HDF5_objectExists(resultFile,path) .and. present(SIunit)) &
    call HDF5_addAttribute(resultFile,'unit',SIunit,path)

end subroutine executionStamp


!--------------------------------------------------------------------------------------------------
!> @brief Return current date and time (including time zone information).
!--------------------------------------------------------------------------------------------------
character(len=24) function now()

  character(len=5)      :: zone
  integer, dimension(8) :: values


  call date_and_time(values=values,zone=zone)
  write(now,'(i4.4,5(a,i2.2),a)') &
    values(1),'-',values(2),'-',values(3),' ',values(5),':',values(6),':',values(7),zone

end function now


end module result

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief dummy homogenization homogenization scheme for 1 constituent per material point
!--------------------------------------------------------------------------------------------------
submodule(homogenization:mechanical) mechanical_pass

contains

!--------------------------------------------------------------------------------------------------
!> @brief allocates all necessary fields, reads information from material configuration file
!--------------------------------------------------------------------------------------------------
module subroutine pass_init()

  integer :: &
    ho, &
    Nmembers

  print'(/,1x,a)', '<<<+-  homogenization:mechanical:pass init  -+>>>'

  print'(/,a,i0)', ' # homogenizations: ',count(mechanical_type == MECHANICAL_PASS_ID)
  flush(IO_STDOUT)

  do ho = 1, size(material_name_homogenization)

    if (mechanical_type(ho) /= MECHANICAL_PASS_ID) cycle

    print'(/,1x,a,1x,i0,a)', 'homogenization',ho,': '//material_name_homogenization(ho)

    if (homogenization_Nconstituents(ho) /= 1) &
      call IO_error(211,ext_msg='(pass) with N_constituents !=1')

    Nmembers = count(material_ID_homogenization == ho)
    homogState(ho)%sizeState = 0
    allocate(homogState(ho)%state0(0,Nmembers))
    allocate(homogState(ho)%state (0,Nmembers))

  end do

end subroutine pass_init

end submodule mechanical_pass

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, KU Leuven
!--------------------------------------------------------------------------------------------------
submodule(homogenization) damage

  interface

    module subroutine pass_init
    end subroutine pass_init

  end interface

  type :: tDataContainer
    real(pREAL), dimension(:), allocatable :: phi
  end type tDataContainer

  type(tDataContainer), dimension(:), allocatable :: current

  type :: tParameters
    character(len=pSTRLEN), allocatable, dimension(:) :: &
      output
  end type tParameters

  type(tparameters),             dimension(:), allocatable :: &
    param


contains

!--------------------------------------------------------------------------------------------------
!> @brief Allocate variables and set parameters.
!--------------------------------------------------------------------------------------------------
module subroutine damage_init()

  type(tDict), pointer :: &
    configHomogenizations, &
    configHomogenization, &
    configHomogenizationDamage
  integer :: ho,Nmembers


  print'(/,1x,a)', '<<<+-  homogenization:damage init  -+>>>'


  configHomogenizations => config_material%get_dict('homogenization')
  allocate(param(size(configHomogenizations)))
  allocate(current(size(configHomogenizations)))

  do ho = 1, size(configHomogenizations)
    Nmembers = count(material_ID_homogenization == ho)
    allocate(current(ho)%phi(Nmembers), source=1.0_pREAL)
    configHomogenization => configHomogenizations%get_dict(ho)
    associate(prm => param(ho))
      if (configHomogenization%contains('damage')) then
        configHomogenizationDamage => configHomogenization%get_dict('damage')
#if defined (__GFORTRAN__)
        prm%output = output_as1dStr(configHomogenizationDamage)
#else
        prm%output = configHomogenizationDamage%get_as1dStr('output',defaultVal=emptyStrArray)
#endif
        damageState_h(ho)%sizeState = 1
        allocate(damageState_h(ho)%state0(1,Nmembers), source=1.0_pREAL)
        allocate(damageState_h(ho)%state (1,Nmembers), source=1.0_pREAL)
      else
        prm%output = emptyStrArray
      end if
    end associate
  end do

  call pass_init()

end subroutine damage_init


!--------------------------------------------------------------------------------------------------
!> @brief Check if damage homogemization description is present in the configuration file
!--------------------------------------------------------------------------------------------------
module function homogenization_damage_active() result(active)

  logical :: active

  active = any(damage_active(:))

end function homogenization_damage_active


!--------------------------------------------------------------------------------------------------
!> @brief Partition temperature onto the individual constituents.
!--------------------------------------------------------------------------------------------------
module subroutine damage_partition(ce)

  integer, intent(in) :: ce

  real(pREAL) :: phi
  integer :: co


  if (damageState_h(material_ID_homogenization(ce))%sizeState < 1) return
  phi = damagestate_h(material_ID_homogenization(ce))%state(1,material_entry_homogenization(ce))
  do co = 1, homogenization_Nconstituents(material_ID_homogenization(ce))
    call phase_set_phi(phi,co,ce)
  end do


end subroutine damage_partition


!--------------------------------------------------------------------------------------------------
!> @brief Homogenize damage viscosity.
!--------------------------------------------------------------------------------------------------
module function homogenization_mu_phi(ce) result(mu)

  integer, intent(in) :: ce
  real(pREAL) :: mu


  mu = phase_mu_phi(1,ce)

end function homogenization_mu_phi


!--------------------------------------------------------------------------------------------------
!> @brief Homogenize damage conductivity.
!--------------------------------------------------------------------------------------------------
module function homogenization_K_phi(ce) result(K)

  integer, intent(in) :: ce
  real(pREAL), dimension(3,3) :: K


  K = phase_K_phi(1,ce)

end function homogenization_K_phi


!--------------------------------------------------------------------------------------------------
!> @brief Homogenize damage driving force.
!--------------------------------------------------------------------------------------------------
module function homogenization_f_phi(phi,ce) result(f)

  integer, intent(in) :: ce
  real(pREAL), intent(in) :: phi
  real(pREAL) :: f


  f = phase_f_phi(phi, 1, ce)

end function homogenization_f_phi


!--------------------------------------------------------------------------------------------------
!> @brief Set damage field.
!--------------------------------------------------------------------------------------------------
module subroutine homogenization_set_phi(phi)

  real(pREAL), dimension(:), intent(in) :: phi

  integer :: ho, en, ce


  do ce=lbound(phi,1), ubound(phi,1)
    ho = material_ID_homogenization(ce)
    en = material_entry_homogenization(ce)
    damagestate_h(ho)%state(1,en) = phi(ce)
    current(ho)%phi(en) = phi(ce)
  end do

end subroutine homogenization_set_phi


!--------------------------------------------------------------------------------------------------
!> @brief writes results to HDF5 output file
!--------------------------------------------------------------------------------------------------
module subroutine damage_result(ho,group)

  integer,          intent(in) :: ho
  character(len=*), intent(in) :: group

  integer :: o


  associate(prm => param(ho))
      outputsLoop: do o = 1,size(prm%output)
        select case(prm%output(o))
          case ('phi')
            call result_writeDataset(current(ho)%phi,group,prm%output(o),&
                                     'damage indicator','-')
        end select
      end do outputsLoop
  end associate

end subroutine damage_result

end submodule damage

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Defines phase and homogenization
!--------------------------------------------------------------------------------------------------
module material
  use prec
  use config
  use result
  use math
  use IO
  use rotations
  use discretization
  use types

  implicit none(type,external)
  private

  type, public :: tRotationContainer
    type(tRotation), dimension(:), allocatable :: data
  end type tRotationContainer

  type, public :: tTensorContainer
    real(pREAL), dimension(:,:,:), allocatable :: data
  end type tTensorContainer


  type(tRotationContainer), dimension(:), allocatable, public, protected :: material_O_0
  type(tTensorContainer),   dimension(:), allocatable, public, protected :: material_V_e_0

  integer, dimension(:), allocatable, public, protected :: &
    homogenization_Nconstituents                                                                    !< number of grains in each homogenization
  integer, public, protected :: &
    homogenization_maxNconstituents                                                                 !< max number of grains in any homogenization

! --- BAD
  integer, dimension(:), allocatable, public :: &
    homogenization_chemical_Ncomponents

  integer, public:: &
    homogenization_chemical_maxNcomponents
! ---
  character(len=:), public, protected, allocatable, dimension(:) :: &
    material_name_phase, &                                                                          !< name of each phase
    material_name_homogenization                                                                    !< name of each homogenization

  integer, dimension(:),   allocatable, public, protected :: &                                      ! (cell)
    material_ID_homogenization, &                                                                   !< Number of the homogenization
    material_entry_homogenization                                                                   !< Position in array of used homogenization
  integer, dimension(:,:), allocatable, public, protected :: &                                      ! (constituent,cell)
    material_ID_phase, &                                                                            !< Number of the phase
    material_entry_phase                                                                            !< Position in array of used phase

  real(pREAL), dimension(:,:), allocatable, public, protected :: &
    material_v                                                                                      ! fraction

  character(len=:), dimension(:), public, allocatable :: &
    material_name_species

    public :: &
    material_init



contains

!--------------------------------------------------------------------------------------------------
!> @brief Parse material configuration file (material.yaml) and write mappings to result file.
!--------------------------------------------------------------------------------------------------
subroutine material_init()

  print'(/,1x,a)', '<<<+-  material init  -+>>>'; flush(IO_STDOUT)

  call parse()
  print'(/,1x,a)', 'parsed material.yaml'

  call result_openJobFile()
  if (.not. result_objectExists('cell_to/phase')) &
    call result_mapping_phase(material_ID_phase,material_entry_phase,material_name_phase)
  if (.not. result_objectExists('cell_to/homogenization')) &
    call result_mapping_homogenization(material_ID_homogenization,material_entry_homogenization,material_name_homogenization)
  call result_closeJobFile()

end subroutine material_init


!--------------------------------------------------------------------------------------------------
!> @brief Parse material.yaml to get the global structure.
!--------------------------------------------------------------------------------------------------
subroutine parse()

  type(tList), pointer :: materials, &                                                              !< all materials
                          constituents                                                              !< all constituents of a material
  type(tDict), pointer :: phases, &                                                                 !< all phases
                          homogenizations, &                                                        !< all homogenizations
                          material, &                                                               !< material definition
                          constituent, &                                                            !< constituent definition
                          homogenization

  type(tItem), pointer :: item
  integer, dimension(:), allocatable :: &
    counterPhase, &
    counterHomogenization, &
    ho_of
  integer, dimension(:,:), allocatable :: ph_of
  real(pREAL), dimension(:,:), allocatable :: v_of

  real(pREAL) :: v
  integer :: &
    el, ip, &
    ho, ph, &
    co, ce, &
    ma


  materials       => config_material%get_list('material')
  phases          => config_material%get_dict('phase')
  homogenizations => config_material%get_dict('homogenization')


  if (maxval(discretization_materialAt) > size(materials)) &
    call IO_error(155,ext_msg='More materials requested than found in material.yaml')

  material_name_phase          = phases%keys()
  material_name_homogenization = homogenizations%keys()
  material_name_species = get_chemical_species(phases)

  allocate(homogenization_Nconstituents(size(homogenizations)))
  do ho=1, size(homogenizations)
    homogenization => homogenizations%get_dict(ho)
    homogenization_Nconstituents(ho) = homogenization%get_asInt('N_constituents')
  end do
  homogenization_maxNconstituents = maxval(homogenization_Nconstituents)

  allocate(material_v(homogenization_maxNconstituents,discretization_Ncells),source=0.0_pREAL)

  allocate(material_O_0(size(materials)))
  allocate(material_V_e_0(size(materials)))

  allocate(ho_of(size(materials)))
  allocate(ph_of(size(materials),homogenization_maxNconstituents),source=-1)
  allocate( v_of(size(materials),homogenization_maxNconstituents),source=0.0_pREAL)

  ! Parse YAML structure. Manual loop over linked list to have O(n) instead of O(n^2) complexity
  item => materials%first
  do ma = 1, size(materials)
    material => item%node%asDict()
    ho_of(ma) = homogenizations%index(material%get_asStr('homogenization'))
    constituents => material%get_list('constituents')

    homogenization => homogenizations%get_dict(ho_of(ma))
    if (size(constituents) /= homogenization%get_asInt('N_constituents')) call IO_error(148)

    allocate(material_O_0(ma)%data(size(constituents)))
    allocate(material_V_e_0(ma)%data(1:3,1:3,size(constituents)))

    do co = 1, size(constituents)
      constituent => constituents%get_dict(co)
       v_of(ma,co) = constituent%get_asReal('v')
      ph_of(ma,co) = phases%index(constituent%get_asStr('phase'))

      call material_O_0(ma)%data(co)%fromQuaternion(constituent%get_as1dReal('O',requiredSize=4))
      material_V_e_0(ma)%data(1:3,1:3,co) = constituent%get_as2dReal('V_e',defaultVal=math_I3,requiredShape=[3,3])
      if (any(dNeq(material_V_e_0(ma)%data(1:3,1:3,co),transpose(material_V_e_0(ma)%data(1:3,1:3,co))))) &
        call IO_error(147)

    end do
    if (dNeq(sum(v_of(ma,:)),1.0_pREAL,1.e-9_pREAL)) call IO_error(153,ext_msg='constituent')

    item => item%next
  end do

  allocate(counterPhase(size(phases)),source=0)
  allocate(counterHomogenization(size(homogenizations)),source=0)

  allocate(material_ID_homogenization(discretization_Ncells),source=0)
  allocate(material_entry_homogenization(discretization_Ncells),source=0)

  allocate(material_ID_phase(homogenization_maxNconstituents,discretization_Ncells),source=0)
  allocate(material_entry_phase(homogenization_maxNconstituents,discretization_Ncells),source=0)


  ! build mappings
  do el = 1, discretization_Nelems

    ma = discretization_materialAt(el)
    ho = ho_of(ma)

    do ip = 1, discretization_nIPs
      ce = (el-1)*discretization_nIPs + ip
      material_ID_homogenization(ce) = ho
      counterHomogenization(ho) = counterHomogenization(ho) + 1
      material_entry_homogenization(ce) = counterHomogenization(ho)
    end do

    do co = 1, size(ph_of(ma,:)>0)

      v  =  v_of(ma,co)
      ph = ph_of(ma,co)

      do ip = 1, discretization_nIPs
        ce = (el-1)*discretization_nIPs + ip
        material_ID_phase(co,ce) = ph
        counterPhase(ph) = counterPhase(ph) + 1
        material_entry_phase(co,ce) = counterPhase(ph)
        material_v(co,ce) = v
      end do

    end do
  end do

end subroutine parse


#if defined (__GFORTRAN__)
!--------------------------------------------------------------------------------------------------
!> @brief %keys() is broken on gfortran
!--------------------------------------------------------------------------------------------------
function getKeys(dict)

  type(tDict), intent(in) :: dict
  character(len=:),       dimension(:), allocatable :: getKeys
  character(len=pSTRLEN), dimension(:), allocatable :: temp

  integer :: i,l

  allocate(temp(size(dict)))
  l = 0
  do i=1, size(dict)
    temp(i) = dict%key(i)
    l = max(len_trim(temp(i)),l)
  end do

  allocate(character(l)::getKeys(size(dict)))
  do i=1, size(dict)
    getKeys(i) = trim(temp(i))
  end do

end function getKeys
#endif

!--------------------------------------------------------------------------------------------------
!> @brief Get names of chemical species.
!--------------------------------------------------------------------------------------------------
function get_chemical_species(phases)

  type(tDict), intent(in) :: phases
  character(len=:),       dimension(:), allocatable :: get_chemical_species

  type(tDict), pointer :: phase, &
                          chemical, &
                          components


  ! SR: sanity check probably required if other phases have the same set of components defined or not
  phase => phases%get_dict(material_name_phase(1))
  if (phase%contains('chemical')) then
    chemical => phase%get_dict('chemical')
    components => chemical%get_dict('components')
    get_chemical_species = components%keys()
  else
    get_chemical_species = emptyStrArray
  end if

end function get_chemical_species


end module material

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @brief elasticity, plasticity, damage & thermal internal microstructure state
!--------------------------------------------------------------------------------------------------
module phase
  use prec
  use constants
  use math
  use rotations
  use polynomials
  use tables
  use IO
  use config
  use material
  use result
  use crystal
  use discretization
  use parallelization
  use HDF5
  use HDF5_utilities

  implicit none(type,external)
  private

  type :: tState
    integer :: &
      sizeState        = 0, &                                                                       !< size of state
      sizeDotState     = 0, &                                                                       !< size of dot state, i.e. state(1:sizeDot) follows time evolution by dotState rates
      offsetDeltaState = 0, &                                                                       !< index offset of delta state
      sizeDeltaState   = 0                                                                          !< size of delta state, i.e. state(offset+1:offset+sizeDelta) follows time evolution by deltaState increments
    real(pREAL), allocatable, dimension(:) :: &
      atol
    ! http://stackoverflow.com/questions/3948210
    real(pREAL), pointer,     dimension(:,:), contiguous :: &                                       !< is basically an allocatable+target, but in a type needs to be pointer
      state0, &
      state, &                                                                                      !< state
      dotState, &                                                                                   !< rate of state change
      deltaState                                                                                    !< increment of state change
    real(pREAL), pointer,     dimension(:,:)  :: &
      deltaState2
  end type

  type, extends(tState) :: tPlasticState
    logical :: nonlocal = .false.
  end type

  type :: tSourceState
    type(tState), dimension(:), allocatable :: p                                                    !< tState for each active source mechanism in a phase
  end type

  enum, bind(c); enumerator :: &
    UNDEFINED, &
    MECHANICAL_PLASTICITY_NONE, &
    MECHANICAL_PLASTICITY_ISOTROPIC, &
    MECHANICAL_PLASTICITY_PHENOPOWERLAW, &
    MECHANICAL_PLASTICITY_KINEHARDENING, &
    MECHANICAL_PLASTICITY_DISLOTWIN, &
    MECHANICAL_PLASTICITY_DISLOTUNGSTEN, &
    MECHANICAL_PLASTICITY_NONLOCAL, &
    MECHANICAL_EIGEN_THERMALEXPANSION, &
    DAMAGE_ISOBRITTLE, &
    DAMAGE_ANISOBRITTLE, &
    THERMAL_SOURCE_DISSIPATION, &
    THERMAL_SOURCE_EXTERNALHEAT, &
    CHEMICAL_REGULARSOLUTION, &
    CHEMICAL_QUADENERGY
  end enum


  integer(kind(UNDEFINED)), dimension(:), allocatable :: &
    mechanical_plasticity_type, &                                                                   !< plasticity of each phase
    damage_type                                                                                     !< damage type of each phase

  character(len=2), allocatable, dimension(:) :: phase_lattice
  real(pREAL),      allocatable, dimension(:) :: phase_cOverA
  real(pREAL),      allocatable, dimension(:) :: phase_rho

  type(tRotationContainer), dimension(:), allocatable :: &
    phase_O_0, &
    phase_O

  type :: tNumerics
    integer :: &
      iJacoLpresiduum, &                                                                            !< frequency of Jacobian update of residuum in Lp
      iJacoLiresiduum, &                                                                            !< frequency of Jacobian update of residuum in Li
      nState, &                                                                                     !< state loop limit
      nStress_Lp, &                                                                                 !< stress loop limit for Lp
      nStress_Li                                                                                    !< stress loop limit for Li
    real(pREAL) :: &
      stepMinCryst, &                                                                               !< minimum (relative) size of sub-step allowed during cutback
      stepSizeCryst, &                                                                              !< size of first substep when cutback
      stepSizeLp, &                                                                                 !< size of first substep when cutback in Lp calculation
      stepSizeLi, &                                                                                 !< size of first substep when cutback in Li calculation
      stepIncreaseCryst, &                                                                          !< increase of next substep size when previous substep converged
      rtol_crystalliteState, &
      rtol_Lp, &                                                                                    !< relative tolerance in stress loop for Lp
      atol_Lp, &                                                                                    !< absolute tolerance in stress loop for Lp
      rtol_Li, &                                                                                    !< relative tolerance in stress loop for Li
      atol_Li                                                                                       !< absolute tolerance in stress loop for Li
  end type tNumerics

  type(tNumerics) :: num                                                                            ! numerics parameters. Better name?

  type(tPlasticState), allocatable, dimension(:), public :: &
    plasticState
  type(tState),  allocatable, dimension(:), public :: &
    damageState
!  type(tState),  allocatable, dimension(:), public :: &
!    chemicalState


  interface

! == cleaned:begin =================================================================================
    module subroutine mechanical_init(phases,num_mech)
      type(tDict), pointer :: phases, num_mech
    end subroutine mechanical_init

    module subroutine damage_init
    end subroutine damage_init

    module subroutine thermal_init(phases)
      type(tDict), pointer :: phases
    end subroutine thermal_init

    module subroutine chemical_init(phases)
      type(tDict), pointer :: phases
    end subroutine chemical_init

    module subroutine mechanical_result(group,ph)
      character(len=*), intent(in) :: group
      integer,          intent(in) :: ph
    end subroutine mechanical_result

    module subroutine damage_result(group,ph)
      character(len=*), intent(in) :: group
      integer,          intent(in) :: ph
    end subroutine damage_result

    module subroutine thermal_result(group,ph)
      character(len=*), intent(in) :: group
      integer,          intent(in) :: ph
    end subroutine thermal_result

    module subroutine chemical_result(group,ph)
      character(len=*), intent(in) :: group
      integer,          intent(in) :: ph
    end subroutine chemical_result

    module subroutine mechanical_forward()
    end subroutine mechanical_forward

    module subroutine damage_forward()
    end subroutine damage_forward

    module subroutine thermal_forward()
    end subroutine thermal_forward

    module subroutine chemical_forward()
    end subroutine chemical_forward


    module subroutine mechanical_restore(ce)
      integer, intent(in) :: ce
    end subroutine mechanical_restore

    module subroutine damage_restore(ce)
      integer, intent(in) :: ce
    end subroutine damage_restore


    module function phase_mechanical_dPdF(Delta_t,co,ce) result(dPdF)
      real(pREAL), intent(in) :: Delta_t
      integer, intent(in) :: &
        co, &                                                                                       !< counter in constituent loop
        ce
      real(pREAL), dimension(3,3,3,3) :: dPdF
    end function phase_mechanical_dPdF

    module subroutine mechanical_restartWrite(groupHandle,ph)
      integer(HID_T), intent(in) :: groupHandle
      integer, intent(in) :: ph
    end subroutine mechanical_restartWrite

    module subroutine thermal_restartWrite(groupHandle,ph)
      integer(HID_T), intent(in) :: groupHandle
      integer, intent(in) :: ph
    end subroutine thermal_restartWrite

    module subroutine damage_restartWrite(groupHandle,ph)
      integer(HID_T), intent(in) :: groupHandle
      integer, intent(in) :: ph
    end subroutine damage_restartWrite

    module subroutine chemical_restartWrite(groupHandle,ph)
      integer(HID_T), intent(in) :: groupHandle
      integer, intent(in) :: ph
    end subroutine chemical_restartWrite

    module subroutine mechanical_restartRead(groupHandle,ph)
      integer(HID_T), intent(in) :: groupHandle
      integer, intent(in) :: ph
    end subroutine mechanical_restartRead

    module subroutine thermal_restartRead(groupHandle,ph)
      integer(HID_T), intent(in) :: groupHandle
      integer, intent(in) :: ph
    end subroutine thermal_restartRead

    module subroutine damage_restartRead(groupHandle,ph)
      integer(HID_T), intent(in) :: groupHandle
      integer, intent(in) :: ph
    end subroutine damage_restartRead

    module subroutine chemical_restartRead(groupHandle,ph)
      integer(HID_T), intent(in) :: groupHandle
      integer, intent(in) :: ph
    end subroutine chemical_restartRead

    module function mechanical_S(ph,en) result(S)
      integer, intent(in) :: ph,en
      real(pREAL), dimension(3,3) :: S
    end function mechanical_S

    module function mechanical_L_p(ph,en) result(L_p)
      integer, intent(in) :: ph,en
      real(pREAL), dimension(3,3) :: L_p
    end function mechanical_L_p

    module function mechanical_F_e(ph,en) result(F_e)
      integer, intent(in) :: ph,en
      real(pREAL), dimension(3,3) :: F_e
    end function mechanical_F_e

    module function mechanical_F_i(ph,en) result(F_i)
      integer, intent(in) :: ph,en
      real(pREAL), dimension(3,3) :: F_i
    end function mechanical_F_i

    module function phase_F(co,ce) result(F)
      integer, intent(in) :: co, ce
      real(pREAL), dimension(3,3) :: F
    end function phase_F

    module function phase_P(co,ce) result(P)
      integer, intent(in) :: co, ce
      real(pREAL), dimension(3,3) :: P
    end function phase_P

    pure module function thermal_T(ph,en) result(T)
      integer, intent(in) :: ph,en
      real(pREAL) :: T
    end function thermal_T

    module function thermal_dot_T(ph,en) result(dot_T)
      integer, intent(in) :: ph,en
      real(pREAL) :: dot_T
    end function thermal_dot_T

    module function damage_phi(ph,en) result(phi)
      integer, intent(in) :: ph,en
      real(pREAL) :: phi
    end function damage_phi


    module subroutine phase_set_F(F,co,ce)
      real(pREAL), dimension(3,3), intent(in) :: F
      integer, intent(in) :: co, ce
    end subroutine phase_set_F

    module subroutine phase_thermal_setField(T,dot_T, co,ce)
      real(pREAL), intent(in) :: T, dot_T
      integer, intent(in) :: co, ce
    end subroutine phase_thermal_setField

    module subroutine phase_set_phi(phi,co,ce)
      real(pREAL), intent(in) :: phi
      integer, intent(in) :: co, ce
    end subroutine phase_set_phi


    module function phase_mu_phi(co,ce) result(mu)
      integer, intent(in) :: co, ce
      real(pREAL) :: mu
    end function phase_mu_phi

    module function phase_K_phi(co,ce) result(K)
      integer, intent(in) :: co, ce
      real(pREAL), dimension(3,3) :: K
    end function phase_K_phi


    module function phase_mu_T(co,ce) result(mu)
      integer, intent(in) :: co, ce
      real(pREAL) :: mu
    end function phase_mu_T

    module function phase_K_T(co,ce) result(K)
      integer, intent(in) :: co, ce
      real(pREAL), dimension(3,3) :: K
    end function phase_K_T

! == cleaned:end ===================================================================================

    module function phase_thermal_constitutive(Delta_t,ph,en) result(status)
      real(pREAL), intent(in) :: Delta_t
      integer, intent(in) :: ph, en
      integer(kind(STATUS_OK)) :: status
    end function phase_thermal_constitutive

    module function phase_damage_constitutive(Delta_t,co,ce) result(status)
      real(pREAL), intent(in) :: Delta_t
      integer, intent(in) :: co, ce
      integer(kind(STATUS_OK)) :: status
    end function phase_damage_constitutive

    module function phase_mechanical_constitutive(Delta_t,co,ce) result(status)
      real(pREAL), intent(in) :: Delta_t
      integer, intent(in) :: co, ce
      integer(kind(STATUS_OK)) :: status
    end function phase_mechanical_constitutive

    !ToDo: Merge all the stiffness functions
    module function phase_homogenizedC66(ph,en) result(C)
      integer, intent(in) :: ph, en
      real(pREAL), dimension(6,6) :: C
    end function phase_homogenizedC66
    module function phase_damage_C66(C66,ph,en) result(C66_degraded)
      real(pREAL), dimension(6,6), intent(in)  :: C66
      integer,                     intent(in)  :: ph,en
      real(pREAL), dimension(6,6) :: C66_degraded
    end function phase_damage_C66

    module function phase_f_phi(phi,co,ce) result(f)
      integer, intent(in) :: ce,co
      real(pREAL), intent(in) :: &
        phi                                                                                         !< damage parameter
      real(pREAL) :: &
        f
    end function phase_f_phi

    module function phase_f_T(ph,en) result(f)
      integer, intent(in) :: ph, en
      real(pREAL) :: f
    end function phase_f_T

    module subroutine plastic_dependentState(ph,en)
      integer, intent(in) :: &
        ph, &
        en
    end subroutine plastic_dependentState


    module subroutine damage_anisobrittle_LiAndItsTangent(L_i, dL_i_dM_i, M_i, ph,en)
      integer, intent(in) :: ph, en
      real(pREAL),   intent(in),  dimension(3,3) :: &
        M_i
      real(pREAL),   intent(out), dimension(3,3) :: &
        L_i                                                                                         !< damage velocity gradient
      real(pREAL),   intent(out), dimension(3,3,3,3) :: &
        dL_i_dM_i                                                                                   !< derivative of L_i with respect to M_i
    end subroutine damage_anisobrittle_LiAndItsTangent

    module function phase_calculate_composition(mu,co,ce) result(conc)
      real(pREAL), intent(in), dimension(:) :: mu
      integer, intent(in) :: co, ce
      real(pREAL), dimension(:), allocatable :: conc
    end function phase_calculate_composition

    module function phase_get_mobility(co,ce) result(mobility)
      integer, intent(in) :: co, ce
      real(pREAL), dimension(:,:),allocatable :: mobility
    end function phase_get_mobility

    module subroutine phase_chemical_setField(comp,Delta_t,co,ce)
      real(pREAL), dimension(:), intent(in) :: comp
      real(pREAL), intent(in) :: Delta_t
      integer, intent(in) :: co, ce
    end subroutine phase_chemical_setField

    module function phase_compositionTangent(mu,co,ce) result(comp_tangent)
      real(pREAL), dimension(:), intent(in) :: mu
      integer, intent(in) :: co, ce
      real(pREAL), dimension(:,:),allocatable :: comp_tangent
    end function phase_compositionTangent

  end interface

  public :: &
    phase_init, &
    phase_homogenizedC66, &
    phase_f_phi, &
    phase_f_T, &
    phase_K_phi, &
    phase_K_T, &
    phase_mu_phi, &
    phase_mu_T, &
    phase_result, &
    phase_allocateState, &
    phase_forward, &
    phase_restore, &
    converged, &
    phase_mechanical_constitutive, &
    phase_thermal_constitutive, &
    phase_damage_constitutive, &
    phase_mechanical_dPdF, &
    crystallite_orientations, &
    crystallite_push33ToRef, &
    phase_restartWrite, &
    phase_restartRead, &
    phase_thermal_setField, &
    phase_set_phi, &
    phase_P, &
    phase_set_F, &
    phase_F, &
    phase_calculate_composition, &
    phase_get_mobility, &
    phase_chemical_setField, &
    phase_compositionTangent

contains

!--------------------------------------------------------------------------------------------------
!> @brief Initialize constitutive models for individual physics
!--------------------------------------------------------------------------------------------------
subroutine phase_init()

  integer :: &
    ph, ce, co, ma
  type(tDict), pointer :: &
    phases, &
    phase, &
    num_phase, &
    num_mech
  character(len=:), allocatable :: refs


  print'(/,1x,a)', '<<<+-  phase init  -+>>>'; flush(IO_STDOUT)

  phases => config_material%get_dict('phase')
  allocate(phase_lattice(size(phases)))
  allocate(phase_cOverA(size(phases)),source=-1.0_pREAL)
  allocate(phase_rho(size(phases)))
  allocate(phase_O_0(size(phases)))

  do ph = 1,size(phases)
    print'(/,1x,a,i0,a)', 'phase ',ph,': '//phases%key(ph)
    phase => phases%get_dict(ph)
    refs = config_listReferences(phase,indent=3)
    if (len(refs) > 0) print'(/,1x,a)', refs
    phase_rho(ph) = phase%get_asReal('rho',defaultVal=0.0_pREAL)
    phase_lattice(ph) = phase%get_asStr('lattice')
    if (all(phase_lattice(ph) /= ['cF','cI','hP','tI'])) &
      call IO_error(130_pI16,'invalid lattice', phase_lattice(ph), emph=[2])
    if (any(phase_lattice(ph) == ['hP','tI'])) &
      phase_cOverA(ph) = phase%get_asReal('c/a')
    allocate(phase_O_0(ph)%data(count(material_ID_phase==ph)))
  end do

  do ce = 1, size(material_ID_phase,2)
    ma = discretization_materialAt((ce-1)/discretization_nIPs+1)
    do co = 1,homogenization_Nconstituents(material_ID_homogenization(ce))
      ph = material_ID_phase(co,ce)
      phase_O_0(ph)%data(material_entry_phase(co,ce)) = material_O_0(ma)%data(co)
    end do
  end do

  allocate(phase_O(size(phases)))
  do ph = 1,size(phases)
    phase_O(ph)%data = phase_O_0(ph)%data
  end do

  num_phase => config_numerics%get_dict('phase',defaultVal=emptyDict)
  num_mech  => num_phase%get_dict('mechanical', defaultVal=emptyDict)

  call mechanical_init(phases,num_mech)
  call damage_init()
  call thermal_init(phases)
  call chemical_init(phases)

  call crystallite_init()

end subroutine phase_init


!--------------------------------------------------------------------------------------------------
!> @brief Allocate the components of the state structure for a given phase
!--------------------------------------------------------------------------------------------------
subroutine phase_allocateState(state, &
                               NEntries,sizeState,sizeDotState,sizeDeltaState,offsetDeltaState)

  class(tState), intent(inout) :: &
    state
  integer, intent(in) :: &
    NEntries, &
    sizeState, &
    sizeDotState, &
    sizeDeltaState
  integer, intent(in), optional :: &
    offsetDeltaState

  state%sizeState        = sizeState
  state%sizeDotState     = sizeDotState
  state%sizeDeltaState   = sizeDeltaState
  if (present(offsetDeltaState)) then
    state%offsetDeltaState = offsetDeltaState                                                       ! ToDo: this is a fix for broken nonlocal
  else
    state%offsetDeltaState = sizeState-sizeDeltaState                                               ! deltaState occupies latter part of state by definition
  end if

  allocate(state%atol             (sizeState),          source=0.0_pREAL)
  allocate(state%state0           (sizeState,NEntries), source=0.0_pREAL)
  allocate(state%state            (sizeState,NEntries), source=0.0_pREAL)

  allocate(state%dotState      (sizeDotState,NEntries), source=0.0_pREAL)

  allocate(state%deltaState  (sizeDeltaState,NEntries), source=0.0_pREAL)
  state%deltaState2 => state%state(state%offsetDeltaState+1: &
                                   state%offsetDeltaState+state%sizeDeltaState,:)

end subroutine phase_allocateState


!--------------------------------------------------------------------------------------------------
!> @brief Restore data after homog cutback.
!--------------------------------------------------------------------------------------------------
subroutine phase_restore(ce)

  integer, intent(in) :: ce


  call mechanical_restore(ce)
  call damage_restore(ce)

end subroutine phase_restore


!--------------------------------------------------------------------------------------------------
!> @brief Forward data after successful increment.
!--------------------------------------------------------------------------------------------------
subroutine phase_forward()

  call mechanical_forward()
  call damage_forward()
  call thermal_forward()
  call chemical_forward()

end subroutine phase_forward


!--------------------------------------------------------------------------------------------------
!> @brief writes constitutive results to HDF5 output file
!--------------------------------------------------------------------------------------------------
subroutine phase_result()

  integer :: ph
  character(len=:), allocatable :: group


  call result_closeGroup(result_addGroup('/current/phase/'))
  do ph = 1, size(material_name_phase)

    group = '/current/phase/'//trim(material_name_phase(ph))//'/'
    call result_closeGroup(result_addGroup(group))
    call result_addAttribute('lattice',phase_lattice(ph),group)
    if (any(phase_lattice(ph) == ['hP','tI'])) &
      call result_addAttribute('c/a',phase_cOverA(ph),group)

    call mechanical_result(group,ph)
    call damage_result(group,ph)
    call thermal_result(group,ph)
    call chemical_result(group,ph)

  end do

end subroutine phase_result


!--------------------------------------------------------------------------------------------------
!> @brief Allocate and initialize.
!--------------------------------------------------------------------------------------------------
subroutine crystallite_init()

  integer :: &
    ce, &
    co, &                                                                                           !< counter in integration point component loop
    en, ph


  !$OMP PARALLEL DO PRIVATE(ph,en)
  do ce = 1, size(material_ID_homogenization)
    do co = 1,homogenization_Nconstituents(material_ID_homogenization(ce))
      ph = material_ID_phase(co,ce)
      en = material_entry_phase(co,ce)
      call crystallite_orientations(co,ce)
      call plastic_dependentState(ph,en)                                                          ! update dependent state variables to be consistent with basic states
    end do
  end do
  !$OMP END PARALLEL DO


end subroutine crystallite_init


!--------------------------------------------------------------------------------------------------
!> @brief Update orientations and, if needed, compatibility.
!--------------------------------------------------------------------------------------------------
subroutine crystallite_orientations(co,ce)

  integer, intent(in) :: &
    co, &
    ce

  integer :: ph, en


  ph = material_ID_phase(co,ce)
  en = material_entry_phase(co,ce)

  call phase_O(ph)%data(en)%fromMatrix(transpose(math_rotationalPart(mechanical_F_e(ph,en))))

end subroutine crystallite_orientations


!--------------------------------------------------------------------------------------------------
!> @brief Map 2nd order tensor to reference configuration.
!--------------------------------------------------------------------------------------------------
function crystallite_push33ToRef(co,ce, tensor33)

  real(pREAL), dimension(3,3), intent(in) :: tensor33
  integer, intent(in):: &
    co, &
    ce
  real(pREAL), dimension(3,3) :: crystallite_push33ToRef

  real(pREAL), dimension(3,3) :: T
  integer :: ph, en


  ph = material_ID_phase(co,ce)
  en = material_entry_phase(co,ce)
  T = matmul(phase_O_0(ph)%data(en)%asMatrix(),transpose(math_inv33(phase_F(co,ce))))               ! ToDo: initial orientation correct?

  crystallite_push33ToRef = matmul(transpose(T),matmul(tensor33,T))

end function crystallite_push33ToRef


!--------------------------------------------------------------------------------------------------
!> @brief Determine whether a point is converged.
!--------------------------------------------------------------------------------------------------
logical pure function converged(residuum,state,atol)

  real(pREAL), intent(in), dimension(:) :: &
    residuum, state, atol

  real(pREAL) :: &
    rTol


  rTol = num%rTol_crystalliteState

  converged = all(abs(residuum) <= max(atol, rtol*abs(state)))

end function converged


!--------------------------------------------------------------------------------------------------
!> @brief Write restart data to file.
!--------------------------------------------------------------------------------------------------
subroutine phase_restartWrite(fileHandle)

  integer(HID_T), intent(in) :: fileHandle

  integer(HID_T), dimension(2) :: groupHandle
  integer :: ph


  groupHandle(1) = HDF5_addGroup(fileHandle,'phase')

  do ph = 1, size(material_name_phase)

    groupHandle(2) = HDF5_addGroup(groupHandle(1),material_name_phase(ph))

    call mechanical_restartWrite(groupHandle(2),ph)
    call thermal_restartWrite(groupHandle(2),ph)
    call damage_restartWrite(groupHandle(2),ph)
    call chemical_restartWrite(groupHandle(2),ph)

    call HDF5_closeGroup(groupHandle(2))

  end do

  call HDF5_closeGroup(groupHandle(1))

end subroutine phase_restartWrite


!--------------------------------------------------------------------------------------------------
!> @brief Read restart data from file.
!--------------------------------------------------------------------------------------------------
subroutine phase_restartRead(fileHandle)

  integer(HID_T), intent(in) :: fileHandle

  integer(HID_T), dimension(2) :: groupHandle
  integer :: ph


  groupHandle(1) = HDF5_openGroup(fileHandle,'phase')

  do ph = 1, size(material_name_phase)

    groupHandle(2) = HDF5_openGroup(groupHandle(1),material_name_phase(ph))

    call mechanical_restartRead(groupHandle(2),ph)
    call thermal_restartRead(groupHandle(2),ph)
    call damage_restartRead(groupHandle(2),ph)
    call chemical_restartRead(groupHandle(2),ph)

    call HDF5_closeGroup(groupHandle(2))

  end do

  call HDF5_closeGroup(groupHandle(1))

end subroutine phase_restartRead


end module phase

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, KU Leuven
!--------------------------------------------------------------------------------------------------
submodule(homogenization) thermal

  interface

    module subroutine pass_init
    end subroutine pass_init

    module subroutine isotemperature_init
    end subroutine isotemperature_init

  end interface

  type :: tDataContainer
    real(pREAL), dimension(:), allocatable :: T, dot_T
  end type tDataContainer

  type(tDataContainer), dimension(:), allocatable :: current

  type :: tParameters
    character(len=pSTRLEN), allocatable, dimension(:) :: &
      output
  end type tParameters

  type(tparameters),             dimension(:), allocatable :: &
    param


contains

!--------------------------------------------------------------------------------------------------
!> @brief Allocate variables and set parameters.
!--------------------------------------------------------------------------------------------------
module subroutine thermal_init()

  type(tDict), pointer :: &
    configHomogenizations, &
    configHomogenization, &
    configHomogenizationThermal
  integer :: ho


  print'(/,1x,a)', '<<<+-  homogenization:thermal init  -+>>>'


  configHomogenizations => config_material%get_dict('homogenization')
  allocate(param(size(configHomogenizations)))
  allocate(current(size(configHomogenizations)))

  do ho = 1, size(configHomogenizations)
    allocate(current(ho)%T(count(material_ID_homogenization==ho)), source=T_ROOM)
    allocate(current(ho)%dot_T(count(material_ID_homogenization==ho)), source=0.0_pREAL)
    configHomogenization => configHomogenizations%get_dict(ho)
    associate(prm => param(ho))

      if (configHomogenization%contains('thermal')) then
        configHomogenizationThermal => configHomogenization%get_dict('thermal')
#if defined (__GFORTRAN__)
        prm%output = output_as1dStr(configHomogenizationThermal)
#else
        prm%output = configHomogenizationThermal%get_as1dStr('output',defaultVal=emptyStrArray)
#endif
        select case (configHomogenizationThermal%get_asStr('type'))

          case ('pass')
            call pass_init()

          case ('isotemperature')
            call isotemperature_init()

        end select
      else
        prm%output = emptyStrArray
      end if

    end associate
  end do

end subroutine thermal_init


!--------------------------------------------------------------------------------------------------
!> @brief Check if thermal homogemization description is present in the configuration file
!--------------------------------------------------------------------------------------------------
module function homogenization_thermal_active() result(active)

  logical :: active

  active = any(thermal_active(:))

end function homogenization_thermal_active


!--------------------------------------------------------------------------------------------------
!> @brief Partition temperature onto the individual constituents.
!--------------------------------------------------------------------------------------------------
module subroutine thermal_partition(ce)

  integer, intent(in) :: ce

  real(pREAL) :: T, dot_T
  integer :: co


  T     = current(material_ID_homogenization(ce))%T(material_entry_homogenization(ce))
  dot_T = current(material_ID_homogenization(ce))%dot_T(material_entry_homogenization(ce))
  do co = 1, homogenization_Nconstituents(material_ID_homogenization(ce))
    call phase_thermal_setField(T,dot_T,co,ce)
  end do

end subroutine thermal_partition


!--------------------------------------------------------------------------------------------------
!> @brief Homogenize thermal viscosity.
!--------------------------------------------------------------------------------------------------
module function homogenization_mu_T(ce) result(mu)

  integer, intent(in) :: ce
  real(pREAL) :: mu

  integer :: co


  mu = phase_mu_T(1,ce)*material_v(1,ce)
  do co = 2, homogenization_Nconstituents(material_ID_homogenization(ce))
    mu = mu + phase_mu_T(co,ce)*material_v(co,ce)
  end do

end function homogenization_mu_T


!--------------------------------------------------------------------------------------------------
!> @brief Homogenize thermal conductivity.
!--------------------------------------------------------------------------------------------------
module function homogenization_K_T(ce) result(K)

  integer, intent(in) :: ce
  real(pREAL), dimension(3,3) :: K

  integer :: co


  K = phase_K_T(1,ce)*material_v(1,ce)
  do co = 2, homogenization_Nconstituents(material_ID_homogenization(ce))
    K = K + phase_K_T(co,ce)*material_v(co,ce)
  end do

end function homogenization_K_T


!--------------------------------------------------------------------------------------------------
!> @brief Homogenize heat generation rate.
!--------------------------------------------------------------------------------------------------
module function homogenization_f_T(ce) result(f)

  integer, intent(in) :: ce
  real(pREAL) :: f

  integer :: co


  f = phase_f_T(material_ID_phase(1,ce),material_entry_phase(1,ce))*material_v(1,ce)
  do co = 2, homogenization_Nconstituents(material_ID_homogenization(ce))
    f = f + phase_f_T(material_ID_phase(co,ce),material_entry_phase(co,ce))*material_v(co,ce)
  end do

end function homogenization_f_T


!--------------------------------------------------------------------------------------------------
!> @brief Set thermal field and its rate (T and dot_T).
!--------------------------------------------------------------------------------------------------
module subroutine homogenization_thermal_setField(T,dot_T)

  real(pREAL), dimension(:), intent(in) :: T, dot_T

  integer :: ho, en, ce


  do ce=max(lbound(T,1),lbound(dot_T,1)), min(ubound(T,1),ubound(dot_T,1))
    ho = material_ID_homogenization(ce)
    en = material_entry_homogenization(ce)
    current(ho)%T(en) = T(ce)
    current(ho)%dot_T(en) = dot_T(ce)
    call thermal_partition(ce)
  end do

end subroutine homogenization_thermal_setField


!--------------------------------------------------------------------------------------------------
!> @brief writes results to HDF5 output file
!--------------------------------------------------------------------------------------------------
module subroutine thermal_result(ho,group)

  integer,          intent(in) :: ho
  character(len=*), intent(in) :: group

  integer :: o


  associate(prm => param(ho))
    outputsLoop: do o = 1,size(prm%output)
      select case(trim(prm%output(o)))
        case('T')
          call result_writeDataset(current(ho)%T,group,'T','temperature','K')
      end select
    end do outputsLoop
  end associate

end subroutine thermal_result

end submodule thermal

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Luc Hantcherli, Max-Planck-Institut für Eisenforschung GmbH
!> @author W.A. Counts
!> @author Denny Tjahjanto, Max-Planck-Institut für Eisenforschung GmbH
!> @author Christoph Kords, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Interfaces DAMASK with MSC.Marc
!--------------------------------------------------------------------------------------------------
#ifdef linux
#undef linux
#endif

#ifdef unix
#undef unix
#endif

#ifdef DAMASKVERSION
#define DAMASK_VERSION DAMASKVERSION
#endif

#include "../prec.f90"
#include "../C_interfacing.f90"
#include "../constants.f90"
#include "../parallelization.f90"
#include "../misc.f90"
#include "../IO.f90"
#include "../types.f90"
#include "../YAML.f90"
#include "../HDF5_utilities.f90"
#include "IO_Marc.f90"

module DAMASK_interface
  use, intrinsic :: ISO_fortran_env, only: &
    compiler_version, &
    compiler_options
  use ifport, only: &
    CHDIR

  use prec
  use IO
  use IO_Marc

  implicit none(type,external)
  private

  type, public :: tLoadcase
    character(len=32) :: lname
    integer           :: frequency
  end type tLoadcase

  type(tLoadcase), allocatable, protected, public :: loadcase(:)
  logical,          protected, public             :: symmetricSolver
  character(len=*), parameter, public             :: INPUTFILEEXTENSION = '.dat'
  character(len=:), allocatable, public           :: CLI_jobName
  integer, save, public                           :: inc_written


  public :: &
    DAMASK_interface_init, &
    getOutputFrequency

contains

!--------------------------------------------------------------------------------------------------
!> @brief Report and set working directory.
!--------------------------------------------------------------------------------------------------
subroutine DAMASK_interface_init()

  integer, dimension(8)   :: dateAndTime
  integer                 :: ierr
  character(len=pPATHLEN) :: wd


  print'(/,1x,a)', '<<<+-  DAMASK_Marc init -+>>>'

  print*, 'Roters et al., Computational Materials Science 158:420–478, 2019'
  print*, 'https://doi.org/10.1016/j.commatsci.2018.04.030'

  print'(/,a)', ' Version: '//DAMASKVERSION

  print'(/,a)', ' Compiled with: '//compiler_version()
  print'(a)',   ' Compiler options: '//compiler_options()

  print'(/,a)', ' Compiled on: '//__DATE__//' at '//__TIME__

  call date_and_time(values = dateAndTime)
  print'(/,a,2(i2.2,a),i4.4)', ' Date: ',dateAndTime(3),'/',dateAndTime(2),'/', dateAndTime(1)
  print'(a,2(i2.2,a),i2.2)',   ' Time: ',dateAndTime(5),':', dateAndTime(6),':', dateAndTime(7)

  inquire(5, name=wd)
  wd = wd(1:scan(wd,'/',back=.true.))
  ierr = CHDIR(wd)
  if (ierr /= 0) then
    print*, 'working directory "'//trim(wd)//'" does not exist'
    call quit(1)
  end if
  CLI_jobName = getSolverJobName()

  symmetricSolver = solverIsSymmetric()
  call getOutputFrequency

end subroutine DAMASK_interface_init


!--------------------------------------------------------------------------------------------------
!> @brief Return stem of Marc input file as solver job name.
!--------------------------------------------------------------------------------------------------
function getSolverJobName()

  character(len=:), allocatable :: getSolverJobName
  character(1024)               :: inputName
  character(len=*), parameter   :: pathSep = achar(47)//achar(92)                                   ! forward and backward slash
  integer :: extPos

  inquire(5, name=inputName)                                                                        ! determine inputfile
  extPos = len_trim(inputName)-4
  getSolverJobName=inputName(scan(inputName,pathSep,back=.true.)+1:extPos)

end function getSolverJobName


!--------------------------------------------------------------------------------------------------
!> @brief Determine whether a symmetric solver is used.
!--------------------------------------------------------------------------------------------------
logical function solverIsSymmetric()

  character(len=pSTRLEN) :: line
  integer :: myStat,fileUnit,s,e

  open(newunit=fileUnit, file=CLI_jobName//INPUTFILEEXTENSION, &
       status='old', position='rewind', action='read',iostat=myStat)
  do
    read (fileUnit,'(A)',END=100) line
    if (index(trim(IO_lc(line)),'solver') == 1) then
      read (fileUnit,'(A)',END=100) line                                                            ! next line
        s =     verify(line,      ' ')                                                              ! start of first chunk
        s = s + verify(line(s+1:),' ')                                                              ! start of second chunk
        e = s + scan  (line(s+1:),' ')                                                              ! end of second chunk
      solverIsSymmetric = line(s:e) /= '1'
    end if
  end do
100 close(fileUnit)

end function solverIsSymmetric

!--------------------------------------------------------------------------------------------------
!> @brief Determine and report output frequency of each loadcase.
!--------------------------------------------------------------------------------------------------
subroutine getOutputFrequency

  integer :: mystat, fileunit, number_loadcases, i
  character(len=pSTRLEN) :: line
  integer, allocatable, dimension(:) :: chunkPos

  open(newunit=fileUnit, file=CLI_jobName//INPUTFILEEXTENSION, &
       status='old', position='rewind', action='read',iostat=myStat)
  number_loadcases = 0
  do
    read (fileUnit,'(A)',END=100) line
    chunkPos = strPos(line)
    if (chunkPos(1) < 4) cycle
    if (IO_lc(strValue(line,chunkPos,1)) == '$....start') then
      if (IO_lc(strValue(line,chunkPos,2)) == 'of') then
        if (IO_lc(strValue(line,chunkPos,3)) == 'loadcase') then
          number_loadcases = number_loadcases + 1
        end if
      end if
    end if
  end do
100 rewind(fileUnit)
  allocate(loadcase(number_loadcases))
  i=0
  do
    read (fileUnit,'(A)',END=200) line
    chunkPos = strPos(line)
    if (chunkPos(1) < 1) cycle
    if (IO_lc(strValue(line,chunkPos,1)) == 'post') then
      if (chunkPos(1) == 1) then
        read (fileUnit,'(A)',END=200) line
        chunkPos = strPos(line)
        loadcase(1)%frequency = IO_strAsInt(strValue(line,chunkPos,9))
      elseif (IO_lc(strValue(line,chunkPos,2)) == 'increment') then
        read (fileUnit,'(A)',END=200) line
        chunkPos = strPos(line)
        if (IO_strAsInt(strValue(line,chunkPos,1)) /= 0) then                                       ! change output frequency only if specified by number of incs
          loadcase(i)%frequency = IO_strAsInt(strValue(line,chunkPos,1))
        end if
      end if
    end if
    if (IO_lc(strValue(line,chunkPos,1)) == '$....start') then
      if (IO_lc(strValue(line,chunkPos,2)) == 'of') then
        if (IO_lc(strValue(line,chunkPos,3)) == 'loadcase') then
          i = i + 1
          loadcase(i)%lname = IO_lc(strValue(line,chunkPos,4))
          loadcase(i)%frequency = loadcase(max(1,i-1))%frequency
        end if
      end if
    end if
  end do
200 close(fileUnit)
  print *
  print '(a,i3)', ' number of loadcases: ', number_loadcases
  print *
  print '(a33, a)', ' loadcase name                   ', 'write frequency'
  do i = 1, number_loadcases
    print '(2a,i3)', ' ', loadcase(i)
  end do

end subroutine getOutputFrequency

end module DAMASK_interface

#include "../result.f90"
#include "../config.f90"
#include "../LAPACK_interface.f90"
#include "../math.f90"
#include "../rotations.f90"
#include "../polynomials.f90"
#include "../tables.f90"
#include "../crystal.f90"
#include "element.f90"
#include "../geometry_plastic_nonlocal.f90"
#include "../discretization.f90"
#include "discretization_Marc.f90"
#include "../material.f90"
#include "../phase.f90"
#include "../phase_mechanical.f90"
#include "../phase_mechanical_elastic.f90"
#include "../phase_mechanical_plastic.f90"
#include "../phase_mechanical_plastic_none.f90"
#include "../phase_mechanical_plastic_isotropic.f90"
#include "../phase_mechanical_plastic_phenopowerlaw.f90"
#include "../phase_mechanical_plastic_kinehardening.f90"
#include "../phase_mechanical_plastic_dislotwin.f90"
#include "../phase_mechanical_plastic_dislotungsten.f90"
#include "../phase_mechanical_plastic_nonlocal.f90"
#include "../phase_mechanical_eigen.f90"
#include "../phase_mechanical_eigen_thermalexpansion.f90"
#include "../phase_thermal.f90"
#include "../phase_thermal_source_dissipation.f90"
#include "../phase_thermal_source_externalheat.f90"
#include "../phase_damage.f90"
#include "../phase_damage_isobrittle.f90"
#include "../phase_damage_anisobrittle.f90"
#include "../phase_chemical.f90"
#include "../phase_chemical_quadenergy.f90"
#include "../phase_chemical_regularsolution.f90"
#include "../homogenization.f90"
#include "../homogenization_mechanical.f90"
#include "../homogenization_mechanical_pass.f90"
#include "../homogenization_mechanical_isostrain.f90"
#include "../homogenization_mechanical_RGC.f90"
#include "../homogenization_thermal.f90"
#include "../homogenization_thermal_pass.f90"
#include "../homogenization_thermal_isotemperature.f90"
#include "../homogenization_damage.f90"
#include "../homogenization_damage_pass.f90"
#include "../homogenization_chemical.f90"
#include "../homogenization_chemical_pass.f90"
#include "materialpoint_Marc.f90"

!--------------------------------------------------------------------------------------------------
!> @brief This is the MSC.Marc user subroutine for defining material behavior.
!> @details (1) F,R,U are only available for continuum and membrane elements (not for
!> @details     shells and beams).
!> @details
!> @details (2) Use the -> 'Plasticity,3' card(=update+finite+large disp+constant d)
!> @details     in the parameter section of input deck (updated Lagrangian formulation).
!--------------------------------------------------------------------------------------------------
subroutine hypela2(d,g,e,de,s,t,dt,ngens,m,nn,kcus,matus,ndi,nshear,disp, &
                   dispt,coord,ffn,frotn,strechn,eigvn,ffn1,frotn1, &
                   strechn1,eigvn1,ncrd,itel,ndeg,ndm,nnode, &
                   jtype,lclass,ifr,ifu)
  use prec
  use DAMASK_interface
  use config
  use types
  use discretization_Marc
  use homogenization
  use materialpoint_Marc
  use OMP_LIB

  implicit none(type,external)
  integer(pI64),                         intent(in) :: &                                            ! according to MSC.Marc 2012 Manual D
    ngens, &                                                                                        !< size of stress-strain law
    nn, &                                                                                           !< integration point number
    ndi, &                                                                                          !< number of direct components
    nshear, &                                                                                       !< number of shear components
    ncrd, &                                                                                         !< number of coordinates
    itel, &                                                                                         !< dimension of F and R, either 2 or 3
    ndeg, &                                                                                         !< number of degrees of freedom
    ndm, &                                                                                          !< not specified in MSC.Marc 2012 Manual D
    nnode, &                                                                                        !< number of nodes per element
    jtype, &                                                                                        !< element type
    ifr, &                                                                                          !< set to 1 if R has been calculated
    ifu                                                                                             !< set to 1 if stretch has been calculated
  integer(pI64), dimension(2),           intent(in) :: &                                            ! according to MSC.Marc 2012 Manual D
    m, &                                                                                            !< (1) user element number, (2) internal element number
    matus, &                                                                                        !< (1) user material identification number, (2) internal material identification number
    kcus, &                                                                                         !< (1) layer number, (2) internal layer number
    lclass                                                                                          !< (1) element class, (2) 0: displacement, 1: low order Herrmann, 2: high order Herrmann
  real(pREAL),   dimension(*),           intent(in) :: &                                            ! has dimension(1) according to MSC.Marc 2012 Manual D, but according to example hypela2.f dimension(*)
    e, &                                                                                            !< total elastic strain
    de, &                                                                                           !< increment of strain
    dt                                                                                              !< increment of state variables
  real(pREAL),   dimension(itel),        intent(in) :: &                                            ! according to MSC.Marc 2012 Manual D
    strechn, &                                                                                      !< square of principal stretch ratios, lambda(i) at t=n
    strechn1                                                                                        !< square of principal stretch ratios, lambda(i) at t=n+1
  real(pREAL),   dimension(3,3),         intent(in) :: &                                            ! has dimension(itel,*) according to MSC.Marc 2012 Manual D, but we alway assume dimension(3,3)
    ffn, &                                                                                          !< deformation gradient at t=n
    ffn1                                                                                            !< deformation gradient at t=n+1
  real(pREAL),   dimension(itel,*),      intent(in) :: &                                            ! according to MSC.Marc 2012 Manual D
    frotn, &                                                                                        !< rotation tensor at t=n
    eigvn, &                                                                                        !< i principal direction components for j eigenvalues at t=n
    frotn1, &                                                                                       !< rotation tensor at t=n+1
    eigvn1                                                                                          !< i principal direction components for j eigenvalues at t=n+1
  real(pREAL),   dimension(ndeg,*),      intent(in) :: &                                            ! according to MSC.Marc 2012 Manual D
    disp, &                                                                                         !< incremental displacements
    dispt                                                                                           !< displacements at t=n (at assembly, lovl=4) and displacements at t=n+1 (at stress recovery, lovl=6)
  real(pREAL),   dimension(ncrd,*),      intent(in) :: &                                            ! according to MSC.Marc 2012 Manual D
    coord                                                                                           !< coordinates
  real(pREAL),   dimension(*),           intent(inout) :: &                                         ! according to MSC.Marc 2012 Manual D
    t                                                                                               !< state variables (comes in at t=n, must be updated to have state variables at t=n+1)
  real(pREAL),   dimension(ndi+nshear),  intent(out) :: &                                           ! has dimension(*) according to MSC.Marc 2012 Manual D, but we need to loop over it
    s, &                                                                                            !< stress - should be updated by user
    g                                                                                               !< change in stress due to temperature effects
  real(pREAL),   dimension(ngens,ngens), intent(out) :: &                                           ! according to MSC.Marc 2012 Manual D, but according to example hypela2.f dimension(ngens,*)
    d                                                                                               !< stress-strain law to be formed

!--------------------------------------------------------------------------------------------------
! Marc common blocks are in fixed format so they have to be interpreted accordingly

!DIR$ NOFREEFORM
#include "concom"                                                                                   ! concom is needed for inc, lovl
#include "creeps"                                                                                   ! creeps is needed for timinc (time increment)
!DIR$ FREEFORM

  logical :: cutBack
  real(pREAL), dimension(6) ::   stress
  real(pREAL), dimension(6,6) :: ddsdde
  integer :: computationMode, i, node, CPnodeID
  integer(pI32) :: defaultNumThreadsInt                                                             !< default value set by Marc

  integer, save :: &
    theInc       = -1, &                                                                            !< last processed increment
    lastLovl     =  0                                                                               !< lovl in previous call to marc hypela2
  real(pREAL), save :: &
    theTime      = 0.0_pREAL, &                                                                     !< last processed time
    theDelta     = 0.0_pREAL                                                                        !< last processed time increment
  logical, save :: &
    lastIncConverged  = .false., &                                                                  !< flag indicating convergence of last increment
    outdatedByNewInc  = .false., &                                                                  !< flag for updating results
    materialpoint_init_done   = .false.                                                             !< remember whether init has been done already


  defaultNumThreadsInt = omp_get_num_threads()                                                      ! remember number of threads set by Marc
  call omp_set_num_threads(1_pI32)                                                                  ! no openMP

  if (.not. materialpoint_init_done) then
    materialpoint_init_done = .true.
    call materialpoint_initAll()
  end if

  computationMode = 0                                                                               ! save initialization value, since it does not result in any calculation
  if (lovl == 4 ) then                                                                              ! jacobian requested by marc
    if (timinc < theDelta .and. theInc == inc .and. lastLovl /= lovl) &                             ! first after cutback
      computationMode = materialpoint_RESTOREJACOBIAN
  elseif (lovl == 6) then                                                                           ! stress requested by marc
    computationMode = materialpoint_CALCRESULTS
    if (cptim > theTime .or. inc /= theInc) then                                                    ! reached "convergence"
      cycleCounter = -1                                                                             ! first calc step increments this to cycle = 0
      if (inc == 0) then                                                                            ! >> start of analysis <<
        lastIncConverged = .false.
        outdatedByNewInc = .false.
        lastLovl = lovl                                                                             ! pretend that this is NOT the first after a lovl change
        print'(a,i6,1x,i2)', '<< HYPELA2 >> start of analysis..! ',m(1),nn
      else if (inc - theInc > 1) then                                                               ! >> restart of broken analysis <<
        lastIncConverged = .false.
        outdatedByNewInc = .false.
        print'(a,i6,1x,i2)', '<< HYPELA2 >> restart of analysis..! ',m(1),nn
      else                                                                                          ! >> just the next inc <<
        lastIncConverged = .true.
        outdatedByNewInc = .true.
        print'(a,i6,1x,i2)', '<< HYPELA2 >> new increment..! ',m(1),nn
      end if
    else if ( timinc < theDelta ) then                                                              ! >> cutBack <<
      lastIncConverged = .false.
      outdatedByNewInc = .false.
      cycleCounter = -1                                                                             ! first calc step increments this to cycle = 0
      print'(a,i6,1x,i2)', '<< HYPELA2 >> cutback detected..! ',m(1),nn
    end if                                                                                          ! convergence treatment end
    flush(6)

    if (lastLovl /= lovl) then
      cycleCounter  = cycleCounter + 1
      !mesh_cellnode = mesh_build_cellnodes()                                                       ! update cell node coordinates
      !call mesh_build_ipCoordinates()                                                              ! update ip coordinates
    end if
    if (outdatedByNewInc) then
      computationMode = ior(computationMode,materialpoint_AGERESULTS)
      outdatedByNewInc = .false.
    end if
    if (lastIncConverged) then
      computationMode = ior(computationMode,materialpoint_BACKUPJACOBIAN)
      lastIncConverged = .false.
    end if

    theTime  = cptim
    theDelta = timinc
    theInc   = inc

  end if
  lastLovl = lovl

  call materialpoint_general(computationMode,ffn,ffn1,t(1),timinc,int(m(1)),int(nn),stress,ddsdde)

  d = ddsdde(1:ngens,1:ngens)
  s = stress(1:ndi+nshear)
  g = 0.0_pREAL
  if (symmetricSolver) d = 0.5_pREAL*(d+transpose(d))

  call omp_set_num_threads(defaultNumThreadsInt)                                                    ! reset number of threads to stored default value

end subroutine hypela2


!--------------------------------------------------------------------------------------------------
!> @brief Calculate internal heat generated due to inelastic energy dissipation.
!--------------------------------------------------------------------------------------------------
subroutine flux(f,ts,n,time)
  use prec
  use homogenization
  use discretization_Marc

  implicit none(type,external)
  real(pREAL),   dimension(6),  intent(in) :: &
    ts
  integer(pI64), dimension(10), intent(in) :: &
    n
  real(pREAL),                  intent(in) :: &
    time
  real(pREAL),   dimension(2),  intent(out) :: &
    f


  f(1) = homogenization_f_T(discretization_Marc_FEM2DAMASK_cell(int(n(3)),int(n(1))))
  f(2) = 0.0_pREAL

 end subroutine flux


!--------------------------------------------------------------------------------------------------
!> @brief Trigger writing of results.
!> @details uedinc is called before each new increment, not at the end of a converged one.
!> Therefore, storing the last written inc with an 'save' variable is required to avoid writing the
! same increment multiple times.
!--------------------------------------------------------------------------------------------------
subroutine uedinc(inc,incsub)
  use prec
  use IO
  use materialpoint_Marc
  use discretization_Marc
  use DAMASK_interface

  implicit none(type,external)

  external :: nodvar
  integer(pI64), intent(in) :: inc, incsub

  integer :: i, n, nqncomp, nqdatatype
  integer, save :: write_freq = 1, start_inc
  real(pREAL), allocatable, dimension(:,:) :: d_n
  character(len=32), save :: old_loadcase

! Marc common blocks are in fixed format so they have to be interpreted accordingly
!DIR$ NOFREEFORM
#include "bclabel"                                                                                  ! bclabel is needed for ldcasename (load case name)
#include "creeps"                                                                                   ! creeps is needed for cptim (time at beginning of increment)
!DIR$ FREEFORM


  if (ldcasename /= old_loadcase) then
    do i = 1 , size(loadcase)
      if (IO_lc(ldcasename) == loadcase(i)%lname) then
        write_freq = loadcase(i)%frequency
        exit
      end if
    end do
    old_loadcase = ldcasename
    start_inc = int(inc) -1
  end if
  if (modulo(int(inc) - start_inc, write_freq) == 0 .and. inc > inc_written) then
    allocate(d_n(3,count(discretization_Marc_FEM2DAMASK_node /= -1)))
    do n = lbound(discretization_Marc_FEM2DAMASK_node,1), ubound(discretization_Marc_FEM2DAMASK_node,1)
      if (discretization_Marc_FEM2DAMASK_node(n) /= -1) then
        call nodvar(1,n,d_n(1:3,discretization_Marc_FEM2DAMASK_node(n)),nqncomp,nqdatatype)
        if (nqncomp == 2) d_n(3,discretization_Marc_FEM2DAMASK_node(n)) = 0.0_pREAL
      end if
    end do

    call discretization_Marc_UpdateNodeAndIpCoords(d_n)
    call materialpoint_result(int(inc),cptim)

    inc_written = int(inc)
  end if

end subroutine uedinc

!--------------------------------------------------------------------------------------------------
!> @brief Trigger writing of results.
!> @details uedjob is called twice at the end of a Marc job.
!> At this point inc has already been inceased by 1, therefore, (inc-1) needs to be compared with
! the last written inc to avoid writing the last increment multiple times.
!--------------------------------------------------------------------------------------------------
subroutine uedjob(icall,iexit)
  use prec
  use materialpoint_Marc
  use discretization_Marc
  use DAMASK_interface

  implicit none(type,external)

  external :: nodvar
  integer(pI64), intent(in) :: icall,iexit

  integer :: n, nqncomp, nqdatatype
  real(pREAL), allocatable, dimension(:,:) :: d_n

! Marc common blocks are in fixed format so they have to be interpreted accordingly
!DIR$ NOFREEFORM
#include "concom"                                                                                   ! concom is needed for inc
#include "creeps"                                                                                   ! creeps is needed for cptim (time at beginning of increment)
!DIR$ FREEFORM

  if (icall == 0 .and. inc - 1 > inc_written) then                                                  ! write results for final inc unless already done
    allocate(d_n(3,count(discretization_Marc_FEM2DAMASK_node /= -1)))
    do n = lbound(discretization_Marc_FEM2DAMASK_node,1), ubound(discretization_Marc_FEM2DAMASK_node,1)
      if (discretization_Marc_FEM2DAMASK_node(n) /= -1) then
        call nodvar(1,n,d_n(1:3,discretization_Marc_FEM2DAMASK_node(n)),nqncomp,nqdatatype)
        if (nqncomp == 2) d_n(3,discretization_Marc_FEM2DAMASK_node(n)) = 0.0_pREAL
      end if
    end do

    call discretization_Marc_UpdateNodeAndIpCoords(d_n)
    call materialpoint_result(int(inc - 1),cptim)

    inc_written = int(inc)
    print *, 'inc',  inc_written
  end if

end subroutine uedjob

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, KU Leuven
!> @author Philip Eisenlohr, Michigan State University
!> @brief Miscellaneous tools.
!--------------------------------------------------------------------------------------------------
module misc
  use prec
  use constants

  implicit none(type,external)
  private

  interface misc_optional
    module procedure misc_optional_bool
    module procedure misc_optional_pI32
    module procedure misc_optional_pI64
    module procedure misc_optional_real
    module procedure misc_optional_complex
    module procedure misc_optional_str
  end interface misc_optional

  public :: &
    misc_init, &
    misc_selfTest, &
    misc_optional, &
    misc_prefixOptions, &
    misc_ones, &
    misc_zeros

contains


!--------------------------------------------------------------------------------------------------
!> @brief Do self test.
!--------------------------------------------------------------------------------------------------
subroutine misc_init()

  print'(/,1x,a)', '<<<+-  misc init  -+>>>'

  call misc_selfTest()

end subroutine misc_init


!--------------------------------------------------------------------------------------------------
!> @brief Return bool value if given, otherwise default.
!--------------------------------------------------------------------------------------------------
pure elemental function misc_optional_bool(given,default) result(var)

  logical, intent(in), optional :: given
  logical, intent(in)           :: default
  logical                       :: var


  if (present(given)) then
    var = given
  else
    var = default
  end if

end function misc_optional_bool


!--------------------------------------------------------------------------------------------------
!> @brief Return integer(pI32) value if given, otherwise default.
!--------------------------------------------------------------------------------------------------
pure elemental function misc_optional_pI32(given,default) result(var)

  integer(pI32), intent(in), optional :: given
  integer(pI32), intent(in)           :: default
  integer(pI32)                       :: var


  if (present(given)) then
    var = given
  else
    var = default
  end if

end function misc_optional_pI32


!--------------------------------------------------------------------------------------------------
!> @brief Return integer(pI64) value if given, otherwise default.
!--------------------------------------------------------------------------------------------------
pure elemental function misc_optional_pI64(given,default) result(var)

  integer(pI64), intent(in), optional :: given
  integer(pI64), intent(in)           :: default
  integer(pI64)                       :: var


  if (present(given)) then
    var = given
  else
    var = default
  end if

end function misc_optional_pI64


!--------------------------------------------------------------------------------------------------
!> @brief Return real value if given, otherwise default.
!--------------------------------------------------------------------------------------------------
pure elemental function misc_optional_real(given,default) result(var)

  real(pREAL), intent(in), optional :: given
  real(pREAL), intent(in)           :: default
  real(pREAL)                       :: var


  if (present(given)) then
    var = given
  else
    var = default
  end if

end function misc_optional_real


!--------------------------------------------------------------------------------------------------
!> @brief Return complex value if given, otherwise default.
!--------------------------------------------------------------------------------------------------
pure elemental function misc_optional_complex(given,default) result(var)

  complex(pREAL), intent(in), optional :: given
  complex(pREAL), intent(in)           :: default
  complex(pREAL)                       :: var


  if (present(given)) then
    var = given
  else
    var = default
  end if

end function misc_optional_complex

!--------------------------------------------------------------------------------------------------
!> @brief Return string value if given, otherwise default.
!--------------------------------------------------------------------------------------------------
pure function misc_optional_str(given,default) result(var)

  character(len=*), intent(in), optional :: given
  character(len=*), intent(in)           :: default
  character(len=:), allocatable          :: var


  if (present(given)) then
    var = given
  else
    var = default
  end if

end function misc_optional_str

!--------------------------------------------------------------------------------------------------
!> @brief Add prefix to options in string.
!> @detail An option starts with a dash followed by at least one letter.
!--------------------------------------------------------------------------------------------------
pure function misc_prefixOptions(string,prefix) result(prefixed)

  character(len=*), intent(in)  :: string,prefix
  character(len=:), allocatable :: prefixed

  integer :: i,N


  prefixed = ''
  N = len(string)
  do i = 1, N
    prefixed = prefixed//string(i:i)
    if (string(i:i) == '-' .and. verify(string(min(i+1,N):min(i+1,N)),LOWER//UPPER) == 0) &
      prefixed = prefixed//prefix
  end do

end function misc_prefixOptions


!--------------------------------------------------------------------------------------------------
!> @brief 1D array of zeros.
!--------------------------------------------------------------------------------------------------
pure function misc_zeros(N)

  integer, intent(in) :: N                                                                          !< number of zeros
  real(pREAL), dimension(N) :: misc_zeros


  misc_zeros = 0._pREAL

end function misc_zeros


!--------------------------------------------------------------------------------------------------
!> @brief 1D array of ones.
!--------------------------------------------------------------------------------------------------
pure function misc_ones(N)

  integer, intent(in) :: N                                                                          !< number of ones
  real(pREAL), dimension(N) :: misc_ones


  misc_ones = 1._pREAL

end function misc_ones


!--------------------------------------------------------------------------------------------------
!> @brief Check correctness of some misc functions.
!--------------------------------------------------------------------------------------------------
subroutine misc_selfTest()

  real(pREAL) :: r
  real(pREAL), dimension(:), allocatable :: rN
  character(len=:),      allocatable :: str,out
  integer :: N


  call random_number(r)
  N = int(r*99._pREAL)
  allocate(rN(N),source=0.0_pREAL)
  call random_number(rN)

  if (test_str('DAMASK') /= 'DAMASK')                        error stop 'optional_str, present'
  if (test_str() /= 'default')                               error stop 'optional_str, not present'
  if (misc_optional(default='default') /= 'default')         error stop 'optional_str, default only'
  if (test_pI32(20191102_pI32) /= 20191102_pI32)             error stop 'optional_int, present'
  if (test_pI32() /= 42_pI32)                                error stop 'optional_int, not present'
  if (misc_optional(default=20191102) /= 20191102)           error stop 'optional_int, default only'
  if (dNeq(test_real(r),r))                                  error stop 'optional_real, present'
  if (dNeq(test_real(),0.0_pREAL))                           error stop 'optional_real, not present'
  if (dNeq(misc_optional(default=r),r))                      error stop 'optional_real, default only'
  if (any(dNeq(misc_optional(default=rN),rN)))               error stop 'optional_real array, default only'
  if (test_bool(r<0.5_pREAL) .neqv. r<0.5_pREAL)             error stop 'optional_bool, present'
  if (.not. test_bool())                                     error stop 'optional_bool, not present'
  if (misc_optional(default=r>0.5_pREAL) .neqv. r>0.5_pREAL) error stop 'optional_bool, default only'

  str='-a -1 -more 123 -flag -'
  out=misc_prefixOptions(str,'p_')
  if (out /= '-p_a -1 -p_more 123 -p_flag -')                error stop 'misc_prefixOptions'

  N = int(r*99._pREAL)
  if (size(misc_zeros(N)) /= N)           error stop 'shape zeros'
  if (size(misc_ones(N)) /= N)            error stop 'shape ones'
  if (any(dNeq(misc_zeros(N),0.0_pREAL))) error stop 'value zeros'
  if (any(dNeq(misc_ones(N),1.0_pREAL)))  error stop 'value ones'

contains

  pure function test_str(str_in) result(str_out)
#ifndef __GFORTRAN__
    import, only: misc_optional_str
#endif
    character(len=:), allocatable          :: str_out
    character(len=*), intent(in), optional :: str_in


    str_out = misc_optional_str(str_in,'default')

  end function test_str


  pure function test_pI32(int_in) result(int_out)
#ifndef __GFORTRAN__
    use prec
    import, only: misc_optional_pI32
#endif
    integer(pI32)                       :: int_out
    integer(pI32), intent(in), optional :: int_in


    int_out = misc_optional_pI32(int_in,42_pI32)

  end function test_pI32


  pure function test_real(real_in) result(real_out)
#ifndef __GFORTRAN__
    use prec
    import, only: misc_optional_real
#endif
    real(pREAL)                       :: real_out
    real(pREAL), intent(in), optional :: real_in


    real_out = misc_optional_real(real_in,0.0_pREAL)

  end function test_real


  pure function test_bool(bool_in) result(bool_out)
#ifndef __GFORTRAN__
    import, only: misc_optional_bool
#endif
    logical                       :: bool_out
    logical, intent(in), optional :: bool_in


    bool_out = misc_optional_bool(bool_in,.true.)

  end function test_bool


end subroutine misc_selfTest

end module misc

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Luv Sharma, Max-Planck-Institut für Eisenforschung GmbH
!> @author Pratheek Shanthraj, Max-Planck-Institut für Eisenforschung GmbH
!> @brief material subroutine incorporating anisotropic brittle damage source mechanism
!> @details to be done
!--------------------------------------------------------------------------------------------------
submodule (phase:damage) anisobrittle

  type :: tParameters                                                                               !< container type for internal constitutive parameters
    real(pREAL) :: &
      dot_o_0, &                                                                                    !< opening rate of cleavage planes
      p                                                                                             !< damage rate sensitivity
    real(pREAL), dimension(:), allocatable :: &
      s_crit, &                                                                                     !< critical displacement
      g_crit                                                                                        !< critical load
    real(pREAL), dimension(:,:,:,:), allocatable :: &
      cleavage_systems
    integer :: &
      sum_N_cl                                                                                      !< total number of cleavage planes
    character(len=pSTRLEN), allocatable, dimension(:) :: &
      output
  end type tParameters

  type(tParameters), dimension(:), allocatable :: param                                             !< containers of constitutive parameters (len Ninstances)


contains


!--------------------------------------------------------------------------------------------------
!> @brief module initialization
!> @details reads in material parameters, allocates arrays, and does sanity checks
!--------------------------------------------------------------------------------------------------
module function anisobrittle_init() result(mySources)

  logical, dimension(:), allocatable :: mySources

  type(tDict), pointer :: &
    phases, &
    phase, &
    src
  integer :: Nmembers,ph
  integer, dimension(:), allocatable :: N_cl
  character(len=:), allocatable :: &
    refs, &
    extmsg


  mySources = source_active('anisobrittle')
  if (count(mySources) == 0) return

  print'(/,1x,a)', '<<<+-  phase:damage:anisobrittle init  -+>>>'
  print'(/,1x,a,1x,i0)', '# phases:',count(mySources); flush(IO_STDOUT)


  phases => config_material%get_dict('phase')
  allocate(param(size(phases)))
  extmsg = ''

  do ph = 1, size(phases)
    if (mySources(ph)) then
      phase => phases%get_dict(ph)
      src => phase%get_dict('damage')

      associate(prm  => param(ph))

        print'(/,1x,a,1x,i0,a)', 'phase',ph,': '//phases%key(ph)
        refs = config_listReferences(src,indent=3)
        if (len(refs) > 0) print'(/,1x,a)', refs

        N_cl = src%get_as1dInt('N_cl',defaultVal=emptyIntArray)
        prm%sum_N_cl = sum(abs(N_cl))

        prm%p       = src%get_asReal('p')
        prm%dot_o_0 = src%get_asReal('dot_o_0')

        prm%s_crit  = src%get_as1dReal('s_crit',requiredSize=size(N_cl))
        prm%g_crit  = src%get_as1dReal('g_crit',requiredSize=size(N_cl))

        prm%cleavage_systems = crystal_SchmidMatrix_cleavage(N_cl,phase_lattice(ph),phase_cOverA(ph))

        ! expand: family => system
        prm%s_crit = math_expand(prm%s_crit,N_cl)
        prm%g_crit = math_expand(prm%g_crit,N_cl)

#if defined (__GFORTRAN__)
        prm%output = output_as1dStr(src)
#else
        prm%output = src%get_as1dStr('output',defaultVal=emptyStrArray)
#endif

        ! sanity checks
        if (prm%p          <= 0.0_pREAL)  extmsg = trim(extmsg)//' p'
        if (prm%dot_o_0    <= 0.0_pREAL)  extmsg = trim(extmsg)//' dot_o_0'
        if (any(prm%g_crit <  0.0_pREAL)) extmsg = trim(extmsg)//' g_crit'
        if (any(prm%s_crit <  0.0_pREAL)) extmsg = trim(extmsg)//' s_crit'

        Nmembers = count(material_ID_phase==ph)
        call phase_allocateState(damageState(ph),Nmembers,1,1,0)
        damageState(ph)%atol = src%get_asReal('atol_phi',defaultVal=1.0e-9_pREAL)
        if (any(damageState(ph)%atol < 0.0_pREAL)) extmsg = trim(extmsg)//' atol_phi'

      end associate

      if (extmsg /= '') call IO_error(211,ext_msg=trim(extmsg)//'(damage_anisoBrittle)')
    end if

  end do

end function anisobrittle_init


!--------------------------------------------------------------------------------------------------
!> @brief
!--------------------------------------------------------------------------------------------------
module subroutine anisobrittle_dotState(M_i, ph,en)

  integer, intent(in) :: &
    ph,en
  real(pREAL),  intent(in), dimension(3,3) :: &
    M_i

  integer :: &
    a, i
  real(pREAL) :: &
    traction, traction_crit


  associate(prm => param(ph))
    damageState(ph)%dotState(1,en) = 0.0_pREAL
    do a = 1, prm%sum_N_cl
      traction_crit = damage_phi(ph,en)**2 * prm%g_crit(a)
      do i = 1,3
        traction = math_tensordot(M_i,prm%cleavage_systems(1:3,1:3,i,a))

        damageState(ph)%dotState(1,en) = damageState(ph)%dotState(1,en) &
          + prm%dot_o_0 / prm%s_crit(a) &
            * (max(0.0_pREAL, abs(traction) - traction_crit)/traction_crit)**prm%p
      end do
    end do
  end associate

end subroutine anisobrittle_dotState


!--------------------------------------------------------------------------------------------------
!> @brief Write results to HDF5 output file.
!--------------------------------------------------------------------------------------------------
module subroutine anisobrittle_result(phase,group)

  integer,          intent(in) :: phase
  character(len=*), intent(in) :: group

  integer :: o


  associate(prm => param(phase), stt => damageState(phase)%state)
    outputsLoop: do o = 1,size(prm%output)
      select case(trim(prm%output(o)))
        case ('Psi_D')
          call result_writeDataset(stt,group,trim(prm%output(o)),'damage energy density','J/m³')
      end select
    end do outputsLoop
  end associate

end subroutine anisobrittle_result


!--------------------------------------------------------------------------------------------------
!> @brief  contains the constitutive equation for calculating the velocity gradient
!--------------------------------------------------------------------------------------------------
module subroutine damage_anisobrittle_LiAndItsTangent(L_i, dL_i_dM_i, M_i, ph,en)

  integer, intent(in) :: &
    ph,en
  real(pREAL),   intent(in),  dimension(3,3) :: &
    M_i
  real(pREAL),   intent(out), dimension(3,3) :: &
    L_i                                                                                             !< damage velocity gradient
  real(pREAL),   intent(out), dimension(3,3,3,3) :: &
    dL_i_dM_i                                                                                       !< derivative of L_i with respect to M_i

  integer :: &
    a, k, l, m, n, i
  real(pREAL) :: &
    traction, traction_crit, &
    udot, dudot_dt


  L_i = 0.0_pREAL
  dL_i_dM_i = 0.0_pREAL
  associate(prm => param(ph))
    do a = 1,prm%sum_N_cl
      traction_crit = damage_phi(ph,en)**2 * prm%g_crit(a)

      do i = 1, 3
        traction = math_tensordot(M_i,prm%cleavage_systems(1:3,1:3,i,a))
        if (abs(traction) > traction_crit + tol_math_check) then
          udot = sign(1.0_pREAL,traction)* prm%dot_o_0 * ((abs(traction) - traction_crit)/traction_crit)**prm%p
          L_i = L_i + udot*prm%cleavage_systems(1:3,1:3,i,a)
          dudot_dt = sign(1.0_pREAL,traction)*udot*prm%p / (abs(traction) - traction_crit)
          forall (k=1:3,l=1:3,m=1:3,n=1:3) &
            dL_i_dM_i(k,l,m,n) = dL_i_dM_i(k,l,m,n) &
                               + dudot_dt*prm%cleavage_systems(k,l,i,a) * prm%cleavage_systems(m,n,i,a)
        end if
      end do
    end do
  end associate

end subroutine damage_anisobrittle_LiAndItsTangent

end submodule anisobrittle

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief  phenomenological crystal plasticity formulation using a powerlaw fitting
!--------------------------------------------------------------------------------------------------
submodule(phase:plastic) phenopowerlaw

  type :: tParameters
    real(pREAL),               allocatable, dimension(:) :: &
      dot_gamma_0_sl, &                                                                             !< reference shear strain rate for slip
      dot_gamma_0_tw, &                                                                             !< reference shear strain rate for twin
      a_sl, &
      n_sl, &                                                                                       !< stress exponent for slip
      n_tw, &                                                                                       !< stress exponent for twin
      xi_inf_sl, &                                                                                  !< maximum critical shear stress for slip
      f_sat_sl_tw, &                                                                                !< push-up factor for slip saturation due to twinning
      c_1, &
      c_2, &
      c_3, &
      c_4, &
      h_0_sl_sl, &                                                                                  !< reference hardening slip - slip
      h_0_tw_sl, &                                                                                  !< reference hardening twin - slip
      h_0_tw_tw, &                                                                                  !< reference hardening twin - twin
      gamma_char                                                                                    !< characteristic shear for twins
    real(pREAL),               allocatable, dimension(:,:) :: &
      h_sl_sl, &                                                                                    !< slip resistance from slip activity
      h_sl_tw, &                                                                                    !< slip resistance from twin activity
      h_tw_sl, &                                                                                    !< twin resistance from slip activity
      h_tw_tw                                                                                       !< twin resistance from twin activity
    real(pREAL),               allocatable, dimension(:,:,:) :: &
      P_sl, &
      P_tw, &
      P_nS_pos, &
      P_nS_neg
    integer :: &
      sum_N_sl, &                                                                                   !< total number of active slip system
      sum_N_tw                                                                                      !< total number of active twin systems
    character(len=pSTRLEN),    allocatable, dimension(:) :: &
      output
    character(len=:),          allocatable, dimension(:) :: &
      systems_sl, &
      systems_tw
  end type tParameters

  type :: tIndexDotState
    integer, dimension(2) :: &
      xi_sl, &
      xi_tw, &
      gamma_sl, &
      gamma_tw
  end type tIndexDotState

  type :: tPhenopowerlawState
    real(pREAL), pointer, dimension(:,:) :: &
      xi_sl, &
      xi_tw, &
      gamma_sl, &
      gamma_tw
  end type tPhenopowerlawState

!--------------------------------------------------------------------------------------------------
! containers for parameters, dot state index,  and state
  type(tParameters),         allocatable, dimension(:) :: param
  type(tIndexDotState),      allocatable, dimension(:) :: indexDotState
  type(tPhenopowerlawState), allocatable, dimension(:) :: state

contains


!--------------------------------------------------------------------------------------------------
!> @brief Perform module initialization.
!> @details reads in material parameters, allocates arrays, and does sanity checks
!--------------------------------------------------------------------------------------------------
module function plastic_phenopowerlaw_init() result(myPlasticity)

  logical, dimension(:), allocatable :: myPlasticity
  integer :: &
    ph, i, &
    Nmembers, &
    sizeState, sizeDotState, &
    startIndex, endIndex
  integer,     dimension(:), allocatable :: &
    N_sl, &                                                                                         !< number of slip-systems for a given slip family
    N_tw                                                                                            !< number of twin-systems for a given twin family
  real(pREAL), dimension(:), allocatable :: &
    xi_0_sl, &                                                                                      !< initial critical shear stress for slip
    xi_0_tw                                                                                          !< initial critical shear stress for twin
  real(pREAL), dimension(:,:), allocatable :: &
    a_nS                                                                                            !< non-Schmid coefficients
  character(len=:), allocatable :: &
    refs, &
    extmsg
  type(tDict), pointer :: &
    phases, &
    phase, &
    mech, &
    pl


  myPlasticity = plastic_active('phenopowerlaw')
  if (count(myPlasticity) == 0) return

  print'(/,1x,a)', '<<<+-  phase:mechanical:plastic:phenopowerlaw init  -+>>>'

  print'(/,1x,a)', 'F. Roters et al., Computational Materials Science 158:420–478, 2019'
  print'(  1x,a)', 'https://doi.org/10.1016/j.commatsci.2018.04.030'

  print'(/,1x,a)', 'Updated slip resistance evolution as in Eq. 3:'
  print'(  1x,a)', 'N. Prabhu and M. Diehl, Advanced Engineering Materials 28, 2026'
  print'(  1x,a)', 'https://doi.org/10.1002/adem.202500390'

  print'(/,1x,a,1x,i0)', '# phases:',count(myPlasticity); flush(IO_STDOUT)


  phases => config_material%get_dict('phase')
  allocate(param(size(phases)))
  allocate(indexDotState(size(phases)))
  allocate(state(size(phases)))
  extmsg = ''

  do ph = 1, size(phases)
    if (.not. myPlasticity(ph)) cycle

    associate(prm => param(ph), &
              stt => state(ph), &
              idx_dot => indexDotState(ph))

    phase => phases%get_dict(ph)
    mech => phase%get_dict('mechanical')
    pl => mech%get_dict('plastic')

    print'(/,1x,a,1x,i0,a)', 'phase',ph,': '//phases%key(ph)
    refs = config_listReferences(pl,indent=3)
    if (len(refs) > 0) print'(/,1x,a)', refs

#if defined (__GFORTRAN__)
    prm%output = output_as1dStr(pl)
#else
    prm%output = pl%get_as1dStr('output',defaultVal=emptyStrArray)
#endif

!--------------------------------------------------------------------------------------------------
! slip related parameters
    N_sl = pl%get_as1dInt('N_sl',defaultVal=emptyIntArray)
    prm%sum_N_sl = sum(abs(N_sl))
    slipActive: if (prm%sum_N_sl > 0) then
      prm%P_sl = crystal_SchmidMatrix_slip(N_sl,phase_lattice(ph),phase_cOverA(ph))
      prm%systems_sl = crystal_labels_slip(N_sl,phase_lattice(ph))

      a_nS = pl%get_as2dReal('a_non-Schmid',defaultVal=reshape(emptyRealArray,[0,0]))
      prm%P_nS_pos = crystal_SchmidMatrix_slip(N_sl,phase_lattice(ph),phase_cOverA(ph), &
                                               nonSchmidCoefficients=a_nS,sense=+1)
      prm%P_nS_neg = crystal_SchmidMatrix_slip(N_sl,phase_lattice(ph),phase_cOverA(ph), &
                                               nonSchmidCoefficients=a_nS,sense=-1)

      prm%h_sl_sl = crystal_interaction_SlipBySlip(N_sl,pl%get_as1dReal('h_sl-sl'),phase_lattice(ph))

      prm%dot_gamma_0_sl = math_expand(pl%get_as1dReal('dot_gamma_0_sl',requiredSize=size(N_sl)), N_sl)
      prm%n_sl           = math_expand(pl%get_as1dReal('n_sl',          requiredSize=size(N_sl)), N_sl)
      prm%a_sl           = math_expand(pl%get_as1dReal('a_sl',          requiredSize=size(N_sl)), N_sl)
      prm%h_0_sl_sl      = math_expand(pl%get_as1dReal('h_0_sl-sl',     requiredSize=size(N_sl)), N_sl)
#ifdef __GFORTRAN__
      xi_0_sl            = pl%get_as1dReal('xi_0_sl',  requiredChunks=N_sl)
      prm%xi_inf_sl      = pl%get_as1dReal('xi_inf_sl',requiredChunks=N_sl)
#else
      xi_0_sl            = math_expand(pl%get_as1dReal('xi_0_sl',       requiredSize=size(N_sl)), N_sl)
      prm%xi_inf_sl      = math_expand(pl%get_as1dReal('xi_inf_sl',     requiredSize=size(N_sl)), N_sl)
#endif
      prm%c_1            = math_expand(pl%get_as1dReal('c_1',           requiredSize=size(N_sl), &
                                                                        defaultVal=misc_zeros(size(N_sl))), N_sl)
      prm%c_2            = math_expand(pl%get_as1dReal('c_2',           requiredSize=size(N_sl), &
                                                                        defaultVal=misc_ones(size(N_sl))), N_sl)
      prm%f_sat_sl_tw    = math_expand(pl%get_as1dReal('f_sat_sl-tw',   requiredSize=size(N_sl), &
                                                                        defaultVal=misc_zeros(size(N_sl))), N_sl)
      ! sanity checks
      if (any(prm%dot_gamma_0_sl <= 0.0_pREAL))   extmsg = trim(extmsg)//' dot_gamma_0_sl'
      if (any(prm%n_sl           <= 0.0_pREAL))   extmsg = trim(extmsg)//' n_sl'
      if (any(prm%a_sl           <= 0.0_pREAL))   extmsg = trim(extmsg)//' a_sl'
      if (any(xi_0_sl            <= 0.0_pREAL))   extmsg = trim(extmsg)//' xi_0_sl'
      if (any(prm%xi_inf_sl      <= 0.0_pREAL))   extmsg = trim(extmsg)//' xi_inf_sl'

    else slipActive
      xi_0_sl = emptyRealArray
      allocate(prm%dot_gamma_0_sl, &
               prm%a_sl, &
               prm%n_sl, &
               prm%xi_inf_sl, &
               prm%f_sat_sl_tw, &
               prm%c_1, &
               prm%c_2, &
               prm%h_0_sl_sl, &
               source=emptyRealArray)
      allocate(prm%h_sl_sl(0,0))
    end if slipActive

!--------------------------------------------------------------------------------------------------
! twin related parameters
    N_tw = pl%get_as1dInt('N_tw',defaultVal=emptyIntArray)
    prm%sum_N_tw = sum(abs(N_tw))
    twinActive: if (prm%sum_N_tw > 0) then
      prm%P_tw = crystal_SchmidMatrix_twin(N_tw,phase_lattice(ph),phase_cOverA(ph))
      prm%systems_tw = crystal_labels_twin(N_tw,phase_lattice(ph))
      prm%gamma_char = abs(crystal_characteristicShear_twin(N_tw,phase_lattice(ph),phase_cOverA(ph)))

      prm%h_tw_tw = crystal_interaction_TwinByTwin(N_tw,pl%get_as1dReal('h_tw-tw'),phase_lattice(ph))

      prm%dot_gamma_0_tw = math_expand(pl%get_as1dReal('dot_gamma_0_tw', requiredSize=size(N_tw)), N_tw)
      prm%n_tw           = math_expand(pl%get_as1dReal('n_tw',           requiredSize=size(N_tw)), N_tw)
      prm%h_0_tw_tw      = math_expand(pl%get_as1dReal('h_0_tw-tw',      requiredSize=size(N_tw)), N_tw)
      xi_0_tw            = math_expand(pl%get_as1dReal('xi_0_tw',        requiredSize=size(N_tw)), N_tw)
      prm%c_3            = math_expand(pl%get_as1dReal('c_3',            requiredSize=size(N_tw), &
                                                                         defaultVal=misc_ones(size(N_tw))), N_tw)
      prm%c_4            = math_expand(pl%get_as1dReal('c_4',            requiredSize=size(N_tw), &
                                                                         defaultVal=misc_zeros(size(N_tw))), N_tw)
      ! sanity checks
      if (any(prm%dot_gamma_0_tw <= 0.0_pREAL))   extmsg = trim(extmsg)//' dot_gamma_0_tw'
      if (any(prm%n_tw           <= 0.0_pREAL))   extmsg = trim(extmsg)//' n_tw'
      if (any(xi_0_tw            <= 0.0_pREAL))   extmsg = trim(extmsg)//' xi_0_tw'

    else twinActive
      xi_0_tw = emptyRealArray
      allocate(prm%dot_gamma_0_tw, &
               prm%n_tw, &
               prm%c_3, &
               prm%c_4, &
               prm%gamma_char, &
               prm%h_0_tw_sl, &
               prm%h_0_tw_tw, &
               source=emptyRealArray)
      allocate(prm%h_tw_tw(0,0))
    end if twinActive

!--------------------------------------------------------------------------------------------------
! slip-twin related parameters
    slipAndTwinActive: if (prm%sum_N_sl > 0 .and. prm%sum_N_tw > 0) then
      prm%h_0_tw_sl = math_expand(pl%get_as1dReal('h_0_tw-sl',requiredSize=size(N_tw)), N_tw)
      prm%h_sl_tw = crystal_interaction_SlipByTwin(N_sl,N_tw,pl%get_as1dReal('h_sl-tw'),phase_lattice(ph))
      prm%h_tw_sl = crystal_interaction_TwinBySlip(N_tw,N_sl,pl%get_as1dReal('h_tw-sl'),phase_lattice(ph))
    else slipAndTwinActive
      allocate(prm%h_sl_tw(prm%sum_N_sl,prm%sum_N_tw))                                              ! at least one dimension is 0
      allocate(prm%h_tw_sl(prm%sum_N_tw,prm%sum_N_sl))                                              ! at least one dimension is 0
      prm%h_0_tw_sl = [(0.0_pREAL,i=1,size(N_tw))]
    end if slipAndTwinActive

!--------------------------------------------------------------------------------------------------
! allocate state arrays
    Nmembers = count(material_ID_phase == ph)
    sizeDotState = size(['xi_sl   ','gamma_sl']) * prm%sum_N_sl &
                 + size(['xi_tw   ','gamma_tw']) * prm%sum_N_tw
    sizeState = sizeDotState

    call phase_allocateState(plasticState(ph),Nmembers,sizeState,sizeDotState,0)
    deallocate(plasticState(ph)%dotState) ! ToDo: remove dotState completely

!--------------------------------------------------------------------------------------------------
! state aliases and initialization
    startIndex = 1
    endIndex   = prm%sum_N_sl
    idx_dot%xi_sl = [startIndex,endIndex]
    stt%xi_sl => plasticState(ph)%state(startIndex:endIndex,:)
    stt%xi_sl = spread(xi_0_sl, 2, Nmembers)
    plasticState(ph)%atol(startIndex:endIndex) = pl%get_asReal('atol_xi',defaultVal=1.0_pREAL)
    if (any(plasticState(ph)%atol(startIndex:endIndex) < 0.0_pREAL)) extmsg = trim(extmsg)//' atol_xi'

    startIndex = endIndex + 1
    endIndex   = endIndex + prm%sum_N_tw
    idx_dot%xi_tw = [startIndex,endIndex]
    stt%xi_tw => plasticState(ph)%state(startIndex:endIndex,:)
    stt%xi_tw = spread(xi_0_tw, 2, Nmembers)
    plasticState(ph)%atol(startIndex:endIndex) = pl%get_asReal('atol_xi',defaultVal=1.0_pREAL)

    startIndex = endIndex + 1
    endIndex   = endIndex + prm%sum_N_sl
    idx_dot%gamma_sl = [startIndex,endIndex]
    stt%gamma_sl => plasticState(ph)%state(startIndex:endIndex,:)
    plasticState(ph)%atol(startIndex:endIndex) = pl%get_asReal('atol_gamma',defaultVal=1.0e-6_pREAL)
    if (any(plasticState(ph)%atol(startIndex:endIndex) < 0.0_pREAL)) extmsg = trim(extmsg)//' atol_gamma'

    startIndex = endIndex + 1
    endIndex   = endIndex + prm%sum_N_tw
    idx_dot%gamma_tw = [startIndex,endIndex]
    stt%gamma_tw => plasticState(ph)%state(startIndex:endIndex,:)
    plasticState(ph)%atol(startIndex:endIndex) = pl%get_asReal('atol_gamma',defaultVal=1.0e-6_pREAL)

    end associate

!--------------------------------------------------------------------------------------------------
!  exit if any parameter is out of range
    if (extmsg /= '') call IO_error(211,ext_msg=trim(extmsg))

  end do

end function plastic_phenopowerlaw_init


!--------------------------------------------------------------------------------------------------
!> @brief Calculate plastic velocity gradient and its tangent.
!> @details assumes that deformation by dislocation glide affects twinned and untwinned volume
!  equally (Taylor assumption). Twinning happens only in untwinned volume
!--------------------------------------------------------------------------------------------------
pure module subroutine phenopowerlaw_LpAndItsTangent(Lp,dLp_dMp,Mp,ph,en)

  real(pREAL), dimension(3,3),     intent(out) :: &
    Lp                                                                                              !< plastic velocity gradient
  real(pREAL), dimension(3,3,3,3), intent(out) :: &
    dLp_dMp                                                                                         !< derivative of Lp with respect to the Mandel stress

  real(pREAL), dimension(3,3), intent(in) :: &
    Mp                                                                                              !< Mandel stress
  integer,               intent(in) :: &
    ph, &
    en

  integer :: &
    i,k,l,m,n
  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    dot_gamma_sl,ddot_gamma_dtau_sl
  real(pREAL), dimension(3,3,param(ph)%sum_N_sl) :: &
    P_nS
  real(pREAL), dimension(param(ph)%sum_N_tw) :: &
    dot_gamma_tw,ddot_gamma_dtau_tw


  Lp = 0.0_pREAL
  dLp_dMp = 0.0_pREAL

  associate(prm => param(ph))

    call kinetics_sl(Mp,ph,en,dot_gamma_sl,ddot_gamma_dtau_sl)
    P_nS = merge(prm%P_nS_pos,prm%P_nS_neg, spread(spread(dot_gamma_sl,1,3),2,3)>0.0_pREAL)         ! faster than 'merge' in loop
    slipSystems: do i = 1, prm%sum_N_sl
      Lp = Lp + dot_gamma_sl(i)*prm%P_sl(1:3,1:3,i)
      forall (k=1:3,l=1:3,m=1:3,n=1:3) &
        dLp_dMp(k,l,m,n) = dLp_dMp(k,l,m,n) &
                         + ddot_gamma_dtau_sl(i) * prm%P_sl(k,l,i) * P_nS(m,n,i)
    end do slipSystems

    call kinetics_tw(Mp,ph,en,dot_gamma_tw,ddot_gamma_dtau_tw)
    twinSystems: do i = 1, prm%sum_N_tw
      Lp = Lp + dot_gamma_tw(i)*prm%P_tw(1:3,1:3,i)
      forall (k=1:3,l=1:3,m=1:3,n=1:3) &
        dLp_dMp(k,l,m,n) = dLp_dMp(k,l,m,n) &
                         + ddot_gamma_dtau_tw(i)*prm%P_tw(k,l,i)*prm%P_tw(m,n,i)
    end do twinSystems

  end associate

end subroutine phenopowerlaw_LpAndItsTangent


!--------------------------------------------------------------------------------------------------
!> @brief Calculate the rate of change of microstructure.
!--------------------------------------------------------------------------------------------------
module function phenopowerlaw_dotState(Mp,ph,en) result(dotState)

  real(pREAL), dimension(3,3),  intent(in) :: &
    Mp                                                                                              !< Mandel stress
  integer,                      intent(in) :: &
    ph, &
    en
  real(pREAL), dimension(plasticState(ph)%sizeDotState) :: &
    dotState

  real(pREAL) :: &
    sumF
  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    xi_sl_sat_offset, &
    left_SlipSlip


  associate(prm => param(ph), stt => state(ph), &
            dot_xi_sl => dotState(indexDotState(ph)%xi_sl(1):indexDotState(ph)%xi_sl(2)), &
            dot_xi_tw => dotState(indexDotState(ph)%xi_tw(1):indexDotState(ph)%xi_tw(2)), &
            dot_gamma_sl => dotState(indexDotState(ph)%gamma_sl(1):indexDotState(ph)%gamma_sl(2)), &
            dot_gamma_tw => dotState(indexDotState(ph)%gamma_tw(1):indexDotState(ph)%gamma_tw(2)))

    call kinetics_sl(Mp,ph,en, dot_gamma_sl)
    call kinetics_tw(Mp,ph,en, dot_gamma_tw)
    dot_gamma_sl = abs(dot_gamma_sl)
    sumF = sum(stt%gamma_tw(:,en)/prm%gamma_char)

    xi_sl_sat_offset = prm%f_sat_sl_tw*sqrt(sumF)

    left_SlipSlip = sign(abs(1.0_pREAL - stt%xi_sl(:,en) / (prm%xi_inf_sl+xi_sl_sat_offset))**prm%a_sl, &
                             1.0_pREAL - stt%xi_sl(:,en) / (prm%xi_inf_sl+xi_sl_sat_offset))

    dot_xi_sl = prm%h_0_sl_sl * (1.0_pREAL + prm%c_1 * sumF**prm%c_2) &
              * left_SlipSlip &
              * matmul(prm%h_sl_sl,dot_gamma_sl) &
              + matmul(prm%h_sl_tw,dot_gamma_tw)

    dot_xi_tw = prm%h_0_tw_sl * sum(stt%gamma_sl(:,en))**prm%c_3 * matmul(prm%h_tw_sl,dot_gamma_sl) &
              + prm%h_0_tw_tw * sumF                   **prm%c_4 * matmul(prm%h_tw_tw,dot_gamma_tw)

  end associate

end function phenopowerlaw_dotState


!--------------------------------------------------------------------------------------------------
!> @brief Write results to HDF5 output file.
!--------------------------------------------------------------------------------------------------
module subroutine plastic_phenopowerlaw_result(ph,group)

  integer,          intent(in) :: ph
  character(len=*), intent(in) :: group

  integer :: ou


  associate(prm => param(ph), stt => state(ph))

    do ou = 1,size(prm%output)

      select case(trim(prm%output(ou)))

        case('xi_sl')
          call result_writeDataset(stt%xi_sl,group,trim(prm%output(ou)), &
                                   'resistance against plastic slip','Pa',prm%systems_sl)
        case('gamma_sl')
          call result_writeDataset(stt%gamma_sl,group,trim(prm%output(ou)), &
                                   'plastic shear','1',prm%systems_sl)

        case('xi_tw')
          call result_writeDataset(stt%xi_tw,group,trim(prm%output(ou)), &
                                   'resistance against twinning','Pa',prm%systems_tw)
        case('gamma_tw')
          call result_writeDataset(stt%gamma_tw,group,trim(prm%output(ou)), &
                                   'twinning shear','1',prm%systems_tw)

      end select

    end do

  end associate

end subroutine plastic_phenopowerlaw_result


!--------------------------------------------------------------------------------------------------
!> @brief Calculate shear rates on slip systems and their derivatives with respect to resolved
!         stress.
!> @details Sign of dot_gamma_sl conveys sense of shear.
! Derivatives are calculated only optionally, hence, contrary to common convention,
! here the result (i.e. intent(out)) variables have to be put at the end.
!--------------------------------------------------------------------------------------------------
pure subroutine kinetics_sl(Mp,ph,en, &
                            dot_gamma_sl,ddot_gamma_dtau_sl)

  real(pREAL), dimension(3,3),                           intent(in) :: &
    Mp                                                                                              !< Mandel stress
  integer,                                               intent(in) :: &
    ph, &
    en

  real(pREAL), dimension(param(ph)%sum_N_sl),           intent(out) :: &
    dot_gamma_sl
  real(pREAL), dimension(param(ph)%sum_N_sl), optional, intent(out) :: &
    ddot_gamma_dtau_sl

  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    tau_sl_pos, &
    tau_sl_neg
  integer :: i


  associate(prm => param(ph), stt => state(ph))

    tau_sl_pos = [(math_tensordot(Mp,prm%P_nS_pos(1:3,1:3,i)),i=1,prm%sum_N_sl)]
    tau_sl_neg = [(math_tensordot(Mp,prm%P_nS_neg(1:3,1:3,i)),i=1,prm%sum_N_sl)]

    dot_gamma_sl = merge(+1.0_pREAL,-1.0_pREAL, tau_sl_pos>tau_sl_neg) &
                 * prm%dot_gamma_0_sl  &
                 * (max(tau_sl_pos,tau_sl_neg)/stt%xi_sl(:,en))**prm%n_sl

    if (present(ddot_gamma_dtau_sl)) then
      where(dNeq0(dot_gamma_sl))
        ddot_gamma_dtau_sl = dot_gamma_sl*prm%n_sl/max(tau_sl_pos,tau_sl_neg)
      else where
        ddot_gamma_dtau_sl = 0.0_pREAL
      end where
    end if

  end associate

end subroutine kinetics_sl


!--------------------------------------------------------------------------------------------------
!> @brief Calculate shear rates on twin systems and their derivatives with respect to resolved stress.
!         Twinning is assumed to take place only in an untwinned volume.
!> @details Derivatives are calculated and returned if corresponding output variables are present in the argument list.
! NOTE: Contrary to common convention, here the result (i.e. intent(out)) variables have to be put
! at the end since some of them are optional.
!--------------------------------------------------------------------------------------------------
pure subroutine kinetics_tw(Mp,ph,en,&
                            dot_gamma_tw,ddot_gamma_dtau_tw)

  real(pREAL), dimension(3,3),  intent(in) :: &
    Mp                                                                                              !< Mandel stress
  integer,                      intent(in) :: &
    ph, &
    en

  real(pREAL), dimension(param(ph)%sum_N_tw), intent(out) :: &
    dot_gamma_tw
  real(pREAL), dimension(param(ph)%sum_N_tw), intent(out), optional :: &
    ddot_gamma_dtau_tw

  real(pREAL), dimension(param(ph)%sum_N_tw) :: &
    tau_tw
  integer :: i


  associate(prm => param(ph), stt => state(ph))

    tau_tw = [(math_tensordot(Mp,prm%P_tw(1:3,1:3,i)),i=1,prm%sum_N_tw)]

    where(tau_tw > 0.0_pREAL)
      dot_gamma_tw = (1.0_pREAL-sum(stt%gamma_tw(:,en)/prm%gamma_char)) &                           ! only twin in untwinned volume fraction
                   * prm%dot_gamma_0_tw*(tau_tw/stt%xi_tw(:,en))**prm%n_tw
    else where
      dot_gamma_tw = 0.0_pREAL
    end where

    if (present(ddot_gamma_dtau_tw)) then
      where(dNeq0(dot_gamma_tw))
        ddot_gamma_dtau_tw = dot_gamma_tw*prm%n_tw/tau_tw
      else where
        ddot_gamma_dtau_tw = 0.0_pREAL
      end where
    end if

  end associate

end subroutine kinetics_tw

end submodule phenopowerlaw

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author Yi Hu, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Utilities used by the different spectral solver variants
!--------------------------------------------------------------------------------------------------
#include <petsc/finclude/petscsys.h>
#if defined(PETSC_EXPOSES_MPIF90)
#define MPI_COMM_WORLD_F90 MPI_COMM_WORLD
#else
#define MPI_COMM_WORLD_F90 MPI_COMM_WORLD%MPI_val
#endif
module spectral_utilities
  use PETScSys
#ifndef PETSC_EXPOSES_MPI
  use MPI_f08
#endif

  use FFTW3
  use prec
  use CLI
  use parallelization
  use math
  use rotations
  use IO
  use config
  use discretization_grid
  use discretization
  use homogenization

#ifndef PETSC_EXPOSES_MPIF90
  implicit none(type,external)
#else
  implicit none
#endif
  private

!--------------------------------------------------------------------------------------------------
! grid related information
  real(pREAL), protected, public               :: wgt                                               !< weighting factor 1/Nelems
  real(pREAL), protected, public, dimension(3) :: scaledGeomSize                                    !< scaled geometry size for calculation of divergence
  integer :: &
    cells1Red, &                                                                                    !< cells(1)/2+1
    cells2 = 0, &                                                                                   !< (local) cells in 2nd direction
    cells2Offset                                                                                    !< (local) cells offset in 2nd direction

!--------------------------------------------------------------------------------------------------
! variables storing information for spectral method and FFTW

  real(C_DOUBLE),            dimension(:,:,:,:,:),     pointer     :: tensorField_real              !< tensor field in real space
  real(C_DOUBLE),            dimension(:,:,:,:),       pointer     :: vectorField_real              !< vector field in real space
  real(C_DOUBLE),            dimension(:,:,:),         pointer     :: scalarField_real              !< scalar field in real space
  complex(C_DOUBLE_COMPLEX), dimension(:,:,:,:,:),     pointer     :: tensorField_fourier           !< tensor field in Fourier space
  complex(C_DOUBLE_COMPLEX), dimension(:,:,:,:),       pointer     :: vectorField_fourier           !< vector field in Fourier space
  complex(C_DOUBLE_COMPLEX), dimension(:,:,:),         pointer     :: scalarField_fourier           !< scalar field in Fourier space
  complex(pREAL),            dimension(:,:,:,:,:,:,:), allocatable :: Gamma_hat                     !< gamma operator (field) for spectral method
  complex(pREAL),            dimension(:,:,:,:,:,:,:), allocatable :: G_hat                         !< G operator (field) for Galerkin method
  complex(pREAL),            dimension(:,:,:,:),       allocatable :: xi1st                         !< wave vector field for first derivatives
  complex(pREAL),            dimension(:,:,:,:),       allocatable :: xi2nd                         !< wave vector field for second derivatives
  real(pREAL),               dimension(3,3,3,3)                    :: C_ref                         !< mechanic reference stiffness

!--------------------------------------------------------------------------------------------------
! plans for FFTW
  type(C_PTR) :: &
    planTensorForth, &                                                                              !< FFTW MPI plan P(x) to P(k)
    planTensorBack, &                                                                               !< FFTW MPI plan F(k) to F(x)
    planVectorForth, &                                                                              !< FFTW MPI plan v(x) to v(k)
    planVectorBack, &                                                                               !< FFTW MPI plan v(k) to v(x)
    planScalarForth, &                                                                              !< FFTW MPI plan s(x) to s(k)
    planScalarBack                                                                                  !< FFTW MPI plan s(k) to s(x)

!--------------------------------------------------------------------------------------------------
! derived types
  type, public :: tSolutionState                                                                    !< return type of solution from spectral solver variants
    integer :: &
       iterationsNeeded  = 0
    logical :: &
       converged         = .true., &
       stagConverged     = .true.
  end type tSolutionState

  type :: tNumerics
    integer :: &
      divergence_correction                                                                         !< scale divergence/curl calculation
    logical :: &
      memory_efficient                                                                              !< calculate gamma operator on the fly
  end type tNumerics

  type(tNumerics) :: num                                                                            ! numerics parameters. Better name?

  enum, bind(c); enumerator :: &
    DERIVATIVE_CONTINUOUS_ID, &
    DERIVATIVE_CENTRAL_DIFF_ID, &
    DERIVATIVE_FWBW_DIFF_ID
  end enum

  integer(kind(DERIVATIVE_CONTINUOUS_ID)) :: &
    spectral_derivative_ID

  public :: &
    spectral_utilities_init, &
    utilities_updateGamma, &
    utilities_GammaConvolution, &
    utilities_G_Convolution, &
    utilities_GreenConvolution, &
    utilities_divergenceRMS, &
    utilities_curlRMS, &
    utilities_scalarGradient, &
    utilities_vectorDivergence, &
    utilities_updateCoords

contains

!--------------------------------------------------------------------------------------------------
!> @brief Allocate all neccessary fields and create plans for FFTW.
!--------------------------------------------------------------------------------------------------
subroutine spectral_utilities_init(active_Gamma, active_G, active_parabolic)

  logical, intent(in) :: active_Gamma, active_G, active_parabolic

  PetscErrorCode :: err_PETSc
  integer        :: i, j, k, &
    FFTW_planner_flag
  integer, dimension(3) :: k_s
  type(C_PTR) :: &
    tensorField, &                                                                                  !< tensor data for FFTW in real and Fourier space (in-place)
    vectorField, &                                                                                  !< vector data for FFTW in real and Fourier space (in-place)
    scalarField                                                                                     !< scalar data for FFTW in real and Fourier space (in-place)
  integer(C_INTPTR_T), dimension(3) :: cellsFFTW
  integer(C_INTPTR_T) :: N, &
    cells3FFTW, &                                                                                   !< # of cells in 3. dim on current process in real space
    cells3_offset, &                                                                                !< offset for cells in 3. dim on current process in real space
    cells2FFTW, &                                                                                   !< # of cells in 2. dim on current process in Fourier space
    cells2_offset                                                                                   !< offset for cells in 2. dim on curren process in Fourier space
  integer(C_INTPTR_T), parameter :: &
    vectorSize = 3_C_INTPTR_T, &
    tensorSize = 9_C_INTPTR_T
  type(tDict) , pointer :: &
    num_solver, &
    num_grid, &
    num_grid_fft

  print'(/,1x,a)', '<<<+-  spectral_utilities init  -+>>>'

  print'(/,1x,a)', 'M. Diehl, Diploma Thesis TU München, 2010'
  print'(  1x,a)', 'https://doi.org/10.13140/2.1.3234.3840'//IO_EOL

  print'(  1x,a)', 'P. Eisenlohr et al., International Journal of Plasticity 46:37–53, 2013'
  print'(  1x,a)', 'https://doi.org/10.1016/j.ijplas.2012.09.012'//IO_EOL

  print'(  1x,a)', 'P. Shanthraj et al., International Journal of Plasticity 66:31–45, 2015'
  print'(  1x,a)', 'https://doi.org/10.1016/j.ijplas.2014.02.006'//IO_EOL

  print'(  1x,a)', 'P. Shanthraj et al., Handbook of Mechanics of Materials, 2019'
  print'(  1x,a)', 'https://doi.org/10.1007/978-981-10-6884-3_80'//IO_EOL

  print'(  1x,a)', 'M. Frigo and S.G. Johnson, Proceedings of the IEEE 93(2):216–231, 2005'
  print'(  1x,a)', 'https://doi.org/10.1109/jproc.2004.840301'

  num_solver      => config_numerics%get_dict('solver',defaultVal=emptyDict)
  num_grid        => num_solver%get_dict('grid',defaultVal=emptyDict)
  num_grid_fft    => num_grid%get_dict('FFT',defaultVal=emptyDict)

  call PetscOptionsInsertString(PETSC_NULL_OPTIONS,&
                                num_grid%get_asStr('PETSc_options',defaultVal=''),err_PETSc)
  CHKERRQ(err_PETSc)

  cells1Red = cells(1)/2 + 1
  wgt = real(product(cells),pREAL)**(-1)

  num%memory_efficient      = num_grid_fft%get_asBool('memory_efficient',     defaultVal=.true.)

!--------------------------------------------------------------------------------------------------
! scale dimension to calculate either uncorrected, dimension-independent, or dimension- and
! resolution-independent divergence
  select case (num_grid_fft%get_asStr('divergence_correction',defaultVal='grid+size'))
    case ('none')
      do j = 1, 3
       if (j /= minloc(geomSize,1) .and. j /= maxloc(geomSize,1)) &
         scaledGeomSize = geomSize/geomSize(j)
      end do
    case ('grid+size', 'size+grid')
      do j = 1, 3
       if (      j /= minloc(geomSize/real(cells,pREAL),1) &
           .and. j /= maxloc(geomSize/real(cells,pREAL),1)) &
         scaledGeomSize = geomSize/geomSize(j)*real(cells(j),pREAL)
      end do
    case ('size')
      scaledGeomSize = geomSize
    case default
      call IO_error(301,ext_msg=trim(num_grid_fft%get_asStr('divergence_correction')))
  end select

  select case (num_grid_fft%get_asStr('derivative',defaultVal='continuous'))
    case ('continuous')
      spectral_derivative_ID = DERIVATIVE_CONTINUOUS_ID
    case ('central_difference')
      spectral_derivative_ID = DERIVATIVE_CENTRAL_DIFF_ID
    case ('FWBW_difference')
      spectral_derivative_ID = DERIVATIVE_FWBW_DIFF_ID
    case default
      call IO_error(601_pI16,trim(num_grid_fft%get_asStr('derivative')), &
                    'is not a valid approach for calculation of derivatives',emph=[1])
  end select


  select case(num_grid_fft%get_asStr('FFTW_plan_mode',defaultVal='FFTW_MEASURE'))
    case ('FFTW_ESTIMATE')                                                                          ! ordered from slow execution (but fast plan creation) to fast execution
      FFTW_planner_flag = FFTW_ESTIMATE
    case ('FFTW_MEASURE')
      FFTW_planner_flag = FFTW_MEASURE
    case ('FFTW_PATIENT')
      FFTW_planner_flag = FFTW_PATIENT
    case ('FFTW_EXHAUSTIVE')
      FFTW_planner_flag = FFTW_EXHAUSTIVE
    case default
      call IO_error(601_pI16,trim(num_grid_fft%get_asStr('FFTW_plan_mode')), &
                    'is not a valid planner flag for FFTW',emph=[1])
  end select

!--------------------------------------------------------------------------------------------------
! general initialization of FFTW (see manual on fftw.org for more details)
  if (pREAL /= C_DOUBLE .or. kind(1) /= C_INT) error stop 'C and Fortran datatypes do not match'
  call fftw_set_timelimit(num_grid_fft%get_asReal('FFTW_timelimit',defaultVal=300.0_pREAL))

  print'(/,1x,a)', 'FFTW initialized'; flush(IO_STDOUT)

  cellsFFTW = int(cells,C_INTPTR_T)


!--------------------------------------------------------------------------------------------------
! set up FFTW data structures for tensor fields
! ToDo: FEM uses tensor field to calculate coordinates, this is not needed
  N = fftw_mpi_local_size_many_transposed(3,[cellsFFTW(3),cellsFFTW(2),int(cells1Red,C_INTPTR_T)], &
                                          tensorSize,FFTW_MPI_DEFAULT_BLOCK,FFTW_MPI_DEFAULT_BLOCK,MPI_COMM_WORLD_F90, &
                                          cells3FFTW,cells3_offset,cells2FFTW,cells2_offset)
  cells2 = int(cells2FFTW)
  cells2Offset = int(cells2_offset)
  if (int(cells3FFTW) /= cells3) error stop 'domain decomposition mismatch (tensor, real space)'

  tensorField = fftw_alloc_complex(N)
  call c_f_pointer(tensorField,tensorField_real, &
                   [3_C_INTPTR_T,3_C_INTPTR_T,int(cells1Red*2,C_INTPTR_T),cellsFFTW(2),cells3FFTW])
  call c_f_pointer(tensorField,tensorField_fourier, &
                   [3_C_INTPTR_T,3_C_INTPTR_T,int(cells1Red,  C_INTPTR_T),cellsFFTW(3),cells2FFTW])

  planTensorForth = fftw_mpi_plan_many_dft_r2c(3,cellsFFTW(3:1:-1),tensorSize, &
                                               FFTW_MPI_DEFAULT_BLOCK,FFTW_MPI_DEFAULT_BLOCK, &
                                               tensorField_real,tensorField_fourier, &
                                               MPI_COMM_WORLD_F90,FFTW_planner_flag+FFTW_MPI_TRANSPOSED_OUT)
  if (.not. c_associated(planTensorForth)) error stop 'FFTW error r2c tensor'
  planTensorBack  = fftw_mpi_plan_many_dft_c2r(3,cellsFFTW(3:1:-1),tensorSize, &
                                               FFTW_MPI_DEFAULT_BLOCK,FFTW_MPI_DEFAULT_BLOCK, &
                                               tensorField_fourier,tensorField_real, &
                                               MPI_COMM_WORLD_F90,FFTW_planner_flag+FFTW_MPI_TRANSPOSED_IN)
  if (.not. c_associated(planTensorBack))  error stop 'FFTW error c2r tensor'

!--------------------------------------------------------------------------------------------------
! set up FFTW data structures for vector fields
! ToDo: FEM uses vector field to calculate coordinates, this is not needed
  N = fftw_mpi_local_size_many_transposed(3,[cellsFFTW(3),cellsFFTW(2),int(cells1Red,C_INTPTR_T)], &
                                          vectorSize,FFTW_MPI_DEFAULT_BLOCK,FFTW_MPI_DEFAULT_BLOCK,MPI_COMM_WORLD_F90, &
                                          cells3FFTW,cells3_offset,cells2FFTW,cells2_offset)
  if (int(cells3FFTW) /= cells3) error stop 'domain decomposition mismatch (vector, real space)'
  if (int(cells2FFTW) /= cells2) error stop 'domain decomposition mismatch (vector, Fourier space)'

  vectorField = fftw_alloc_complex(N)
  call c_f_pointer(vectorField,vectorField_real, &
                   [3_C_INTPTR_T,int(cells1Red*2,C_INTPTR_T),cellsFFTW(2),cells3FFTW])
  call c_f_pointer(vectorField,vectorField_fourier, &
                   [3_C_INTPTR_T,int(cells1Red,  C_INTPTR_T),cellsFFTW(3),cells2FFTW])

  planVectorForth = fftw_mpi_plan_many_dft_r2c(3,cellsFFTW(3:1:-1),vectorSize, &
                                               FFTW_MPI_DEFAULT_BLOCK,FFTW_MPI_DEFAULT_BLOCK, &
                                               vectorField_real,vectorField_fourier, &
                                               MPI_COMM_WORLD_F90,FFTW_planner_flag+FFTW_MPI_TRANSPOSED_OUT)
  if (.not. c_associated(planVectorForth)) error stop 'FFTW error r2c vector'
  planVectorBack  = fftw_mpi_plan_many_dft_c2r(3,cellsFFTW(3:1:-1),vectorSize, &
                                               FFTW_MPI_DEFAULT_BLOCK,FFTW_MPI_DEFAULT_BLOCK, &
                                               vectorField_fourier,vectorField_real, &
                                               MPI_COMM_WORLD_F90,FFTW_planner_flag+FFTW_MPI_TRANSPOSED_IN)
  if (.not. c_associated(planVectorBack))  error stop 'FFTW error c2r vector'

!--------------------------------------------------------------------------------------------------
! set up FFTW data structures for scalar fields
  if (active_parabolic) then
    N = fftw_mpi_local_size_3d_transposed(cellsFFTW(3),cellsFFTW(2),int(cells1Red,C_INTPTR_T), &
                                          MPI_COMM_WORLD_F90,cells3FFTW,cells3_offset,cells2FFTW,cells2_offset)
    if (int(cells3FFTW) /= cells3) error stop 'domain decomposition mismatch (scalar, real space)'
    if (int(cells2FFTW) /= cells2) error stop 'domain decomposition mismatch (scalar, Fourier space)'

    scalarField = fftw_alloc_complex(N)
    call c_f_pointer(scalarField,scalarField_real, &
                     [int(cells1Red*2,C_INTPTR_T),cellsFFTW(2),cells3FFTW])
    call c_f_pointer(scalarField,scalarField_fourier, &
                     [int(cells1Red,  C_INTPTR_T),cellsFFTW(3),cells2FFTW])

    planScalarForth = fftw_mpi_plan_dft_r2c_3d(cellsFFTW(3),cellsFFTW(2),cellsFFTW(1), &
                                               scalarField_real,scalarField_fourier, &
                                               MPI_COMM_WORLD_F90,FFTW_planner_flag+FFTW_MPI_TRANSPOSED_OUT)
    if (.not. c_associated(planScalarForth)) error stop 'FFTW error r2c scalar'
    planScalarBack  = fftw_mpi_plan_dft_c2r_3d(cellsFFTW(3),cellsFFTW(2),cellsFFTW(1), &
                                               scalarField_fourier,scalarField_real, &
                                               MPI_COMM_WORLD_F90,FFTW_planner_flag+FFTW_MPI_TRANSPOSED_IN)
    if (.not. c_associated(planScalarBack))  error stop 'FFTW error c2r scalar'
  end if

!--------------------------------------------------------------------------------------------------
! discrete angular frequencies, ordered as in FFTW (wrap around)
  allocate (xi1st (3,cells1Red,cells(3),cells2),source = cmplx(0.0_pREAL,0.0_pREAL,pREAL))          ! frequencies for first derivatives, only half the size for first dimension
  allocate (xi2nd (3,cells1Red,cells(3),cells2),source = cmplx(0.0_pREAL,0.0_pREAL,pREAL))          ! frequencies for second derivatives, only half the size for first dimension

  do j = cells2Offset+1, cells2Offset+cells2
    k_s(2) = j - 1
    if (j > cells(2)/2 + 1) k_s(2) = k_s(2) - cells(2)                                              ! running from 0,1,...,N/2,N/2+1,-N/2,-N/2+1,...,-1
      do k = 1, cells(3)
        k_s(3) = k - 1
        if (k > cells(3)/2 + 1) k_s(3) = k_s(3) - cells(3)                                          ! running from 0,1,...,N/2,N/2+1,-N/2,-N/2+1,...,-1
          do i = 1, cells1Red
            k_s(1) = i - 1                                                                          ! symmetry, junst running from 0,1,...,N/2,N/2+1
            xi2nd(1:3,i,k,j-cells2Offset) = utilities_getFreqDerivative(k_s)
            where(mod(cells,2)==0 .and. [i,j,k] == cells/2+1 .and. &
                  spectral_derivative_ID == DERIVATIVE_CONTINUOUS_ID)                               ! for even grids, set the Nyquist Freq component to 0.0
              xi1st(1:3,i,k,j-cells2Offset) = cmplx(0.0_pREAL,0.0_pREAL,pREAL)
            elsewhere
              xi1st(1:3,i,k,j-cells2Offset) = xi2nd(1:3,i,k,j-cells2Offset)
            endwhere
  end do; end do; end do

  if (active_Gamma) then
    if (num%memory_efficient) then                                                                  ! allocate just single fourth order tensor
      allocate (Gamma_hat(3,3,3,3,1,1,1), source = cmplx(0.0_pREAL,0.0_pREAL,pREAL))
    else                                                                                            ! precalculation of Gamma_hat field
      allocate (Gamma_hat(3,3,3,3,cells1Red,cells(3),cells2), source = cmplx(0.0_pREAL,0.0_pREAL,pREAL))
    end if
  end if

  if (active_G) G_hat = G_hat_init()

  call selfTest()

end subroutine spectral_utilities_init


!---------------------------------------------------------------------------------------------------
!> @brief Update reference stiffness and potentially precalculated gamma operator.
!> @details Set the current reference stiffness to the stiffness given as an argument.
!> If the gamma operator is precalculated, it is calculated with this stiffness.
!> In case of an on-the-fly calculation, only the reference stiffness is updated.
!---------------------------------------------------------------------------------------------------
subroutine utilities_updateGamma(C)

  real(pREAL), intent(in), dimension(3,3,3,3) :: C                                                  !< input stiffness to store as reference stiffness

  complex(pREAL),              dimension(3,3) :: temp33_cmplx, xiDyad_cmplx
  real(pREAL),                 dimension(6,6) :: A, A_inv
  integer :: &
    i, j, k, &
    l, m, n, o
  logical :: err


  C_ref = C/wgt

  if (.not. num%memory_efficient) then
    Gamma_hat = cmplx(0.0_pREAL,0.0_pREAL,pREAL)                                                    ! for the singular point and any non invertible A
    !$OMP PARALLEL DO PRIVATE(l,m,n,o,temp33_cmplx,xiDyad_cmplx,A,A_inv,err)
    do j = cells2Offset+1, cells2Offset+cells2; do k = 1, cells(3); do i = 1, cells1Red
      if (any([i,j,k] /= 1)) then                                                                   ! singular point at xi=(0.0,0.0,0.0) i.e. i=j=k=1
        do l = 1, 3; do m = 1, 3
          xiDyad_cmplx(l,m) = conjg(-xi1st(l,i,k,j-cells2Offset))*xi1st(m,i,k,j-cells2Offset)
        end do; end do
        do l = 1, 3; do m = 1, 3
          temp33_cmplx(l,m) = sum(cmplx(C_ref(l,1:3,m,1:3),0.0_pREAL,pREAL)*xiDyad_cmplx)
        end do; end do
        A(1:3,1:3) = temp33_cmplx%re; A(4:6,4:6) =  temp33_cmplx%re
        A(1:3,4:6) = temp33_cmplx%im; A(4:6,1:3) = -temp33_cmplx%im
        if (abs(math_det33(A(1:3,1:3))) > 1.e-16_pREAL) then
          call math_invert(A_inv, err, A)
          temp33_cmplx = cmplx(A_inv(1:3,1:3),A_inv(1:3,4:6),pREAL)
          do l = 1, 3; do m = 1, 3; do n = 1, 3; do o = 1, 3
            Gamma_hat(l,m,n,o,i,k,j-cells2Offset) = temp33_cmplx(l,n) * xiDyad_cmplx(o,m)
          end do; end do; end do; end do
        end if
      end if
    end do; end do; end do
    !$OMP END PARALLEL DO
  end if

end subroutine utilities_updateGamma


!--------------------------------------------------------------------------------------------------
!> @brief Calculate gamma_hat * field_real (convolution).
!> @details The average value equals the given aim.
!--------------------------------------------------------------------------------------------------
function utilities_GammaConvolution(field, fieldAim) result(gammaField)

  real(pREAL), intent(in), dimension(3,3,cells(1),cells(2),cells3) :: field
  real(pREAL), intent(in), dimension(3,3) :: fieldAim                                               !< desired average value of the field after convolution
  real(pREAL),             dimension(3,3,cells(1),cells(2),cells3) :: gammaField

  complex(pREAL), dimension(3,3) :: temp33_cmplx, xiDyad_cmplx
  real(pREAL),    dimension(6,6) :: A, A_inv
  integer :: &
    i, j, k, &
    l, m, n, o
  logical :: err


  print'(/,1x,a)', '... doing gamma convolution ...............................................'
  flush(IO_STDOUT)

  tensorField_real(1:3,1:3,cells(1)+1:cells1Red*2,1:cells(2),1:cells3) = 0.0_pREAL
  tensorField_real(1:3,1:3,1:cells(1),            1:cells(2),1:cells3) = field
  call fftw_mpi_execute_dft_r2c(planTensorForth,tensorField_real,tensorField_fourier)

  memoryEfficient: if (num%memory_efficient) then
    !$OMP PARALLEL DO PRIVATE(l,m,n,o,temp33_cmplx,xiDyad_cmplx,A,A_inv,err,Gamma_hat)
    do j = 1, cells2; do k = 1, cells(3); do i = 1, cells1Red
      if (any([i,j+cells2Offset,k] /= 1)) then                                                      ! singular point at xi=(0.0,0.0,0.0) i.e. i=j=k=1
        do l = 1, 3; do m = 1, 3
          xiDyad_cmplx(l,m) = conjg(-xi1st(l,i,k,j))*xi1st(m,i,k,j)
        end do; end do
        do l = 1, 3; do m = 1, 3
          temp33_cmplx(l,m) = sum(cmplx(C_ref(l,1:3,m,1:3),0.0_pREAL,pREAL)*xiDyad_cmplx)
        end do; end do
        A(1:3,1:3) = temp33_cmplx%re; A(4:6,4:6) =  temp33_cmplx%re
        A(1:3,4:6) = temp33_cmplx%im; A(4:6,1:3) = -temp33_cmplx%im
        if (abs(math_det33(A(1:3,1:3))) > 1.e-16_pREAL) then
          call math_invert(A_inv, err, A)
          temp33_cmplx = cmplx(A_inv(1:3,1:3),A_inv(1:3,4:6),pREAL)
          do l = 1, 3; do m = 1, 3; do n = 1, 3; do o = 1, 3
            Gamma_hat(l,m,n,o,1,1,1) = temp33_cmplx(l,n)*xiDyad_cmplx(o,m)
          end do; end do; end do; end do
          do l = 1, 3; do m = 1, 3
            temp33_cmplx(l,m) = sum(Gamma_hat(l,m,1:3,1:3,1,1,1)*tensorField_fourier(1:3,1:3,i,k,j))
          end do; end do
          tensorField_fourier(1:3,1:3,i,k,j) = temp33_cmplx
        else
          tensorField_fourier(1:3,1:3,i,k,j) = cmplx(0.0_pREAL,0.0_pREAL,pREAL)
        end if
      end if
    end do; end do; end do
    !$OMP END PARALLEL DO
  else memoryEfficient
    !$OMP PARALLEL DO PRIVATE(l,m,temp33_cmplx)
    do j = 1, cells2;  do k = 1, cells(3);  do i = 1,cells1Red
      do l = 1, 3; do m = 1, 3
        temp33_cmplx(l,m) = sum(Gamma_hat(l,m,1:3,1:3,i,k,j)*tensorField_fourier(1:3,1:3,i,k,j))
      end do; end do
      tensorField_fourier(1:3,1:3,i,k,j) = temp33_cmplx
    end do; end do; end do
    !$OMP END PARALLEL DO
  end if memoryEfficient

  if (cells3Offset == 0) tensorField_fourier(1:3,1:3,1,1,1) = cmplx(fieldAim,0.0_pREAL,pREAL)

  call fftw_mpi_execute_dft_c2r(planTensorBack,tensorField_fourier,tensorField_real)
  gammaField = tensorField_real(1:3,1:3,1:cells(1),1:cells(2),1:cells3)

end function utilities_GammaConvolution


!--------------------------------------------------------------------------------------------------
!> @brief Assemble G.
!--------------------------------------------------------------------------------------------------
function G_hat_init() result(G_hat_)

  complex(pREAL), dimension(:,:,:,:,:,:,:), allocatable :: G_hat_                                   !< G operator (field) for Galerkin method

  integer :: &
    i, j, k, &
    l, m, n, o
  complex(pREAL) :: xi_norm_2
  complex(pREAL), dimension(3,3), parameter :: delta = cmplx(math_I3,0.0_pREAL,pREAL)


  allocate(G_hat_(3,3,3,3,cells1Red,cells(3),cells2),source=cmplx(.0_pREAL,.0_pREAL,pREAL))

  !$OMP PARALLEL DO PRIVATE(l,m,n,o,xi_norm_2)
  do j = 1, cells2; do k = 1, cells(3); do i = 1, cells1Red
    if (any([i,j+cells2Offset,k] /= 1)) then                                                        ! singular point at xi=(0.0,0.0,0.0) i.e. i=j=k=1
      xi_norm_2 = cmplx(abs(dot_product(xi1st(:,i,k,j), xi1st(:,i,k,j))),0.0_pREAL,pREAL)
      if (xi_norm_2%re > 1.e-16_pREAL) then
        do l = 1, 3; do m = 1, 3; do n = 1, 3; do o = 1, 3
          G_hat_(l,m,n,o,i,k,j) = delta(l,n)*conjg(-xi1st(m,i,k,j))*xi1st(o,i,k,j)/xi_norm_2
        end do; end do; end do; end do
      end if
    end if
  end do; end do; end do
  !$OMP END PARALLEL DO

end function G_hat_init


!--------------------------------------------------------------------------------------------------
!> @brief Calculate G * field_real (convolution).
!> @details G*field_real = Fourier_inv( G_hat : Fourier(field_real) )
!> @details Yi: make tensor field compatible
!> @details G_hat index according to S Lucarini et al. MSMSE 2021
!> @details fieldAim is for impose dP of stress bc in form_residual
!> @details fieldAim is not needed for stress bc in form_jacobian GK_op
!--------------------------------------------------------------------------------------------------
function utilities_G_Convolution(field,stress_mask,fieldAim) result(G_Field)

  real(pREAL), intent(in), dimension(3,3,cells(1),cells(2),cells3) :: field
  logical,     intent(in), dimension(3,3) :: stress_mask                                            !< impose the mask component <=> G* in Lucarini
  real(pREAL), intent(in), dimension(3,3), optional :: fieldAim                                     !< desired average value of the field after convolution

  real(pREAL),             dimension(3,3,cells(1),cells(2),cells3) :: G_Field

  complex(pREAL), dimension(3,3) :: temp33_cmplx
  integer :: &
    i, j, k, &
    l, m


  tensorField_real(1:3,1:3,cells(1)+1:cells1Red*2,1:cells(2),1:cells3) = 0.0_pREAL
  tensorField_real(1:3,1:3,1:cells(1),            1:cells(2),1:cells3) = field
  call fftw_mpi_execute_dft_r2c(planTensorForth,tensorField_real,tensorField_fourier)

  !$OMP PARALLEL DO PRIVATE(l,m,temp33_cmplx)
  do j = 1, cells2; do k = 1, cells(3); do i = 1, cells1Red
    if (any([i,j+cells2Offset,k] /= 1)) then                                                        ! singular point at xi=(0.0,0.0,0.0) i.e. i=j=k=1
      do l = 1, 3; do m = 1, 3
        temp33_cmplx(l,m) = sum(G_hat(l,m,1:3,1:3,i,k,j)*tensorField_fourier(1:3,1:3,i,k,j))
      end do; end do
      tensorField_fourier(1:3,1:3,i,k,j) = temp33_cmplx
    end if
  end do; end do; end do
  !$OMP END PARALLEL DO

  ! Apply stress bounday conditions
  if (cells3Offset == 0) then
    if (present(fieldAim)) &
      tensorField_fourier(1:3,1:3,1,1,1) = cmplx(fieldAim/wgt,0.0_pREAL,pREAL)
    where (stress_mask) tensorField_fourier(1:3,1:3,1,1,1) = cmplx(0.0_pREAL,0.0_pREAL,pREAL)
  end if

  call fftw_mpi_execute_dft_c2r(planTensorBack,tensorField_fourier,tensorField_real)
  G_Field = tensorField_real(1:3,1:3,1:cells(1),1:cells(2),1:cells3)

end function utilities_G_Convolution


!--------------------------------------------------------------------------------------------------
!> @brief Convolution of Greens' operator for damage/thermal.
!--------------------------------------------------------------------------------------------------
function utilities_GreenConvolution(field, D_ref, mu_ref, Delta_t) result(greenField)

  real(pREAL), intent(in), dimension(cells(1),cells(2),cells3) :: field
  real(pREAL), dimension(3,3), intent(in) :: D_ref
  real(pREAL),                 intent(in) :: mu_ref, Delta_t
  real(pREAL), dimension(cells(1),cells(2),cells3) :: greenField

  complex(pREAL)                          :: GreenOp_hat
  integer                                 :: i, j, k


  scalarField_real(cells(1)+1:cells1Red*2,1:cells(2),1:cells3) = 0.0_pREAL
  scalarField_real(1:cells(1),            1:cells(2),1:cells3) = field
  call fftw_mpi_execute_dft_r2c(planScalarForth,scalarField_real,scalarField_fourier)

  !$OMP PARALLEL DO PRIVATE(GreenOp_hat)
  do j = 1, cells2; do k = 1, cells(3); do i = 1, cells1Red
    GreenOp_hat = cmplx(wgt,0.0_pREAL,pREAL) &
                / (cmplx(mu_ref,0.0_pREAL,pREAL) + cmplx(Delta_t,0.0_pREAL,pREAL) &
                   * sum(conjg(xi1st(1:3,i,k,j))* matmul(cmplx(D_ref,0.0_pREAL,pREAL),xi1st(1:3,i,k,j))))
    scalarField_fourier(i,k,j) = scalarField_fourier(i,k,j)*GreenOp_hat
  end do; end do; end do
  !$OMP END PARALLEL DO

  call fftw_mpi_execute_dft_c2r(planScalarBack,scalarField_fourier,scalarField_real)
  greenField = scalarField_real(1:cells(1),1:cells(2),1:cells3)

end function utilities_GreenConvolution


!--------------------------------------------------------------------------------------------------
!> @brief Calculate root mean square of divergence.
!--------------------------------------------------------------------------------------------------
real(pREAL) function utilities_divergenceRMS(tensorField)

  real(pREAL), dimension(3,3,cells(1),cells(2),cells3), intent(in) :: tensorField

  integer :: i, j, k
  integer(MPI_INTEGER_KIND) :: err_MPI
  complex(pREAL), dimension(3) :: rescaledGeom


  tensorField_real(1:3,1:3,cells(1)+1:cells1Red*2,1:cells(2),1:cells3) = 0.0_pREAL
  tensorField_real(1:3,1:3,1:cells(1),            1:cells(2),1:cells3) = tensorField
  call fftw_mpi_execute_dft_r2c(planTensorForth,tensorField_real,tensorField_fourier)

  rescaledGeom = cmplx(geomSize/scaledGeomSize,0.0_pREAL,pREAL)

!--------------------------------------------------------------------------------------------------
! calculating RMS divergence criterion in Fourier space
  utilities_divergenceRMS = 0.0_pREAL
  do j = 1, cells2; do k = 1, cells(3)
    do i = 2, cells1Red -1                                                                          ! Has somewhere a conj. complex counterpart. Therefore count it twice.
      utilities_divergenceRMS = utilities_divergenceRMS &
            + 2.0_pREAL*(sum (real(matmul(tensorField_fourier(1:3,1:3,i,k,j), &                     ! (sqrt(real(a)**2 + aimag(a)**2))**2 = real(a)**2 + aimag(a)**2, i.e. do not take square root and square again
                                          conjg(-xi1st(1:3,i,k,j))*rescaledGeom))**2) &             ! --> sum squared L_2 norm of vector
                        +sum(aimag(matmul(tensorField_fourier(1:3,1:3,i,k,j),&
                                          conjg(-xi1st(1:3,i,k,j))*rescaledGeom))**2))
    end do
    utilities_divergenceRMS = utilities_divergenceRMS &                                             ! these two layers (DC and Nyquist) do not have a conjugate complex counterpart (if cells(1) /= 1)
               + sum( real(matmul(tensorField_fourier(1:3,1:3,1       ,k,j), &
                                  conjg(-xi1st(1:3,1,k,j))*rescaledGeom))**2) &
               + sum(aimag(matmul(tensorField_fourier(1:3,1:3,1       ,k,j), &
                                  conjg(-xi1st(1:3,1,k,j))*rescaledGeom))**2) &
               + sum( real(matmul(tensorField_fourier(1:3,1:3,cells1Red,k,j), &
                                  conjg(-xi1st(1:3,cells1Red,k,j))*rescaledGeom))**2) &
               + sum(aimag(matmul(tensorField_fourier(1:3,1:3,cells1Red,k,j), &
                                  conjg(-xi1st(1:3,cells1Red,k,j))*rescaledGeom))**2)
  end do; end do
  call MPI_Allreduce(MPI_IN_PLACE,utilities_divergenceRMS,1_MPI_INTEGER_KIND,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  utilities_divergenceRMS = sqrt(utilities_divergenceRMS) * wgt                                     ! RMS in real space calculated with Parsevals theorem from Fourier space
  if (cells(1) == 1) utilities_divergenceRMS = utilities_divergenceRMS * 0.5_pREAL                  ! counted twice in case of cells(1) == 1

end function utilities_divergenceRMS


!--------------------------------------------------------------------------------------------------
!> @brief Calculate root mean square of curl.
!--------------------------------------------------------------------------------------------------
real(pREAL) function utilities_curlRMS(tensorField)

  real(pREAL), dimension(3,3,cells(1),cells(2),cells3), intent(in) :: tensorField

  integer  ::  i, j, k, l
  integer(MPI_INTEGER_KIND) :: err_MPI
  complex(pREAL), dimension(3,3) :: curl_fourier
  complex(pREAL), dimension(3)   :: rescaledGeom


  tensorField_real(1:3,1:3,cells(1)+1:cells1Red*2,1:cells(2),1:cells3) = 0.0_pREAL
  tensorField_real(1:3,1:3,1:cells(1),            1:cells(2),1:cells3) = tensorField
  call fftw_mpi_execute_dft_r2c(planTensorForth,tensorField_real,tensorField_fourier)

  rescaledGeom = cmplx(geomSize/scaledGeomSize,0.0_pREAL,pREAL)

!--------------------------------------------------------------------------------------------------
! calculating max curl criterion in Fourier space
  utilities_curlRMS = 0.0_pREAL

  do j = 1, cells2; do k = 1, cells(3);
    do i = 2, cells1Red - 1
      do l = 1, 3
        curl_fourier(l,1) = (+tensorField_fourier(l,3,i,k,j)*xi1st(2,i,k,j)*rescaledGeom(2) &
                             -tensorField_fourier(l,2,i,k,j)*xi1st(3,i,k,j)*rescaledGeom(3))
        curl_fourier(l,2) = (+tensorField_fourier(l,1,i,k,j)*xi1st(3,i,k,j)*rescaledGeom(3) &
                             -tensorField_fourier(l,3,i,k,j)*xi1st(1,i,k,j)*rescaledGeom(1))
        curl_fourier(l,3) = (+tensorField_fourier(l,2,i,k,j)*xi1st(1,i,k,j)*rescaledGeom(1) &
                             -tensorField_fourier(l,1,i,k,j)*xi1st(2,i,k,j)*rescaledGeom(2))
      end do
      utilities_curlRMS = utilities_curlRMS &
                        +2.0_pREAL*sum(curl_fourier%re**2+curl_fourier%im**2)                       ! Has somewhere a conj. complex counterpart. Therefore count it twice.
    end do
    do l = 1, 3
       curl_fourier = (+tensorField_fourier(l,3,1,k,j)*xi1st(2,1,k,j)*rescaledGeom(2) &
                       -tensorField_fourier(l,2,1,k,j)*xi1st(3,1,k,j)*rescaledGeom(3))
       curl_fourier = (+tensorField_fourier(l,1,1,k,j)*xi1st(3,1,k,j)*rescaledGeom(3) &
                       -tensorField_fourier(l,3,1,k,j)*xi1st(1,1,k,j)*rescaledGeom(1))
       curl_fourier = (+tensorField_fourier(l,2,1,k,j)*xi1st(1,1,k,j)*rescaledGeom(1) &
                       -tensorField_fourier(l,1,1,k,j)*xi1st(2,1,k,j)*rescaledGeom(2))
    end do
    utilities_curlRMS = utilities_curlRMS &
                      + sum(curl_fourier%re**2 + curl_fourier%im**2)                                ! this layer (DC) does not have a conjugate complex counterpart (if cells(1) /= 1)
    do l = 1, 3
      curl_fourier = (+tensorField_fourier(l,3,cells1Red,k,j)*xi1st(2,cells1Red,k,j)*rescaledGeom(2) &
                      -tensorField_fourier(l,2,cells1Red,k,j)*xi1st(3,cells1Red,k,j)*rescaledGeom(3))
      curl_fourier = (+tensorField_fourier(l,1,cells1Red,k,j)*xi1st(3,cells1Red,k,j)*rescaledGeom(3) &
                      -tensorField_fourier(l,3,cells1Red,k,j)*xi1st(1,cells1Red,k,j)*rescaledGeom(1))
      curl_fourier = (+tensorField_fourier(l,2,cells1Red,k,j)*xi1st(1,cells1Red,k,j)*rescaledGeom(1) &
                      -tensorField_fourier(l,1,cells1Red,k,j)*xi1st(2,cells1Red,k,j)*rescaledGeom(2))
    end do
    utilities_curlRMS = utilities_curlRMS &
                      + sum(curl_fourier%re**2 + curl_fourier%im**2)                                ! this layer (Nyquist) does not have a conjugate complex counterpart (if cells(1) /= 1)
  end do; end do

  call MPI_Allreduce(MPI_IN_PLACE,utilities_curlRMS,1_MPI_INTEGER_KIND,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  utilities_curlRMS = sqrt(utilities_curlRMS) * wgt                                                 ! RMS in real space calculated with Parsevals theorem from Fourier space
  if (cells(1) == 1) utilities_curlRMS = utilities_curlRMS * 0.5_pREAL                              ! counted twice in case of cells(1) == 1

end function utilities_curlRMS


!--------------------------------------------------------------------------------------------------
!> @brief Calculate gradient of scalar field.
!--------------------------------------------------------------------------------------------------
function utilities_scalarGradient(field) result(grad)

  real(pREAL), intent(in), dimension(  cells(1),cells(2),cells3) :: field
  real(pREAL),             dimension(3,cells(1),cells(2),cells3) :: grad

  integer :: i, j, k


  scalarField_real(cells(1)+1:cells1Red*2,1:cells(2),1:cells3) = 0.0_pREAL
  scalarField_real(1:cells(1),            1:cells(2),1:cells3) = field
  call fftw_mpi_execute_dft_r2c(planScalarForth,scalarField_real,scalarField_fourier)
  do j = 1, cells2;  do k = 1, cells(3);  do i = 1,cells1Red
    vectorField_fourier(1:3,i,k,j) = scalarField_fourier(i,k,j)*xi1st(1:3,i,k,j)
  end do; end do; end do
  call fftw_mpi_execute_dft_c2r(planVectorBack,vectorField_fourier,vectorField_real)
  grad = vectorField_real(1:3,1:cells(1),1:cells(2),1:cells3)*wgt

end function utilities_scalarGradient


!--------------------------------------------------------------------------------------------------
!> @brief Calculate divergence of vector field.
!--------------------------------------------------------------------------------------------------
function utilities_vectorDivergence(field) result(div)

  real(pREAL), intent(in), dimension(3,cells(1),cells(2),cells3) :: field
  real(pREAL),             dimension(  cells(1),cells(2),cells3) :: div


  vectorField_real(1:3,cells(1)+1:cells1Red*2,1:cells(2),1:cells3) = 0.0_pREAL
  vectorField_real(1:3,1:cells(1),            1:cells(2),1:cells3) = field
  call fftw_mpi_execute_dft_r2c(planVectorForth,vectorField_real,vectorField_fourier)
  scalarField_fourier(1:cells1Red,1:cells(3),1:cells2) = sum(vectorField_fourier(1:3,1:cells1Red,1:cells(3),1:cells2) &
                                                             *conjg(-xi1st),1)                      ! ToDo: use "xi1st" instead of "conjg(-xi1st)"?
  call fftw_mpi_execute_dft_c2r(planScalarBack,scalarField_fourier,scalarField_real)
  div = scalarField_real(1:cells(1),1:cells(2),1:cells3)*wgt

end function utilities_vectorDivergence


!--------------------------------------------------------------------------------------------------
!> @brief Calculate Filter for Fourier convolution.
!> @details this is the full operator to calculate derivatives, i.e. 2 \pi i k for the
! standard approach
!--------------------------------------------------------------------------------------------------
pure function utilities_getFreqDerivative(k_s)

  integer, intent(in),  dimension(3) :: k_s                                                         !< indices of frequency

  complex(pREAL),       dimension(3) :: utilities_getFreqDerivative


  select case (spectral_derivative_ID)
    case (DERIVATIVE_CONTINUOUS_ID)
      utilities_getFreqDerivative = cmplx(0.0_pREAL, TAU*real(k_s,pREAL)/geomSize,pREAL)

    case (DERIVATIVE_CENTRAL_DIFF_ID)
      utilities_getFreqDerivative = cmplx(0.0_pREAL, sin(TAU*real(k_s,pREAL)/real(cells,pREAL)), pREAL)/ &
                                    cmplx(2.0_pREAL*geomSize/real(cells,pREAL), 0.0_pREAL, pREAL)

    case (DERIVATIVE_FWBW_DIFF_ID)
      utilities_getFreqDerivative(1) = &
                               cmplx(cos(TAU*real(k_s(1),pREAL)/real(cells(1),pREAL)) - 1.0_pREAL, &
                                     sin(TAU*real(k_s(1),pREAL)/real(cells(1),pREAL)), pREAL)* &
                               cmplx(cos(TAU*real(k_s(2),pREAL)/real(cells(2),pREAL)) + 1.0_pREAL, &
                                     sin(TAU*real(k_s(2),pREAL)/real(cells(2),pREAL)), pREAL)* &
                               cmplx(cos(TAU*real(k_s(3),pREAL)/real(cells(3),pREAL)) + 1.0_pREAL, &
                                     sin(TAU*real(k_s(3),pREAL)/real(cells(3),pREAL)), pREAL)/ &
                               cmplx(4.0_pREAL*geomSize(1)/real(cells(1),pREAL), 0.0_pREAL, pREAL)
      utilities_getFreqDerivative(2) = &
                               cmplx(cos(TAU*real(k_s(1),pREAL)/real(cells(1),pREAL)) + 1.0_pREAL, &
                                     sin(TAU*real(k_s(1),pREAL)/real(cells(1),pREAL)), pREAL)* &
                               cmplx(cos(TAU*real(k_s(2),pREAL)/real(cells(2),pREAL)) - 1.0_pREAL, &
                                     sin(TAU*real(k_s(2),pREAL)/real(cells(2),pREAL)), pREAL)* &
                               cmplx(cos(TAU*real(k_s(3),pREAL)/real(cells(3),pREAL)) + 1.0_pREAL, &
                                     sin(TAU*real(k_s(3),pREAL)/real(cells(3),pREAL)), pREAL)/ &
                               cmplx(4.0_pREAL*geomSize(2)/real(cells(2),pREAL), 0.0_pREAL, pREAL)
      utilities_getFreqDerivative(3) = &
                               cmplx(cos(TAU*real(k_s(1),pREAL)/real(cells(1),pREAL)) + 1.0_pREAL, &
                                     sin(TAU*real(k_s(1),pREAL)/real(cells(1),pREAL)), pREAL)* &
                               cmplx(cos(TAU*real(k_s(2),pREAL)/real(cells(2),pREAL)) + 1.0_pREAL, &
                                     sin(TAU*real(k_s(2),pREAL)/real(cells(2),pREAL)), pREAL)* &
                               cmplx(cos(TAU*real(k_s(3),pREAL)/real(cells(3),pREAL)) - 1.0_pREAL, &
                                     sin(TAU*real(k_s(3),pREAL)/real(cells(3),pREAL)), pREAL)/ &
                               cmplx(4.0_pREAL*geomSize(3)/real(cells(3),pREAL), 0.0_pREAL, pREAL)
  end select

end function utilities_getFreqDerivative


!--------------------------------------------------------------------------------------------------
!> @brief Calculate coordinates in current configuration for given defgrad field
! using integration in Fourier space.
!--------------------------------------------------------------------------------------------------
subroutine utilities_updateCoords(F)

  real(pREAL),   dimension(3,3,cells(1),cells(2),cells3), intent(in) :: F

  real(pREAL),   dimension(3,  cells(1),cells(2),cells3)             :: x_p                         !< Point/cell center coordinates
  real(pREAL),   dimension(3,  cells(1),cells(2),0:cells3+1)         :: u_tilde_p_padded            !< Fluctuation of cell center displacement (padded along z for MPI)
  real(pREAL),   dimension(3,  cells(1)+1,cells(2)+1,cells3+1)       :: x_n                         !< Node coordinates
  integer :: &
    i,j,k,n, &
    c
  integer(MPI_INTEGER_KIND) :: &
    rank_t, rank_b
  integer(MPI_INTEGER_KIND) :: err_MPI
#ifndef PETSC_EXPOSES_MPIF90
  type(MPI_Request), dimension(4) :: request
  type(MPI_Status),  dimension(4) :: status
#else
  integer, dimension(4) :: request
  integer, dimension(MPI_STATUS_SIZE,4) :: status
#endif
  real(pREAL),   dimension(3)   :: step
  real(pREAL),   dimension(3,3) :: Favg
  integer,       dimension(3)   :: me
  integer, dimension(3,8) :: &
    neighbor = reshape([ &
                        0, 0, 0, &
                        1, 0, 0, &
                        1, 1, 0, &
                        0, 1, 0, &
                        0, 0, 1, &
                        1, 0, 1, &
                        1, 1, 1, &
                        0, 1, 1  ], [3,8])


  step = geomSize/real(cells, pREAL)

  tensorField_real(1:3,1:3,1:cells(1),            1:cells(2),1:cells3) = F
  tensorField_real(1:3,1:3,cells(1)+1:cells1Red*2,1:cells(2),1:cells3) = 0.0_pREAL
  call fftw_mpi_execute_dft_r2c(planTensorForth,tensorField_real,tensorField_fourier)

 !--------------------------------------------------------------------------------------------------
 ! average F
  if (cells3Offset == 0) Favg = tensorField_fourier(1:3,1:3,1,1,1)%re*wgt
  call MPI_Bcast(Favg,9_MPI_INTEGER_KIND,MPI_DOUBLE,0_MPI_INTEGER_KIND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)

 !--------------------------------------------------------------------------------------------------
 ! integration in Fourier space to get fluctuations of cell center displacements
  !$OMP PARALLEL DO
  do j = 1, cells2; do k = 1, cells(3); do i = 1, cells1Red
    if (any([i,j+cells2Offset,k] /= 1)) then
      vectorField_fourier(1:3,i,k,j) = matmul(tensorField_fourier(1:3,1:3,i,k,j),xi2nd(1:3,i,k,j)) &
                                     / sum(conjg(-xi2nd(1:3,i,k,j))*xi2nd(1:3,i,k,j))
    else
      vectorField_fourier(1:3,i,k,j) = cmplx(0.0,0.0,pREAL)
    end if
  end do; end do; end do
  !$OMP END PARALLEL DO

  call fftw_mpi_execute_dft_c2r(planVectorBack,vectorField_fourier,vectorField_real)
  u_tilde_p_padded(1:3,1:cells(1),1:cells(2),1:cells3) = vectorField_real(1:3,1:cells(1),1:cells(2),1:cells3) * wgt

 !--------------------------------------------------------------------------------------------------
 ! pad cell center fluctuations along z-direction (needed when running MPI simulation)
  c = product(shape(u_tilde_p_padded(:,:,:,1)))                                                     !< amount of data to transfer
  rank_t = modulo(worldrank+1_MPI_INTEGER_KIND,worldsize)
  rank_b = modulo(worldrank-1_MPI_INTEGER_KIND,worldsize)

  ! send bottom layer to process below
  call MPI_Isend(u_tilde_p_padded(:,:,:,1),       c,MPI_DOUBLE,rank_b,0_MPI_INTEGER_KIND,MPI_COMM_WORLD,request(1),err_MPI)
  call parallelization_chkerr(err_MPI)
  call MPI_Irecv(u_tilde_p_padded(:,:,:,cells3+1),c,MPI_DOUBLE,rank_t,0_MPI_INTEGER_KIND,MPI_COMM_WORLD,request(2),err_MPI)
  call parallelization_chkerr(err_MPI)

  ! send top layer to process above
  call MPI_Isend(u_tilde_p_padded(:,:,:,cells3)  ,c,MPI_DOUBLE,rank_t,1_MPI_INTEGER_KIND,MPI_COMM_WORLD,request(3),err_MPI)
  call parallelization_chkerr(err_MPI)
  call MPI_Irecv(u_tilde_p_padded(:,:,:,0),       c,MPI_DOUBLE,rank_b,1_MPI_INTEGER_KIND,MPI_COMM_WORLD,request(4),err_MPI)
  call parallelization_chkerr(err_MPI)

  call MPI_Waitall(4,request,status,err_MPI)
  call parallelization_chkerr(err_MPI)
#ifndef PETSC_EXPOSES_MPIF90
  ! ToDo
#else
  if (any(status(MPI_ERROR,:) /= 0)) error stop 'MPI error'
#endif

 !--------------------------------------------------------------------------------------------------
 ! calculate nodal positions
  x_n = 0.0_pREAL
  do j = 0,cells(2); do k = 0,cells3; do i = 0,cells(1)
    x_n(1:3,i+1,j+1,k+1) = matmul(Favg,step*(real([i,j,k+cells3Offset],pREAL)))
    averageFluct: do n = 1,8
      me = [i+neighbor(1,n),j+neighbor(2,n),k+neighbor(3,n)]
      x_n(1:3,i+1,j+1,k+1) = x_n(1:3,i+1,j+1,k+1) &
                           + u_tilde_p_padded(1:3,modulo(me(1)-1,cells(1))+1,modulo(me(2)-1,cells(2))+1,me(3))*0.125_pREAL
    end do averageFluct
  end do; end do; end do

 !--------------------------------------------------------------------------------------------------
 ! calculate cell center/point positions
  do k = 1,cells3; do j = 1,cells(2); do i = 1,cells(1)
    x_p(1:3,i,j,k) = u_tilde_p_padded(1:3,i,j,k) &
                   + matmul(Favg,step*(real([i,j,k+cells3Offset],pREAL)-0.5_pREAL))
  end do; end do; end do

  call discretization_setNodeCoords(reshape(x_n,[3,(cells(1)+1)*(cells(2)+1)*(cells3+1)]))
  call discretization_setIPcoords  (reshape(x_p,[3,cells(1)*cells(2)*cells3]))

end subroutine utilities_updateCoords


!--------------------------------------------------------------------------------------------------
!> @brief Check correctness of forward-backward transform.
!--------------------------------------------------------------------------------------------------
subroutine selfTest()

  real(pREAL), allocatable, dimension(:,:,:,:,:) :: tensorField_real_
  real(pREAL), allocatable, dimension(:,:,:,:) :: vectorField_real_
  real(pREAL), allocatable, dimension(:,:,:) :: scalarField_real_
  real(pREAL), dimension(3,3) :: tensorSum
  real(pREAL), dimension(3) :: vectorSum
  real(pREAL) :: scalarSum
  real(pREAL), dimension(3,3) :: r
  integer(MPI_INTEGER_KIND) :: err_MPI

  call random_number(r)
  call MPI_Bcast(r,9_MPI_INTEGER_KIND,MPI_DOUBLE,0_MPI_INTEGER_KIND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)

  if (associated(tensorField_real)) then
    call random_number(tensorField_real)
    tensorField_real(1:3,1:3,cells(1)+1:cells1Red*2,:,:) = 0.0_pREAL
    tensorField_real_ = tensorField_real
    call fftw_mpi_execute_dft_r2c(planTensorForth,tensorField_real,tensorField_fourier)
    call MPI_Allreduce(sum(sum(sum(tensorField_real_,dim=5),dim=4),dim=3),tensorSum,9_MPI_INTEGER_KIND, &
                       MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,err_MPI)
    call parallelization_chkerr(err_MPI)
    if (worldrank==0) then
      if (any(dNeq(tensorSum/tensorField_fourier(:,:,1,1,1)%re,1.0_pREAL,1.0e-12_pREAL))) &
        error stop 'mismatch avg tensorField FFT <-> real'
    end if
    call fftw_mpi_execute_dft_c2r(planTensorBack,tensorField_fourier,tensorField_real)
    tensorField_real(1:3,1:3,cells(1)+1:cells1Red*2,:,:) = 0.0_pREAL
    if (maxval(abs(tensorField_real_ - tensorField_real*wgt))>5.0e-15_pREAL) &
      error stop 'mismatch tensorField FFT/invFFT <-> real'

    tensorField_real_ = spread(spread(spread(r,3,cells(1)),4,cells(2)),5,cells3)
    if (utilities_divergenceRMS(tensorField_real_)>5.0e-14_pREAL) error stop 'non-zero RMS div(const)'
    if (utilities_curlRMS(tensorField_real_)>5.0e-14_pREAL)       error stop 'non-zero RMS curl(const)'
  end if

  if (associated(vectorField_real)) then
    call random_number(vectorField_real)
    vectorField_real(1:3,cells(1)+1:cells1Red*2,:,:) = 0.0_pREAL
    vectorField_real_ = vectorField_real
    call fftw_mpi_execute_dft_r2c(planVectorForth,vectorField_real,vectorField_fourier)
    call MPI_Allreduce(sum(sum(sum(vectorField_real_,dim=4),dim=3),dim=2),vectorSum,3_MPI_INTEGER_KIND, &
                       MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,err_MPI)
    call parallelization_chkerr(err_MPI)
    if (worldrank==0) then
      if (any(dNeq(vectorSum/vectorField_fourier(:,1,1,1)%re,1.0_pREAL,1.0e-12_pREAL))) &
        error stop 'mismatch avg vectorField FFT <-> real'
    end if
    call fftw_mpi_execute_dft_c2r(planVectorBack,vectorField_fourier,vectorField_real)
    vectorField_real(1:3,cells(1)+1:cells1Red*2,:,:) = 0.0_pREAL
    if (maxval(abs(vectorField_real_ - vectorField_real*wgt))>5.0e-15_pREAL) &
      error stop 'mismatch vectorField FFT/invFFT <-> real'
  end if

  if (associated(scalarField_real)) then
    call random_number(scalarField_real)
    scalarField_real(cells(1)+1:cells1Red*2,:,:) = 0.0_pREAL
    scalarField_real_ = scalarField_real
    call fftw_mpi_execute_dft_r2c(planScalarForth,scalarField_real,scalarField_fourier)
    call MPI_Allreduce(sum(sum(sum(scalarField_real_,dim=3),dim=2),dim=1),scalarSum,1_MPI_INTEGER_KIND, &
                       MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,err_MPI)
    call parallelization_chkerr(err_MPI)
    if (worldrank==0) then
      if (dNeq(scalarSum/scalarField_fourier(1,1,1)%re,1.0_pREAL,1.0e-12_pREAL)) &
        error stop 'mismatch avg scalarField FFT <-> real'
    end if
    call fftw_mpi_execute_dft_c2r(planScalarBack,scalarField_fourier,scalarField_real)
    scalarField_real(cells(1)+1:cells1Red*2,:,:) = 0.0_pREAL
    if (maxval(abs(scalarField_real_ - scalarField_real*wgt))>5.0e-15_pREAL) &
      error stop 'mismatch scalarField FFT/invFFT <-> real'
  end if

  if (associated(scalarField_real) .and. associated(vectorField_real)) then
    scalarField_real_ = r(1,1)
    if (maxval(abs(utilities_scalarGradient(scalarField_real_)))>5.0e-9_pREAL)   error stop 'non-zero grad(const)'

    vectorField_real_ = spread(spread(spread(r(1,:),2,cells(1)),3,cells(2)),4,cells3)
    if (maxval(abs(utilities_vectorDivergence(vectorField_real_)))>5.0e-9_pREAL) error stop 'non-zero div(const)'


    if (cells(1) > 2 .and.  spectral_derivative_ID == DERIVATIVE_CONTINUOUS_ID) then
      scalarField_real_ = spread(spread(planeCosine(cells(1)),2,cells(2)),3,cells3)
      vectorField_real_ = utilities_scalarGradient(scalarField_real_)/TAU*geomSize(1)
      scalarField_real_ = -spread(spread(planeSine  (cells(1)),2,cells(2)),3,cells3)
      if (maxval(abs(vectorField_real_(1,:,:,:) - scalarField_real_))>5.0e-12_pREAL) error stop 'grad cosine'
      scalarField_real_ = spread(spread(planeSine  (cells(1)),2,cells(2)),3,cells3)
      vectorField_real_ = utilities_scalarGradient(scalarField_real_)/TAU*geomSize(1)
      scalarField_real_ = spread(spread(planeCosine(cells(1)),2,cells(2)),3,cells3)
      if (maxval(abs(vectorField_real_(1,:,:,:) - scalarField_real_))>5.0e-12_pREAL) error stop 'grad sine'

      vectorField_real_(2:3,:,:,:) = 0.0_pREAL
      vectorField_real_(1,:,:,:) = spread(spread(planeCosine(cells(1)),2,cells(2)),3,cells3)
      scalarField_real_ = utilities_vectorDivergence(vectorField_real_)/TAU*geomSize(1)
      vectorField_real_(1,:,:,:) =-spread(spread(planeSine(  cells(1)),2,cells(2)),3,cells3)
      if (maxval(abs(vectorField_real_(1,:,:,:) - scalarField_real_))>5.0e-12_pREAL) error stop 'div cosine'
      vectorField_real_(2:3,:,:,:) = 0.0_pREAL
      vectorField_real_(1,:,:,:) = spread(spread(planeSine(  cells(1)),2,cells(2)),3,cells3)
      scalarField_real_ = utilities_vectorDivergence(vectorField_real_)/TAU*geomSize(1)
      vectorField_real_(1,:,:,:) = spread(spread(planeCosine(cells(1)),2,cells(2)),3,cells3)
      if (maxval(abs(vectorField_real_(1,:,:,:) - scalarField_real_))>5.0e-12_pREAL) error stop 'div sine'
    end if
  end if

  contains

    function planeCosine(n)
#ifndef __GFORTRAN__
      use prec
      use math
      import, none
#endif
      integer, intent(in) :: n
      real(pREAL), dimension(n) :: planeCosine


      planeCosine = cos(real(math_range(n),pREAL)/real(n,pREAL)*TAU-TAU/real(n*2,pREAL))

    end function planeCosine

    function planeSine(n)
#ifndef __GFORTRAN__
      use prec
      use math
      import, none
#endif
      integer, intent(in) :: n
      real(pREAL), dimension(n) :: planeSine


      planeSine = sin(real(math_range(n),pREAL)/real(n,pREAL)*TAU-TAU/real(n*2,pREAL))

    end function planeSine

end subroutine selfTest

end module spectral_utilities

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @author Pratheek Shanthraj, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Michigan State University
!> @brief material subroutine for variable heat source
!--------------------------------------------------------------------------------------------------
submodule(phase:thermal) source_externalheat


  integer,           dimension(:),   allocatable :: &
    source_ID                                                                                       !< index in phase source list corresponding to this source

  type :: tParameters                                                                               !< container type for internal constitutive parameters
    type(tTable) :: f                                                                               !< external heat power as (tabulated) function of time
  end type tParameters

  type(tParameters), dimension(:), allocatable  :: param                                            !< containers of constitutive parameters (len Ninstances)


contains


!--------------------------------------------------------------------------------------------------
!> @brief module initialization
!> @details reads in material parameters, allocates arrays, and does sanity checks
!--------------------------------------------------------------------------------------------------
module function source_externalheat_init(maxNsources) result(isMySource)

  integer, intent(in)                  :: maxNsources
  logical, dimension(:,:), allocatable :: isMySource

  type(tDict), pointer :: &
    phases, &
    phase, &
    thermal, &
    src
  type(tList), pointer :: &
    sources
  character(len=:), allocatable :: refs
  integer :: ph,Nmembers,so,Nsources


  isMySource = thermal_active('externalheat',maxNsources)
  if (count(isMySource) == 0) return

  print'(/,1x,a)', '<<<+-  phase:thermal:source_externalheat init  -+>>>'
  print'(/,1x,a,1x,i0)', '# phases:',count(isMySource); flush(IO_STDOUT)


  phases => config_material%get_dict('phase')
  allocate(param(size(phases)))
  allocate(source_ID(size(phases)), source=0)

  do ph = 1, size(phases)
    Nsources = count(isMySource(:,ph))
    if (Nsources == 0) cycle
    if (Nsources > 1) call IO_error(600,ext_msg='externalheat')
    Nmembers = count(material_ID_phase == ph)
    phase => phases%get_dict(ph)
    thermal => phase%get_dict('thermal')
    sources => thermal%get_list('source')
    do so = 1, size(sources)
      if (isMySource(so,ph)) then
        source_ID(ph) = so
        associate(prm  => param(ph))
          src => sources%get_dict(so)
          print'(/,1x,a,1x,i0,1x,a,1x,a,1x,i0)', 'phase',ph,'('//phases%key(ph)//')','source',so
          refs = config_listReferences(src,indent=3)
          if (len(refs) > 0) print'(/,1x,a)', refs

          prm%f = table(src,'t','f')
          call phase_allocateState(thermalState(ph)%p(so),Nmembers,1,1,0)
        end associate
        exit
      end if
    end do
  end do

end function source_externalheat_init


!--------------------------------------------------------------------------------------------------
!> @brief rate of change of state
!> @details state only contains current time to linearly interpolate given heat powers
!--------------------------------------------------------------------------------------------------
module subroutine source_externalheat_dotState(ph, en)

  integer, intent(in) :: &
    ph, &
    en


  thermalState(ph)%p(source_ID(ph))%dotState(1,en) = 1.0_pREAL                                         ! state is current time

end subroutine source_externalheat_dotState


!--------------------------------------------------------------------------------------------------
!> @brief returns local heat generation rate
!--------------------------------------------------------------------------------------------------
module function source_externalheat_f_T(ph,en) result(f_T)

  integer, intent(in) :: &
    ph, &
    en
  real(pREAL) :: &
    f_T


  associate(prm => param(ph))
    f_T = prm%f%at(thermalState(ph)%p(source_ID(ph))%state(1,en))
  end associate

end function source_externalheat_f_T

end submodule source_externalheat

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
submodule(phase:mechanical) plastic

  interface

    module function plastic_none_init()          result(myPlasticity)
      logical, dimension(:), allocatable :: &
        myPlasticity
    end function plastic_none_init

    module function plastic_isotropic_init()     result(myPlasticity)
      logical, dimension(:), allocatable :: &
        myPlasticity
    end function plastic_isotropic_init

    module function plastic_phenopowerlaw_init() result(myPlasticity)
      logical, dimension(:), allocatable :: &
        myPlasticity
    end function plastic_phenopowerlaw_init

    module function plastic_kinehardening_init() result(myPlasticity)
      logical, dimension(:), allocatable :: &
        myPlasticity
    end function plastic_kinehardening_init

    module function plastic_dislotwin_init()     result(myPlasticity)
      logical, dimension(:), allocatable :: &
        myPlasticity
    end function plastic_dislotwin_init

    module function plastic_dislotungsten_init() result(myPlasticity)
      logical, dimension(:), allocatable :: &
        myPlasticity
    end function plastic_dislotungsten_init

    module function plastic_nonlocal_init()      result(myPlasticity)
      logical, dimension(:), allocatable :: &
        myPlasticity
    end function plastic_nonlocal_init

    module subroutine isotropic_LpAndItsTangent(Lp,dLp_dMp,Mp,ph,en)
      real(pREAL), dimension(3,3),     intent(out) :: &
        Lp
      real(pREAL), dimension(3,3,3,3), intent(out) :: &
        dLp_dMp
      real(pREAL), dimension(3,3),     intent(in) :: &
        Mp
      integer,                         intent(in) :: &
        ph, &
        en
    end subroutine isotropic_LpAndItsTangent

    pure module subroutine phenopowerlaw_LpAndItsTangent(Lp,dLp_dMp,Mp,ph,en)
      real(pREAL), dimension(3,3),     intent(out) :: &
        Lp
      real(pREAL), dimension(3,3,3,3), intent(out) :: &
        dLp_dMp
      real(pREAL), dimension(3,3),     intent(in) :: &
        Mp
      integer,                         intent(in) :: &
        ph, &
        en
    end subroutine phenopowerlaw_LpAndItsTangent

    pure module subroutine kinehardening_LpAndItsTangent(Lp,dLp_dMp,Mp,ph,en)
      real(pREAL), dimension(3,3),     intent(out) :: &
        Lp
      real(pREAL), dimension(3,3,3,3), intent(out) :: &
        dLp_dMp
      real(pREAL), dimension(3,3),     intent(in) :: &
        Mp
      integer,                         intent(in) :: &
        ph, &
        en
    end subroutine kinehardening_LpAndItsTangent

    module subroutine dislotwin_LpAndItsTangent(Lp,dLp_dMp,Mp,ph,en)
      real(pREAL), dimension(3,3),     intent(out) :: &
        Lp
      real(pREAL), dimension(3,3,3,3), intent(out) :: &
        dLp_dMp
      real(pREAL), dimension(3,3),     intent(in) :: &
        Mp
      integer,                         intent(in) :: &
        ph, &
        en
    end subroutine dislotwin_LpAndItsTangent

    pure module subroutine dislotungsten_LpAndItsTangent(Lp,dLp_dMp,Mp,ph,en)
      real(pREAL), dimension(3,3),     intent(out) :: &
        Lp
      real(pREAL), dimension(3,3,3,3), intent(out) :: &
        dLp_dMp
      real(pREAL), dimension(3,3),     intent(in) :: &
        Mp
      integer,                         intent(in) :: &
        ph, &
        en
    end subroutine dislotungsten_LpAndItsTangent

    module subroutine nonlocal_LpAndItsTangent(Lp,dLp_dMp,Mp,ph,en)
      real(pREAL), dimension(3,3),     intent(out) :: &
        Lp
      real(pREAL), dimension(3,3,3,3), intent(out) :: &
        dLp_dMp
      real(pREAL), dimension(3,3),     intent(in) :: &
        Mp                                                                                          !< Mandel stress
      integer,                         intent(in) :: &
        ph, &
        en
    end subroutine nonlocal_LpAndItsTangent


    module function isotropic_dotState(Mp,ph,en) result(dotState)
      real(pREAL), dimension(3,3),  intent(in) :: &
        Mp                                                                                          !< Mandel stress
      integer,                      intent(in) :: &
        ph, &
        en
      real(pREAL), dimension(plasticState(ph)%sizeDotState) :: &
        dotState
    end function isotropic_dotState

    module function phenopowerlaw_dotState(Mp,ph,en) result(dotState)
      real(pREAL), dimension(3,3),  intent(in) :: &
        Mp                                                                                          !< Mandel stress
      integer,                      intent(in) :: &
        ph, &
        en
      real(pREAL), dimension(plasticState(ph)%sizeDotState) :: &
        dotState
    end function phenopowerlaw_dotState

    module function plastic_kinehardening_dotState(Mp,ph,en) result(dotState)
      real(pREAL), dimension(3,3),  intent(in) :: &
        Mp                                                                                          !< Mandel stress
      integer,                      intent(in) :: &
        ph, &
        en
      real(pREAL), dimension(plasticState(ph)%sizeDotState) :: &
        dotState
    end function plastic_kinehardening_dotState

    module function dislotwin_dotState(Mp,ph,en) result(dotState)
      real(pREAL), dimension(3,3),  intent(in) :: &
        Mp                                                                                          !< Mandel stress
      integer,                      intent(in) :: &
        ph, &
        en
      real(pREAL), dimension(plasticState(ph)%sizeDotState) :: &
        dotState
    end function dislotwin_dotState

    module function dislotungsten_dotState(Mp,ph,en) result(dotState)
      real(pREAL), dimension(3,3),  intent(in) :: &
        Mp                                                                                          !< Mandel stress
      integer,                      intent(in) :: &
        ph, &
        en
      real(pREAL), dimension(plasticState(ph)%sizeDotState) :: &
        dotState
    end function dislotungsten_dotState

    module subroutine nonlocal_dotState(Mp,Delta_T,ph,en)
      real(pREAL), dimension(3,3), intent(in) :: &
        Mp                                                                                          !< MandelStress
      real(pREAL), intent(in) :: &
        Delta_T                                                                                     !< substepped crystallite time increment
      integer, intent(in) :: &
        ph, &
        en
    end subroutine nonlocal_dotState

    module subroutine dislotwin_dependentState(ph,en)
      integer,       intent(in) :: &
        ph, &
        en
    end subroutine dislotwin_dependentState

    module subroutine dislotungsten_dependentState(ph,en)
      integer,       intent(in) :: &
        ph, &
        en
    end subroutine dislotungsten_dependentState

    module subroutine nonlocal_dependentState(ph,en)
      integer, intent(in) :: &
        ph, &
        en
    end subroutine nonlocal_dependentState

    module subroutine plastic_kinehardening_deltaState(Mp,ph,en)
      real(pREAL), dimension(3,3),  intent(in) :: &
        Mp                                                                                          !< Mandel stress
      integer,                      intent(in) :: &
        ph, &
        en
    end subroutine plastic_kinehardening_deltaState

    module subroutine plastic_nonlocal_deltaState(Mp,ph,en)
      real(pREAL), dimension(3,3), intent(in) :: &
        Mp
      integer, intent(in) :: &
        ph, &
        en
    end subroutine plastic_nonlocal_deltaState

    module subroutine plastic_nonlocal_updateCompatibility(orientation,ph,en)
      integer, intent(in) :: ph, en
        type(tRotationContainer), dimension(:), intent(in) :: orientation
    end subroutine plastic_nonlocal_updateCompatibility

  end interface

contains

module subroutine plastic_init


  print'(/,1x,a)', '<<<+-  phase:mechanical:plasticity init  -+>>>'

  where(plastic_none_init())              mechanical_plasticity_type = MECHANICAL_PLASTICITY_NONE
  where(plastic_isotropic_init())         mechanical_plasticity_type = MECHANICAL_PLASTICITY_ISOTROPIC
  where(plastic_phenopowerlaw_init())     mechanical_plasticity_type = MECHANICAL_PLASTICITY_PHENOPOWERLAW
  where(plastic_kinehardening_init())     mechanical_plasticity_type = MECHANICAL_PLASTICITY_KINEHARDENING
  where(plastic_dislotwin_init())         mechanical_plasticity_type = MECHANICAL_PLASTICITY_DISLOTWIN
  where(plastic_dislotungsten_init())     mechanical_plasticity_type = MECHANICAL_PLASTICITY_DISLOTUNGSTEN
  where(plastic_nonlocal_init())          mechanical_plasticity_type = MECHANICAL_PLASTICITY_NONLOCAL

  if (any(mechanical_plasticity_type == UNDEFINED)) call IO_error(200, label1='plasticity')

end subroutine plastic_init

!--------------------------------------------------------------------------------------------------
!> @brief constitutive equation for calculating the velocity gradient
! ToDo: Discuss whether it makes sense if crystallite handles the configuration conversion, i.e.
! Mp in, dLp_dMp out
!--------------------------------------------------------------------------------------------------
module subroutine plastic_LpAndItsTangents(Lp, dLp_dS, dLp_dFi, &
                                           S, Fi, ph,en)
  integer, intent(in) :: &
    ph,en
  real(pREAL),   intent(in),  dimension(3,3) :: &
    S, &                                                                                            !< 2nd Piola-Kirchhoff stress
    Fi                                                                                              !< intermediate deformation gradient
  real(pREAL),   intent(out), dimension(3,3) :: &
    Lp                                                                                              !< plastic velocity gradient
  real(pREAL),   intent(out), dimension(3,3,3,3) :: &
    dLp_dS, &
    dLp_dFi                                                                                         !< derivative en Lp with respect to Fi

  real(pREAL), dimension(3,3,3,3) :: &
    dLp_dMp                                                                                         !< derivative of Lp with respect to Mandel stress
  real(pREAL), dimension(3,3) :: &
    Mp                                                                                              !< Mandel stress work conjugate with Lp
  integer :: &
    i, j


  if (mechanical_plasticity_type(ph) == MECHANICAL_PLASTICITY_NONE) then
    Lp      = 0.0_pREAL
    dLp_dFi = 0.0_pREAL
    dLp_dS  = 0.0_pREAL
  else

    Mp = matmul(matmul(transpose(Fi),Fi),S)

    plasticType: select case (mechanical_plasticity_type(ph))

      case (MECHANICAL_PLASTICITY_ISOTROPIC) plasticType
        call isotropic_LpAndItsTangent(Lp,dLp_dMp,Mp,ph,en)

      case (MECHANICAL_PLASTICITY_PHENOPOWERLAW) plasticType
        call phenopowerlaw_LpAndItsTangent(Lp,dLp_dMp,Mp,ph,en)

      case (MECHANICAL_PLASTICITY_KINEHARDENING) plasticType
        call kinehardening_LpAndItsTangent(Lp,dLp_dMp,Mp,ph,en)

      case (MECHANICAL_PLASTICITY_NONLOCAL) plasticType
        call nonlocal_LpAndItsTangent(Lp,dLp_dMp,Mp,ph,en)

      case (MECHANICAL_PLASTICITY_DISLOTWIN) plasticType
        call dislotwin_LpAndItsTangent(Lp,dLp_dMp,Mp,ph,en)

      case (MECHANICAL_PLASTICITY_DISLOTUNGSTEN) plasticType
        call dislotungsten_LpAndItsTangent(Lp,dLp_dMp,Mp,ph,en)

    end select plasticType

    do i=1,3; do j=1,3
      dLp_dFi(i,j,1:3,1:3) = matmul(matmul(Fi,S),transpose(dLp_dMp(i,j,1:3,1:3))) + &
                             matmul(matmul(Fi,dLp_dMp(i,j,1:3,1:3)),S)
      dLp_dS(i,j,1:3,1:3)  = matmul(matmul(transpose(Fi),Fi),dLp_dMp(i,j,1:3,1:3))                  ! ToDo: @PS: why not:   dLp_dMp:(FiT Fi)
    end do; end do

  end if

end subroutine plastic_LpAndItsTangents


!--------------------------------------------------------------------------------------------------
!> @brief contains the constitutive equation for calculating the rate of change of microstructure
!--------------------------------------------------------------------------------------------------
module function plastic_dotState(subdt,ph,en) result(dotState)

  integer, intent(in) :: &
    ph, &
    en
  real(pREAL),  intent(in) :: &
    subdt                                                                                           !< timestep
  real(pREAL),              dimension(3,3) :: &
    Mp
  real(pREAL), dimension(plasticState(ph)%sizeDotState) :: &
    dotState


  if (mechanical_plasticity_type(ph) /= MECHANICAL_PLASTICITY_NONE) then
    Mp = matmul(matmul(transpose(phase_mechanical_Fi(ph)%data(1:3,1:3,en)),&
                       phase_mechanical_Fi(ph)%data(1:3,1:3,en)),phase_mechanical_S(ph)%data(1:3,1:3,en))

    plasticType: select case (mechanical_plasticity_type(ph))

      case (MECHANICAL_PLASTICITY_ISOTROPIC) plasticType
        dotState = isotropic_dotState(Mp,ph,en)

      case (MECHANICAL_PLASTICITY_PHENOPOWERLAW) plasticType
        dotState = phenopowerlaw_dotState(Mp,ph,en)

      case (MECHANICAL_PLASTICITY_KINEHARDENING) plasticType
        dotState = plastic_kinehardening_dotState(Mp,ph,en)

      case (MECHANICAL_PLASTICITY_DISLOTWIN) plasticType
        dotState = dislotwin_dotState(Mp,ph,en)

      case (MECHANICAL_PLASTICITY_DISLOTUNGSTEN) plasticType
        dotState = dislotungsten_dotState(Mp,ph,en)

      case (MECHANICAL_PLASTICITY_NONLOCAL) plasticType
        call nonlocal_dotState(Mp,subdt,ph,en)
        dotState = plasticState(ph)%dotState(:,en)

    end select plasticType
  end if

end function plastic_dotState


!--------------------------------------------------------------------------------------------------
!> @brief calls microstructure function of the different plasticity constitutive models
!--------------------------------------------------------------------------------------------------
module subroutine plastic_dependentState(ph,en)

  integer, intent(in) :: &
    ph, &
    en


  plasticType: select case (mechanical_plasticity_type(ph))

    case (MECHANICAL_PLASTICITY_DISLOTWIN) plasticType
      call dislotwin_dependentState(ph,en)

    case (MECHANICAL_PLASTICITY_DISLOTUNGSTEN) plasticType
      call dislotungsten_dependentState(ph,en)

    case (MECHANICAL_PLASTICITY_NONLOCAL) plasticType
      call nonlocal_dependentState(ph,en)
      if (plasticState(ph)%nonlocal) call plastic_nonlocal_updateCompatibility(phase_O,ph,en)

  end select plasticType

end subroutine plastic_dependentState


!--------------------------------------------------------------------------------------------------
!> @brief for constitutive models that have an instantaneous change of state
!> will return false if delta state is not needed/supported by the constitutive model
!--------------------------------------------------------------------------------------------------
module function plastic_deltaState(ph, en) result(status)

  integer, intent(in) :: &
    ph, &
    en
  integer(kind(STATUS_OK)) :: status

  real(pREAL), dimension(3,3) :: &
    Mp
  integer :: &
    mySize


  status = STATUS_OK

  select case (mechanical_plasticity_type(ph))
    case (MECHANICAL_PLASTICITY_NONLOCAL,MECHANICAL_PLASTICITY_KINEHARDENING)

      Mp = matmul(matmul(transpose(phase_mechanical_Fi(ph)%data(1:3,1:3,en)),&
                         phase_mechanical_Fi(ph)%data(1:3,1:3,en)),&
                  phase_mechanical_S(ph)%data(1:3,1:3,en))

      plasticType: select case (mechanical_plasticity_type(ph))

        case (MECHANICAL_PLASTICITY_KINEHARDENING) plasticType
          call plastic_kinehardening_deltaState(Mp,ph,en)

        case (MECHANICAL_PLASTICITY_NONLOCAL) plasticType
          call plastic_nonlocal_deltaState(Mp,ph,en)

      end select plasticType

      if (any(IEEE_is_NaN(plasticState(ph)%deltaState(:,en)))) status = STATUS_FAIL_PHASE_MECHANICAL_DELTASTATE
      if (status == STATUS_OK) then
        mySize   = plasticState(ph)%sizeDeltaState
        plasticState(ph)%deltaState2(1:mySize,en) = plasticState(ph)%deltaState2(1:mySize,en) &
                                                  + plasticState(ph)%deltaState(1:mySize,en)
      end if

  end select

end function plastic_deltaState


!--------------------------------------------------------------------------------------------------
!> @brief checks if a plastic module is active or not
!--------------------------------------------------------------------------------------------------
function plastic_active(plastic_label) result(active_plastic)

  character(len=*), intent(in)       :: plastic_label                                               !< type of plasticity model
  logical, dimension(:), allocatable :: active_plastic

  type(tDict), pointer :: &
    phases, &
    phase, &
    mech, &
    pl
  integer :: ph

  phases => config_material%get_dict('phase')
  allocate(active_plastic(size(phases)), source = .false. )
  do ph = 1, size(phases)
    phase => phases%get_dict(ph)
    mech  => phase%get_dict('mechanical')
    pl    => mech%get_dict('plastic',defaultVal = emptyDict)
    active_plastic(ph) = pl%get_asStr('type',defaultVal='none') == plastic_label
  end do

end function plastic_active

end submodule plastic

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!----------------------------------------------------------------------------------------------------
!> @brief internal microstructure state for all thermal sources and kinematics constitutive models
!----------------------------------------------------------------------------------------------------
submodule(phase) thermal

  type :: tThermalParameters
    type(tpolynomial) :: C_p                                                                        !< heat capacity
    type(tpolynomial) :: K_11, K_33                                                                 !< thermal conductivity
    character(len=pSTRLEN), allocatable, dimension(:) :: output
  end type tThermalParameters

  integer, dimension(:), allocatable :: &
    thermal_Nsources

  type(tSourceState),  allocatable, dimension(:) :: &
    thermalState

  type :: tFieldQuantities
    real(pREAL), dimension(:), allocatable :: T, dot_T
  end type tFieldQuantities

  type(tFieldQuantities), dimension(:), allocatable :: current

  type(tThermalParameters), dimension(:), allocatable :: param

  integer :: thermal_source_maxSizeDotState

  integer(kind(UNDEFINED)),  dimension(:,:), allocatable :: &
    thermal_source_type


  interface

    module function source_dissipation_init(maxNsources) result(isMySource)
      integer, intent(in) :: maxNsources
      logical, dimension(:,:), allocatable :: isMySource
    end function source_dissipation_init

    module function source_externalheat_init(maxNsources) result(isMySource)
      integer, intent(in) :: maxNsources
      logical, dimension(:,:), allocatable :: isMySource
    end function source_externalheat_init


    module subroutine source_externalheat_dotState(ph, en)
      integer, intent(in) :: &
        ph, &
        en
    end subroutine source_externalheat_dotState

    module function source_dissipation_f_T(ph,en) result(f_T)
      integer, intent(in) :: &
        ph, &
        en
      real(pREAL) :: f_T
    end function source_dissipation_f_T

    module function source_externalheat_f_T(ph,en)  result(f_T)
      integer, intent(in) :: &
        ph, &
        en
      real(pREAL) :: f_T
    end function source_externalheat_f_T

 end interface

contains

!----------------------------------------------------------------------------------------------
!< @brief Initializes thermal sources and kinematics mechanism.
!----------------------------------------------------------------------------------------------
module subroutine thermal_init(phases)

  type(tDict), pointer :: &
    phases

  type(tDict), pointer :: &
    phase, &
    thermal
  type(tList), pointer :: &
    sources
  character(len=:), allocatable :: &
    refs, &
    extmsg
  integer :: &
    ph, so, &
    Nmembers
  logical :: thermal_active

  print'(/,1x,a)', '<<<+-  phase:thermal init  -+>>>'

  allocate(current(size(phases)))
  allocate(thermalState(size(phases)))
  allocate(thermal_Nsources(size(phases)),source = 0)
  allocate(param(size(phases)))

  extmsg = ''
  thermal_active = .false.
  do ph = 1, size(phases)
    Nmembers = count(material_ID_phase == ph)
    allocate(current(ph)%T(Nmembers),source=T_ROOM)
    allocate(current(ph)%dot_T(Nmembers),source=0.0_pREAL)

    phase => phases%get_dict(ph)
    if (thermal_active) then
      thermal => phase%get_dict('thermal')
    else
      thermal => phase%get_dict('thermal',defaultVal=emptyDict)
    end if

    if (size(thermal) > 0) then
      thermal_active = .true.

      print'(/,1x,a,i0,a)', 'phase ',ph,': '//phases%key(ph)
      refs = config_listReferences(thermal,indent=3)
      if (len(refs) > 0) print'(/,1x,a)', refs

      associate(prm => param(ph))

        prm%C_p = polynomial(thermal,'C_p','T')
        prm%K_11 = polynomial(thermal,'K_11','T')

        if (any(phase_lattice(ph) == ['hP','tI'])) prm%K_33 = polynomial(thermal,'K_33','T')

      end associate

      ! sanity checks
      if (    phase_rho(ph) <= 0.0_pREAL )  extmsg = trim(extmsg)//' rho'
      if (extmsg /= '') call IO_error(211,ext_msg=trim(extmsg))

#if defined(__GFORTRAN__)
      param(ph)%output = output_as1dStr(thermal)
#else
      param(ph)%output = thermal%get_as1dStr('output',defaultVal=emptyStrArray)
#endif
      sources => thermal%get_list('source',defaultVal=emptyList)
      thermal_Nsources(ph) = size(sources)
    else
      thermal_Nsources(ph) = 0
    end if

    allocate(thermalstate(ph)%p(thermal_Nsources(ph)))

  end do

  allocate(thermal_source_type(maxval(thermal_Nsources),size(phases)), source = UNDEFINED)

  if (maxval(thermal_Nsources) /= 0) then
    where(source_dissipation_init (maxval(thermal_Nsources))) thermal_source_type = THERMAL_SOURCE_DISSIPATION
    where(source_externalheat_init(maxval(thermal_Nsources))) thermal_source_type = THERMAL_SOURCE_EXTERNALHEAT
  end if

  thermal_source_maxSizeDotState = 0
  do ph = 1,size(phases)

    do so = 1,thermal_Nsources(ph)
      thermalState(ph)%p(so)%state  = thermalState(ph)%p(so)%state0
    end do

    thermal_source_maxSizeDotState  = max(thermal_source_maxSizeDotState, &
                                          maxval(thermalState(ph)%p%sizeDotState))
  end do

end subroutine thermal_init


!----------------------------------------------------------------------------------------------
!< @brief Calculate thermal source (forcing term).
!----------------------------------------------------------------------------------------------
module function phase_f_T(ph,en) result(f)

  integer, intent(in) :: ph, en
  real(pREAL) :: f


  integer :: so


  f = 0.0_pREAL

  do so = 1, thermal_Nsources(ph)
   select case(thermal_source_type(so,ph))

     case (THERMAL_SOURCE_DISSIPATION)
       f = f + source_dissipation_f_T(ph,en)

     case (THERMAL_SOURCE_EXTERNALHEAT)
       f = f + source_externalheat_f_T(ph,en)

   end select

  end do

end function phase_f_T


!--------------------------------------------------------------------------------------------------
!> @brief tbd.
!--------------------------------------------------------------------------------------------------
function phase_thermal_collectDotState(ph,en) result(status)

  integer, intent(in) :: ph, en
  integer(kind(STATUS_OK)) :: status

  integer :: i


  status = STATUS_OK

  SourceLoop: do i = 1, thermal_Nsources(ph)

    if (thermal_source_type(i,ph) == THERMAL_SOURCE_EXTERNALHEAT) &
      call source_externalheat_dotState(ph,en)

    if (any(IEEE_is_NaN(thermalState(ph)%p(i)%dotState(:,en)))) status = STATUS_FAIL_PHASE_THERMAL_DOTSTATE

  end do SourceLoop

end function phase_thermal_collectDotState


!--------------------------------------------------------------------------------------------------
!> @brief Thermal viscosity.
!--------------------------------------------------------------------------------------------------
module function phase_mu_T(co,ce) result(mu)

  integer, intent(in) :: co, ce
  real(pREAL) :: mu

  real(pREAL) :: T


  associate(ph => material_ID_phase(co,ce), &
            en => material_entry_phase(co,ce))

    T = current(ph)%T(en)
    mu = phase_rho(ph) &
       * param(ph)%C_p%at(T)

  end associate

end function phase_mu_T


!--------------------------------------------------------------------------------------------------
!> @brief Thermal conductivity in reference configuration.
!--------------------------------------------------------------------------------------------------
module function phase_K_T(co,ce) result(K)

  integer, intent(in) :: co, ce
  real(pREAL), dimension(3,3) :: K

  real(pREAL) :: T


  associate(ph => material_ID_phase(co,ce), &
            en => material_entry_phase(co,ce))

    T = current(ph)%T(en)

    K = 0.0_pREAL
    K(1,1) = param(ph)%K_11%at(T)
    if (any(phase_lattice(ph) == ['hP','tI'])) K(3,3) = param(ph)%K_33%at(T)

    K = crystal_symmetrize_33(K,phase_lattice(ph))
    K = crystallite_push33ToRef(co,ce,K)

  end associate


end function phase_K_T


module function phase_thermal_constitutive(Delta_t,ph,en) result(status)

  real(pREAL), intent(in) :: Delta_t
  integer, intent(in) :: ph, en
  integer(kind(STATUS_OK)) :: status


  status = integrateThermalState(Delta_t,ph,en)

end function phase_thermal_constitutive


!--------------------------------------------------------------------------------------------------
!> @brief Integrate state with 1st order explicit Euler method.
!--------------------------------------------------------------------------------------------------
function integrateThermalState(Delta_t, ph,en) result(status)

  real(pREAL), intent(in) :: Delta_t
  integer, intent(in) :: ph, en
  integer(kind(STATUS_OK)) :: status

  integer :: &
    so, &
    sizeDotState


  status = phase_thermal_collectDotState(ph,en)
  if (status == STATUS_OK) then

    do so = 1, thermal_Nsources(ph)
      sizeDotState = thermalState(ph)%p(so)%sizeDotState
      thermalState(ph)%p(so)%state(1:sizeDotState,en) = thermalState(ph)%p(so)%state0(1:sizeDotState,en) &
                                                      + thermalState(ph)%p(so)%dotState(1:sizeDotState,en) * Delta_t
    end do

  end if

end function integrateThermalState


module subroutine thermal_restartWrite(groupHandle,ph)

  integer(HID_T), intent(in) :: groupHandle
  integer, intent(in) :: ph

  integer :: so


  do so = 1,thermal_Nsources(ph)
    call HDF5_write(thermalState(ph)%p(so)%state,groupHandle,'omega_thermal')
  end do

end subroutine thermal_restartWrite


module subroutine thermal_restartRead(groupHandle,ph)

  integer(HID_T), intent(in) :: groupHandle
  integer, intent(in) :: ph

  integer :: so


  do so = 1,thermal_Nsources(ph)
    call HDF5_read(thermalState(ph)%p(so)%state0,groupHandle,'omega_thermal')
  end do

end subroutine thermal_restartRead


module subroutine thermal_forward()

  integer :: ph, so


  do ph = 1, size(thermalState)
    do so = 1, size(thermalState(ph)%p)
      thermalState(ph)%p(so)%state0 = thermalState(ph)%p(so)%state
    end do
  end do

end subroutine thermal_forward


!----------------------------------------------------------------------------------------------
!< @brief Get temperature (for use by non-thermal physics).
!----------------------------------------------------------------------------------------------
pure module function thermal_T(ph,en) result(T)

  integer, intent(in) :: ph, en
  real(pREAL) :: T


  T = current(ph)%T(en)

end function thermal_T


!----------------------------------------------------------------------------------------------
!< @brief Get rate of temperature (for use by non-thermal physics).
!----------------------------------------------------------------------------------------------
module function thermal_dot_T(ph,en) result(dot_T)

  integer, intent(in) :: ph, en
  real(pREAL) :: dot_T


  dot_T = current(ph)%dot_T(en)

end function thermal_dot_T


!----------------------------------------------------------------------------------------------
!< @brief Set temperature
!----------------------------------------------------------------------------------------------
module subroutine phase_thermal_setField(T,dot_T, co,ce)

  real(pREAL), intent(in) :: T, dot_T
  integer, intent(in) :: ce, co


  current(material_ID_phase(co,ce))%T(material_entry_phase(co,ce)) = T
  current(material_ID_phase(co,ce))%dot_T(material_entry_phase(co,ce)) = dot_T

end subroutine phase_thermal_setField



!--------------------------------------------------------------------------------------------------
!> @brief checks if a source mechanism is active or not
!--------------------------------------------------------------------------------------------------
function thermal_active(source_label,src_length)  result(active_source)

  character(len=*), intent(in)         :: source_label                                              !< name of source mechanism
  integer,          intent(in)         :: src_length                                                !< max. number of sources in system
  logical, dimension(:,:), allocatable :: active_source

  type(tDict), pointer :: &
    phases, &
    phase, &
    thermal, &
    src
  type(tList), pointer :: &
    sources
  integer :: p,s

  phases => config_material%get_dict('phase')
  allocate(active_source(src_length,size(phases)), source = .false. )
  do p = 1, size(phases)
    phase => phases%get_dict(p)
    thermal => phase%get_dict('thermal',defaultVal=emptyDict)
    sources => thermal%get_list('source',defaultVal=emptyList)
    do s = 1, size(sources)
      src => sources%get_dict(s)
      active_source(s,p) = src%get_asStr('type') == source_label
    end do
  end do


end function thermal_active


!----------------------------------------------------------------------------------------------
!< @brief Write thermal sources results to HDF5 output file.
!----------------------------------------------------------------------------------------------
module subroutine thermal_result(group,ph)

  character(len=*), intent(in) :: group
  integer,          intent(in) :: ph


  integer :: ou

  if (.not. allocated(param(ph)%output)) return

  call result_closeGroup(result_addGroup(group//'thermal'))

  do ou = 1, size(param(ph)%output)

    select case(trim(param(ph)%output(ou)))

      case ('T')
        call result_writeDataset(current(ph)%T,group//'thermal','T', 'temperature','K')

    end select

  end do

end subroutine thermal_result


end submodule thermal

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author   Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author   Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author   Christoph Kords, Max-Planck-Institut für Eisenforschung GmbH
!> @author   Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @author   Luv Sharma, Max-Planck-Institut für Eisenforschung GmbH
!> @brief    setting precision for real and int type
!--------------------------------------------------------------------------------------------------
#ifdef PETSC
#include <petsc/finclude/petscsys.h>
#endif
module prec
  use, intrinsic :: IEEE_arithmetic
  use, intrinsic :: ISO_C_binding

#ifdef PETSC
  use PETScSys
#endif

  implicit none(type,external)
  public

  ! https://stevelionel.com/drfortran/2017/03/27/doctor-fortran-in-it-takes-all-kinds
  integer, parameter :: pREAL = IEEE_selected_real_kind(15,307)                                     !< number with 15 significant digits, up to 1e+-307 (typically 64 bit)
  integer, parameter :: pI16  = selected_int_kind(4)                                                !< number with at least up to +-1e4 (typically 16 bit)
  integer, parameter :: pI32  = selected_int_kind(9)                                                !< number with at least up to +-1e9 (typically 32 bit)
  integer, parameter :: pI64  = selected_int_kind(18)                                               !< number with at least up to +-1e18 (typically 64 bit)
#ifdef PETSC
  PetscInt,        private   :: dummy_int
  PetscErrorCode,  private   :: dummy_error_code
  integer,         parameter :: pPETSCINT = kind(dummy_int)
  integer,         parameter :: pPETSCERRORCODE = kind(dummy_error_code)
#endif
  integer,         parameter :: pSTRLEN = 256                                                       !< default length for fixed length strings
  integer,         parameter :: pPATHLEN = 4096                                                     !< maximum length of a path name on linux

  real(pREAL), parameter :: tol_math_check = 1.0e-8_pREAL                                           !< tolerance for internal math self-checks (rotation)


  real(pREAL), private, parameter :: PREAL_EPSILON = epsilon(0.0_pREAL)                             !< minimum positive number such that 1.0 + EPSILON /= 1.0.
  real(pREAL), public,  parameter :: PREAL_MIN     = tiny(0.0_pREAL)                                !< smallest normalized floating point number

  integer,                dimension(0), parameter :: emptyIntArray  = [integer::]
  real(pREAL),            dimension(0), parameter :: emptyRealArray = [real(pREAL)::]
  character(len=pSTRLEN), dimension(0), parameter :: emptyStrArray  = [character(len=pSTRLEN)::]


contains


!--------------------------------------------------------------------------------------------------
!> @brief Report precision and do self test.
!--------------------------------------------------------------------------------------------------
subroutine prec_init()

#ifdef PETSC
  PetscErrorCode :: err_PETSc
#endif


  print'(/,1x,a)', '<<<+-  prec init  -+>>>'

  print'(/,a,i0)',    ' integer size / bit:  ',bit_size(0)
  print'(  a,i0)',    '   maximum value:     ',huge(0)
  print'(/,a,i0)',    ' real size / bit:     ',storage_size(0.0_pREAL)
  print'(  a,e9.3)',  '   maximum value:     ',huge(0.0_pREAL)
  print'(  a,e9.3)',  '   minimum value:     ',PREAL_MIN
  print'(  a,e9.3)',  '   epsilon value:     ',PREAL_EPSILON
  print'(  a,i0)',    '   decimal precision: ',precision(0.0_pREAL)

#ifdef PETSC
#ifdef DEBUG
  call PetscSetFPTrap(PETSC_FP_TRAP_ON,err_PETSc)
#else
  call PetscSetFPTrap(PETSC_FP_TRAP_OFF,err_PETSc)
#endif
  CHKERRQ(err_PETSc)
#endif

  call prec_selfTest()

end subroutine prec_init


!--------------------------------------------------------------------------------------------------
!> @brief Test floating point numbers with double precision for equality.
! replaces "==" but for certain (relative) tolerance. Counterpart to dNeq
! https://randomascii.wordpress.com/2012/02/25/comparing-floating-point-numbers-2012-edition/
! AlmostEqualRelative
! ToDo: Use 'spacing': https://gcc.gnu.org/onlinedocs/gfortran/SPACING.html#SPACING
!--------------------------------------------------------------------------------------------------
logical elemental pure function dEq(a,b,tol)

  real(pREAL), intent(in)           :: a,b
  real(pREAL), intent(in), optional :: tol


  if (present(tol)) then
    dEq = abs(a-b) <= tol
  else
    dEq = abs(a-b) <= PREAL_EPSILON * maxval(abs([a,b]))
  end if

end function dEq


!--------------------------------------------------------------------------------------------------
!> @brief Test floating point numbers with double precision for inequality.
! replaces "!=" but for certain (relative) tolerance. Counterpart to dEq
! https://randomascii.wordpress.com/2012/02/25/comparing-floating-point-numbers-2012-edition/
! AlmostEqualRelative NOT
!--------------------------------------------------------------------------------------------------
logical elemental pure function dNeq(a,b,tol)

  real(pREAL), intent(in)           :: a,b
  real(pREAL), intent(in), optional :: tol


  dNeq = .not. dEq(a,b,tol)

end function dNeq


!--------------------------------------------------------------------------------------------------
!> @brief Test floating point number with double precision for equality to 0.
! replaces "==0" but everything not representable as a normal number is treated as 0. Counterpart to dNeq0
! https://de.mathworks.com/help/matlab/ref/realmin.html
! https://docs.oracle.com/cd/E19957-01/806-3568/ncg_math.html
!--------------------------------------------------------------------------------------------------
logical elemental pure function dEq0(a,tol)

  real(pREAL), intent(in)           :: a
  real(pREAL), intent(in), optional :: tol


  if (present(tol)) then
    dEq0 = abs(a) <= tol
  else
    dEq0 = abs(a) <= PREAL_MIN * 10.0_pREAL
  end if

end function dEq0


!--------------------------------------------------------------------------------------------------
!> @brief Test floating point number with double precision for inequality to 0.
! replaces "!=0" but everything not representable as a normal number is treated as 0. Counterpart to dEq0
! https://de.mathworks.com/help/matlab/ref/realmin.html
! https://docs.oracle.com/cd/E19957-01/806-3568/ncg_math.html
!--------------------------------------------------------------------------------------------------
logical elemental pure function dNeq0(a,tol)

  real(pREAL), intent(in)           :: a
  real(pREAL), intent(in), optional :: tol


  dNeq0 = .not. dEq0(a,tol)

end function dNeq0


!--------------------------------------------------------------------------------------------------
!> @brief Test complex floating point numbers with double precision for equality.
! replaces "==" but for certain (relative) tolerance. Counterpart to cNeq
! https://randomascii.wordpress.com/2012/02/25/comparing-floating-point-numbers-2012-edition/
! probably a component wise comparison would be more accurate than the comparsion of the absolute
! value
!--------------------------------------------------------------------------------------------------
logical elemental pure function cEq(a,b,tol)

  complex(pREAL), intent(in)           :: a,b
  real(pREAL),    intent(in), optional :: tol


  if (present(tol)) then
    cEq = abs(a-b) <= tol
  else
    cEq = abs(a-b) <= PREAL_EPSILON * maxval(abs([a,b]))
  end if

end function cEq


!--------------------------------------------------------------------------------------------------
!> @brief Test complex floating point numbers with double precision for inequality.
! replaces "!=" but for certain (relative) tolerance. Counterpart to cEq
! https://randomascii.wordpress.com/2012/02/25/comparing-floating-point-numbers-2012-edition/
! probably a component wise comparison would be more accurate than the comparsion of the absolute
! value
!--------------------------------------------------------------------------------------------------
logical elemental pure function cNeq(a,b,tol)

  complex(pREAL), intent(in)           :: a,b
  real(pREAL),    intent(in), optional :: tol


  cNeq = .not. cEq(a,b,tol)

end function cNeq


!--------------------------------------------------------------------------------------------------
!> @brief Decode byte array (C_SIGNED_CHAR) as C_FLOAT array (4 byte float).
!--------------------------------------------------------------------------------------------------
pure function prec_bytesToC_FLOAT(bytes)

  integer(C_SIGNED_CHAR), dimension(:), intent(in) :: bytes                                         !< byte-wise representation of a C_FLOAT array
  real(C_FLOAT), dimension(size(bytes,kind=pI64)/(storage_size(0._C_FLOAT,pI64)/8_pI64)) :: &
    prec_bytesToC_FLOAT


  prec_bytesToC_FLOAT = transfer(bytes,prec_bytesToC_FLOAT,size(prec_bytesToC_FLOAT))

end function prec_bytesToC_FLOAT


!--------------------------------------------------------------------------------------------------
!> @brief Decode byte array (C_SIGNED_CHAR) as C_DOUBLE array (8 byte float).
!--------------------------------------------------------------------------------------------------
pure function prec_bytesToC_DOUBLE(bytes)

  integer(C_SIGNED_CHAR), dimension(:), intent(in) :: bytes                                         !< byte-wise representation of a C_DOUBLE array
  real(C_DOUBLE), dimension(size(bytes,kind=pI64)/(storage_size(0._C_DOUBLE,pI64)/8_pI64)) :: &
    prec_bytesToC_DOUBLE


  prec_bytesToC_DOUBLE = transfer(bytes,prec_bytesToC_DOUBLE,size(prec_bytesToC_DOUBLE))

end function prec_bytesToC_DOUBLE


!--------------------------------------------------------------------------------------------------
!> @brief Decode byte array (C_SIGNED_CHAR) as C_INT32_T array (4 byte signed integer).
!--------------------------------------------------------------------------------------------------
pure function prec_bytesToC_INT32_T(bytes)

  integer(C_SIGNED_CHAR), dimension(:), intent(in) :: bytes                                         !< byte-wise representation of a C_INT32_T array
  integer(C_INT32_T), dimension(size(bytes,kind=pI64)/(storage_size(0_C_INT32_T,pI64)/8_pI64)) :: &
    prec_bytesToC_INT32_T


  prec_bytesToC_INT32_T = transfer(bytes,prec_bytesToC_INT32_T,size(prec_bytesToC_INT32_T))

end function prec_bytesToC_INT32_T


!--------------------------------------------------------------------------------------------------
!> @brief Decode byte array (C_SIGNED_CHAR) as C_INT64_T array (8 byte signed integer).
!--------------------------------------------------------------------------------------------------
pure function prec_bytesToC_INT64_T(bytes)

  integer(C_SIGNED_CHAR), dimension(:), intent(in) :: bytes                                         !< byte-wise representation of a C_INT64_T array
  integer(C_INT64_T), dimension(size(bytes,kind=pI64)/(storage_size(0_C_INT64_T,pI64)/8_pI64)) :: &
     prec_bytesToC_INT64_T


  prec_bytesToC_INT64_T = transfer(bytes,prec_bytesToC_INT64_T,size(prec_bytesToC_INT64_T))

end function prec_bytesToC_INT64_T


!--------------------------------------------------------------------------------------------------
!> @brief Check correctness of some prec functions.
!--------------------------------------------------------------------------------------------------
subroutine prec_selfTest()

  integer, allocatable, dimension(:) :: realloc_lhs_test
  real(pREAL),   dimension(1) :: f
  integer(pI64), dimension(1) :: i
  real(pREAL),   dimension(2) :: r
  real(pREAL)                 :: NaN
#ifdef PETSC
  PetscReal :: dummy_scalar


  if (pREAL /= kind(dummy_scalar))          error stop 'PETSc and DAMASK scalar datatypes do not match'
#endif

  realloc_lhs_test = [1,2]
  if (any(realloc_lhs_test/=[1,2]))         error stop 'LHS allocation'

  call random_number(r)
  r = r/minval(r)
  if (.not. all(dEq(r,r+PREAL_EPSILON)))    error stop 'dEq'
  if (dEq(r(1),r(2)) .and. dNeq(r(1),r(2))) error stop 'dNeq'
  if (.not. all(dEq0(r-(r+PREAL_MIN))))     error stop 'dEq0'

  NaN = IEEE_value(1.0_pREAL, IEEE_QUIET_NAN)

  ! even silent NaN causes issues with  PETSc's SetFPTrap
#ifndef DEBUG
  if (dEq(NaN,NaN))                         error stop 'dEq/(NaN,NaN)'
  if (dEq(NaN,r(1)))                        error stop 'dEq/(NaN,float)'
  if (dEq(r(1),NaN))                        error stop 'dEq/(float,NaN)'
  if (dEq0(NaN))                            error stop 'dEq0/(NaN)'

  if (.not. dNeq(NaN,NaN))                  error stop 'dNeq/(NaN,NaN)'
  if (.not. dNeq(NaN,r(1)))                 error stop 'dNeq/(NaN,float)'
  if (.not. dNeq(r(1),NaN))                 error stop 'dNeq/(float,NaN)'
  if (.not. dNeq0(NaN))                     error stop 'dNeq0/(NaN)'

  if (dEq(NaN,NaN,huge(1._pREAL)))          error stop 'dEq/(NaN,NaN,tol)'
  if (dEq(NaN,r(1),huge(1._pREAL)))         error stop 'dEq/(NaN,float,tol)'
  if (dEq(r(1),NaN,huge(1._pREAL)))         error stop 'dEq/(float,NaN,tol)'
  if (dEq0(NaN,huge(1._pREAL)))             error stop 'dEq0/(NaN,tol)'

  if (.not. dNeq(NaN,NaN,huge(1._pREAL)))   error stop 'dNeq/(NaN,NaN,tol)'
  if (.not. dNeq(NaN,r(1),huge(1._pREAL)))  error stop 'dNeq/(NaN,float,tol)'
  if (.not. dNeq(r(1),NaN,huge(1._pREAL)))  error stop 'dNeq/(float,NaN,tol)'
  if (.not. dNeq0(NaN,huge(1._pREAL)))      error stop 'dNeq0/(NaN,tol)'
#endif

  ! https://www.binaryconvert.com
  ! https://www.rapidtables.com/convert/number/binary-to-decimal.html
  f = real(prec_bytesToC_FLOAT(int([-65,+11,-102,+75],C_SIGNED_CHAR)),pREAL)
  if (dNeq(f(1),20191102.0_pREAL,0.0_pREAL)) error stop 'prec_bytesToC_FLOAT'

  f = real(prec_bytesToC_DOUBLE(int([0,0,0,-32,+119,+65,+115,65],C_SIGNED_CHAR)),pREAL)
  if (dNeq(f(1),20191102.0_pREAL,0.0_pREAL)) error stop 'prec_bytesToC_DOUBLE'

  i = int(prec_bytesToC_INT32_T(int([+126,+23,+52,+1],C_SIGNED_CHAR)),pI64)
  if (i(1) /= 20191102_pI64)                 error stop 'prec_bytesToC_INT32_T'

  i = int(prec_bytesToC_INT64_T(int([+126,+23,+52,+1,0,0,0,0],C_SIGNED_CHAR)),pI64)
  if (i(1) /= 20191102_pI64)                 error stop 'prec_bytesToC_INT64_T'

end subroutine prec_selfTest

end module prec

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Dummy plasticity for purely elastic material
!--------------------------------------------------------------------------------------------------
submodule(phase:plastic) none

contains

!--------------------------------------------------------------------------------------------------
!> @brief Perform module initialization.
!> @details reads in material parameters, allocates arrays, and does sanity checks
!--------------------------------------------------------------------------------------------------
module function plastic_none_init() result(myPlasticity)

  logical, dimension(:), allocatable :: myPlasticity
  integer :: &
    ph
  type(tDict), pointer :: &
    phases


  myPlasticity = plastic_active('none')
  if (count(myPlasticity) == 0) return

  print'(/,1x,a)', '<<<+-  phase:mechanical:plastic:none init  -+>>>'
  print'(/,1x,a,1x,i0)', '# phases:',count(myPlasticity); flush(IO_STDOUT)


  phases => config_material%get_dict('phase')

  do ph = 1, size(phases)
    if (.not. myPlasticity(ph)) cycle

    print'(/,1x,a,1x,i0,a)', 'phase',ph,': '//phases%key(ph)

    call phase_allocateState(plasticState(ph),count(material_ID_phase == ph),0,0,0)
  end do

end function plastic_none_init


end submodule none

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Pratheek Shanthraj, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author Javier Velo, KU Leuven
!--------------------------------------------------------------------------------------------------
#include <petsc/finclude/petscdmplex.h>
#include <petsc/finclude/petscis.h>
#include <petsc/finclude/petscdmda.h>
module discretization_mesh
  use PETScDMplex
  use PETScDMDA
  use PETScIS
#if PETSC_VERSION_MINOR<23
  use PETScDT
#endif
#ifndef PETSC_EXPOSES_MPI
  use MPI_f08
#endif

  use CLI
  use prec
  use parallelization
  use config
  use IO
  use discretization
  use result
  use types
  use prec

#ifndef PETSC_EXPOSES_MPIF90
  implicit none(type,external)
#else
  implicit none
#endif
  private

  PetscInt, public, protected :: &
    mesh_Nboundaries                                                                                !< Number of defined BC (total)

  PetscInt, dimension(2), public, protected :: &
    mesh_BCTypeSetSize                                                                              !< Number of each BC type (1: Vertex, 2: Faces)

  PetscInt, dimension(:), allocatable, public, protected :: &
    mesh_boundariesIS, &                                                                            !< Index Set (tag values) of BC in mesh file
    mesh_boundariesIdx                                                                              !< PETSC_BC_TYPE_X

  PetscInt, public, protected :: &
    mesh_nElems

!!!! BEGIN DEPRECATED !!!!!
  PetscInt, public, protected :: &
    mesh_maxNips                                                                                    !< max number of IPs in any CP element
!!!! END DEPRECATED !!!!!

  PetscInt, parameter, public :: &
    mesh_BCTypeFace   = 1_pPETSCINT, &
    mesh_BCTypeVertex = 2_pPETSCINT

  real(pREAL), dimension(:,:), allocatable, public, protected :: &
    x_n                                                                                             !< node x,z,y coordinates

  character(len=pSTRLEN), dimension(:), allocatable, public, protected :: &
    mesh_BCLabels

  enum, bind(c); enumerator :: &
    PETSC_BC_TYPE_CELL = 1, &
    PETSC_BC_TYPE_FACE, &
    PETSC_BC_TYPE_EDGE, &
    PETSC_BC_TYPE_VERTEX
  end enum

  character(len=*), &
  dimension(size([PETSC_BC_TYPE_CELL,PETSC_BC_TYPE_FACE,PETSC_BC_TYPE_EDGE,PETSC_BC_TYPE_VERTEX])), &
  parameter, public :: &
    PETSC_GENERIC_LABELS = ['Cell Sets  ', 'Face Sets  ', 'Edge Sets  ', 'Vertex Sets']             ! PETSc generic labels

  DM, public :: geomMesh

#if PETSC_VERSION_MINOR<23
  external :: &
    PetscFEDestroy, &
    PetscFEGetDimension, &
    PetscFEGetDualSpace, &
    PetscDualSpaceGetFunctional
#endif

  public :: &
    discretization_mesh_init

contains


!--------------------------------------------------------------------------------------------------
!> @brief Initialize the mesh.
!--------------------------------------------------------------------------------------------------
subroutine discretization_mesh_init()

  DM        :: globalMesh
  PetscInt  :: dimPlex, &                                                                           ! mesh dimension
               p_s, p_i, &                                                                          ! shape function/integration order
               n_mesh_labels, &                                                                     ! total number of labels in mesh file
               cellStart, cellEnd, pointStart, &
               j
  IS        :: label_values_IS                                                                      ! BC label values IS
  PetscBool :: has_label                                                                            ! label exists in the mesh
#if PETSC_VERSION_MINOR>=24
  IS        :: celltype_IS                                                                          ! 'celltype' label IS
  PetscBool :: isSimplex                                                                            ! reduced integration, simplex mesh
  PetscInt                                   :: nPolytopes                                          ! number of different polytopes in the mesh
  PetscInt,    dimension(:),     pointer     :: cells_IS                                            ! celltype IS values
  PetscInt,    dimension(:,:),   allocatable :: T_e                                                 ! element connectivity (node numbers in each cell)
#else
  real(pREAL), dimension(:),     pointer     :: qPointsP
  real(pREAL), dimension(:),     pointer     :: PETSC_NULL_REAL_POINTER => NULL()
#endif
  DMLabel   :: dm_label
  PetscSF   :: sf
  PetscQuadrature :: quadrature
  PetscErrorCode  :: err_PETSc

  type(tDict), pointer :: &
    num_solver, &
    num_mesh
  integer                                    :: dim, n, m, k
  integer(MPI_INTEGER_KIND)                  :: err_MPI
  integer,     dimension(:),     allocatable :: BC_set_idx                                          ! index for PETSc set labels (no 'edges' in 2D)
  PetscInt,    dimension(:),     pointer     :: label_values                                        ! BC label values (from IS)
  PetscInt,    dimension(:),     allocatable :: materialAt, &                                       ! material ID per cell
                                                label_tmp
  real(pREAL), dimension(:,:),   allocatable :: v_0                                                 ! volume associated with IP (initially!)
  real(pREAL), dimension(:,:,:), allocatable :: x_p                                                 ! IP x,y,z coordinates (after deformation!)

  character(pSTRLEN) :: &
    BC_label                                                                                        ! label (string, defined in mesh file)


  print'(/,1x,a)',   '<<<+-  discretization_mesh init  -+>>>'

!--------------------------------------------------------------------------------
! read numerics parameter
  num_solver => config_numerics%get_dict('solver',defaultVal=emptyDict)
  num_mesh   => num_solver%get_dict('mesh',defaultVal=emptyDict)
  p_i = int(num_mesh%get_asInt('p_i',defaultVal=2),pPETSCINT)
  p_s = int(num_mesh%get_asInt('p_s',defaultVal=2),pPETSCINT)

  call PetscOptionsInsertString(PETSC_NULL_OPTIONS,                        &
                                ' -dm_plex_filename ' // CLI_geomFile // ' &
                                & -dm_plex_interpolate 1                   &
                                & -dm_plex_gmsh_use_generic                &
                                & -dm_plex_gmsh_use_regions                &
                                & -dm_plex_gmsh_multiple_tags              &
                                & -dm_plex_gmsh_mark_vertices ',           &
                                err_PETSc)
  call DMCreate(PETSC_COMM_WORLD, globalMesh, err_PETSc)
  CHKERRQ(err_PETSc)
  call DMSetType(globalMesh, DMPLEX, err_PETSc)
  CHKERRQ(err_PETSc)
  call DMSetFromOptions(globalMesh, err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGetDimension(globalMesh,dimPlex,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGetStratumSize(globalMesh,'depth',dimPlex,mesh_nElems,err_PETSc)
  CHKERRQ(err_PETSc)

#if PETSC_VERSION_MINOR>=24
  call DMPlexIsSimplex(globalMesh,isSimplex,err_PETSc)
  CHKERRQ(err_PETSc)
  if (.not. isSimplex) p_i = p_i + 1_pPETSCINT                                                      ! adjust for quad/hex (non-simplex)
! check invalid mesh (mixed or unsupported elements)
  call DMGetLabelIdIS(globalMesh, 'celltype', celltype_IS, err_PETSc)
  call ISGetSize(celltype_IS, nPolytopes, err_PETSc)
  if (nPolytopes /= dimPlex + 1_pPETSCINT) then                                                     ! at most one polytope type per dimension (0..dimPlex)
    call ISGetIndices(celltype_IS, cells_IS, err_PETSc)
    if (any(cells_IS == DM_POLYTOPE_SEG_PRISM_TENSOR%v .or. &
            cells_IS >  DM_POLYTOPE_HEXAHEDRON%v)) then
      call IO_error(800_pI16, 'mesh contains elements other than tri/quad/tet/hex')
    else if (count(cells_IS == DM_POLYTOPE_TRIANGLE%v .and. &
                   cells_IS == DM_POLYTOPE_QUADRILATERAL%v, dim = 1) > 1) then
      call IO_error(800_pI16, 'mixed triangles and quadrilaterals elements')
    else if (count(cells_IS == DM_POLYTOPE_TRIANGLE%v .and. &
                   cells_IS == DM_POLYTOPE_QUADRILATERAL%v, dim = 1) > 1) then
      call IO_error(800_pI16, 'mixed tetrahedra and hexahedra elements')
    end if
  end if
  call ISDestroy(celltype_IS, err_PETSc)
#endif

!--------------------------------------------------------------------------------
! read mesh tags
  if (dimPlex == 2_pPETSCINT) then
    allocate(BC_set_idx, source = [PETSC_BC_TYPE_FACE, PETSC_BC_TYPE_VERTEX])
  else
    allocate(BC_set_idx, source = [PETSC_BC_TYPE_FACE, PETSC_BC_TYPE_EDGE, PETSC_BC_TYPE_VERTEX])
  end if

  mesh_Nboundaries = 0_pPETSCINT
  do n = 1, size(BC_set_idx)
    call DMHasLabel(globalMesh,PETSC_GENERIC_LABELS(BC_set_idx(n)),has_label,err_PETSc)
    if (has_label) then
      call DMGetLabel(globalMesh,PETSC_GENERIC_LABELS(BC_set_idx(n)),dm_label,err_PETSc)
      CHKERRQ(err_PETSc)
      call DMLabelGetNonEmptyStratumValuesIS(dm_label, label_values_IS, err_PETSc)
      CHKERRQ(err_PETSc)
      call ISGetIndices(label_values_IS,label_values,err_PETSc)
      CHKERRQ(err_PETSc)
      if (.not. allocated(mesh_boundariesIS)) then
        allocate(mesh_boundariesIS, source = label_values)
        allocate(mesh_boundariesIdx(size(label_values)), source = int(BC_set_idx(n), pPETSCINT))
        mesh_Nboundaries = mesh_Nboundaries + int(size(label_values), pPETSCINT)
      else
        allocate(label_tmp, mold = label_values)
        k = 0
        do m = 1, size(label_values)
          if (any(label_values(m) == mesh_boundariesIS)) cycle
          k = k + 1
          label_tmp(k) = label_values(m)
        end do
        mesh_boundariesIS = [mesh_boundariesIS, label_tmp(1:k)]
        mesh_boundariesIdx = [mesh_boundariesIdx, [(int(BC_set_idx(n), pPETSCINT), m = 1, k)]]
        mesh_Nboundaries = mesh_Nboundaries + int(k, pPETSCINT)
        deallocate(label_tmp)
      end if
      call ISRestoreIndices(label_values_IS,label_values,err_PETSc)
      CHKERRQ(err_PETSc)
    end if
  end do
  deallocate(BC_set_idx)
  if (mesh_Nboundaries == 0_pPETSCINT) &
    call IO_error(800_pI16, 'no mesh groups found to apply boundary conditions')

!--------------------------------------------------------------------------------
! read mesh labels
  call DMGetNumLabels(globalMesh, n_mesh_labels, err_PETSc)
  CHKERRQ(err_PETSc)
  if (n_mesh_labels > 2_pPETSCINT) then                                                             ! there are user-defined labels (for BC/material ID)
    allocate(character(len=pSTRLEN) :: mesh_BCLabels(mesh_Nboundaries))
    mesh_BCLabels = ''

    call DMPlexGetHeightStratum(globalMesh,0_pPETSCINT,cellStart,cellEnd,err_PETSc)
    do j = 2_pPETSCINT, n_mesh_labels - 1_pPETSCINT                                                 ! skip 'celltype' and 'depth' labels; 0-indexing in PETSc
      call DMGetLabelName(globalMesh, j, BC_label, err_PETSc)
      CHKERRQ(err_PETSc)
      if (any(BC_label == PETSC_GENERIC_LABELS)) cycle
      call DMGetLabel(globalMesh, BC_label, dm_label, err_PETSc)
      call DMLabelGetBounds(dm_label, pointStart, PETSC_NULL_INTEGER, err_PETSc)
      if (pointStart < cellEnd) cycle
      call DMLabelGetNonEmptyStratumValuesIS(dm_label, label_values_IS, err_PETSc)
      CHKERRQ(err_PETSc)
      call ISGetIndices(label_values_IS,label_values,err_PETSc)
      CHKERRQ(err_PETSc)
      n = findloc(mesh_boundariesIS, label_values(1), dim = 1)
      mesh_BCLabels(n) = BC_label
      call ISRestoreIndices(label_values_IS,label_values,err_PETSc)
      CHKERRQ(err_PETSc)
    end do
  else
    mesh_BCLabels = emptyStrArray
  end if

  dim = int(dimPlex)
  call MPI_Bcast(dim,1_MPI_INTEGER_KIND,MPI_INTEGER,0_MPI_INTEGER_KIND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  dimPlex = int(dim,pPETSCINT)

  if (worldsize == 1) then
    call DMClone(globalMesh,geomMesh,err_PETSc)
  else
    call DMPlexDistribute(globalMesh,0_pPETSCINT,sf,geomMesh,err_PETSc)
  end if
  CHKERRQ(err_PETSc)

  call MPI_Bcast(mesh_Nboundaries,1_MPI_INTEGER_KIND,MPI_INTEGER,0_MPI_INTEGER_KIND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  call MPI_Bcast(mesh_boundariesIS,int(mesh_Nboundaries,MPI_INTEGER_KIND),MPI_INTEGER,0_MPI_INTEGER_KIND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  call MPI_Bcast(mesh_boundariesIdx,int(mesh_Nboundaries,MPI_INTEGER_KIND),MPI_INTEGER,0_MPI_INTEGER_KIND, &
                 MPI_COMM_WORLD,err_MPI)
  if (worldrank /= 0) allocate(character(len=pSTRLEN) :: mesh_BCLabels(mesh_Nboundaries))
  call MPI_Bcast(mesh_BCLabels,int(pSTRLEN*size(mesh_BCLabels),MPI_INTEGER_KIND),MPI_CHARACTER, &
                 0_MPI_INTEGER_KIND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)

  call DMDestroy(globalMesh,err_PETSc)
  CHKERRQ(err_PETSc)

! Get initial nodal coordinates
#if PETSC_VERSION_MINOR>=24
  if (isSimplex) then
    call PetscDTSimplexQuadrature(dimPlex,p_i,PETSCDTSIMPLEXQUAD_DEFAULT,quadrature,err_PETSc)
  else
    call PetscDTGaussTensorQuadrature(dimPlex,dimPlex,p_i,-1.0_pREAL,1.0_pREAL, &
                                      quadrature,err_PETSc)
  end if
#elif PETSC_VERSION_MINOR==23
  call PetscDTSimplexQuadrature(dimPlex,p_i,PETSCDTSIMPLEXQUAD_DEFAULT,quadrature,err_PETSc)
#else
  call PetscDTSimplexQuadrature(dimPlex,p_i,-1,quadrature,err_PETSc)
#endif
  CHKERRQ(err_PETSc)

#if PETSC_VERSION_MINOR>=24
  call PetscQuadratureGetData(quadrature,PETSC_NULL_INTEGER,PETSC_NULL_INTEGER, &
                              mesh_maxNips,PETSC_NULL_REAL_POINTER, &
                              PETSC_NULL_REAL_POINTER,err_PETSc)
#elif PETSC_VERSION_MINOR>21
  call PetscQuadratureGetData(quadrature,PETSC_NULL_INTEGER,PETSC_NULL_INTEGER, &
                              mesh_maxNips,qPointsP,PETSC_NULL_REAL_POINTER,err_PETSc)
#else
  call PetscQuadratureGetData(quadrature,PETSC_NULL_INTEGER(1),PETSC_NULL_INTEGER(1), &
                              mesh_maxNips,qPointsP,PETSC_NULL_REAL_POINTER,err_PETSc)
#endif
  CHKERRQ(err_PETSc)

#if PETSC_VERSION_MINOR>=24
  x_p = build_coordinates_IP(dimPlex,quadrature)
#else
  x_p = build_coordinates_IP(dimPlex,qPointsP)
#endif
  v_0 = build_volume_IP(dimPlex)

#if (PETSC_VERSION_MINOR>24 || (PETSC_VERSION_MINOR==24 && PETSC_VERSION_SUBMINOR>=1))
  call build_nodes_and_connectivity(x_n,T_e,p_s)
#else
  call build_nodes_and_connectivity(x_n,p_s)
#endif

#if (PETSC_VERSION_MINOR==22 || PETSC_VERSION_MINOR==23)
  call PetscQuadratureRestoreData(quadrature,PETSC_NULL_INTEGER,PETSC_NULL_INTEGER, &
                                  PETSC_NULL_INTEGER,qPointsP,PETSC_NULL_REAL_POINTER,err_PETSc)
#elif (PETSC_VERSION_MINOR<22)
  call PetscQuadratureRestoreData(quadrature,PETSC_NULL_INTEGER(1),PETSC_NULL_INTEGER(1), &
                                  PETSC_NULL_INTEGER(1),qPointsP,PETSC_NULL_REAL_POINTER,err_PETSc)
#endif
  CHKERRQ(err_PETSc)

  call PetscQuadratureDestroy(quadrature, err_PETSc)
  CHKERRQ(err_PETSc)

  allocate(materialAt(mesh_nElems))
  do j = 1, mesh_nElems
    call DMGetLabelValue(geomMesh,'Cell Sets',j-1,materialAt(j),err_PETSc)
    CHKERRQ(err_PETSc)
  end do

  call discretization_init(int(materialAt),&
                           reshape(x_p,[3,int(mesh_maxNips*mesh_nElems)]), &
                           x_n)

#if (PETSC_VERSION_MINOR>24 || (PETSC_VERSION_MINOR==24 && PETSC_VERSION_SUBMINOR>=1))
  call writeGeometry(reshape(x_p,[3,int(mesh_maxNips*mesh_nElems)]),x_n,T_e)
#else
  call writeGeometry(reshape(x_p,[3,int(mesh_maxNips*mesh_nElems)]),x_n)
#endif

end subroutine discretization_mesh_init


!--------------------------------------------------------------------------------------------------
!> @brief Calculate IP volume.
!--------------------------------------------------------------------------------------------------
function build_volume_IP(dimPlex) result(v_0)

  real(pREAL), dimension(:,:), allocatable :: v_0
  PetscInt,    intent(in) :: dimPlex

  PetscReal      :: vol
  PetscInt       :: cellStart, cellEnd, cell
  PetscErrorCode :: err_PETSc
  PetscReal, pointer,dimension(:) :: pCent, pNorm


  allocate(v_0(mesh_maxNips,mesh_nElems),source=0.0_pREAL)

  call DMPlexGetHeightStratum(geomMesh,0_pPETSCINT,cellStart,cellEnd,err_PETSc)
  CHKERRQ(err_PETSc)
  allocate(pCent(dimPlex))
  allocate(pNorm(dimPlex))
  do cell = cellStart, cellEnd-1
    call DMPlexComputeCellGeometryFVM(geomMesh,cell,vol,pCent,pNorm,err_PETSc)
    CHKERRQ(err_PETSc)
    v_0(:,cell+1) = vol/real(mesh_maxNips,pREAL)
  end do

end function build_volume_IP


!--------------------------------------------------------------------------------------------------
!> @brief Calculate IP Coordinates.
!--------------------------------------------------------------------------------------------------
#if (PETSC_VERSION_MINOR>=24)
function build_coordinates_IP(dimPlex,quadrature) result(x_p)
#else
function build_coordinates_IP(dimPlex,qPoints) result(x_p)
#endif

  PetscInt,                                     intent(in) :: dimPlex
#if PETSC_VERSION_MINOR>=24
  PetscQuadrature,                              intent(in) :: quadrature
#else
  PetscReal,   dimension(mesh_maxNips*dimPlex), intent(in) :: qPoints
#endif
  real(pREAL), dimension(:,:,:), allocatable :: x_p


#if PETSC_VERSION_MINOR>=24
  PetscReal, pointer, dimension(:) :: pV0, pCellJ, pInvcellJ, pDetJ
#else
  PetscReal, pointer, dimension(:) :: pV0, pCellJ, pInvcellJ
  PetscReal      :: detJ
  PetscInt       :: qPt, dirI, dirJ, qOffset
#endif
  PetscInt       :: cellStart, cellEnd, cell
  PetscErrorCode :: err_PETSc


  call DMPlexGetHeightStratum(geomMesh,0_pPETSCINT,cellStart,cellEnd,err_PETSc)
  CHKERRQ(err_PETSc)

  allocate(x_p(3,mesh_maxNips,mesh_nElems),source=0.0_pREAL)
#if PETSC_VERSION_MINOR>=24
  allocate(pV0(mesh_maxNips*dimPlex))
  allocate(pCellJ(mesh_maxNips*dimPlex**2))
  allocate(pInvCellJ(mesh_maxNips*dimPlex**2))
  allocate(pDetJ(mesh_maxNips))

  do cell = cellStart, cellEnd-1_pPETSCINT
    call DMPlexComputeCellGeometryFEM(geomMesh,cell,quadrature,pV0,pCellJ,pInvCellJ,pDetJ,err_PETSc)
    CHKERRQ(err_PETSc)
    x_p(1:dimPlex,1:mesh_maxNips,cell+1_pPETSCINT) = reshape(pV0,[dimPlex,mesh_maxNips])
  end do
#else
  allocate(pV0(dimPlex))
  allocate(pCellJ(dimPlex**2))
  allocate(pinvCellJ(dimPlex**2))

  do cell = cellStart, cellEnd - 1_pPETSCINT                                                        ! loop over all elements
    call DMPlexComputeCellGeometryAffineFEM(geomMesh,cell,pV0,pCellJ,pInvcellJ,detJ,err_PETSc)
    CHKERRQ(err_PETSc)
    qOffset = 0
    do qPt = 1_pPETSCINT, mesh_maxNips
      do dirI = 1_pPETSCINT, dimPlex
        x_p(dirI,qPt,cell+1) = pV0(dirI)
        do dirJ = 1_pPETSCINT, dimPlex
          x_p(dirI,qPt,cell+1) = x_p(dirI,qPt,cell+1) &
                               + pCellJ((dirI-1)*dimPlex+dirJ)*(qPoints(qOffset+dirJ) + 1.0_pREAL)
        end do
      end do
      qOffset = qOffset + dimPlex
    end do
  end do
#endif

end function build_coordinates_IP


!--------------------------------------------------------------------------------------------------
!> @brief Get mesh node coordinates and element connectivity matrix.
!--------------------------------------------------------------------------------------------------
#if (PETSC_VERSION_MINOR>24 || (PETSC_VERSION_MINOR==24 && PETSC_VERSION_SUBMINOR>=1))
subroutine build_nodes_and_connectivity(x_n, T_e, p_s)
#else
subroutine build_nodes_and_connectivity(x_n, p_s)
#endif

  real(pREAL), dimension(:,:), allocatable, intent(out) :: &
    x_n                                                                                             !< mesh nodes coordinates (including high-order approximation)
#if (PETSC_VERSION_MINOR>24 || (PETSC_VERSION_MINOR==24 && PETSC_VERSION_SUBMINOR>=1))
  PetscInt,    dimension(:,:), allocatable, intent(out) :: &
    T_e                                                                                             !< element connectivity (node numbers in each cell)
#endif
  PetscInt, intent(in) :: &
    p_s                                                                                             !< order of approximation space

  DM       :: coordDM                                                                               ! approximation space DM
  Vec      :: coordVec                                                                              ! local nodes coordinates
  PetscInt :: coordDim,    &                                                                        ! DOF-per-node
              nLocalNodes, &                                                                        ! local number of nodes
              nCellNodes,  &                                                                        ! number of nodes in a cell
              feDim,       &                                                                        ! DOF per cell (nNodes x DOF per node)
              feBasis,     &
              cellStart, cellEnd, cell
  PetscDS  :: coordDS
  PetscFE  :: coordFE
  PetscSection    :: globalSection, localSection                                                    ! section (to retrieve DOF)
#if PETSC_VERSION_MINOR>=24
  DMPolytopeType  :: cell_type                                                                      ! tri, quad, tet, hex
#endif
  PetscDualSpace  :: coordDualSpace
  PetscQuadrature :: refQuadrature
  PetscErrorCode  :: err_PETSc, ierr

  real(pREAL), dimension(:), pointer     :: coords, &                                               ! local nodes coordinates
                                            nodeCoords                                              ! single node coordinates
  real(pREAL), dimension(:), allocatable :: refCoords                                               ! node coordinates in reference element [-1,+1]^d
#if PETSC_VERSION_MINOR>22
  real(pREAL), dimension(:), allocatable :: mappedCoords                                            ! real (mesh) node coordinates
#else
  real(pREAL), dimension(:), allocatable, target :: mappedCoords                                    ! real (mesh) node coordinates
  real(pREAL), dimension(:), pointer     :: pMappedCoords, &
                                            PETSC_NULL_REAL_POINTER => NULL()
#endif
#if (PETSC_VERSION_MINOR>24 || (PETSC_VERSION_MINOR==24 && PETSC_VERSION_SUBMINOR>=1))
  PetscInt,    dimension(:), pointer     :: indices                                                 ! cell closure DOF indices
  integer,     dimension(:), allocatable :: node_map                                                ! PETSc to VTK node order mapping
#endif
#if PETSC_VERSION_MINOR>=24
  PetscBool :: isSimplex
#endif


  call PetscOptionsInsertString(PETSC_NULL_OPTIONS, &
                                '-coord_petscspace_degree ' // IO_intAsStr(int(p_s)) // ' &
                                &-coord_petscdualspace_lagrange_node_type equispaced &
                                &-coord_petscdualspace_lagrange_node_endpoints 1 ',  &
                                err_PETSc)
  CHKERRQ(err_PETSc)
  call DMClone(geomMesh, coordDM, err_PETSc)
  CHKERRQ(err_PETSc)
  call DMSetFromOptions(coordDM, err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGetDimension(coordDM, coordDim, err_PETSc)
  CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR>=24
  call DMPlexIsSimplex(coordDM,isSimplex,err_PETSc)
  CHKERRQ(err_PETSc)
  call PetscFECreateDefault(PETSC_COMM_SELF, coordDim, coordDim, isSimplex, 'coord_', p_s, &
                            coordFE, err_PETSc)
#else
  call PetscFECreateDefault(PETSC_COMM_SELF, coordDim, coordDim, PETSC_TRUE, 'coord_', p_s, &
                            coordFE, err_PETSc)
#endif
  CHKERRQ(err_PETSc)

  call PetscFEGetDimension(coordFE, feDim, err_PETSc)
  CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR>22
  call DMAddField(coordDM, PETSC_NULL_DMLABEL, PetscObjectCast(coordFE), err_PETSc)
#else
  call DMAddField(coordDM, PETSC_NULL_DMLABEL, coordFE, err_PETSc)
#endif
  CHKERRQ(err_PETSc)

  call DMCreateDS(coordDM, err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGetDS(coordDM, coordDS, err_PETSc)
  CHKERRQ(err_PETSc)

  call DMGetGlobalSection(coordDM, globalSection, err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGetLocalSection(coordDM, localSection, err_PETSc)
  CHKERRQ(err_PETSc)
  call DMCreateLocalVector(coordDM, coordVec, err_PETSc)
  CHKERRQ(err_PETSc)

  call PetscFEGetDualSpace(coordFE, coordDualSpace, err_PETSc)
  CHKERRQ(err_PETSc)
  call PetscFEDestroy(coordFE, err_PETSc)
  CHKERRQ(err_PETSc)
  call DMPlexGetHeightStratum(coordDM, 0_pPETSCINT, cellStart, cellEnd, err_PETSc)
  CHKERRQ(err_PETSc)

  allocate(nodeCoords(coordDim))
  allocate(refCoords(feDim))
  allocate(mappedCoords(feDim))
  nCellNodes = feDim / coordDim

  do feBasis = 0_pPETSCINT, feDim-1_pPETSCINT, coordDim                                             ! coordinates in the reference cell in [-1,+1]^d
    call PetscDualSpaceGetFunctional(coordDualSpace, feBasis, refQuadrature, err_PETSc)
    CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR>21
    call PetscQuadratureGetData(refQuadrature, coordDim, PETSC_NULL_INTEGER, PETSC_NULL_INTEGER, &
#else
    call PetscQuadratureGetData(refQuadrature, coordDim, PETSC_NULL_INTEGER(1), &
                                PETSC_NULL_INTEGER(1), &
#endif
                                nodeCoords, PETSC_NULL_REAL_POINTER, err_PETSc)
    CHKERRQ(err_PETSc)
    refCoords(feBasis + 1:feBasis + coordDim) = nodeCoords
  end do

  do cell = cellStart, cellEnd - 1_pPETSCINT                                                        ! map reference to real (mesh) coordinates
    call DMPlexReferenceToCoordinates(coordDM, cell, nCellNodes, refCoords, &
                                      mappedCoords, err_PETSc)
    CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR>22
    PetscCall(DMPlexVecSetClosure(coordDM, localSection, coordVec, cell, mappedCoords,INSERT_VALUES, ierr))
#else
    pMappedCoords => mappedCoords
    call DMPlexVecSetClosure(coordDM, localSection, coordVec, cell, pMappedCoords, &
                             INSERT_VALUES, err_PETSc)
    CHKERRQ(err_PETSc)
#endif
  end do

  call VecGetArrayRead(coordVec,coords,err_PETSc)
  nLocalNodes = size(coords) / coordDim
  allocate(x_n(3, nLocalNodes), source = 0.0_pREAL)
  x_n(1:coordDim, 1:nLocalNodes) = reshape(coords, [coordDim, nLocalNodes])
  call VecRestoreArrayRead(coordVec, coords, err_PETSc)

#if (PETSC_VERSION_MINOR>24 || (PETSC_VERSION_MINOR==24 && PETSC_VERSION_SUBMINOR>=1))
  PetscCall(DMPlexGetHeightStratum(coordDM, 0_pPETSCINT, cellStart, cellEnd, ierr))
  PetscCall(DMPlexGetCellType(coordDM, cellStart, cell_type, ierr))
  node_map = PETSc_to_VTK_node_order(cell_type, int(p_s))

  allocate(T_e(nCellNodes, cellEnd - cellStart), source = -1_pPETSCINT)
  do cell = cellStart, cellEnd - 1_pPETSCINT
    call DMPlexGetClosureIndices(coordDM, localSection, globalSection, cell, PETSC_TRUE, &
                                 PETSC_NULL_INTEGER, indices, PETSC_NULL_INTEGER_ARRAY, &
                                 PETSC_NULL_REAL_POINTER, ierr)
    CHKERRQ(ierr)
    T_e(1:nCellNodes, cell + 1_pPETSCINT) = indices(coordDim * node_map - 1_pPETSCINT) / coordDim
    call DMPlexRestoreClosureIndices(coordDM, localSection, globalSection, cell, PETSC_TRUE, &
                                     PETSC_NULL_INTEGER, indices, PETSC_NULL_INTEGER_ARRAY, &
                                     PETSC_NULL_REAL_POINTER, ierr)
    CHKERRQ(ierr)
  end do
#endif

  call DMDestroy(coordDM, err_PETSc)
  CHKERRQ(err_PETSc)

end subroutine build_nodes_and_connectivity


!--------------------------------------------------------------------------------------------------
!> @brief Map node order from PETSc to VTK.
!--------------------------------------------------------------------------------------------------
function PETSc_to_VTK_node_order(cell_type, order) result(mapping)

  integer, allocatable, dimension(:) :: &
    mapping                                                                                         !< node mapping
  DMPolytopeType, intent(in) :: &
    cell_type                                                                                       !< tri, quad, tet, hex
  integer,        intent(in) :: &
    order                                                                                           !< approximation space order


  if (cell_type == DM_POLYTOPE_TRIANGLE) then
    select case (order)
      case (1)
        mapping = [  1,   2,   3]
      case (2)
        mapping = [  4,   5,   6,   1,   2,   3]
      case (3)
        mapping = [  8,   9,  10,   2,   3,   4,   5,   6,   7,   1]
      case (4)
        mapping = [ 13,  14,  15,   4,   5,   6,   7,   8,   9,  10,  11,  12,   1,   2,   3]
      case (5)
        mapping = [ 19,  20,  21,   7,   8,   9,  10,  11,  12,  13,  14,  15,  16,  17,  18,  1,  &
                     3,   6,   2,   5,   4]
    end select
  else if (cell_type == DM_POLYTOPE_QUADRILATERAL) then
    select case (order)
      case (1)
        mapping = [  1,   2,   3,   4]
      case (2)
        mapping = [  6,   7,   8,   9,   2,   3,   4,   5,   1]
      case (3)
        mapping = [  13, 14,  15,  16,   5,   6,   7,   8,  10,  9,  12,   11,  1,   2,   3,   4]
      case (4)
        mapping = [ 22,  23,  24,  25,  10,  11,  12,  13,  14,  15,  18,  17,  16,  21,  20,  19, &
                     1,   2,   3,   4,   5,   6,   7,   8,   9]
      case (5)
        mapping = [ 33,  34,  35,  36,  17,  18,  19,  20,  21,  22,  23,  24,  28,  27,  26,  25, &
                    32,  31,  30,  29,   1,   2,   3,   4,   5,   6,   7,   8,   9,  10,  11,  12, &
                    13,  14,  15,  16]
    end select
  else if (cell_type == DM_POLYTOPE_TETRAHEDRON) then
    select case (order)
      case (1)
        mapping = [  2,   4,   1,   3]
      case (2)
        mapping = [  8,  10,   7,   9,   5,   4,   1,   2,   6,   3]
      case (3)
        mapping = [ 18,  20,  17,  19,  14,  13,  12,  11,   5,   6,   7,   8,  16,  15,  10,   9, &
                     4,   3,   1,   2]
      case (4)
        mapping = [ 33,  35,  32,  34,  28,  27,  26,  25,  24,  23,  14,  15,  16,  17,  18,  19, &
                    31,  30,  29,  22,  21,  20,  12,  13,  11,   8,   9,  10,   3,   4,   2,   7, &
                     5,   6,   1]
      case (5)
        mapping = [ 54,  56,  53,  55,  48,  47,  46,  45,  44,  43,  42,  41,  29,  30,  31,  32, &
                    33,  34,  35,  36,  52,  51,  50,  49,  40,  39,  38,  37,  25,  28,  23,  27, &
                    26,  24,  17,  19,  22,  18,  21,  20,   7,  10,   5,   9,   8,   6,  16,  11, &
                    13,  14,  12,  15,   3,   4,   1,   2]
    end select
  else if (cell_type == DM_POLYTOPE_HEXAHEDRON) then
    select case (order)
      case (1)
        mapping = [  1,   4,   3,   2,   5,   6,   7,   8]
      case (2)
        mapping = [ 20,  23,  22,  21,  24,  25,  26,  27,  11,  10,   9,   8,  12,  13,  14,  15, &
                    17,  16,  19,  18,   7,   6,   4,   5,   2,   3,   1]
      case (3)
        mapping = [ 57,  60,  59,  58,  61,  62,  63,  64,  40,  39,  38,  37,  35,  36,  33,  34, &
                    41,  42,  43,  44,  46,  45,  48,  47,  52,  51,  49,  50,  56,  55,  53,  54, &
                    29,  31,  30,  32,  25,  26,  27,  28,  17,  18,  19,  20,  22,  21,  24,  23, &
                     9,  11,  10,  12,  13,  14,  15,  16,   1,   2,   3,   4,   5,  6,   7,   8]
      case (4)
        mapping = [118, 121, 120, 119, 122, 123, 124, 125,  93,  92,  91,  90,  89,  88,  85,  86, &
                    87,  82,  83,  84,  94,  95,  96,  97,  98,  99, 102, 101, 100, 105, 104, 103, &
                   111, 110, 109, 106, 107, 108, 117, 116, 115, 112, 113, 114,  73,  76,  79,  74, &
                    77,  80,  75,  78,  81,  64,  65,  66,  67,  68,  69,  70,  71,  72,  46,  47, &
                    48,  49,  50,  51,  52,  53,  54,  57,  56,  55,  60,  59,  58,  63,  62,  61, &
                    28,  31,  34,  29,  32,  35,  30,  33,  36,  37,  38,  39,  40,  41,  42,  43, &
                    44,  45,   1,   2,   3,   4,   5,   6,   7,   8,   9,  10,  11,  12,  13,  14, &
                    15,  16,  17,  18,  19,  20,  21,  22,  23,  24,  25,  26,  27]
      case (5)
        mapping = [209, 212, 211, 210, 213, 214, 215, 216, 176, 175, 174, 173, 172, 171, 170, 169, &
                   165, 166, 167, 168, 161, 162, 163, 164, 177, 178, 179, 180, 181, 182, 183, 184, &
                   188, 187, 186, 185, 192, 191, 190, 189, 200, 199, 198, 197, 193, 194, 195, 196, &
                   208, 207, 206, 205, 201, 202, 203, 204, 145, 149, 153, 157, 146, 150, 154, 158, &
                   147, 151, 155, 159, 148, 152, 156, 160, 129, 130, 131, 132, 133, 134, 135, 136, &
                   137, 138, 139, 140, 141, 142, 143, 144,  97,  98,  99, 100, 101, 102, 103, 104, &
                   105, 106, 107, 108, 109, 110, 111, 112, 116, 115, 114, 113, 120, 119, 118, 117, &
                   124, 123, 122, 121, 128, 127, 126, 125,  65,  69,  73,  77,  66,  70,  74,  78, &
                    67,  71,  75,  79,  68,  72,  76,  80,  81,  82,  83,  84,  85,  86,  87,  88, &
                    89,  90,  91,  92,  93,  94,  95,  96,   1,   2,   3,   4,   5,   6,   7,   8, &
                     9,  10,  11,  12,  13,  14,  15,  16,  17,  18,  19,  20,  21,  22,  23,  24, &
                    25,  26,  27,  28,  29,  30,  31,  32,  33,  34,  35,  36,  37,  38,  39,  40, &
                    41,  42,  43,  44,  45,  46,  47,  48,  49,  50,  51,  52,  53,  54,  55,  56, &
                    57,  58,  59,  60,  61,  62,  63,  64]
    end select
  end if

end function PETSc_to_VTK_node_order


!--------------------------------------------------------------------------------------------------
!> @brief Write all information needed for the DADF5 geometry.
!--------------------------------------------------------------------------------------------------
subroutine writeGeometry(x_p,x_n,T_e)

  real(pREAL), dimension(:,:), intent(in) :: &
    x_n, &                                                                                          !< mesh nodes coordinates (including high-order approximation)
    x_p                                                                                             !< ip coordinates
  PetscInt,    dimension(:,:), intent(in), optional :: &
    T_e                                                                                             !< element connectivity (node numbers in each cell)


  call result_openJobFile()
  call result_closeGroup(result_addGroup('geometry'))

  call result_writeDataset(x_n,'geometry','x_n','initial coordinates of the nodes','m')

  call result_writeDataset(x_p,'geometry','x_p', &
                           'initial coordinates of the materialpoints (cell centers)','m')

  if (present(T_e)) &
    call result_writeDataset(int(T_e),'geometry','T_e','connectivity matrix','1')

  call result_closeJobFile()

end subroutine writeGeometry

end module discretization_mesh

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Pratheek Shanthraj, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Driver controlling inner and outer load case looping of the FEM solver
!> @details doing cutbacking, reporting statistics, writing
!> results
!--------------------------------------------------------------------------------------------------
program DAMASK_mesh
#include <petsc/finclude/petscsys.h>
  use PetscDM
  use prec
  use CLI
  use IO
  use parallelization
  use materialpoint
  use discretization_mesh
  use FEM_Utilities
  use mesh_mechanical_FEM

  implicit none(type,external)

  type :: tLoadCase
    real(pREAL)   :: t                   = 0.0_pREAL                                                !< length of increment
    integer       :: N                   = 0, &                                                     !< number of increments
                     f_out               = 1                                                        !< frequency of result writes
    logical       :: estimate_rate       = .true.                                                   !< follow trajectory of former loadcase
    type(tMechBC),  allocatable, dimension(:) :: mechBC
  end type tLoadCase


!--------------------------------------------------------------------------------------------------
! loop variables, convergence etc.
  integer, parameter :: &
    sub_step_factor = 2                                                                             !< for each substep, divide the last time increment by 2.0
  real(pREAL) :: &
    t   = 0.0_pREAL, &                                                                              !< elapsed time
    t_0 = 0.0_pREAL, &                                                                              !< begin of interval
    Delta_t = 0.0_pREAL, &                                                                          !< current time interval
    Delta_t_prev = 0.0_pREAL                                                                        !< previous time interval
  logical :: &
    guess
  integer :: &
    l, &
    cut_back_level = 0, &                                                                           !< cut back level \f$ t = \frac{t_{inc}}{2^l} \f$
    step_fraction = 0, &                                                                            !< fraction of current time interval
    inc, &                                                                                          !< current increment in current load case
    n_total_inc = 0, &                                                                              !< total # of increments
    unit_stat = 0                                                                                   !< file unit for statistics output
  type(tDict), pointer :: &
    num_solver => NULL(), &                                                                         !< dictionaries: solver
    num_mesh => NULL(), &                                                                           !<               mechanical
    load => NULL()                                                                                  !<               full load file
  character(len=pSTRLEN) :: &
    inc_info                                                                                        !< report new step (iterations, cut backs, etc)
  integer :: &
    max_cutback                                                                                     !< max number of cutbacks
  type(tLoadCase), allocatable, dimension(:) :: &
    load_cases                                                                                      !< array of all load cases
  type(tSolutionState) :: &
    sol_state                                                                                       !< solution status (converged, iters needed)
  character(len=:), allocatable :: &
    f_content, f_name                                                                               !< load file full content/filename


!--------------------------------------------------------------------------------------------------
! init DAMASK (all modules)
  call materialpoint_initAll()
  print'(/,1x,a)', '<<<+-  DAMASK_mesh init  -+>>>'; flush(IO_STDOUT)

!--------------------------------------------------------------------------------------------------
! reading field information from numerics file and do sanity checks
  num_solver => config_numerics%get_dict('solver',defaultVal=emptyDict)
  num_mesh   => num_solver%get_dict('mesh',defaultVal=emptyDict)
  max_cutback   = num_mesh%get_asInt('N_cutback_max',defaultVal=3)

  if (max_cutback < 0) call IO_error(301,ext_msg='N_cutback_max')

!--------------------------------------------------------------------------------------------------
! parse load life, do all necessary checks for correct BC, and output load case information
  if (worldrank == 0) then
    f_content = IO_read(CLI_loadFile)
    f_name = CLI_loadFile
    if (scan(f_name,'/') /= 0) f_name = f_name(scan(f_name,'/',.true.)+1:)
    call result_openJobFile(parallel=.false.)
    call result_addSetupFile(f_content,f_name,'load case definition (mesh solver)')
    call result_closeJobFile()
  end if

  call parallelization_bcast_str(f_content)
  load => YAML_str_asDict(f_content)
  load_cases = parse_and_print_load_cases(load%get_list('loadstep'))

!--------------------------------------------------------------------------------------------------
! doing initialization depending on active solvers
  call FEM_Utilities_init(num_mesh)
  call FEM_mechanical_init(load_cases(1)%mechBC,num_mesh)
  call config_numerics_deallocate()

  if (worldrank == 0) then
    open(newunit=unit_stat,file=trim(CLI_jobName)//'.sta',form='FORMATTED',status='REPLACE')
    write(unit_stat,'(a)') 'Increment Time CutbackLevel Converged IterationsNeeded'                 ! statistics file
  end if

  print'(/,1x,a)', '... saving initial configuration ..........................................'
  flush(IO_STDOUT)
  call materialpoint_result(0,0.0_pREAL)

  loadCaseLooping: do l = 1, size(load_cases)
    t_0 = t                                                                                         ! load case start time
    guess = load_cases(l)%estimate_rate                                                             ! change of load case? homogeneous guess for the first inc
    call FEM_mechanical_assembleFext(load_cases(l)%mechBC, load_cases(l)%t)                         ! assemble external loads vector
    call FEM_mechanical_assembleU(load_cases(l)%mechBC, load_cases(l)%t)                            ! assemble vector of displacements (Dirichlet) BC

    incLooping: do inc = 1, load_cases(l)%N
      n_total_inc = n_total_inc + 1

!--------------------------------------------------------------------------------------------------
! forwarding time
      Delta_t_prev = Delta_t                                                                        ! last timeinc that brought former inc to an end
      Delta_t = load_cases(l)%t/real(load_cases(l)%N,pREAL)
      Delta_t = Delta_t * real(sub_step_factor,pREAL)**real(-cut_back_level,pREAL)                  ! depending on cut back level, decrease time step
      step_fraction = 0                                                                             ! fraction scaled by stepFactor**cutLevel

      subStepLooping: do while (step_fraction < sub_step_factor**cut_back_level)
        t = t + Delta_t                                                                             ! forward target time
        step_fraction = step_fraction + 1                                                           ! count step

!--------------------------------------------------------------------------------------------------
! report begin of new step
        print'(/,1x,a)', '###########################################################################'
        print'(1x,a,es12.5,6(a,i0))',&
                'Time', t, &
                's: Increment ', inc, '/', load_cases(l)%N,&
                '-', step_fraction, '/', sub_step_factor**cut_back_level,&
                ' of load case ', l,'/', size(load_cases)
        write(inc_info,'(4(a,i0))') &
               'Increment ',n_total_inc,'/',sum(load_cases%N),&
               '-',step_fraction, '/', sub_step_factor**cut_back_level
        flush(IO_STDOUT)

        call FEM_mechanical_forward(guess,Delta_t,Delta_t_prev)

!--------------------------------------------------------------------------------------------------
! solve fields
        sol_state = FEM_mechanical_solution(inc_info,Delta_t,Delta_t_prev,load_cases(l)%mechBC)
        cutBack = .False.

        if (.not. sol_state%converged) then                                                         ! no solution found
          if (cut_back_level < max_cutback) then                                                    ! do cut back
            cutBack = .True.
            step_fraction = (step_fraction - 1) * sub_step_factor                                   ! adjust to new denominator
            cut_back_level = cut_back_level + 1
            t = t - Delta_t                                                                         ! rewind time
            Delta_t = Delta_t/2.0_pREAL
            print'(/,1x,a)', 'cutting back'
          else                                                                                      ! default behavior, exit if spectral solver does not converge
            if (worldrank == 0) close(unit_stat)
            call IO_error(950)
          end if
        else
          guess = .true.                                                                            ! start guessing after first converged (sub)inc
          Delta_t_prev = Delta_t
        end if
        if (.not. cutBack .and. worldrank == 0) then
          write(unit_stat,*) n_total_inc, t, cut_back_level, &
                            sol_state%converged, sol_state%iter_needed                              ! write statistics about accepted solution
          flush(unit_stat)
        end if
      end do subStepLooping

      cut_back_level = max(0, cut_back_level - 1)                                                   ! try half number of subincs next inc

      if (mod(inc,load_cases(l)%f_out) == 0) then                                                   ! at output frequency
        print'(/,1x,a)', '... saving results ........................................................'
        call FEM_mechanical_updateCoords()
        call materialpoint_result(n_total_inc,t)
      end if
    end do incLooping
  end do loadCaseLooping

!--------------------------------------------------------------------------------------------------
! report summary of whole calculation
  print'(/,1x,a)', '###########################################################################'
  if (worldrank == 0) close(unit_stat)

  call quit(0)                                                                                      ! no complains ;)


contains

!--------------------------------------------------------------------------------------------------
!> @brief Parse load cases data from YAML file, perform all necessary checks, and print it.
!--------------------------------------------------------------------------------------------------
function parse_and_print_load_cases(load_steps) result(load_cases)

#ifndef __GFORTRAN__
#include <petsc/finclude/petscsys.h>
  use PetscDM

  use prec
  use types
  use IO
  use discretization_mesh
  use FEM_Utilities
  use mesh_mechanical_FEM

  import, only: tLoadCase
#endif

  type(tList), target, intent(in) :: load_steps                                                     !< full YAML file dictionary
  type(tLoadCase), allocatable, dimension(:) :: load_cases                                          !< array of all load cases

  integer :: &
    boundary, component, l, m, &                                                                    ! loop variables
    BC_tag                                                                                          ! tag used for BC
  PetscInt :: &
    dimPlex                                                                                         ! mesh dimension (2D or 3D)
  real(pREAL) :: &
    BC_comp_value                                                                                   ! BC x/y/z component value from YAML load file
  logical, dimension(mesh_nBoundaries) :: &
    known_BC, &                                                                                     ! already read BC entries (repetition per load-step forbidden)
    use_label                                                                                       ! BC uses label or tag
  character(len=pSTRLEN) :: &
    BC_label                                                                                        ! mesh label or generic label
  character(len=3) :: &
    BC_unit                                                                                         ! unit for printing: one of [m, m/s, N, N/s]
  PetscErrorCode :: &
    err_PETSc
  type(tDict), pointer :: &
    load_step           => NULL(), &                                                                ! dictionaries: loadstep entry
    boundary_conditions => NULL(), &                                                                !               boundary conditions entry
    BC_mechanical       => NULL(), &                                                                !               single BC entry (mechanics solver)
    step_discretization => NULL()                                                                   !               discretization entry
  type(tList), pointer :: &
    BCs_mechanical      => NULL(), &                                                                !               mechanical entry
    BC_load_comps       => NULL()                                                                   ! u/f[_dot] components list


  call DMGetDimension(geomMesh, dimPlex, err_PETSc)
  CHKERRA(err_PETSc)

!--------------------------------------------------------------------------------------------------
! allocate loadstep-related arrays
  allocate(load_cases(size(load_steps)))
  do l = 1, size(load_steps)
    load_step => load_steps%get_dict(l)
    if (load_step%contains('boundary_condition')) then
      boundary_conditions => load_step%get_dict('boundary_condition')
    else
      boundary_conditions => load_step%get_dict('boundary_conditions')
    end if
    BCs_mechanical => boundary_conditions%get_list('mechanical')
    allocate(load_cases(l)%mechBC(mesh_nBoundaries))
    do boundary = 1, int(mesh_nBoundaries)
      allocate(load_cases(l)%mechBC(boundary)%displacements(dimPlex), source = 0.0_pREAL)
      allocate(load_cases(l)%mechBC(boundary)%forces(dimPlex), source = 0.0_pREAL)
      allocate(load_cases(l)%mechBC(boundary)%active(dimPlex), source = BC_TYPE_NONE)
    end do

!--------------------------------------------------------------------------------------------------
! check valid tags/labels
    use_label = .false.                                                                             ! reset per load step
    known_BC = .false.
    do m = 1, size(BCs_mechanical)
      BC_mechanical => BCs_mechanical%get_dict(m)
      if (BC_mechanical%contains('label') .and. BC_mechanical%contains('tag')) then
        call IO_error(812_pI16, '"label" and "tag" are given for boundary condition', m, emph=[2])
      elseif (BC_mechanical%contains('label')) then
        BC_label = BC_mechanical%get_asStr('label')
        boundary = findloc(mesh_BCLabels, BC_label, dim = 1)
        if (boundary == 0) &                                                                        ! label not defined in mesh file
          call IO_error(812_pI16, 'label', trim(BC_label), 'not defined', emph = [2])
        if (known_BC(boundary)) &                                                                   ! duplicated label/tag
          call IO_error(812_pI16, 'duplicated entries: label', trim(BC_label), 'and tag', &
                        mesh_boundariesIS(boundary), emph = [2,4])
        known_BC(boundary) = .true.
        use_label(boundary) = .true.
      else if (BC_mechanical%contains('tag')) then
        BC_tag = BC_mechanical%get_asInt('tag')
        boundary = findloc(mesh_boundariesIS, BC_tag, dim = 1)
        if (boundary == 0) &                                                                        ! tag not defined in mesh file
          call IO_error(812_pI16, 'tag', BC_tag, 'not defined', emph = [2])
        if (known_BC(boundary)) &                                                                   ! duplicated tag/label
          call IO_error(812_pI16, 'duplicated entries: tag', BC_tag, 'and label', &
                        trim(mesh_BCLabels(boundary)), emph = [2, 4])
        known_BC(boundary) = .true.
      else
        call IO_error(812_pI16, 'neither "label" nor "tag" given for boundary condition', m, emph=[2])
      end if
!--------------------------------------------------------------------------------------------------
! read BC data
      associate (BC => load_cases(l)%mechBC(boundary))
        if (BC_mechanical%contains('u_dot')) then
          BC_load_comps => BC_mechanical%get_list('u_dot')
        else if (BC_mechanical%contains('dot_u')) then
          BC_load_comps => BC_mechanical%get_list('dot_u')
        end if
        if (associated(BC_load_comps)) then
          do component = 1, int(dimPlex)
            if (BC_load_comps%get_asStr(component) /= 'x') then
              BC%displacements(component) = BC_load_comps%get_asReal(component)
              BC%active(component) = ior(BC%active(component), BC_TYPE_U_DOT)
            end if
          end do
          nullify(BC_load_comps)
        end if
        if (BC_mechanical%contains('u')) then
          BC_load_comps => BC_mechanical%get_list('u')
          do component = 1, int(dimPlex)
            if (BC_load_comps%get_asStr(component) /= 'x') then
              BC%displacements(component) = BC_load_comps%get_asReal(component)
              BC%active(component) = ior(BC%active(component), BC_TYPE_U)
            end if
          end do
          nullify(BC_load_comps)
        end if
        if (BC_mechanical%contains('f_dot')) then
          BC_load_comps => BC_mechanical%get_list('f_dot')
        else if (BC_mechanical%contains('dot_f')) then
          BC_load_comps => BC_mechanical%get_list('dot_f')
        end if
        if (associated(BC_load_comps)) then
          do component = 1, int(dimPlex)
            if (BC_load_comps%get_asStr(component) /= 'x') then
              BC%forces(component) = BC_load_comps%get_asReal(component)
              BC%active(component) = ior(BC%active(component), BC_TYPE_F_DOT)
            end if
          end do
          nullify(BC_load_comps)
        end if
        if (BC_mechanical%contains('f')) then
          BC_load_comps => BC_mechanical%get_list('f')
          do component = 1, int(dimPlex)
            if (BC_load_comps%get_asStr(component) /= 'x') then
              BC%forces(component) = BC_load_comps%get_asReal(component)
              BC%active(component) = ior(BC%active(component), BC_TYPE_F)
            end if
          end do
          nullify(BC_load_comps)
        end if
!--------------------------------------------------------------------------------------------------
! check valid BC definition
        do component = 1, int(dimPlex)
          if (popcnt(BC%active(component)) > 1) then
            if (use_label(boundary)) then
              call IO_error(812_pI16, 'more than one condition specified for component', &
                            component, IO_EOL, 'in loadcase', l, '/ label', trim(BC_label), emph = [2,5,7])
            else
              call IO_error(812_pI16, 'more than one condition specified for component', &
                            component, IO_EOL, 'in loadcase', l, '/ tag', BC_tag, emph = [2,5,7])
            end if
          end if
        end do
      end associate
    end do

!--------------------------------------------------------------------------------------------------
! store discretization, time and frequency; check values
    step_discretization => load_step%get_dict('discretization')
    load_cases(l)%t = step_discretization%get_asReal('t')
    if (load_cases(l)%t < 0.0_pREAL) &
      call IO_error(301_pI16, 'loadcase', l, 'has non-positive time step length', 't', emph = [2,4])

    load_cases(l)%N = step_discretization%get_asInt('N')
    if (load_cases(l)%N < 1) &
      call IO_error(301_pI16, 'loadcase', l, 'has non-positive number of steps', 'N', emph = [2,4])

    if (load_step%get_asStr('f_out',defaultVal='n/a') == 'none') then
      load_cases(l)%f_out = huge(0)
    else
      load_cases(l)%f_out = load_step%get_asInt('f_out', defaultVal=1)
    end if
    if (load_cases(l)%f_out < 1) &
      call IO_error(301_pI16, 'loadcase', l, 'has non-positive output frequency', 'f_out', emph = [2,4])

    load_cases(l)%estimate_rate = (load_step%get_asBool('estimate_rate',defaultVal=.true.) .and. l>1)

!--------------------------------------------------------------------------------------------------
! output of load case information
    print'(/,1x,a,1x,i0)', 'load case:', l
    if (.not. load_cases(l)%estimate_rate) print'(2x,a)', 'drop guessing along trajectory'
    print'(2x,a)', 'Field '//trim(FIELD_MECH_label)

    do boundary = 1, int(mesh_nBoundaries)
      associate (BC => load_cases(l)%mechBC(boundary))
        if (all(BC%active == BC_TYPE_NONE)) cycle
        if (use_label(boundary)) then
          BC_label = mesh_BCLabels(boundary)
        else
          m = mesh_boundariesIdx(boundary)
          if (dimPlex == 2_pPETSCINT .and. m < size(PETSC_GENERIC_LABELS)) m = m + 1                ! adjust for 2D (cells -> faces)
          BC_label = PETSC_GENERIC_LABELS(m)
        end if

        print'(3x,a,1x,a,i0,a)', &
          trim(BC_label), '(', mesh_boundariesIS(boundary), ')'
        do component = 1_pPETSCINT, dimPlex
          if (BC%active(component) == BC_TYPE_NONE) cycle
          select case (BC%active(component))
            case (BC_TYPE_U_DOT : BC_TYPE_U)
              BC_comp_value = BC%displacements(component)
              BC_unit = merge('m/s', 'm  ', BC%active(component) == BC_TYPE_U_DOT)
            case (BC_TYPE_F_DOT : BC_TYPE_F)
              BC_comp_value = BC%forces(component)
              BC_unit = merge('N/s', 'N  ', BC%active(component) == BC_TYPE_F_DOT)
            end select
          print'(5x,a,1x,i1,a,1x,en12.3e2,2x,a)', &
            'Component', component, ':', BC_comp_value, BC_unit
        end do
      end associate
    end do
    print'(2x,a,T19,en12.3e2,2x,a)', 'time:',             load_cases(l)%t, 's'
    print'(2x,a,T22,i0)',            'increments:',       load_cases(l)%N
    print'(2x,a,T22,i0)',            'output frequency:', load_cases(l)%f_out
  end do

end function parse_and_print_load_cases

end program DAMASK_mesh

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief  Wrappers to C routines for system operations
!--------------------------------------------------------------------------------------------------
module OS
  use, intrinsic :: ISO_C_binding
  use, intrinsic :: ISO_fortran_env

  use prec
  use C_interfacing
  use IO

  implicit none(type,external)
  private

  public :: &
    OS_init, &
    OS_selfTest, &
    OS_setCWD, &
    OS_getCWD, &
    OS_getHostName, &
    OS_getUserName

  interface

    function set_CWD_C(cwd) bind(C)
      use, intrinsic :: ISO_C_binding, only: C_INT, C_CHAR

      implicit none(type,external)
      integer(C_INT) :: set_CWD_C
      character(kind=C_CHAR), dimension(*), intent(in) :: cwd
    end function set_CWD_C

    subroutine get_CWD_C(cwd, stat) bind(C)
      use, intrinsic :: ISO_C_binding, only: C_INT, C_CHAR

      implicit none(type,external)
      character(kind=C_CHAR,len=:), allocatable, intent(out) :: cwd
      integer(C_INT),                            intent(out) :: stat
    end subroutine get_CWD_C

    subroutine get_hostname_C(hostname, stat) bind(C)
      use, intrinsic :: ISO_C_binding, only: C_INT, C_CHAR

      implicit none(type,external)
      character(kind=C_CHAR,len=:), allocatable, intent(out) :: hostname
      integer(C_INT),                            intent(out) :: stat
    end subroutine get_hostname_C

    subroutine get_username_C(username, stat) bind(C)
      use, intrinsic :: ISO_C_binding, only: C_INT, C_CHAR

      implicit none(type,external)
      character(kind=C_CHAR,len=:), allocatable, intent(out) :: username
      integer(C_INT),                            intent(out) :: stat
    end subroutine get_username_C

  end interface

contains


!--------------------------------------------------------------------------------------------------
!> @brief Do self test.
!--------------------------------------------------------------------------------------------------
subroutine OS_init()

  print'(/,1x,a)', '<<<+-  OS init  -+>>>'; flush(OUTPUT_UNIT)

  call OS_selfTest()

end subroutine OS_init


!--------------------------------------------------------------------------------------------------
!> @brief Set the current working directory.
!--------------------------------------------------------------------------------------------------
logical function OS_setCWD(path)

  character(len=*), intent(in) :: path


  OS_setCWD = set_CWD_C(f_c_string(path)) /= 0_C_INT

end function OS_setCWD


!--------------------------------------------------------------------------------------------------
!> @brief Get the current working directory.
!--------------------------------------------------------------------------------------------------
function OS_getCWD()

  character(kind=C_CHAR,len=:), allocatable :: OS_getCWD

  integer(C_INT) :: stat


  call get_CWD_C(OS_getCWD,stat)
  if (stat /= 0) call IO_error(640)
end function OS_getCWD


!--------------------------------------------------------------------------------------------------
!> @brief Get the host name.
!--------------------------------------------------------------------------------------------------
function OS_getHostName()

  character(kind=C_CHAR,len=:), allocatable :: OS_getHostName

  integer(C_INT) :: stat


  call get_hostname_C(OS_getHostName,stat)
  if (stat /= 0) OS_getHostName = 'n/a (Error!)'

end function OS_getHostName


!--------------------------------------------------------------------------------------------------
!> @brief Get the user name.
!--------------------------------------------------------------------------------------------------
function OS_getUserName()

  character(kind=C_CHAR,len=:), allocatable :: OS_getUserName

  integer(C_INT) :: stat


  call get_username_C(OS_getUserName,stat)
  if (stat /= 0) OS_getUserName = 'n/a (Error!)'

end function OS_getUserName


!--------------------------------------------------------------------------------------------------
!> @brief Check correctness of some OS functions.
!--------------------------------------------------------------------------------------------------
subroutine OS_selfTest()

  character(len=:), allocatable :: cwd, hostname, username
  logical :: failed


  cwd = OS_getCWD()
  if (len_trim(cwd) == 0) error stop 'OS_getCWD returned empty string'
  hostname = OS_getHostName()
  if (len_trim(hostname) == 0) error stop 'OS_getHostName returned empty string'
  username = OS_getUserName()
  if (len_trim(username) == 0) error stop 'OS_getUserName returned empty string'
  failed = OS_setCWD(cwd)
  if (failed) error stop 'OS_setCWD failed to set to current directory'

end subroutine OS_selfTest


end module OS

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @author Denny Tjahjanto, Max-Planck-Institut für Eisenforschung GmbH
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Relaxed grain cluster (RGC) homogenization scheme
!> N_constituents is defined as p x q x r (cluster)
!--------------------------------------------------------------------------------------------------
submodule(homogenization:mechanical) RGC
  use rotations
  use crystal

  type :: tParameters
    integer, dimension(:), allocatable :: &
      N_constituents
    real(pREAL) :: &
      xi_alpha, &
      c_Alpha
    real(pREAL), dimension(:), allocatable :: &
      D_alpha, &
      a_g
    character(len=pSTRLEN), allocatable, dimension(:) :: &
      output
  end type tParameters

  type :: tRGCstate
    real(pREAL), pointer,     dimension(:,:) :: &
      relaxationVector
  end type tRGCstate

  type :: tRGCdependentState
    real(pREAL), allocatable,     dimension(:) :: &
      volumeDiscrepancy, &
      relaxationRate_avg, &
      relaxationRate_max
    real(pREAL), allocatable,     dimension(:,:) :: &
      mismatch
    real(pREAL), allocatable,     dimension(:,:,:) :: &
      orientation
  end type tRGCdependentState

  type :: tNumerics_RGC
    real(pREAL) :: &
      atol, &                                                                                       !< absolute tolerance of RGC residuum
      rtol, &                                                                                       !< relative tolerance of RGC residuum
      absMax, &                                                                                     !< absolute maximum of RGC residuum
      relMax, &                                                                                     !< relative maximum of RGC residuum
      pPert, &                                                                                      !< perturbation for computing RGC penalty tangent
      xSmoo, &                                                                                      !< RGC penalty smoothing parameter (hyperbolic tangent)
      viscPower, &                                                                                  !< power (sensitivity rate) of numerical viscosity in RGC scheme, Default 1.0e0: Newton viscosity (linear model)
      viscModus, &                                                                                  !< stress modulus of RGC numerical viscosity, Default 0.0e0: No viscosity is applied
      refRelaxRate, &                                                                               !< reference relaxation rate in RGC viscosity
      maxdRelax, &                                                                                  !< threshold of maximum relaxation vector increment (if exceed this then cutback)
      maxVolDiscr, &                                                                                !< threshold of maximum volume discrepancy allowed
      volDiscrMod, &                                                                                !< stiffness of RGC volume discrepancy (zero = without volume discrepancy constraint)
      volDiscrPow                                                                                   !< powerlaw penalty for volume discrepancy
  end type tNumerics_RGC

  type(tparameters),          dimension(:), allocatable :: &
    param
  type(tRGCstate),            dimension(:), allocatable :: &
    state, &
    state0
  type(tRGCdependentState),   dimension(:), allocatable :: &
    dependentState
  type(tNumerics_RGC) :: &
    num                                                                                             ! numerics parameters. Better name?

contains

!--------------------------------------------------------------------------------------------------
!> @brief allocates all necessary fields, reads information from material configuration file
!--------------------------------------------------------------------------------------------------
module subroutine RGC_init()

  integer :: &
    ho, &
    Nmembers, &
    sizeState, nIntFaceTot

  class(tDict), pointer :: &
    num_homogenization, &
    num_mechanical, &
    num_RGC, &                                                                                      ! pointer to RGC numerics data
    material_homogenization, &
    homog, &
    homogMech

  print'(/,1x,a)', '<<<+-  homogenization:mechanical:RGC init  -+>>>'

  print'(/,1x,a)', 'D.D. Tjahjanto et al., International Journal of Material Forming 2(1):939–942, 2009'
  print'(  1x,a)', 'https://doi.org/10.1007/s12289-009-0619-1'

  print'(/,1x,a)', 'D.D. Tjahjanto et al., Modelling and Simulation in Materials Science and Engineering 18:015006, 2010'
  print'(  1x,a)', 'https://doi.org/10.1088/0965-0393/18/1/015006'

  print'(/,a,i0)', ' # homogenizations: ',count(mechanical_type == MECHANICAL_RGC_ID)


  material_homogenization => config_material%get_dict('homogenization')
  allocate(param(size(material_homogenization)))
  allocate(state(size(material_homogenization)))
  allocate(state0(size(material_homogenization)))
  allocate(dependentState(size(material_homogenization)))

  num_homogenization => config_numerics%get_dict('homogenization',defaultVal=emptyDict)
  num_mechanical => num_homogenization%get_dict('mechanical',defaultVal=emptyDict)
  num_RGC => num_mechanical%get_dict('RGC',defaultVal=emptyDict)

  num%atol         =  num_RGC%get_asReal('eps_abs_P',          defaultVal=1.0e+4_pREAL)
  num%rtol         =  num_RGC%get_asReal('eps_rel_P',          defaultVal=1.0e-3_pREAL)
  num%absMax       =  num_RGC%get_asReal('eps_abs_max',        defaultVal=1.0e+10_pREAL)
  num%relMax       =  num_RGC%get_asReal('eps_rel_max',        defaultVal=1.0e+2_pREAL)
  num%pPert        =  num_RGC%get_asReal('Delta_a',            defaultVal=1.0e-7_pREAL)
  num%xSmoo        =  num_RGC%get_asReal('relevant_mismatch',  defaultVal=1.0e-5_pREAL)
  num%viscPower    =  num_RGC%get_asReal('viscosity_exponent', defaultVal=1.0e+0_pREAL)
  num%viscModus    =  num_RGC%get_asReal('viscosity_modulus',  defaultVal=0.0e+0_pREAL)
  num%refRelaxRate =  num_RGC%get_asReal('dot_a_ref',          defaultVal=1.0e-3_pREAL)
  num%maxdRelax    =  num_RGC%get_asReal('dot_a_max',          defaultVal=1.0e+0_pREAL)
  num%maxVolDiscr  =  num_RGC%get_asReal('Delta_V_max',        defaultVal=1.0e-5_pREAL)
  num%volDiscrMod  =  num_RGC%get_asReal('Delta_V_modulus',    defaultVal=1.0e+12_pREAL)
  num%volDiscrPow  =  num_RGC%get_asReal('Delta_V_exponent',   defaultVal=5.0_pREAL)

  if (num%atol <= 0.0_pREAL)         call IO_error(301,ext_msg='eps_abs_P')
  if (num%rtol <= 0.0_pREAL)         call IO_error(301,ext_msg='eps_rel_P')
  if (num%absMax <= 0.0_pREAL)       call IO_error(301,ext_msg='eps_abs_max')
  if (num%relMax <= 0.0_pREAL)       call IO_error(301,ext_msg='eps_rel_max')
  if (num%pPert <= 0.0_pREAL)        call IO_error(301,ext_msg='Delta_a')
  if (num%xSmoo <= 0.0_pREAL)        call IO_error(301,ext_msg='relevant_mismatch')
  if (num%viscPower < 0.0_pREAL)     call IO_error(301,ext_msg='viscosity_exponent')
  if (num%viscModus < 0.0_pREAL)     call IO_error(301,ext_msg='viscosity_modulus')
  if (num%refRelaxRate <= 0.0_pREAL) call IO_error(301,ext_msg='dot_a_ref')
  if (num%maxdRelax <= 0.0_pREAL)    call IO_error(301,ext_msg='dot_a_max')
  if (num%maxVolDiscr <= 0.0_pREAL)  call IO_error(301,ext_msg='Delta_V_max')
  if (num%volDiscrMod < 0.0_pREAL)   call IO_error(301,ext_msg='Delta_V_modulus')
  if (num%volDiscrPow <= 0.0_pREAL)  call IO_error(301,ext_msg='Delta_V_exponent')


  do ho = 1, size(material_name_homogenization)

    if (mechanical_type(ho) /= MECHANICAL_RGC_ID) cycle

    print'(/,1x,a,1x,i0,a)', 'homogenization',ho,': '//material_name_homogenization(ho)

    homog => material_homogenization%get_dict(ho)
    homogMech => homog%get_dict('mechanical')
    associate(prm => param(ho), &
              stt => state(ho), &
              st0 => state0(ho), &
              dst => dependentState(ho))

#if defined (__GFORTRAN__)
    prm%output = output_as1dStr(homogMech)
#else
    prm%output = homogMech%get_as1dStr('output',defaultVal=emptyStrArray)
#endif

    prm%N_constituents = homogMech%get_as1dInt('cluster_size',requiredSize=3)
    if (homogenization_Nconstituents(ho) /= product(prm%N_constituents)) &
      call IO_error(211,ext_msg='N_constituents (RGC)')

    prm%xi_alpha = homogMech%get_asReal('xi_alpha')
    prm%c_alpha  = homogMech%get_asReal('c_alpha')

    prm%D_alpha  = homogMech%get_as1dReal('D_alpha', requiredSize=3)
    prm%a_g      = homogMech%get_as1dReal('a_g',     requiredSize=3)

    Nmembers = count(material_ID_homogenization == ho)
    nIntFaceTot = 3*(  (prm%N_constituents(1)-1)*prm%N_constituents(2)*prm%N_constituents(3) &
                      + prm%N_constituents(1)*(prm%N_constituents(2)-1)*prm%N_constituents(3) &
                      + prm%N_constituents(1)*prm%N_constituents(2)*(prm%N_constituents(3)-1))
    sizeState = nIntFaceTot

    homogState(ho)%sizeState = sizeState
    allocate(homogState(ho)%state0   (sizeState,Nmembers), source=0.0_pREAL)
    allocate(homogState(ho)%state    (sizeState,Nmembers), source=0.0_pREAL)

    stt%relaxationVector => homogState(ho)%state(1:nIntFaceTot,:)
    st0%relaxationVector => homogState(ho)%state0(1:nIntFaceTot,:)

    allocate(dst%volumeDiscrepancy(   Nmembers), source=0.0_pREAL)
    allocate(dst%relaxationRate_avg(  Nmembers), source=0.0_pREAL)
    allocate(dst%relaxationRate_max(  Nmembers), source=0.0_pREAL)
    allocate(dst%mismatch(          3,Nmembers), source=0.0_pREAL)

!--------------------------------------------------------------------------------------------------
! assigning cluster orientations
    dependentState(ho)%orientation = spread(eu2om(prm%a_g*inRad),3,Nmembers)
    !dst%orientation = spread(eu2om(prm%a_g*inRad),3,Nmembers) ifort version 18.0.1 crashes (for whatever reason)

    end associate

  end do

end subroutine RGC_init


!--------------------------------------------------------------------------------------------------
!> @brief partitions the deformation gradient onto the constituents
!--------------------------------------------------------------------------------------------------
module subroutine RGC_partitionDeformation(F,avgF,ce)

  real(pREAL),   dimension (:,:,:), intent(out) :: F                                                !< partitioned F  per grain

  real(pREAL),   dimension (3,3),   intent(in)  :: avgF                                             !< averaged F
  integer,                          intent(in)  :: &
    ce

  real(pREAL), dimension(3) :: aVect,nVect
  integer,     dimension(4) :: intFace
  integer,     dimension(3) :: iGrain3
  integer ::  iGrain,iFace,i,j,ho,en

  associate(prm => param(material_ID_homogenization(ce)))

  ho = material_ID_homogenization(ce)
  en = material_entry_homogenization(ce)
!--------------------------------------------------------------------------------------------------
! compute the deformation gradient of individual grains due to relaxations
  F = 0.0_pREAL
  do iGrain = 1,product(prm%N_constituents)
    iGrain3 = grain1to3(iGrain,prm%N_constituents)
    do iFace = 1,6
      intFace = getInterface(iFace,iGrain3)                                                         ! identifying 6 interfaces of each grain
      aVect = relaxationVector(intFace,ho,en)                                                       ! get the relaxation vectors for each interface from global relaxation vector array
      nVect = interfaceNormal(intFace,ho,en)
      forall (i=1:3,j=1:3) &
        F(i,j,iGrain) = F(i,j,iGrain) + aVect(i)*nVect(j)                                           ! calculating deformation relaxations due to interface relaxation
    end do
    F(1:3,1:3,iGrain) = F(1:3,1:3,iGrain) + avgF                                                    ! resulting relaxed deformation gradient
  end do

  end associate

end subroutine RGC_partitionDeformation


!--------------------------------------------------------------------------------------------------
!> @brief update the internal state of the homogenization scheme and tell whether "done" and
! "happy" with result
!--------------------------------------------------------------------------------------------------
module function RGC_updateState(P,F,avgF,dt,dPdF,ce) result(doneAndHappy)
      logical, dimension(2) :: doneAndHappy
      real(pREAL), dimension(:,:,:),     intent(in)    :: &
        P,&                                                                                         !< partitioned stresses
        F                                                                                           !< partitioned deformation gradients
      real(pREAL), dimension(:,:,:,:,:), intent(in) :: dPdF                                         !< partitioned stiffnesses
      real(pREAL), dimension(3,3),       intent(in) :: avgF                                         !< average F
      real(pREAL),                       intent(in) :: dt                                           !< time increment
      integer,                           intent(in) :: &
        ce                                                                                          !< cell

  integer, dimension(4) :: intFaceN,intFaceP,faceID
  integer, dimension(3) :: nGDim,iGr3N,iGr3P
  integer :: ho,iNum,i,j,nIntFaceTot,iGrN,iGrP,iMun,iFace,k,l,ipert,nGrain, en
  real(pREAL), dimension(3,3,size(P,3)) :: R,pF,pR,D,pD
  real(pREAL), dimension(3,size(P,3))   :: NN,devNull
  real(pREAL), dimension(3)             :: normP,normN,mornP,mornN
  real(pREAL) :: residMax,stresMax
  logical :: error
  real(pREAL), dimension(:,:), allocatable :: tract,jmatrix,jnverse,smatrix,pmatrix,rmatrix
  real(pREAL), dimension(:), allocatable   :: resid,relax,p_relax,p_resid,drelax

  zeroTimeStep: if (dEq0(dt)) then
    doneAndHappy = .true.                                                                   ! pretend everything is fine and return
    return
  end if zeroTimeStep

  ho  = material_ID_homogenization(ce)
  en = material_entry_homogenization(ce)

  associate(stt => state(ho), st0 => state0(ho), dst => dependentState(ho), prm => param(ho))

!--------------------------------------------------------------------------------------------------
! get the dimension of the cluster (grains and interfaces)
  nGDim  = prm%N_constituents
  nGrain = product(nGDim)
  nIntFaceTot = (nGDim(1)-1)*nGDim(2)*nGDim(3) &
              + nGDim(1)*(nGDim(2)-1)*nGDim(3) &
              + nGDim(1)*nGDim(2)*(nGDim(3)-1)

!--------------------------------------------------------------------------------------------------
! allocate the size of the global relaxation arrays/jacobian matrices depending on the size of the cluster
  allocate(resid(3*nIntFaceTot), source=0.0_pREAL)
  allocate(tract(nIntFaceTot,3), source=0.0_pREAL)
  relax  = stt%relaxationVector(:,en)
  drelax = stt%relaxationVector(:,en) - st0%relaxationVector(:,en)

!--------------------------------------------------------------------------------------------------
! computing interface mismatch and stress penalty tensor for all interfaces of all grains
  call stressPenalty(R,NN,avgF,F,ho,en)

!--------------------------------------------------------------------------------------------------
! calculating volume discrepancy and stress penalty related to overall volume discrepancy
  call volumePenalty(D,dst%volumeDiscrepancy(en),avgF,F,nGrain)

!------------------------------------------------------------------------------------------------
! computing the residual stress from the balance of traction at all (interior) interfaces
  do iNum = 1,nIntFaceTot
    faceID = interface1to4(iNum,param(ho)%N_constituents)                                           ! identifying the interface ID in local coordinate system (4-dimensional index)

!--------------------------------------------------------------------------------------------------
! identify the left/bottom/back grain (-|N)
    iGr3N = faceID(2:4)                                                                             ! identifying the grain ID in local coordinate system (3-dimensional index)
    iGrN = grain3to1(iGr3N,param(ho)%N_constituents)                                                ! translate the local grain ID into global coordinate system (1-dimensional index)
    intFaceN = getInterface(2*faceID(1),iGr3N)
    normN = interfaceNormal(intFaceN,ho,en)

!--------------------------------------------------------------------------------------------------
! identify the right/up/front grain (+|P)
    iGr3P = iGr3N
    iGr3P(faceID(1)) = iGr3N(faceID(1))+1                                                           ! identifying the grain ID in local coordinate system (3-dimensional index)
    iGrP = grain3to1(iGr3P,param(ho)%N_constituents)                                                ! translate the local grain ID into global coordinate system (1-dimensional index)
    intFaceP = getInterface(2*faceID(1)-1,iGr3P)
    normP = interfaceNormal(intFaceP,ho,en)

!--------------------------------------------------------------------------------------------------
! compute the residual of traction at the interface (in local system, 4-dimensional index)
    do i = 1,3
      tract(iNum,i) = sign(num%viscModus*(abs(drelax(i+3*(iNum-1)))/(num%refRelaxRate*dt))**num%viscPower, &
                           drelax(i+3*(iNum-1)))                                                    ! contribution from the relaxation viscosity
      do j = 1,3
        tract(iNum,i) = tract(iNum,i) + (P(i,j,iGrP) + R(i,j,iGrP) + D(i,j,iGrP))*normP(j) &        ! contribution from material stress P, mismatch penalty R, and volume penalty D projected into the interface
                                      + (P(i,j,iGrN) + R(i,j,iGrN) + D(i,j,iGrN))*normN(j)
        resid(i+3*(iNum-1)) = tract(iNum,i)                                                         ! translate the local residual into global 1-dimensional residual array
      end do
    end do

  end do

!--------------------------------------------------------------------------------------------------
! convergence check for stress residual
  stresMax = maxval(abs(P))                                                                         ! get the maximum of first Piola-Kirchhoff (material) stress
  residMax = maxval(abs(tract))                                                                     ! get the maximum of the residual

  doneAndHappy = .false.

!--------------------------------------------------------------------------------------------------
!  If convergence reached => done and happy
  if (residMax < num%rtol*stresMax .or. residMax < num%atol) then
    doneAndHappy = .true.

    dst%mismatch(1:3,en)       = sum(NN,2)/real(nGrain,pREAL)
    dst%relaxationRate_avg(en) = sum(abs(drelax))/dt/real(3*nIntFaceTot,pREAL)
    dst%relaxationRate_max(en) = maxval(abs(drelax))/dt

    return

!--------------------------------------------------------------------------------------------------
! if residual blows-up => done but unhappy
  elseif (residMax > num%relMax*stresMax .or. residMax > num%absMax) then                           ! try to restart when residual blows up exceeding maximum bound
    doneAndHappy = [.true.,.false.]                                                         ! with direct cut-back
   return
  end if

!---------------------------------------------------------------------------------------------------
! construct the global Jacobian matrix for updating the global relaxation vector array when
! convergence is not yet reached ...

!--------------------------------------------------------------------------------------------------
! ... of the constitutive stress tangent, assembled from dPdF or material constitutive model "smatrix"
  allocate(smatrix(3*nIntFaceTot,3*nIntFaceTot), source=0.0_pREAL)
  do iNum = 1,nIntFaceTot
    faceID = interface1to4(iNum,param(ho)%N_constituents)                                           ! assembling of local dPdF into global Jacobian matrix

!--------------------------------------------------------------------------------------------------
! identify the left/bottom/back grain (-|N)
    iGr3N = faceID(2:4)                                                                             ! identifying the grain ID in local coordinate sytem
    iGrN = grain3to1(iGr3N,param(ho)%N_constituents)                                                ! translate into global grain ID
    intFaceN = getInterface(2*faceID(1),iGr3N)                                                      ! identifying the connecting interface in local coordinate system
    normN = interfaceNormal(intFaceN,ho,en)
    do iFace = 1,6
      intFaceN = getInterface(iFace,iGr3N)                                                          ! identifying all interfaces that influence relaxation of the above interface
      mornN = interfaceNormal(intFaceN,ho,en)
      iMun = interface4to1(intFaceN,param(ho)%N_constituents)                                       ! translate the interfaces ID into local 4-dimensional index
      if (iMun > 0) then                                                                            ! get the corresponding tangent
        do i=1,3; do j=1,3; do k=1,3; do l=1,3
          smatrix(3*(iNum-1)+i,3*(iMun-1)+j) = smatrix(3*(iNum-1)+i,3*(iMun-1)+j) &
                                             + dPdF(i,k,j,l,iGrN)*normN(k)*mornN(l)
        end do;end do;end do;end do
! projecting the material tangent dPdF into the interface
! to obtain the Jacobian matrix contribution of dPdF
      end if
    end do

!--------------------------------------------------------------------------------------------------
! identify the right/up/front grain (+|P)
    iGr3P = iGr3N
    iGr3P(faceID(1)) = iGr3N(faceID(1))+1                                                           ! identifying the grain ID in local coordinate sytem
    iGrP = grain3to1(iGr3P,param(ho)%N_constituents)                                                ! translate into global grain ID
    intFaceP = getInterface(2*faceID(1)-1,iGr3P)                                                    ! identifying the connecting interface in local coordinate system
    normP = interfaceNormal(intFaceP,ho,en)
    do iFace = 1,6
      intFaceP = getInterface(iFace,iGr3P)                                                          ! identifying all interfaces that influence relaxation of the above interface
      mornP = interfaceNormal(intFaceP,ho,en)
      iMun = interface4to1(intFaceP,param(ho)%N_constituents)                                       ! translate the interfaces ID into local 4-dimensional index
      if (iMun > 0) then                                                                            ! get the corresponding tangent
        do i=1,3; do j=1,3; do k=1,3; do l=1,3
          smatrix(3*(iNum-1)+i,3*(iMun-1)+j) = smatrix(3*(iNum-1)+i,3*(iMun-1)+j) &
                                             + dPdF(i,k,j,l,iGrP)*normP(k)*mornP(l)
        end do;end do;end do;end do
      end if
    end do
  end do

!--------------------------------------------------------------------------------------------------
! ... of the stress penalty tangent (mismatch penalty and volume penalty, computed using numerical
! perturbation method) "pmatrix"
  allocate(pmatrix(3*nIntFaceTot,3*nIntFaceTot), source=0.0_pREAL)
  allocate(p_relax(3*nIntFaceTot),               source=0.0_pREAL)
  allocate(p_resid(3*nIntFaceTot),               source=0.0_pREAL)

  do ipert = 1,3*nIntFaceTot
    p_relax = relax
    p_relax(ipert) = relax(ipert) + num%pPert                                                       ! perturb the relaxation vector
    stt%relaxationVector(:,en) = p_relax
    call grainDeformation(pF,avgF,ho,en)                                                            ! rain deformation from perturbed state
    call stressPenalty(pR,DevNull,      avgF,pF,ho,en)                                              ! stress penalty due to interface mismatch from perturbed state
    call volumePenalty(pD,devNull(1,1), avgF,pF,nGrain)                                             ! stress penalty due to volume discrepancy from perturbed state

!--------------------------------------------------------------------------------------------------
! computing the global stress residual array from the perturbed state
    p_resid = 0.0_pREAL
    do iNum = 1,nIntFaceTot
      faceID = interface1to4(iNum,param(ho)%N_constituents)                                         ! identifying the interface ID in local coordinate system (4-dimensional index)

!--------------------------------------------------------------------------------------------------
! identify the left/bottom/back grain (-|N)
      iGr3N = faceID(2:4)                                                                           ! identify the grain ID in local coordinate system (3-dimensional index)
      iGrN = grain3to1(iGr3N,param(ho)%N_constituents)                                              ! translate the local grain ID into global coordinate system (1-dimensional index)
      intFaceN = getInterface(2*faceID(1),iGr3N)                                                    ! identify the interface ID of the grain
      normN = interfaceNormal(intFaceN,ho,en)

!--------------------------------------------------------------------------------------------------
! identify the right/up/front grain (+|P)
      iGr3P = iGr3N
      iGr3P(faceID(1)) = iGr3N(faceID(1))+1                                                         ! identify the grain ID in local coordinate system (3-dimensional index)
      iGrP = grain3to1(iGr3P,param(ho)%N_constituents)                                              ! translate the local grain ID into global coordinate system (1-dimensional index)
      intFaceP = getInterface(2*faceID(1)-1,iGr3P)                                                  ! identify the interface ID of the grain
      normP = interfaceNormal(intFaceP,ho,en)

!--------------------------------------------------------------------------------------------------
! compute the residual stress (contribution of mismatch and volume penalties) from perturbed state
! at all interfaces
      do i = 1,3; do j = 1,3
        p_resid(i+3*(iNum-1)) = p_resid(i+3*(iNum-1)) + (pR(i,j,iGrP) - R(i,j,iGrP))*normP(j) &
                                                      + (pR(i,j,iGrN) - R(i,j,iGrN))*normN(j) &
                                                      + (pD(i,j,iGrP) - D(i,j,iGrP))*normP(j) &
                                                      + (pD(i,j,iGrN) - D(i,j,iGrN))*normN(j)
      end do; end do
    end do
    pmatrix(:,ipert) = p_resid/num%pPert
  end do


!--------------------------------------------------------------------------------------------------
! ... of the numerical viscosity traction "rmatrix"
  allocate(rmatrix(3*nIntFaceTot,3*nIntFaceTot),source=0.0_pREAL)
  do i=1,3*nIntFaceTot
    rmatrix(i,i) = num%viscModus*num%viscPower/(num%refRelaxRate*dt)* &                             ! tangent due to numerical viscosity traction appears
                   (abs(drelax(i))/(num%refRelaxRate*dt))**(num%viscPower - 1.0_pREAL)              ! only in the main diagonal term
  end do


!--------------------------------------------------------------------------------------------------
! The overall Jacobian matrix summarizing contributions of smatrix, pmatrix, rmatrix
  allocate(jmatrix(3*nIntFaceTot,3*nIntFaceTot)); jmatrix = smatrix + pmatrix + rmatrix

!--------------------------------------------------------------------------------------------------
! computing the update of the state variable (relaxation vectors) using the Jacobian matrix
  allocate(jnverse(3*nIntFaceTot,3*nIntFaceTot),source=0.0_pREAL)
  call math_invert(jnverse,error,jmatrix)

!--------------------------------------------------------------------------------------------------
! calculate the state update (global relaxation vectors) for the next Newton-Raphson iteration
  drelax = 0.0_pREAL
  do i = 1,3*nIntFaceTot;do j = 1,3*nIntFaceTot
    drelax(i) = drelax(i) - jnverse(i,j)*resid(j)                                                   ! Calculate the correction for the state variable
  end do; end do
  stt%relaxationVector(:,en) = relax + drelax                                                       ! Updateing the state variable for the next iteration
  if (any(abs(drelax) > num%maxdRelax)) then                                                        ! Forcing cutback when the incremental change of relaxation vector becomes too large
    doneAndHappy = [.true.,.false.]
    !$OMP CRITICAL (write2out)
    print'(a,i3,a,i3,a)',' RGC_updateState: enforces cutback'
    print'(a,e15.8)',' due to large relaxation change = ',maxval(abs(drelax))
    flush(IO_STDOUT)
    !$OMP END CRITICAL (write2out)
  end if

  end associate

  contains
  !------------------------------------------------------------------------------------------------
  !> @brief calculate stress-like penalty due to deformation mismatch
  !------------------------------------------------------------------------------------------------
  subroutine stressPenalty(rPen,nMis,avgF,fDef,ho,en)

    real(pREAL),   dimension (:,:,:), intent(out) :: rPen                                           !< stress-like penalty
    real(pREAL),   dimension (:,:),   intent(out) :: nMis                                           !< total amount of mismatch

    real(pREAL),   dimension (:,:,:), intent(in)  :: fDef                                           !< deformation gradients
    real(pREAL),   dimension (3,3),   intent(in)  :: avgF                                           !< initial effective stretch tensor
    integer,                          intent(in)  :: ho, en

    integer, dimension (4)   :: intFace
    integer, dimension (3)   :: iGrain3,iGNghb3,nGDim
    real(pREAL),   dimension (3,3) :: gDef,nDef
    real(pREAL),   dimension (3)   :: nVect,surfCorr
    integer :: iGrain,iGNghb,iFace,i,j,k,l
    real(pREAL) :: muGrain,muGNghb,nDefNorm
    real(pREAL), parameter  :: &
      nDefToler = 1.0e-10_pREAL, &
      b = 2.5e-10_pREAL                                                                             ! Length of Burgers vector

    nGDim = param(ho)%N_constituents
    rPen = 0.0_pREAL
    nMis = 0.0_pREAL

    !----------------------------------------------------------------------------------------------
    ! get the correction factor the modulus of penalty stress representing the evolution of area of
    ! the interfaces due to deformations

    surfCorr = surfaceCorrection(avgF,ho,en)

    associate(prm => param(ho))

   !-----------------------------------------------------------------------------------------------
   ! computing the mismatch and penalty stress tensor of all grains
   grainLoop: do iGrain = 1,product(prm%N_constituents)
     muGrain = equivalentMu(iGrain,ce)
     iGrain3 = grain1to3(iGrain,prm%N_constituents)                                                 ! get the grain ID in local 3-dimensional index (x,y,z)-position

     interfaceLoop: do iFace = 1,6
       intFace = getInterface(iFace,iGrain3)                                                        ! get the 4-dimensional index of the interface in local numbering system of the grain
       nVect = interfaceNormal(intFace,ho,en)
       iGNghb3 = iGrain3                                                                            ! identify the neighboring grain across the interface
       iGNghb3(abs(intFace(1))) = iGNghb3(abs(intFace(1))) &
                                + int(real(intFace(1),pREAL)/real(abs(intFace(1)),pREAL))
       where(iGNghb3 < 1)    iGNghb3 = nGDim
       where(iGNghb3 >nGDim) iGNghb3 = 1
       iGNghb  = grain3to1(iGNghb3,prm%N_constituents)                                              ! get the ID of the neighboring grain
       muGNghb = equivalentMu(iGNghb,ce)
       gDef = 0.5_pREAL*(fDef(1:3,1:3,iGNghb) - fDef(1:3,1:3,iGrain))                               ! difference/jump in deformation gradeint across the neighbor

       !-------------------------------------------------------------------------------------------
       ! compute the mismatch tensor of all interfaces
       nDefNorm = 0.0_pREAL
       nDef = 0.0_pREAL
       do i = 1,3; do j = 1,3
         do k = 1,3; do l = 1,3
           nDef(i,j) = nDef(i,j) - nVect(k)*gDef(i,l)*math_LeviCivita(j,k,l)                        ! compute the interface mismatch tensor from the jump of deformation gradient
         end do; end do
         nDefNorm = nDefNorm + nDef(i,j)**2                                                         ! compute the norm of the mismatch tensor
       end do; end do
       nDefNorm = max(nDefToler,sqrt(nDefNorm))                                                     ! approximation to zero mismatch if mismatch is zero (singularity)
       nMis(abs(intFace(1)),iGrain) = nMis(abs(intFace(1)),iGrain) + nDefNorm                       ! total amount of mismatch experienced by the grain (at all six interfaces)


       !-------------------------------------------------------------------------------------------
       ! compute the stress penalty of all interfaces
       do i = 1,3; do j = 1,3; do k = 1,3; do l = 1,3
         rPen(i,j,iGrain) = rPen(i,j,iGrain) + 0.5_pREAL*(muGrain*b + muGNghb*b)*prm%xi_alpha &
                                                *surfCorr(abs(intFace(1)))/prm%D_alpha(abs(intFace(1))) &
                                                *cosh(prm%c_alpha*nDefNorm) &
                                                *0.5_pREAL*nVect(l)*nDef(i,k)/nDefNorm*math_LeviCivita(k,l,j) &
                                                *tanh(nDefNorm/num%xSmoo)
       end do; end do;end do; end do
     end do interfaceLoop


   end do grainLoop

   end associate

  end subroutine stressPenalty


  !------------------------------------------------------------------------------------------------
  !> @brief calculate stress-like penalty due to volume discrepancy
  !------------------------------------------------------------------------------------------------
  subroutine volumePenalty(vPen,vDiscrep,fAvg,fDef,nGrain)

    real(pREAL), dimension (:,:,:), intent(out) :: vPen                                             ! stress-like penalty due to volume
    real(pREAL),                    intent(out) :: vDiscrep                                         ! total volume discrepancy

    real(pREAL), dimension (:,:,:), intent(in)  :: fDef                                             ! deformation gradients
    real(pREAL), dimension (3,3),   intent(in)  :: fAvg                                             ! overall deformation gradient
    integer,                        intent(in) :: &
      Ngrain

    real(pREAL), dimension(size(vPen,3)) :: gVol
    integer :: i

    !----------------------------------------------------------------------------------------------
    ! compute the volumes of grains and of cluster
    vDiscrep = math_det33(fAvg)                                                                     ! compute the volume of the cluster
    do i = 1,nGrain
      gVol(i) = math_det33(fDef(1:3,1:3,i))                                                         ! compute the volume of individual grains
      vDiscrep     = vDiscrep - gVol(i)/real(nGrain,pREAL)                                          ! calculate the difference/dicrepancy between
                                                                                                    ! the volume of the cluster and the the total volume of grains
    end do

    !----------------------------------------------------------------------------------------------
    ! calculate the stress and penalty due to volume discrepancy
    vPen      = 0.0_pREAL
    do i = 1,nGrain
      vPen(:,:,i) = -real(nGrain,pREAL)**(-1)*num%volDiscrMod*num%volDiscrPow/num%maxVolDiscr &
                  * sign((abs(vDiscrep)/num%maxVolDiscr)**(num%volDiscrPow - 1.0_pREAL),vDiscrep) &
                  * gVol(i)*transpose(math_inv33(fDef(:,:,i)))
    end do

  end subroutine volumePenalty


  !--------------------------------------------------------------------------------------------------
  !> @brief compute the correction factor accouted for surface evolution (area change) due to
  ! deformation
  !--------------------------------------------------------------------------------------------------
  function surfaceCorrection(avgF,ho,en)

    real(pREAL), dimension(3)               :: surfaceCorrection

    real(pREAL), dimension(3,3), intent(in) :: avgF                                                 !< average F
    integer,                     intent(in) :: &
      ho, &
      en
    real(pREAL), dimension(3,3)             :: invC
    real(pREAL), dimension(3)               :: nVect
    real(pREAL)  :: detF
    integer :: i,j,iBase
    logical     ::  error

    call math_invert33(invC,detF,error,matmul(transpose(avgF),avgF))

    surfaceCorrection = 0.0_pREAL
    do iBase = 1,3
      nVect = interfaceNormal([iBase,1,1,1],ho,en)
      do i = 1,3; do j = 1,3
        surfaceCorrection(iBase) = surfaceCorrection(iBase) + invC(i,j)*nVect(i)*nVect(j)           ! compute the component of (the inverse of) the stretch in the direction of the normal
      end do; end do
      surfaceCorrection(iBase) = sqrt(surfaceCorrection(iBase))*detF                                ! get the surface correction factor (area contraction/enlargement)
    end do

  end function surfaceCorrection


  !-------------------------------------------------------------------------------------------------
  !> @brief compute the equivalent shear and bulk moduli from the elasticity tensor
  !-------------------------------------------------------------------------------------------------
  real(pREAL) function equivalentMu(co,ce)

    integer, intent(in)    :: &
      co,&
      ce

    real(pREAL), dimension(6,6) :: C

    C = phase_homogenizedC66(material_ID_phase(co,ce),material_entry_phase(co,ce))                  ! damage not included!

    equivalentMu = crystal_isotropic_mu(C,'isostrain')

  end function equivalentMu


  !-------------------------------------------------------------------------------------------------
  !> @brief calculating the grain deformation gradient (the same with
  ! homogenization_RGC_partitionDeformation, but used only for perturbation scheme)
  !-------------------------------------------------------------------------------------------------
  subroutine grainDeformation(F, avgF, ho, en)

    real(pREAL),   dimension(:,:,:), intent(out) :: F                                               !< partitioned F  per grain

    real(pREAL),   dimension(:,:),   intent(in)  :: avgF                                            !< averaged F
    integer,                         intent(in)  :: &
      ho, &
      en

    real(pREAL),   dimension(3) :: aVect,nVect
    integer,       dimension(4) :: intFace
    integer,       dimension(3) :: iGrain3
    integer :: iGrain,iFace,i,j

    !-----------------------------------------------------------------------------------------------
    ! compute the deformation gradient of individual grains due to relaxations

    associate (prm => param(ho))

    F = 0.0_pREAL
    do iGrain = 1,product(prm%N_constituents)
      iGrain3 = grain1to3(iGrain,prm%N_constituents)
      do iFace = 1,6
        intFace = getInterface(iFace,iGrain3)
        aVect   = relaxationVector(intFace,ho,en)
        nVect   = interfaceNormal(intFace,ho,en)
        forall (i=1:3,j=1:3) &
          F(i,j,iGrain) = F(i,j,iGrain) + aVect(i)*nVect(j)                                         ! effective relaxations
      end do
      F(1:3,1:3,iGrain) = F(1:3,1:3,iGrain) + avgF                                                  ! relaxed deformation gradient
    end do

    end associate

  end subroutine grainDeformation

end function RGC_updateState


!--------------------------------------------------------------------------------------------------
!> @brief writes results to HDF5 output file
!--------------------------------------------------------------------------------------------------
module subroutine RGC_result(ho,group)

  integer,          intent(in) :: ho
  character(len=*), intent(in) :: group

  integer :: o

  associate(stt => state(ho), dst => dependentState(ho), prm => param(ho))
    outputsLoop: do o = 1,size(prm%output)
      select case(trim(prm%output(o)))
        case('M')
          call result_writeDataset(dst%mismatch,group,trim(prm%output(o)), &
                                   'average mismatch tensor','1')
        case('Delta_V')
          call result_writeDataset(dst%volumeDiscrepancy,group,trim(prm%output(o)), &
                                 'volume discrepancy','m³')
        case('max_dot_a')
          call result_writeDataset(dst%relaxationrate_max,group,trim(prm%output(o)), &
                                 'maximum relaxation rate','m/s')
        case('avg_dot_a')
          call result_writeDataset(dst%relaxationrate_avg,group,trim(prm%output(o)), &
                                   'average relaxation rate','m/s')
      end select
    end do outputsLoop
  end associate

end subroutine RGC_result


!--------------------------------------------------------------------------------------------------
!> @brief collect relaxation vectors of an interface
!--------------------------------------------------------------------------------------------------
pure function relaxationVector(intFace,ho,en)

  real(pREAL), dimension (3)            :: relaxationVector

  integer,                   intent(in) :: ho,en
  integer,     dimension(4), intent(in) :: intFace                                                  !< set of interface ID in 4D array (normal and position)

  integer :: iNum

!--------------------------------------------------------------------------------------------------
! collect the interface relaxation vector from the global state array

  associate (prm => param(ho), &
             stt => state(ho))

  iNum = interface4to1(intFace,prm%N_constituents)                                                  ! identify the position of the interface in global state array
  if (iNum > 0) then
    relaxationVector = stt%relaxationVector((3*iNum-2):(3*iNum),en)
  else
    relaxationVector = 0.0_pREAL
  end if

  end associate

end function relaxationVector


!--------------------------------------------------------------------------------------------------
!> @brief identify the normal of an interface
!--------------------------------------------------------------------------------------------------
pure function interfaceNormal(intFace,ho,en) result(n)

  real(pREAL), dimension(3)             :: n
  integer,     dimension(4), intent(in) :: intFace                                                  !< interface ID in 4D array (normal and position)
  integer,                   intent(in) :: &
    ho, &
    en


  associate (dst => dependentState(ho))

    n = 0.0_pREAL
    n(abs(intFace(1))) = real(intFace(1)/abs(intFace(1)),pREAL)                                     ! get the normal vector w.r.t. cluster axis

    n = matmul(dst%orientation(1:3,1:3,en),n)                                                       ! map the normal vector into sample coordinate system (basis)

  end associate

end function interfaceNormal


!--------------------------------------------------------------------------------------------------
!> @brief collect six faces of a grain in 4D (normal and position)
!--------------------------------------------------------------------------------------------------
pure function getInterface(iFace,iGrain3) result(i)

  integer, dimension(4)             :: i
  integer, dimension(3), intent(in) :: iGrain3                                                      !< grain ID in 3D array
  integer,               intent(in) :: iFace                                                        !< face index (1..6) mapped like (-e1,-e2,-e3,+e1,+e2,+e3) or iDir = (-1,-2,-3,1,2,3)

  integer :: iDir                                                                                   !< direction of interface normal


  iDir = (int(real(iFace-1,pREAL)/2.0_pREAL)+1)*(-1)**iFace
  i = [iDir,iGrain3]
  if (iDir < 0) i(1-iDir) = i(1-iDir)-1                                       ! to have a correlation with coordinate/position in real space

end function getInterface


!--------------------------------------------------------------------------------------------------
!> @brief map grain ID from in 1D (global array) to in 3D (local position)
!--------------------------------------------------------------------------------------------------
pure function grain1to3(grain1,nGDim)

  integer, dimension(3)             :: grain1to3

  integer,               intent(in) :: grain1                                                       !< grain ID in 1D array
  integer, dimension(3), intent(in) :: nGDim

  grain1to3 = 1 + [mod((grain1-1), nGDim(1)), &
                   mod((grain1-1)/ nGDim(1),nGDim(2)), &
                       (grain1-1)/(nGDim(1)*nGDim(2))]

end function grain1to3


!--------------------------------------------------------------------------------------------------
!> @brief map grain ID from in 3D (local position) to in 1D (global array)
!--------------------------------------------------------------------------------------------------
integer pure function grain3to1(grain3,nGDim)

  integer, dimension(3), intent(in) :: grain3                                                       !< grain ID in 3D array (pos.x,pos.y,pos.z)
  integer, dimension(3), intent(in) :: nGDim

  grain3to1 = grain3(1) &
            + nGDim(1)*(grain3(2)-1) &
            + nGDim(1)*nGDim(2)*(grain3(3)-1)

end function grain3to1


!--------------------------------------------------------------------------------------------------
!> @brief maps interface ID from 4D (normal and local position) into 1D (global array)
!--------------------------------------------------------------------------------------------------
integer pure function interface4to1(iFace4D, nGDim)

  integer, dimension(4), intent(in) :: iFace4D                                                      !< interface ID in 4D array (n.dir,pos.x,pos.y,pos.z)
  integer, dimension(3), intent(in) :: nGDim


  select case(abs(iFace4D(1)))

    case(1)
      if ((iFace4D(2) == 0) .or. (iFace4D(2) == nGDim(1))) then
        interface4to1 = 0
      else
        interface4to1 = iFace4D(3) + nGDim(2)*(iFace4D(4)-1) &
                      + nGDim(2)*nGDim(3)*(iFace4D(2)-1)
      end if

    case(2)
      if ((iFace4D(3) == 0) .or. (iFace4D(3) == nGDim(2))) then
        interface4to1 = 0
      else
        interface4to1 = iFace4D(4) + nGDim(3)*(iFace4D(2)-1) &
                      + nGDim(3)*nGDim(1)*(iFace4D(3)-1) &
                      + (nGDim(1)-1)*nGDim(2)*nGDim(3)                                              ! total # of interfaces normal || e1
      end if

    case(3)
      if ((iFace4D(4) == 0) .or. (iFace4D(4) == nGDim(3))) then
        interface4to1 = 0
      else
        interface4to1 = iFace4D(2) + nGDim(1)*(iFace4D(3)-1) &
                      + nGDim(1)*nGDim(2)*(iFace4D(4)-1) &
                      + (nGDim(1)-1)*nGDim(2)*nGDim(3) &                                            ! total # of interfaces normal || e1
                      + nGDim(1)*(nGDim(2)-1)*nGDim(3)                                              ! total # of interfaces normal || e2
      end if

    case default
      interface4to1 = -1

  end select

end function interface4to1


!--------------------------------------------------------------------------------------------------
!> @brief maps interface ID from 1D (global array) into 4D (normal and local position)
!--------------------------------------------------------------------------------------------------
pure function interface1to4(iFace1D, nGDim)

  integer, dimension(4)             :: interface1to4

  integer,               intent(in) :: iFace1D                                                      !< interface ID in 1D array
  integer, dimension(3), intent(in) :: nGDim
  integer, dimension(3)             :: nIntFace

!--------------------------------------------------------------------------------------------------
! compute the total number of interfaces, which ...
  nIntFace = [(nGDim(1)-1)*nGDim(2)*nGDim(3), &                                                     ! ... normal || e1
              nGDim(1)*(nGDim(2)-1)*nGDim(3), &                                                     ! ... normal || e2
              nGDim(1)*nGDim(2)*(nGDim(3)-1)]                                                       ! ... normal || e3

!--------------------------------------------------------------------------------------------------
! get the corresponding interface ID in 4D (normal and local position)
  if (iFace1D > 0 .and. iFace1D <= nIntFace(1)) then                                                ! interface with normal || e1
    interface1to4(1) = 1
    interface1to4(3) = mod((iFace1D-1),nGDim(2))+1
    interface1to4(4) = mod(int(real(iFace1D-1,pREAL)/real(nGDim(2),pREAL)),nGDim(3))+1
    interface1to4(2) = int(real(iFace1D-1,pREAL)/real(nGDim(2),pREAL)/real(nGDim(3),pREAL))+1
  elseif (iFace1D > nIntFace(1) .and. iFace1D <= (nIntFace(2) + nIntFace(1))) then                  ! interface with normal || e2
    interface1to4(1) = 2
    interface1to4(4) = mod((iFace1D-nIntFace(1)-1),nGDim(3))+1
    interface1to4(2) = mod(int(real(iFace1D-nIntFace(1)-1,pREAL)/real(nGDim(3),pREAL)),nGDim(1))+1
    interface1to4(3) = int(real(iFace1D-nIntFace(1)-1,pREAL)/real(nGDim(3),pREAL)/real(nGDim(1),pREAL))+1
  elseif (iFace1D > nIntFace(2) + nIntFace(1) .and. iFace1D <= (nIntFace(3) + nIntFace(2) + nIntFace(1))) then ! interface with normal || e3
    interface1to4(1) = 3
    interface1to4(2) = mod((iFace1D-nIntFace(2)-nIntFace(1)-1),nGDim(1))+1
    interface1to4(3) = mod(int(real(iFace1D-nIntFace(2)-nIntFace(1)-1,pREAL)/real(nGDim(1),pREAL)),nGDim(2))+1
    interface1to4(4) = int(real(iFace1D-nIntFace(2)-nIntFace(1)-1,pREAL)/real(nGDim(1),pREAL)/real(nGDim(2),pREAL))+1
  end if

end function interface1to4


end submodule RGC

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @brief needs a good name and description
!--------------------------------------------------------------------------------------------------
module materialpoint
  use parallelization
  use CLI
  use OS
  use signal
  use prec
  use misc
  use IO
  use types
  use YAML
  use HDF5
  use HDF5_utilities
  use result
  use config
  use math
  use rotations
  use polynomials
  use tables
  use crystal
  use material
  use phase
  use homogenization
  use discretization
#if   defined(MESH)
  use discretization_mesh
#elif defined(GRID)
#if !defined(BOOST)
  use base64
  use zlib
#endif
  use discretization_grid
#endif

  implicit none(type,external)
  public

contains


!--------------------------------------------------------------------------------------------------
!> @brief Initialize all modules.
!--------------------------------------------------------------------------------------------------
subroutine materialpoint_initAll()

  call parallelization_init()
  call prec_init()
  call OS_init()
  call misc_init()
  call IO_init()
  call CLI_init()                                                                                   ! grid and mesh commandline interface
  call signal_init()
#if defined(GRID) && !defined(BOOST)
   call zlib_init()
   call base64_init()
#endif
  call types_init()
  call YAML_init()
  call HDF5_utilities_init()
  call result_init(restart = CLI_restartInc /= -1)
  call config_init()
  call math_init()
  call rotations_init()
  call polynomials_init()
  call tables_init()
  call crystal_init()
#if   defined(MESH)
  call discretization_mesh_init()
#elif defined(GRID)
  call discretization_grid_init()
#endif
  call material_init()
  call phase_init()
  call homogenization_init()
  call materialpoint_init()
  call config_material_deallocate()

end subroutine materialpoint_initAll


!--------------------------------------------------------------------------------------------------
!> @brief Read restart information if needed.
!--------------------------------------------------------------------------------------------------
subroutine materialpoint_init()

  integer(HID_T) :: fileHandle


  print'(/,1x,a)', '<<<+-  materialpoint init  -+>>>'; flush(IO_STDOUT)

  if (CLI_restartInc /= -1) then
    print'(/,1x,a,1x,i0)', 'loading restart information of increment',CLI_restartInc; flush(IO_STDOUT)

    fileHandle = HDF5_openFile(CLI_jobName//'_restart.hdf5','r')

    call homogenization_restartRead(fileHandle)
    call phase_restartRead(fileHandle)

    call HDF5_closeFile(fileHandle)
  end if

end subroutine materialpoint_init


!--------------------------------------------------------------------------------------------------
!> @brief Write restart information.
!--------------------------------------------------------------------------------------------------
subroutine materialpoint_restartWrite()

  integer(HID_T) :: fileHandle


  print'(1x,a)', 'saving field and constitutive data required for restart';flush(IO_STDOUT)

  fileHandle = HDF5_openFile(CLI_jobName//'_restart.hdf5','a')

  call homogenization_restartWrite(fileHandle)
  call phase_restartWrite(fileHandle)

  call HDF5_closeFile(fileHandle)

end subroutine materialpoint_restartWrite


!--------------------------------------------------------------------------------------------------
!> @brief Forward data for new time increment.
!--------------------------------------------------------------------------------------------------
subroutine materialpoint_forward()

  call homogenization_forward()
  call phase_forward()

end subroutine materialpoint_forward


!--------------------------------------------------------------------------------------------------
!> @brief Trigger writing of results.
!--------------------------------------------------------------------------------------------------
subroutine materialpoint_result(inc,time)

  integer,     intent(in) :: inc
  real(pREAL), intent(in) :: time

  call result_openJobFile()
  call result_addIncrement(inc,time)
  call phase_result()
  call homogenization_result()
  call discretization_result()
  call result_finalizeIncrement()
  call result_closeJobFile()

end subroutine materialpoint_result

end module materialpoint

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author Denny Tjahjanto, Max-Planck-Institut für Eisenforschung GmbH
!> @brief homogenization manager, organizing deformation partitioning and stress homogenization
!--------------------------------------------------------------------------------------------------
module homogenization
  use prec
  use math
  use constants
  use IO
  use config
  use material
  use phase
  use discretization
  use HDF5
  use HDF5_utilities
  use result
  use crystal

  implicit none(type,external)
  private

  type :: tState
    integer :: &
      sizeState        = 0                                                                          !< size of state
    ! http://stackoverflow.com/questions/3948210
    real(pREAL), pointer,     dimension(:,:), contiguous :: &                                       !< is basically an allocatable+target, but in a type needs to be pointer
      state0, &
      state
  end type

  enum, bind(c); enumerator :: &
    THERMAL_UNDEFINED_ID, &
    THERMAL_PASS_ID, &
    THERMAL_ISOTEMPERATURE_ID, &
    CHEMICAL_UNDEFINED_ID, &
    CHEMICAL_PASS_ID
  end enum
  integer(kind(THERMAL_UNDEFINED_ID)), dimension(:),   allocatable :: &
    thermal_type, &
    chemical_type                                                                                   !< type of each homogenization

  type(tState),        allocatable, dimension(:), public :: &
    homogState, &
    damageState_h

  logical,             allocatable, dimension(:) :: &
    thermal_active, &
    chemical_active, &
    damage_active

!--------------------------------------------------------------------------------------------------
! General variables for the homogenization at a  material point
  real(pREAL),   dimension(:,:,:),     allocatable, public :: &
    homogenization_F                                                                                !< def grad of IP to be reached at end of FE increment
  real(pREAL),   dimension(:,:,:),     allocatable, public, protected :: &
    homogenization_P                                                                                !< first P--K stress of IP
  real(pREAL),   dimension(:,:,:,:,:), allocatable, public, protected :: &
    homogenization_dPdF                                                                             !< tangent of first P--K stress at IP

!--------------------------------------------------------------------------------------------------
  interface

    module subroutine mechanical_init()
    end subroutine mechanical_init

    module subroutine thermal_init()
    end subroutine thermal_init

    module subroutine chemical_init()
    end subroutine chemical_init

    module subroutine damage_init()
    end subroutine damage_init

    module subroutine mechanical_partition(subF,ce)
      real(pREAL), intent(in), dimension(3,3) :: &
        subF
      integer,     intent(in) :: &
        ce
    end subroutine mechanical_partition

    module subroutine thermal_partition(ce)
      integer,     intent(in) :: ce
    end subroutine thermal_partition

    module subroutine damage_partition(ce)
      integer,     intent(in) :: ce
    end subroutine damage_partition

    module subroutine chemical_partition(Delta_t, ce)
      real(pREAL), intent(in) :: Delta_t
      integer,     intent(in) :: ce
    end subroutine chemical_partition

    module subroutine mechanical_homogenize(Delta_t,ce)
      real(pREAL), intent(in) :: Delta_t
      integer, intent(in) :: ce                                                                                           !< cell
    end subroutine mechanical_homogenize

    module subroutine mechanical_result(group_base,ho)
      character(len=*), intent(in) :: group_base
      integer, intent(in)          :: ho
    end subroutine mechanical_result

    module subroutine damage_result(ho,group)
      integer,          intent(in) :: ho
      character(len=*), intent(in) :: group
    end subroutine damage_result

    module subroutine thermal_result(ho,group)
      integer,          intent(in) :: ho
      character(len=*), intent(in) :: group
    end subroutine thermal_result

    module subroutine chemical_result(ho,group)
      integer,          intent(in) :: ho
      character(len=*), intent(in) :: group
    end subroutine chemical_result

    module function mechanical_updateState(subdt,subF,ce) result(doneAndHappy)
      real(pREAL), intent(in) :: &
        subdt                                                                                       !< current time step
      real(pREAL), intent(in), dimension(3,3) :: &
        subF
      integer,     intent(in) :: &
        ce                                                                                          !< cell
      logical, dimension(2) :: doneAndHappy
    end function mechanical_updateState

    module function homogenization_thermal_active() result(active)
      logical :: active
    end function homogenization_thermal_active

    module function homogenization_mu_T(ce) result(mu)
      integer, intent(in) :: ce
      real(pREAL) :: mu
    end function homogenization_mu_T

    module function homogenization_K_T(ce) result(K)
      integer, intent(in) :: ce
      real(pREAL), dimension(3,3) :: K
    end function homogenization_K_T

    module function homogenization_f_T(ce) result(f)
      integer, intent(in) :: ce
      real(pREAL) :: f
    end function homogenization_f_T

    module subroutine homogenization_thermal_setField(T,dot_T)
      real(pREAL), dimension(:),  intent(in) :: T, dot_T
    end subroutine homogenization_thermal_setField

    module function homogenization_damage_active() result(active)
      logical :: active
    end function homogenization_damage_active

    module function homogenization_mu_phi(ce) result(mu)
      integer, intent(in) :: ce
      real(pREAL) :: mu
    end function homogenization_mu_phi

    module function homogenization_K_phi(ce) result(K)
      integer, intent(in) :: ce
      real(pREAL), dimension(3,3) :: K
    end function homogenization_K_phi

    module function homogenization_f_phi(phi,ce) result(f)
      integer, intent(in) :: ce
      real(pREAL), intent(in) :: phi
      real(pREAL) :: f
    end function homogenization_f_phi

    module subroutine homogenization_set_phi(phi)
      real(pREAL), dimension(:), intent(in) :: phi
    end subroutine homogenization_set_phi

    module function homogenization_chemical_active() result(active)
      logical :: active
    end function homogenization_chemical_active

    module function homogenization_composition(mu, Delta_t, ce) result(comp)
      real(pREAL), dimension(:), intent(in) :: mu
      real(pREAL), intent(in) :: Delta_t
      integer,     intent(in) :: ce
      real(pREAL), dimension(:), allocatable :: comp
    end function homogenization_composition

    module function homogenization_compositionTangent(mu, Delta_t, ce) result(comp_tangent)
      real(pREAL), dimension(:), intent(in) :: mu
      real(pREAL), intent(in) :: Delta_t
      integer,     intent(in) :: ce
      real(pREAL), dimension(:,:),allocatable :: comp_tangent
    end function homogenization_compositionTangent

    module function homogenization_mobility(ce) result(mobility)
      integer, intent(in) :: ce
      real(pREAL), dimension(:,:), allocatable :: mobility
    end function homogenization_mobility

    module subroutine homogenization_chemical_setField(mu, comp, Delta_t, ce)
      real(pREAL), dimension(:),  intent(in) :: mu
      real(pREAL), dimension(:),  intent(in) :: comp
      real(pREAL), intent(in) :: Delta_t
      integer, intent(in) :: ce
    end subroutine homogenization_chemical_setField

  end interface

  public ::  &
    homogenization_init, &
    homogenization_mechanical_response, &
    homogenization_thermal_response, &
    homogenization_thermal_active, &
    homogenization_chemical_active, &
    homogenization_mu_T, &
    homogenization_K_T, &
    homogenization_f_T, &
    homogenization_thermal_setfield, &
    homogenization_damage_active, &
    homogenization_mu_phi, &
    homogenization_K_phi, &
    homogenization_f_phi, &
    homogenization_set_phi, &
    homogenization_composition, &
    homogenization_compositionTangent, &
    homogenization_mobility, &
    homogenization_chemical_setField, &
    homogenization_forward, &
    homogenization_result, &
    homogenization_restartRead, &
    homogenization_restartWrite

contains


!--------------------------------------------------------------------------------------------------
!> @brief Module initialization.
!--------------------------------------------------------------------------------------------------
subroutine homogenization_init()

  print'(/,1x,a)', '<<<+-  homogenization init  -+>>>'; flush(IO_STDOUT)


  allocate(homogState      (size(material_name_homogenization)))
  allocate(damageState_h   (size(material_name_homogenization)))
  call parseHomogenization()

  call mechanical_init()
  call thermal_init()
  call damage_init()
  call chemical_init()

end subroutine homogenization_init


!--------------------------------------------------------------------------------------------------
!> @brief
!--------------------------------------------------------------------------------------------------
subroutine homogenization_mechanical_response(status,Delta_t,cell_start,cell_end)

  integer(kind(STATUS_OK)), intent(out) :: status
  real(pREAL), intent(in) :: Delta_t                                                                !< time increment
  integer, intent(in) :: &
    cell_start, cell_end
  integer :: &
    co, ce, ho, en
  logical :: &
    converged
  logical, dimension(2) :: &
    doneAndHappy


  status = STATUS_OK
  !$OMP PARALLEL DO PRIVATE(en,ho,co,converged,doneAndHappy)
  do ce = cell_start, cell_end

    en = material_entry_homogenization(ce)
    ho = material_ID_homogenization(ce)

    call phase_restore(ce) ! wrong name (is more a forward function)

    if (homogState(ho)%sizeState > 0)  homogState(ho)%state(:,en) = homogState(ho)%state0(:,en)
    if (damageState_h(ho)%sizeState > 0) damageState_h(ho)%state(:,en) = damageState_h(ho)%state0(:,en)
    call damage_partition(ce)

    doneAndHappy = [.false.,.true.]

    convergenceLooping: do while (status == STATUS_OK .and. .not. doneAndHappy(1))

      call mechanical_partition(homogenization_F(1:3,1:3,ce),ce)
      converged = all([(phase_mechanical_constitutive(Delta_t,co,ce) == STATUS_OK,co=1,homogenization_Nconstituents(ho))])
      if (converged) then
        doneAndHappy = mechanical_updateState(Delta_t,homogenization_F(1:3,1:3,ce),ce)
        converged = all(doneAndHappy)
      else
        doneAndHappy = [.true.,.false.]
      end if
    end do convergenceLooping
    if (.not. converged) then
      if (status == STATUS_OK) &
        call IO_warning(600,'mechanical response of cell', ce, 'on MPI rank', worldrank, emph=[2,4])
      status = STATUS_FAIL_PHASE_MECHANICAL
    end if
    converged = converged .and. all([(phase_damage_constitutive(Delta_t,co,ce)==STATUS_OK,co=1,homogenization_Nconstituents(ho))])

    if (.not. converged) then
      if (status == STATUS_OK) then
        call IO_warning(600,'damage response of cell', ce, 'on MPI rank', worldrank, emph=[2,4])
        status = STATUS_FAIL_PHASE_DAMAGE
      end if
    end if
  end do
  !$OMP END PARALLEL DO

  if (status /= STATUS_OK) return

  !$OMP PARALLEL DO PRIVATE(ho)
  do ce = cell_start, cell_end
      ho = material_ID_homogenization(ce)
      do co = 1, homogenization_Nconstituents(ho)
        call crystallite_orientations(co,ce)
      end do
      call mechanical_homogenize(Delta_t,ce)
  end do
  !$OMP END PARALLEL DO

end subroutine homogenization_mechanical_response


!--------------------------------------------------------------------------------------------------
!> @brief
!--------------------------------------------------------------------------------------------------
subroutine homogenization_thermal_response(status, &
                                           Delta_t,cell_start,cell_end)

  integer(kind(STATUS_OK)), intent(out) :: status
  real(pREAL), intent(in) :: Delta_t                                                                !< time increment
  integer, intent(in) :: &
    cell_start, cell_end

  integer :: &
    co, ce, ho


  status = STATUS_OK
  !$OMP PARALLEL DO PRIVATE(ho)
  do ce = cell_start, cell_end
    if (status /= STATUS_OK) continue
    ho = material_ID_homogenization(ce)
    do co = 1, homogenization_Nconstituents(ho)
      if (phase_thermal_constitutive(Delta_t,material_ID_phase(co,ce),material_entry_phase(co,ce)) /= STATUS_OK) then
        if (status == STATUS_OK) &
          call IO_warning(600,'thermal response of cell', ce, 'on MPI rank', worldrank, emph=[2,4])
        status = STATUS_FAIL_PHASE_THERMAL
      end if
    end do
  end do
  !$OMP END PARALLEL DO

end subroutine homogenization_thermal_response


!--------------------------------------------------------------------------------------------------
!> @brief writes homogenization results to HDF5 output file
!--------------------------------------------------------------------------------------------------
subroutine homogenization_result()

  integer :: ho
  character(len=:), allocatable :: group_base,group


  call result_closeGroup(result_addGroup('current/homogenization/'))

  do ho=1,size(material_name_homogenization)
    group_base = 'current/homogenization/'//trim(material_name_homogenization(ho))
    call result_closeGroup(result_addGroup(group_base))

    call mechanical_result(group_base,ho)

    if (damage_active(ho)) then
      group = trim(group_base)//'/damage'
      call result_closeGroup(result_addGroup(group))
      call damage_result(ho,group)
    end if

    if (thermal_active(ho)) then
      group = trim(group_base)//'/thermal'
      call result_closeGroup(result_addGroup(group))
      call thermal_result(ho,group)
    end if

    if (chemical_active(ho)) then
      group = trim(group_base)//'/chemical'
      call result_closeGroup(result_addGroup(group))
      call chemical_result(ho,group)
    end if

 end do

end subroutine homogenization_result


!--------------------------------------------------------------------------------------------------
!> @brief Forward data after successful increment.
! ToDo: Any guessing for the current states possible?
!--------------------------------------------------------------------------------------------------
subroutine homogenization_forward()

  integer :: ho


  do ho = 1, size(material_name_homogenization)
    homogState (ho)%state0 = homogState (ho)%state
    if (damageState_h(ho)%sizeState > 0) &
      damageState_h(ho)%state0 = damageState_h(ho)%state
  end do

end subroutine homogenization_forward


!--------------------------------------------------------------------------------------------------
!--------------------------------------------------------------------------------------------------
subroutine homogenization_restartWrite(fileHandle)

  integer(HID_T), intent(in) :: fileHandle

  integer(HID_T), dimension(2) :: groupHandle
  integer :: ho


  groupHandle(1) = HDF5_addGroup(fileHandle,'homogenization')

  do ho = 1, size(material_name_homogenization)

    groupHandle(2) = HDF5_addGroup(groupHandle(1),material_name_homogenization(ho))

    call HDF5_write(homogState(ho)%state,groupHandle(2),'omega_mechanical') ! ToDo: should be done by mech

    if (damageState_h(ho)%sizeState > 0) &
      call HDF5_write(damageState_h(ho)%state,groupHandle(2),'omega_damage') ! ToDo: should be done by mech

    call HDF5_closeGroup(groupHandle(2))

  end do

  call HDF5_closeGroup(groupHandle(1))

end subroutine homogenization_restartWrite


!--------------------------------------------------------------------------------------------------
!--------------------------------------------------------------------------------------------------
subroutine homogenization_restartRead(fileHandle)

  integer(HID_T), intent(in) :: fileHandle

  integer(HID_T), dimension(2) :: groupHandle
  integer :: ho


  groupHandle(1) = HDF5_openGroup(fileHandle,'homogenization')

  do ho = 1, size(material_name_homogenization)

    groupHandle(2) = HDF5_openGroup(groupHandle(1),material_name_homogenization(ho))

    call HDF5_read(homogState(ho)%state0,groupHandle(2),'omega_mechanical') ! ToDo: should be done by mech

    if (damageState_h(ho)%sizeState > 0) &
      call HDF5_read(damageState_h(ho)%state0,groupHandle(2),'omega_damage') ! ToDo: should be done by mech

    call HDF5_closeGroup(groupHandle(2))

  end do

  call HDF5_closeGroup(groupHandle(1))

end subroutine homogenization_restartRead


!--------------------------------------------------------------------------------------------------
!> @brief parses the homogenization part from the material configuration
!--------------------------------------------------------------------------------------------------
subroutine parseHomogenization

  type(tDict), pointer :: &
    material_homogenization, &
    homog, &
    homogThermal, &
    homogDamage, &
    homogChemical

  integer :: h

  material_homogenization => config_material%get_dict('homogenization')

  allocate(thermal_type(size(material_name_homogenization)),source=THERMAL_UNDEFINED_ID)
  allocate(chemical_type(size(material_name_homogenization)),source=CHEMICAL_UNDEFINED_ID)
  allocate(thermal_active(size(material_name_homogenization)),source=.false.)
  allocate(damage_active(size(material_name_homogenization)),source=.false.)
  allocate(chemical_active(size(material_name_homogenization)),source=.false.)

  do h=1, size(material_name_homogenization)
    homog => material_homogenization%get_dict(h)

    if (homog%contains('thermal')) then
      homogThermal => homog%get_dict('thermal')
        select case (homogThermal%get_asStr('type'))
          case('pass')
            thermal_type(h) = THERMAL_PASS_ID
            thermal_active(h) = .true.
          case('isotemperature')
            thermal_type(h) = THERMAL_ISOTEMPERATURE_ID
            thermal_active(h) = .true.
          case default
            call IO_error(500,ext_msg=homogThermal%get_asStr('type'))
        end select
    end if

    if (homog%contains('damage')) then
      homogDamage => homog%get_dict('damage')
        select case (homogDamage%get_asStr('type'))
          case('pass')
            damage_active(h) = .true.
          case default
            call IO_error(500,ext_msg=homogDamage%get_asStr('type'))
        end select
    end if

    if (homog%contains('chemical')) then
      homogChemical => homog%get_dict('chemical')
        select case (homogChemical%get_asStr('type'))
          case('pass')
            chemical_type(h) = CHEMICAL_PASS_ID
            chemical_active(h) = .true.
          case default
            call IO_error(500,ext_msg=homogChemical%get_asStr('type'))
        end select
    end if
  end do


end subroutine parseHomogenization


end module homogenization

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @brief internal microstructure state for all damage sources and kinematics constitutive models
!--------------------------------------------------------------------------------------------------
submodule(phase) damage

  type :: tDamageParameters
    real(pREAL) :: &
      mu = 0.0_pREAL, &                                                                             !< viscosity
      l_c = 0.0_pREAL                                                                               !< characteristic length
  end type tDamageParameters

  integer :: phase_damage_maxSizeDotState

  type :: tFieldQuantities
    real(pREAL), dimension(:), allocatable :: phi
  end type tFieldQuantities


  type(tFieldQuantities), dimension(:), allocatable :: current

  type(tDamageParameters), dimension(:), allocatable :: param

  interface

    module function anisobrittle_init() result(mySources)
      logical, dimension(:), allocatable :: mySources
    end function anisobrittle_init

    module function isobrittle_init() result(mySources)
      logical, dimension(:), allocatable :: mySources
    end function isobrittle_init


    module subroutine isobrittle_deltaState(C, Fe, ph, en)
      integer, intent(in) :: ph,en
      real(pREAL),  intent(in), dimension(3,3) :: &
        Fe
      real(pREAL),  intent(in), dimension(6,6) :: &
        C
    end subroutine isobrittle_deltaState


    module subroutine anisobrittle_dotState(M_i, ph, en)
      integer, intent(in) :: ph,en
      real(pREAL),  intent(in), dimension(3,3) :: &
        M_i
    end subroutine anisobrittle_dotState


    module subroutine anisobrittle_result(phase,group)
      integer,          intent(in) :: phase
      character(len=*), intent(in) :: group
    end subroutine anisobrittle_result

    module subroutine isobrittle_result(phase,group)
      integer,          intent(in) :: phase
      character(len=*), intent(in) :: group
    end subroutine isobrittle_result

 end interface

contains

!----------------------------------------------------------------------------------------------
!< @brief Initialize damage mechanisms.
!----------------------------------------------------------------------------------------------
module subroutine damage_init()

  integer :: &
    ph, &
    Nmembers
  type(tDict), pointer :: &
    phases, &
    phase, &
    damage
  character(len=:), allocatable :: &
    refs, &
    extmsg
  logical:: damage_active


  print'(/,1x,a)', '<<<+-  phase:damage init  -+>>>'


  phases => config_material%get_dict('phase')
  allocate(current(size(phases)))
  allocate(damageState(size(phases)))
  allocate(param(size(phases)))

  extmsg = ''
  damage_active = .false.
  do ph = 1,size(phases)

    Nmembers = count(material_ID_phase == ph)
    allocate(current(ph)%phi(Nmembers),source=1.0_pREAL)

    phase => phases%get_dict(ph)
    if (damage_active) then
      damage => phase%get_dict('damage')
    else
      damage => phase%get_dict('damage',defaultVal=emptyDict)
    end if

    if (size(damage) > 0) then
      damage_active = .true.

      print'(/,1x,a,i0,a)', 'phase ',ph,': '//phases%key(ph)
      refs = config_listReferences(damage,indent=3)
      if (len(refs) > 0) print'(/,1x,a)', refs

      param(ph)%mu = damage%get_asReal('mu')
      param(ph)%l_c = damage%get_asReal('l_c')

      ! sanity checks
      if (param(ph)%mu  < 0.0_pREAL)  extmsg = trim(extmsg)//' mu'
      if (param(ph)%l_c < 0.0_pREAL)  extmsg = trim(extmsg)//' l_c'
      if (extmsg /= '') call IO_error(211,ext_msg=trim(extmsg))

    end if

  end do

  allocate(damage_type(size(phases)), source = UNDEFINED)

  where(isobrittle_init()  ) damage_type = DAMAGE_ISOBRITTLE
  where(anisobrittle_init()) damage_type = DAMAGE_ANISOBRITTLE
  phase_damage_maxSizeDotState = maxval(damageState%sizeDotState)

  if (damage_active) then
    do ph = 1,size(phases)
      phase => phases%get_dict(ph)
      damage => phase%get_dict('damage')
      if (any(damage%keys() == 'type') .and. damage_type(ph) == UNDEFINED) &
        call IO_error(200,label1='damage',ext_msg=damage%get_asStr('type'))
    end do
  end if

end subroutine damage_init


!--------------------------------------------------------------------------------------------------
!> @brief t.b.d.
!--------------------------------------------------------------------------------------------------
module function phase_damage_constitutive(Delta_t,co,ce) result(status)

  real(pREAL), intent(in) :: Delta_t
  integer, intent(in) :: &
    co, &
    ce
  integer(kind(STATUS_OK)) :: status

  integer :: &
    ph, en


  ph = material_ID_phase(co,ce)
  en = material_entry_phase(co,ce)

  status = integrateDamageState(Delta_t,ph,en)

end function phase_damage_constitutive


!--------------------------------------------------------------------------------------------------
!> @brief Return the degraded/modified elasticity matrix.
!--------------------------------------------------------------------------------------------------
module function phase_damage_C66(C66,ph,en) result(C66_degraded)

  real(pREAL), dimension(6,6), intent(in)  :: C66
  integer,                     intent(in)  :: ph,en
  real(pREAL), dimension(6,6) :: C66_degraded


  damageType: select case (damage_type(ph))
    case (DAMAGE_ISOBRITTLE) damageType
      C66_degraded = C66 * damage_phi(ph,en)**2
    case default damageType
      C66_degraded = C66
  end select damageType

end function phase_damage_C66


!--------------------------------------------------------------------------------------------------
!> @brief Restore data after homog cutback.
!--------------------------------------------------------------------------------------------------
module subroutine damage_restore(ce)

  integer, intent(in) :: ce

  integer :: &
    co


  do co = 1,homogenization_Nconstituents(material_ID_homogenization(ce))
    if (damageState(material_ID_phase(co,ce))%sizeState > 0) &
    damageState(material_ID_phase(co,ce))%state( :,material_entry_phase(co,ce)) = &
      damageState(material_ID_phase(co,ce))%state0(:,material_entry_phase(co,ce))
  end do

end subroutine damage_restore


!----------------------------------------------------------------------------------------------
!< @brief returns local part of nonlocal damage driving force
!----------------------------------------------------------------------------------------------
module function phase_f_phi(phi,co,ce) result(f)

  integer, intent(in) :: ce,co
  real(pREAL), intent(in) :: &
    phi                                                                                             !< damage parameter
  real(pREAL) :: &
    f

  integer :: &
    ph, &
    en


  ph = material_ID_phase(co,ce)
  en = material_entry_phase(co,ce)

  select case(damage_type(ph))
    case(DAMAGE_ISOBRITTLE,DAMAGE_ANISOBRITTLE)
      f = 1.0_pREAL &
        - 2.0_pREAL * phi*damageState(ph)%state(1,en)                                               ! ToDo: MD: seems to be phi**2
    case default
      f = 0.0_pREAL
  end select

end function phase_f_phi


!--------------------------------------------------------------------------------------------------
!> @brief integrate stress, state with adaptive 1st order explicit Euler method
!> using Fixed Point Iteration to adapt the stepsize
!--------------------------------------------------------------------------------------------------
function integrateDamageState(Delta_t,ph,en) result(status)

  real(pREAL), intent(in) :: Delta_t
  integer, intent(in) :: &
    ph, &
    en
  integer(kind(STATUS_OK)) :: status

  integer :: &
    NiterationState, &                                                                              !< number of iterations in state loop
    size_so
  real(pREAL) :: &
    zeta
  real(pREAL), dimension(phase_damage_maxSizeDotState) :: &
    r                                                                                               ! state residuum
  real(pREAL), dimension(phase_damage_maxSizeDotState,2) :: source_dotState
  logical :: &
    converged_


  if (damageState(ph)%sizeState == 0) then
    status = STATUS_OK
    return
  end if

  converged_ = .true.
  status = phase_damage_collectDotState(ph,en)
  if (status /= STATUS_OK) return

  size_so = damageState(ph)%sizeDotState
  damageState(ph)%state(1:size_so,en) = damageState(ph)%state0  (1:size_so,en) &
                                      + damageState(ph)%dotState(1:size_so,en) * Delta_t
  source_dotState(1:size_so,2) = 0.0_pREAL

  iteration: do NiterationState = 1, num%nState

    if (nIterationState > 1) source_dotState(1:size_so,2) = source_dotState(1:size_so,1)
    source_dotState(1:size_so,1) = damageState(ph)%dotState(:,en)

    status = phase_damage_collectDotState(ph,en)
    if (status /= STATUS_OK) exit iteration


      zeta = damper(damageState(ph)%dotState(:,en),source_dotState(1:size_so,1),source_dotState(1:size_so,2))
      damageState(ph)%dotState(:,en) = damageState(ph)%dotState(:,en) * zeta &
                                     + source_dotState(1:size_so,1)* (1.0_pREAL - zeta)
      r(1:size_so) = damageState(ph)%state   (1:size_so,en)  &
                   - damageState(ph)%State0  (1:size_so,en)  &
                   - damageState(ph)%dotState(1:size_so,en) * Delta_t
      damageState(ph)%state(1:size_so,en) = damageState(ph)%state(1:size_so,en) - r(1:size_so)
      converged_ = converged_  .and. converged(r(1:size_so), &
                                               damageState(ph)%state(1:size_so,en), &
                                               damageState(ph)%atol(1:size_so))


    if (converged_) then
      status = phase_damage_deltaState(mechanical_F_e(ph,en),ph,en)
      exit iteration
    end if

  end do iteration

  if (.not. converged_) status = STATUS_FAIL_PHASE_DAMAGE_STATE

  contains
  !--------------------------------------------------------------------------------------------------
  !> @brief Calculate the damping for correction of state and dot state.
  !--------------------------------------------------------------------------------------------------
  real(pREAL) pure function damper(omega_0,omega_1,omega_2)
#ifndef __GFORTRAN__
  use prec
  import, none
#endif

  real(pREAL), dimension(:), intent(in) :: &
    omega_0, omega_1, omega_2

  real(pREAL) :: dot_prod12, dot_prod22

  dot_prod12 = dot_product(omega_0-omega_1, omega_1-omega_2)
  dot_prod22 = dot_product(omega_1-omega_2, omega_1-omega_2)

  if (min(dot_product(omega_0,omega_1),dot_prod12) < 0.0_pREAL .and. dot_prod22 > 0.0_pREAL) then
    damper = 0.75_pREAL + 0.25_pREAL * tanh(2.0_pREAL + 4.0_pREAL * dot_prod12 / dot_prod22)
  else
    damper = 1.0_pREAL
  end if

  end function damper

end function integrateDamageState


module subroutine damage_restartWrite(groupHandle,ph)

  integer(HID_T), intent(in) :: groupHandle
  integer, intent(in) :: ph


  select case(damage_type(ph))
    case(DAMAGE_ISOBRITTLE,DAMAGE_ANISOBRITTLE)
      call HDF5_write(damageState(ph)%state,groupHandle,'omega_damage')
  end select

end subroutine damage_restartWrite


module subroutine damage_restartRead(groupHandle,ph)

  integer(HID_T), intent(in) :: groupHandle
  integer, intent(in) :: ph


  select case(damage_type(ph))
    case(DAMAGE_ISOBRITTLE,DAMAGE_ANISOBRITTLE)
  call HDF5_read(damageState(ph)%state0,groupHandle,'omega_damage')
  end select


end subroutine damage_restartRead


!----------------------------------------------------------------------------------------------
!< @brief writes damage sources results to HDF5 output file
!----------------------------------------------------------------------------------------------
module subroutine damage_result(group,ph)

  character(len=*), intent(in) :: group
  integer,          intent(in) :: ph


  if (damage_type(ph) /= UNDEFINED) &
    call result_closeGroup(result_addGroup(group//'damage'))

  sourceType: select case (damage_type(ph))

    case (DAMAGE_ISOBRITTLE) sourceType
      call isobrittle_result(ph,group//'damage/')

    case (DAMAGE_ANISOBRITTLE) sourceType
      call anisobrittle_result(ph,group//'damage/')

  end select sourceType

end subroutine damage_result


!--------------------------------------------------------------------------------------------------
!> @brief Constitutive equation for calculating the rate of change of microstructure.
!--------------------------------------------------------------------------------------------------
function phase_damage_collectDotState(ph,en) result(status)

  integer, intent(in) :: &
    ph, &
    en                                                                                         !< counter in source loop
  integer(kind(STATUS_OK)) :: status


  status = STATUS_OK

  if (damageState(ph)%sizeState > 0) then

    sourceType: select case (damage_type(ph))

      case (DAMAGE_ANISOBRITTLE) sourceType
        call anisobrittle_dotState(mechanical_S(ph,en), ph,en) ! ToDo: use M_d

    end select sourceType

    if (any(IEEE_is_NaN(damageState(ph)%dotState(:,en)))) status = STATUS_FAIL_PHASE_DAMAGE_STATE

  end if

end function phase_damage_collectDotState


!--------------------------------------------------------------------------------------------------
!> @brief Damage viscosity.
!--------------------------------------------------------------------------------------------------
module function phase_mu_phi(co,ce) result(mu)

  integer, intent(in) :: co, ce
  real(pREAL) :: mu


  mu = param(material_ID_phase(co,ce))%mu

end function phase_mu_phi


!--------------------------------------------------------------------------------------------------
!> @brief Damage conductivity/diffusivity in reference configuration.
!--------------------------------------------------------------------------------------------------
module function phase_K_phi(co,ce) result(K)

  integer, intent(in) :: co, ce
  real(pREAL), dimension(3,3) :: K


  K = crystallite_push33ToRef(co,ce,param(material_ID_phase(co,ce))%l_c**2*math_I3)

end function phase_K_phi


!--------------------------------------------------------------------------------------------------
!> @brief for constitutive models having an instantaneous change of state
!> will return false if delta state is not needed/supported by the constitutive model
!--------------------------------------------------------------------------------------------------
function phase_damage_deltaState(Fe, ph, en) result(status)

  integer, intent(in) :: &
    ph, &
    en
  real(pREAL),   intent(in), dimension(3,3) :: &
    Fe                                                                                              !< elastic deformation gradient

  integer :: &
    myOffset, &
    mySize
  integer(kind(STATUS_OK)) :: status


  status = STATUS_OK

  if (damageState(ph)%sizeState == 0) return

   sourceType: select case (damage_type(ph))

    case (DAMAGE_ISOBRITTLE) sourceType
      call isobrittle_deltaState(phase_homogenizedC66(ph,en), Fe, ph,en)
      if (any(IEEE_is_NaN(damageState(ph)%deltaState(:,en)))) status = STATUS_FAIL_PHASE_DAMAGE_DELTASTATE
      if (status == STATUS_OK) then
        myOffset = damageState(ph)%offsetDeltaState
        mySize   = damageState(ph)%sizeDeltaState
        damageState(ph)%state(myOffset + 1: myOffset + mySize,en) = &
        damageState(ph)%state(myOffset + 1: myOffset + mySize,en) + damageState(ph)%deltaState(1:mySize,en)
      end if

  end select sourceType


end function phase_damage_deltaState


!--------------------------------------------------------------------------------------------------
!> @brief Check if a source mechanism is active or not.
!--------------------------------------------------------------------------------------------------
function source_active(source_label)  result(active_source)

  character(len=*), intent(in)         :: source_label                                              !< name of source mechanism
  logical, dimension(:), allocatable  :: active_source

  type(tDict), pointer :: &
    phases, &
    phase, &
    src
  integer :: ph


  phases => config_material%get_dict('phase')
  allocate(active_source(size(phases)))
  do ph = 1, size(phases)
    phase => phases%get_dict(ph)
    src => phase%get_dict('damage',defaultVal=emptyDict)
    active_source(ph) = src%get_asStr('type',defaultVal = 'x') == source_label
  end do


end function source_active


!----------------------------------------------------------------------------------------------
!< @brief Set damage parameter
!----------------------------------------------------------------------------------------------
module subroutine phase_set_phi(phi,co,ce)

  real(pREAL), intent(in) :: phi
  integer, intent(in) :: ce, co


  current(material_ID_phase(co,ce))%phi(material_entry_phase(co,ce)) = phi

end subroutine phase_set_phi


module function damage_phi(ph,en) result(phi)

  integer, intent(in) :: ph, en
  real(pREAL) :: phi


  phi = current(ph)%phi(en)

end function damage_phi



!--------------------------------------------------------------------------------------------------
!> @brief Forward data after successful increment.
!--------------------------------------------------------------------------------------------------
module subroutine damage_forward()

  integer :: ph


  do ph = 1, size(damageState)
    if (damageState(ph)%sizeState > 0) &
      damageState(ph)%state0 = damageState(ph)%state
  end do

end subroutine damage_forward


end submodule damage

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
module test_IO
  use prec
  use parallelization
  use IO

  implicit none(type,external)

  private
  public :: test_IO_run

  contains

subroutine test_IO_run()

  real, dimension(30) :: rnd_real
  character(len=size(rnd_real)) :: rnd_str
  character(len=pSTRLEN), dimension(1) :: strarray_out
  character(len=:), allocatable :: str_out, fname
  integer :: u,i


  call IO_selfTest()

  call random_number(rnd_real)
  fname = 'test'//IO_intAsStr(worldrank)//'.txt'

  do i = 1, size(rnd_real)
    rnd_str(i:i) = char(32 + int(rnd_real(i)*(127.-32.)))
  end do
  open(newunit=u,file=fname,status='replace',form='formatted')
  write(u,'(a)') rnd_str
  close(u)

  str_out = IO_read(fname)
  if (rnd_str//IO_EOL /= str_out) error stop 'IO_read'

end subroutine test_IO_run

end module test_IO

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author Christoph Koords, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Geometric information about the IP cells needed for the nonlocal
! plasticity model
!--------------------------------------------------------------------------------------------------
module geometry_plastic_nonlocal
  use prec
  use result

  implicit none(type,external)
  public

  integer, protected :: &
    geometry_plastic_nonlocal_nIPneighbors

  integer,     dimension(:,:,:,:), allocatable, protected :: &
    geometry_plastic_nonlocal_IPneighborhood                                                        !< 6 or less neighboring IPs as [element ID, IP ID, face ID that point to me]

  real(pREAL), dimension(:,:),     allocatable, protected :: &
    geometry_plastic_nonlocal_IPvolume0                                                             !< volume associated with IP (initially!)

  real(pREAL), dimension(:,:,:),   allocatable, protected :: &
    geometry_plastic_nonlocal_IParea0                                                               !< area of interface to neighboring IP (initially!)

  real(pREAL), dimension(:,:,:,:), allocatable, protected :: &
    geometry_plastic_nonlocal_IPareaNormal0                                                         !< area normal of interface to neighboring IP (initially!)


contains

!---------------------------------------------------------------------------------------------------
!> @brief Set the integration point (IP) neighborhood.
!> @details: The IP neighborhood for element ID (last index), IP ID (second but last index) and
!            face ID (second index) gives the element ID (1 @ first index), IP ID (2 @ first index)
!            and face ID (3 @ first index).
!            A triangle (2D) has 3 faces, a quadrilateral (2D) had 4 faces, a tetrahedron (3D) has
!            4 faces, and a hexahedron (3D) has 6 faces.
!---------------------------------------------------------------------------------------------------
subroutine geometry_plastic_nonlocal_setIPneighborhood(IPneighborhood)

  integer, dimension(:,:,:,:), intent(in) :: IPneighborhood


  geometry_plastic_nonlocal_IPneighborhood = IPneighborhood
  geometry_plastic_nonlocal_nIPneighbors   = size(IPneighborhood,2)

end subroutine geometry_plastic_nonlocal_setIPneighborhood


!---------------------------------------------------------------------------------------------------
!> @brief Set the initial volume associated with an integration point.
!---------------------------------------------------------------------------------------------------
subroutine geometry_plastic_nonlocal_setIPvolume(IPvolume)

  real(pREAL), dimension(:,:), intent(in) :: IPvolume


  geometry_plastic_nonlocal_IPvolume0 = IPvolume

end subroutine geometry_plastic_nonlocal_setIPvolume


!---------------------------------------------------------------------------------------------------
!> @brief Set the initial areas of the unit triangle/unit quadrilateral/tetrahedron/hexahedron
!         encompassing an integration point.
!---------------------------------------------------------------------------------------------------
subroutine geometry_plastic_nonlocal_setIParea(IParea)

  real(pREAL), dimension(:,:,:), intent(in) :: IParea


  geometry_plastic_nonlocal_IParea0 = IParea

end subroutine geometry_plastic_nonlocal_setIParea


!---------------------------------------------------------------------------------------------------
!> @brief Set the direction normal of the areas of the triangle/quadrilateral/tetrahedron/hexahedron
!         encompassing an integration point
!---------------------------------------------------------------------------------------------------
subroutine geometry_plastic_nonlocal_setIPareaNormal(IPareaNormal)

  real(pREAL), dimension(:,:,:,:), intent(in) :: IPareaNormal


  geometry_plastic_nonlocal_IPareaNormal0 = IPareaNormal

end subroutine geometry_plastic_nonlocal_setIPareaNormal


!---------------------------------------------------------------------------------------------------
!> @brief Free memory used by variables only needed by plastic_nonlocal.
!---------------------------------------------------------------------------------------------------
subroutine geometry_plastic_nonlocal_disable

  if (allocated(geometry_plastic_nonlocal_IPneighborhood)) &
    deallocate(geometry_plastic_nonlocal_IPneighborhood)

  if (allocated(geometry_plastic_nonlocal_IPvolume0)) &
    deallocate(geometry_plastic_nonlocal_IPvolume0)

  if (allocated(geometry_plastic_nonlocal_IParea0)) &
    deallocate(geometry_plastic_nonlocal_IParea0)

  if (allocated(geometry_plastic_nonlocal_IPareaNormal0)) &
    deallocate(geometry_plastic_nonlocal_IPareaNormal0)

end subroutine geometry_plastic_nonlocal_disable


!---------------------------------------------------------------------------------------------------
!> @brief Write geometry data to results file.
!---------------------------------------------------------------------------------------------------
subroutine geometry_plastic_nonlocal_result()

  integer, dimension(:), allocatable :: shp


  call result_openJobFile()

  writeVolume: block
    real(pREAL), dimension(:), allocatable :: temp
    shp = shape(geometry_plastic_nonlocal_IPvolume0)
    temp = reshape(geometry_plastic_nonlocal_IPvolume0,[shp(1)*shp(2)])
    call result_writeDataset(temp,'geometry','v_0',&
                             'initial cell volume','m³')
  end block writeVolume

  writeAreas: block
    real(pREAL), dimension(:,:), allocatable :: temp
    shp = shape(geometry_plastic_nonlocal_IParea0)
    temp = reshape(geometry_plastic_nonlocal_IParea0,[shp(1),shp(2)*shp(3)])
    call result_writeDataset(temp,'geometry','a_0',&
                             'initial cell face area','m²')
  end block writeAreas

  writeNormals: block
    real(pREAL), dimension(:,:,:), allocatable :: temp
    shp = shape(geometry_plastic_nonlocal_IPareaNormal0)
    temp = reshape(geometry_plastic_nonlocal_IPareaNormal0,[shp(1),shp(2),shp(3)*shp(4)])
    call result_writeDataset(temp,'geometry','n_0',&
                             'initial cell face normals','-',transposed=.false.)
  end block writeNormals

  call result_closeJobFile()

end subroutine geometry_plastic_nonlocal_result

end module geometry_plastic_nonlocal

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Aadhithyan Kannan, KU Leuven
!> @brief regular solution model for free energy using SGTE representation (second generation)
!> @details input from CALPHAD-based databases
!> @details no contribution to free energy from other physics. For example, magnetic
!--------------------------------------------------------------------------------------------------
submodule(phase:chemical) regularsolution

  real(pREAL), parameter :: &
    R = 8.314459848_pREAL                                      ! check: add reference for value or have it in constant.f90

  type :: tParameters                                                                       !< container type for internal constitutive parameters
    integer :: &
      N_components
    real(pREAL), dimension(:), allocatable :: &
      Mobility, &
      c_0                                                      ! check: needs to be defined? initial composition corresponding to mu initialized in VTI
    real(pREAL), dimension(:,:,:), allocatable :: &
      G0_coeff                                                 ! for each component, for each temperature range, and third dimension: Temp range(2) + coefficients(8)
    real(pREAL), dimension(:, :, :, :), allocatable :: &
      Tranges_L0                                                ! for each component, for each interacting component, for each temperature range, and the range
    type(tpolynomial), dimension(:, :, :), allocatable :: L0_T  ! for each component, for each interacting component, for each temperature range
  end type tParameters

  type(tParameters), dimension(:),   allocatable :: param                                   !< containers of constitutive parameters (len Ninstances)

contains

!--------------------------------------------------------------------------------------------------
!> @brief module initialization
!> @details reads in material parameters and allocates arrays
!--------------------------------------------------------------------------------------------------
module function regularsolution_init() result(myChemicalEnergy)

  logical, dimension(:), allocatable :: myChemicalEnergy

  type(tDict), pointer :: &
    phases, &
    phase, &
    chemical, components, component, &
    G_xs, &                                         ! dictionary keys are component for excess interactions
    G0_range, Gxs_range

  type(tList), pointer :: &
    G_0, &
    Gxs_comp

  integer :: ph, Nmembers, com, xs_com, maxSize_G0lists, maxSize_Gxscomlists, i

  character(len=:), allocatable :: refs

  myChemicalEnergy = chemical_active('regularsolution')
  if (count(myChemicalEnergy) == 0) return

  print'(/,a)', ' <<<+-  phase:chemical:regularsolution init  -+>>>'
  print'(a,i2)', ' # phases: ',count(myChemicalEnergy); flush(IO_STDOUT)

  phases => config_material%get_dict('phase')
  allocate(param(size(phases)))

  do ph = 1, size(phases)
    if ( .not. myChemicalEnergy(ph)) cycle

    phase => phases%get_dict(ph)
    chemical => phase%get_dict('chemical')
    components => chemical%get_dict('components',defaultVal=emptyDict)

    print'(/,1x,a,1x,i0,a)', 'phase',ph,': '//phases%key(ph)
    refs = config_listReferences(chemical,indent=3)
    if (len(refs) > 0) print'(/,1x,a)', refs

    maxSize_G0lists = 0
    maxSize_Gxscomlists = 0

! parse to allocate. ToDo: add all warnings and error before allocate
    do com = 1, size(components)
      component => components%get_dict(com)
      maxSize_G0lists = max(maxSize_G0lists, size(component%get_list('G_0', defaultVal=emptyList))) ! check: size can never be zero. at least one temp range needed
      if (com > 1) then
        G_xs => component%get_dict('G_xs',defaultVal=emptyDict)     ! check: should not be empty. no interactions must need zeros as interaction coefficients. specify in documentation
        do xs_com = 1, size(G_xs)
          maxSize_Gxscomlists = max(maxSize_Gxscomlists, size(G_xs%get_list(G_xs%key(xs_com), defaultVal=emptyList))) ! check: size can never be zero. at least one temp range needed
        end do
      endif
    end do

    associate(prm  => param(ph))

      prm%N_components = size(components)
      allocate(prm%c_0(size(components)),        source=0.0_pREAL)
      allocate(prm%Mobility(size(components)),   source=0.0_pREAL)
      allocate(prm%G0_coeff(size(components),maxSize_G0lists,10), source=0.0_pREAL)
      allocate(prm%L0_T(size(components),size(components),maxSize_Gxscomlists))
      allocate(prm%Tranges_L0(size(components),size(components),maxSize_Gxscomlists,2), source=0.0_pREAL)

! parse and store
      do com = 1, size(components)
        component => components%get_dict(com)
        prm%Mobility(com)           = component%get_asReal('M')
        prm%c_0     (com)           = component%get_asReal('c_0')

        G_0 => component%get_list('G_0')
        do i = 1, size(G_0)
          G0_range  => G_0%get_dict(i)
          prm%G0_coeff (com, i, 1:2)  = G0_range%get_as1dReal('T_range', requiredSize=2)     ! check: handle size mismatch
          prm%G0_coeff (com, i, 3:)   = G0_range%get_as1dReal('SGTE_coeff', requiredSize=8)  ! check: handle size mismatch
        end do

        if (com > 1) then                  ! by default expect interactions for the second component onwards. Should be present as zero in material.yaml for non-interacting components
          G_xs => component%get_dict('G_xs')
          do xs_com = 1, size(G_xs)        ! size(G_xs) should be com-1. add check? ensures keys for dict: component, are already present before in components:material.yaml get added for xs
            Gxs_comp => G_xs%get_list(components%key(xs_com)) ! order corresponds to order in components dictionary. same component raise error
            do i = 1, size(Gxs_comp)
              Gxs_range => Gxs_comp%get_dict(i)
              prm%Tranges_L0 (com, xs_com, i, :) = Gxs_range%get_as1dReal('T_range', requiredSize=2)  ! check: handle size mismatch
              prm%L0_T(com, xs_com, i) = polynomial(Gxs_range, 'L_0', 'T')   ! only lower triangle of interaction matrix. symmetry applied later
            end do
          end do
        endif
      end do

      Nmembers = count(material_ID_phase == ph)
      ! call phase_allocateState(chemicalState(ph),Nmembers,1,1,0)
      allocate(current(ph)%C(prm%N_components,Nmembers),source=spread(prm%c_0,2,Nmembers))
      allocate(current(ph)%dot_C(prm%N_components,Nmembers),source=0.0_pREAL)
      allocate(current(ph)%C0(prm%N_components,Nmembers),source=spread(prm%c_0,2,Nmembers))

    end associate

  end do

end function regularsolution_init


!--------------------------------------------------------------------------------------------------
!> @brief return chemical potential explicit.
!--------------------------------------------------------------------------------------------------
module function regularsolution_mu_explicit(ph,en,comp_prev) result(mu_explicit)

  integer, intent(in) :: &
    ph, &
    en
  real(pREAL), dimension(:), intent(in)    :: comp_prev
  real(pREAL), dimension(:), allocatable   :: mu_explicit

  real(pREAL), dimension(:), allocatable   :: G0
  real(pREAL), dimension(:, :), allocatable :: L0
  integer :: com_i, com_j

  associate(prm => param(ph))

    allocate(mu_explicit(prm%N_components - 1), source=0.0_pREAL)

    L0 = get_L0(ph, en)
    G0 = get_G0(ph, en)

    do com_i = 1, prm%N_components-1
      mu_explicit(com_i) = G0(com_i) - G0(prm%N_components) + &
                              L0(com_i, prm%N_components)*(comp_prev(prm%N_components) - comp_prev(com_i))
      do com_j = 1, prm%N_components-1
        if (com_j /= com_i) then
          mu_explicit(com_i) = mu_explicit(com_i) + (L0(com_i, com_j) - L0(prm%N_components, com_j))*(comp_prev(com_j))
        endif
      end do
    end do

 end associate

end function regularsolution_mu_explicit


!--------------------------------------------------------------------------------------------------
!> @brief Returns G0: reference free energy for pure components evaluated at temperature T
!--------------------------------------------------------------------------------------------------
pure function get_G0(ph, en) result(G0)

  integer, intent(in) :: &
    ph, &
    en
  real(pREAL), dimension(:),allocatable :: G0

  real(pREAL) :: T
  integer :: com_i, i

  T = thermal_T(ph,en)

  associate(prm => param(ph))

    allocate(G0(prm%N_components), source=0.0_pREAL)

    do com_i = 1, prm%N_components
      do i = 1, size(prm%G0_coeff,2)
        if (prm%G0_coeff(com_i,i,1) <= T .and. T <= prm%G0_coeff(com_i,i,2)) then
          G0(com_i) = prm%G0_coeff(com_i, i, 3) + prm%G0_coeff(com_i, i, 4)*T + prm%G0_coeff(com_i, i, 5)*T*log(T) + &
                                                  prm%G0_coeff(com_i, i, 6)*T**2 + prm%G0_coeff(com_i, i, 7)/T + &
                                                  prm%G0_coeff(com_i, i, 8)*T**3 + prm%G0_coeff(com_i, i, 9)*T**7 + &
                                                  prm%G0_coeff(com_i, i, 10)*T**(-9)
          exit
        endif
      end do
    end do

 end associate

end function get_G0


!--------------------------------------------------------------------------------------------------
!> @brief Returns L0: interaction coefficients(zero order) evaluated at temperature T
!--------------------------------------------------------------------------------------------------
pure function get_L0(ph, en) result(L0)

  integer, intent(in) :: &
    ph, &
    en
  real(pREAL), dimension(:, :),allocatable :: L0

  real(pREAL) :: T
  integer :: com_i, com_j, i, j, k

  T = thermal_T(ph,en)

  associate(prm => param(ph))
    allocate(L0(prm%N_components, prm%N_components), source=0.0_pREAL)

    do com_i = 1, prm%N_components-1
      do com_j = com_i+1, prm%N_components
        do k = 1, size(prm%Tranges_L0,3)
          if (prm%Tranges_L0(com_j, com_i, k, 1) <= T .and. T <= prm%Tranges_L0(com_j, com_i, k, 2)) then
            L0(com_j, com_i) = prm%L0_T(com_j, com_i, k)%at(T)
            L0(com_i, com_j) = L0(com_j, com_i)
            exit
          endif
        end do
      end do
    end do

  end associate

end function get_L0


!--------------------------------------------------------------------------------------------------
!> @brief return composition from chemical potential.
!--------------------------------------------------------------------------------------------------
module function regularsolution_composition(mu_chemical,comp_prev,ph,en) result(comp)
  real(pREAL), dimension(:), intent(in) :: mu_chemical
  real(pREAL), dimension(:), intent(in) :: comp_prev
  integer, intent(in) :: &
    ph, &
    en
  real(pREAL), dimension(:), allocatable :: comp

  real(pREAL) :: T
  real(pREAL), dimension(:), allocatable :: mu_explicit

  associate(prm => param(ph))

    allocate(comp(prm%N_components), source=0.0_pREAL)
    T = thermal_T(ph,en)

    mu_explicit = regularsolution_mu_explicit(ph,en,comp_prev)
    comp(1:prm%N_components-1) = exp((mu_chemical - mu_explicit)/R/T)/ &
          (1.0_pREAL+sum(exp((mu_chemical - mu_explicit)/R/T)))

    comp(prm%N_components) = 1.0_pREAL - sum(comp(1:prm%N_components-1))

  end associate

end function regularsolution_composition


!--------------------------------------------------------------------------------------------------
!> @brief return derivative of composition with respect to chemical potential.
!--------------------------------------------------------------------------------------------------
module function regularsolution_compositionTangent(mu_chemical,comp_prev,ph,en) result(comp_tangent)

  real(pREAL), dimension(:), intent(in) :: mu_chemical
  real(pREAL), dimension(:), intent(in) :: comp_prev
  integer, intent(in) :: &
    ph, &
    en
  real(pREAL), dimension(:,:),allocatable :: comp_tangent

  real(pREAL) :: T
  real(pREAL), dimension(:), allocatable :: comp

  integer :: com_i, com_j

  associate(prm => param(ph))

    allocate(comp_tangent(prm%N_components-1,prm%N_components-1), source= 0.0_pREAL)
    T = thermal_T(ph,en)

    comp = regularsolution_composition(mu_chemical,comp_prev,ph,en)
    do com_i = 1, prm%N_components-1
      comp_tangent(com_i,com_i) = comp(com_i)/R/T
      do com_j = 1, prm%N_components-1
        comp_tangent(com_i,com_j) = comp_tangent(com_i,com_j) - comp(com_i)*comp(com_j)/R/T
      end do
    end do

  end associate

end function regularsolution_compositionTangent


!--------------------------------------------------------------------------------------------------
!> @brief return mobility. ToDo: from mobility database?
!--------------------------------------------------------------------------------------------------
module function regularsolution_mobility(ph,en) result(mobility)
  integer, intent(in) :: &
    ph, &
    en
  real(pREAL), dimension(:,:),allocatable :: mobility

  integer :: com

  associate(prm => param(ph))

    allocate(mobility(prm%N_components-1,prm%N_components-1), source=0.0_pREAL)
    do com = 1, prm%N_components-1
      mobility(com,com) = prm%Mobility(com)
    end do

  end associate

end function regularsolution_mobility


!--------------------------------------------------------------------------------------------------
!> @brief Write results to HDF5 output file.
!--------------------------------------------------------------------------------------------------
module subroutine regularsolution_result(ph,comp,group)
  integer,          intent(in) :: ph
  real(pREAL), dimension(:,:), intent(in) :: comp
  character(len=*), intent(in) :: group

  integer :: ou

  associate(prm => param(ph))

    do ou = 1,prm%N_components
        call result_writeDataset(comp(ou,:),group,trim(material_name_species(ou)), &
                                 'concentration of '//trim(material_name_species(ou)),'mole fraction')
    end do

  end associate

end subroutine regularsolution_result


end submodule regularsolution

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
program DAMASK_test

  use parallelization
  use HDF5_utilities
  use IO

  use test_prec
  use test_OS
  use test_misc
  use test_math
  use test_polynomials
  use test_tables
  use test_crystal
  use test_rotations
  use test_IO
  use test_types
  use test_HDF5_utilities


  character(len=*), parameter :: &
    ok  = achar(27)//'[32mok'//achar(27)//'[0m', &
    fmt = '(3x,a,T20,a,1x)'

  call parallelization_init()
  call HDF5_utilities_init()

  write(IO_STDOUT,fmt='(/,1x,a,/)') achar(27)//'[1m'//'testing'//achar(27)//'[0m'

  write(IO_STDOUT,fmt=fmt, advance='no') 'prec','...'
  call test_prec_run()
  write(IO_STDOUT,fmt='(a)') ok

  write(IO_STDOUT,fmt=fmt, advance='no') 'misc','...'
  call test_misc_run()
  write(IO_STDOUT,fmt='(a)') ok

  write(IO_STDOUT,fmt=fmt, advance='no') 'OS','...'
  call test_OS_run()
  write(IO_STDOUT,fmt='(a)') ok

  write(IO_STDOUT,fmt=fmt, advance='no') 'math','...'
  call test_math_run()
  write(IO_STDOUT,fmt='(a)') ok

  write(IO_STDOUT,fmt=fmt, advance='no') 'polynomials','...'
  call test_polynomials_run()
  write(IO_STDOUT,fmt='(a)') ok

  write(IO_STDOUT,fmt=fmt, advance='no') 'tables','...'
  call test_tables_run()
  write(IO_STDOUT,fmt='(a)') ok

  write(IO_STDOUT,fmt=fmt, advance='no') 'crystal','...'
  call test_crystal_run()
  write(IO_STDOUT,fmt='(a)') ok

  write(IO_STDOUT,fmt=fmt, advance='no') 'rotations','...'
  call test_rotations_run()
  write(IO_STDOUT,fmt='(a)') ok

  write(IO_STDOUT,fmt=fmt, advance='no') 'IO','...'
  call test_IO_run()
  write(IO_STDOUT,fmt='(a)') ok

  write(IO_STDOUT,fmt=fmt, advance='no') 'types','...'
  call test_types_run()
  write(IO_STDOUT,fmt='(a)') ok

  write(IO_STDOUT,fmt=fmt, advance='no') 'HDF5_utilities','...'
  call test_HDF5_utilities_run()
  write(IO_STDOUT,fmt='(a)') ok

  call quit(0)

end program DAMASK_test

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief material subroutine for isotropic plasticity
!> @details Isotropic Plasticity which resembles the phenopowerlaw plasticity without
!! resolving the stress on the slip systems. Will give the response of phenopowerlaw for an
!! untextured polycrystal
!--------------------------------------------------------------------------------------------------
submodule(phase:plastic) isotropic

  type :: tParameters
    real(pREAL) :: &
      M, &                                                                                          !< Taylor factor
      dot_gamma_0, &                                                                                !< reference strain rate
      n, &                                                                                          !< stress exponent
      h_0, &
      h, &                                                                                          !< hardening pre-factor
      h_ln, &
      xi_inf, &                                                                                     !< maximum critical stress
      a, &
      c_1, &
      c_4, &
      c_3, &
      c_2
    logical :: &
      dilatation
    character(len=pSTRLEN), allocatable, dimension(:) :: &
      output
  end type tParameters

  type :: tIsotropicState
    real(pREAL), pointer, dimension(:) :: &
      xi
  end type tIsotropicState

!--------------------------------------------------------------------------------------------------
! containers for parameters and state
  type(tParameters),     allocatable, dimension(:) :: param
  type(tIsotropicState), allocatable, dimension(:) :: state

contains

!--------------------------------------------------------------------------------------------------
!> @brief Perform module initialization.
!> @details reads in material parameters, allocates arrays, and does sanity checks
!--------------------------------------------------------------------------------------------------
module function plastic_isotropic_init() result(myPlasticity)

  logical, dimension(:), allocatable :: myPlasticity
  integer :: &
    ph, &
    Nmembers, &
    sizeState, sizeDotState
  real(pREAL) :: &
    xi_0                                                                                            !< initial critical stress
  character(len=:), allocatable :: &
    refs, &
    extmsg
  type(tDict), pointer :: &
    phases, &
    phase, &
    mech, &
    pl


  myPlasticity = plastic_active('isotropic')
  if (count(myPlasticity) == 0) return

  print'(/,1x,a)', '<<<+-  phase:mechanical:plastic:isotropic init  -+>>>'

  print'(/,1x,a)', 'T. Maiti and P. Eisenlohr, Scripta Materialia 145:37–40, 2018'
  print'(  1x,a)', 'https://doi.org/10.1016/j.scriptamat.2017.09.047'

  print'(/,1x,a,1x,i0)', '# phases:',count(myPlasticity); flush(IO_STDOUT)

  phases => config_material%get_dict('phase')
  allocate(param(size(phases)))
  allocate(state(size(phases)))
  extmsg = ''

  do ph = 1, size(phases)
    if (.not. myPlasticity(ph)) cycle

    associate(prm => param(ph), &
              stt => state(ph))

    phase => phases%get_dict(ph)
    mech => phase%get_dict('mechanical')
    pl => mech%get_dict('plastic')

    print'(/,1x,a,1x,i0,a)', 'phase',ph,': '//phases%key(ph)
    refs = config_listReferences(pl,indent=3)
    if (len(refs) > 0) print'(/,1x,a)', refs

#if defined (__GFORTRAN__)
    prm%output = output_as1dStr(pl)
#else
    prm%output = pl%get_as1dStr('output',defaultVal=emptyStrArray)
#endif

    xi_0            = pl%get_asReal('xi_0')
    prm%xi_inf      = pl%get_asReal('xi_inf')
    prm%dot_gamma_0 = pl%get_asReal('dot_gamma_0')
    prm%n           = pl%get_asReal('n')
    prm%h_0         = pl%get_asReal('h_0')
    prm%h           = pl%get_asReal('h',    defaultVal=3.0_pREAL)                                   ! match for fcc random polycrystal
    prm%M           = pl%get_asReal('M')
    prm%h_ln        = pl%get_asReal('h_ln', defaultVal=0.0_pREAL)
    prm%c_1         = pl%get_asReal('c_1',  defaultVal=0.0_pREAL)
    prm%c_4         = pl%get_asReal('c_4',  defaultVal=0.0_pREAL)
    prm%c_3         = pl%get_asReal('c_3',  defaultVal=0.0_pREAL)
    prm%c_2         = pl%get_asReal('c_2',  defaultVal=0.0_pREAL)
    prm%a           = pl%get_asReal('a')

    prm%dilatation  = pl%get_asBool('dilatation',defaultVal = .false.)

!--------------------------------------------------------------------------------------------------
!  sanity checks
    if (xi_0            <  0.0_pREAL) extmsg = trim(extmsg)//' xi_0'
    if (prm%dot_gamma_0 <= 0.0_pREAL) extmsg = trim(extmsg)//' dot_gamma_0'
    if (prm%n           <= 0.0_pREAL) extmsg = trim(extmsg)//' n'
    if (prm%a           <= 0.0_pREAL) extmsg = trim(extmsg)//' a'
    if (prm%M           <= 0.0_pREAL) extmsg = trim(extmsg)//' M'

!--------------------------------------------------------------------------------------------------
! allocate state arrays
    Nmembers = count(material_ID_phase == ph)
    sizeDotState = size(['xi'])
    sizeState = sizeDotState

    call phase_allocateState(plasticState(ph),Nmembers,sizeState,sizeDotState,0)
    deallocate(plasticState(ph)%dotState) ! ToDo: remove dotState completely

!--------------------------------------------------------------------------------------------------
! state aliases and initialization
    stt%xi => plasticState(ph)%state(1,:)
    stt%xi = xi_0
    plasticState(ph)%atol(1) = pl%get_asReal('atol_xi',defaultVal=1.0_pREAL)
    if (plasticState(ph)%atol(1) < 0.0_pREAL) extmsg = trim(extmsg)//' atol_xi'

    end associate

!--------------------------------------------------------------------------------------------------
!  exit if any parameter is out of range
    if (extmsg /= '') call IO_error(211,ext_msg=trim(extmsg))

  end do

end function plastic_isotropic_init


!--------------------------------------------------------------------------------------------------
!> @brief Calculate plastic velocity gradient and its tangent.
!--------------------------------------------------------------------------------------------------
module subroutine isotropic_LpAndItsTangent(Lp,dLp_dMp,Mp,ph,en)

  real(pREAL), dimension(3,3),     intent(out) :: &
    Lp                                                                                              !< plastic velocity gradient
  real(pREAL), dimension(3,3,3,3), intent(out) :: &
    dLp_dMp                                                                                         !< derivative of Lp with respect to the Mandel stress

  real(pREAL), dimension(3,3), intent(in) :: &
    Mp                                                                                              !< Mandel stress
  integer,                     intent(in) :: &
    ph, &
    en

  real(pREAL), dimension(3,3) :: &
    Mp_dev                                                                                          !< deviatoric part of the Mandel stress
  real(pREAL) :: &
    dot_gamma, &                                                                                    !< strainrate
    norm_Mp_dev, &                                                                                  !< norm of the deviatoric part of the Mandel stress
    squarenorm_Mp_dev                                                                               !< square of the norm of the deviatoric part of the Mandel stress
  integer :: &
    k, l, m, n


  associate(prm => param(ph), stt => state(ph))

    Mp_dev = math_deviatoric33(Mp)
    squarenorm_Mp_dev = math_tensordot(Mp_dev,Mp_dev)
    norm_Mp_dev = sqrt(squarenorm_Mp_dev)

    if (norm_Mp_dev > 0.0_pREAL) then
      dot_gamma = prm%dot_gamma_0 * (sqrt(1.5_pREAL) * norm_Mp_dev/(prm%M*stt%xi(en)))**prm%n

      Lp = dot_gamma * Mp_dev/norm_Mp_dev
      forall (k=1:3,l=1:3,m=1:3,n=1:3) &
        dLp_dMp(k,l,m,n) = (prm%n-1.0_pREAL) * Mp_dev(k,l)*Mp_dev(m,n) / squarenorm_Mp_dev
      forall (k=1:3,l=1:3) &
        dLp_dMp(k,l,k,l) = dLp_dMp(k,l,k,l) + 1.0_pREAL
      forall (k=1:3,m=1:3) &
        dLp_dMp(k,k,m,m) = dLp_dMp(k,k,m,m) - 1.0_pREAL/3.0_pREAL
      dLp_dMp = dot_gamma * dLp_dMp / norm_Mp_dev
    else
      Lp = 0.0_pREAL
      dLp_dMp = 0.0_pREAL
    end if

  end associate

end subroutine isotropic_LpAndItsTangent


!--------------------------------------------------------------------------------------------------
!> @brief Calculate inelastic velocity gradient and its tangent.
!--------------------------------------------------------------------------------------------------
module subroutine plastic_isotropic_LiAndItsTangent(Li,dLi_dMi,Mi,ph,en)

  real(pREAL), dimension(3,3),     intent(out) :: &
    Li                                                                                              !< inleastic velocity gradient
  real(pREAL), dimension(3,3,3,3), intent(out)  :: &
    dLi_dMi                                                                                         !< derivative of Li with respect to Mandel stress

  real(pREAL), dimension(3,3), intent(in) :: &
    Mi                                                                                              !< Mandel stress
  integer,                     intent(in) :: &
    ph, &
    en

  real(pREAL) :: &
    tr                                                                                              !< trace of spherical part of Mandel stress (= 3 x pressure)
  integer :: &
    k, l, m, n


  associate(prm => param(ph), stt => state(ph))

    tr=math_trace33(math_spherical33(Mi))

    if (prm%dilatation .and. abs(tr) > 0.0_pREAL) then                                              ! no stress or J2 plasticity --> Li and its derivative are zero
      Li = math_I3 &
         * prm%dot_gamma_0 * (3.0_pREAL*prm%M*stt%xi(en))**(-prm%n) &
         * tr * abs(tr)**(prm%n-1.0_pREAL)
      forall (k=1:3,l=1:3,m=1:3,n=1:3) dLi_dMi(k,l,m,n) = prm%n / tr * Li(k,l) * math_I3(m,n)
    else
      Li      = 0.0_pREAL
      dLi_dMi = 0.0_pREAL
    end if

  end associate

 end subroutine plastic_isotropic_LiAndItsTangent


!--------------------------------------------------------------------------------------------------
!> @brief Calculate the rate of change of microstructure.
!--------------------------------------------------------------------------------------------------
module function isotropic_dotState(Mp,ph,en) result(dotState)

  real(pREAL), dimension(3,3),  intent(in) :: &
    Mp                                                                                              !< Mandel stress
  integer,                      intent(in) :: &
    ph, &
    en
  real(pREAL), dimension(plasticState(ph)%sizeDotState) :: &
    dotState

  real(pREAL) :: &
    dot_gamma, &                                                                                    !< strainrate
    xi_inf_star, &                                                                                  !< saturation xi
    norm_Mp                                                                                         !< norm of the (deviatoric) Mandel stress

  associate(prm => param(ph), stt => state(ph), dot_xi => dotState(1))

    norm_Mp = merge(sqrt(math_tensordot(Mp,Mp)), &
                    sqrt(math_tensordot(math_deviatoric33(Mp),math_deviatoric33(Mp))), &
                    prm%dilatation)

  dot_gamma = prm%dot_gamma_0 * (sqrt(1.5_pREAL) * norm_Mp /(prm%M*stt%xi(en))) **prm%n

  if (dot_gamma > 1e-12_pREAL) then
    if (dEq0(prm%c_1)) then
      xi_inf_star = prm%xi_inf
    else
      xi_inf_star = prm%xi_inf &
                  + asinh( (dot_gamma / prm%c_1)**(1.0_pREAL / prm%c_2))**(1.0_pREAL / prm%c_3) &
                  / prm%c_4 * (dot_gamma / prm%dot_gamma_0)**(1.0_pREAL / prm%n)
    end if
    dot_xi = dot_gamma &
           * ( prm%h_0 + prm%h_ln * log(dot_gamma) ) &
           * sign(abs(1.0_pREAL - stt%xi(en)/xi_inf_star)**prm%a *prm%h, 1.0_pREAL-stt%xi(en)/xi_inf_star)
  else
    dot_xi = 0.0_pREAL
  end if

  end associate

end function isotropic_dotState


!--------------------------------------------------------------------------------------------------
!> @brief Write results to HDF5 output file.
!--------------------------------------------------------------------------------------------------
module subroutine plastic_isotropic_result(ph,group)

  integer,          intent(in) :: ph
  character(len=*), intent(in) :: group

  integer :: o

  associate(prm => param(ph), stt => state(ph))
  outputsLoop: do o = 1,size(prm%output)
    select case(trim(prm%output(o)))
      case ('xi')
        call result_writeDataset(stt%xi,group,trim(prm%output(o)), &
                                 'resistance against plastic flow','Pa')
    end select
  end do outputsLoop
  end associate

end subroutine plastic_isotropic_result


end submodule isotropic

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author Christoph Kords, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Mathematical library, including random number generation and tensor representations
!--------------------------------------------------------------------------------------------------
#ifdef PETSC
#include <petsc/finclude/petscsys.h>
#endif
module math
#ifdef PETSC
  use PETScSys
#ifndef PETSC_EXPOSES_MPI
  use MPI_f08
#endif
#endif

  use prec
  use misc
  use IO
  use config
  use types
  use parallelization
  use LAPACK_interface


  implicit none(type,external)
  public

  interface math_expand
    module procedure math_expand_int
    module procedure math_expand_real
  end interface math_expand

  real(pREAL), parameter :: &
    PI = acos(-1.0_pREAL), &                                                                        !< ratio of a circle's circumference to its diameter
    TAU = 2.0_pREAL*PI, &                                                                           !< ratio of a circle's circumference to its radius
    INDEG = 360.0_pREAL/TAU, &                                                                      !< conversion from radian to degree
    INRAD = TAU/360.0_pREAL                                                                         !< conversion from degree to radian

  real(pREAL), dimension(3,3), parameter :: &
    math_I3 = real(reshape([&
      1, 0, 0, &
      0, 1, 0, &
      0, 0, 1  &
      ],shape(math_I3)),pREAL)                                                                      !< 3x3 Identity

  real(pREAL), dimension(*), parameter, private :: &
    NRMMANDEL = [1.0_pREAL, 1.0_pREAL,1.0_pREAL, sqrt(2.0_pREAL), sqrt(2.0_pREAL), sqrt(2.0_pREAL)] !< forward weighting for Mandel notation

  real(pREAL), dimension(*), parameter, private :: &
    INVNRMMANDEL = 1.0_pREAL/NRMMANDEL                                                              !< backward weighting for Mandel notation

  integer, dimension (2,6), parameter, private :: &
    MAPVOIGT = reshape([&
      1,1, &
      2,2, &
      3,3, &
      2,3, &
      1,3, &
      1,2  &
      ],shape(MAPVOIGT))                                                                            !< arrangement in Voigt notation


contains

!--------------------------------------------------------------------------------------------------
!> @brief Report random state and do self test.
!--------------------------------------------------------------------------------------------------
subroutine math_init()

  real(pREAL), dimension(4) :: randTest
  integer :: randSize
  integer, dimension(:), allocatable :: seed
  type(tDict), pointer :: &
    num_generic


  print'(/,1x,a)', '<<<+-  math init  -+>>>'; flush(IO_STDOUT)

  num_generic => config_numerics%get_dict('generic',defaultVal=emptyDict)

  call random_seed(size=randSize)
  allocate(seed(randSize))

  if (num_generic%contains('random_seed')) then
    seed = num_generic%get_as1dInt('random_seed',requiredSize=randSize) &
         + worldrank*42_MPI_INTEGER_KIND
  else
    call random_init(.false.,.false.)
    call random_seed(get = seed)
  end if

  call random_seed(put = seed)
  call random_number(randTest)

  print'(/,a,i2)',              ' size  of random seed:     ', randSize
  print*,                       'value of random seed:     ', seed
  print'(  a,4(/,26x,f17.14))', ' start of random sequence: ', randTest

  call math_selfTest()

end subroutine math_init


!--------------------------------------------------------------------------------------------------
!> @brief Sorting of two-dimensional integer arrays
!> @details Based on quicksort.
!  Sorting is done with respect to array(sortDim,:) and keeps array(/=sortDim,:) linked to it.
!  Default: sortDim=1
!--------------------------------------------------------------------------------------------------
pure recursive subroutine math_sort(a, iStart, iEnd, sortDim)

  integer, dimension(:,:), intent(inout) :: a
  integer,       optional, intent(in)    :: iStart,iEnd, sortDim

  integer :: iPivot,s,e,d


  s = misc_optional(iStart,lbound(a,2))
  e = misc_optional(iEnd,ubound(a,2))
  d = misc_optional(sortDim,1)

  if (s < e) then
    call qsort_partition(a,iPivot, s,e, d)
    call math_sort(a, s, iPivot-1, d)
    call math_sort(a, iPivot+1, e, d)
  end if


  contains

  !-------------------------------------------------------------------------------------------------
  !> @brief Partitioning required for quicksort
  !-------------------------------------------------------------------------------------------------
  pure subroutine qsort_partition(a,p, istart, iend, sort)
#ifndef __GFORTRAN__
    import, none
#endif
    integer, dimension(:,:), intent(inout) :: a
    integer,                 intent(out)   :: p                                                     ! Pivot element
    integer,                 intent(in)    :: istart,iend,sort

    integer, dimension(size(a,1)) :: tmp
    integer :: i,j


    do
      ! find the first element on the right side less than or equal to the pivot point
      do j = iend, istart, -1
        if (a(sort,j) <= a(sort,istart)) exit
      end do
      ! find the first element on the left side greater than the pivot point
      do i = istart, iend
        if (a(sort,i) > a(sort,istart)) exit
      end do
      cross: if (i >= j) then ! exchange left value with pivot and return with the partition index
        tmp         = a(:,istart)
        a(:,istart) = a(:,j)
        a(:,j)      = tmp
        p           = j
        return
      else cross              ! exchange values
        tmp    = a(:,i)
        a(:,i) = a(:,j)
        a(:,j) = tmp
      end if cross
    end do

  end subroutine qsort_partition

end subroutine math_sort


!--------------------------------------------------------------------------------------------------
!> @brief vector expansion
!> @details takes a set of numbers (a,b,c,...) and corresponding multiples (x,y,z,...)
!> to return a vector of x times a, y times b, z times c, ...
!> If there are more multiples than numbers, the numbers are treated as a ring, i.e. looped modulo their size
!--------------------------------------------------------------------------------------------------
pure function math_expand_int(what,how)

  integer, dimension(:), intent(in) :: what
  integer, dimension(:), intent(in) :: how
  integer, dimension(sum(how))      :: math_expand_int

  integer :: i


  if (sum(how) == 0) return

  do i = 1, size(how)
    math_expand_int(sum(how(1:i-1))+1:sum(how(1:i))) = what(mod(i-1,size(what))+1)
  end do

end function math_expand_int


!--------------------------------------------------------------------------------------------------
!> @brief vector expansion
!> @details takes a set of numbers (a,b,c,...) and corresponding multiples (x,y,z,...)
!> to return a vector of x times a, y times b, z times c, ...
!> If there are more multiples than numbers, the numbers are treated as a ring, i.e. looped modulo their size
!--------------------------------------------------------------------------------------------------
pure function math_expand_real(what,how)

  real(pREAL), dimension(:), intent(in) :: what
  integer,     dimension(:), intent(in) :: how
  real(pREAL), dimension(sum(how))      :: math_expand_real

  integer :: i


  if (sum(how) == 0) return

  do i = 1, size(how)
    math_expand_real(sum(how(1:i-1))+1:sum(how(1:i))) = what(mod(i-1,size(what))+1)
  end do

end function math_expand_real


!--------------------------------------------------------------------------------------------------
!> @brief range of integers starting at one
!--------------------------------------------------------------------------------------------------
pure function math_range(N)

  integer, intent(in) :: N                                                                          !< length of range
  integer, dimension(N) :: math_range

  integer :: i


  math_range = [(i,i=1,N)]

end function math_range


!--------------------------------------------------------------------------------------------------
!> @brief Rank two identity tensor of specified dimension.
!--------------------------------------------------------------------------------------------------
pure function math_eye(d)

  integer, intent(in) :: d                                                                          !< tensor dimension
  real(pREAL), dimension(d,d) :: math_eye

  integer :: i


  math_eye = 0.0_pREAL
  do i=1,d
    math_eye(i,i) = 1.0_pREAL
  end do

end function math_eye


!--------------------------------------------------------------------------------------------------
!> @brief Symmetric rank four identity tensor.
!  from http://en.wikipedia.org/wiki/Tensor_derivative_(continuum_mechanics)#Derivative_of_a_second-order_tensor_with_respect_to_itself
!--------------------------------------------------------------------------------------------------
pure function math_identity4th()

  real(pREAL), dimension(3,3,3,3) :: math_identity4th

  integer :: i,j,k,l


  do l=1,3; do k=1,3; do j=1,3; do i=1,3
    math_identity4th(i,j,k,l) = 0.5_pREAL*(math_I3(i,k)*math_I3(j,l)+math_I3(i,l)*math_I3(j,k))
  end do; end do; end do; end do

end function math_identity4th


!--------------------------------------------------------------------------------------------------
!> @brief permutation tensor e_ijk
! e_ijk =  1 if even permutation of ijk
! e_ijk = -1 if odd permutation of ijk
! e_ijk =  0 otherwise
!--------------------------------------------------------------------------------------------------
real(pREAL) pure function math_LeviCivita(i,j,k)

  integer, intent(in) :: i,j,k

  integer :: o


  if     (any([(all(cshift([i,j,k],o) == [1,2,3]),o=0,2)])) then
    math_LeviCivita = +1.0_pREAL
  elseif (any([(all(cshift([i,j,k],o) == [3,2,1]),o=0,2)])) then
    math_LeviCivita = -1.0_pREAL
  else
    math_LeviCivita =  0.0_pREAL
  end if

end function math_LeviCivita


!--------------------------------------------------------------------------------------------------
!> @brief kronecker delta function d_ij
! d_ij = 1 if i = j
! d_ij = 0 otherwise
!--------------------------------------------------------------------------------------------------
real(pREAL) pure function math_delta(i,j)

  integer, intent (in) :: i,j


  math_delta = merge(0.0_pREAL, 1.0_pREAL, i /= j)

end function math_delta


!--------------------------------------------------------------------------------------------------
!> @brief cross product a x b
!--------------------------------------------------------------------------------------------------
pure function math_cross(A,B)

  real(pREAL), dimension(3), intent(in) ::  A,B
  real(pREAL), dimension(3) :: math_cross


  math_cross = [ A(2)*B(3) -A(3)*B(2), &
                 A(3)*B(1) -A(1)*B(3), &
                 A(1)*B(2) -A(2)*B(1) ]

end function math_cross


!--------------------------------------------------------------------------------------------------
!> @brief Outer product of arbitrary sized vectors (A ⊗ B / i,j).
!--------------------------------------------------------------------------------------------------
pure function math_outer(A,B)

  real(pREAL), dimension(:), intent(in) ::  A,B
  real(pREAL), dimension(size(A,1),size(B,1)) ::  math_outer

  integer :: i,j


  do j=1,size(B,1); do i=1,size(A,1)
    math_outer(i,j) = A(i)*B(j)
  end do; end do

end function math_outer


!--------------------------------------------------------------------------------------------------
!> @brief Inner product of arbitrary sized vectors (A · B / i,i).
!--------------------------------------------------------------------------------------------------
real(pREAL) pure function math_inner(A,B)

  real(pREAL), dimension(:),         intent(in) :: A
  real(pREAL), dimension(size(A,1)), intent(in) :: B


  math_inner = sum(A*B)

end function math_inner


!--------------------------------------------------------------------------------------------------
!> @brief Double contraction of 3x3 matrices (A : B / ij,ij).
!--------------------------------------------------------------------------------------------------
real(pREAL) pure function math_tensordot(A,B)

  real(pREAL), dimension(3,3), intent(in) :: A,B


  math_tensordot = sum(A*B)

end function math_tensordot


!--------------------------------------------------------------------------------------------------
!> @brief Matrix double contraction 3333x33 = 33 (ijkl,kl).
!--------------------------------------------------------------------------------------------------
pure function math_mul3333xx33(A,B)

  real(pREAL), dimension(3,3,3,3), intent(in) :: A
  real(pREAL), dimension(3,3),     intent(in) :: B
  real(pREAL), dimension(3,3) :: math_mul3333xx33

  integer :: i,j


  do j=1,3; do i=1,3
    math_mul3333xx33(i,j) = sum(A(i,j,1:3,1:3)*B(1:3,1:3))
  end do; end do

end function math_mul3333xx33


!--------------------------------------------------------------------------------------------------
!> @brief matrix multiplication 3333x3333 = 3333 (ijkl,klmn)
!--------------------------------------------------------------------------------------------------
pure function math_mul3333xx3333(A,B)

  real(pREAL), dimension(3,3,3,3), intent(in) :: A
  real(pREAL), dimension(3,3,3,3), intent(in) :: B
  real(pREAL), dimension(3,3,3,3) :: math_mul3333xx3333

  integer :: i,j,k,l


  do l=1,3; do k=1,3; do j=1,3; do i=1,3
    math_mul3333xx3333(i,j,k,l) = sum(A(i,j,1:3,1:3)*B(1:3,1:3,k,l))
  end do; end do; end do; end do

end function math_mul3333xx3333


!--------------------------------------------------------------------------------------------------
!> @brief 3x3 matrix exponential up to series approximation order n (default 5)
!--------------------------------------------------------------------------------------------------
pure function math_exp33(A,n)

  real(pREAL), dimension(3,3), intent(in) :: A
  integer,                     intent(in), optional :: n
  real(pREAL), dimension(3,3) :: B, math_exp33

  real(pREAL) :: invFac
  integer     :: i


  invFac     = 1.0_pREAL                                                                            ! 0!
  B          = math_I3
  math_exp33 = math_I3                                                                              ! A^0 = I

  do i = 1, misc_optional(n,5)
    invFac = invFac/real(i,pREAL)                                                                   ! invfac = 1/(i!)
    B = matmul(B,A)
    math_exp33 = math_exp33 + invFac*B                                                              ! exp = SUM (A^i)/(i!)
  end do

end function math_exp33


!--------------------------------------------------------------------------------------------------
!> @brief Cramer inversion of 3x3 matrix (function)
!> @details Direct Cramer inversion of matrix A. Returns all zeroes if not possible, i.e.
! if determinant is close to zero
!--------------------------------------------------------------------------------------------------
pure function math_inv33(A)

  real(pREAL), dimension(3,3), intent(in) :: A
  real(pREAL), dimension(3,3) :: math_inv33

  logical     :: error


  call math_invert33(math_inv33,error=error,A=A)
  if (error) math_inv33 = 0.0_pREAL

end function math_inv33


!--------------------------------------------------------------------------------------------------
!> @brief Cramer inversion of 3x3 matrix (subroutine)
!> @details Direct Cramer inversion of matrix A. Also returns determinant
!  Returns an error if not possible, i.e. if determinant is close to zero
!--------------------------------------------------------------------------------------------------
pure subroutine math_invert33(InvA,DetA,error, A)

  real(pREAL), dimension(3,3), intent(out) :: InvA
  real(pREAL),                 intent(out), optional :: DetA
  logical,                     intent(out) :: error
  real(pREAL), dimension(3,3), intent(in)  :: A

  real(pREAL) :: Det


  InvA(1,1) =  A(2,2) * A(3,3) - A(2,3) * A(3,2)
  InvA(2,1) = -A(2,1) * A(3,3) + A(2,3) * A(3,1)
  InvA(3,1) =  A(2,1) * A(3,2) - A(2,2) * A(3,1)

  Det = A(1,1) * InvA(1,1) + A(1,2) * InvA(2,1) + A(1,3) * InvA(3,1)

  if (dEq0(Det)) then
    InvA = 0.0_pREAL
    if (present(DetA)) DetA = 0.0_pREAL
    error = .true.
  else
    InvA(1,2) = -A(1,2) * A(3,3) + A(1,3) * A(3,2)
    InvA(2,2) =  A(1,1) * A(3,3) - A(1,3) * A(3,1)
    InvA(3,2) = -A(1,1) * A(3,2) + A(1,2) * A(3,1)

    InvA(1,3) =  A(1,2) * A(2,3) - A(1,3) * A(2,2)
    InvA(2,3) = -A(1,1) * A(2,3) + A(1,3) * A(2,1)
    InvA(3,3) =  A(1,1) * A(2,2) - A(1,2) * A(2,1)

    InvA = InvA/Det
    if (present(DetA)) DetA = Det
    error = .false.
  end if

end subroutine math_invert33


!--------------------------------------------------------------------------------------------------
!> @brief Invert symmetriced 3x3x3x3 matrix.
!--------------------------------------------------------------------------------------------------
pure function math_invSym3333(A)

  real(pREAL),dimension(3,3,3,3) :: math_invSym3333

  real(pREAL),dimension(3,3,3,3),intent(in) :: A

  integer,     dimension(6)   :: ipiv6
  real(pREAL), dimension(6,6) :: temp66
  real(pREAL), dimension(6*6) :: work
  integer                     :: ierr_i, ierr_f


  temp66 = math_sym3333to66(A)
  call dgetrf(6,6,temp66,6,ipiv6,ierr_i)
  call dgetri(6,temp66,6,ipiv6,work,size(work),ierr_f)
  if (ierr_i /= 0 .or. ierr_f /= 0) then
    error stop 'matrix inversion error'
  else
    math_invSym3333 = math_66toSym3333(temp66)
  end if

end function math_invSym3333


!--------------------------------------------------------------------------------------------------
!> @brief Invert quadratic matrix of arbitrary dimension.
!--------------------------------------------------------------------------------------------------
pure subroutine math_invert(InvA, error, A)

  real(pREAL), dimension(:,:),                 intent(in)  :: A
  real(pREAL), dimension(size(A,1),size(A,1)), intent(out) :: invA
  logical,                                     intent(out) :: error

  integer,     dimension(size(A,1))    :: ipiv
  real(pREAL), dimension(size(A,1)**2) :: work
  integer                              :: ierr


  invA = A
  call dgetrf(size(A,1),size(A,1),invA,size(A,1),ipiv,ierr)
  error = (ierr /= 0)
  call dgetri(size(A,1),InvA,size(A,1),ipiv,work,size(work),ierr)
  error = error .or. (ierr /= 0)

end subroutine math_invert


!--------------------------------------------------------------------------------------------------
!> @brief Symmetrize a 3x3 matrix.
!--------------------------------------------------------------------------------------------------
pure function math_symmetric33(m)

  real(pREAL), dimension(3,3) :: math_symmetric33
  real(pREAL), dimension(3,3), intent(in) :: m


  math_symmetric33 = 0.5_pREAL * (m + transpose(m))

end function math_symmetric33


!--------------------------------------------------------------------------------------------------
!> @brief Calculate skew part of a 3x3 matrix.
!--------------------------------------------------------------------------------------------------
pure function math_skew33(m)

  real(pREAL), dimension(3,3) :: math_skew33
  real(pREAL), dimension(3,3), intent(in) :: m


  math_skew33 = m - math_symmetric33(m)

end function math_skew33


!--------------------------------------------------------------------------------------------------
!> @brief Calculate hydrostatic part of a 3x3 matrix.
!--------------------------------------------------------------------------------------------------
pure function math_spherical33(m)

  real(pREAL), dimension(3,3) :: math_spherical33
  real(pREAL), dimension(3,3), intent(in) :: m


  math_spherical33 = math_I3 * math_trace33(m)/3.0_pREAL

end function math_spherical33


!--------------------------------------------------------------------------------------------------
!> @brief Calculate deviatoric part of a 3x3 matrix.
!--------------------------------------------------------------------------------------------------
pure function math_deviatoric33(m)

  real(pREAL), dimension(3,3) :: math_deviatoric33
  real(pREAL), dimension(3,3), intent(in) :: m


  math_deviatoric33 = m - math_spherical33(m)

end function math_deviatoric33


!--------------------------------------------------------------------------------------------------
!> @brief Calculate trace of a 3x3 matrix.
!--------------------------------------------------------------------------------------------------
real(pREAL) pure function math_trace33(m)

  real(pREAL), dimension(3,3), intent(in) :: m


  math_trace33 = m(1,1) + m(2,2) + m(3,3)

end function math_trace33


!--------------------------------------------------------------------------------------------------
!> @brief Calculate determinant of a 3x3 matrix.
!--------------------------------------------------------------------------------------------------
real(pREAL) pure function math_det33(m)

  real(pREAL), dimension(3,3), intent(in) :: m


  math_det33 = m(1,1)* (m(2,2)*m(3,3)-m(2,3)*m(3,2)) &
             - m(1,2)* (m(2,1)*m(3,3)-m(2,3)*m(3,1)) &
             + m(1,3)* (m(2,1)*m(3,2)-m(2,2)*m(3,1))

end function math_det33


!--------------------------------------------------------------------------------------------------
!> @brief Calculate determinant of a symmetric 3x3 matrix.
!--------------------------------------------------------------------------------------------------
real(pREAL) pure function math_detSym33(m)

  real(pREAL), dimension(3,3), intent(in) :: m


  math_detSym33 = -(m(1,1)*m(2,3)**2 + m(2,2)*m(1,3)**2 + m(3,3)*m(1,2)**2) &
                  + m(1,1)*m(2,2)*m(3,3) + 2.0_pREAL * m(1,2)*m(1,3)*m(2,3)

end function  math_detSym33


!--------------------------------------------------------------------------------------------------
!> @brief Calculate determinant of a matrix of arbitrary dimension.
!--------------------------------------------------------------------------------------------------
real(pREAL) pure function math_det(A)

  real(pREAL), dimension(:,:), intent(in)  :: A

  real(pREAL), dimension(size(A,1),size(A,1)) :: U
  integer,     dimension(size(A,1))           :: ipiv
  integer                                     :: ierr, i


  U = A
  call dgetrf(size(A,1),size(A,1),U,size(A,1),ipiv,ierr)
  if (ierr /= 0) error stop 'LU decomposition failed'

  math_det = product([(U(i,i) * merge(1.0_pREAL,-1.0_pREAL,ipiv(i)==i),i=1,size(A,1))])

end function math_det


!--------------------------------------------------------------------------------------------------
!> @brief Convert 3x3 matrix into 9 vector.
!--------------------------------------------------------------------------------------------------
pure function math_33to9(m33)

  real(pREAL), dimension(9)               :: math_33to9
  real(pREAL), dimension(3,3), intent(in) :: m33


  math_33to9 = reshape(transpose(m33), [9])

end function math_33to9


!--------------------------------------------------------------------------------------------------
!> @brief Convert 9 vector into 3x3 matrix.
!--------------------------------------------------------------------------------------------------
pure function math_9to33(v9)

  real(pREAL), dimension(3,3)           :: math_9to33
  real(pREAL), dimension(9), intent(in) :: v9


  math_9to33 = transpose(reshape(v9, [3,3]))

end function math_9to33


!--------------------------------------------------------------------------------------------------
!> @brief Convert 3x3x3x3 matrix into 9x9 matrix.
!--------------------------------------------------------------------------------------------------
pure function math_3333to99(m3333)

  real(pREAL), dimension(9,9)                 :: math_3333to99
  real(pREAL), dimension(3,3,3,3), intent(in) :: m3333


  math_3333to99 = reshape(reshape(m3333, [3,3,3,3], order=[2,1,4,3]), [9,9])

end function math_3333to99


!--------------------------------------------------------------------------------------------------
!> @brief Convert 9x9 matrix into 3x3x3x3 matrix.
!--------------------------------------------------------------------------------------------------
pure function math_99to3333(m99)

  real(pREAL), dimension(3,3,3,3)         :: math_99to3333
  real(pREAL), dimension(9,9), intent(in) :: m99


  math_99to3333 = reshape(reshape(m99, [3,3,3,3]), [3,3,3,3], order=[2,1,4,3])

end function math_99to3333


!--------------------------------------------------------------------------------------------------
!> @brief Convert symmetric 3x3x3x3 matrix into 6x6 matrix.
!> @details Uses Mandel convention.
!--------------------------------------------------------------------------------------------------
pure function math_sym3333to66(m) result(m_tilde)

  real(pREAL), dimension(6,6)                 :: m_tilde
  real(pREAL), dimension(3,3,3,3), intent(in) :: m                                                  !< symmetric 3x3x3x3 matrix (no internal check)

  integer :: i,j


  do i=1,6; do j=1,6
    m_tilde(i,j) = NRMMANDEL(i)*NRMMANDEL(j)*m(MAPVOIGT(1,i),MAPVOIGT(2,i),MAPVOIGT(1,j),MAPVOIGT(2,j))
  end do; end do

end function math_sym3333to66


!--------------------------------------------------------------------------------------------------
!> @brief Convert 6x6 matrix into symmetric 3x3x3x3 matrix.
!> @details Uses Mandel convention.
!--------------------------------------------------------------------------------------------------
pure function math_66toSym3333(m_tilde) result(m)

  real(pREAL), dimension(3,3,3,3)            :: m
  real(pREAL), dimension(6,6),    intent(in) :: m_tilde                                             !< 6x6 matrix

  integer :: i,j


  do i=1,6; do j=1,6
    m(MAPVOIGT(1,i),MAPVOIGT(2,i),MAPVOIGT(1,j),MAPVOIGT(2,j)) = INVNRMMANDEL(i)*INVNRMMANDEL(j)*m_tilde(i,j)
    m(MAPVOIGT(2,i),MAPVOIGT(1,i),MAPVOIGT(1,j),MAPVOIGT(2,j)) = INVNRMMANDEL(i)*INVNRMMANDEL(j)*m_tilde(i,j)
    m(MAPVOIGT(1,i),MAPVOIGT(2,i),MAPVOIGT(2,j),MAPVOIGT(1,j)) = INVNRMMANDEL(i)*INVNRMMANDEL(j)*m_tilde(i,j)
    m(MAPVOIGT(2,i),MAPVOIGT(1,i),MAPVOIGT(2,j),MAPVOIGT(1,j)) = INVNRMMANDEL(i)*INVNRMMANDEL(j)*m_tilde(i,j)
  end do; end do

end function math_66toSym3333


!--------------------------------------------------------------------------------------------------
!> @brief Convert 6 Voigt stress vector into symmetric 3x3 tensor.
!--------------------------------------------------------------------------------------------------
pure function math_Voigt6to33_stress(sigma_tilde) result(sigma)

  real(pREAL), dimension(3,3) :: sigma
  real(pREAL), dimension(6), intent(in) :: sigma_tilde


  sigma = reshape([sigma_tilde(1), sigma_tilde(6), sigma_tilde(5), &
                   sigma_tilde(6), sigma_tilde(2), sigma_tilde(4), &
                   sigma_tilde(5), sigma_tilde(4), sigma_tilde(3)],[3,3])

end function math_Voigt6to33_stress


!--------------------------------------------------------------------------------------------------
!> @brief Convert 6 Voigt strain vector into symmetric 3x3 tensor.
!--------------------------------------------------------------------------------------------------
pure function math_Voigt6to33_strain(epsilon_tilde) result(epsilon)

  real(pREAL), dimension(3,3) :: epsilon
  real(pREAL), dimension(6), intent(in) :: epsilon_tilde


  epsilon = reshape([          epsilon_tilde(1), 0.5_pREAL*epsilon_tilde(6), 0.5_pREAL*epsilon_tilde(5), &
                     0.5_pREAL*epsilon_tilde(6),           epsilon_tilde(2), 0.5_pREAL*epsilon_tilde(4), &
                     0.5_pREAL*epsilon_tilde(5), 0.5_pREAL*epsilon_tilde(4),           epsilon_tilde(3)],[3,3])

end function math_Voigt6to33_strain


!--------------------------------------------------------------------------------------------------
!> @brief Convert 3x3 stress tensor into 6 Voigt vector.
!--------------------------------------------------------------------------------------------------
pure function math_33toVoigt6_stress(sigma) result(sigma_tilde)

  real(pREAL), dimension(6) :: sigma_tilde
  real(pREAL), dimension(3,3), intent(in) :: sigma


  sigma_tilde = [sigma(1,1), sigma(2,2), sigma(3,3), &
                 sigma(3,2), sigma(3,1), sigma(1,2)]

end function math_33toVoigt6_stress


!--------------------------------------------------------------------------------------------------
!> @brief Convert 3x3 strain tensor into 6 Voigt vector.
!--------------------------------------------------------------------------------------------------
pure function math_33toVoigt6_strain(epsilon) result(epsilon_tilde)

  real(pREAL), dimension(6) :: epsilon_tilde
  real(pREAL), dimension(3,3), intent(in) :: epsilon


  epsilon_tilde = [          epsilon(1,1),           epsilon(2,2),           epsilon(3,3), &
                   2.0_pREAL*epsilon(3,2), 2.0_pREAL*epsilon(3,1), 2.0_pREAL*epsilon(1,2)]

end function math_33toVoigt6_strain



!--------------------------------------------------------------------------------------------------
!> @brief Convert 6x6 Voigt stiffness matrix into symmetric 3x3x3x3 tensor.
!--------------------------------------------------------------------------------------------------
pure function math_Voigt66to3333_stiffness(C_tilde) result(C)

  real(pREAL), dimension(3,3,3,3) :: C
  real(pREAL), dimension(6,6), intent(in) :: C_tilde

  integer :: i,j


  do i=1,6; do j=1,6
    C(MAPVOIGT(1,i),MAPVOIGT(2,i),MAPVOIGT(1,j),MAPVOIGT(2,j)) = C_tilde(i,j)
    C(MAPVOIGT(2,i),MAPVOIGT(1,i),MAPVOIGT(1,j),MAPVOIGT(2,j)) = C_tilde(i,j)
    C(MAPVOIGT(1,i),MAPVOIGT(2,i),MAPVOIGT(2,j),MAPVOIGT(1,j)) = C_tilde(i,j)
    C(MAPVOIGT(2,i),MAPVOIGT(1,i),MAPVOIGT(2,j),MAPVOIGT(1,j)) = C_tilde(i,j)
  end do; end do

end function math_Voigt66to3333_stiffness


!--------------------------------------------------------------------------------------------------
!> @brief Convert 3x3x3x3 stiffness tensor into 6x6 Voigt matrix.
!--------------------------------------------------------------------------------------------------
pure function math_3333toVoigt66_stiffness(C) result(C_tilde)

  real(pREAL), dimension(6,6) :: C_tilde
  real(pREAL), dimension(3,3,3,3), intent(in) :: C

  integer :: i,j


#ifndef __INTEL_COMPILER
  do concurrent(i=1:6, j=1:6)
    C_tilde(i,j) = C(MAPVOIGT(1,i),MAPVOIGT(2,i),MAPVOIGT(1,j),MAPVOIGT(2,j))
  end do
#else
  forall(i=1:6, j=1:6) C_tilde(i,j) = C(MAPVOIGT(1,i),MAPVOIGT(2,i),MAPVOIGT(1,j),MAPVOIGT(2,j))
#endif

end function math_3333toVoigt66_stiffness


!--------------------------------------------------------------------------------------------------
!> @brief Draw a sample from a normal distribution.
!> @details https://en.wikipedia.org/wiki/Box%E2%80%93Muller_transform
!>          https://masuday.github.io/fortran_tutorial/random.html
!--------------------------------------------------------------------------------------------------
impure elemental subroutine math_normal(x,mu,sigma)

  real(pREAL), intent(out) :: x
  real(pREAL), intent(in), optional :: mu, sigma

  real(pREAL), dimension(2) :: rnd


  call random_number(rnd)
  x = misc_optional(mu,0.0_pREAL) &
    + misc_optional(sigma,1.0_pREAL) * sqrt(-2.0_pREAL*log(1.0_pREAL-rnd(1)))*cos(TAU*(1.0_pREAL - rnd(2)))

end subroutine math_normal


!--------------------------------------------------------------------------------------------------
!> @brief Calculate eigenvalues and eigenvectors of symmetric matrix.
!--------------------------------------------------------------------------------------------------
pure subroutine math_eigh(w,v,error,m)

  real(pREAL), dimension(:,:),                  intent(in)  :: m                                    !< quadratic matrix to compute eigenvectors and values of
  real(pREAL), dimension(size(m,1)),            intent(out) :: w                                    !< eigenvalues
  real(pREAL), dimension(size(m,1),size(m,1)),  intent(out) :: v                                    !< eigenvectors
  logical,                                      intent(out) :: error

  integer :: ierr
  real(pREAL), dimension(size(m,1)**2) :: work


  v = m                                                                                             ! copy matrix to input (doubles as output) array
  call dsyev('V','U',size(m,1),v,size(m,1),w,work,size(work,1),ierr)
  error = (ierr /= 0)

end subroutine math_eigh


!--------------------------------------------------------------------------------------------------
!> @brief eigenvalues and eigenvectors of symmetric 3x3 matrix using an analytical expression
!> and the general LAPACK powered version for arbritrary sized matrices as fallback
!> @author Joachim Kopp, Max-Planck-Institut für Kernphysik, Heidelberg (Copyright (C) 2006)
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @details See http://arxiv.org/abs/physics/0610206 (DSYEVH3)
!--------------------------------------------------------------------------------------------------
pure subroutine math_eigh33(w,v,m)

  real(pREAL), dimension(3,3),intent(in)  :: m                                                      !< 3x3 matrix to compute eigenvectors and values of
  real(pREAL), dimension(3),  intent(out) :: w                                                      !< eigenvalues
  real(pREAL), dimension(3,3),intent(out) :: v                                                      !< eigenvectors

  real(pREAL) :: T, U, norm, threshold
  logical :: error


  w = math_eigvalsh33(m)

  v(1:3,2) = [ m(1,2) * m(2,3) - m(1,3) * m(2,2), &
               m(1,3) * m(1,2) - m(2,3) * m(1,1), &
               m(1,2)**2]

  T = maxval(abs(w))
  U = max(T, T**2)
  threshold = max(sqrt(5.68e-14_pREAL * U**2),PREAL_MIN)

  v(1:3,1) = [m(1,3)*w(1) + v(1,2), &
              m(2,3)*w(1) + v(2,2), &
              (m(1,1) - w(1)) * (m(2,2) - w(1)) - v(3,2)]
  norm = norm2(v(1:3, 1))
  fallback1: if (norm < threshold) then
    call math_eigh(w,v,error,m)
  else fallback1
    v(1:3,1) = v(1:3, 1) / norm
    v(1:3,2) = [m(1,3)*w(2) + v(1,2), &
                m(2,3)*w(2) + v(2,2), &
                (m(1,1) - w(2)) * (m(2,2) - w(2)) - v(3,2)]
    norm = norm2(v(1:3, 2))
    fallback2: if (norm < threshold) then
      call math_eigh(w,v,error,m)
    else fallback2
      v(1:3,2) = v(1:3, 2) / norm
      v(1:3,3) = math_cross(v(1:3,1),v(1:3,2))
     end if fallback2
  end if fallback1

end subroutine math_eigh33


!--------------------------------------------------------------------------------------------------
!> @brief Calculate rotational part of a deformation gradient.
!> @details https://www.jstor.org/stable/43637254
!!          https://www.jstor.org/stable/43637372
!!          https://doi.org/10.1023/A:1007407802076
!--------------------------------------------------------------------------------------------------
pure function math_rotationalPart(F) result(R)

  real(pREAL), dimension(3,3), intent(in) :: &
    F                                                                                               ! deformation gradient
  real(pREAL), dimension(3,3) :: &
    C, &                                                                                            ! right Cauchy-Green tensor
    R                                                                                               ! rotational part
  real(pREAL), dimension(3) :: &
    lambda, &                                                                                       ! principal stretches
    I_C, &                                                                                          ! invariants of C
    I_U                                                                                             ! invariants of U
  real(pREAL), dimension(2) :: &
    I_F                                                                                             ! first two invariants of F
  real(pREAL) :: x,Phi


  C = matmul(transpose(F),F)
  I_C = math_invariantsSym33(C)
  I_F = [math_trace33(F), 0.5_pREAL*(math_trace33(F)**2 - math_trace33(matmul(F,F)))]

  x = math_clip(I_C(1)**2 -3.0_pREAL*I_C(2),0.0_pREAL)**(3.0_pREAL/2.0_pREAL)
  if (dNeq0(x)) then
    Phi = acos(math_clip((I_C(1)**3 -4.5_pREAL*I_C(1)*I_C(2) +13.5_pREAL*I_C(3))/x,-1.0_pREAL,1.0_pREAL))
    lambda = I_C(1) +(2.0_pREAL * sqrt(math_clip(I_C(1)**2-3.0_pREAL*I_C(2),0.0_pREAL))) &
                    *cos((Phi-TAU*[1.0_pREAL,2.0_pREAL,3.0_pREAL])/3.0_pREAL)
    lambda = sqrt(math_clip(lambda,0.0_pREAL)/3.0_pREAL)
  else
    lambda = sqrt(I_C(1)/3.0_pREAL)
  end if

  I_U = [sum(lambda), lambda(1)*lambda(2)+lambda(2)*lambda(3)+lambda(3)*lambda(1), product(lambda)]

  R = I_U(1)*I_F(2) * math_I3 &
    +(I_U(1)**2-I_U(2)) * F &
    - I_U(1)*I_F(1) * transpose(F) &
    + I_U(1) * transpose(matmul(F,F)) &
    - matmul(F,C)
  R = R*math_det33(R)**(-1.0_pREAL/3.0_pREAL)

end function math_rotationalPart


!--------------------------------------------------------------------------------------------------
!> @brief Calculate eigenvalues of symmetric matrix.
! will return NaN on error
!--------------------------------------------------------------------------------------------------
pure function math_eigvalsh(m)

  real(pREAL), dimension(:,:),                  intent(in)  :: m                                    !< symmetric matrix to compute eigenvalues of
  real(pREAL), dimension(size(m,1))                         :: math_eigvalsh

  real(pREAL), dimension(size(m,1),size(m,1))               :: m_
  integer :: ierr
  real(pREAL), dimension(size(m,1)**2) :: work


  m_ = m                                                                                            ! m_ will be destroyed
  call dsyev('N','U',size(m,1),m_,size(m,1),math_eigvalsh,work,size(work),ierr)
  if (ierr /= 0) math_eigvalsh = IEEE_value(1.0_pREAL,IEEE_quiet_NaN)

end function math_eigvalsh


!--------------------------------------------------------------------------------------------------
!> @brief eigenvalues of symmetric 3x3 matrix using an analytical expression
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @details similar to http://arxiv.org/abs/physics/0610206 (DSYEVC3)
!> but apparently more stable solution and has general LAPACK powered version for arbritrary sized
!> matrices as fallback
!--------------------------------------------------------------------------------------------------
pure function math_eigvalsh33(m)

  real(pREAL), intent(in), dimension(3,3) :: m                                                      !< 3x3 symmetric matrix to compute eigenvalues of
  real(pREAL), dimension(3) :: math_eigvalsh33,I
  real(pREAL) :: P, Q, rho, phi
  real(pREAL), parameter :: TOL=1.e-14_pREAL


  I = math_invariantsSym33(m)                                                                       ! invariants are coefficients in characteristic polynomial apart for the sign of c0 and c2 in http://arxiv.org/abs/physics/0610206

  P = I(2)-I(1)**2/3.0_pREAL                                                                        ! different from http://arxiv.org/abs/physics/0610206 (this formulation was in DAMASK)
  Q = product(I(1:2))/3.0_pREAL &
    - 2.0_pREAL/27.0_pREAL*I(1)**3 &
    - I(3)                                                                                          ! different from http://arxiv.org/abs/physics/0610206 (this formulation was in DAMASK)

  if (all(abs([P,Q]) < TOL)) then
    math_eigvalsh33 = math_eigvalsh(m)
  else
    rho=sqrt(-3.0_pREAL*P**3)/9.0_pREAL
    phi=acos(math_clip(-Q/rho*0.5_pREAL,-1.0_pREAL,1.0_pREAL))
    math_eigvalsh33 = 2.0_pREAL*rho**(1.0_pREAL/3.0_pREAL)* &
                                                            [cos( phi              /3.0_pREAL), &
                                                             cos((phi+TAU)/3.0_pREAL), &
                                                             cos((phi+2.0_pREAL*TAU)/3.0_pREAL) &
                                                            ] &
                    + I(1)/3.0_pREAL
  end if

end function math_eigvalsh33


!--------------------------------------------------------------------------------------------------
!> @brief invariants of symmetrix 3x3 matrix
!--------------------------------------------------------------------------------------------------
pure function math_invariantsSym33(m)

  real(pREAL), dimension(3,3), intent(in) :: m
  real(pREAL), dimension(3) :: math_invariantsSym33


  math_invariantsSym33(1) = math_trace33(m)
  math_invariantsSym33(2) = m(1,1)*m(2,2) + m(1,1)*m(3,3) + m(2,2)*m(3,3) &
                          -(m(1,2)**2     + m(1,3)**2     + m(2,3)**2)
  math_invariantsSym33(3) = math_detSym33(m)

end function math_invariantsSym33


!--------------------------------------------------------------------------------------------------
!> @brief factorial
!--------------------------------------------------------------------------------------------------
integer pure function math_factorial(n)

  integer, intent(in) :: n


  math_factorial = product(math_range(n))

end function math_factorial


!--------------------------------------------------------------------------------------------------
!> @brief binomial coefficient
!--------------------------------------------------------------------------------------------------
integer pure function math_binomial(n,k)

  integer, intent(in) :: n, k
  integer :: i, k_, n_


  k_ = min(k,n-k)
  n_ = n
  math_binomial = merge(1,0,k_>-1)                                                                  ! handling special cases k < 0 or k > n
  do i = 1, k_
    math_binomial = (math_binomial * n_)/i
    n_ = n_ -1
  end do

end function math_binomial


!--------------------------------------------------------------------------------------------------
!> @brief multinomial coefficient
!--------------------------------------------------------------------------------------------------
integer pure function math_multinomial(k)

  integer, intent(in), dimension(:) :: k
  integer :: i


  math_multinomial = product([(math_binomial(sum(k(1:i)),k(i)),i=1,size(k))])

end function math_multinomial


!--------------------------------------------------------------------------------------------------
!> @brief volume of tetrahedron given by four vertices
!--------------------------------------------------------------------------------------------------
real(pREAL) pure function math_volTetrahedron(v1,v2,v3,v4)

  real(pREAL), dimension (3), intent(in) :: v1,v2,v3,v4
  real(pREAL), dimension (3,3) :: m


  m(1:3,1) = v1-v2
  m(1:3,2) = v1-v3
  m(1:3,3) = v1-v4

  math_volTetrahedron = abs(math_det33(m))/6.0_pREAL

end function math_volTetrahedron


!--------------------------------------------------------------------------------------------------
!> @brief area of triangle given by three vertices
!--------------------------------------------------------------------------------------------------
real(pREAL) pure function math_areaTriangle(v1,v2,v3)

  real(pREAL), dimension (3), intent(in) :: v1,v2,v3


  math_areaTriangle = 0.5_pREAL * norm2(math_cross(v1-v2,v1-v3))

end function math_areaTriangle


!--------------------------------------------------------------------------------------------------
!> @brief Limit a scalar value to a certain range (either one or two sided).
!--------------------------------------------------------------------------------------------------
real(pREAL) pure elemental function math_clip(a, left, right)

  real(pREAL), intent(in) :: a
  real(pREAL), intent(in), optional :: left, right


  math_clip = a
  if (present(left))  math_clip = max(left,math_clip)
  if (present(right)) math_clip = min(right,math_clip)
  if (present(left) .and. present(right)) then
    if (left>right) error stop 'left > right'
  end if

end function math_clip


!--------------------------------------------------------------------------------------------------
!> @brief Check correctness of some math functions.
!--------------------------------------------------------------------------------------------------
subroutine math_selfTest()

  integer, dimension(2,4) :: &
    sort_in_   = reshape([+1,+5,  +5,+6,  -1,-1,  +3,-2],[2,4])
  integer, dimension(2,4), parameter :: &
    sort_out_  = reshape([-1,-1,  +1,+5,  +5,+6,  +3,-2],[2,4])

  integer,     dimension(5) :: range_out_ = [1,2,3,4,5]
  integer,     dimension(3) :: ijk

  real(pREAL)                 :: det
  real(pREAL), dimension(3)   :: v3_1,v3_2,v3_3,v3_4
  real(pREAL), dimension(9)   :: v9
  real(pREAL), dimension(3,3) :: t33,t33_2
  real(pREAL), dimension(6,6) :: t66
  real(pREAL), dimension(9,9) :: t99,t99_2
  real(pREAL), dimension(:,:), &
               allocatable    :: txx,txx_2
  real(pREAL)                 :: r
  integer                     :: d
  logical                     :: e


  if (any(abs([1.0_pREAL,2.0_pREAL,2.0_pREAL,3.0_pREAL,3.0_pREAL,3.0_pREAL] - &
              math_expand([1.0_pREAL,2.0_pREAL,3.0_pREAL],[1,2,3,0])) > tol_math_check)) &
    error stop 'math_expand [1,2,3] by [1,2,3,0] => [1,2,2,3,3,3]'

  if (any(abs([1.0_pREAL,2.0_pREAL,2.0_pREAL] - &
              math_expand([1.0_pREAL,2.0_pREAL,3.0_pREAL],[1,2])) > tol_math_check)) &
    error stop 'math_expand [1,2,3] by [1,2] => [1,2,2]'

  if (any(abs([1.0_pREAL,2.0_pREAL,2.0_pREAL,1.0_pREAL,1.0_pREAL,1.0_pREAL] - &
              math_expand([1.0_pREAL,2.0_pREAL],[1,2,3])) > tol_math_check)) &
    error stop 'math_expand_real [1,2] by [1,2,3] => [1,2,2,1,1,1]'

  if (any(abs([1,2,2,1,1,1] - math_expand([1,2],[1,2,3])) /= 0)) &
    error stop 'math_expand_int [1,2] by [1,2,3] => [1,2,2,1,1,1]'

  call math_sort(sort_in_,1,3,2)
  if (any(sort_in_ /= sort_out_)) &
    error stop 'math_sort'

  if (any(math_range(5) /= range_out_)) &
    error stop 'math_range'

  if (any(dNeq(math_exp33(math_I3,0),math_I3))) &
    error stop 'math_exp33(math_I3,1)'
  if (any(dNeq(math_exp33(math_I3,128),exp(1.0_pREAL)*math_I3))) &
    error stop 'math_exp33(math_I3,128)'

  call random_number(v9)
  if (any(dNeq(math_33to9(math_9to33(v9)),v9))) &
    error stop 'math_33to9/math_9to33'

  call random_number(t99)
  if (any(dNeq(math_3333to99(math_99to3333(t99)),t99))) &
    error stop 'math_3333to99/math_99to3333'

  call random_number(t66)
  if (any(dNeq(math_sym3333to66(math_66toSym3333(t66)),t66,1.0e-15_pREAL))) &
    error stop 'math_sym3333to66/math_66toSym3333'

  if (any(dNeq(math_3333toVoigt66_stiffness(math_Voigt66to3333_stiffness(t66)),t66,1.0e-15_pREAL))) &
    error stop 'math_3333toVoigt66/math_Voigt66to3333'

  call random_number(t33)
  if (any(dNeq0(math_symmetric33(t33) - transpose(math_symmetric33(t33))))) &
    error stop 'math_symmetric33'

  call random_number(v3_1)
  call random_number(v3_2)
  call random_number(v3_3)
  call random_number(v3_4)

  if (dNeq(abs(dot_product(math_cross(v3_1-v3_4,v3_2-v3_4),v3_3-v3_4))/6.0_pREAL, &
          math_volTetrahedron(v3_1,v3_2,v3_3,v3_4),tol=1.0e-12_pREAL)) &
    error stop 'math_volTetrahedron'

  call random_number(t33)
  if (dNeq(math_det33(math_symmetric33(t33)),math_detSym33(math_symmetric33(t33)),tol=1.0e-12_pREAL)) &
    error stop 'math_det33/math_detSym33'

  if (dNeq(math_det33(t33),math_det(t33),tol=1.0e-12_pREAL)) &
    error stop 'math_det33/math_det'

  if (any(dNeq(t33+transpose(t33),math_mul3333xx33(math_identity4th(),t33+transpose(t33))))) &
    error stop 'math_mul3333xx33/math_identity4th'

  if (any(dNeq0(math_eye(3),math_inv33(math_I3)))) &
    error stop 'math_inv33(math_I3)'

  if (any(dNeq(t33,math_symmetric33(t33)+math_skew33(t33),1.0e-10_pREAL))) &
    error stop 'math_symmetric/skew'

  if (any(dNeq(t33,math_spherical33(t33)+math_deviatoric33(t33),1.0e-10_pREAL))) &
    error stop 'math_spherical/deviatoric'

  do while(abs(math_det33(t33))<1.0e-9_pREAL)
    call random_number(t33)
  end do
  if (any(dNeq0(matmul(t33,math_inv33(t33)) - math_eye(3),tol=1.0e-8_pREAL))) &
    error stop 'math_inv33'

  call math_invert33(t33_2,det,e,t33)
  if (any(dNeq0(matmul(t33,t33_2) - math_eye(3),tol=1.0e-9_pREAL)) .or. e) &
    error stop 'math_invert33: T:T^-1 != I'
  if (dNeq(det,math_det33(t33),tol=1.0e-12_pREAL)) &
    error stop 'math_invert33 (determinant)'

  call math_invert(t33_2,e,t33)
  if (any(dNeq0(matmul(t33,t33_2) - math_eye(3),tol=1.0e-9_pREAL)) .or. e) &
    error stop 'math_invert t33'

  do while(math_det33(t33)<1.0e-2_pREAL)                                                            ! O(det(F)) = 1
    call random_number(t33)
  end do
  t33_2 = math_rotationalPart(transpose(t33))
  t33   = math_rotationalPart(t33)
  if (any(dNeq0(matmul(t33_2,t33) - math_I3,tol=1.0e-10_pREAL))) &
    error stop 'math_rotationalPart (forward-backward)'
  if (dNeq(1.0_pREAL,math_det33(math_rotationalPart(t33)),tol=1.0e-10_pREAL)) &
    error stop 'math_rotationalPart (determinant)'

  call random_number(r)
  d = int(r*5.0_pREAL) + 1
  txx = math_eye(d)
  allocate(txx_2(d,d))
  call math_invert(txx_2,e,txx)
  if (any(dNeq0(txx_2,txx) .or. e)) &
    error stop 'math_invert(txx)/math_eye'

  do while(abs(math_det(t99))<1.0e-8_pREAL)                                                         ! avoid approximately singular matrices
    call random_number(t99)
  end do
  call math_invert(t99_2,e,t99)
  if (any(dNeq0(matmul(t99_2,t99)-math_eye(9),tol=1.0e-9_pREAL)) .or. e) &
    error stop 'math_invert(t99)'

  if (any(dNeq(math_clip([4.0_pREAL,9.0_pREAL],5.0_pREAL,6.5_pREAL),[5.0_pREAL,6.5_pREAL]))) &
    error stop 'math_clip'

  if (math_factorial(10) /= 3628800) &
    error stop 'math_factorial'

  if (math_binomial(49,6) /= 13983816) &
    error stop 'math_binomial'

  if (math_multinomial([1,2,3,4]) /= 12600) &
    error stop 'math_multinomial'

  ijk = cshift([1,2,3],int(r*1.0e2_pREAL))
  if (dNeq(math_LeviCivita(ijk(1),ijk(2),ijk(3)),+1.0_pREAL)) &
    error stop 'math_LeviCivita(even)'
  ijk = cshift([3,2,1],int(r*2.0e2_pREAL))
  if (dNeq(math_LeviCivita(ijk(1),ijk(2),ijk(3)),-1.0_pREAL)) &
    error stop 'math_LeviCivita(odd)'
  ijk = cshift([2,2,1],int(r*2.0e2_pREAL))
  if (dNeq0(math_LeviCivita(ijk(1),ijk(2),ijk(3)))) &
    error stop 'math_LeviCivita'

  normal_distribution: block
    integer, parameter :: N = 1000000
    real(pREAL), dimension(:), allocatable :: r
    real(pREAL) :: mu, sigma

    allocate(r(N))
    call random_number(mu)
    call random_number(sigma)

    sigma = 1.0_pREAL + sigma*5.0_pREAL
    mu = (mu-0.5_pREAL)*10_pREAL

    call math_normal(r,mu,sigma)

    if (abs(mu -sum(r)/real(N,pREAL))>5.0e-2_pREAL) &
      error stop 'math_normal(mu)'

    mu = sum(r)/real(N,pREAL)
    if (abs(sigma**2 -1.0_pREAL/real(N-1,pREAL) * sum((r-mu)**2))/sigma > 5.0e-2_pREAL) &
      error stop 'math_normal(sigma)'
  end block normal_distribution

  t33 = 0.0_pREAL
  call math_eigh33(v3_1,t33_2,t33)
  if (any(dNeq0(v3_1)))         error stop 'math_eigh33/zero eigenvalues (values)'
  if (any(dNeq(t33_2,math_I3))) error stop 'math_eigh33/zero eigenvalues (vectors)'

  t33 = math_I3
  call random_number(r)
  d = nint(r*2.0_pREAL) + 1
  t33(d,d) = 5.0_pREAL + r*10.0_pREAL
  t33(mod(d,3)+1,mod(d,3)+1) = 20.0_pREAL + r*10.0_pREAL
  call math_eigh33(v3_1,t33_2,t33)
  if (any(dNeq(v3_1,[1.0_pREAL,t33(d,d),t33(mod(d,3)+1,mod(d,3)+1)]))) &
                                error stop 'math_eigh33/non-zero eigenvalues (values)'
  if (any(dNeq(math_I3(1:3,mod(d+1,3)+1),t33_2(1:3,1)))) error stop 'math_eigh33/min eigenvector'
  if (any(dNeq(math_I3(1:3,d           ),t33_2(1:3,2)))) error stop 'math_eigh33/mid eigenvector'
  if (any(dNeq(math_I3(1:3,mod(d,3)+1  ),t33_2(1:3,3)))) error stop 'math_eigh33/max eigenvector'

end subroutine math_selfTest

end module math

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Read in the material and numerics configuration from their respective file.
!--------------------------------------------------------------------------------------------------
module config
  use IO
  use misc
  use YAML
  use types
  use result
  use parallelization
#if   defined(MESH) || defined(GRID)
  use CLI
#endif
  implicit none(type,external)
  private

  type(tDict), pointer, public :: &
    config_material, &
    config_numerics

  public :: &
    config_init, &
    config_material_deallocate, &
    config_numerics_deallocate, &
    config_listReferences

contains

!--------------------------------------------------------------------------------------------------
!> @brief Read *.yaml configuration files.
!--------------------------------------------------------------------------------------------------
subroutine config_init()

  print'(/,1x,a)', '<<<+-  config init  -+>>>'; flush(IO_STDOUT)

#if defined(MESH) || defined(GRID)
  config_material => parse(CLI_materialFile,'material configuration')
#else
  config_material => parse('material.yaml','material configuration')
#endif

  config_numerics => emptyDict
#if defined(MESH) || defined(GRID)
  if (allocated(CLI_numericsFile)) &
    config_numerics => parse(CLI_numericsFile,'numerics configuration')
#else
  MSCMarc: block
    logical :: exists
    inquire(file='numerics.yaml',exist=exists)
    if (exists) config_numerics => parse('numerics.yaml','numerics configuration')
  end block MSCMarc
#endif

end subroutine config_init


!--------------------------------------------------------------------------------------------------
!> @brief Deallocate config_material.
!--------------------------------------------------------------------------------------------------
subroutine config_material_deallocate()

  print'(/,1x,a)', 'deallocating material configuration'; flush(IO_STDOUT)
  deallocate(config_material)

end subroutine config_material_deallocate

!--------------------------------------------------------------------------------------------------
!> @brief Deallocate config_numerics if present.
!--------------------------------------------------------------------------------------------------
subroutine config_numerics_deallocate()

  if (.not. associated(config_numerics, emptyDict)) then
    print'(/,1x,a)', 'deallocating numerics configuration'; flush(IO_STDOUT)
    deallocate(config_numerics)
  end if

end subroutine config_numerics_deallocate


!--------------------------------------------------------------------------------------------------
!> @brief Return string with references from dict.
!--------------------------------------------------------------------------------------------------
function config_listReferences(config,indent) result(references)

  type(tDict), intent(in) :: config
  integer, intent(in), optional :: indent
  character(len=:), allocatable :: references

  type(tList), pointer :: ref
  character(len=:), allocatable :: filler
  integer :: r


  filler = repeat(' ',misc_optional(indent,0))
  ref => config%get_list('references',emptyList)
  if (size(ref) == 0) then
    references = ''
  else
    references = 'references:'
    do r = 1, size(ref)
      references = references//IO_EOL//filler//'- '//IO_wrapLines(ref%get_asStr(r),filler=filler//'  ')
    end do
  end if

end function config_listReferences


!--------------------------------------------------------------------------------------------------
!> @brief Read configuration, spread over all processes, and add to DADF5.
!--------------------------------------------------------------------------------------------------
function parse(fname,description)

  character(len=*), intent(in) :: fname, description
  type(tDict), pointer :: parse

  character(len=:), allocatable :: fileContent


  if (worldrank == 0) then
    print'(/,1x,a)', 'reading '//description; flush(IO_STDOUT)
    fileContent = IO_read(fname)
    call result_openJobFile(parallel=.false.)
    call result_addSetupFile(fileContent,fname,description)
    call result_closeJobFile()
  end if
  call parallelization_bcast_str(fileContent)

  parse => YAML_str_asDict(fileContent)

end function parse

end module config

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Sharan Roongta, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Data types to create a scalar, a list, and a dictionary/hash
!> @details module describes the various functions to store and get the yaml data.
!! A node is the base class for scalar, list and dictionary, list items and dictionary entries point
!! to a node.
!--------------------------------------------------------------------------------------------------

module types
  use IO
  use prec
  use misc

  implicit none(type,external)
  private

  type, abstract, public :: tNode
    contains
    procedure(asFormattedStr), deferred :: &
      asFormattedStr
    procedure :: &
      asScalar => tNode_asScalar, &
      asList   => tNode_asList, &
      asDict   => tNode_asDict
  end type tNode

  type, extends(tNode), public :: tScalar
    character(len=:), allocatable, private :: &
      value
    contains
    procedure :: &
      asFormattedStr => tScalar_asFormattedStr, &
      asReal => tScalar_asReal, &
      asInt  => tScalar_asInt, &
      asBool => tScalar_asBool, &
      asStr  => tScalar_asStr
  end type tScalar

  type, extends(tNode), public :: tList
    type(tItem), pointer :: &
      first => NULL(), &
      last => NULL()
    integer, private :: &
      length = 0
    contains
    procedure :: &
      asFormattedStr => tList_asFormattedStr, &
      append         => tList_append, &
      as1dReal       => tList_as1dReal, &
      as2dReal       => tList_as2dReal, &
      as1dInt        => tList_as1dInt, &
      as1dBool       => tList_as1dBool, &
      as1dStr        => tList_as1dStr, &
      contains       => tList_contains, &
      tList_get, &
      tList_get_scalar, &
      tList_get_list, &
      tList_get_dict, &
      tList_get_asReal, &
      tList_get_as1dReal, &
      tList_get_asInt, &
      tList_get_as1dInt, &
      tList_get_asBool, &
      tList_get_as1dBool, &
      tList_get_asStr, &
      tList_get_as1dStr
    generic :: get          => tList_get
    generic :: get_scalar   => tList_get_scalar
    generic :: get_list     => tList_get_list
    generic :: get_dict     => tList_get_dict
    generic :: get_asReal   => tList_get_asReal
    generic :: get_as1dReal => tList_get_as1dReal
    generic :: get_asInt    => tList_get_asInt
    generic :: get_as1dInt  => tList_get_as1dInt
    generic :: get_asBool   => tList_get_asBool
    generic :: get_as1dBool => tList_get_as1dBool
    generic :: get_asStr    => tList_get_asStr
    generic :: get_as1dStr  => tList_get_as1dStr
    final :: tList_finalize
  end type tList

  type, extends(tList), public :: tDict
    contains
    procedure ::  &
      asFormattedStr => tDict_asFormattedStr, &
      set            => tDict_set, &
      index          => tDict_index, &
      key            => tDict_key, &
      keys           => tDict_keys, &
      contains       => tDict_contains, &
      tDict_get, &
      tDict_get_scalar, &
      tDict_get_list, &
      tDict_get_dict, &
      tDict_get_asReal, &
      tDict_get_as1dReal_sized, &
      tDict_get_as1dReal_chunked, &
#ifdef __GFORTRAN__
      tDict_get_as2dReal_a, &
      tDict_get_as2dReal_b, &
#else
      tDict_get_as2dReal, &
#endif
      tDict_get_asInt, &
      tDict_get_as1dInt, &
      tDict_get_asBool, &
      tDict_get_as1dBool, &
      tDict_get_asStr, &
      tDict_get_as1dStr
    generic :: get          => tDict_get
    generic :: get_scalar   => tDict_get_scalar
    generic :: get_list     => tDict_get_list
    generic :: get_dict     => tDict_get_dict
    generic :: get_asReal   => tDict_get_asReal
    generic :: get_as1dReal => tDict_get_as1dReal_sized
    generic :: get_as1dReal => tDict_get_as1dReal_chunked
#ifdef __GFORTRAN__
    generic :: get_as2dReal => tDict_get_as2dReal_a
    generic :: get_as2dReal => tDict_get_as2dReal_b
#else
    generic :: get_as2dReal => tDict_get_as2dReal
#endif
    generic :: get_asInt    => tDict_get_asInt
    generic :: get_as1dInt  => tDict_get_as1dInt
    generic :: get_asBool   => tDict_get_asBool
    generic :: get_as1dBool => tDict_get_as1dBool
    generic :: get_asStr    => tDict_get_asStr
    generic :: get_as1dStr  => tDict_get_as1dStr
   end type tDict


  type, public :: tItem
    character(len=:), allocatable :: key
    class(tNode),     pointer     :: node => NULL()
    type(tItem),      pointer     :: next => NULL()
    contains
    final :: tItem_finalize
  end type tItem

  type(tDict), target, public :: &
    emptyDict
  type(tList), target, public :: &
    emptyList

  abstract interface

    recursive function asFormattedStr(self)
      import tNode
      character(len=:), allocatable      :: asFormattedStr
      class(tNode), intent(in), target   :: self
    end function asFormattedStr

  end interface

  interface tScalar
    module procedure tScalar_init__
  end interface tScalar

  interface assignment (=)
    module procedure tScalar_assign__
  end interface assignment (=)

  interface size
    module procedure tList_size
  end interface size

  public :: &
    types_init, &
    types_selfTest, &
#ifdef __GFORTRAN__
    output_as1dStr, &                                       !ToDo: Hack for GNU. Remove later
#endif
    assignment(=), &
    size

contains

!--------------------------------------------------------------------------------------------------
!> @brief Do sanity checks.
!--------------------------------------------------------------------------------------------------
subroutine types_init

  print'(/,1x,a)', '<<<+-  types init  -+>>>'

  call types_selfTest()

end subroutine types_init


!--------------------------------------------------------------------------------------------------
!> @brief Check correctness of some type bound procedures.
!--------------------------------------------------------------------------------------------------
subroutine types_selfTest()

  character(len=5), dimension(3), parameter :: array = ['ab   ', '12435', 'x    ']


  if ('[ab, 12435, x]' /= join_str_array(array)) error stop 'join_str_array'

  scalar: block
    type(tScalar), target :: s
    type(tScalar), pointer :: s_pointer


    s_pointer => s%asScalar()
    s = '1'
    if (s%asInt() /= 1)                error stop 'tScalar_asInt'
    if (s_pointer%asInt() /= 1)        error stop 'tScalar_asInt(pointer)'
    if (dNeq(s%asReal(),1.0_pREAL))    error stop 'tScalar_asReal'
    s = 'true'
    if (.not. s%asBool())              error stop 'tScalar_asBool'
    if (.not. s_pointer%asBool())      error stop 'tScalar_asBool(pointer)'
    if (s%asStr() /= 'true')           error stop 'tScalar_asStr'
    if (s%asFormattedStr() /= 'true')  error stop 'tScalar_asFormattedStr'


  end block scalar

  list: block
    type(tList),   pointer :: l, l_pointer
    type(tScalar), pointer :: s1,s2


    allocate(s1)
    allocate(s2)
    s1 = '1'
    s2 = '2'
    allocate(l)
    l_pointer => l%asList()
    if (l%contains('1'))                               error stop 'empty tList_contains'
    if (l_pointer%contains('1'))                       error stop 'empty tList_contains(pointer)'
    call l%append(s1)
    call l%append(s2)
    if (size(l) /= 2)                                  error stop 'tList%length/size(tList)'
    if (dNeq(l%get_asReal(1),1.0_pREAL))               error stop 'tList_get_asReal'
    if (l%get_asInt(1) /= 1)                           error stop 'tList_get_asInt'
    if (l%get_asStr(2) /= '2')                         error stop 'tList_get_asStr'
    if (any(l%as1dInt() /= [1,2]))                     error stop 'tList_as1dInt'
    if (any(dNeq(l%as1dReal(),real([1.0,2.0],pREAL)))) error stop 'tList_as1dReal'
    s1 = 'true'
    s2 = 'false'
    if (any(l%as1dBool() .neqv. [.true.,.false.]))     error stop 'tList_as1dBool'
    if (any(l%as1dStr() /= ['true ','false']))         error stop 'tList_as1dStr'
    if (l%asFormattedStr() /= '[true, false]')         error stop 'tList_asFormattedStr'
    if (   .not. l%contains('true') &
      .or. .not. l%contains('false'))                  error stop 'tList_contains'

  end block list

  dict: block
    type(tDict),   pointer :: d, d_pointer
    type(tList),   pointer :: l
    type(tScalar), pointer :: s1,s2,s3,s4


    allocate(s1)
    allocate(s2)
    s1 = '1'
    s2 = '2'
    allocate(l)
    call l%append(s1)
    call l%append(s2)

    allocate(s3)
    allocate(s4)
    s3 = '3'
    s4 = '4'
    allocate(d)
    d_pointer => d%asDict()
    if (d%contains('one-two'))                        error stop 'empty tDict_contains'
    if (d_pointer%contains('one-two'))                error stop 'empty tDict_contains(pointer)'
    if (d%get_asInt('one-two',defaultVal=-1) /= -1)   error stop 'empty tDict_get'
    call d%set('one-two',l)
    call d%set('three',s3)
    call d%set('four',s4)
    if (d%asFormattedStr() /= '{one-two: [1, 2], three: 3, four: 4}') &
                                                      error stop 'tDict_asFormattedStr'
    if (d%get_asInt('three') /= 3)                    error stop 'tDict_get_asInt'
    if (dNeq(d%get_asReal('three'),3.0_pREAL))        error stop 'tDict_get_asReal'
    if (any(d%get_as1dReal('one-two') /= real([1,2],pREAL))) &
                                                      error stop 'tDict_get_as1dReal'
    if (any(d%get_as1dReal('three',requiredSize=3) /= real([3,3,3],pREAL))) &
                                                      error stop 'tDict_get_as1dReal/size'
    if (d%get_asStr('three') /= '3')                  error stop 'tDict_get_asStr'
    if (any(d%get_as1dInt('one-two') /= [1,2]))       error stop 'tDict_get_as1dInt'
    if (any(d%get_as1dInt('three',requiredSize=3) /= [3,3,3])) &
                                                      error stop 'tDict_get_as1dInt/size'
    call d%set('one-two',s4)
    if (d%asFormattedStr() /= '{one-two: 4, three: 3, four: 4}') &
                                                      error stop 'tDict_set overwrite'
    if (   .not. d%contains('one-two') &
      .or. .not. d%contains('three') &
      .or. .not. d%contains('four') &
      )                                               error stop 'tDict_contains'


  end block dict

#ifdef __GFORTRAN__
  dict_get_as1dReal_chunked: block
    type(tDict),   pointer :: d
    type(tList),   pointer :: l_outer, l_inner
    type(tScalar), pointer :: s1,s2,s3
    real(pREAL), dimension(5) :: a


    allocate(s1)
    allocate(s2)
    allocate(s3)
    s1 = '1.'
    s2 = '2'
    s3 = '3.0'

    allocate(l_inner)
    call l_inner%append(s1)
    call l_inner%append(s2)

    allocate(l_outer)
    call l_outer%append(l_inner)
    call l_outer%append(s3)

    allocate(d)
    call d%set('list',l_outer)
    call d%set('scalar',s1)

    a = d%get_as1dReal('list',requiredChunks=[2,3])
    if (any(dNeq(a,real([1.0,2.0,3.0,3.0,3.0],pREAL)))) &
      error stop 'dict_get_as1dReal_shape list'

    if (any(dNeq(d%get_as1dReal('non-existing',a,[2,3]),a))) &
      error stop 'dict_get_as1dReal_shape default individual'

    a = real([42.0, 42.0, 5.0, 5.0, 5.0],pREAL)
    if (any(dNeq(d%get_as1dReal('non-existing',[42._pREAL, 5._pREAL],[2,3]),a))) &
      error stop 'dict_get_as1dReal_shape default group'

    if (any(dNeq(d%get_as1dReal('scalar',requiredChunks=[3,5,2]),misc_ones(10)))) &
      error stop 'dict_get_as1dReal_shape scalar'

  end block dict_get_as1dReal_chunked
#endif

end subroutine types_selfTest


!---------------------------------------------------------------------------------------------------
!> @brief Init from string.
!---------------------------------------------------------------------------------------------------
type(tScalar) pure function tScalar_init__(value)

  character(len=*), intent(in) ::  value


  tScalar_init__%value = value

end function tScalar_init__


!---------------------------------------------------------------------------------------------------
!> @brief Set value from string.
!---------------------------------------------------------------------------------------------------
elemental pure subroutine tScalar_assign__(self,value)

  type(tScalar),    intent(out) :: self
  character(len=*), intent(in)  :: value


  self%value = value

end subroutine tScalar_assign__


!--------------------------------------------------------------------------------------------------
!> @brief Format as string (YAML flow style).
!--------------------------------------------------------------------------------------------------
recursive function tScalar_asFormattedStr(self) result(str)

  class (tScalar), intent(in), target    :: self
  character(len=:), allocatable          :: str


  str = trim(self%value)

end function tScalar_asFormattedStr


!--------------------------------------------------------------------------------------------------
!> @brief Type guard, guarantee scalar.
!--------------------------------------------------------------------------------------------------
function tNode_asScalar(self) result(scalar)

  class(tNode),   intent(in), target :: self
  type(tScalar),  pointer            :: scalar


  select type(self)
    class is(tScalar)
      scalar => self
    class default
      nullify(scalar)
      call IO_error(706_pI16,trim(self%asFormattedStr()),'is not a scalar',emph=[1])
  end select

end function tNode_asScalar


!--------------------------------------------------------------------------------------------------
!> @brief Type guard, guarantee list.
!--------------------------------------------------------------------------------------------------
function tNode_asList(self) result(list)

  class(tNode), intent(in), target :: self
  class(tList), pointer            :: list


  select type(self)
    class is(tList)
      list => self
    class default
      nullify(list)
      call IO_error(706_pI16,trim(self%asFormattedStr()),'is not a list',emph=[1])
  end select

end function tNode_asList


!--------------------------------------------------------------------------------------------------
!> @brief Type guard, guarantee dict.
!--------------------------------------------------------------------------------------------------
function tNode_asDict(self) result(dict)

  class(tNode), intent(in), target :: self
  class(tDict), pointer            :: dict


  select type(self)
    class is(tDict)
      dict => self
    class default
      nullify(dict)
      call IO_error(706_pI16,trim(self%asFormattedStr()),'is not a dict',emph=[1])
  end select

end function tNode_asDict


!--------------------------------------------------------------------------------------------------
!> @brief Convert to real.
!--------------------------------------------------------------------------------------------------
function tScalar_asReal(self)

  class(tScalar), intent(in), target :: self
  real(pREAL) :: tScalar_asReal


  tScalar_asReal = IO_strAsReal(self%value)

end function tScalar_asReal


!--------------------------------------------------------------------------------------------------
!> @brief Convert to int.
!--------------------------------------------------------------------------------------------------
function tScalar_asInt(self)

  class(tScalar), intent(in), target :: self
  integer :: tScalar_asInt


  tScalar_asInt = IO_strAsInt(self%value)

end function tScalar_asInt


!--------------------------------------------------------------------------------------------------
!> @brief Convert to bool.
!--------------------------------------------------------------------------------------------------
function tScalar_asBool(self)

  class(tScalar), intent(in), target :: self
  logical :: tScalar_asBool


  tScalar_asBool = IO_strAsBool(self%value)

end function tScalar_asBool


!--------------------------------------------------------------------------------------------------
!> @brief Convert to string.
!--------------------------------------------------------------------------------------------------
function tScalar_asStr(self)

  class(tScalar), intent(in), target :: self
  character(len=:), allocatable :: tScalar_asStr


  tScalar_asStr = self%value

end function tScalar_asStr


!--------------------------------------------------------------------------------------------------
!> @brief Format as string (YAML flow style).
!--------------------------------------------------------------------------------------------------
recursive function tList_asFormattedStr(self) result(str)

  class(tList),intent(in),target      :: self

  type(tItem), pointer  :: item
  character(len=:), allocatable :: str
  integer :: i

  str = '['
  item => self%first
  do i = 2, size(self)
    str = str//item%node%asFormattedStr()//', '
    item => item%next
  end do
  str = str//item%node%asFormattedStr()//']'

end function tList_asFormattedStr


!--------------------------------------------------------------------------------------------------
!> @brief Number of elements.
!--------------------------------------------------------------------------------------------------
pure integer function tList_size(list)

  class(tList), intent(in) :: list


  tList_size = list%length

end function tList_size


!--------------------------------------------------------------------------------------------------
!> @brief Append element.
!--------------------------------------------------------------------------------------------------
subroutine tList_append(self,node)

  class(tList), intent(inout)      :: self
  class(tNode), intent(in), target :: node

  type(tItem), pointer :: item


  if (.not. associated(self%first)) then
    allocate(item)
    self%first => item
    self%last => item
  else
    allocate(self%last%next)
    item => self%last%next
    self%last => item
  end if

  item%node => node
  self%length = self%length + 1

end subroutine tList_append


!--------------------------------------------------------------------------------------------------
!> @brief Convert to real array (1D).
!--------------------------------------------------------------------------------------------------
function tList_as1dReal(self)

  class(tList), intent(in), target :: self
  real(pREAL), dimension(:), allocatable :: tList_as1dReal

  integer :: i
  type(tItem),   pointer :: item
  type(tScalar), pointer :: scalar


  allocate(tList_as1dReal(size(self)))
  item => self%first
  do i = 1, size(self)
    scalar => item%node%asScalar()
    tList_as1dReal(i) = scalar%asReal()
    item => item%next
  end do

end function tList_as1dReal


!--------------------------------------------------------------------------------------------------
!> @brief Convert to real array (2D).
!--------------------------------------------------------------------------------------------------
function tList_as2dReal(self)

  class(tList), intent(in), target :: self
  real(pREAL), dimension(:,:), allocatable :: tList_as2dReal

  integer :: i
  type(tList), pointer :: row_data


  row_data => self%get_list(1)
  allocate(tList_as2dReal(size(self),size(row_data)))

  do i = 1, size(self)
    row_data => self%get_list(i)
    if (size(row_data) /= size(tList_as2dReal,2)) call IO_error(709,ext_msg='inconsistent column count in tList_as2dReal')
    tList_as2dReal(i,:) = self%get_as1dReal(i)
  end do

end function tList_as2dReal


!--------------------------------------------------------------------------------------------------
!> @brief Convert to int array (1D).
!--------------------------------------------------------------------------------------------------
function tList_as1dInt(self)

  class(tList), intent(in), target :: self
  integer, dimension(:), allocatable :: tList_as1dInt

  integer :: i
  type(tItem),   pointer :: item
  type(tScalar), pointer :: scalar


  allocate(tList_as1dInt(size(self)))
  item => self%first
  do i = 1, size(self)
    scalar => item%node%asScalar()
    tList_as1dInt(i) = scalar%asInt()
    item => item%next
  end do

end function tList_as1dInt


!--------------------------------------------------------------------------------------------------
!> @brief Convert to bool array (1D).
!--------------------------------------------------------------------------------------------------
function tList_as1dBool(self)

  class(tList), intent(in), target :: self
  logical, dimension(:), allocatable :: tList_as1dBool

  integer :: i
  type(tItem),   pointer :: item
  type(tScalar), pointer :: scalar


  allocate(tList_as1dBool(size(self)))
  item => self%first
  do i = 1, size(self)
    scalar => item%node%asScalar()
    tList_as1dBool(i) = scalar%asBool()
    item => item%next
  end do

end function tList_as1dBool


!--------------------------------------------------------------------------------------------------
!> @brief Convert to string array (1D).
!--------------------------------------------------------------------------------------------------
function tList_as1dStr(self)

  class(tList), intent(in), target :: self
#ifdef __GFORTRAN__
  character(len=pSTRLEN), allocatable, dimension(:) :: tList_as1dStr
#else
  character(len=:), allocatable, dimension(:) :: tList_as1dStr
#endif

  integer :: j
  type(tItem),   pointer :: item
  type(tScalar), pointer :: scalar


#ifdef __GFORTRAN__
  allocate(tList_as1dStr(size(self)))
#else
  integer :: len_max
  len_max = 0
  item => self%first
  do j = 1, size(self)
    scalar => item%node%asScalar()
    len_max = max(len_max, len_trim(scalar%asStr()))
    item => item%next
  end do

  allocate(character(len=len_max) :: tList_as1dStr(size(self)))
#endif
  item => self%first
  do j = 1, size(self)
    scalar => item%node%asScalar()
    tList_as1dStr(j) = scalar%asStr()
    item => item%next
  end do

end function tList_as1dStr


!-------------------------------------------------------------------------------------------------
!> @brief Check for existence of (string) value.
!-------------------------------------------------------------------------------------------------
function tList_contains(self,element) result(exists)

  class(tList),     intent(in), target :: self
  character(len=*), intent(in)         :: element                                                   !< value to search for
  logical                              :: exists

  integer :: j
  type(tItem),   pointer :: item
  type(tScalar), pointer :: scalar


  item => self%first
  exists = .false.
  j = 1
  do while (j <= size(self) .and. .not. exists)
    scalar => item%node%asScalar()
    exists = scalar%value == element
    item => item%next
    j = j + 1
  end do

end function tList_contains


!--------------------------------------------------------------------------------------------------
!> @brief Get by index.
!--------------------------------------------------------------------------------------------------
function tList_get(self,idx) result(node)

  class(tList), intent(in), target :: self
  integer,      intent(in)         :: idx                                                           !< index
  class(tNode), pointer :: node

  type(tItem), pointer :: item
  integer :: i


  if (idx < 1 .or. idx > size(self)) &
    call IO_error(150,ext_msg='tList_get @ '//IO_intAsStr(idx)//' of '//IO_intAsStr(size(self)) )
  item => self%first
  do i = 2, idx
    item => item%next
  end do
  node => item%node

end function tList_get


!--------------------------------------------------------------------------------------------------
!> @brief Get scalar by index.
!--------------------------------------------------------------------------------------------------
function tList_get_scalar(self,idx) result(nodeAsScalar)

  class(tList), intent(in) :: self
  integer,      intent(in) :: idx                                                                   !< index
  type(tScalar), pointer :: nodeAsScalar

  class(tNode),  pointer :: node


  node => self%get(idx)
  nodeAsScalar => node%asScalar()

end function tList_get_scalar


!--------------------------------------------------------------------------------------------------
!> @brief Get list by index.
!--------------------------------------------------------------------------------------------------
function tList_get_list(self,idx) result(nodeAsList)

  class(tList), intent(in) :: self
  integer,      intent(in) :: idx                                                                   !< index
  type(tList),  pointer :: nodeAsList

  class(tNode),  pointer :: node


  node => self%get(idx)
  nodeAsList => node%asList()

end function tList_get_list


!--------------------------------------------------------------------------------------------------
!> @brief Get dict by index.
!--------------------------------------------------------------------------------------------------
function tList_get_dict(self,idx) result(nodeAsDict)

  class(tList), intent(in) :: self
  integer,      intent(in) :: idx                                                                   !< index
  type(tDict),  pointer :: nodeAsDict

  class(tNode),  pointer :: node


  node => self%get(idx)
  nodeAsDict => node%asDict()

end function tList_get_dict


!--------------------------------------------------------------------------------------------------
!> @brief Get scalar by index and convert to real.
!--------------------------------------------------------------------------------------------------
function tList_get_asReal(self,idx) result(nodeAsReal)

  class(tList), intent(in) :: self
  integer,      intent(in) :: idx                                                                   !< index
  real(pREAL) :: nodeAsReal

  type(tScalar),   pointer :: scalar


  scalar => self%get_scalar(idx)
  nodeAsReal = scalar%asReal()

end function tList_get_asReal


!--------------------------------------------------------------------------------------------------
!> @brief Get list by index and convert to real array (1D).
!--------------------------------------------------------------------------------------------------
function tList_get_as1dReal(self,idx) result(nodeAs1dReal)

  class(tList), intent(in) :: self
  integer,      intent(in) :: idx                                                                   !< index
  real(pREAL), dimension(:), allocatable :: nodeAs1dReal

  class(tList),  pointer :: list


  list => self%get_list(idx)
  nodeAs1dReal = list%as1dReal()

end function tList_get_as1dReal


!--------------------------------------------------------------------------------------------------
!> @brief Get scalar by index and convert to int.
!--------------------------------------------------------------------------------------------------
function tList_get_asInt(self,idx) result(nodeAsInt)

  class(tList), intent(in) :: self
  integer,      intent(in) :: idx                                                                   !< index
  integer :: nodeAsInt

  type(tScalar),   pointer :: scalar


  scalar => self%get_scalar(idx)
  nodeAsInt = scalar%asInt()

end function tList_get_asInt


!--------------------------------------------------------------------------------------------------
!> @brief Get list by index and convert to int array (1D).
!--------------------------------------------------------------------------------------------------
function tList_get_as1dInt(self,idx) result(nodeAs1dInt)

  class(tList), intent(in) :: self
  integer,      intent(in) :: idx                                                                   !< index
  integer, dimension(:), allocatable :: nodeAs1dInt

  class(tList),  pointer :: list


  list => self%get_list(idx)
  nodeAs1dInt = list%as1dInt()

end function tList_get_as1dInt


!--------------------------------------------------------------------------------------------------
!> @brief Get scalar by index and convert to bool
!--------------------------------------------------------------------------------------------------
function tList_get_asBool(self,idx) result(nodeAsBool)

  class(tList), intent(in) :: self
  integer,      intent(in) :: idx                                                                   !< index
  logical :: nodeAsBool

  type(tScalar),   pointer :: scalar


  scalar => self%get_scalar(idx)
  nodeAsBool = scalar%asBool()

end function tList_get_asBool


!--------------------------------------------------------------------------------------------------
!> @brief Get list by index and convert to bool array (1D).
!--------------------------------------------------------------------------------------------------
function tList_get_as1dBool(self,i) result(nodeAs1dBool)

  class(tList), intent(in) :: self
  integer,      intent(in) :: i
  logical, dimension(:), allocatable :: nodeAs1dBool

  class(tList),  pointer :: list


  list => self%get_list(i)
  nodeAs1dBool = list%as1dBool()

end function tList_get_as1dBool


!--------------------------------------------------------------------------------------------------
!> @brief Get scalar by index and convert to string.
!--------------------------------------------------------------------------------------------------
function tList_get_asStr(self,i) result(nodeAsStr)

  class(tList), intent(in) :: self
  integer,      intent(in) :: i
  character(len=:), allocatable :: nodeAsStr

  type(tScalar),   pointer :: scalar


  scalar => self%get_scalar(i)
  nodeAsStr = scalar%asStr()

end function tList_get_asStr


!--------------------------------------------------------------------------------------------------
!> @brief Get list by index and convert to string array (1D).
!--------------------------------------------------------------------------------------------------
function tList_get_as1dStr(self,i) result(nodeAs1dStr)

  class(tList), intent(in) :: self
  integer,      intent(in) :: i
  character(len=:), allocatable, dimension(:) :: nodeAs1dStr

  type(tList),  pointer :: list


  list => self%get_list(i)
  nodeAs1dStr = list%as1dStr()

end function tList_get_as1dStr


!--------------------------------------------------------------------------------------------------
!> @brief Free associated memory.
!--------------------------------------------------------------------------------------------------
recursive subroutine tList_finalize(self)

  type (tList),intent(inout) :: self

  deallocate(self%first)

end subroutine tList_finalize


!--------------------------------------------------------------------------------------------------
!> @brief Format as string (YAML flow style).
!--------------------------------------------------------------------------------------------------
recursive function tDict_asFormattedStr(self) result(str)

  class(tDict),intent(in),target      :: self

  type(tItem),pointer  :: item
  character(len=:), allocatable :: str
  integer :: i


  str = '{'
  item => self%first
  do i = 2, size(self)
    str = str//trim(item%key)//': '//item%node%asFormattedStr()//', '
    item => item%next
  end do
  str = str//trim(item%key)//': '//item%node%asFormattedStr()//'}'

end function tDict_asFormattedStr


!--------------------------------------------------------------------------------------------------
!> @brief Set value (either replace or add new).
!--------------------------------------------------------------------------------------------------
subroutine tDict_set(self,key,node)

  class (tDict),    intent(inout)         :: self
  character(len=*), intent(in)            :: key
  class(tNode),     intent(in), target    :: node

  type(tItem), pointer :: item


  if (.not. associated(self%first)) then
    allocate(self%first)
    item => self%first
    self%length = 1
  else
    item => self%first
    searchExisting: do while (associated(item%next) .and. item%key /= key)
      item => item%next
    end do searchExisting
    if (item%key /= key) then
      allocate(item%next)
      item => item%next
      self%length = self%length + 1
    end if
  end if

  item%key = key
  item%node => node

end subroutine tDict_set


!--------------------------------------------------------------------------------------------------
!> @brief Return the index of a key.
!--------------------------------------------------------------------------------------------------
function tDict_index(self,key) result(keyIndex)

  class(tDict),     intent(in), target :: self
  character(len=*), intent(in)         :: key

  integer              :: keyIndex
  type(tItem), pointer :: item


  item => self%first
  keyIndex = 1
  do while (associated(item%next) .and. item%key /= key)
    item => item%next
    keyIndex = keyIndex+1
  end do

  if (item%key /= key) &
#ifndef __GFORTRAN__
    call IO_error(143_pI16,key,'not in',join_str_array(self%keys()),emph=[1,3])
#else
    call IO_error(143_pI16,key,'not found',emph=[1])
#endif

end function tDict_index


!--------------------------------------------------------------------------------------------------
!> @brief Get key of given index.
!--------------------------------------------------------------------------------------------------
function tDict_key(self,idx) result(key)

  class(tDict),     intent(in), target :: self
  integer,          intent(in)         :: idx                                                       !< index

  character(len=:), allocatable        :: key
  integer              :: i
  type(tItem), pointer :: item


  if (idx < 1 .or. idx > size(self)) &
    call IO_error(150,ext_msg='tDict_key @ '//IO_intAsStr(idx)//' of '//IO_intAsStr(size(self)) )
  item => self%first
  do i = 2, idx
    item => item%next
  end do

  key = item%key

end function tDict_key


!--------------------------------------------------------------------------------------------------
!> @brief Get all keys.
!--------------------------------------------------------------------------------------------------
function tDict_keys(self) result(keys)

  class(tDict), intent(in) :: self
  character(len=:), dimension(:), allocatable :: keys

  character(len=pSTRLEN), dimension(:), allocatable :: temp
  integer :: i, l


  allocate(temp(size(self)))
  l = 0
  do i = 1, size(self)
    temp(i) = self%key(i)
    l = max(len_trim(temp(i)),l)
  end do

  allocate(character(l)::keys(size(self)))
  do i = 1, size(self)
    keys(i) = trim(temp(i))
  end do

end function tDict_keys


!-------------------------------------------------------------------------------------------------
!> @brief Check whether a given key is present.
!-------------------------------------------------------------------------------------------------
function tDict_contains(self,element) result(exists)

  class(tDict),     intent(in), target :: self
  character(len=*), intent(in)         :: element                                                    !< key to check for
  logical                              :: exists

  integer :: j


  exists = .false.
  j = 1
  do while(j <= size(self) .and. .not. exists)
    exists = self%key(j) == element
    j = j + 1
  end do

end function tDict_contains


!--------------------------------------------------------------------------------------------------
!> @brief Get by key.
!--------------------------------------------------------------------------------------------------
function tDict_get(self,key,defaultVal) result(node)

  class(tDict),     intent(in), target         :: self
  character(len=*), intent(in)                 :: key
  class(tNode),     intent(in),optional,target :: defaultVal
  class(tNode),     pointer :: node

  type(tItem), pointer :: item
  integer :: j

  item => self%first

  do j=1, size(self)
    if (item%key == key) then
      node => item%node
      return
    end if
    item => item%next
  end do

  if (present(defaultVal)) then
    node => defaultVal
  else
#ifndef __GFORTRAN__
    call IO_error(143_pI16,key,'not in',join_str_array(self%keys()),emph=[1,3])
#else
    call IO_error(143_pI16,key,'not found',emph=[1])
#endif
  end if

end function tDict_get


!--------------------------------------------------------------------------------------------------
!> @brief Get scalar by key.
!--------------------------------------------------------------------------------------------------
function tDict_get_scalar(self,key,defaultVal) result(nodeAsScalar)

  class(tDict),     intent(in) :: self
  character(len=*), intent(in) :: key
  type(tScalar),    intent(in), optional, target :: defaultVal
  type(tScalar), pointer :: nodeAsScalar

  class(tNode),  pointer :: node


  node => self%get(key,defaultVal)
  nodeAsScalar => node%asScalar()

end function tDict_get_scalar


!--------------------------------------------------------------------------------------------------
!> @brief Get list by key.
!--------------------------------------------------------------------------------------------------
function tDict_get_list(self,key,defaultVal) result(nodeAsList)

  class(tDict),     intent(in) :: self
  character(len=*), intent(in) :: key
  type(tList),      intent(in), optional, target :: defaultVal
  type(tList),  pointer :: nodeAsList

  class(tNode), pointer :: node


  node => self%get(key,defaultVal)
  nodeAsList => node%asList()

end function tDict_get_list


!--------------------------------------------------------------------------------------------------
!> @brief Get dict by key.
!--------------------------------------------------------------------------------------------------
function tDict_get_dict(self,key,defaultVal) result(nodeAsDict)

  class(tDict),     intent(in) :: self
  character(len=*), intent(in) :: key
  type(tDict),      intent(in), optional, target :: defaultVal
  type(tDict),  pointer :: nodeAsDict

  class(tNode), pointer :: node


  node => self%get(key,defaultVal)
  nodeAsDict => node%asDict()

end function tDict_get_dict


!--------------------------------------------------------------------------------------------------
!> @brief Get scalar by key and convert to real.
!--------------------------------------------------------------------------------------------------
function tDict_get_asReal(self,key,defaultVal) result(nodeAsReal)

  class(tDict),     intent(in) :: self
  character(len=*), intent(in) :: key
  real(pREAL),      intent(in), optional :: defaultVal
  real(pREAL) :: nodeAsReal

  type(tScalar), pointer :: scalar


  if (self%contains(key)) then
    scalar => self%get_scalar(key)
    nodeAsReal = scalar%asReal()
  elseif (present(defaultVal)) then
    nodeAsReal = defaultVal
  else
#ifndef __GFORTRAN__
    call IO_error(143_pI16,key,'not in',join_str_array(self%keys()),emph=[1,3])
#else
    call IO_error(143_pI16,key,'not found',emph=[1])
#endif
  end if

end function tDict_get_asReal


!--------------------------------------------------------------------------------------------------
!> @brief Get list by key and convert to real array (1D).
!> @details If a size is required, scalars are valid input and are broadcasted to the required size.
!--------------------------------------------------------------------------------------------------
function tDict_get_as1dReal_sized(self,key,defaultVal,requiredSize) result(nodeAs1dReal)

  class(tDict),     intent(in) :: self
  character(len=*), intent(in) :: key
  real(pREAL),      intent(in), dimension(:), optional :: defaultVal
  integer,          intent(in),               optional :: requiredSize
  real(pREAL), dimension(:), allocatable :: nodeAs1dReal

  class(tNode), pointer :: content


  if (self%contains(key)) then
    content => self%get(key)
    select type(content)
      class is(tScalar)
        if (present(requiredSize)) then
          allocate(nodeAs1dReal(requiredSize),source = content%asReal())
        else
          call IO_error(706_pI16,trim(content%asFormattedStr()),'is not a list of reals',emph=[1])
        end if
      class is(tList)
        nodeAs1dReal = content%as1dReal()
    end select
  elseif (present(defaultVal)) then
    nodeAs1dReal = defaultVal
  else
#ifndef __GFORTRAN__
    call IO_error(143_pI16,key,'not in',join_str_array(self%keys()),emph=[1,3])
#else
    call IO_error(143_pI16,key,'not found',emph=[1])
#endif
  end if

  if (present(requiredSize)) then
    if (requiredSize /= size(nodeAs1dReal)) &
      call IO_error(146,ext_msg=key, &
                    label1='actual',ID1=size(nodeAs1dReal), &
                    label2='required',ID2=requiredSize)
  end if

end function tDict_get_as1dReal_sized


!--------------------------------------------------------------------------------------------------
!> @brief Get entry by key and convert to real array (1D).
!> @details Values will be broadcasted. A List content can be composed from mixture of scalar
!> or list entries. [2., [1., 3.]] with required chunks [3, 2] gives [2., 2., 2., 1., 3.].
!--------------------------------------------------------------------------------------------------
function tDict_get_as1dReal_chunked(self,key,defaultVal,requiredChunks) result(nodeAs1dReal)

  class(tDict),     intent(in) :: self
  character(len=*), intent(in) :: key
  real(pREAL),      intent(in), dimension(:), optional :: defaultVal
  integer,          intent(in), dimension(:)           :: requiredChunks
  real(pREAL),                  dimension(sum(requiredChunks)) :: nodeAs1dReal

  type(tList), pointer :: list_outer, list_inner
  class(tNode), pointer :: node_outer, node_inner
  integer :: i


  if (self%contains(key)) then
    node_outer => self%get(key)
    select type(node_outer)
      class is(tScalar)
        nodeAs1dReal = node_outer%asReal()
      class is(tList)
        list_outer => self%get_list(key)
        if (size(list_outer) /= size(requiredChunks)) &
          call IO_error(709,'list "'//list_outer%asFormattedStr()//'" is not of length '//IO_intAsStr(size(requiredChunks)))
        do i = 1, size(requiredChunks)
          node_inner => list_outer%get(i)
          select type(node_inner)
            class is(tScalar)
              nodeAs1dReal(sum(requiredChunks(:i-1))+1:sum(requiredChunks(:i))) = node_inner%asReal()
            class is(tList)
              list_inner => node_inner%asList()
              if (size(list_inner%as1dReal()) /= requiredChunks(i)) &
                  call IO_error(709,'entry "'//key//'" is not of length '//IO_intAsStr(requiredChunks(i)),&
                                'position',i)
              nodeAs1dReal(sum(requiredChunks(:i-1))+1:sum(requiredChunks(:i))) = list_inner%as1dReal()
            class default
              call IO_error(706_pI16,trim(node_inner%asFormattedStr()),'is neither a real nor a list of reals',emph=[1])
          end select
        end do
    end select
  elseif (present(defaultVal)) then
    if (size(defaultVal) == size(nodeAs1dReal)) then
      nodeAs1dReal = defaultVal
    elseif (size(defaultVal) == size(requiredChunks)) then
      do i = 1, size(requiredChunks)
        nodeAs1dReal(sum(requiredChunks(:i-1))+1:sum(requiredChunks(:i))) = defaultVal(i)
      end do
    else
      call IO_error(709,'default values not of required shape')
    end if
  else
#ifndef __GFORTRAN__
    call IO_error(143_pI16,key,'not in',join_str_array(self%keys()),emph=[1,3])
#else
    call IO_error(143_pI16,key,'not found',emph=[1])
#endif
  end if

end function tDict_get_as1dReal_chunked


#ifndef __GFORTRAN__
!--------------------------------------------------------------------------------------------------
!> @brief Get list of lists by key and convert to real array (2D).
!--------------------------------------------------------------------------------------------------
function tDict_get_as2dReal(self,key,defaultVal,requiredShape) result(nodeAs2dReal)

  class(tDict),     intent(in) :: self
  character(len=*), intent(in) :: key
  real(pREAL),      intent(in), dimension(:,:), optional :: defaultVal
  integer,          intent(in), dimension(2),   optional :: requiredShape
  real(pREAL), dimension(:,:), allocatable :: nodeAs2dReal

  type(tList), pointer :: list


  if (self%contains(key)) then
    list => self%get_list(key)
    nodeAs2dReal = list%as2dReal()
  elseif (present(defaultVal)) then
    nodeAs2dReal = defaultVal
  else
#ifndef __GFORTRAN__
    call IO_error(143_pI16,key,'not in',join_str_array(self%keys()),emph=[1,3])
#else
    call IO_error(143_pI16,key,'not found',emph=[1])
#endif
  end if

  if (present(requiredShape)) then
    if (any(requiredShape /= shape(nodeAs2dReal))) call IO_error(146,ext_msg=key)
  end if

end function tDict_get_as2dReal

#else
!--------------------------------------------------------------------------------------------------
! Older gfortran versions have issues with optional arguments of size zero.
! it somehow works for the predefined parameters 'emptyXXXArray', but reshaping them to a
! multidimensional array breaks things.
! gfortran 10.x does not work, gfortran 13.x is known to work
!--------------------------------------------------------------------------------------------------

!--------------------------------------------------------------------------------------------------
!> @brief Get list of lists by key and convert to real array (2D).
!--------------------------------------------------------------------------------------------------
function tDict_get_as2dReal_a(self,key,requiredShape) result(nodeAs2dReal)

  class(tDict),     intent(in) :: self
  character(len=*), intent(in) :: key
  integer,          intent(in), dimension(2),   optional :: requiredShape
  real(pREAL), dimension(:,:), allocatable :: nodeAs2dReal

  type(tList), pointer :: list


  if (self%contains(key)) then
    list => self%get_list(key)
    nodeAs2dReal = list%as2dReal()
  else
#ifndef __GFORTRAN__
    call IO_error(143_pI16,key,'not in',join_str_array(self%keys()),emph=[1,3])
#else
    call IO_error(143_pI16,key,'not found',emph=[1])
#endif
  end if

  if (present(requiredShape)) then
    if (any(requiredShape /= shape(nodeAs2dReal))) call IO_error(146,ext_msg=key)
  end if

end function tDict_get_as2dReal_a


!--------------------------------------------------------------------------------------------------
!> @brief Get list of lists by key and convert to real array (2D).
!--------------------------------------------------------------------------------------------------
function tDict_get_as2dReal_b(self,key,defaultVal,requiredShape) result(nodeAs2dReal)

  class(tDict),     intent(in) :: self
  character(len=*), intent(in) :: key
  real(pREAL),      intent(in), dimension(:,:) :: defaultVal
  integer,          intent(in), dimension(2),  optional :: requiredShape
  real(pREAL), dimension(:,:), allocatable :: nodeAs2dReal

  type(tList), pointer :: list


  if (self%contains(key)) then
    list => self%get_list(key)
    nodeAs2dReal = list%as2dReal()
  else
    nodeAs2dReal = defaultVal
  end if

  if (present(requiredShape)) then
    if (any(requiredShape /= shape(nodeAs2dReal))) call IO_error(146,ext_msg=key)
  end if

end function tDict_get_as2dReal_b
#endif

!--------------------------------------------------------------------------------------------------
!> @brief Get scalar by key and convert to int.
!--------------------------------------------------------------------------------------------------
function tDict_get_asInt(self,key,defaultVal) result(nodeAsInt)

  class(tDict),     intent(in) :: self
  character(len=*), intent(in) :: key
  integer,          intent(in), optional :: defaultVal
  integer :: nodeAsInt

 type(tScalar), pointer :: scalar


  if (self%contains(key)) then
    scalar => self%get_scalar(key)
    nodeAsInt = scalar%asInt()
  elseif (present(defaultVal)) then
    nodeAsInt = defaultVal
  else
#ifndef __GFORTRAN__
    call IO_error(143_pI16,key,'not in',join_str_array(self%keys()),emph=[1,3])
#else
    call IO_error(143_pI16,key,'not found',emph=[1])
#endif
  end if

end function tDict_get_asInt


!--------------------------------------------------------------------------------------------------
!> @brief Get list by key and convert to int array (1D).
!> @details If a size is required, scalars are valid input and are broadcasted to the required size.
!--------------------------------------------------------------------------------------------------
function tDict_get_as1dInt(self,key,defaultVal,requiredSize) result(nodeAs1dInt)

  class(tDict),          intent(in) :: self
  character(len=*),      intent(in) :: key
  integer, dimension(:), intent(in), optional :: defaultVal
  integer,               intent(in), optional :: requiredSize
  integer, dimension(:), allocatable :: nodeAs1dInt

  class(tNode), pointer :: content


  if (self%contains(key)) then
    content => self%get(key)
    select type(content)
      class is(tScalar)
        if (present(requiredSize)) then
          allocate(nodeAs1dInt(requiredSize),source = content%asInt())
        else
          call IO_error(706_pI16,trim(content%asFormattedStr()),'is not a list of integers',emph=[1])
        end if
      class is(tList)
        nodeAs1dInt = content%as1dInt()
    end select
  elseif (present(defaultVal)) then
    nodeAs1dInt = defaultVal
  else
#ifndef __GFORTRAN__
    call IO_error(143_pI16,key,'not in',join_str_array(self%keys()),emph=[1,3])
#else
    call IO_error(143_pI16,key,'not found',emph=[1])
#endif
  end if

  if (present(requiredSize)) then
    if (requiredSize /= size(nodeAs1dInt)) &
      call IO_error(146,ext_msg=key, &
                    label1='actual',ID1=size(nodeAs1dInt), &
                    label2='required',ID2=requiredSize)
  end if

end function tDict_get_as1dInt


!--------------------------------------------------------------------------------------------------
!> @brief Get scalar by key and convert to bool.
!--------------------------------------------------------------------------------------------------
function tDict_get_asBool(self,key,defaultVal) result(nodeAsBool)

  class(tDict),     intent(in) :: self
  character(len=*), intent(in) :: key
  logical,          intent(in), optional :: defaultVal
  logical :: nodeAsBool

  type(tScalar), pointer :: scalar


  if (self%contains(key)) then
    scalar => self%get_scalar(key)
    nodeAsBool = scalar%asBool()
  elseif (present(defaultVal)) then
    nodeAsBool = defaultVal
  else
#ifndef __GFORTRAN__
    call IO_error(143_pI16,key,'not in',join_str_array(self%keys()),emph=[1,3])
#else
    call IO_error(143_pI16,key,'not found',emph=[1])
#endif
  end if

end function tDict_get_asBool


!--------------------------------------------------------------------------------------------------
!> @brief Get list by key and convert to bool array (1D).
!--------------------------------------------------------------------------------------------------
function tDict_get_as1dBool(self,key,defaultVal) result(nodeAs1dBool)

  class(tDict),          intent(in) :: self
  character(len=*),      intent(in) :: key
  logical, dimension(:), intent(in), optional :: defaultVal
  logical, dimension(:), allocatable          :: nodeAs1dBool

  type(tList), pointer :: list


  if (self%contains(key)) then
    list => self%get_list(key)
    nodeAs1dBool = list%as1dBool()
  elseif (present(defaultVal)) then
    nodeAs1dBool = defaultVal
  else
#ifndef __GFORTRAN__
    call IO_error(143_pI16,key,'not in',join_str_array(self%keys()),emph=[1,3])
#else
    call IO_error(143_pI16,key,'not found',emph=[1])
#endif
  end if

end function tDict_get_as1dBool


!--------------------------------------------------------------------------------------------------
!> @brief Get scalar by key and convert to string.
!--------------------------------------------------------------------------------------------------
function tDict_get_asStr(self,key,defaultVal) result(nodeAsStr)

  class(tDict),     intent(in) :: self
  character(len=*), intent(in) :: key
  character(len=*), intent(in), optional :: defaultVal
  character(len=:), allocatable :: nodeAsStr

  type(tScalar), pointer :: scalar


  if (self%contains(key)) then
    scalar => self%get_scalar(key)
    nodeAsStr = scalar%asStr()
  elseif (present(defaultVal)) then
    nodeAsStr = defaultVal
  else
#ifndef __GFORTRAN__
    call IO_error(143_pI16,key,'not in',join_str_array(self%keys()),emph=[1,3])
#else
    call IO_error(143_pI16,key,'not found',emph=[1])
#endif
  end if

end function tDict_get_asStr


!--------------------------------------------------------------------------------------------------
!> @brief Get list by key and convert to string array (1D).
!--------------------------------------------------------------------------------------------------
function tDict_get_as1dStr(self,key,defaultVal) result(nodeAs1dStr)

  class(tDict),     intent(in) :: self
  character(len=*), intent(in) :: key
  character(len=*), intent(in), dimension(:), optional :: defaultVal
  character(len=:), allocatable, dimension(:)          :: nodeAs1dStr

  type(tList), pointer :: list


  if (self%contains(key)) then
    list => self%get_list(key)
    nodeAs1dStr = list%as1dStr()
  elseif (present(defaultVal)) then
    nodeAs1dStr = defaultVal
  else
#ifndef __GFORTRAN__
    call IO_error(143_pI16,key,'not in',join_str_array(self%keys()),emph=[1,3])
#else
    call IO_error(143_pI16,key,'not found',emph=[1])
#endif
  end if

end function tDict_get_as1dStr


#ifdef __GFORTRAN__
!--------------------------------------------------------------------------------------------------
!> @brief Returns string output array (1D) (hack for GNU).
!--------------------------------------------------------------------------------------------------
function output_as1dStr(self) result(output)

  class(tDict), pointer,intent(in)   ::  self
  character(len=pSTRLEN), allocatable, dimension(:) :: output

  type(tList), pointer :: output_list
  integer :: o


  output_list => self%get_list('output',defaultVal=emptyList)
  allocate(output(size(output_list)))
  do o = 1, size(output_list)
    output(o) = output_list%get_asStr(o)
  end do

end function output_as1dStr
#endif


!--------------------------------------------------------------------------------------------------
!> @brief Free associated memory.
!--------------------------------------------------------------------------------------------------
recursive subroutine tItem_finalize(self)

  type(tItem),intent(inout) :: self


  deallocate(self%node)
  if (associated(self%next)) deallocate(self%next)

end subroutine tItem_finalize


!--------------------------------------------------------------------------------------------------
!> @brief Join strings from array.
!> @details Separated by comma, enclosed by square brackets.
!--------------------------------------------------------------------------------------------------
pure function join_str_array(array) result(joined)

  character(len=*), dimension(:), intent(in) :: array
  character(len=:), allocatable :: joined

  integer :: i


  joined = '['
  if (size(array) > 0) joined = joined//trim(array(1))
  do i = 2, size(array)
    joined = joined//', '//trim(array(i))
  end do
  joined = joined//']'

end function join_str_array

end module types

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
#include <petsc/finclude/petscsnes.h>
#include <petsc/finclude/petscdmda.h>
module grid_chemical_FDM
  use PETScDMDA
  use PETScSNES
#ifndef PETSC_EXPOSES_MPI
  use MPI_f08
#endif
  use HDF5

  use prec
  use parallelization
  use IO
  use misc
  use CLI
  use HDF5_utilities
  use spectral_utilities
  use discretization_grid
  use homogenization
  use material
  use types
  use config
  use math

#ifndef PETSC_EXPOSES_MPIF90
  implicit none(type,external)
#else
  implicit none
#endif
  private

  type :: tNumerics
    integer :: &
      itmax                                                                                         !< maximum number of iterations
    real(pREAL) :: &
      eps_chemical_atol, &                                                                          !< absolute tolerance for thermal equilibrium
      eps_chemical_rtol                                                                             !< relative tolerance for thermal equilibrium
  end type tNumerics

  type(tNumerics) :: num

!--------------------------------------------------------------------------------------------------
! PETSc data
  SNES :: SNES_chemical
  Vec :: mu_vec, mu_lastinc_vec

  type, private :: tScal
    PetscReal, pointer :: scal(:,:,:,:)
  end type tScal

  real(pREAL), private :: delta(3)
  real(pREAL), dimension(:,:,:,:), allocatable :: &
    c, &
    c_lastinc, &
    c_staginc

  integer :: totalIter = 0                                                                          !< total iteration in current increment
  integer :: N_components
  real(pREAL) :: Delta_t_

  public :: &
    grid_chemical_FDM_init, &
    grid_chemical_FDM_solution, &
    grid_chemical_FDM_restartWrite, &
    grid_chemical_FDM_forward

contains

!--------------------------------------------------------------------------------------------------
!> @brief Allocate all necessary fields and fill them with data, potentially from restart info.
!--------------------------------------------------------------------------------------------------
subroutine grid_chemical_FDM_init(num_grid_chemical)

  type(tDict), pointer, intent(in) :: num_grid_chemical

  PetscInt, dimension(0:worldsize-1) :: cells3_global
  integer :: i, j , k, ce, com
  DM :: DM_chemical
  PetscReal, dimension(:,:,:,:), pointer :: mu
  PetscErrorCode :: err_PETSc
  integer(HID_T) :: fileHandle, groupHandle
  integer(MPI_INTEGER_KIND) :: err_MPI
  real(pREAL), dimension(:,:,:,:), allocatable :: mu_0
  real(pREAL), dimension(:,:),     allocatable :: tempN
  character(len=:), allocatable :: petsc_options


  print'(/,1x,a)', '<<<+-  grid_chemical_FDM init  -+>>>'

  print'(/,1x,a)', 'P. Shanthraj et al., Computer Methods in Applied Mechanics and Engineering, 2020'
  print'(  1x,a)', 'https://doi.org/10.1016/j.cma.2020.113029'


  N_components = homogenization_chemical_maxNcomponents - 1
  allocate(mu_0(N_components,cells(1),cells(2),cells3),    source=0.0_pREAL)
  allocate(tempN(N_components,product(cells(1:2))*cells3), source=0.0_pREAL)
!-------------------------------------------------------------------------------------------------
! read numerical parameters and do sanity checks
  num%itmax             = num_grid_chemical%get_asInt  ('itmax',           defaultVal=250)
  num%eps_chemical_atol = num_grid_chemical%get_asReal('eps_chemical_atol',defaultVal=1.0e-6_pREAL)
  num%eps_chemical_rtol = num_grid_chemical%get_asReal('eps_chemical_rtol',defaultVal=1.0e-6_pREAL)

  if (num%itmax <= 1)                     call IO_error(301,ext_msg='itmax')
  if (num%eps_chemical_atol <= 0.0_pREAL) call IO_error(301,ext_msg='eps_chemical_atol')
  if (num%eps_chemical_rtol <= 0.0_pREAL) call IO_error(301,ext_msg='eps_chemical_rtol')

!--------------------------------------------------------------------------------------------------
! set default and user defined options for PETSc
  petsc_options = misc_prefixOptions('-snes_type newtonls -snes_ksp_ew -ksp_type fgmres -ksp_max_it 25 ' &
                                        //num_grid_chemical%get_asStr('PETSc_options',defaultVal=''), &
                                     'chemical_')
  call PetscOptionsInsertString(PETSC_NULL_OPTIONS,petsc_options,err_PETSc)
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! initialize solver specific parts of PETSc
  call SNESCreate(PETSC_COMM_WORLD,SNES_chemical,err_PETSc); CHKERRQ(err_PETSc)
  call SNESSetOptionsPrefix(SNES_chemical,'chemical_',err_PETSc);CHKERRQ(err_PETSc)
  call MPI_Allgather(int(cells3,pPETSCINT),1_MPI_INTEGER_KIND,MPI_INTEGER,&
                     cells3_global,1_MPI_INTEGER_KIND,MPI_INTEGER,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  call DMDACreate3D(PETSC_COMM_WORLD, &
         DM_BOUNDARY_PERIODIC, DM_BOUNDARY_PERIODIC, DM_BOUNDARY_PERIODIC, &                        ! cut off stencil at boundary
         DMDA_STENCIL_BOX, &                                                                        ! Moore (26) neighborhood around central point
         int(cells(1),pPETSCINT),int(cells(2),pPETSCINT),int(cells(3),pPETSCINT), &                 ! global grid
         1_pPETSCINT, 1_pPETSCINT, int(worldsize,pPETSCINT), &
         int(N_components,pPETSCINT), 1_pPETSCINT, &                                                ! #dof (mu field), ghost boundary width (domain overlap)
         [int(cells(1),pPETSCINT)],[int(cells(2),pPETSCINT)],cells3_global, &                       ! local grid
         DM_chemical,err_PETSc)                                                                     ! handle, error
  CHKERRQ(err_PETSc)
  call SNESSetDM(SNES_chemical,DM_chemical,err_PETSc); CHKERRQ(err_PETSc)                           ! connect snes to da
  call DMsetFromOptions(DM_chemical,err_PETSc); CHKERRQ(err_PETSc)
  call DMsetUp(DM_chemical,err_PETSc); CHKERRQ(err_PETSc)
  call DMCreateGlobalVector(DM_chemical,mu_vec,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMCreateGlobalVector(DM_chemical,mu_lastinc_vec,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMSNESSetFunctionLocal(DM_chemical,form_residual,PETSC_NULL_SNES,err_PETSc)                  ! residual vector of same shape as solution vector
  CHKERRQ(err_PETSc)
  call DMSNESSetJacobianLocal(DM_chemical,form_jacobian,PETSC_NULL_SNES,err_PETSc)                  ! function to evaluate stiffness matrix
  CHKERRQ(err_PETSc)
  call SNESSetMaxLinearSolveFailures(SNES_chemical, huge(1_pPETSCINT), err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESSetFromOptions(SNES_chemical,err_PETSc); CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! init fields
  call VecSet(mu_vec,0.0_pREAL,err_PETSc); CHKERRQ(err_PETSc)
  call VecSet(mu_lastinc_vec,0.0_pREAL,err_PETSc); CHKERRQ(err_PETSc)

  allocate(c(1:N_components+1,cells(1),cells(2),cells3),source=0.0_pREAL)
  allocate(c_staginc(1:N_components+1,cells(1),cells(2),cells3),source=0.0_pREAL)
  allocate(c_lastinc(1:N_components+1,cells(1),cells(2),cells3),source=0.0_pREAL)

  call DMDAVecGetArray(DM_chemical,mu_vec,mu,err_PETSc)
  CHKERRQ(err_PETSc)

  restartRead: if (CLI_restartInc /= -1) then
    print'(/,1x,a,1x,i0)', 'loading restart data of increment', CLI_restartInc

    fileHandle  = HDF5_openFile(CLI_jobName//'_restart.hdf5','r')
    groupHandle = HDF5_openGroup(fileHandle,'solver')

    call HDF5_read(tempN,groupHandle,'mu',.false.)
    mu_0 = reshape(tempN,[N_components,cells(1),cells(2),cells3])
  else
    do com = 1, N_components
      mu_0(com,:,:,:) = discretization_grid_getScalarInitialCondition(material_name_species(com))
    end do
  end if restartRead

  ce = 0
  do k = 1,cells3; do j = 1, cells(2); do i = 1, cells(1)
    ce = ce + 1
    c(:,i,j,k) = homogenization_composition(mu_0(:,i,j,k), 1.0_pREAL, ce)
    c_lastinc(:,i,j,k) = c(:,i,j,k)
    c_staginc(:,i,j,k) = c(:,i,j,k)
    call homogenization_chemical_setField(mu_0(:,i,j,k),c(1:N_components+1,i,j,k), 1.0_pREAL, ce)
  end do; end do; end do
  mu = mu_0
  call DMDAVecRestoreArray(DM_chemical,mu_vec,mu,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecCopy(mu_vec,mu_lastinc_vec,err_PETSc)
  CHKERRQ(err_PETSc)

  delta = geomSize/real(cells,pREAL)

end subroutine grid_chemical_FDM_init


!--------------------------------------------------------------------------------------------------
!> @brief solution for the FEM chemical scheme with internal iterations
!--------------------------------------------------------------------------------------------------
function grid_chemical_FDM_solution(Delta_t) result(solution)

  real(pREAL), intent(in) :: Delta_t
  type(tSolutionState) :: solution

  DM :: da_local
  PetscReal, pointer :: mu(:,:,:,:)
  integer   :: i, j, k, ce, com
  real(pREAL), dimension(N_components+1) :: conc_min, conc_max, conc_avg, stagNorm
  PetscErrorCode :: err_PETSc
  integer(MPI_INTEGER_KIND) :: err_MPI
  SNESConvergedReason :: reason

  solution%converged = .false.

!--------------------------------------------------------------------------------------------------
! set module wide availabe data
  Delta_t_ = Delta_t

  call SNESSolve(SNES_chemical,PETSC_NULL_VEC,mu_vec,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESGetConvergedReason(SNES_chemical,reason,err_PETSc)
  CHKERRQ(err_PETSc)

#if PETSC_VERSION_MINOR<23
  solution%converged = reason > SNES_CONVERGED_ITERATING ! .and. status == STATUS_OK
#else
  solution%converged = reason%v > SNES_CONVERGED_ITERATING%v ! .and. status == STATUS_OK
#endif
  solution%iterationsNeeded = merge(totalIter,num%itmax,solution%converged)

  call SNESGetDM(SNES_chemical,da_local,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecGetArray(da_local,mu_vec,mu,err_PETSc)
  CHKERRQ(err_PETSc)

  conc_min(1:N_components+1) =  huge(1.0_pREAL)
  conc_max(1:N_components+1) = -huge(1.0_pREAL)
  conc_avg(1:N_components+1) = 0.0_pREAL
  stagNorm(1:N_components+1) = -huge(1.0_pREAL)

  ce = 0
  do k = 1+cells3offset, cells3+cells3offset; do j = 1, cells(2); do i = 1, cells(1)
    ce = ce + 1
    c(:,i,j,k-cells3offset) = homogenization_composition(mu(0:N_components-1,i-1,j-1,k-1), Delta_t_, ce)
    do com = 1, N_components+1
      conc_min(com) = min(conc_min(com),c(com,i,j,k-cells3offset))
      conc_max(com) = max(conc_max(com),c(com,i,j,k-cells3offset))
      conc_avg(com) = conc_avg(com) + c(com,i,j,k-cells3offset)
      stagNorm(com) = max(stagNorm(com),abs(c(com,i,j,k-cells3offset) - c_staginc(com,i,j,k-cells3offset)))
    end do
  end do; end do; end do
  call MPI_Allreduce(MPI_IN_PLACE,stagNorm,N_components+1,MPI_DOUBLE,MPI_MAX,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  call MPI_Allreduce(MPI_IN_PLACE,conc_avg,N_components+1,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  call MPI_Allreduce(MPI_IN_PLACE,conc_max,N_components+1,MPI_DOUBLE,MPI_MAX,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  call MPI_Allreduce(MPI_IN_PLACE,conc_min,N_components+1,MPI_DOUBLE,MPI_MIN,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  solution%stagConverged = all(stagNorm < num%eps_chemical_atol)
  c_staginc = c

!--------------------------------------------------------------------------------------------------
! updating chemical state
  ce = 0
  do k = 1 + cells3offset, cells3+cells3offset; do j = 1, cells(2); do i = 1, cells(1)
    ce = ce + 1
    call homogenization_chemical_setField(mu(0:N_components-1,i-1,j-1,k-1),&
                                          c(1:N_components+1,i,j,k-cells3offset), &
                                          Delta_t_, ce)
  end do; end do; end do

  call DMDAVecRestoreArray(da_local,mu_vec,mu,err_PETSc)
  CHKERRQ(err_PETSc)
  if (solution%converged) then
    print'(/,1x,a)', '... chemical diffusion converged ..................................'
    do com = 1, N_components+1
      print'(/,1x,a,f8.4,2x,f8.4,2x,f8.4,2x,f8.4)', 'Minimum|Maximum|Avg|Delta composition / mole_fraction = ', &
        conc_min(com), conc_max(com), conc_avg(com)*wgt, stagNorm(com)
    end do
    print'(/,1x,a)', '==========================================================================='
    flush(IO_STDOUT)
  end if


end function grid_chemical_FDM_solution


!--------------------------------------------------------------------------------------------------
!> @brief forwarding routine
!--------------------------------------------------------------------------------------------------
subroutine grid_chemical_FDM_forward(cutBack)

  logical, intent(in) :: cutBack

  integer :: i, j, k, ce
  DM :: da_local
  PetscReal, dimension(:,:,:,:), pointer :: mu
  PetscErrorCode :: err_PETSc

  if (cutBack) then
    c = c_lastinc
    c_staginc = c_lastinc

    call SNESGetDM(SNES_chemical,da_local,err_PETSc)
    CHKERRQ(err_PETSc)
    call VecCopy(mu_lastinc_vec,mu_vec,err_PETSc)
    CHKERRQ(err_PETSc)
    call DMDAVecGetArray(da_local,mu_vec,mu,err_PETSc)
    CHKERRQ(err_PETSc)
    ce = 0
    do k = 1, cells3offset, cells3+cells3offset; do j = 1, cells(2); do i = 1, cells(1)
      ce = ce + 1
      call homogenization_chemical_setField(mu(0:N_components-1,i-1,j-1,k-1),&
                                           c(1:N_components+1,i,j,k-cells3offset), &
                                           Delta_t_, ce)
    end do; end do; end do
    call DMDAVecRestoreArray(da_local,mu_vec,mu,err_PETSc)
    CHKERRQ(err_PETSc)
  else
    c_lastinc = c
    call VecCopy(mu_vec,mu_lastinc_vec,err_PETSc)
    CHKERRQ(err_PETSc)
  end if


end subroutine grid_chemical_FDM_forward


!--------------------------------------------------------------------------------------------------
!> @brief Write current solver and constitutive data for restart to file.
!--------------------------------------------------------------------------------------------------
subroutine grid_chemical_FDM_restartWrite()

  PetscErrorCode :: err_PETSc
  DM :: da_local
  integer(HID_T) :: fileHandle, groupHandle
  real(pREAL), dimension(:,:,:,:), pointer :: mu


  call SNESGetDM(SNES_chemical,da_local,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecGetArrayRead(da_local,mu_vec,mu,err_PETSc)
  CHKERRQ(err_PETSc)

  print'(1x,a)', 'saving chemical solver data required for restart'; flush(IO_STDOUT)

  fileHandle  = HDF5_openFile(CLI_jobName//'_restart.hdf5','a')
  groupHandle = HDF5_openGroup(fileHandle,'solver')
  call HDF5_write(reshape(mu,[N_components,product(shape(mu))/N_components]),groupHandle,'mu')
  call HDF5_closeGroup(groupHandle)
  call HDF5_closeFile(fileHandle)

  call DMDAVecRestoreArrayRead(da_local,mu_vec,mu,err_PETSc);
  CHKERRQ(err_PETSc)

end subroutine grid_chemical_FDM_restartWrite


!--------------------------------------------------------------------------------------------------
!> @brief Construct the residual vector.
!--------------------------------------------------------------------------------------------------
subroutine form_residual(da_local,solution_current_local,r_vec,dummy,err_PETSc)

  DM  :: da_local
  Vec :: solution_current_local, &
         r_vec
  PetscObject :: dummy
  PetscErrorCode :: err_PETSc

  Vec, dimension(N_components) :: mobility_global, &
                                  mobility_local
  type(tScal),dimension(N_components) :: mobility_scal
  PetscReal, dimension(:,:,:,:), pointer :: mu, &
                                            r
  real(pREAL),dimension(3,N_components) :: mu_grad_forward, &
                                           mu_grad_backward, &
                                           flux_forward, &
                                           flux_backward
  real(pREAL), dimension(3,N_components,N_components) :: mobility_forward, &
                                                         mobility_backward
  integer :: ce, i, j, k, dir, com_i, com_j
  real(pREAL), dimension(N_components,N_components) :: mobility


  call VecSet(r_vec,0.0_pREAL,err_PETSc); CHKERRQ(err_PETSc)
  call DMDAVecGetArray(da_local,r_vec,r,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecGetArray(da_local,solution_current_local,mu,err_PETSc)
  CHKERRQ(err_PETSc)

  do com_i = 1, N_components
    call DMGetGlobalVector(da_local,mobility_global(com_i),err_PETSc)
    CHKERRQ(err_PETSc)
    call DMGetLocalVector(da_local,mobility_local(com_i),err_PETSc)
    CHKERRQ(err_PETSc)
    call VecSet(mobility_global(com_i),0.0_pREAL,err_PETSc)
    CHKERRQ(err_PETSc)
    call VecSet(mobility_local(com_i),0.0_pREAL,err_PETSc)
    CHKERRQ(err_PETSc)
    call DMDAVecGetArray(da_local,mobility_global(com_i),mobility_scal(com_i)%scal,err_PETSc)
    CHKERRQ(err_PETSc)
  end do

  ce = 0
  do k = 1+cells3offset, cells3offset+cells3; do j = 1, cells(2); do i = 1, cells(1)
    ce = ce + 1
    ! Get mobility tensor
    mobility = homogenization_mobility(ce)
    do com_i = 1, N_components
      mobility_scal(com_i)%scal(0:N_components-1,i-1,j-1,k-1) = mobility(com_i,1:N_components)
    end do
  end do; end do; end do

  do com_i = 1, N_components
    call DMDAVecRestoreArray(da_local,mobility_global(com_i),mobility_scal(com_i)%scal,err_PETSc)
    CHKERRQ(err_PETSc)
    call DMGlobalToLocalBegin(da_local,mobility_global(com_i),INSERT_VALUES,mobility_local(com_i),err_PETSc)
    CHKERRQ(err_PETSc)
    call DMGlobalToLocalEnd  (da_local,mobility_global(com_i),INSERT_VALUES,mobility_local(com_i),err_PETSc)
    CHKERRQ(err_PETSc)
    call DMRestoreGlobalVector(da_local,mobility_global(com_i),err_PETSc)
    CHKERRQ(err_PETSc)
    call DMDAVecGetArray(da_local,mobility_local(com_i),mobility_scal(com_i)%scal,err_PETSc)
    CHKERRQ(err_PETSc)
  end do

  ce = 0
  do k = cells3offset, cells3offset+cells3-1; do j = 0, cells(2)-1; do i = 0, cells(1)-1
    ce = ce + 1
    do com_i = 1, N_components
       mobility_forward(1,com_i,:)   =  (mobility_scal(com_i)%scal(:,i  ,j  ,k  ) &
                                     +   mobility_scal(com_i)%scal(:,i+1,j  ,k  ))/2
       mobility_forward(2,com_i,:)   =  (mobility_scal(com_i)%scal(:,i  ,j  ,k  ) &
                                     +   mobility_scal(com_i)%scal(:,i  ,j+1,k  ))/2
       mobility_forward(3,com_i,:)   =  (mobility_scal(com_i)%scal(:,i  ,j  ,k  ) &
                                     +   mobility_scal(com_i)%scal(:,i  ,j  ,k+1))/2
       mobility_backward(1,com_i,:)  =  (mobility_scal(com_i)%scal(:,i  ,j  ,k  ) &
                                     +   mobility_scal(com_i)%scal(:,i-1,j  ,k  ))/2
       mobility_backward(2,com_i,:)  =  (mobility_scal(com_i)%scal(:,i  ,j  ,k  ) &
                                     +   mobility_scal(com_i)%scal(:,i  ,j-1,k  ))/2
       mobility_backward(3,com_i,:)  =  (mobility_scal(com_i)%scal(:,i  ,j  ,k  ) &
                                     +   mobility_scal(com_i)%scal(:,i  ,j  ,k-1))/2
    end do

    ! get potential gradients
    mu_grad_forward (1,:) = (mu(:,i+1,j  ,k  ) - mu(:,i  ,j  ,k  ))/delta(1)
    mu_grad_forward (2,:) = (mu(:,i  ,j+1,k  ) - mu(:,i  ,j  ,k  ))/delta(2)
    mu_grad_forward (3,:) = (mu(:,i  ,j  ,k+1) - mu(:,i  ,j  ,k  ))/delta(3)
    mu_grad_backward(1,:) = (mu(:,i  ,j  ,k  ) - mu(:,i-1,j  ,k  ))/delta(1)
    mu_grad_backward(2,:) = (mu(:,i  ,j  ,k  ) - mu(:,i  ,j-1,k  ))/delta(2)
    mu_grad_backward(3,:) = (mu(:,i  ,j  ,k  ) - mu(:,i  ,j  ,k-1))/delta(3)

    ! get fluxes
    flux_forward  = 0.0_pREAL
    flux_backward = 0.0_pREAL
    do com_i = 1, N_components
      do com_j = 1, N_components
        do dir = 1, 3
          flux_forward (dir,com_i) = flux_forward (dir,com_i) &
                                   + mobility_forward(dir,com_i,com_j) &
                                   * mu_grad_forward(dir,com_j)
          flux_backward(dir,com_i) = flux_backward(dir,com_i) &
                                   + mobility_backward(dir,com_i,com_j) &
                                   * mu_grad_backward(dir,com_j)
        end do
      end do
    end do


    ! form residual (c - c_0 - deltaT * div (M*grad(mu))). source (-fdt not included yet)

    c(:,i+1,j+1,k+1-cells3offset) = homogenization_composition(mu(:,i,j,k), Delta_t_, ce)
    r(0:N_components-1,i,j,k) = c(1:N_components,i+1,j+1,k+1-cells3offset) &
                              - c_lastinc(1:N_components,i+1,j+1,k+1-cells3offset)
    do com_i = 0, N_components-1
      do dir = 1, 3
        r(com_i,i,j,k) = r(com_i,i,j,k) &
                       - (flux_forward (dir,com_i+1) - flux_backward(dir,com_i+1))*Delta_t_/delta(dir)
      end do
    end do
  end do; end do; end do

  do com_i = 1, N_components
    call DMDAVecRestoreArray(da_local,mobility_local(com_i),mobility_scal(com_i)%scal,err_PETSc)
    CHKERRQ(err_PETSc)
    call DMRestoreLocalVector(da_local,mobility_local(com_i),err_PETSc)
    CHKERRQ(err_PETSc)
  end do

  call DMDAVecRestoreArray(da_local,solution_current_local,mu,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecRestoreArray(da_local,r_vec,r,err_PETSc)
  CHKERRQ(err_PETSc)

end subroutine form_residual


!--------------------------------------------------------------------------------------------------
!> @brief Form the FDM Jacobian matrix.
!--------------------------------------------------------------------------------------------------
subroutine form_jacobian(da_local,solution_current_local,Jac_mat,Jac_pre_mat,dummy,err_PETSc) ! needed for periodic bc?

  DM  :: da_local
  Vec :: solution_current_local
  Mat :: Jac_mat, Jac_pre_mat
  PetscObject :: dummy
  PetscErrorCode :: err_PETSc

  Vec, dimension(N_components) :: mobility_global, &
                                  mobility_local
  type(tScal),dimension(N_components) :: mobility_scal
  PetscReal, dimension(:,:,:,:), pointer :: mu
  real(pREAL), dimension(3,N_components,N_components) :: mobility_forward, &
                                                         mobility_backward
  integer :: ce, i, j, k, dir, com, com_i
  real(pREAL), dimension(N_components,N_components) ::  mobility
#if PETSC_VERSION_MINOR<23
  MatStencil,dimension(4,7*N_components) :: col
  MatStencil,dimension(4,N_components) :: row
#else
  MatStencil,dimension(7*N_components) :: col
  MatStencil,dimension(N_components) :: row
#endif
  PetscReal :: Jac(N_components,7*N_components)

!--------------------------------------------------------------------------------------------------
! get mobilities
  do com_i = 1, N_components
    call DMGetGlobalVector(da_local,mobility_global(com_i),err_PETSc);
    CHKERRQ(err_PETSc)
    call DMGetLocalVector(da_local,mobility_local(com_i),err_PETSc)
    CHKERRQ(err_PETSc)
    call VecSet(mobility_global(com_i),0.0_pREAL,err_PETSc)
    CHKERRQ(err_PETSc)
    call VecSet(mobility_local(com_i),0.0_pREAL,err_PETSc);
    CHKERRQ(err_PETSc)
    call DMDAVecGetArray(da_local,mobility_global(com_i),mobility_scal(com_i)%scal,err_PETSc)
    CHKERRQ(err_PETSc)
  end do

  ce = 0
  do k = 1+cells3offset, cells3offset+cells3; do j = 1, cells(2); do i = 1, cells(1)
    ce = ce + 1
   ! Get mobility tensor
    mobility = homogenization_mobility(ce)
    do com_i = 1, N_components
      mobility_scal(com_i)%scal(:,i-1,j-1,k-1) = mobility(com_i,:)
    end do
  end do; end do; end do

  do com_i = 1, N_components
    call DMDAVecRestoreArray(da_local,mobility_global(com_i),mobility_scal(com_i)%scal,err_PETSc)
    CHKERRQ(err_PETSc)
    call DMGlobalToLocalBegin(da_local,mobility_global(com_i),INSERT_VALUES,mobility_local(com_i),err_PETSc)
    CHKERRQ(err_PETSc)
    call DMGlobalToLocalEnd  (da_local,mobility_global(com_i),INSERT_VALUES,mobility_local(com_i),err_PETSc)
    CHKERRQ(err_PETSc)
    call DMRestoreGlobalVector(da_local,mobility_global(com_i),err_PETSc)
    CHKERRQ(err_PETSc)
    call DMDAVecGetArray(da_local,mobility_local(com_i),mobility_scal(com_i)%scal,err_PETSc)
    CHKERRQ(err_PETSc)
  end do

!--------------------------------------------------------------------------------------------------
! assemble matrix
  call MatSetOption(Jac_mat,MAT_KEEP_NONZERO_PATTERN,PETSC_TRUE,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatSetOption(Jac_mat,MAT_NEW_NONZERO_ALLOCATION_ERR,PETSC_FALSE,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatZeroEntries(Jac_mat,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecGetArray(da_local,solution_current_local,mu,err_PETSc)
  CHKERRQ(err_PETSc)
  ce = 0
  do k = cells3offset, cells3offset+cells3-1; do j = 0, cells(2)-1; do i = 0, cells(1)-1
    ce = ce + 1
    Jac = 0.0_pREAL
    do com = 0, N_components-1
#if PETSC_VERSION_MINOR<23
      row(MatStencil_i,  com+1) = i
      row(MatStencil_j,  com+1) = j
      row(MatStencil_k,  com+1) = k
      row(MatStencil_c,  com+1) = com
      col(MatStencil_i,7*com+1) = i
      col(MatStencil_j,7*com+1) = j
      col(MatStencil_k,7*com+1) = k
      col(MatStencil_c,7*com+1) = com
      col(MatStencil_i,7*com+2) = i+1
      col(MatStencil_j,7*com+2) = j
      col(MatStencil_k,7*com+2) = k
      col(MatStencil_c,7*com+2) = com
      col(MatStencil_i,7*com+3) = i
      col(MatStencil_j,7*com+3) = j+1
      col(MatStencil_k,7*com+3) = k
      col(MatStencil_c,7*com+3) = com
      col(MatStencil_i,7*com+4) = i
      col(MatStencil_j,7*com+4) = j
      col(MatStencil_k,7*com+4) = k+1
      col(MatStencil_c,7*com+4) = com
      col(MatStencil_i,7*com+5) = i-1
      col(MatStencil_j,7*com+5) = j
      col(MatStencil_k,7*com+5) = k
      col(MatStencil_c,7*com+5) = com
      col(MatStencil_i,7*com+6) = i
      col(MatStencil_j,7*com+6) = j-1
      col(MatStencil_k,7*com+6) = k
      col(MatStencil_c,7*com+6) = com
      col(MatStencil_i,7*com+7) = i
      col(MatStencil_j,7*com+7) = j
      col(MatStencil_k,7*com+7) = k-1
      col(MatStencil_c,7*com+7) = com
#else
      row(  com+1)%i = i
      row(  com+1)%j = j
      row(  com+1)%k = k
      row(  com+1)%c = com
      col(7*com+1)%i = i
      col(7*com+1)%j = j
      col(7*com+1)%k = k
      col(7*com+1)%c = com
      col(7*com+2)%i = i+1
      col(7*com+2)%j = j
      col(7*com+2)%k = k
      col(7*com+2)%c = com
      col(7*com+3)%i = i
      col(7*com+3)%j = j+1
      col(7*com+3)%k = k
      col(7*com+3)%c = com
      col(7*com+4)%i = i
      col(7*com+4)%j = j
      col(7*com+4)%k = k+1
      col(7*com+4)%c = com
      col(7*com+5)%i = i-1
      col(7*com+5)%j = j
      col(7*com+5)%k = k
      col(7*com+5)%c = com
      col(7*com+6)%i = i
      col(7*com+6)%j = j-1
      col(7*com+6)%k = k
      col(7*com+6)%c = com
      col(7*com+7)%i = i
      col(7*com+7)%j = j
      col(7*com+7)%k = k-1
      col(7*com+7)%c = com
#endif
    end do

    do com_i = 1, N_components
      mobility_forward(1,com_i,:)   =  (mobility_scal(com_i)%scal(:,i  ,j  ,k  ) &
                                      + mobility_scal(com_i)%scal(:,i+1,j  ,k  ))/2
      mobility_forward(2,com_i,:)   =  (mobility_scal(com_i)%scal(:,i  ,j  ,k  ) &
                                      + mobility_scal(com_i)%scal(:,i  ,j+1,k  ))/2
      mobility_forward(3,com_i,:)   =  (mobility_scal(com_i)%scal(:,i  ,j  ,k  ) &
                                      + mobility_scal(com_i)%scal(:,i  ,j  ,k+1))/2
      mobility_backward(1,com_i,:)  =  (mobility_scal(com_i)%scal(:,i  ,j  ,k  ) &
                                      + mobility_scal(com_i)%scal(:,i-1,j  ,k  ))/2
      mobility_backward(2,com_i,:)  =  (mobility_scal(com_i)%scal(:,i  ,j  ,k  ) &
                                      + mobility_scal(com_i)%scal(:,i  ,j-1,k  ))/2
      mobility_backward(3,com_i,:)  =  (mobility_scal(com_i)%scal(:,i  ,j  ,k  ) &
                                      + mobility_scal(com_i)%scal(:,i  ,j  ,k-1))/2
    end do

    Jac(1:N_components,1:7*N_components:7) = &
             matmul(math_eye(N_components),homogenization_compositionTangent(mu(:,i,j,k),Delta_t_,ce))

    do dir = 1, 3
      Jac(1:N_components,1:    7*N_components:7) = Jac(1:N_components,1:7*N_components:7) &
                                                 + (mobility_forward (dir,:,:) + mobility_backward(dir,:,:))  &
                                                    * Delta_t_/delta(dir)**2
      Jac(1:N_components,1+dir:7*N_components:7) = Jac(1:N_components,1+dir:7*N_components:7) &
                                                 - mobility_forward (dir,:,:) * Delta_t_/delta(dir)**2
      Jac(1:N_components,4+dir:7*N_components:7) = Jac(1:N_components,4+dir:7*N_components:7) &
                                                 - mobility_backward(dir,:,:) * Delta_t_/delta(dir)**2
    end do
#if PETSC_VERSION_MINOR<23
    call MatSetValuesStencil(Jac_mat,int(N_components,pPETSCINT),row,int(7*N_components,pPETSCINT),&
                             col,transpose(Jac),INSERT_VALUES,err_PETSc)
#else
    call MatSetValuesStencil(Jac_mat,int(N_components,pPETSCINT),row,int(7*N_components,pPETSCINT),&
                             col,reshape(transpose(Jac),[size(Jac)]),INSERT_VALUES,err_PETSc)
#endif
    CHKERRQ(err_PETSc)
  end do; end do; end do
  call MatAssemblyBegin(Jac_mat,MAT_FINAL_ASSEMBLY,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatAssemblyEnd(Jac_mat,MAT_FINAL_ASSEMBLY,err_PETSc)
  CHKERRQ(err_PETSc)
  ! MD: Is anything done with Jac_pre_mat?
  call MatAssemblyBegin(Jac_pre_mat,MAT_FINAL_ASSEMBLY,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatAssemblyEnd(Jac_pre_mat,MAT_FINAL_ASSEMBLY,err_PETSc)
  CHKERRQ(err_PETSc)

  do com_i = 1, N_components
    call DMDAVecRestoreArray(da_local,mobility_local(com_i),mobility_scal(com_i)%scal,err_PETSc)
    CHKERRQ(err_PETSc)
    call DMRestoreLocalVector(da_local,mobility_local(com_i),err_PETSc)
    CHKERRQ(err_PETSc)
  end do
  call DMDAVecRestoreArray(da_local,solution_current_local,mu,err_PETSc)
  CHKERRQ(err_PETSc)

end subroutine form_jacobian

end module grid_chemical_FDM

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
submodule(homogenization:chemical) chemical_pass

contains

module subroutine pass_init()

  integer :: &
    ho


  print'(/,a)', ' <<<+-  homogenization:chemical:pass init  -+>>>'

  if (count(chemical_type == CHEMICAL_PASS_ID) == 0) return

  print'(/,a,i0)', ' # homogenizations: ',count(chemical_type == CHEMICAL_PASS_ID)

  do ho = 1, size(material_name_homogenization)

    if (chemical_type(ho) /= CHEMICAL_PASS_ID) cycle

    print'(/,1x,a,1x,i0,a)', 'homogenization',ho,': '//material_name_homogenization(ho)

  end do
end subroutine pass_init

end submodule chemical_pass

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Daniel Otto de Mentock, Max‑Planck‑Institut für Nachhaltige Materialien GmbH
!> @author Martin Diehl, KU Leuven
!> @brief  Helpers to interface between C and Fortran strings
!--------------------------------------------------------------------------------------------------
module C_interfacing
  use, intrinsic :: ISO_C_binding

  use prec

  implicit none(type,external)
  private

#if (defined(__INTEL_COMPILER) && __INTEL_COMPILER_BUILD_DATE < 20240000) \
 || (defined(__GFORTRAN__) && __GNUC__ < 15) \
 || defined(__flang__)
  public :: &
    f_c_string
#endif

contains

#if (defined(__INTEL_COMPILER) && __INTEL_COMPILER_BUILD_DATE < 20240000) \
 || (defined(__GFORTRAN__) && __GNUC__ < 15) \
 || defined(__flang__)
!--------------------------------------------------------------------------------------------------
!> @brief Fortran 2023 "f_c_string" (without optional argument).
!> @details: C string is NULL terminated and, hence, longer by one than the Fortran string.
!--------------------------------------------------------------------------------------------------
pure function f_c_string(f_string) result(c_string)

  character(len=*), intent(in) :: f_string
  character(kind=C_CHAR,len=len_trim(f_string,pI64)+1_pI64) :: c_string


  c_string = trim(f_string)//C_NULL_CHAR

end function f_c_string
#endif


end module C_interfacing

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief  Decode Base64 strings.
!> @details See https://en.wikipedia.org/wiki/Base64.
!--------------------------------------------------------------------------------------------------
module base64
  use prec
  use IO

  implicit none(type,external)
  private

  character(len=*), parameter :: &
    base64_encoding='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'

  public :: &
    base64_init, &
    base64_to_bytes, &
    base64_nChar, &
    base64_nByte

contains


!--------------------------------------------------------------------------------------------------
!> @brief Do self test.
!--------------------------------------------------------------------------------------------------
subroutine base64_init()

  print'(/,1x,a)', '<<<+-  base64 init  -+>>>'; flush(IO_STDOUT)

  call selfTest()

end subroutine base64_init


!--------------------------------------------------------------------------------------------------
!> @brief Calculate number of Base64 characters required for storage of N bytes.
!--------------------------------------------------------------------------------------------------
pure function base64_nChar(nByte)

  integer(pI64), intent(in) :: nByte
  integer(pI64)             :: base64_nChar

  base64_nChar = 4_pI64 * (nByte/3_pI64 + merge(1_pI64,0_pI64,mod(nByte,3_pI64) /= 0_pI64))

end function base64_nChar


!--------------------------------------------------------------------------------------------------
!> @brief Calculate number of bytes required for storage of N Base64 characters.
!--------------------------------------------------------------------------------------------------
pure function base64_nByte(nBase64)

  integer(pI64), intent(in) :: nBase64
  integer(pI64)             :: base64_nByte

  base64_nByte = 3_pI64 * (nBase64/4_pI64)

end function base64_nByte


!--------------------------------------------------------------------------------------------------
!> @brief Decode Base64 ASCII string into byte-wise binary representation.
!--------------------------------------------------------------------------------------------------
function base64_to_bytes(base64_str,s,e) result(bytes)

  character(len=*),  intent(in) :: base64_str                                                       !< Base64 string representation
  integer(pI64), intent(in), optional :: &
    s, &                                                                                            !< start (in bytes)
    e                                                                                               !< end (in bytes)

  integer(pI64) :: s_bytes, e_bytes, s_str, e_str
  integer(C_SIGNED_CHAR), dimension(:), allocatable :: bytes


  if (.not. validBase64(base64_str)) call IO_error(114,ext_msg='invalid character')

  if (present(s)) then
    if (s<1_pI64) call IO_error(114, ext_msg='s out of range')
    s_str = ((s-1_pI64)/3_pI64)*4_pI64 + 1_pI64
    s_bytes = mod(s-1_pI64,3_pI64) + 1_pI64
  else
    s_str = 1_pI64
    s_bytes = 1_pI64
  end if

  if (present(e)) then
    if (e>base64_nByte(len(base64_str,kind=pI64))) call IO_error(114, ext_msg='e out of range')
    e_str = ((e-1_pI64)/3_pI64)*4_pI64 + 4_pI64
    e_bytes = e - base64_nByte(s_str)
  else
    e_str = len(base64_str,kind=pI64)
    e_bytes = base64_nByte(len(base64_str,kind=pI64)) - base64_nByte(s_str)
    if (base64_str(e_str-0_pI64:e_str-0_pI64) == '=') e_bytes = e_bytes - 1_pI64
    if (base64_str(e_str-1_pI64:e_str-1_pI64) == '=') e_bytes = e_bytes - 1_pI64
  end if

  bytes = decodeBase64(base64_str(s_str:e_str))
  bytes = bytes(s_bytes:e_bytes)

end function base64_to_bytes


!--------------------------------------------------------------------------------------------------
!> @brief Convert a Base64 ASCII string into its byte-wise binary representation.
!--------------------------------------------------------------------------------------------------
pure function decodeBase64(base64_str) result(bytes)

  character(len=*), intent(in) :: base64_str                                                        !< Base64 string representation

  integer(C_SIGNED_CHAR), dimension(base64_nByte(len(base64_str,pI64))) :: bytes

  integer(C_SIGNED_CHAR), dimension(0:3) :: charPos
  integer(pI64) :: c, b, p


  c = 1_pI64
  b = 1_pI64

  do while(c < len(base64_str,kind=pI64))
    do p=0_pI64,3_pI64
      if (c+p<=len(base64_str,kind=pI64)) then
        charPos(p) = int(index(base64_encoding,base64_str(c+p:c+p))-1,C_SIGNED_CHAR)
      else
        charPos(p) = 0_C_SIGNED_CHAR
      end if
    end do

    call mvbits(charPos(0),0,6,bytes(b+0),2)
    call mvbits(charPos(1),4,2,bytes(b+0),0)
    call mvbits(charPos(1),0,4,bytes(b+1),4)
    call mvbits(charPos(2),2,4,bytes(b+1),0)
    call mvbits(charPos(2),0,2,bytes(b+2),6)
    call mvbits(charPos(3),0,6,bytes(b+2),0)
    b = b+3_pI64
    c = c+4_pI64
  end do

end function decodeBase64


!--------------------------------------------------------------------------------------------------
!> @brief Test for valid Base64 encoded string.
!> @details Input string must be properly padded.
!--------------------------------------------------------------------------------------------------
pure logical function validBase64(base64_str)

  character(len=*), intent(in) :: base64_str                                                        !< Base64 string representation

  integer(pI64) :: l


  l = len(base64_str,pI64)
  validBase64 = .true.

  if (mod(l,4_pI64)/=0_pI64 .or. l < 4_pI64)                                  validBase64 = .false.
  if (verify(base64_str(:l-2_pI64),base64_encoding,     kind=pI64) /= 0_pI64) validBase64 = .false.
  if (verify(base64_str(l-1_pI64:),base64_encoding//'=',kind=pI64) /= 0_pI64) validBase64 = .false.

end function validBase64


!--------------------------------------------------------------------------------------------------
!> @brief Check correctness of base64 functions.
!--------------------------------------------------------------------------------------------------
subroutine selfTest()

  integer(C_SIGNED_CHAR), dimension(:), allocatable :: bytes
  character(len=*), parameter :: zero_to_three = 'AAECAw=='


  ! https://en.wikipedia.org/wiki/Base64#Output_padding
  if (base64_nChar(20_pI64) /= 28_pI64) error stop 'base64_nChar/20/28'
  if (base64_nChar(19_pI64) /= 28_pI64) error stop 'base64_nChar/19/28'
  if (base64_nChar(18_pI64) /= 24_pI64) error stop 'base64_nChar/18/24'
  if (base64_nChar(17_pI64) /= 24_pI64) error stop 'base64_nChar/17/24'
  if (base64_nChar(16_pI64) /= 24_pI64) error stop 'base64_nChar/16/24'

  if (base64_nByte(4_pI64)  /= 3_pI64)  error stop 'base64_nByte/4/3'
  if (base64_nByte(8_pI64)  /= 6_pI64)  error stop 'base64_nByte/8/6'

  bytes = base64_to_bytes(zero_to_three)
  if (any(bytes /= int([0,1,2,3],C_SIGNED_CHAR)) .or. size(bytes) /= 4) error stop 'base64_to_bytes//'

  bytes = base64_to_bytes(zero_to_three,e=1_pI64)
  if (any(bytes /= int([0],C_SIGNED_CHAR))       .or. size(bytes) /= 1) error stop 'base64_to_bytes//1'
  bytes = base64_to_bytes(zero_to_three,e=2_pI64)
  if (any(bytes /= int([0,1],C_SIGNED_CHAR))     .or. size(bytes) /= 2) error stop 'base64_to_bytes//2'
  bytes = base64_to_bytes(zero_to_three,e=3_pI64)
  if (any(bytes /= int([0,1,2],C_SIGNED_CHAR))   .or. size(bytes) /= 3) error stop 'base64_to_bytes//3'
  bytes = base64_to_bytes(zero_to_three,e=4_pI64)
  if (any(bytes /= int([0,1,2,3],C_SIGNED_CHAR)) .or. size(bytes) /= 4) error stop 'base64_to_bytes//4'

  bytes = base64_to_bytes(zero_to_three,s=1_pI64)
  if (any(bytes /= int([0,1,2,3],C_SIGNED_CHAR)) .or. size(bytes) /= 4) error stop 'base64_to_bytes/1/'
  bytes = base64_to_bytes(zero_to_three,s=2_pI64)
  if (any(bytes /= int([1,2,3],C_SIGNED_CHAR))   .or. size(bytes) /= 3) error stop 'base64_to_bytes/2/'
  bytes = base64_to_bytes(zero_to_three,s=3_pI64)
  if (any(bytes /= int([2,3],C_SIGNED_CHAR))     .or. size(bytes) /= 2) error stop 'base64_to_bytes/3/'
  bytes = base64_to_bytes(zero_to_three,s=4_pI64)
  if (any(bytes /= int([3],C_SIGNED_CHAR))       .or. size(bytes) /= 1) error stop 'base64_to_bytes/4/'

  bytes = base64_to_bytes(zero_to_three,s=1_pI64,e=1_pI64)
  if (any(bytes /= int([0],C_SIGNED_CHAR))       .or. size(bytes) /= 1) error stop 'base64_to_bytes/1/1'
  bytes = base64_to_bytes(zero_to_three,s=2_pI64,e=2_pI64)
  if (any(bytes /= int([1],C_SIGNED_CHAR))       .or. size(bytes) /= 1) error stop 'base64_to_bytes/2/2'
  bytes = base64_to_bytes(zero_to_three,s=3_pI64,e=3_pI64)
  if (any(bytes /= int([2],C_SIGNED_CHAR))       .or. size(bytes) /= 1) error stop 'base64_to_bytes/3/3'
  bytes = base64_to_bytes(zero_to_three,s=4_pI64,e=4_pI64)
  if (any(bytes /= int([3],C_SIGNED_CHAR))       .or. size(bytes) /= 1) error stop 'base64_to_bytes/4/4'

  bytes = base64_to_bytes(zero_to_three,s=1_pI64,e=2_pI64)
  if (any(bytes /= int([0,1],C_SIGNED_CHAR))     .or. size(bytes) /= 2) error stop 'base64_to_bytes/1/2'
  bytes = base64_to_bytes(zero_to_three,s=2_pI64,e=3_pI64)
  if (any(bytes /= int([1,2],C_SIGNED_CHAR))     .or. size(bytes) /= 2) error stop 'base64_to_bytes/2/3'
  bytes = base64_to_bytes(zero_to_three,s=3_pI64,e=4_pI64)
  if (any(bytes /= int([2,3],C_SIGNED_CHAR))     .or. size(bytes) /= 2) error stop 'base64_to_bytes/3/4'

  bytes = base64_to_bytes(zero_to_three,s=1_pI64,e=3_pI64)
  if (any(bytes /= int([0,1,2],C_SIGNED_CHAR))   .or. size(bytes) /= 3) error stop 'base64_to_bytes/1/3'
  bytes = base64_to_bytes(zero_to_three,s=2_pI64,e=4_pI64)
  if (any(bytes /= int([1,2,3],C_SIGNED_CHAR))   .or. size(bytes) /= 3) error stop 'base64_to_bytes/2/4'

  bytes = base64_to_bytes(zero_to_three,s=1_pI64,e=4_pI64)
  if (any(bytes /= int([0,1,2,3],C_SIGNED_CHAR)) .or. size(bytes) /= 4) error stop 'base64_to_bytes/1/4'

end subroutine selfTest

end module base64

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Fortran interfaces for LAPACK routines
!> @details https://www.netlib.org/lapack/
!--------------------------------------------------------------------------------------------------
module LAPACK_interface
  interface

    !----------------------------------------------------------------------------------------------
    !> @brief Compute eigenvalues and, optionally, the left and/or right eigenvectors of
    !> a real nonsymmetrix matrix
    !----------------------------------------------------------------------------------------------
    pure subroutine dgeev(jobvl,jobvr,n,a,lda,wr,wi,vl,ldvl,vr,ldvr,work,lwork,info)
      use prec
      implicit none(type,external)

      character,   intent(in)                             :: jobvl,jobvr
      integer,     intent(in)                             :: n,lda,ldvl,ldvr,lwork
      real(pREAL), intent(inout), dimension(lda,n)        :: a
      real(pREAL), intent(out),   dimension(n)            :: wr,wi
      real(pREAL), intent(out),   dimension(ldvl,n)       :: vl
      real(pREAL), intent(out),   dimension(ldvr,n)       :: vr
      real(pREAL), intent(out),   dimension(max(1,lwork)) :: work
      integer,     intent(out)                            :: info
    end subroutine dgeev

    !----------------------------------------------------------------------------------------------
    !> @brief Compute eigenvalues and, optionally, eigenvectors of a real symmetric matrix.
    !----------------------------------------------------------------------------------------------
    pure subroutine dsyev(jobz,uplo,n,a,lda,w,work,lwork,info)
      use prec
      implicit none(type,external)

      character,   intent(in)                             :: jobz,uplo
      integer,     intent(in)                             :: n,lda,lwork
      real(pREAL), intent(inout), dimension(lda,n)        :: a
      real(pREAL), intent(out),   dimension(n)            :: w
      real(pREAL), intent(out),   dimension(max(1,lwork)) :: work
      integer,     intent(out)                            :: info
    end subroutine dsyev

    !----------------------------------------------------------------------------------------------
    !> @brief Compute the solution to a real system of linear equations.
    !----------------------------------------------------------------------------------------------
    pure subroutine dgesv(n,nrhs,a,lda,ipiv,b,ldb,info)
      use prec
      implicit none(type,external)

      integer,     intent(in)                             :: n,nrhs,lda,ldb
      real(pREAL), intent(inout), dimension(lda,n)        :: a
      integer,     intent(out),   dimension(n)            :: ipiv
      real(pREAL), intent(inout), dimension(ldb,nrhs)     :: b
      integer,     intent(out)                            :: info
    end subroutine dgesv

    !----------------------------------------------------------------------------------------------
    !> @brief Compute the LU factorization of a general matrix.
    !----------------------------------------------------------------------------------------------
    pure subroutine dgetrf(m,n,a,lda,ipiv,info)
      use prec
      implicit none(type,external)

      integer,     intent(in)                             :: m,n,lda
      real(pREAL), intent(inout), dimension(lda,n)        :: a
      integer,     intent(out),   dimension(min(m,n))     :: ipiv
      integer,     intent(out)                            :: info
    end subroutine dgetrf

    !----------------------------------------------------------------------------------------------
    !> @brief Compute the inverse of a matrix from the LU factorization.
    !----------------------------------------------------------------------------------------------
    pure subroutine dgetri(n,a,lda,ipiv,work,lwork,info)
      use prec
      implicit none(type,external)

      integer,     intent(in)                             :: n,lda,lwork
      real(pREAL), intent(inout), dimension(lda,n)        :: a
      integer,     intent(in),    dimension(n)            :: ipiv
      real(pREAL), intent(out),   dimension(max(1,lwork)) :: work
      integer,     intent(out)                            :: info
    end subroutine dgetri

  end interface

end module LAPACK_interface

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!----------------------------------------------------------------------------------------------------
!> @brief internal microstructure state for all chemical sources and kinematics constitutive models
!----------------------------------------------------------------------------------------------------
submodule(phase) chemical

  type :: tChemicalParameters
    real(pREAL) ::                 V_m = 0.0_pREAL                                                  !< molar volume
    character(len=pSTRLEN), allocatable, dimension(:) :: &
      output
  end type tChemicalParameters

  integer(kind(UNDEFINED)),  dimension(:), allocatable :: &
    chemical_energy

  type :: tDataContainer             ! ?? not very telling name. Better: "fieldQuantities" ??
    real(pREAL), dimension(:,:), allocatable :: C, dot_C, C0
  end type tDataContainer

  type(tDataContainer), dimension(:), allocatable  :: current         ! ?? not very telling name. Better: "field" ?? MD: current(ho)%T(en) reads quite good

  type(tChemicalParameters), dimension(:), allocatable :: param


  interface


    module function regularsolution_init() result(myChemicalEnergy)
      logical, dimension(:), allocatable :: mychemicalEnergy
    end function regularsolution_init

    module function regularsolution_mu_explicit(ph,en,comp_prev) result(mu_explicit)
      integer, intent(in) :: &
        ph, &
        en
      real(pREAL), dimension(:), intent(in) :: comp_prev
      real(pREAL), dimension(:),allocatable :: mu_explicit
    end function regularsolution_mu_explicit

    module function regularsolution_composition(mu_chemical,comp_prev,ph,en) result(comp)
      real(pREAL), dimension(:), intent(in) :: mu_chemical, comp_prev
      integer, intent(in) :: &
        ph, &
        en
      real(pREAL), dimension(:),allocatable :: comp
    end function regularsolution_composition

    module function regularsolution_compositionTangent(mu_chemical,comp_prev,ph,en) result(comp_tangent)
      real(pREAL), dimension(:), intent(in) :: mu_chemical
      real(pREAL), dimension(:), intent(in) :: comp_prev
      integer, intent(in) :: &
        ph, &
        en
      real(pREAL), dimension(:,:),allocatable :: comp_tangent
    end function regularsolution_compositionTangent

    module function regularsolution_mobility(ph,en) result(mobility)
      integer, intent(in) :: ph, en
      real(pREAL), dimension(:,:),allocatable :: mobility
    end function regularsolution_mobility

    module subroutine regularsolution_result(ph,comp,group)
      integer,          intent(in) :: ph
      real(pREAL), dimension(:,:),intent(in) :: comp
      character(len=*), intent(in) :: group
    end subroutine regularsolution_result

    module function quadenergy_init() result(myChemicalEnergy)
      logical, dimension(:), allocatable :: mychemicalEnergy
    end function quadenergy_init

    module function quadenergy_composition(mu_chemical,ph,en) result(comp)
      real(pREAL), dimension(:), intent(in) :: mu_chemical
      integer, intent(in) :: &
        ph, &
        en
      real(pREAL), dimension(:),allocatable :: comp
    end function quadenergy_composition

    module function quadenergy_compositionTangent(mu_chemical,ph,en) result(comp_tangent)
      real(pREAL), dimension(:), intent(in) :: mu_chemical
      integer, intent(in) :: &
        ph, &
        en
      real(pREAL), dimension(:,:),allocatable :: comp_tangent
    end function quadenergy_compositionTangent

    module function quadenergy_mobility(ph,en) result(mobility)
      integer, intent(in) :: ph, en
      real(pREAL), dimension(:,:),allocatable :: mobility
    end function quadenergy_mobility


 end interface

contains

!----------------------------------------------------------------------------------------------
!< @brief initializes chemical energy and sources/kinematics (eventually)
!----------------------------------------------------------------------------------------------
module subroutine chemical_init(phases)

  type(tDict), pointer :: &
    phases

  type(tDict), pointer :: &
    phase, &
    chemical
  integer :: &
    ph,    &
    Nmembers
  logical :: chemical_active

  print'(/,a)', ' <<<+-  phase:chemical init  -+>>>'

  allocate(current(size(phases)))
!  allocate(chemicalState(size(phases)))
  allocate(chemical_energy(size(phases)),source=UNDEFINED)
  allocate(param(size(phases)))

  phases => config_material%get_dict('phase')

  chemical_active = .false.

  do ph = 1, size(phases)

    phase => phases%get_dict(ph)

    if (chemical_active) then
      chemical => phase%get_dict('chemical')
    else
      chemical => phase%get_dict('chemical',defaultVal=emptyDict)
    end if

    if (size(chemical) > 0) then
      chemical_active = .true.
      print'(/,1x,a,i0,a)', 'phase ',ph,': '//phases%key(ph)

      if (.not. chemical%contains('type')) &
        call IO_error(143_pI16,'type','not specified for phase',ph,emph=[1,3])

      param(ph)%V_m = chemical%get_asReal('V_m',defaultVal=1.0_pREAL)
#if defined (__GFORTRAN__)
      param(ph)%output = output_as1dStr(chemical)
#else
      param(ph)%output = chemical%get_as1dStr('output',defaultVal=emptyStrArray)
#endif
    end if

  end do

  !initialize chemical energy model
  where(quadenergy_init())      chemical_energy = CHEMICAL_QUADENERGY
  where(regularsolution_init()) chemical_energy = CHEMICAL_REGULARSOLUTION

  do ph = 1, size(phases)

    Nmembers = count(material_ID_phase == ph)

    if (chemical_energy(ph) == UNDEFINED) then
      allocate(current(ph)%C(1,Nmembers),source=0.0_pREAL)
      allocate(current(ph)%dot_C(1,Nmembers),source=0.0_pREAL)
      allocate(current(ph)%C0(1,Nmembers),source=0.0_pREAL)
    end if

  end do

end subroutine chemical_init


!----------------------------------------------------------------------------------------------
!< @brief Calculates composition for constituent.
!----------------------------------------------------------------------------------------------
module function phase_calculate_composition(mu,co,ce) result(conc)

  real(pREAL), intent(in), dimension(:) :: mu
  integer, intent(in) :: co, ce
  real(pREAL), dimension(:), allocatable :: conc
  real(pREAL), dimension(:), allocatable :: mu_chemical

  integer :: &
    ph, en


  ph = material_ID_phase(co,ce)
  en = material_entry_phase(co,ce)

  mu_chemical = mu
  chemicalEnergyType: select case (chemical_energy(ph))

    case (CHEMICAL_REGULARSOLUTION)
      conc =  regularsolution_composition(mu_chemical,current(ph)%C0(:,en),ph,en)
    case (CHEMICAL_QUADENERGY)
      conc = quadenergy_composition(mu_chemical,ph,en)

  end select chemicalEnergyType

end function phase_calculate_composition


!----------------------------------------------------------------------------------------------
!< @brief set chemical field
!----------------------------------------------------------------------------------------------
module subroutine phase_chemical_setField(comp, Delta_t, co, ce)

  real(pREAL), dimension(:), intent(in) :: comp
  real(pREAL), intent(in) :: Delta_t
  integer, intent(in) :: co, ce

  integer :: &
    ph, en

  ph = material_ID_phase(co,ce)
  en = material_entry_phase(co,ce)

  current(ph)%C(:,en) = comp
  current(ph)%dot_C(:,en) = (current(ph)%C(:,en) - current(ph)%C0(:,en))/merge(1.0_pREAL,Delta_t,dEq0(Delta_t))

end subroutine phase_chemical_setField


!----------------------------------------------------------------------------------------------
!< @brief
!----------------------------------------------------------------------------------------------
module function phase_get_mobility(co,ce) result(mobility)

  integer, intent(in) :: co, ce
  real(pREAL), dimension(:,:),allocatable :: mobility

  integer :: &
    ph, en


  ph = material_ID_phase(co,ce)
  en = material_entry_phase(co,ce)

  chemicalEnergyType: select case (chemical_energy(ph))

    case (CHEMICAL_REGULARSOLUTION)
      mobility =  regularsolution_mobility(ph,en)
    case (CHEMICAL_QUADENERGY)
      mobility = quadenergy_mobility(ph,en)

  end select chemicalEnergyType

end function phase_get_mobility


!----------------------------------------------------------------------------------------------
!< @brief
!----------------------------------------------------------------------------------------------
module function phase_compositionTangent(mu,co,ce) result(comp_tangent)

  real(pREAL), dimension(:), intent(in) :: mu
  integer, intent(in) :: co, ce
  real(pREAL), dimension(:,:),allocatable :: comp_tangent
  real(pREAL), dimension(:),  allocatable :: mu_chemical

  integer :: &
    ph, en


  ph = material_ID_phase(co,ce)
  en = material_entry_phase(co,ce)

  mu_chemical = mu
  chemicalEnergyType: select case (chemical_energy(ph))

    case (CHEMICAL_REGULARSOLUTION)
      comp_tangent =  regularsolution_compositionTangent(mu_chemical,current(ph)%C0(:,en),ph,en)
    case (CHEMICAL_QUADENERGY)
      comp_tangent = quadenergy_compositionTangent(mu_chemical,ph,en)

  end select chemicalEnergyType

end function phase_compositionTangent


!--------------------------------------------------------------------------------------------------
!> @brief Forward data after successful increment.
!--------------------------------------------------------------------------------------------------
module subroutine chemical_forward()

  integer :: ph

  do ph = 1, size(current)
    current(ph)%C0 = current(ph)%C
  end do

end subroutine chemical_forward


!----------------------------------------------------------------------------------------------
!< @brief writes restart data for chemical to file.
!----------------------------------------------------------------------------------------------
module subroutine chemical_restartWrite(groupHandle,ph)

  integer(HID_T), intent(in) :: groupHandle
  integer, intent(in) :: ph


  call HDF5_write(current(ph)%C,groupHandle,'x')

end subroutine chemical_restartWrite


!----------------------------------------------------------------------------------------------
!< @brief reads restart data for chemical to file.
!----------------------------------------------------------------------------------------------
module subroutine chemical_restartRead(groupHandle,ph)

  integer(HID_T), intent(in) :: groupHandle
  integer, intent(in) :: ph


  call HDF5_read(current(ph)%C0,groupHandle,'x')

end subroutine chemical_restartRead


!----------------------------------------------------------------------------------------------
!< @brief writes chemical results to HDF5 output file
!----------------------------------------------------------------------------------------------
module subroutine chemical_result(group,ph)

  character(len=*), intent(in) :: group
  integer,          intent(in) :: ph

  integer :: ou

  if (chemical_energy(ph) /= UNDEFINED) then

    call result_closeGroup(result_addGroup(group//'chemical'))
    outputsLoop: do ou = 1,size(param(ph)%output)
      select case(trim(param(ph)%output(ou)))
        case ('x')
          call result_writeDataset(current(ph)%C,group//'chemical/','x','mole fraction','1',material_name_species)
      end select
    end do outputsLoop
  end if

end subroutine chemical_result


!--------------------------------------------------------------------------------------------------
!> @brief checks if a chemical energy module is active or not
!--------------------------------------------------------------------------------------------------
function chemical_active(chemical_label)  result(active_chemical)

  character(len=*), intent(in)       :: chemical_label                                              !< type of chemical energy model
  logical, dimension(:), allocatable :: active_chemical

  type(tDict), pointer :: &
    phases, &
    phase, &
    chemical
  integer :: ph

  phases => config_material%get_dict('phase')
  allocate(active_chemical(size(phases)), source = .false. )
  do ph = 1, size(phases)
    phase => phases%get_dict(ph)
    chemical => phase%get_dict('chemical',defaultVal=emptyDict)
    if (chemical%get_asStr('type',defaultVal='none') == chemical_label) active_chemical(ph) = .true.
  end do

end function chemical_active


end submodule chemical

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Pratheek Shanthraj, Max-Planck-Institut für Eisenforschung GmbH
!> @brief material subroutine incorporating kinematics resulting from thermal expansion
!> @details to be done
!--------------------------------------------------------------------------------------------------
submodule(phase:eigen) thermalexpansion

  integer, dimension(:), allocatable :: kinematics_thermal_expansion_instance

  type :: tParameters
    type(tPolynomial) :: &
      Alpha_11, &
      Alpha_33
  end type tParameters

  type(tParameters), dimension(:), allocatable :: param

contains


!--------------------------------------------------------------------------------------------------
!> @brief module initialization
!> @details reads in material parameters, allocates arrays, and does sanity checks
!--------------------------------------------------------------------------------------------------
module function thermalexpansion_init(kinematics_length) result(myKinematics)

  integer, intent(in)                  :: kinematics_length
  logical, dimension(:,:), allocatable :: myKinematics

  integer :: ph, k
  character(len=:), allocatable :: refs
  type(tList), pointer :: &
    kinematics
  type(tDict), pointer :: &
    phases, &
    phase, &
    mech


  myKinematics = kinematics_active('thermalexpansion',kinematics_length)
  if (count(myKinematics) == 0) return

  print'(/,1x,a)', '<<<+-  phase:mechanical:eigen:thermalexpansion init  -+>>>'
  print'(/,1x,a,1x,i0)', '# phases:',count(myKinematics); flush(IO_STDOUT)

  phases => config_material%get_dict('phase')
  allocate(param(count(myKinematics)))
  allocate(kinematics_thermal_expansion_instance(size(phases)), source=0)

  do ph = 1, size(phases)
    if (any(myKinematics(:,ph))) kinematics_thermal_expansion_instance(ph) = count(myKinematics(:,1:ph))
    if (count(myKinematics(:,ph)) == 0) cycle

    phase => phases%get_dict(ph)
    mech => phase%get_dict('mechanical')
    kinematics => mech%get_list('eigen')

    do k = 1, size(kinematics)
      if (myKinematics(k,ph)) then
        associate(prm  => param(kinematics_thermal_expansion_instance(ph)))

          print'(/,1x,a,1x,i0,a)', 'phase',ph,': '//phases%key(ph)
          refs = config_listReferences(kinematics%get_dict(k),indent=3)
          if (len(refs) > 0) print'(/,1x,a)', refs

          prm%Alpha_11 = polynomial(kinematics%get_dict(k),'Alpha_11','T')
          if (any(phase_lattice(ph) == ['hP','tI'])) &
            prm%Alpha_33 = polynomial(kinematics%get_dict(k),'Alpha_33','T')
        end associate
      end if
    end do
  end do

end function thermalexpansion_init


!--------------------------------------------------------------------------------------------------
!> @brief constitutive equation for calculating the velocity gradient
!--------------------------------------------------------------------------------------------------
module subroutine thermalexpansion_LiAndItsTangent(Li, dLi_dTstar, ph,me)

  integer, intent(in) :: ph, me
  real(pREAL),   intent(out), dimension(3,3) :: &
    Li                                                                                              !< thermal velocity gradient
  real(pREAL),   intent(out), dimension(3,3,3,3) :: &
    dLi_dTstar                                                                                      !< derivative of Li with respect to Tstar (4th-order tensor defined to be zero)

  real(pREAL) :: T, dot_T
  real(pREAL), dimension(3,3) :: Alpha


  T     = thermal_T(ph,me)
  dot_T = thermal_dot_T(ph,me)

  associate(prm => param(kinematics_thermal_expansion_instance(ph)))

    Alpha = 0.0_pREAL
    Alpha(1,1) = prm%Alpha_11%at(T)
    if (any(phase_lattice(ph) == ['hP','tI'])) Alpha(3,3) = prm%Alpha_33%at(T)
    Alpha = crystal_symmetrize_33(Alpha,phase_lattice(ph))
    Li = dot_T * Alpha

  end associate
  dLi_dTstar = 0.0_pREAL

end subroutine thermalexpansion_LiAndItsTangent

end submodule thermalexpansion

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, KU Leuven
!> @brief Constants.
!--------------------------------------------------------------------------------------------------
module constants
  use prec

  implicit none(type,external)
  public

  real(pREAL), parameter :: &
    T_ROOM = 293.15_pREAL, &                                                                        !< Room temperature (20°C) in K (https://en.wikipedia.org/wiki/ISO_1)
    K_B = 1.380649e-23_pREAL, &                                                                     !< Boltzmann constant in J/Kelvin (https://doi.org/10.1351/goldbook)
    N_A = 6.02214076e23_pREAL                                                                       !< Avogadro constant in 1/mol (https://doi.org/10.1351/goldbook)

  character, parameter :: &
    CR = achar(13), &
    LF = new_line('DAMASK')

  character(len=*),          parameter :: LOWER = 'abcdefghijklmnopqrstuvwxyz'
  character(len=len(LOWER)), parameter :: UPPER = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'

  enum, bind(c); enumerator :: &
    STATUS_OK, &
    STATUS_ITERATING, &
    STATUS_FAIL_PHASE_MECHANICAL, &
    STATUS_FAIL_PHASE_MECHANICAL_STATE, &
    STATUS_FAIL_PHASE_MECHANICAL_DELTASTATE, &
    STATUS_FAIL_PHASE_MECHANICAL_STRESS, &
    STATUS_FAIL_PHASE_MECHANICAL_STRESS_LP_MAXIT, &
    STATUS_FAIL_PHASE_MECHANICAL_STRESS_LP_NAN, &
    STATUS_FAIL_PHASE_MECHANICAL_STRESS_LP_DGESV, &
    STATUS_FAIL_PHASE_DAMAGE, &
    STATUS_FAIL_PHASE_DAMAGE_STATE, &
    STATUS_FAIL_PHASE_DAMAGE_DELTASTATE, &
    STATUS_FAIL_PHASE_THERMAL, &
    STATUS_FAIL_PHASE_THERMAL_DOTSTATE, &
    STATUS_FAIL_PHASE_CHEMICAL
  end enum

end module constants

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Vitesh Shah, Max-Planck-Institut für Eisenforschung GmbH
!> @author Yi-Chin Yang, Max-Planck-Institut für Eisenforschung GmbH
!> @author Jennifer Nastola, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Michigan State University
!--------------------------------------------------------------------------------------------------
#ifdef PETSC
#include <petsc/finclude/petscsys.h>
#endif
module HDF5_utilities
  use IO
  use HDF5
#ifdef PETSC
  use PETScSys
#ifndef PETSC_EXPOSES_MPI
  use MPI_f08
  use MPI, only: MPI_INFO_NULL_F90 => MPI_INFO_NULL
#endif
#endif

  use prec
  use parallelization
  use misc

#ifndef PETSC_EXPOSES_MPIF90
  implicit none(type,external)
#else
  implicit none
#endif
  private

!--------------------------------------------------------------------------------------------------
!> @brief Read integer or real data of defined shape from file.
!> @details for parallel IO, all dimension except for the last need to match
!--------------------------------------------------------------------------------------------------
  interface HDF5_read
    module procedure HDF5_read_real1
    module procedure HDF5_read_real2
    module procedure HDF5_read_real3
    module procedure HDF5_read_real4
    module procedure HDF5_read_real5

    module procedure HDF5_read_int1
    module procedure HDF5_read_int2
    module procedure HDF5_read_int3
    module procedure HDF5_read_int4
    module procedure HDF5_read_int5
  end interface HDF5_read

!--------------------------------------------------------------------------------------------------
!> @brief Write integer or real data of defined shape to file.
!> @details for parallel IO, all dimension except for the last need to match
!--------------------------------------------------------------------------------------------------
  interface HDF5_write
#if defined(__GFORTRAN__)
    ! https://gcc.gnu.org/bugzilla/show_bug.cgi?id=105674
    ! https://gcc.gnu.org/bugzilla/show_bug.cgi?id=105687
    module procedure HDF5_write_real1
    module procedure HDF5_write_real2
    module procedure HDF5_write_real3
    module procedure HDF5_write_real4
    module procedure HDF5_write_real5

    module procedure HDF5_write_int1
    module procedure HDF5_write_int2
    module procedure HDF5_write_int3
    module procedure HDF5_write_int4
    module procedure HDF5_write_int5
#else
    module procedure HDF5_write_real
    module procedure HDF5_write_int
#endif
  end interface HDF5_write

!--------------------------------------------------------------------------------------------------
!> @brief Attach attribute of type char, integer, or real to a file/dataset/group.
!--------------------------------------------------------------------------------------------------
  interface HDF5_addAttribute
    module procedure HDF5_addAttribute_str
    module procedure HDF5_addAttribute_int
    module procedure HDF5_addAttribute_real
    module procedure HDF5_addAttribute_str_array
    module procedure HDF5_addAttribute_int_array
    module procedure HDF5_addAttribute_real_array
  end interface HDF5_addAttribute

#ifdef PETSC
  logical, parameter :: parallel_default = .true.
#else
  logical, parameter :: parallel_default = .false.
#endif
  logical :: compression_possible

  public :: &
    HDF5_utilities_init, &
    HDF5_chkerr, &
    HDF5_read, &
    HDF5_write, &
    HDF5_write_str, &
    HDF5_addAttribute, &
    HDF5_addGroup, &
    HDF5_openGroup, &
    HDF5_closeGroup, &
    HDF5_openFile, &
    HDF5_closeFile, &
    HDF5_objectExists, &
    HDF5_setLink

contains


!--------------------------------------------------------------------------------------------------
!> @brief Initialize HDF5 libary and perform sanity checks.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_utilities_init()

  integer :: hdferr, HDF5_major, HDF5_minor, HDF5_release, configFlags
  logical :: avail
  integer(SIZE_T) :: typeSize


  print'(/,1x,a)', '<<<+-  HDF5_utilities init  -+>>>'


  call H5Open_f(hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Tget_size_f(H5T_NATIVE_INTEGER,typeSize, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  if (int(bit_size(0),SIZE_T)/=typeSize*8) &
    error stop 'Default integer size does not match H5T_NATIVE_INTEGER'

  call H5Tget_size_f(H5T_NATIVE_DOUBLE,typeSize, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  if (int(storage_size(0.0_pREAL),SIZE_T)/=typeSize*8) &
    error stop 'pREAL does not match H5T_NATIVE_DOUBLE'

  call H5get_libversion_f(HDF5_major,HDF5_minor,HDF5_release,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  compression_possible = (HDF5_major == 1 .and. HDF5_minor >= 12)                                   ! https://forum.hdfgroup.org/t/6186

  call H5Zfilter_avail_f(H5Z_FILTER_DEFLATE_F,avail,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  compression_possible = compression_possible .and. avail

  if (avail) then
    call H5Zget_filter_info_f(H5Z_FILTER_DEFLATE_F,configFlags,hdferr)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
    compression_possible = compression_possible .and. iand(H5Z_FILTER_ENCODE_ENABLED_F,configFlags) > 0
  end if

  call H5Zfilter_avail_f(H5Z_FILTER_SHUFFLE_F,avail,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  compression_possible = compression_possible .and. avail

  if (avail) then
    call H5Zget_filter_info_f(H5Z_FILTER_SHUFFLE_F,configFlags,hdferr)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
    compression_possible = compression_possible .and. iand(H5Z_FILTER_ENCODE_ENABLED_F,configFlags) > 0
  end if

end subroutine HDF5_utilities_init


!--------------------------------------------------------------------------------------------------
!> @brief Check for HDF5 error.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_chkerr(e,msg)

  integer, intent(in) :: e                                                                         !< error code (negative for failure)

  character(len=*), intent(in), optional :: msg                                                    !< error message


  if (present(msg)) then
    if (e<0) error stop 'HDF5 error ('//msg//')'
  else
    if (e<0) error stop 'HDF5 error'
  end if

end subroutine HDF5_chkerr


!--------------------------------------------------------------------------------------------------
!> @brief Open and initialize HDF5 file.
!--------------------------------------------------------------------------------------------------
integer(HID_T) function HDF5_openFile(fileName,mode,parallel)

  character(len=*), intent(in)           :: fileName
  character,        intent(in), optional :: mode
  logical,          intent(in), optional :: parallel

  character      :: m
  integer(HID_T) :: plist_access_id,plist_create_id
  integer :: hdferr
  logical :: exist


  m = misc_optional(mode,'r')

  call H5Pcreate_f(H5P_FILE_CREATE_F,plist_create_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Pset_link_creation_order_f(plist_create_id,ior(H5P_CRT_ORDER_INDEXED_F,H5P_CRT_ORDER_TRACKED_F),hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Pcreate_f(H5P_FILE_ACCESS_F, plist_access_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
#ifdef PETSC
  if (misc_optional(parallel,.true.)) &
#if defined(PETSC_EXPOSES_MPIF90)
    call H5Pset_fapl_mpio_f(plist_access_id, PETSC_COMM_WORLD,       MPI_INFO_NULL,     hdferr)
#elif !defined(HDF5_SUPPORTS_MPIF08)
    call H5Pset_fapl_mpio_f(plist_access_id, MPI_COMM_WORLD%MPI_val, MPI_INFO_NULL_F90, hdferr)
#else
    call H5Pset_fapl_mpio_f(plist_access_id, MPI_COMM_WORLD,         MPI_INFO_NULL, hdferr)
#endif
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
#endif

  if     (m == 'w') then
    call H5Fcreate_f(fileName,H5F_ACC_TRUNC_F,HDF5_openFile,hdferr,&
                     access_prp=plist_access_id,creation_prp=plist_create_id)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  elseif (m == 'a') then
    call H5Fopen_f(fileName,H5F_ACC_RDWR_F,HDF5_openFile,hdferr,access_prp=plist_access_id)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  elseif (m == 'r') then
    inquire(file=fileName,exist=exist)
    if (.not. exist) call IO_error(100_pI16,'file does not exist',trim(fileName),emph=[2])
    call H5Fopen_f(fileName,H5F_ACC_RDONLY_F,HDF5_openFile,hdferr,access_prp=plist_access_id)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  else
    error stop 'unknown access mode'
  end if

  call H5Pclose_f(plist_access_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Pclose_f(plist_create_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

end function HDF5_openFile


!--------------------------------------------------------------------------------------------------
!> @brief Close an open HDF5 file.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_closeFile(fileHandle)

  integer(HID_T), intent(in) :: fileHandle

  integer     :: hdferr


  call H5Fclose_f(fileHandle,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

end subroutine HDF5_closeFile


!--------------------------------------------------------------------------------------------------
!> @brief Add a new group to the file.
!--------------------------------------------------------------------------------------------------
integer(HID_T) function HDF5_addGroup(fileHandle,groupName)

  integer(HID_T),   intent(in) :: fileHandle
  character(len=*), intent(in) :: groupName

  integer        :: hdferr
  integer(HID_T) :: gapl_id, gcpl_id


!-------------------------------------------------------------------------------------------------
! set I/O mode to collective (for MPI parallel simulations)
  call H5Pcreate_f(H5P_GROUP_ACCESS_F,gapl_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
#ifdef PETSC
  call H5Pset_all_coll_metadata_ops_f(gapl_id,.true.,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
#endif

!-------------------------------------------------------------------------------------------------
! keep creation order in group
  call H5Pcreate_f(H5P_GROUP_CREATE_F,gcpl_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Pset_link_creation_order_f(gcpl_id,ior(H5P_CRT_ORDER_INDEXED_F,H5P_CRT_ORDER_TRACKED_F),hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

!-------------------------------------------------------------------------------------------------
! Create group
  call H5Gcreate_f(fileHandle,trim(groupName),HDF5_addGroup,hdferr, &
                   OBJECT_NAMELEN_DEFAULT_F,gcpl_id=gcpl_id,gapl_id=gapl_id)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Pclose_f(gcpl_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Pclose_f(gapl_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

end function HDF5_addGroup


!--------------------------------------------------------------------------------------------------
!> @brief Open an existing group in a file.
!--------------------------------------------------------------------------------------------------
integer(HID_T) function HDF5_openGroup(fileHandle,groupName)

  integer(HID_T),   intent(in) :: fileHandle
  character(len=*), intent(in) :: groupName


  integer        :: hdferr
  integer(HID_T) :: aplist_id
  logical        :: is_collective


 !-------------------------------------------------------------------------------------------------
 ! creating a property list for data access properties
  call H5Pcreate_f(H5P_GROUP_ACCESS_F, aplist_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

 !-------------------------------------------------------------------------------------------------
 ! setting I/O mode to collective
#ifdef PETSC
  call H5Pget_all_coll_metadata_ops_f(aplist_id, is_collective, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
#endif

 !-------------------------------------------------------------------------------------------------
 ! opening the group
  call H5Gopen_f(fileHandle, trim(groupName), HDF5_openGroup, hdferr, gapl_id = aplist_id)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Pclose_f(aplist_id,hdferr)

end function HDF5_openGroup


!--------------------------------------------------------------------------------------------------
!> @brief Close a group.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_closeGroup(group_id)

  integer(HID_T), intent(in) :: group_id

  integer :: hdferr


  call H5Gclose_f(group_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

end subroutine HDF5_closeGroup


!--------------------------------------------------------------------------------------------------
!> @brief Check whether a group or a dataset exists.
!--------------------------------------------------------------------------------------------------
logical function HDF5_objectExists(loc_id,path)

  integer(HID_T),   intent(in)            :: loc_id
  character(len=*), intent(in), optional  :: path

  integer :: hdferr
  character(len=:), allocatable :: p


  p = trim(misc_optional(path,'.'))

  call H5Lexists_f(loc_id, p, HDF5_objectExists, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  if (HDF5_objectExists) then
    call H5Oexists_by_name_f(loc_id, p, HDF5_objectExists, hdferr)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

end function HDF5_objectExists


!--------------------------------------------------------------------------------------------------
!> @brief Add a string attribute to the path given relative to the location.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_addAttribute_str(loc_id,attrLabel,attrValue,path)

  integer(HID_T),   intent(in)           :: loc_id
  character(len=*), intent(in)           :: attrLabel, attrValue
  character(len=*), intent(in), optional :: path

  integer(HID_T) :: attr_id, space_id
  logical        :: attrExists
  integer        :: hdferr
  character(len=:), allocatable :: p
  character(len=len_trim(attrValue)+1,kind=C_CHAR), dimension(1), target :: attrValue_
  type(C_PTR), target, dimension(1) :: ptr


  p = trim(misc_optional(path,'.'))

  attrValue_(1) = trim(attrValue)//C_NULL_CHAR
  ptr(1) = c_loc(attrValue_(1))

  call H5Screate_f(H5S_SCALAR_F,space_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Aexists_by_name_f(loc_id,p,attrLabel,attrExists,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  if (attrExists) then
    call H5Adelete_by_name_f(loc_id,p,attrLabel,hdferr)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call H5Acreate_by_name_f(loc_id,p,trim(attrLabel),H5T_STRING,space_id,attr_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Awrite_f(attr_id, H5T_STRING, c_loc(ptr), hdferr)                                          ! ptr instead of c_loc(ptr) works on gfortran, not on ifort
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Aclose_f(attr_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Sclose_f(space_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

end subroutine HDF5_addAttribute_str


!--------------------------------------------------------------------------------------------------
!> @brief Add an integer attribute to the path given relative to the location.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_addAttribute_int(loc_id,attrLabel,attrValue,path)

  integer(HID_T),   intent(in)           :: loc_id
  character(len=*), intent(in)           :: attrLabel
  integer,          intent(in)           :: attrValue
  character(len=*), intent(in), optional :: path

  integer(HID_T) :: attr_id, space_id
  integer        :: hdferr
  logical        :: attrExists
  character(len=:), allocatable :: p


  p = trim(misc_optional(path,'.'))

  call H5Screate_f(H5S_SCALAR_F,space_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Aexists_by_name_f(loc_id,p,attrLabel,attrExists,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  if (attrExists) then
    call H5Adelete_by_name_f(loc_id,p,attrLabel,hdferr)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call H5Acreate_by_name_f(loc_id,p,trim(attrLabel),H5T_NATIVE_INTEGER,space_id,attr_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Awrite_f(attr_id, H5T_NATIVE_INTEGER, attrValue, int([1],HSIZE_T), hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Aclose_f(attr_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Sclose_f(space_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

end subroutine HDF5_addAttribute_int


!--------------------------------------------------------------------------------------------------
!> @brief Add a real attribute to the path given relative to the location.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_addAttribute_real(loc_id,attrLabel,attrValue,path)

  integer(HID_T),   intent(in)           :: loc_id
  character(len=*), intent(in)           :: attrLabel
  real(pREAL),      intent(in)           :: attrValue
  character(len=*), intent(in), optional :: path

  integer(HID_T) :: attr_id, space_id
  integer        :: hdferr
  logical        :: attrExists
  character(len=:), allocatable :: p


  p = trim(misc_optional(path,'.'))

  call H5Screate_f(H5S_SCALAR_F,space_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Aexists_by_name_f(loc_id,p,attrLabel,attrExists,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  if (attrExists) then
    call H5Adelete_by_name_f(loc_id,p,attrLabel,hdferr)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call H5Acreate_by_name_f(loc_id,p,trim(attrLabel),H5T_NATIVE_DOUBLE,space_id,attr_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Awrite_f(attr_id, H5T_NATIVE_DOUBLE, attrValue, int([1],HSIZE_T), hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Aclose_f(attr_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Sclose_f(space_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

end subroutine HDF5_addAttribute_real


!--------------------------------------------------------------------------------------------------
!> @brief Add a string array attribute to the path given relative to the location.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_addAttribute_str_array(loc_id,attrLabel,attrValue,path)

  integer(HID_T),   intent(in)               :: loc_id
  character(len=*), intent(in)               :: attrLabel
  character(len=*), intent(in), dimension(:) :: attrValue
  character(len=*), intent(in), optional     :: path

  integer(HID_T)                :: attr_id, space_id
  logical                       :: attrExists
  integer                       :: hdferr,i
  character(len=:), allocatable :: p
  character(len=len(attrValue)+1,kind=C_CHAR), dimension(size(attrValue)), target :: attrValue_
  type(C_PTR), target, dimension(size(attrValue))  :: ptr


  p = trim(misc_optional(path,'.'))

  do i=1,size(attrValue)
    attrValue_(i) = attrValue(i)//C_NULL_CHAR
    ptr(i) = c_loc(attrValue_(i))
  end do

  call H5Screate_simple_f(1,shape(attrValue_,kind=HSIZE_T),space_id,hdferr,shape(attrValue_,kind=HSIZE_T))
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Aexists_by_name_f(loc_id,p,attrLabel,attrExists,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  if (attrExists) then
    call H5Adelete_by_name_f(loc_id,p,attrLabel,hdferr)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call H5Acreate_by_name_f(loc_id,p,trim(attrLabel),H5T_STRING,space_id,attr_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Awrite_f(attr_id, H5T_STRING, c_loc(ptr), hdferr)                                          ! ptr instead of c_loc(ptr) works on gfortran, not on ifort
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Aclose_f(attr_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Sclose_f(space_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

end subroutine HDF5_addAttribute_str_array


!--------------------------------------------------------------------------------------------------
!> @brief Add an integer array attribute to the path given relative to the location.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_addAttribute_int_array(loc_id,attrLabel,attrValue,path)

  integer(HID_T),   intent(in)               :: loc_id
  character(len=*), intent(in)               :: attrLabel
  integer,          intent(in), dimension(:) :: attrValue
  character(len=*), intent(in), optional     :: path

  integer(HSIZE_T),dimension(1) :: array_size
  integer(HID_T)                :: attr_id, space_id
  integer                       :: hdferr
  logical                       :: attrExists
  character(len=:), allocatable :: p


  p = trim(misc_optional(path,'.'))

  array_size = size(attrValue,kind=HSIZE_T)

  call H5Screate_simple_f(1, array_size, space_id, hdferr, array_size)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Aexists_by_name_f(loc_id,p,attrLabel,attrExists,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  if (attrExists) then
    call H5Adelete_by_name_f(loc_id,p,attrLabel,hdferr)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call H5Acreate_by_name_f(loc_id,p,trim(attrLabel),H5T_NATIVE_INTEGER,space_id,attr_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Awrite_f(attr_id, H5T_NATIVE_INTEGER, attrValue, array_size, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Aclose_f(attr_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Sclose_f(space_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

end subroutine HDF5_addAttribute_int_array


!--------------------------------------------------------------------------------------------------
!> @brief Add a real array attribute to the path given relative to the location.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_addAttribute_real_array(loc_id,attrLabel,attrValue,path)

  integer(HID_T),   intent(in)               :: loc_id
  character(len=*), intent(in)               :: attrLabel
  real(pREAL),      intent(in), dimension(:) :: attrValue
  character(len=*), intent(in), optional     :: path

  integer(HSIZE_T),dimension(1) :: array_size
  integer(HID_T)                :: attr_id, space_id
  integer                       :: hdferr
  logical                       :: attrExists
  character(len=:), allocatable :: p


  p = trim(misc_optional(path,'.'))

  array_size = size(attrValue,kind=HSIZE_T)

  call H5Screate_simple_f(1, array_size, space_id, hdferr, array_size)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Aexists_by_name_f(loc_id,p,attrLabel,attrExists,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  if (attrExists) then
    call H5Adelete_by_name_f(loc_id,p,attrLabel,hdferr)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call H5Acreate_by_name_f(loc_id,p,trim(attrLabel),H5T_NATIVE_DOUBLE,space_id,attr_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Awrite_f(attr_id, H5T_NATIVE_DOUBLE, attrValue, array_size, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Aclose_f(attr_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Sclose_f(space_id,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

end subroutine HDF5_addAttribute_real_array


!--------------------------------------------------------------------------------------------------
!> @brief Set link to object in results file.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_setLink(loc_id,target_name,link_name)

  character(len=*), intent(in) :: target_name, link_name
  integer(HID_T),   intent(in) :: loc_id
  integer                      :: hdferr
  logical                      :: linkExists

  call H5Lexists_f(loc_id, link_name,linkExists, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  if (linkExists) then
    call H5Ldelete_f(loc_id,link_name, hdferr)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if
  call H5Lcreate_soft_f(target_name, loc_id, link_name, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

end subroutine HDF5_setLink


!--------------------------------------------------------------------------------------------------
!> @brief Read dataset of type real with 1 dimension.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_read_real1(dataset,loc_id,datasetName,parallel)

  real(pREAL),      intent(out), dimension(:) :: dataset                                            !< data read from file
  integer(HID_T),   intent(in) :: loc_id                                                            !< file or group handle
  character(len=*), intent(in) :: datasetName                                                       !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes

  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id, aplist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)
  integer :: hdferr


  myShape = int(shape(dataset),HSIZE_T)

  call initialize_read(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, aplist_id, &
                       loc_id,myShape,datasetName,misc_optional(parallel,parallel_default))

  if (any(totalShape == 0)) return

  call H5Dread_f(dset_id, H5T_NATIVE_DOUBLE,dataset,totalShape, hdferr,&
                 file_space_id = filespace_id, xfer_prp = plist_id, mem_space_id = memspace_id)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call finalize_read(dset_id, filespace_id, memspace_id, plist_id, aplist_id)

end subroutine HDF5_read_real1

!--------------------------------------------------------------------------------------------------
!> @brief Read dataset of type real with 2 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_read_real2(dataset,loc_id,datasetName,parallel)

  real(pREAL),      intent(out), dimension(:,:) :: dataset                                          !< data read from file
  integer(HID_T),   intent(in) :: loc_id                                                            !< file or group handle
  character(len=*), intent(in) :: datasetName                                                       !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes

  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id, aplist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)
  integer :: hdferr


  myShape = int(shape(dataset),HSIZE_T)

  call initialize_read(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, aplist_id, &
                       loc_id,myShape,datasetName,misc_optional(parallel,parallel_default))

  if (any(totalShape == 0)) return

  call H5Dread_f(dset_id, H5T_NATIVE_DOUBLE,dataset,totalShape, hdferr,&
                 file_space_id = filespace_id, xfer_prp = plist_id, mem_space_id = memspace_id)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call finalize_read(dset_id, filespace_id, memspace_id, plist_id, aplist_id)

end subroutine HDF5_read_real2

!--------------------------------------------------------------------------------------------------
!> @brief Read dataset of type real with 2 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_read_real3(dataset,loc_id,datasetName,parallel)

  real(pREAL),      intent(out), dimension(:,:,:) :: dataset                                        !< data read from file
  integer(HID_T),   intent(in) :: loc_id                                                            !< file or group handle
  character(len=*), intent(in) :: datasetName                                                       !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes

  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id, aplist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)
  integer :: hdferr


  myShape = int(shape(dataset),HSIZE_T)

  call initialize_read(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, aplist_id, &
                       loc_id,myShape,datasetName,misc_optional(parallel,parallel_default))

  if (any(totalShape == 0)) return

  call H5Dread_f(dset_id, H5T_NATIVE_DOUBLE,dataset,totalShape, hdferr,&
                 file_space_id = filespace_id, xfer_prp = plist_id, mem_space_id = memspace_id)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call finalize_read(dset_id, filespace_id, memspace_id, plist_id, aplist_id)

end subroutine HDF5_read_real3

!--------------------------------------------------------------------------------------------------
!> @brief Read dataset of type real with 4 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_read_real4(dataset,loc_id,datasetName,parallel)

  real(pREAL),      intent(out), dimension(:,:,:,:) :: dataset                                      !< data read from file
  integer(HID_T),   intent(in) :: loc_id                                                            !< file or group handle
  character(len=*), intent(in) :: datasetName                                                       !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes

  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id, aplist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)
  integer :: hdferr


  myShape = int(shape(dataset),HSIZE_T)
  if (any(myShape(1:size(myShape)-1) == 0)) return                                                  !< empty dataset (last dimension can be empty)

  call initialize_read(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, aplist_id, &
                       loc_id,myShape,datasetName,misc_optional(parallel,parallel_default))

  if (any(totalShape == 0)) return

  call H5Dread_f(dset_id, H5T_NATIVE_DOUBLE,dataset,totalShape, hdferr,&
                 file_space_id = filespace_id, xfer_prp = plist_id, mem_space_id = memspace_id)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call finalize_read(dset_id, filespace_id, memspace_id, plist_id, aplist_id)

end subroutine HDF5_read_real4

!--------------------------------------------------------------------------------------------------
!> @brief Read dataset of type real with 5 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_read_real5(dataset,loc_id,datasetName,parallel)

  real(pREAL),      intent(out), dimension(:,:,:,:,:) :: dataset                                    !< data read from file
  integer(HID_T),   intent(in) :: loc_id                                                            !< file or group handle
  character(len=*), intent(in) :: datasetName                                                       !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes

  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id, aplist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)
  integer :: hdferr


  myShape = int(shape(dataset),HSIZE_T)
  if (any(myShape(1:size(myShape)-1) == 0)) return                                                  !< empty dataset (last dimension can be empty)

  call initialize_read(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, aplist_id, &
                       loc_id,myShape,datasetName,misc_optional(parallel,parallel_default))

  if (any(totalShape == 0)) return

  call H5Dread_f(dset_id, H5T_NATIVE_DOUBLE,dataset,totalShape, hdferr,&
                 file_space_id = filespace_id, xfer_prp = plist_id, mem_space_id = memspace_id)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call finalize_read(dset_id, filespace_id, memspace_id, plist_id, aplist_id)

end subroutine HDF5_read_real5


!--------------------------------------------------------------------------------------------------
!> @brief Read dataset of type integer with 1 dimension.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_read_int1(dataset,loc_id,datasetName,parallel)

  integer,          intent(out), dimension(:) :: dataset                                            !< data read from file
  integer(HID_T),   intent(in) :: loc_id                                                            !< file or group handle
  character(len=*), intent(in) :: datasetName                                                       !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes


  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id, aplist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)
  integer :: hdferr

  myShape = int(shape(dataset),HSIZE_T)

  call initialize_read(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, aplist_id, &
                       loc_id,myShape,datasetName,misc_optional(parallel,parallel_default))

if (any(totalShape == 0)) return

  call H5Dread_f(dset_id, H5T_NATIVE_INTEGER,dataset,totalShape, hdferr,&
                 file_space_id = filespace_id, xfer_prp = plist_id, mem_space_id = memspace_id)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call finalize_read(dset_id, filespace_id, memspace_id, plist_id, aplist_id)

end subroutine HDF5_read_int1

!--------------------------------------------------------------------------------------------------
!> @brief Read dataset of type integer with 2 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_read_int2(dataset,loc_id,datasetName,parallel)

  integer,          intent(out), dimension(:,:) :: dataset                                          !< data read from file
  integer(HID_T),   intent(in) :: loc_id                                                            !< file or group handle
  character(len=*), intent(in) :: datasetName                                                       !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes

  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id, aplist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)
  integer :: hdferr


  myShape = int(shape(dataset),HSIZE_T)
  if (any(myShape(1:size(myShape)-1) == 0)) return                                                  !< empty dataset (last dimension can be empty)

  call initialize_read(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, aplist_id, &
                       loc_id,myShape,datasetName,misc_optional(parallel,parallel_default))

  if (any(totalShape == 0)) return

  call H5Dread_f(dset_id, H5T_NATIVE_INTEGER,dataset,totalShape, hdferr,&
                 file_space_id = filespace_id, xfer_prp = plist_id, mem_space_id = memspace_id)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call finalize_read(dset_id, filespace_id, memspace_id, plist_id, aplist_id)

end subroutine HDF5_read_int2

!--------------------------------------------------------------------------------------------------
!> @brief Read dataset of type integer with 3 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_read_int3(dataset,loc_id,datasetName,parallel)

  integer,          intent(out), dimension(:,:,:) :: dataset                                        !< data read from file
  integer(HID_T),   intent(in) :: loc_id                                                            !< file or group handle
  character(len=*), intent(in) :: datasetName                                                       !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes

  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id, aplist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)
  integer :: hdferr


  myShape = int(shape(dataset),HSIZE_T)

  call initialize_read(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, aplist_id, &
                       loc_id,myShape,datasetName,misc_optional(parallel,parallel_default))

  if (any(totalShape == 0)) return

  call H5Dread_f(dset_id, H5T_NATIVE_INTEGER,dataset,totalShape, hdferr,&
                 file_space_id = filespace_id, xfer_prp = plist_id, mem_space_id = memspace_id)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call finalize_read(dset_id, filespace_id, memspace_id, plist_id, aplist_id)

end subroutine HDF5_read_int3

!--------------------------------------------------------------------------------------------------
!> @brief Read dataset of type integer with 4 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_read_int4(dataset,loc_id,datasetName,parallel)

  integer,          intent(out), dimension(:,:,:,:) :: dataset                                      !< data read from file
  integer(HID_T),   intent(in) :: loc_id                                                            !< file or group handle
  character(len=*), intent(in) :: datasetName                                                       !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes

  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id, aplist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)
  integer :: hdferr


  myShape = int(shape(dataset),HSIZE_T)

  call initialize_read(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, aplist_id, &
                       loc_id,myShape,datasetName,misc_optional(parallel,parallel_default))

  if (any(totalShape == 0)) return

  call H5Dread_f(dset_id, H5T_NATIVE_INTEGER,dataset,totalShape, hdferr,&
                 file_space_id = filespace_id, xfer_prp = plist_id, mem_space_id = memspace_id)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call finalize_read(dset_id, filespace_id, memspace_id, plist_id, aplist_id)

end subroutine HDF5_read_int4

!--------------------------------------------------------------------------------------------------
!> @brief Read dataset of type integer with 5 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_read_int5(dataset,loc_id,datasetName,parallel)

  integer,          intent(out), dimension(:,:,:,:,:) :: dataset                                    !< data read from file
  integer(HID_T),   intent(in) :: loc_id                                                            !< file or group handle
  character(len=*), intent(in) :: datasetName                                                       !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes

  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id, aplist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)
  integer :: hdferr


  myShape = int(shape(dataset),HSIZE_T)

  call initialize_read(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, aplist_id, &
                       loc_id,myShape,datasetName,misc_optional(parallel,parallel_default))

  if (any(totalShape == 0)) return

  call H5Dread_f(dset_id, H5T_NATIVE_INTEGER,dataset,totalShape, hdferr,&
                 file_space_id = filespace_id, xfer_prp = plist_id, mem_space_id = memspace_id)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call finalize_read(dset_id, filespace_id, memspace_id, plist_id, aplist_id)

end subroutine HDF5_read_int5


#if defined(__GFORTRAN__)
!--------------------------------------------------------------------------------------------------
!> @brief Write dataset of type real with 1 dimension.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_write_real1(dataset,loc_id,datasetName,parallel)

  real(pREAL),      intent(in), dimension(:) :: dataset                                             !< data written to file
  integer(HID_T),   intent(in)  :: loc_id                                                           !< file or group handle
  character(len=*), intent(in)  :: datasetName                                                      !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes


  integer :: hdferr
  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)

!---------------------------------------------------------------------------------------------------
! determine shape of dataset
  myShape = int(shape(dataset),HSIZE_T)
  if (any(myShape(1:size(myShape)-1) == 0)) return                                                  !< empty dataset (last dimension can be empty)

  call initialize_write(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, &
                        loc_id,myShape,datasetName,H5T_NATIVE_DOUBLE, &
                        misc_optional(parallel,parallel_default))

  if (product(totalShape) /= 0) then
    call H5Dwrite_f(dset_id, H5T_NATIVE_DOUBLE,dataset,int(totalShape,HSIZE_T), hdferr,&
                   file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call finalize_write(plist_id, dset_id, filespace_id, memspace_id)

end subroutine HDF5_write_real1

!--------------------------------------------------------------------------------------------------
!> @brief Write dataset of type real with 2 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_write_real2(dataset,loc_id,datasetName,parallel)

  real(pREAL),      intent(in), dimension(:,:) :: dataset                                           !< data written to file
  integer(HID_T),   intent(in)  :: loc_id                                                           !< file or group handle
  character(len=*), intent(in)  :: datasetName                                                      !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes


  integer :: hdferr
  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)

!---------------------------------------------------------------------------------------------------
! determine shape of dataset
  myShape = int(shape(dataset),HSIZE_T)
  if (any(myShape(1:size(myShape)-1) == 0)) return                                                  !< empty dataset (last dimension can be empty)

  call initialize_write(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, &
                        loc_id,myShape,datasetName,H5T_NATIVE_DOUBLE, &
                        misc_optional(parallel,parallel_default))

  if (product(totalShape) /= 0) then
    call H5Dwrite_f(dset_id, H5T_NATIVE_DOUBLE,dataset,int(totalShape,HSIZE_T), hdferr,&
                   file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call finalize_write(plist_id, dset_id, filespace_id, memspace_id)

end subroutine HDF5_write_real2

!--------------------------------------------------------------------------------------------------
!> @brief Write dataset of type real with 3 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_write_real3(dataset,loc_id,datasetName,parallel)

  real(pREAL),      intent(in), dimension(:,:,:) :: dataset                                         !< data written to file
  integer(HID_T),   intent(in)  :: loc_id                                                           !< file or group handle
  character(len=*), intent(in)  :: datasetName                                                      !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes


  integer :: hdferr
  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)

!---------------------------------------------------------------------------------------------------
! determine shape of dataset
  myShape = int(shape(dataset),HSIZE_T)
  if (any(myShape(1:size(myShape)-1) == 0)) return                                                  !< empty dataset (last dimension can be empty)

  call initialize_write(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, &
                        loc_id,myShape,datasetName,H5T_NATIVE_DOUBLE, &
                        misc_optional(parallel,parallel_default))

  if (product(totalShape) /= 0) then
    call H5Dwrite_f(dset_id, H5T_NATIVE_DOUBLE,dataset,int(totalShape,HSIZE_T), hdferr,&
                   file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call finalize_write(plist_id, dset_id, filespace_id, memspace_id)

end subroutine HDF5_write_real3

!--------------------------------------------------------------------------------------------------
!> @brief Write dataset of type real with 4 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_write_real4(dataset,loc_id,datasetName,parallel)

  real(pREAL),      intent(in), dimension(:,:,:,:) :: dataset                                       !< data written to file
  integer(HID_T),   intent(in)  :: loc_id                                                           !< file or group handle
  character(len=*), intent(in)  :: datasetName                                                      !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes


  integer :: hdferr
  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)

!---------------------------------------------------------------------------------------------------
! determine shape of dataset
  myShape = int(shape(dataset),HSIZE_T)
  if (any(myShape(1:size(myShape)-1) == 0)) return                                                  !< empty dataset (last dimension can be empty)

  call initialize_write(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, &
                        loc_id,myShape,datasetName,H5T_NATIVE_DOUBLE, &
                        misc_optional(parallel,parallel_default))

  if (product(totalShape) /= 0) then
    call H5Dwrite_f(dset_id, H5T_NATIVE_DOUBLE,dataset,int(totalShape,HSIZE_T), hdferr,&
                   file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call finalize_write(plist_id, dset_id, filespace_id, memspace_id)

end subroutine HDF5_write_real4


!--------------------------------------------------------------------------------------------------
!> @brief Write dataset of type real with 5 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_write_real5(dataset,loc_id,datasetName,parallel)

  real(pREAL),      intent(in), dimension(:,:,:,:,:) :: dataset                                     !< data written to file
  integer(HID_T),   intent(in)  :: loc_id                                                           !< file or group handle
  character(len=*), intent(in)  :: datasetName                                                      !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes


  integer :: hdferr
  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)

!---------------------------------------------------------------------------------------------------
! determine shape of dataset
  myShape = int(shape(dataset),HSIZE_T)
  if (any(myShape(1:size(myShape)-1) == 0)) return                                                  !< empty dataset (last dimension can be empty)

  call initialize_write(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, &
                        loc_id,myShape,datasetName,H5T_NATIVE_DOUBLE, &
                        misc_optional(parallel,parallel_default))

  if (product(totalShape) /= 0) then
    call H5Dwrite_f(dset_id, H5T_NATIVE_DOUBLE,dataset,int(totalShape,HSIZE_T), hdferr,&
                   file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call finalize_write(plist_id, dset_id, filespace_id, memspace_id)

end subroutine HDF5_write_real5

#else

!--------------------------------------------------------------------------------------------------
!> @brief Write dataset of type real with 1-5 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_write_real(dataset,loc_id,datasetName,parallel)

  real(pREAL),      intent(in), dimension(..) :: dataset                                            !< data written to file
  integer(HID_T),   intent(in)  :: loc_id                                                           !< file or group handle
  character(len=*), intent(in)  :: datasetName                                                      !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes


  integer :: hdferr
  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)

!---------------------------------------------------------------------------------------------------
! determine shape of dataset
  myShape = int(shape(dataset),HSIZE_T)
  if (any(myShape(1:size(myShape)-1) == 0)) return                                                  !< empty dataset (last dimension can be empty)

  call initialize_write(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, &
                        loc_id,myShape,datasetName,H5T_NATIVE_DOUBLE, &
                        misc_optional(parallel,parallel_default))

  if (product(totalShape) /= 0) then
    select rank(dataset)
      rank (1)
        call H5Dwrite_f(dset_id, H5T_NATIVE_DOUBLE,dataset,int(totalShape,HSIZE_T), hdferr,&
                        file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
      rank (2)
        call H5Dwrite_f(dset_id, H5T_NATIVE_DOUBLE,dataset,int(totalShape,HSIZE_T), hdferr,&
                        file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
      rank (3)
        call H5Dwrite_f(dset_id, H5T_NATIVE_DOUBLE,dataset,int(totalShape,HSIZE_T), hdferr,&
                        file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
      rank (4)
        call H5Dwrite_f(dset_id, H5T_NATIVE_DOUBLE,dataset,int(totalShape,HSIZE_T), hdferr,&
                        file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
      rank (5)
        call H5Dwrite_f(dset_id, H5T_NATIVE_DOUBLE,dataset,int(totalShape,HSIZE_T), hdferr,&
                        file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
    end select
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call finalize_write(plist_id, dset_id, filespace_id, memspace_id)

end subroutine HDF5_write_real
#endif


!--------------------------------------------------------------------------------------------------
!> @brief Write dataset of type string (scalar).
!> @details Not collective, must be called by one process at at time.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_write_str(dataset,loc_id,datasetName)

  character(len=*), intent(in) :: dataset
  integer(HID_T),   intent(in) :: loc_id
  character(len=*), intent(in) :: datasetName                                                      !< name of the dataset in the file

  integer(HID_T)  :: filetype_id, memtype_id, space_id, dataset_id, dcpl
  integer :: hdferr
  character(len=len_trim(dataset,pI64),kind=C_CHAR), target :: dataset_


  dataset_ = trim(dataset)

  call H5Tcopy_f(H5T_C_S1, filetype_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Tset_size_f(filetype_id, len(dataset_,SIZE_T)+1_SIZE_T, hdferr)                            ! +1 for NULL
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Tcopy_f(H5T_FORTRAN_S1, memtype_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Tset_size_f(memtype_id, len(dataset_,SIZE_T), hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Pcreate_f(H5P_DATASET_CREATE_F, dcpl, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Pset_chunk_f(dcpl, 1, [1_HSIZE_T], hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Pset_Fletcher32_f(dcpl,hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  if (compression_possible .and. len(dataset,pI64) > 1024_pI64*256_pI64) then
    call H5Pset_shuffle_f(dcpl, hdferr)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
    call H5Pset_deflate_f(dcpl, 6, hdferr)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call H5Screate_simple_f(1, [1_HSIZE_T], space_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  CALL H5Dcreate_f(loc_id, datasetName, filetype_id, space_id, dataset_id, hdferr, dcpl)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Dwrite_f(dataset_id, memtype_id, c_loc(dataset_(1:1)), hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Pclose_f(dcpl, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Dclose_f(dataset_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Sclose_f(space_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Tclose_f(memtype_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Tclose_f(filetype_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

end subroutine HDF5_write_str


#if defined(__GFORTRAN__)
!--------------------------------------------------------------------------------------------------
!> @brief Write dataset of type integer with 1 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_write_int1(dataset,loc_id,datasetName,parallel)

  integer,          intent(in), dimension(:) :: dataset                                             !< data written to file
  integer(HID_T),   intent(in)  :: loc_id                                                           !< file or group handle
  character(len=*), intent(in)  :: datasetName                                                      !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes


  integer :: hdferr
  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)

!---------------------------------------------------------------------------------------------------
! determine shape of dataset
  myShape = int(shape(dataset),HSIZE_T)
  if (any(myShape(1:size(myShape)-1) == 0)) return                                                  !< empty dataset (last dimension can be empty)

  call initialize_write(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, &
                        loc_id,myShape,datasetName,H5T_NATIVE_INTEGER, &
                        misc_optional(parallel,parallel_default))

  if (product(totalShape) /= 0) then
    call H5Dwrite_f(dset_id, H5T_NATIVE_INTEGER,dataset,int(totalShape,HSIZE_T), hdferr,&
                   file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call finalize_write(plist_id, dset_id, filespace_id, memspace_id)

end subroutine HDF5_write_int1

!--------------------------------------------------------------------------------------------------
!> @brief Write dataset of type integer with 2 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_write_int2(dataset,loc_id,datasetName,parallel)

  integer,          intent(in), dimension(:,:) :: dataset                                           !< data written to file
  integer(HID_T),   intent(in)  :: loc_id                                                           !< file or group handle
  character(len=*), intent(in)  :: datasetName                                                      !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes


  integer :: hdferr
  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)

!---------------------------------------------------------------------------------------------------
! determine shape of dataset
  myShape = int(shape(dataset),HSIZE_T)
  if (any(myShape(1:size(myShape)-1) == 0)) return                                                  !< empty dataset (last dimension can be empty)

  call initialize_write(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, &
                        loc_id,myShape,datasetName,H5T_NATIVE_INTEGER, &
                        misc_optional(parallel,parallel_default))

  if (product(totalShape) /= 0) then
    call H5Dwrite_f(dset_id, H5T_NATIVE_INTEGER,dataset,int(totalShape,HSIZE_T), hdferr,&
                   file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call finalize_write(plist_id, dset_id, filespace_id, memspace_id)

end subroutine HDF5_write_int2

!--------------------------------------------------------------------------------------------------
!> @brief Write dataset of type integer with 3 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_write_int3(dataset,loc_id,datasetName,parallel)

  integer,          intent(in), dimension(:,:,:) :: dataset                                         !< data written to file
  integer(HID_T),   intent(in)  :: loc_id                                                           !< file or group handle
  character(len=*), intent(in)  :: datasetName                                                      !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes


  integer :: hdferr
  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)

!---------------------------------------------------------------------------------------------------
! determine shape of dataset
  myShape = int(shape(dataset),HSIZE_T)
  if (any(myShape(1:size(myShape)-1) == 0)) return                                                  !< empty dataset (last dimension can be empty)

  call initialize_write(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, &
                        loc_id,myShape,datasetName,H5T_NATIVE_INTEGER, &
                        misc_optional(parallel,parallel_default))

  if (product(totalShape) /= 0) then
    call H5Dwrite_f(dset_id, H5T_NATIVE_INTEGER,dataset,int(totalShape,HSIZE_T), hdferr,&
                   file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call finalize_write(plist_id, dset_id, filespace_id, memspace_id)

end subroutine HDF5_write_int3

!--------------------------------------------------------------------------------------------------
!> @brief Write dataset of type integer with 4 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_write_int4(dataset,loc_id,datasetName,parallel)

  integer,          intent(in), dimension(:,:,:,:) :: dataset                                       !< data written to file
  integer(HID_T),   intent(in)  :: loc_id                                                           !< file or group handle
  character(len=*), intent(in)  :: datasetName                                                      !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes


  integer :: hdferr
  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)

!---------------------------------------------------------------------------------------------------
! determine shape of dataset
  myShape = int(shape(dataset),HSIZE_T)
  if (any(myShape(1:size(myShape)-1) == 0)) return                                                  !< empty dataset (last dimension can be empty)

  call initialize_write(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, &
                        loc_id,myShape,datasetName,H5T_NATIVE_INTEGER, &
                        misc_optional(parallel,parallel_default))

  if (product(totalShape) /= 0) then
    call H5Dwrite_f(dset_id, H5T_NATIVE_INTEGER,dataset,int(totalShape,HSIZE_T), hdferr,&
                   file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call finalize_write(plist_id, dset_id, filespace_id, memspace_id)

end subroutine HDF5_write_int4

!--------------------------------------------------------------------------------------------------
!> @brief Write dataset of type integer with 5 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_write_int5(dataset,loc_id,datasetName,parallel)

  integer,          intent(in), dimension(:,:,:,:,:) :: dataset                                     !< data written to file
  integer(HID_T),   intent(in)  :: loc_id                                                           !< file or group handle
  character(len=*), intent(in)  :: datasetName                                                      !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes


  integer :: hdferr
  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)

!---------------------------------------------------------------------------------------------------
! determine shape of dataset
  myShape = int(shape(dataset),HSIZE_T)
  if (any(myShape(1:size(myShape)-1) == 0)) return                                                  !< empty dataset (last dimension can be empty)

  call initialize_write(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, &
                        loc_id,myShape,datasetName,H5T_NATIVE_INTEGER, &
                        misc_optional(parallel,parallel_default))

  if (product(totalShape) /= 0) then
    call H5Dwrite_f(dset_id, H5T_NATIVE_INTEGER,dataset,int(totalShape,HSIZE_T), hdferr,&
                   file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
   call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call finalize_write(plist_id, dset_id, filespace_id, memspace_id)

end subroutine HDF5_write_int5

#else

!--------------------------------------------------------------------------------------------------
!> @brief Write dataset of type integer with 1-5 dimensions.
!--------------------------------------------------------------------------------------------------
subroutine HDF5_write_int(dataset,loc_id,datasetName,parallel)

  integer,          intent(in), dimension(..) :: dataset                                            !< data written to file
  integer(HID_T),   intent(in)  :: loc_id                                                           !< file or group handle
  character(len=*), intent(in)  :: datasetName                                                      !< name of the dataset in the file
  logical, intent(in), optional :: parallel                                                         !< dataset is distributed over multiple processes


  integer :: hdferr
  integer(HID_T)   :: dset_id, filespace_id, memspace_id, plist_id
  integer(HSIZE_T), dimension(rank(dataset)) :: &
    myStart, &
    myShape, &                                                                                      !< shape of the dataset (this process)
    totalShape                                                                                      !< shape of the dataset (all processes)

!---------------------------------------------------------------------------------------------------
! determine shape of dataset
  myShape = int(shape(dataset),HSIZE_T)
  if (any(myShape(1:size(myShape)-1) == 0)) return                                                  !< empty dataset (last dimension can be empty)

  call initialize_write(myStart,totalShape,dset_id,filespace_id,memspace_id,plist_id, &
                        loc_id,myShape,datasetName,H5T_NATIVE_INTEGER, &
                        misc_optional(parallel,parallel_default))

  if (product(totalShape) /= 0) then
    select rank(dataset)
      rank(1)
        call H5Dwrite_f(dset_id, H5T_NATIVE_INTEGER,dataset,int(totalShape,HSIZE_T), hdferr,&
                       file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
      rank(2)
        call H5Dwrite_f(dset_id, H5T_NATIVE_INTEGER,dataset,int(totalShape,HSIZE_T), hdferr,&
                       file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
      rank(3)
        call H5Dwrite_f(dset_id, H5T_NATIVE_INTEGER,dataset,int(totalShape,HSIZE_T), hdferr,&
                       file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
      rank(4)
        call H5Dwrite_f(dset_id, H5T_NATIVE_INTEGER,dataset,int(totalShape,HSIZE_T), hdferr,&
                       file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
      rank(5)
        call H5Dwrite_f(dset_id, H5T_NATIVE_INTEGER,dataset,int(totalShape,HSIZE_T), hdferr,&
                       file_space_id = filespace_id, mem_space_id = memspace_id, xfer_prp = plist_id)
    end select
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if

  call finalize_write(plist_id, dset_id, filespace_id, memspace_id)

end subroutine HDF5_write_int
#endif


!--------------------------------------------------------------------------------------------------
!> @brief Initialize read handles and determine global shape in case of parallel IO.
!--------------------------------------------------------------------------------------------------
subroutine initialize_read(myStart, globalShape, dset_id, filespace_id, memspace_id, plist_id, aplist_id, &
                           loc_id,localShape,datasetName,parallel)

  integer(HID_T),    intent(in) :: loc_id                                                           !< file or group handle
  character(len=*),  intent(in) :: datasetName                                                      !< name of the dataset in the file
  logical,           intent(in) :: parallel
  integer(HSIZE_T),  intent(in),  dimension(:) :: localShape
  integer(HSIZE_T),  intent(out), dimension(size(localShape)) :: &
    myStart, &
    globalShape                                                                                     !< shape of the dataset (all processes)
  integer(HID_T),    intent(out) :: dset_id, filespace_id, memspace_id, plist_id, aplist_id

  integer(MPI_INTEGER_KIND), dimension(worldsize) :: readSize                                       !< contribution of all processes
  integer :: hdferr
  integer(MPI_INTEGER_KIND) :: err_MPI

!-------------------------------------------------------------------------------------------------
! creating a property list for transfer properties (is collective for MPI)
  call H5Pcreate_f(H5P_DATASET_XFER_F, plist_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

!--------------------------------------------------------------------------------------------------
  readSize = 0_MPI_INTEGER_KIND
  readSize(worldrank+1) = int(localShape(ubound(localShape,1)),MPI_INTEGER_KIND)
#ifdef PETSC
  if (parallel) then
    call H5Pset_dxpl_mpio_f(plist_id, H5FD_MPIO_COLLECTIVE_F, hdferr)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
    call MPI_Allgather(int(localShape(ubound(localShape,1)),MPI_INTEGER_KIND),1_MPI_INTEGER_KIND,MPI_INTEGER,&
                       readSize,1_MPI_INTEGER_KIND,MPI_INTEGER,MPI_COMM_WORLD,err_MPI)
    call parallelization_chkerr(err_MPI)
  end if
#endif
  myStart                   = int(0,HSIZE_T)
  myStart(ubound(myStart))  = int(sum(readSize(1:worldrank)),HSIZE_T)
  globalShape = [localShape(1:ubound(localShape,1)-1),int(sum(readSize),HSIZE_T)]

  if (any(globalShape == 0)) then
    call H5Pclose_f(plist_id, hdferr)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
    return
  end if

!--------------------------------------------------------------------------------------------------
! create dataspace in memory (local shape)
  call H5Screate_simple_f(size(localShape), localShape, memspace_id, hdferr, localShape)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

!--------------------------------------------------------------------------------------------------
! creating a property list for IO and set it to collective
  call H5Pcreate_f(H5P_DATASET_ACCESS_F, aplist_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
#ifdef PETSC
  call H5Pset_all_coll_metadata_ops_f(aplist_id, .true., hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
#endif

!--------------------------------------------------------------------------------------------------
! open the dataset in the file and get the space ID
  call H5Dopen_f(loc_id,datasetName,dset_id,hdferr, dapl_id = aplist_id)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Dget_space_f(dset_id, filespace_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

!--------------------------------------------------------------------------------------------------
! select a hyperslab (the portion of the current process) in the file
  call H5Sselect_hyperslab_f(filespace_id, H5S_SELECT_SET_F, myStart, localShape, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

end subroutine initialize_read


!--------------------------------------------------------------------------------------------------
!> @brief Close read handles.
!--------------------------------------------------------------------------------------------------
subroutine finalize_read(dset_id, filespace_id, memspace_id, plist_id, aplist_id)

  integer(HID_T), intent(in) :: dset_id, filespace_id, memspace_id, plist_id, aplist_id
  integer :: hdferr

  call H5Pclose_f(plist_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Pclose_f(aplist_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Dclose_f(dset_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Sclose_f(filespace_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Sclose_f(memspace_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

end subroutine finalize_read


!--------------------------------------------------------------------------------------------------
!> @brief Initialize write handles and determine global shape in case of parallel IO.
!--------------------------------------------------------------------------------------------------
subroutine initialize_write(myStart, totalShape, dset_id, filespace_id, memspace_id, plist_id, &
                            loc_id, localShape, datasetName, datatype, parallel)

  integer(HID_T),    intent(in) :: loc_id                                                           !< file or group handle
  character(len=*),  intent(in) :: datasetName                                                      !< name of the dataset in the file
  logical,           intent(in) :: parallel
  integer(HID_T),    intent(in) :: datatype
  integer(HSIZE_T),  intent(in),  dimension(:) :: localShape
  integer(HSIZE_T),  intent(out), dimension(size(localShape)) :: &
    myStart, &
    totalShape                                                                                      !< shape of the dataset (all processes)
  integer(HID_T),    intent(out) :: dset_id, filespace_id, memspace_id, plist_id

  integer(MPI_INTEGER_KIND), dimension(worldsize) :: writeSize                                      !< contribution of all processes
  integer(HID_T) :: dcpl
  integer :: hdferr
  integer(MPI_INTEGER_KIND) :: err_MPI
  integer(HSIZE_T), parameter :: chunkSize = 1024_HSIZE_T**2/8_HSIZE_T


!-------------------------------------------------------------------------------------------------
! creating a property list for transfer properties (is collective when writing in parallel)
  call H5Pcreate_f(H5P_DATASET_XFER_F, plist_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
#ifdef PETSC
  if (parallel) then
    call H5Pset_dxpl_mpio_f(plist_id, H5FD_MPIO_COLLECTIVE_F, hdferr)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  end if
#endif

!--------------------------------------------------------------------------------------------------
! determine the global data layout among all processes
  writeSize              = 0_MPI_INTEGER_KIND
  writeSize(worldrank+1) = int(localShape(ubound(localShape,1)),MPI_INTEGER_KIND)
#ifdef PETSC
  if (parallel) then
    call MPI_Allgather(int(localShape(ubound(localShape,1)),MPI_INTEGER_KIND),1_MPI_INTEGER_KIND,MPI_INTEGER,&
                       writeSize,1_MPI_INTEGER_KIND,MPI_INTEGER,MPI_COMM_WORLD,err_MPI)
    call parallelization_chkerr(err_MPI)
  end if
#endif
  myStart                   = int(0,HSIZE_T)
  myStart(ubound(myStart))  = int(sum(writeSize(1:worldrank)),HSIZE_T)
  totalShape = [localShape(1:ubound(localShape,1)-1),int(sum(writeSize),HSIZE_T)]

!--------------------------------------------------------------------------------------------------
! chunk dataset, enable compression for larger datasets
  call H5Pcreate_f(H5P_DATASET_CREATE_F, dcpl, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  if (product(totalShape) > 0) then
    call H5Pset_Fletcher32_f(dcpl,hdferr)
    call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

    if (product(totalShape) >= chunkSize*2_HSIZE_T) then
      call H5Pset_chunk_f(dcpl, size(totalShape), get_chunks(totalShape,chunkSize), hdferr)
      call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
      if (compression_possible) then
        call H5Pset_shuffle_f(dcpl, hdferr)
        call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
        call H5Pset_deflate_f(dcpl, 6, hdferr)
        call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
      end if
    else
      call H5Pset_chunk_f(dcpl, size(totalShape), totalShape, hdferr)
      call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
    end if
  end if

!--------------------------------------------------------------------------------------------------
! create dataspace in memory (local shape) and in file (global shape)
  call H5Screate_simple_f(size(localShape), localShape, memspace_id, hdferr, localShape)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Screate_simple_f(size(totalShape), totalShape, filespace_id, hdferr, totalShape)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

!--------------------------------------------------------------------------------------------------
! create dataset in the file and select a hyperslab from it (the portion of the current process)
  call H5Dcreate_f(loc_id, trim(datasetName), datatype, filespace_id, dset_id, hdferr, dcpl)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Sselect_hyperslab_f(filespace_id, H5S_SELECT_SET_F, myStart, localShape, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  call H5Pclose_f(dcpl, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

  contains
  !------------------------------------------------------------------------------------------------
  !> @brief Determine chunk layout.
  !------------------------------------------------------------------------------------------------
  pure function get_chunks(totalShape,chunkSize)
#ifndef __GFORTRAN__
    use HDF5
    import, none
#endif

    integer(HSIZE_T), dimension(:), intent(in)    :: totalShape
    integer(HSIZE_T),               intent(in)    :: chunkSize
    integer(HSIZE_T), dimension(size(totalShape)) :: get_chunks

    get_chunks = [totalShape(1:size(totalShape)-1),&
                  chunkSize/product(totalShape(1:size(totalShape)-1))]

  end function get_chunks

end subroutine initialize_write


!--------------------------------------------------------------------------------------------------
!> @brief Closes write handles.
!--------------------------------------------------------------------------------------------------
subroutine finalize_write(plist_id, dset_id, filespace_id, memspace_id)

  integer(HID_T), intent(in) :: dset_id, filespace_id, memspace_id, plist_id
  integer :: hdferr

  call H5Pclose_f(plist_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Dclose_f(dset_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Sclose_f(filespace_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))
  call H5Sclose_f(memspace_id, hdferr)
  call HDF5_chkerr(hdferr,__FILE__//':'//IO_intAsStr(__LINE__))

end subroutine finalize_write


end module HDF5_Utilities

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author Christoph Kords, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief  input/output functions
!--------------------------------------------------------------------------------------------------
module IO
  use, intrinsic :: ISO_C_binding
  use, intrinsic :: ISO_Fortran_env, only: &
    IO_STDOUT => OUTPUT_UNIT, &
    IO_STDERR => ERROR_UNIT, &
    IO_STDIN => INPUT_UNIT

  use prec
  use constants
  use misc

  implicit none(type,external)
  private

  interface
#ifndef MARC_SOURCE
    function isatty_stdout_C() bind(C)
      use, intrinsic :: ISO_C_binding, only: C_BOOL

      implicit none(type,external)
      logical(C_BOOL) :: isatty_stdout_C
    end function isatty_stdout_C

    function isatty_stderr_C() bind(C)
      use, intrinsic :: ISO_C_binding, only: C_BOOL

      implicit none(type,external)
      logical(C_BOOL) :: isatty_stderr_C
    end function isatty_stderr_C

    function isatty_stdin_C() bind(C)
      use, intrinsic :: ISO_C_binding, only: C_BOOL

      implicit none(type,external)
      logical(C_BOOL) :: isatty_stdin_C
    end function isatty_stdin_C
#else
    subroutine quit(stop_id)

      implicit none(type,external)
      integer, intent(in) :: stop_id
    end subroutine quit
#endif
  end interface

  ! For transition period
  interface IO_error
    module procedure IO_error_new
    module procedure IO_error_old
  end interface IO_error

  character, parameter, public :: &
    IO_ESC = achar(27), &                                                                           !< escape character
    IO_EOL = LF                                                                                     !< end of line character
  character(len=*), parameter, public :: &
    IO_FORMATRESET = IO_ESC//'[0m', &                                                               !< reset formatting
    IO_EMPH = IO_ESC//'[3m', &                                                                      !< emphasize (italics)
    IO_QUOTES  = "'"//'"' , &                                                                       !< quotes for strings
    IO_WHITESPACE = achar(44)//achar(32)//achar(9)//achar(10)//achar(13)                            !< whitespace characters

#ifndef MARC_SOURCE
    logical(C_BOOL), bind(C, name='IO_redirectedSTDOUT'), public :: IO_redirectedSTDOUT = .false.   !< STDOUT writes to file 'out.X' where X is the world rank
    logical(C_BOOL), bind(C, name='IO_redirectedSTDERR'), public :: IO_redirectedSTDERR = .false.   !< STDERR writes to file 'err.X' where X is the world rank
#endif
   logical :: IO_colored = .true.                                                                   !< status of colored output

  public :: &
    quit, &
    IO_init, &
    IO_selfTest, &
    IO_read, &
    IO_wrapLines, &
    IO_lc, &
    IO_glueDiffering, &
    IO_intAsStr, &
    IO_realAsStr, &
    IO_strAsInt, &
    IO_strAsReal, &
    IO_strAsBool, &
    IO_color, &
    IO_error, &
    IO_warning, &
    IO_STDOUT, &
    IO_STDERR, &
    tokenize

contains


!--------------------------------------------------------------------------------------------------
!> @brief Set options related to use of ANSI escape codes and do self test.
!--------------------------------------------------------------------------------------------------
subroutine IO_init()

  character(len=pSTRLEN) :: fname
  integer :: status


  print'(/,1x,a)', '<<<+-  IO init  -+>>>'; flush(IO_STDOUT)

#ifndef MARC_SOURCE
  ! redirection occurs in parallelization_init before any output is written
  inquire(unit=IO_STDOUT,name=fname)
  IO_redirectedSTDOUT = logical(fname(:4) == 'out.',C_BOOL)
  inquire(unit=IO_STDERR,name=fname)
  IO_redirectedSTDERR = logical(fname(:4) == 'err.',C_BOOL)
#endif
  call get_environment_variable('NO_COLOR',status=status)                                           !< https://no-color.org
  IO_colored = 0 /= status

  call IO_selfTest()

end subroutine IO_init


!--------------------------------------------------------------------------------------------------
!> @brief Read ASCII file.
!> @details Proper Unix style (LF line endings and LF at EOF) is ensured.
!--------------------------------------------------------------------------------------------------
function IO_read(fileName) result(fileContent)

  character(len=*),  intent(in) :: fileName
  character(len=:), allocatable :: fileContent

  integer ::  &
    fileUnit, &
    myStat
  integer(pI64) ::  &
    fileLength


  inquire(file = fileName, size=fileLength)
  open(newunit=fileUnit, file=fileName, access='stream',&
       status='old', position='rewind', action='read',iostat=myStat)
  if (myStat /= 0) call IO_error(100_pI16,'cannot open file',fileName,emph=[2])
  allocate(character(len=fileLength)::fileContent)
  if (fileLength==0) then
    close(fileUnit)
    return
  end if

  read(fileUnit,iostat=myStat) fileContent
  if (myStat /= 0) call IO_error(100_pI16,'cannot read from file',fileName,emph=[2])
  close(fileUnit)

  if (index(fileContent,CR//LF,kind=pI64) /= 0)     fileContent = CRLF2LF(fileContent)
  if (fileContent(fileLength:fileLength) /= IO_EOL) fileContent = fileContent//IO_EOL               ! ensure EOL@EOF

end function IO_read


!--------------------------------------------------------------------------------------------------
!> @brief Insert EOL at separator trying to keep line length below limit.
!--------------------------------------------------------------------------------------------------
function IO_wrapLines(str,separator,filler,length)

  character(len=*),    intent(in) :: str                                                            !< string to split
  character, optional, intent(in) :: separator                                                      !< line breaks are possible after this character, defaults to ','
  character(len=*), optional, intent(in) :: filler                                                  !< character(s) to insert after line break, defaults to none
  integer,   optional, intent(in) :: length                                                         !< (soft) line limit, defaults to 80
  character(len=:), allocatable :: IO_wrapLines

  integer, dimension(:), allocatable :: pos_sep, pos_split
  integer :: i,s,e


  i = index(str,misc_optional(separator,','))
  if (i == 0) then
    IO_wrapLines = str
  else
    pos_sep = [0]
    s = i
    do while (i /= 0 .and. s < len(str))
      pos_sep = [pos_sep,s]
      i = index(str(s+1:),misc_optional(separator,','))
      s = s + i
    end do
    pos_sep = [pos_sep,len(str)]

    pos_split = emptyIntArray
    s = 1
    e = 2
    IO_wrapLines = ''
    do while (e < size(pos_sep))
      if (pos_sep(e+1) - pos_sep(s) >= misc_optional(length,80)) then
        IO_wrapLines = IO_wrapLines//adjustl(str(pos_sep(s)+1:pos_sep(e)))//IO_EOL//misc_optional(filler,'')
        s = e
      end if
      e = e + 1
    end do
    IO_wrapLines = IO_wrapLines//adjustl(str(pos_sep(s)+1:))
  end if

end function IO_wrapLines


!--------------------------------------------------------------------------------------------------
!> @brief Convert characters in string to lower case.
!--------------------------------------------------------------------------------------------------
pure function IO_lc(str)

  character(len=*), intent(in) :: str                                                               !< string to convert
  character(len=len(str))   :: IO_lc

  integer :: i,n


  do i = 1,len(str)
    n = index(UPPER,str(i:i))
    if (n==0) then
      IO_lc(i:i) = str(i:i)
    else
      IO_lc(i:i) = LOWER(n:n)
    end if
  end do

end function IO_lc


!--------------------------------------------------------------------------------------------------
! @brief Return first (with glued on second if they differ).
!--------------------------------------------------------------------------------------------------
pure function IO_glueDiffering(first,second,glue)

  character(len=*),           intent(in)  :: first
  character(len=*),           intent(in)  :: second
  character(len=*), optional, intent(in)  :: glue
  character(len=:), allocatable :: IO_glueDiffering

  character(len=:), allocatable           :: glue_


  glue_ = misc_optional(glue,'<--')
  IO_glueDiffering = trim(first)
  if (trim(first) /= trim(second)) IO_glueDiffering = IO_glueDiffering//' '//trim(glue_)//' '//trim(second)

end function IO_glueDiffering


!--------------------------------------------------------------------------------------------------
!> @brief Return given int value as string.
!--------------------------------------------------------------------------------------------------
pure function IO_intAsStr(i)

  integer, intent(in) :: i
  character(len=merge(2,1,i<0) + floor(log10(real(abs(merge(1,i,i==0)))))) :: IO_intAsStr


  write(IO_intAsStr,'(i0)') i

end function IO_intAsStr


!--------------------------------------------------------------------------------------------------
!> @brief Return given float value as string.
!--------------------------------------------------------------------------------------------------
pure function IO_realAsStr(r)

  real(pREAL), intent(in) :: r
  character(len=:), allocatable :: IO_realAsStr

  character(len=15) :: tmp


  write(tmp,'(g15.7)') r
  tmp = adjustl(tmp)
  IO_realAsStr = tmp(:len_trim(tmp))

end function IO_realAsStr


!--------------------------------------------------------------------------------------------------
!> @brief Return integer value from given string.
!--------------------------------------------------------------------------------------------------
integer function IO_strAsInt(str)

  character(len=*), intent(in) :: str                                                               !< string for conversion to int value

  integer :: readStatus


  read(str,*,iostat=readStatus) IO_strAsInt
  if (readStatus /= 0) call IO_error(111_pI16,'cannot represent',str,'as integer',emph=[2])

end function IO_strAsInt


!--------------------------------------------------------------------------------------------------
!> @brief Return real value from given string.
!--------------------------------------------------------------------------------------------------
real(pREAL) function IO_strAsReal(str)

  character(len=*), intent(in) :: str                                                               !< string for conversion to real value

  integer :: readStatus


  read(str,*,iostat=readStatus) IO_strAsReal
  if (readStatus /= 0) call IO_error(111_pI16,'cannot represent',str,'as real',emph=[2])

end function IO_strAsReal


!--------------------------------------------------------------------------------------------------
!> @brief Return logical value from given string.
!> @details: 'True' and 'true' are converted to .true.
!> @details: 'False' and 'false' are converted to .false.
!--------------------------------------------------------------------------------------------------
logical function IO_strAsBool(str)

  character(len=*), intent(in) :: str                                                               !< string for conversion to boolean


  if     (trim(adjustl(str)) == 'True' .or.  trim(adjustl(str)) == 'true') then
    IO_strAsBool = .true.
  elseif (trim(adjustl(str)) == 'False' .or. trim(adjustl(str)) == 'false') then
    IO_strAsBool = .false.
  else
    call IO_error(111_pI16,'cannot represent',str,'as boolean',emph=[2])
  end if

end function IO_strAsBool


!--------------------------------------------------------------------------------------------------
!> @brief Return string to set foreground and/or background color.
!> @details Only active if unit is a TTY. Does nothing for MSC.Marc. No color disables formatting.
!> @details https://stackoverflow.com/questions/4842424
!--------------------------------------------------------------------------------------------------
function IO_color(fg,bg,unit)

  character(len=:), allocatable :: IO_color
  integer, intent(in), dimension(3), optional :: &
    fg, &                                                                                           !< foreground color (8 bit RGB)
    bg                                                                                              !< background color (8 bit RGB)
  integer, intent(in), optional :: unit                                                             !< output unit (default STDOUT)


  IO_color = ''

  if (.not. IO_colored .or. .not. IO_isaTTY(misc_optional(unit,int(IO_STDOUT)))) return

  if (present(fg)) &
    IO_color = IO_color//IO_ESC//'[38;2;'//IO_intAsStr(fg(1))//';' &
                                         //IO_intAsStr(fg(2))//';' &
                                         //IO_intAsStr(fg(3))//'m'
  if (present(bg)) &
    IO_color = IO_color//IO_ESC//'[48;2;'//IO_intAsStr(bg(1))//';' &
                                         //IO_intAsStr(bg(2))//';' &
                                         //IO_intAsStr(bg(3))//'m'

  if (.not. present(fg) .and. .not. present(bg)) IO_color = IO_FORMATRESET

end function IO_color


!--------------------------------------------------------------------------------------------------
!> @brief Write error statements and terminate the run with exit #9xxx.
!> @details Should become "IO_error" after completed migration.
!--------------------------------------------------------------------------------------------------
subroutine IO_error_new(error_ID, &
                        info_1,info_2,info_3,info_4,info_5,info_6,info_7,info_8,info_9, &
                        emph)


  integer(pI16),      intent(in) :: error_ID        ! should go back to default integer after completed migration.
  class(*), optional, intent(in) :: info_1,info_2,info_3,info_4,info_5,info_6,info_7,info_8,info_9
  integer, dimension(:), optional, intent(in) :: emph                                               !< which info(s) to emphasize

  character(len=:), allocatable :: msg


  select case (error_ID)

!--------------------------------------------------------------------------------------------------
! file handling errors
    case (100)
      msg = 'file error'

!--------------------------------------------------------------------------------------------------
! file parsing errors
    case (110)
      msg = 'invalid chunk selected'
    case (111)
      msg = 'invalid string for conversion'
    case (114)
      msg = 'cannot decode base64 string:'

!--------------------------------------------------------------------------------------------------
! lattice error messages
    case (130)
      msg = 'invalid crystal parameters'
    case (138)
      msg = 'not enough interaction parameters given'

!--------------------------------------------------------------------------------------------------
! errors related to the parsing of material.yaml
    case (141)
      msg = 'number of chunks in string differs'
    case (142)
      msg = 'empty list'
    case (143)
      msg = 'key error'
    case (144)
      msg = 'negative number systems requested'
    case (145)
      msg = 'too many systems requested'
    case (146)
      msg = 'number of values does not match'
    case (147)
      msg = 'V_e needs to be symmetric'
    case (148)
      msg = 'Nconstituents mismatch between homogenization and material'

!--------------------------------------------------------------------------------------------------
! material error messages and related messages in geometry
    case (150)
      msg = 'index out of bounds'
    case (153)
      msg = 'sum of phase fractions differs from 1'
    case (155)
      msg = 'material index out of bounds'
    case (180)
      msg = 'missing/invalid material definition'
    case (190)
      msg = 'unknown element type:'
    case (191)
      msg = 'mesh contains more than one element type'

!--------------------------------------------------------------------------------------------------
! plasticity error messages
    case (200)
      msg = 'unknown type specified:'

    case (211)
      msg = 'material parameter out of bounds:'
    case (212)
      msg = 'nonlocal model not supported'

!--------------------------------------------------------------------------------------------------
! numerics error messages
    case (301)
      msg = 'numerics parameter out of bounds:'

!--------------------------------------------------------------------------------------------------
! math errors
    case (402)
      msg = 'invalid orientation specified'

!-------------------------------------------------------------------------------------------------
! homogenization errors
    case (500)
      msg = 'unknown homogenization specified'
    case (501)
      msg = 'homogenization description absent'

!--------------------------------------------------------------------------------------------------
! user errors
    case (600)
      msg = 'only one source entry allowed'
    case (601)
      msg = 'invalid option'
    case (603)
      msg = 'invalid data for table'
    case (610)
      msg = 'invalid command line options'
    case (640)
      msg = 'invalid working directory'


!------------------------------------------------------------------------------------------------
! errors related to YAML data
    case (701)
      msg = 'incorrect indent/Null value not allowed'
    case (702)
      msg = 'invalid use of flow YAML'
    case (703)
      msg = 'invalid YAML'
    case (704)
      msg = 'space expected after a colon for <key>: <value> pair'
    case (706)
      msg = 'type mismatch in YAML data node'
    case (708)
      msg = '"---" expected after YAML file header'
    case (709)
      msg = 'length mismatch'
    case (710)
      msg = 'closing quotation mark missing in string'

!-------------------------------------------------------------------------------------------------
! errors related to the mesh solver
    case (800)
      msg = 'invalid mesh'
    case (812)
      msg = 'invalid boundary conditions'

!-------------------------------------------------------------------------------------------------
! errors related to the grid solver
    case (830)
      msg = 'invalid load case'
    case (844)
      msg = 'invalid VTI file'
    case (894)
      msg = 'MPI error'

    case (950)
      msg = 'max number of cutbacks exceeded, terminating'

    case default
      error stop 'invalid error number'

  end select

  call panel('error',int(error_ID),msg, &
             info_1,info_2,info_3,info_4,info_5,info_6,info_7,info_8,info_9, &
             emph)
  call quit(9000+int(error_ID))

end subroutine IO_error_new


!--------------------------------------------------------------------------------------------------
!> @brief Write error statements and terminate the run with exit #9xxx.
!> @details Deprecated.
!--------------------------------------------------------------------------------------------------
subroutine IO_error_old(error_ID,ext_msg,label1,ID1,label2,ID2)

  integer,                    intent(in) :: error_ID
  character(len=*), optional, intent(in) :: ext_msg,label1,label2
  integer,          optional, intent(in) :: ID1,ID2

  character(len=:), allocatable :: msg_extra


  if (.not. present(label1) .and. present(ID1)) error stop 'missing label for value 1'
  if (.not. present(label2) .and. present(ID2)) error stop 'missing label for value 2'

  msg_extra = ''
  if (present(ext_msg)) msg_extra = msg_extra//ext_msg//IO_EOL
  if (present(label1)) then
    msg_extra = msg_extra//'at '//label1
    if (present(ID1)) msg_extra = msg_extra//' '//IO_intAsStr(ID1)
    msg_extra = msg_extra//IO_EOL
  end if
  if (present(label2)) then
    msg_extra = msg_extra//'at '//label2
    if (present(ID2)) msg_extra = msg_extra//' '//IO_intAsStr(ID2)
    msg_extra = msg_extra//IO_EOL
  end if

  call IO_error_new(int(error_ID,pI16),msg_extra,IO_EOL)

end subroutine IO_error_old


!--------------------------------------------------------------------------------------------------
!> @brief Write warning statements.
!--------------------------------------------------------------------------------------------------
subroutine IO_warning(warning_ID, &
                      info_1,info_2,info_3,info_4,info_5,info_6,info_7,info_8,info_9, &
                      emph)

  integer,                         intent(in) :: warning_ID
  class(*),              optional, intent(in) :: info_1,info_2,info_3,info_4,info_5,info_6,info_7,info_8,info_9
  integer, dimension(:), optional, intent(in) :: emph                                               !< which info(s) to emphasize

  character(len=:), allocatable :: msg


  select case (warning_ID)
    case (10)
      msg = 'deprecated keyword'
    case (207)
      msg = 'line truncated'
    case (600)
      msg = 'failed to converge'
    case (601)
      msg = 'unexpected stiffness'
    case (709)
      msg = 'read only the first document'

    case default
      error stop 'invalid warning number'
  end select

  call panel('warning',int(warning_ID),msg, &
             info_1,info_2,info_3,info_4,info_5,info_6,info_7,info_8,info_9, &
             emph)

end subroutine IO_warning


!--------------------------------------------------------------------------------------------------
!> @brief C interface to IO_error_new taking a CFI character string.
!--------------------------------------------------------------------------------------------------
subroutine F_IO_error(error_ID, msg) bind(C, name='F_IO_error')

  integer(C_INT), intent(in), value :: error_ID
  character(kind=C_CHAR,len=*), intent(in) :: msg


  call IO_error_new(int(error_ID,pI16), msg)

end subroutine F_IO_error


!--------------------------------------------------------------------------------------------------
!> @brief Test whether a file descriptor refers to a terminal.
!> @detail A terminal is neither a file nor a redirected STDOUT/STDERR/STDIN.
!>         This function cannot detect redirection when invoked via mpirun/mpiexec.
!--------------------------------------------------------------------------------------------------
logical function IO_isaTTY(unit)

  integer, intent(in) :: unit


  select case(unit)
#ifndef MARC_SOURCE
    case (IO_STDOUT)
      IO_isaTTY = .not. logical(IO_redirectedSTDOUT) .and. logical(isatty_stdout_C())
    case (IO_STDERR)
      IO_isaTTY = .not. logical(IO_redirectedSTDERR) .and. logical(isatty_stderr_C())
    case (IO_STDIN)
      IO_isaTTY = logical(isatty_stdin_C())
#endif
    case default
      IO_isaTTY = .false.
  end select

end function IO_isaTTY


!--------------------------------------------------------------------------------------------------
!> @brief Check correctness of some IO functions.
!--------------------------------------------------------------------------------------------------
subroutine IO_selfTest()

  character(len=:),      allocatable :: str
  character(len=:), dimension(:), allocatable :: tokens


  if (dNeq(1.0_pREAL, IO_strAsReal('1.0')))          error stop 'IO_strAsReal'
  if (dNeq(1.0_pREAL, IO_strAsReal('1e0')))          error stop 'IO_strAsReal'
  if (dNeq(0.1_pREAL, IO_strAsReal('1e-1')))         error stop 'IO_strAsReal'
  if (dNeq(0.1_pREAL, IO_strAsReal('1.0e-1')))       error stop 'IO_strAsReal'
  if (dNeq(0.1_pREAL, IO_strAsReal('1.00e-1')))      error stop 'IO_strAsReal'
  if (dNeq(10._pREAL, IO_strAsReal(' 1.0e+1 ')))     error stop 'IO_strAsReal'

  if (3112019  /= IO_strAsInt( '3112019'))           error stop 'IO_strAsInt'
  if (3112019  /= IO_strAsInt(' 3112019'))           error stop 'IO_strAsInt'
  if (-3112019 /= IO_strAsInt('-3112019'))           error stop 'IO_strAsInt'
  if (3112019  /= IO_strAsInt('+3112019 '))          error stop 'IO_strAsInt'
  if (3112019  /= IO_strAsInt('03112019 '))          error stop 'IO_strAsInt'
  if (3112019  /= IO_strAsInt('+03112019'))          error stop 'IO_strAsInt'

  if (.not. IO_strAsBool(' true'))                   error stop 'IO_strAsBool'
  if (.not. IO_strAsBool(' True '))                  error stop 'IO_strAsBool'
  if (      IO_strAsBool(' false'))                  error stop 'IO_strAsBool'
  if (      IO_strAsBool('False'))                   error stop 'IO_strAsBool'

  if ('1234' /= IO_intAsStr(1234))                   error stop 'IO_intAsStr'
  if ('-12'  /= IO_intAsStr(-0012))                  error stop 'IO_intAsStr'

  if ('-0.1200000' /= IO_realAsStr(-0.12_pREAL))        error stop 'IO_realAsStr'
  if ('0.1234000E-31' /= IO_realAsStr(123.4e-34_pREAL)) error stop 'IO_realAsStr'

  if (CRLF2LF('') /= '')                             error stop 'CRLF2LF/0'
  if (CRLF2LF(LF)     /= LF)                         error stop 'CRLF2LF/1a'
  if (CRLF2LF(CR//LF) /= LF)                         error stop 'CRLF2LF/1b'
  if (CRLF2LF(' '//LF)     /= ' '//LF)               error stop 'CRLF2LF/2a'
  if (CRLF2LF(' '//CR//LF) /= ' '//LF)               error stop 'CRLF2LF/2b'
  if (CRLF2LF('A'//CR//LF//'B') /= 'A'//LF//'B')     error stop 'CRLF2LF/3'
  if (CRLF2LF('A'//CR//LF//'B'//CR//LF) /= &
              'A'//LF//'B'//LF)                      error stop 'CRLF2LF/4'
  if (CRLF2LF('A'//LF//CR//'B') /= 'A'//LF//CR//'B') error stop 'CRLF2LF/5'

  str='*(HiU!)3';if ('*(hiu!)3' /= IO_lc(str))       error stop 'IO_lc'

  if ('abc, def' /= IO_wrapLines('abc, def')) &
                                                     error stop 'IO_wrapLines/1'
  if ('abc,'//IO_EOL//'def' /= IO_wrapLines('abc,def',length=3)) &
                                                     error stop 'IO_wrapLines/2'
  if ('abc,'//IO_EOL//'def' /= IO_wrapLines('abc,def',length=5)) &
                                                     error stop 'IO_wrapLines/3'
  if ('abc, def' /= IO_wrapLines('abc, def',length=3,separator='.')) &
                                                     error stop 'IO_wrapLines/4'
  if ('abc.'//IO_EOL//'def' /= IO_wrapLines('abc. def',length=3,separator='.')) &
                                                     error stop 'IO_wrapLines/5'
  if ('abc,'//IO_EOL//'defg,'//IO_EOL//'hij' /= IO_wrapLines('abc,defg,hij',length=4)) &
                                                     error stop 'IO_wrapLines/6'
  if ('abc,'//IO_EOL//'xxdefg,'//IO_EOL//'xxhij' /= IO_wrapLines('abc,defg, hij',filler='xx',length=4)) &
                                                     error stop 'IO_wrapLines/7'

#if ((defined(__INTEL_COMPILER) && __INTEL_COMPILER_BUILD_DATE < 20240000) || !defined(__INTEL_COMPILER))
  call tokenize('','$',tokens)
  if (size(tokens) /= 0 .or. len(tokens) /=0) error stop 'tokenize empty'
  call tokenize('abcd','dcba',tokens)
  if (size(tokens) /= 0 .or. len(tokens) /=0) error stop 'tokenize only separators'

  tokens=['a']
  call test_tokenize('a','#',tokens)
  call test_tokenize('#a','#',tokens)
  call test_tokenize('a#','#',tokens)

  tokens=['aa']
  call test_tokenize('aa','#',tokens)
  call test_tokenize('$aa','$',tokens)
  call test_tokenize('aa$','$',tokens)

  tokens=['a','b']
  call test_tokenize('a$b','$',tokens)
  call test_tokenize('@a@$b@','$@',tokens)

  tokens=['aa','bb']
  call test_tokenize('aa$bb','$',tokens)
  call test_tokenize('aa$$bb','$',tokens)
  call test_tokenize('aa$bb$','$',tokens)

  tokens=['aa  ','bbb ','cccc']
  call test_tokenize('aa$bbb$cccc','$',tokens)
  call test_tokenize('$aa$bbb$cccc$','$',tokens)
  call tokenize('#aa@@bbb!!!cccc#','#@!',tokens)


  contains
  pure subroutine test_tokenize(input,delimiter,solution)
#ifndef __GFORTRAN__
    import, only: tokenize
#endif
    character(len=*), intent(in) :: input, delimiter
    character(len=*), dimension(:), intent(in) :: solution

    character(len=:), dimension(:), allocatable :: tok
    integer :: i


    call tokenize(input,delimiter,tok)
    do i = 1,size(tok)
      !if (solution(i) /= tok(i)) error stop 'tokenize "'//solution(i)//'" vs. "'//tok(i)//'"'      ! requires 2018 standard
      if (solution(i) /= tok(i)) error stop 'tokenize'
    end do

  end subroutine test_tokenize
#endif

end subroutine IO_selfTest


#ifndef MARC_SOURCE
!--------------------------------------------------------------------------------------------------
!> @brief Stop execution and report status.
!> @details exits the program and reports current time and duration. Exit code 0 signals
!> everything is fine. Exit code 1 signals an error, message according to IO_error.
!--------------------------------------------------------------------------------------------------
subroutine quit(stop_id)
#include <petsc/finclude/petscsys.h>
  use PETScSys
#ifndef PETSC_EXPOSES_MPI
  use MPI_f08
#endif
  use HDF5

  integer, intent(in) :: stop_id

  integer, dimension(8) :: date_time
  integer :: err_HDF5
  integer(MPI_INTEGER_KIND) :: err_MPI, worldsize
  PetscErrorCode :: err_PETSc


  !$OMP SINGLE
  call H5Open_f(err_HDF5)                                                                           ! prevents error if not opened yet
  if (err_HDF5 < 0) write(IO_STDERR,'(a,i0)') ' Error in H5Open_f ',err_HDF5
  call H5Close_f(err_HDF5)
  if (err_HDF5 < 0) write(IO_STDERR,'(a,i0)') ' Error in H5Close_f ',err_HDF5

  call PetscFinalize(err_PETSc)

  call date_and_time(values = date_time)
  write(IO_STDOUT,'(/,a)') ' DAMASK terminated on:'
  print'(3x,a,1x,2(i2.2,a),i4.4)', 'Date:',date_time(3),'/',date_time(2),'/',date_time(1)
  print'(3x,a,1x,2(i2.2,a),i2.2)', 'Time:',date_time(5),':',date_time(6),':',date_time(7)

  if (stop_id == 0 .and. err_HDF5 == 0 .and. err_PETSC == 0) then
    call MPI_Finalize(err_MPI)
    if (err_MPI /= 0_MPI_INTEGER_KIND) error stop 'MPI_Finalize error'
    stop 0                                                                                          ! normal termination
  else
    call MPI_Comm_size(MPI_COMM_WORLD,worldsize,err_MPI)
    if (err_MPI /= 0_MPI_INTEGER_KIND) error stop 'MPI_Comm error'
    if (stop_id /= 0 .and. worldsize > 1) call MPI_Abort(MPI_COMM_WORLD,1,err_MPI)
    stop 1                                                                                          ! ToDo: return stop ID (needs to be < 125)
  endif
  !$OMP END SINGLE

end subroutine quit


!--------------------------------------------------------------------------------------------------
!> @brief C interface for printing a CFI character string.
!--------------------------------------------------------------------------------------------------
subroutine F_IO_print(msg) bind(C, name='F_IO_print')

  character(kind=C_CHAR,len=*), intent(in) :: msg


  write(IO_STDOUT, '(a)', advance='no') msg
  flush(IO_STDOUT)

end subroutine F_IO_print
#endif


!--------------------------------------------------------------------------------------------------
!> @brief Convert Windows (CRLF) to Unix (LF) line endings.
!--------------------------------------------------------------------------------------------------
pure function CRLF2LF(str)

  character(len=*), intent(in)  :: str
  character(len=:), allocatable :: CRLF2LF

  integer(pI64) :: c,n


  allocate(character(len=len_trim(str,pI64))::CRLF2LF)
  if (len(CRLF2LF,pI64) == 0) return

  n = 0_pI64
  do c=1_pI64, len_trim(str,pI64)
    CRLF2LF(c-n:c-n) = str(c:c)
    if (c == len_trim(str,pI64)) exit
    if (str(c:c+1_pI64) == CR//LF) n = n + 1_pI64
  end do

  CRLF2LF = CRLF2LF(:c-n)

end function CRLF2LF

#if ((defined(__INTEL_COMPILER) && __INTEL_COMPILER_BUILD_DATE < 20240000) || !defined(__INTEL_COMPILER))
!--------------------------------------------------------------------------------------------------
!> @brief Fortran 2023 "tokenize" (first form, without optional argument).
!--------------------------------------------------------------------------------------------------
pure subroutine tokenize(string,set,tokens)

  character(len=*), intent(in) :: string, set
  character(len=:), dimension(:), allocatable, intent(out) :: tokens

  integer, allocatable, dimension(:,:) :: pos
  integer :: i, s, e


  allocate(pos(2,0))
  e = 0
  do while (e < verify(string,set,back=.true.))
    s = e + merge(verify(string(e+1:),set),1,scan(string(e+1:),set)/=0)
    e = s + merge(scan(string(s:),set)-2,len(string(s:))-1,scan(string(s:),set)/=0)
    pos = reshape([pos,[s,e]],[2,size(pos)/2+1])
  end do
  allocate(character(len=merge(maxval(pos(2,:)-pos(1,:))+1,0,size(pos)>0))::tokens(size(pos,2)))
  do i = 1, size(pos,2)
    tokens(i) = string(pos(1,i):pos(2,i))
  end do

end subroutine tokenize
#endif

!--------------------------------------------------------------------------------------------------
!> @brief Write statements to standard error.
!--------------------------------------------------------------------------------------------------
subroutine panel(paneltype,ID,msg, &
                 info_1,info_2,info_3,info_4,info_5,info_6,info_7,info_8,info_9, &
                 emph)

  character(len=*),           intent(in) :: paneltype, &                                            !< either 'error' or 'warning'
                                            msg                                                     !< general error/warning message
  integer,                    intent(in) :: ID                                                      !< error/warning ID
  class(*),         optional, intent(in) :: info_1,info_2,info_3,info_4,info_5,info_6,info_7,info_8,info_9 !< extra info
  integer, dimension(:), optional, intent(in) :: emph                                               !< which info(s) to emphasize

  integer, parameter :: panelwidth = 69
  character(len=*), parameter :: DIVIDER = repeat('─',panelwidth)
  character(len=pSTRLEN) :: formatString
  character(len=:), allocatable :: heading, msg_, info_extra
  character(len=:), dimension(:), allocatable :: info_split
  integer :: len_corrected, &                                                                       !< string length corrected for control characters
             i


  ! Needed to avoid output glitches observed with GFortran.
  ! see https://gcc.gnu.org/bugzilla/show_bug.cgi?id=113797
  !     https://fortran-lang.discourse.group/t/openmp-and-thread-safety-of-i-os-write-read/4567
  !$OMP CRITICAL (string_concatenation)
  heading = paneltype//' '//IO_intAsStr(ID)

  select case (paneltype)

    case ('error')
       msg_ = IO_color([255,0,0],  unit=IO_STDERR)//trim(msg)//IO_color(unit=IO_STDERR)
    case ('warning')
       msg_ = IO_color([255,192,0],unit=IO_STDERR)//trim(msg)//IO_color(unit=IO_STDERR)
    case default
       error stop 'invalid panel type: '//trim(paneltype)

  end select

  info_extra = as_str(info_1,is_emph(1,emph)) &
            // as_str(info_2,is_emph(2,emph)) &
            // as_str(info_3,is_emph(3,emph)) &
            // as_str(info_4,is_emph(4,emph)) &
            // as_str(info_5,is_emph(5,emph)) &
            // as_str(info_6,is_emph(6,emph)) &
            // as_str(info_7,is_emph(7,emph)) &
            // as_str(info_8,is_emph(8,emph)) &
            // as_str(info_9,is_emph(9,emph))
  !$OMP END CRITICAL (string_concatenation)

  !$OMP CRITICAL (output_to_screen)
  write(IO_STDERR,'(/,a)')                ' ┌'       //DIVIDER//        '┐'
  write(formatString,'(a,i2,a)') '(a,24x,a,',max(1,panelwidth-24-len_trim(heading)),'x,a)'
  write(IO_STDERR,formatString)           ' │',    trim(heading),       '│'
  write(IO_STDERR,'(a)')                  ' ├'       //DIVIDER//        '┤'
  write(formatString,'(a,i3.3,a,i3.3,a)') '(a,a',max(1,len_trim(msg_)),',',&
                                                 max(1,panelwidth+3-len_trim(msg)-4),'x,a)'
  write(IO_STDERR,formatString)           ' │ ',     trim(msg_),        '│'
  if (len_trim(info_extra) > 0) then
    call tokenize(info_extra,IO_EOL,info_split)
    do i = 1, size(info_split)
      info_extra = adjustl(info_split(i))
      if (len_trim(info_extra) == 0) then
        write(IO_STDERR,'(a)')            ' │'//repeat(' ',panelwidth)//'│'
      else
        len_corrected = len_trim(info_extra) - count([(info_extra(i:i)==IO_ESC,i=1,len_trim(info_extra))])*4
        write(formatString,'(a,i3.3,a,i3.3,a)') '(a,a',max(1,len_trim(info_extra)),',',&
                                                       max(1,panelwidth+3-len_corrected-4),'x,a)'
        write(IO_STDERR,formatString)     ' │ ',    trim(info_extra),   '│'
      end if
    end do
  endif
  write(IO_STDERR,'(a)')                  ' └'       //DIVIDER//        '┘'
  flush(IO_STDERR)
  !$OMP END CRITICAL (output_to_screen)

end subroutine panel


!-----------------------------------------------------------------------------------------------
!> @brief Convert to string with white space prefix and optional emphasis.
!-----------------------------------------------------------------------------------------------
function as_str(info,emph)

  character(len=:), allocatable :: as_str
  class(*), optional, intent(in) :: info                                                           !< info message
  logical, intent(in) :: emph                                                                      !< whether info should be emphasized


  if (present(info)) then
    select type(info)
      type is (character(*))
        as_str = info
      type is (integer)
        as_str = IO_intAsStr(info)
      type is (real(pREAL))
        as_str = IO_realAsStr(info)
      class default
        error stop 'cannot convert info argument to string'
    end select

    if (emph) then
      if (IO_colored .and. IO_isaTTY(IO_STDERR)) then
        as_str = IO_EMPH//as_str//IO_FORMATRESET
      else
        as_str = IO_QUOTES(2:2)//as_str//IO_QUOTES(2:2)
      end if
    end if
    as_str = ' '//as_str
  else
    as_str = ''
  end if

end function as_str

!-----------------------------------------------------------------------------------------------
!> @brief Determine whether info at given position has to be emphasized.
!-----------------------------------------------------------------------------------------------
pure logical function is_emph(idx,emph)

  integer, intent(in) :: idx                                                                        !< index of considered info
  integer, dimension(:), optional, intent(in) :: emph                                               !< which info(s) to emphasize


  if (present(emph)) then
    is_emph = any(emph == idx)
  else
    is_emph = .false.
  end if

end function is_emph


end module IO

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @author Pratheek Shanthraj, Max-Planck-Institut für Eisenforschung GmbH
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @brief material subroutine for thermal source due to plastic dissipation
!> @details to be done
!--------------------------------------------------------------------------------------------------
submodule(phase:thermal) source_dissipation

  type :: tParameters                                                                               !< container type for internal constitutive parameters
    real(pREAL) :: &
      kappa                                                                                         !< TAYLOR-QUINNEY factor
  end type tParameters

  type(tParameters), dimension(:),   allocatable :: param                                           !< containers of constitutive parameters (len Ninstances)


contains


!--------------------------------------------------------------------------------------------------
!> @brief module initialization
!> @details reads in material parameters, allocates arrays, and does sanity checks
!--------------------------------------------------------------------------------------------------
module function source_dissipation_init(maxNsources) result(isMySource)

  integer, intent(in)                  :: maxNsources
  logical, dimension(:,:), allocatable :: isMySource

  type(tDict), pointer :: &
    phases, &
    phase, &
    thermal, &
    src
  class(tList), pointer :: &
    sources
  character(len=:), allocatable :: refs
  integer :: ph,Nmembers,so,Nsources


  isMySource = thermal_active('dissipation',maxNsources)
  if (count(isMySource) == 0) return

  print'(/,1x,a)', '<<<+-  phase:thermal:source_dissipation init  -+>>>'
  print'(/,1x,a,1x,i0)', '# phases:',count(isMySource); flush(IO_STDOUT)


  phases => config_material%get_dict('phase')
  allocate(param(size(phases)))

  do ph = 1, size(phases)
    Nsources = count(isMySource(:,ph))
    if (Nsources == 0) cycle
    if (Nsources > 1) call IO_error(600,ext_msg='dissipation')
    Nmembers = count(material_ID_phase == ph)
    phase => phases%get_dict(ph)
    thermal => phase%get_dict('thermal')
    sources => thermal%get_list('source')
    do so = 1, size(sources)
      if (isMySource(so,ph)) then
        associate(prm  => param(ph))
          src => sources%get_dict(so)
          print'(/,1x,a,1x,i0,1x,a,1x,a,1x,i0)', 'phase',ph,'('//phases%key(ph)//')','source',so
          refs = config_listReferences(src,indent=3)
          if (len(refs) > 0) print'(/,1x,a)', refs

          prm%kappa = src%get_asReal('kappa')
          call phase_allocateState(thermalState(ph)%p(so),Nmembers,0,0,0)
        end associate
        exit
      end if
    end do
  end do


end function source_dissipation_init


!--------------------------------------------------------------------------------------------------
!> @brief Ninstancess dissipation rate
!--------------------------------------------------------------------------------------------------
module function source_dissipation_f_T(ph,en) result(f_T)

  integer, intent(in) :: ph, en
  real(pREAL) :: &
    f_T
  real(pREAL), dimension(3,3) :: &
    Mp                                                                                              !< Mandel stress work conjugate with Lp

  Mp = matmul(matmul(transpose(mechanical_F_i(ph,en)),mechanical_F_i(ph,en)),mechanical_S(ph,en))

  associate(prm => param(ph))
    f_T = prm%kappa*sum(abs(Mp*mechanical_L_p(ph,en)))
  end associate

end function source_dissipation_f_T

end submodule source_dissipation

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Parse geometry file to set up discretization and geometry for nonlocal model
!--------------------------------------------------------------------------------------------------
#include <petsc/finclude/petscsys.h>
#if defined(PETSC_EXPOSES_MPIF90)
#define MPI_COMM_WORLD_F90 MPI_COMM_WORLD
#else
#define MPI_COMM_WORLD_F90 MPI_COMM_WORLD%MPI_val
#endif
module discretization_grid
  use PETScSys
#ifndef PETSC_EXPOSES_MPI
  use MPI_f08
#endif
  use HDF5

  use FFTW3
  use prec
  use parallelization
#if !defined(BOOST)
  use VTI
#endif
  use CLI
  use IO
  use C_interfacing
  use config
  use HDF5_utilities
  use result
  use discretization
  use geometry_plastic_nonlocal


#ifndef PETSC_EXPOSES_MPIF90
  implicit none(type,external)
#else
  implicit none
#endif
  private

  integer,     dimension(3), public, protected :: &
    cells                                                                                           !< (global) cells
  integer,                   public, protected :: &
    cells3, &                                                                                       !< (local) cells in 3rd direction
    cells3Offset                                                                                    !< (local) cells offset in 3rd direction
  real(pREAL), dimension(3), public, protected :: &
    geomSize                                                                                        !< (global) physical size
  real(pREAL),               public, protected :: &
    size3, &                                                                                        !< (local) size in 3rd direction
    size3offset                                                                                     !< (local) size offset in 3rd direction

  public :: &
    discretization_grid_init, &
    discretization_grid_getScalarInitialCondition, &
    discretization_grid_getVectorInitialCondition, &
    discretization_grid_finalize

#if defined(BOOST)
  type(C_PTR) :: VTI_ = C_NULL_PTR

interface
  function C_VTI_new(vtiPath) result(this) bind(C, name='C_VTI_new')
    use, intrinsic :: ISO_C_binding, only: C_PTR, C_CHAR
    character(kind=C_CHAR), dimension(*), intent(in) :: vtiPath
    type(C_PTR) :: this
  end function C_VTI_new

  subroutine C_VTI_readDatasetInt(this, label, data) bind(C, name='C_VTI_readDatasetInt')
    use, intrinsic :: ISO_C_binding, only: C_PTR, C_CHAR, C_INT
    type(C_PTR), value :: this
    character(kind=C_CHAR), dimension(*), intent(in) :: label
    integer(C_INT), allocatable, intent(out) :: data(:)
  end subroutine C_VTI_readDatasetInt

  subroutine C_VTI_readDatasetReal(this, label, data) bind(C, name='C_VTI_readDatasetReal')
    use, intrinsic :: ISO_C_binding, only: C_PTR, C_CHAR, C_INT, C_DOUBLE
    type(C_PTR), value :: this
    character(kind=C_CHAR), dimension(*), intent(in) :: label
    real(C_DOUBLE), allocatable, intent(out) :: data(:)
  end subroutine C_VTI_readDatasetReal

  subroutine C_VTI_readGeometry(this, cells, geomSize, origin, labels) &
       bind(C, name='C_VTI_readGeometry')
    use, intrinsic :: ISO_C_binding, only: C_PTR, C_CHAR, C_INT, C_DOUBLE
    type(C_PTR), value :: this
    integer(C_INT), intent(out) :: cells(3)
    real(C_DOUBLE), intent(out) :: geomSize(3), origin(3)
    character(kind=C_CHAR,len=:), allocatable :: labels(:)
  end subroutine C_VTI_readGeometry

  subroutine C_VTI_delete(this) bind(C, name='C_VTI_delete')
    use, intrinsic :: ISO_C_binding, only: C_PTR
    type(C_PTR), value :: this
  end subroutine C_VTI_delete

end interface
#endif

contains

!--------------------------------------------------------------------------------------------------
!> @brief Read the geometry file to obtain information on discretization.
!--------------------------------------------------------------------------------------------------
subroutine discretization_grid_init()

  real(pREAL), dimension(3) :: &
    mySize, &                                                                                       !< domain size of this process
    origin                                                                                          !< (global) distance to origin
  integer,     dimension(3) :: &
    myGrid                                                                                          !< domain cells of this process

  integer,     dimension(:),   allocatable :: &
    materialAt, materialAt_global

  integer :: &
    i, &
    n_labels                                                                                         !< number cell datasets in VTI file
  integer(MPI_INTEGER_KIND) :: err_MPI
  integer(C_INTPTR_T) :: &
    devNull, cells3_, cells3Offset_
  integer, dimension(worldsize) :: &
    displs, sendcounts
  character(len=:), allocatable :: &
    fileContent, fname
#if defined(BOOST)
  character(kind=C_CHAR, len=:), allocatable :: &
#else
  character(len=pSTRLEN), dimension(:), allocatable :: &
#endif
    labels(:)     ! ToDo double dimension/len                                                        !< cell data labels in VTI file
  integer(HID_T) :: handle


  print'(/,1x,a)', '<<<+-  discretization_grid init  -+>>>'; flush(IO_STDOUT)


  if (worldrank == 0) then
#if defined(BOOST)
    print'(/,1x,a)', 'Using C++ XML parser'
    VTI_ = C_VTI_new(f_c_string(CLI_geomFile))
    fileContent = IO_read(CLI_geomFile)                                                            ! still needed for job file
    call C_VTI_readGeometry(VTI_,cells,geomSize,origin,labels)
#else
    print'(/,1x,a)', 'Using Fortran XML parser'
    fileContent = IO_read(CLI_geomFile)
    call VTI_readGeometry(cells,geomSize,origin,labels,fileContent)
#endif
    n_labels = size(labels)
#if defined(BOOST)
    call C_VTI_readDatasetInt(VTI_,f_c_string('material'),materialAt_global)
#else
    materialAt_global = VTI_readDataset_int(fileContent,'material') + 1
#endif
    if (any(materialAt_global < 1)) &
      call IO_error(180_pI16,'material ID < 1')
    if (size(materialAt_global) /= product(cells)) &
      call IO_error(180_pI16,'mismatch in # of material IDs and cells')
    fname = CLI_geomFile
    if (scan(fname,'/') /= 0) fname = fname(scan(fname,'/',.true.)+1:)
    call result_openJobFile(parallel=.false.)
    call result_addSetupFile(fileContent,fname,'geometry definition (grid solver)')
    call result_closeJobFile()
  else
    allocate(materialAt_global(0))                                                                  ! needed for IntelMPI
  end if

  call MPI_Bcast(cells,3_MPI_INTEGER_KIND,MPI_INTEGER,0_MPI_INTEGER_KIND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  if (cells(1) < 2) call IO_error(844_pI16,'cells(1) must be larger than 1')
  call MPI_Bcast(geomSize,3_MPI_INTEGER_KIND,MPI_DOUBLE,0_MPI_INTEGER_KIND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  call MPI_Bcast(origin,3_MPI_INTEGER_KIND,MPI_DOUBLE,0_MPI_INTEGER_KIND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  call MPI_Bcast(n_labels,1_MPI_INTEGER_KIND,MPI_INTEGER,0_MPI_INTEGER_KIND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)

  if (worldrank /= 0) allocate(character(len=pSTRLEN) :: labels(n_labels))
  call MPI_Bcast(labels,int(pSTRLEN*n_labels,MPI_INTEGER_KIND),MPI_CHARACTER, &
                 0_MPI_INTEGER_KIND,MPI_COMM_WORLD, err_MPI)
  call parallelization_chkerr(err_MPI)

  print'(/,1x,3(a,i0))',      'cells:   ', cells(1),    ' × ', cells(2),    ' × ', cells(3)
  print'(  1x,3(a,es9.2),a)', 'size:   ',  geomSize(1), ' × ', geomSize(2), ' × ', geomSize(3), ' m³'
  print'(  1x,3(a,es9.2),a)', 'origin: ',  origin(1),   '   ', origin(2),   '   ', origin(3),   ' m'
  print'(/,1x,a)', 'cell data:'
  do i = 1, n_labels
    print '(2x,a,a)', '- ', trim(labels(i))
  end do

  if (worldsize>cells(3)) call IO_error(894_pI16,'number of processes exceeds cells(3)')

  call fftw_mpi_init()
  devNull = fftw_mpi_local_size_3d(int(cells(3),C_INTPTR_T),int(cells(2),C_INTPTR_T),int(cells(1)/2+1,C_INTPTR_T), &
                                   MPI_COMM_WORLD_F90, &
                                   cells3_, &                                                       ! domain cells size along z
                                   cells3Offset_)                                                   ! domain cells offset along z
  if (cells3_==0_C_INTPTR_T) call IO_error(894_pI16,'Cannot distribute MPI processes')

  cells3       = int(cells3_)
  cells3Offset = int(cells3Offset_)
  size3       = geomSize(3)*real(cells3,pREAL)      /real(cells(3),pREAL)
  size3Offset = geomSize(3)*real(cells3Offset,pREAL)/real(cells(3),pREAL)
  myGrid = [cells(1:2),cells3]
  mySize = [geomSize(1:2),size3]

  call MPI_Gather(product(cells(1:2))*cells3Offset,1_MPI_INTEGER_KIND,MPI_INTEGER,displs,&
                  1_MPI_INTEGER_KIND,MPI_INTEGER,0_MPI_INTEGER_KIND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  call MPI_Gather(product(myGrid),               1_MPI_INTEGER_KIND,MPI_INTEGER,sendcounts,&
                  1_MPI_INTEGER_KIND,MPI_INTEGER,0_MPI_INTEGER_KIND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)

  allocate(materialAt(product(myGrid)))
  call MPI_Scatterv(materialAt_global,sendcounts,displs,MPI_INTEGER,materialAt,size(materialAt),&
                    MPI_INTEGER,0_MPI_INTEGER_KIND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)

  call discretization_init(materialAt, &
                           IPcoordinates0(myGrid,mySize,cells3Offset), &
                           Nodes0(myGrid,mySize,cells3Offset),&
                           merge((cells(1)+1) * (cells(2)+1) * (cells3+1),&                         ! write top layer...
                                 (cells(1)+1) * (cells(2)+1) *  cells3,&                            ! ...unless not last process
                                 worldrank+1==worldsize))

!--------------------------------------------------------------------------------------------------
! store geometry information for post processing
  if (worldrank == 0) then
    call result_openJobFile(parallel=.false.)
    if (.not. result_objectExists('geometry')) then
      handle = result_addGroup('geometry')
      call HDF5_write(cells,   handle,'cells', .false.)
      call HDF5_write(geomSize,handle,'size',  .false.)
      call HDF5_write(origin,  handle,'origin',.false.)
      call HDF5_addAttribute(handle,'unit','1','cells')
      call HDF5_addAttribute(handle,'unit','m³','size')
      call HDF5_addAttribute(handle,'unit','m','origin')
      call result_addAttribute('cells', cells,   '/geometry') ! legacy for DADF5 1.x
      call result_addAttribute('size',  geomSize,'/geometry') ! legacy for DADF5 1.x
      call result_addAttribute('origin',origin,  '/geometry') ! legacy for DADF5 1.x
      call result_closeGroup(handle)
    end if
    call result_closeJobFile()
  end if

!--------------------------------------------------------------------------------------------------
! geometry information required by the nonlocal CP model
  call geometry_plastic_nonlocal_setIPvolume(reshape([(product(mySize/real(myGrid,pREAL)),i=1,product(myGrid))], &
                                                     [1,product(myGrid)]))
  call geometry_plastic_nonlocal_setIParea        (cellSurfaceArea(mySize,myGrid))
  call geometry_plastic_nonlocal_setIPareaNormal  (cellSurfaceNormal(product(myGrid)))
  call geometry_plastic_nonlocal_setIPneighborhood(IPneighborhood(myGrid))

end subroutine discretization_grid_init


!--------------------------------------------------------------------------------------------------
!> @brief Deallocate parsed VTI object.
!--------------------------------------------------------------------------------------------------
subroutine discretization_grid_finalize()
#if defined(BOOST)
  if (worldrank == 0) call C_VTI_delete(VTI_)
#endif
end subroutine discretization_grid_finalize


!---------------------------------------------------------------------------------------------------
!> @brief Calculate undeformed position of IPs/cell centers (pretend to be an element).
!---------------------------------------------------------------------------------------------------
function IPcoordinates0(cells,geomSize,cells3Offset)

  integer,     dimension(3), intent(in) :: cells                                                    ! cells (for this process!)
  real(pREAL), dimension(3), intent(in) :: geomSize                                                 ! size (for this process!)
  integer,                   intent(in) :: cells3Offset                                             ! cells(3) offset

  real(pREAL), dimension(3,product(cells))  :: ipCoordinates0

  integer :: &
    a,b,c, &
    i


  i = 0
  do c = 1, cells(3); do b = 1, cells(2); do a = 1, cells(1)
    i = i + 1
    IPcoordinates0(1:3,i) = geomSize/real(cells,pREAL) * (real([a,b,cells3Offset+c],pREAL) -0.5_pREAL)
  end do; end do; end do

end function IPcoordinates0


!---------------------------------------------------------------------------------------------------
!> @brief Calculate position of undeformed nodes (pretend to be an element).
!---------------------------------------------------------------------------------------------------
pure function nodes0(cells,geomSize,cells3Offset)

  integer,     dimension(3), intent(in) :: cells                                                    ! cells (for this process!)
  real(pREAL), dimension(3), intent(in) :: geomSize                                                 ! size (for this process!)
  integer,                   intent(in) :: cells3Offset                                             ! cells(3) offset

  real(pREAL), dimension(3,product(cells+1)) :: nodes0

  integer :: &
    a,b,c, &
    n

  n = 0
  do c = 0, cells3; do b = 0, cells(2); do a = 0, cells(1)
    n = n + 1
    nodes0(1:3,n) = geomSize/real(cells,pREAL) * real([a,b,cells3Offset+c],pREAL)
  end do; end do; end do

end function nodes0


!--------------------------------------------------------------------------------------------------
!> @brief Calculate IP interface areas.
!--------------------------------------------------------------------------------------------------
pure function cellSurfaceArea(geomSize,cells)

  real(pREAL), dimension(3), intent(in) :: geomSize                                                 ! size (for this process!)
  integer,     dimension(3), intent(in) :: cells                                                    ! cells (for this process!)

  real(pREAL), dimension(6,1,product(cells)) :: cellSurfaceArea


  cellSurfaceArea(1:2,1,:) = geomSize(2)/real(cells(2),pREAL) * geomSize(3)/real(cells(3),pREAL)
  cellSurfaceArea(3:4,1,:) = geomSize(3)/real(cells(3),pREAL) * geomSize(1)/real(cells(1),pREAL)
  cellSurfaceArea(5:6,1,:) = geomSize(1)/real(cells(1),pREAL) * geomSize(2)/real(cells(2),pREAL)

end function cellSurfaceArea


!--------------------------------------------------------------------------------------------------
!> @brief Calculate IP interface areas normals.
!--------------------------------------------------------------------------------------------------
pure function cellSurfaceNormal(nElems)

  integer, intent(in) :: nElems

  real(pREAL), dimension(3,6,1,nElems) :: cellSurfaceNormal

  cellSurfaceNormal(1:3,1,1,:) = spread([+1.0_pREAL, 0.0_pREAL, 0.0_pREAL],2,nElems)
  cellSurfaceNormal(1:3,2,1,:) = spread([-1.0_pREAL, 0.0_pREAL, 0.0_pREAL],2,nElems)
  cellSurfaceNormal(1:3,3,1,:) = spread([ 0.0_pREAL,+1.0_pREAL, 0.0_pREAL],2,nElems)
  cellSurfaceNormal(1:3,4,1,:) = spread([ 0.0_pREAL,-1.0_pREAL, 0.0_pREAL],2,nElems)
  cellSurfaceNormal(1:3,5,1,:) = spread([ 0.0_pREAL, 0.0_pREAL,+1.0_pREAL],2,nElems)
  cellSurfaceNormal(1:3,6,1,:) = spread([ 0.0_pREAL, 0.0_pREAL,-1.0_pREAL],2,nElems)

end function cellSurfaceNormal


!--------------------------------------------------------------------------------------------------
!> @brief Build IP neighborhood relations.
!--------------------------------------------------------------------------------------------------
pure function IPneighborhood(cells)

  integer, dimension(3), intent(in) :: cells                                                        ! cells (for this process!)

  integer, dimension(3,6,1,product(cells)) :: IPneighborhood                                        !< 6 neighboring IPs as [element ID, IP ID, face ID]

  integer :: &
   x,y,z, &
   e

  e = 0
  do z = 0,cells(3)-1; do y = 0,cells(2)-1; do x = 0,cells(1)-1
    e = e + 1
    ! element ID
    IPneighborhood(1,1,1,e) = z * cells(1) * cells(2) &
                            + y * cells(1) &
                            + modulo(x+1,cells(1)) &
                            + 1
    IPneighborhood(1,2,1,e) = z * cells(1) * cells(2) &
                            + y * cells(1) &
                            + modulo(x-1,cells(1)) &
                            + 1
    IPneighborhood(1,3,1,e) = z * cells(1) * cells(2) &
                            + modulo(y+1,cells(2)) * cells(1) &
                            + x &
                            + 1
    IPneighborhood(1,4,1,e) = z * cells(1) * cells(2) &
                            + modulo(y-1,cells(2)) * cells(1) &
                            + x &
                            + 1
    IPneighborhood(1,5,1,e) = modulo(z+1,cells(3)) * cells(1) * cells(2) &
                            + y * cells(1) &
                            + x &
                            + 1
    IPneighborhood(1,6,1,e) = modulo(z-1,cells(3)) * cells(1) * cells(2) &
                            + y * cells(1) &
                            + x &
                            + 1
    ! IP ID
    IPneighborhood(2,:,1,e) = 1

    ! face ID
    IPneighborhood(3,1,1,e) = 2
    IPneighborhood(3,2,1,e) = 1
    IPneighborhood(3,3,1,e) = 4
    IPneighborhood(3,4,1,e) = 3
    IPneighborhood(3,5,1,e) = 6
    IPneighborhood(3,6,1,e) = 5

  end do; end do; end do

end function IPneighborhood


!--------------------------------------------------------------------------------------------------
!> @brief Read scalar initial condition from VTI file.
!--------------------------------------------------------------------------------------------------
function discretization_grid_getScalarInitialCondition(label) result(ic)

  character(len=*), intent(in) :: label                                                              !< dataset label
  real(pREAL), dimension(cells(1),cells(2),cells3) :: ic                                             !< scalar field of initial conditions


  ic = reshape(get_initial_condition(label),[cells(1),cells(2),cells3])

end function discretization_grid_getScalarInitialCondition


!--------------------------------------------------------------------------------------------------
!> @brief Read vector initial condition from VTI file.
!--------------------------------------------------------------------------------------------------
function discretization_grid_getVectorInitialCondition(label) result(ic)

  character(len=*), intent(in) :: label                                                              !< dataset label
  real(pREAL), dimension(:,:,:,:), allocatable :: ic                                                 !< vector field of initial conditions

  real(pREAL), dimension(:), allocatable :: ic_flat
  integer :: width


  ic_flat = get_initial_condition(label)
  width = size(ic_flat) / (product(cells(1:2))*cells3)
  ic = reshape(ic_flat,[width,cells(1),cells(2),cells3])

end function discretization_grid_getVectorInitialCondition


!--------------------------------------------------------------------------------------------------
!> @brief Read initial condition from VTI file.
!--------------------------------------------------------------------------------------------------
function get_initial_condition(label) result(ic_local)

  character(len=*), intent(in) :: label                                                              !< dataset label
  real(pREAL), dimension(:), allocatable :: ic_local                                                 !< flattened initial conditions

  real(pREAL), dimension(:), allocatable :: ic_global
  integer(MPI_INTEGER_KIND) :: err_MPI
  integer, dimension(worldsize) :: &
    displs, sendcounts
  integer :: width


  if (worldrank == 0) then
#if defined(BOOST)
    call C_VTI_readDatasetReal(VTI_,f_c_string(label),ic_global)
#else
    ic_global = VTI_readDataset_real(IO_read(CLI_geomFile),label)
#endif
    width = size(ic_global) / product(cells)
  else
    allocate(ic_global(0))                                                                          ! needed for IntelMPI
  end if

  call MPI_Bcast(width,1_MPI_INTEGER_KIND,MPI_INTEGER,&
                 0_MPI_INTEGER_KIND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  call MPI_Gather(product(cells(1:2))*width*cells3Offset,1_MPI_INTEGER_KIND,MPI_INTEGER,&
                  displs,1_MPI_INTEGER_KIND,MPI_INTEGER,&
                  0_MPI_INTEGER_KIND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  call MPI_Gather(product(cells(1:2))*width*cells3,1_MPI_INTEGER_KIND,MPI_INTEGER,&
                  sendcounts,1_MPI_INTEGER_KIND,MPI_INTEGER,&
                  0_MPI_INTEGER_KIND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)

  allocate(ic_local(product(cells(1:2))*cells3*width))
  call MPI_Scatterv(ic_global,sendcounts,displs,MPI_DOUBLE,&
                    ic_local,size(ic_local),MPI_DOUBLE,&
                    0_MPI_INTEGER_KIND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)

end function get_initial_condition


end module discretization_grid

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
submodule(phase:mechanical) eigen

  integer, dimension(:), allocatable :: &
    Nmodels

  integer(kind(UNDEFINED)),  dimension(:,:), allocatable :: &
    mechanical_eigen_kinematics_type

  interface

    module function thermalexpansion_init(kinematics_length) result(myKinematics)
      integer, intent(in) :: kinematics_length
      logical, dimension(:,:), allocatable :: myKinematics
    end function thermalexpansion_init

    module subroutine thermalexpansion_LiAndItsTangent(Li, dLi_dTstar, ph,me)
      integer, intent(in) :: ph, me
      real(pREAL),   intent(out), dimension(3,3) :: &
        Li                                                                                          !< thermal velocity gradient
      real(pREAL),   intent(out), dimension(3,3,3,3) :: &
        dLi_dTstar                                                                                  !< derivative of Li with respect to Tstar (4th-order tensor defined to be zero)
    end subroutine thermalexpansion_LiAndItsTangent

  end interface


contains


module subroutine eigen_init(phases)

  type(tDict), pointer :: &
    phases

  integer :: &
    ph
  type(tDict), pointer :: &
    phase, &
    mechanics
  type(tList), pointer :: &
    kinematics


  print'(/,1x,a)', '<<<+-  phase:mechanical:eigen init  -+>>>'


!--------------------------------------------------------------------------------------------------
! explicit eigen mechanisms
  allocate(Nmodels(size(phases)),source = 0)

  do ph = 1,size(phases)
    phase => phases%get_dict(ph)
    mechanics => phase%get_dict('mechanical')
    kinematics => mechanics%get_list('eigen',defaultVal=emptyList)
    Nmodels(ph) = size(kinematics)
  end do

  allocate(mechanical_eigen_kinematics_type(maxval(Nmodels),size(phases)), source = UNDEFINED)

  if (maxval(Nmodels) /= 0) then
    where(thermalexpansion_init(maxval(Nmodels))) mechanical_eigen_kinematics_type = MECHANICAL_EIGEN_THERMALEXPANSION
  end if

end subroutine eigen_init


!--------------------------------------------------------------------------------------------------
!> @brief Check if an eigen kinematic mechanism is active.
!--------------------------------------------------------------------------------------------------
function kinematics_active(kinematics_label,kinematics_length)  result(active_kinematics)

  character(len=*), intent(in)         :: kinematics_label                                          !< name of kinematic mechanism
  integer,          intent(in)         :: kinematics_length                                         !< max. number of kinematics in system
  logical, dimension(:,:), allocatable :: active_kinematics

  type(tDict), pointer :: &
    phases, &
    phase, &
    mechanics, &
    kinematic
  type(tList), pointer :: &
    kinematics
  integer :: ph,k


  phases => config_material%get_dict('phase')
  allocate(active_kinematics(kinematics_length,size(phases)), source = .false. )
  do ph = 1, size(phases)
    phase => phases%get_dict(ph)
    mechanics => phase%get_dict('mechanical')
    kinematics => mechanics%get_list('eigen',defaultVal=emptyList)
    do k = 1, size(kinematics)
      kinematic => kinematics%get_dict(k)
      active_kinematics(k,ph) = kinematic%get_asStr('type') == kinematics_label
    end do
  end do

end function kinematics_active


!--------------------------------------------------------------------------------------------------
!> @brief  contains the constitutive equation for calculating the velocity gradient
! ToDo: MD: S is Mi?
!--------------------------------------------------------------------------------------------------
module subroutine phase_LiAndItsTangents(Li, dLi_dS, dLi_dFi, &
                                         S, Fi, ph,en)

  integer, intent(in) :: &
    ph,en
  real(pREAL),   intent(in),  dimension(3,3) :: &
    S                                                                                               !< 2nd Piola-Kirchhoff stress
  real(pREAL),   intent(in),  dimension(3,3) :: &
    Fi                                                                                              !< intermediate deformation gradient
  real(pREAL),   intent(out), dimension(3,3) :: &
    Li                                                                                              !< intermediate velocity gradient
  real(pREAL),   intent(out), dimension(3,3,3,3) :: &
    dLi_dS, &                                                                                       !< derivative of Li with respect to S
    dLi_dFi

  real(pREAL), dimension(3,3) :: &
    my_Li, &                                                                                        !< intermediate velocity gradient
    FiInv, &
    temp_33
  real(pREAL), dimension(3,3,3,3) :: &
    my_dLi_dS
  real(pREAL) :: &
    detFi
  integer :: &
    k, i, j
  logical :: active

  active = .false.
  Li = 0.0_pREAL
  dLi_dS  = 0.0_pREAL
  dLi_dFi = 0.0_pREAL


  KinematicsLoop: do k = 1, Nmodels(ph)
    kinematicsType: select case (mechanical_eigen_kinematics_type(k,ph))
      case (MECHANICAL_EIGEN_THERMALEXPANSION) kinematicsType
        call thermalexpansion_LiAndItsTangent(my_Li, my_dLi_dS, ph,en)
        Li = Li + my_Li
        dLi_dS = dLi_dS + my_dLi_dS
        active = .true.
    end select kinematicsType
  end do KinematicsLoop

  plasticType: select case (mechanical_plasticity_type(ph))
    case (MECHANICAL_PLASTICITY_ISOTROPIC) plasticType
      call plastic_isotropic_LiAndItsTangent(my_Li, my_dLi_dS, S ,ph,en)
      Li = Li + my_Li
      dLi_dS = dLi_dS + my_dLi_dS
      active = .true.
  end select plasticType

  damageType: select case (damage_type(ph))
    case (DAMAGE_ANISOBRITTLE)
      call damage_anisobrittle_LiAndItsTangent(my_Li, my_dLi_dS, S, ph, en)
      Li = Li + my_Li
      dLi_dS = dLi_dS + my_dLi_dS
      active = .true.
  end select damageType

  if (.not. active) return

  FiInv = math_inv33(Fi)
  detFi = math_det33(Fi)
  Li = matmul(matmul(Fi,Li),FiInv)*detFi                                                            !< push forward to intermediate configuration
  temp_33 = matmul(FiInv,Li)

  do i = 1,3; do j = 1,3
    dLi_dS(1:3,1:3,i,j)  = matmul(matmul(Fi,dLi_dS(1:3,1:3,i,j)),FiInv)*detFi
    dLi_dFi(1:3,1:3,i,j) = dLi_dFi(1:3,1:3,i,j) + Li*FiInv(j,i)
    dLi_dFi(1:3,i,1:3,j) = dLi_dFi(1:3,i,1:3,j) + math_I3*temp_33(j,i) + Li*FiInv(j,i)
  end do; end do

end subroutine phase_LiAndItsTangents


end submodule eigen

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!----------------------------------------------------------------------------------------------------
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @author Sharan Roongta, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Parser for YAML files.
!> @details Module converts a YAML input file to an equivalent YAML flow style which is then parsed.
!----------------------------------------------------------------------------------------------------
module YAML
  use prec
  use misc
  use IO
  use types
#ifdef FYAML
  use C_interfacing
#endif

  implicit none(type,external)
  private

  public :: &
    YAML_init, &
    YAML_str_asList, &
    YAML_str_asDict

#ifdef FYAML
  interface
    subroutine to_flow_C(flow,mixed,stat) bind(C)
      use, intrinsic :: ISO_C_binding, only: C_INT, C_CHAR
      implicit none(type,external)

      character(kind=C_CHAR,len=:), allocatable, intent(out) :: flow
      integer(C_INT), intent(out) :: stat
      character(kind=C_CHAR), dimension(*), intent(in) :: mixed
    end subroutine to_flow_C
  end interface
#endif


contains

!--------------------------------------------------------------------------------------------------
!> @brief Do sanity checks.
!--------------------------------------------------------------------------------------------------
subroutine YAML_init()

  print'(/,1x,a)', '<<<+-  YAML init  -+>>>'
#ifdef FYAML
  print'(/,1x,a)', 'libfyaml powered'
#else
  call YAML_selfTest()
#endif

end subroutine YAML_init


!--------------------------------------------------------------------------------------------------
!> @brief Parse a YAML string with list at root into a structure of nodes.
!> @details The string needs to end with a newline (unless using libfyaml).
!--------------------------------------------------------------------------------------------------
function YAML_str_asList(str) result(list)

  character(len=*), intent(in) :: str
  type(tList), pointer :: list

  class(tNode), pointer :: node


  node => parse_flow(to_flow(str))
  list => node%asList()

end function YAML_str_asList


!--------------------------------------------------------------------------------------------------
!> @brief Parse a YAML string with dict at root into a structure of nodes.
!> @details The string needs to end with a newline (unless using libfyaml).
!--------------------------------------------------------------------------------------------------
function YAML_str_asDict(str) result(dict)

  character(len=*), intent(in) :: str
  type(tDict), pointer :: dict

  class(tNode), pointer :: node


  node => parse_flow(to_flow(str))
  dict => node%asDict()

end function YAML_str_asDict


!--------------------------------------------------------------------------------------------------
!> @brief Read a string in flow style and store it in the form of dictionaries, lists, and scalars.
!> @details A node-type pointer can either point to a dictionary, list, or scalar type entities.
!--------------------------------------------------------------------------------------------------
recursive function parse_flow(YAML_flow) result(node)

  character(len=*), intent(in) :: YAML_flow                                                         !< YAML file in flow style
  class(tNode), pointer        :: node

  class(tNode), pointer :: &
    myVal
  character(len=:), allocatable :: &
    flow_string, &
    key
  integer(pI64) :: &
    e, &                                                                                            ! end position of dictionary or list
    s, &                                                                                            ! start position of dictionary or list
    d                                                                                               ! position of key: value separator (':')


  flow_string = trim(adjustl(YAML_flow))
  if (len_trim(flow_string,pI64) == 0_pI64) then
    node => emptyDict
    return
  elseif (flow_string(1:1) == '{') then                                                             ! start of a dictionary
    allocate(tDict::node)
    select type (dict => node)
      class is (tDict)
        e = 1_pI64
        do while (e < len_trim(flow_string,pI64))
          s = e
          d = s + scan(flow_string(s+1_pI64:),':',kind=pI64)
          e = d + find_end(flow_string(d+1_pI64:),'}')
          key = trim(adjustl(flow_string(s+1_pI64:d-1_pI64)))
          if (quotedStr(key)) key = key(2_pI64:len(key,kind=pI64)-1_pI64)
          myVal => parse_flow(flow_string(d+1_pI64:e-1_pI64))                                       ! parse items (recursively)
          call dict%set(key,myVal)
        end do
    end select
  elseif (flow_string(1:1) == '[') then                                                             ! start of a list
    allocate(tList::node)
    select type (list => node)
      class is (tList)
        e = 1_pI64
        do while (e < len_trim(flow_string,pI64))
          s = e
          e = s + find_end(flow_string(s+1_pI64:),']')
          myVal => parse_flow(flow_string(s+1_pI64:e-1_pI64))                                       ! parse items (recursively)
          call list%append(myVal)
        end do
    end select
  else                                                                                              ! scalar value
    allocate(tScalar::node)
    select type (scalar => node)
      class is (tScalar)
        if (quotedStr(flow_string)) then
          scalar = trim(adjustl(flow_string(2_pI64:len(flow_string,kind=pI64)-1_pI64)))
        else
          scalar = trim(adjustl(flow_string))
        end if
    end select
  end if

end function parse_flow


!--------------------------------------------------------------------------------------------------
!> @brief Find location of chunk end: ',' '}', or ']'.
!> @details leaves nested lists ( '[...]' and dicts '{...}') intact
!--------------------------------------------------------------------------------------------------
integer(pI64) function find_end(str,e_char)

  character(len=*), intent(in) :: str                                                               !< chunk of YAML flow string
  character,        intent(in) :: e_char                                                            !< end of list/dict  ( '}' or ']')

  integer(pI64) :: N_sq, &                                                                          !< number of open square brackets
                   N_cu, &                                                                          !< number of open curly brackets
                                  i

  N_sq = 0_pI64
  N_cu = 0_pI64
  i = 1_pI64
  do while(i<=len_trim(str,pI64))
    if (scan(str(i:i),IO_QUOTES,kind=pI64) == 1_pI64)  i = i + scan(str(i+1:),str(i:i),kind=pI64)
    if (N_sq==0 .and. N_cu==0 .and. scan(str(i:i),e_char//',',kind=pI64) == 1_pI64) exit
    N_sq = N_sq + merge(1_pI64,0_pI64,str(i:i) == '[')
    N_cu = N_cu + merge(1_pI64,0_pI64,str(i:i) == '{')
    N_sq = N_sq - merge(1_pI64,0_pI64,str(i:i) == ']')
    N_cu = N_cu - merge(1_pI64,0_pI64,str(i:i) == '}')
    i = i + 1_pI64
  end do
  find_end = i

end function find_end


!--------------------------------------------------------------------------------------------------
! @brief Check whether a string is enclosed with single or double quotes.
!--------------------------------------------------------------------------------------------------
logical function quotedStr(line)

  character(len=*), intent(in) :: line


  quotedStr = .false.

  if (len(line,kind=pI64) == 0) return

  if (scan(line(:1),IO_QUOTES,kind=pI64) == 1_pI64) then
    quotedStr = .true.
    if (line(len(line,kind=pI64):len(line,kind=pI64)) /= line(:1)) call IO_error(710,ext_msg=line)
  end if

end function quotedStr


#ifdef FYAML
!--------------------------------------------------------------------------------------------------
! @brief Convert all block-style YAML parts to flow style.
!--------------------------------------------------------------------------------------------------
function to_flow(mixed) result(flow)

  character(len=*), intent(in) :: mixed
  character(len=:,kind=C_CHAR), allocatable :: flow


  integer(C_INT) :: stat


  call to_flow_C(flow,f_c_string(mixed),stat)
  if (stat /= 0_C_INT) call IO_error(703_pI16,'libyfaml parser error')

end function to_flow

#else
!--------------------------------------------------------------------------------------------------
! @brief Determine indentation depth.
! @details Indentation level is determined for a given block/line.
! In case of nested lists, an offset is added to determine the indent of the item block (skip
! leading dashes).
!--------------------------------------------------------------------------------------------------
integer(pI64) function indentDepth(line,offset)

  character(len=*), intent(in) :: line
  integer(pI64), optional,intent(in) :: offset


  indentDepth = verify(line,IO_WHITESPACE,kind=pI64) - 1_pI64 + misc_optional(offset,0_pI64)

end function indentDepth


!--------------------------------------------------------------------------------------------------
! @brief Check whether a string is in flow style, i.e. starts with '{' or '['.
!--------------------------------------------------------------------------------------------------
logical function isFlow(line)

  character(len=*), intent(in) :: line


  isFlow = index(adjustl(line),'[',kind=pI64) == 1_pI64 .or. index(adjustl(line),'{',kind=pI64) == 1_pI64

end function isFlow


!--------------------------------------------------------------------------------------------------
! @brief Check whether a string is a scalar item, i.e. starts without any special symbols.
!--------------------------------------------------------------------------------------------------
logical function isScalar(line)

  character(len=*), intent(in) :: line


  isScalar = (.not. isKeyValue(line) .and. &
              .not. isKey(line) .and. &
              .not. isListItem(line) .and. &
              .not. isFlow(line))

end function isScalar


!--------------------------------------------------------------------------------------------------
! @brief Check whether a string is a list item, i.e. starts with '-'.
!--------------------------------------------------------------------------------------------------
logical function isListItem(line)

  character(len=*), intent(in) :: line


  isListItem = .false.
  if (len_trim(adjustl(line),pI64)> 2_pI64 .and. index(trim(adjustl(line)),'-',kind=pI64) == 1_pI64) then
    isListItem = scan(trim(adjustl(line)),' ',kind=pI64) == 2_pI64
  else
    isListItem = trim(adjustl(line)) == '-'
  end if

end function isListItem


!--------------------------------------------------------------------------------------------------
! @brief Check whether a string contains a key-value pair of the form '<key>: <value>'.
!--------------------------------------------------------------------------------------------------
logical function isKeyValue(line)

  character(len=*), intent(in) :: line
  isKeyValue = .false.


  if ( .not. isKey(line) .and. index(clean(line),':',kind=pI64) > 0_pI64 .and. .not. isFlow(line)) then
    if (index(clean(line),': ',kind=pI64) > 0_pI64) isKeyValue = .true.
  end if

end function isKeyValue


!--------------------------------------------------------------------------------------------------
! @brief Check whether a string contains a key without a value, i.e. it ends in ':'.
! ToDo: check whether this is safe for trailing spaces followed by a newline character
!--------------------------------------------------------------------------------------------------
logical function isKey(line)

  character(len=*), intent(in) :: line


  if (len(clean(line),kind=pI64) == 0_pI64) then
    isKey = .false.
  else
    isKey = index(clean(line),':',back=.false.,kind=pI64) == len(clean(line),kind=pI64) .and. &
            index(clean(line),':',back=.true.,kind=pI64)  == len(clean(line),kind=pI64) .and. &
            .not. isFlow(line)
  end if

end function isKey


!--------------------------------------------------------------------------------------------------
! @brief Check whether a string is a list in flow style.
!--------------------------------------------------------------------------------------------------
logical function isFlowList(line)

  character(len=*), intent(in) :: line


  isFlowList = index(adjustl(line),'[',kind=pI64) == 1_pI64

end function isFlowList


!--------------------------------------------------------------------------------------------------
! @brief Skip empty lines.
! @details Update start position in the block by skipping empty lines if present.
!--------------------------------------------------------------------------------------------------
subroutine skip_empty_lines(blck,s_blck)

  character(len=*), intent(in)     :: blck
  integer(pI64),    intent(inout)  :: s_blck

  logical :: empty


  empty = .true.
  do while (empty .and. len_trim(blck(s_blck:),pI64) /= 0_pI64)
    empty = len_trim(clean(blck(s_blck:s_blck + index(blck(s_blck:),IO_EOL,kind=pI64) - 2_pI64)),pI64) == 0_pI64
    if (empty) s_blck = s_blck + index(blck(s_blck:),IO_EOL,kind=pI64)
  end do

end subroutine skip_empty_lines


!--------------------------------------------------------------------------------------------------
! @brief Skip file header.
! @details Update start position in the block by skipping file header if present.
!--------------------------------------------------------------------------------------------------
subroutine skip_file_header(blck,s_blck)

  character(len=*), intent(in)     :: blck
  integer(pI64),    intent(inout)  :: s_blck

  character(len=:), allocatable    :: line


  line = clean(blck(s_blck:s_blck + index(blck(s_blck:),IO_EOL,kind=pI64) - 2_pI64))
  if (index(adjustl(line),'%YAML',kind=pI64) == 1_pI64) then
    s_blck = s_blck + index(blck(s_blck:),IO_EOL,kind=pI64)
    call skip_empty_lines(blck,s_blck)
    if (trim(clean(blck(s_blck:s_blck + index(blck(s_blck:),IO_EOL,kind=pI64) - 2_pI64))) == '---') then
      s_blck = s_blck + index(blck(s_blck:),IO_EOL,kind=pI64)
    else
      call IO_error(708,ext_msg = line)
    end if
  end if

end subroutine skip_file_header


!--------------------------------------------------------------------------------------------------
!> @brief Check whether a line in flow style starts and ends on the same line.
!--------------------------------------------------------------------------------------------------
logical function flow_is_closed(str,e_char)

  character(len=*), intent(in) :: str
  character,        intent(in) :: e_char                                                            !< end of list/dict  ( '}' or ']')
  integer(pI64)                :: N_sq, &                                                           !< number of open square brackets
                                  N_cu, &                                                           !< number of open curly brackets
                                  i
  character(len=:), allocatable:: line


  flow_is_closed = .false.
  N_sq = 0_pI64
  N_cu = 0_pI64
  if (e_char == ']') line = str(index(str(:),'[',kind=pI64)+1:)
  if (e_char == '}') line = str(index(str(:),'{',kind=pI64)+1:)

  do i = 1_pI64, len_trim(line,pI64)
    flow_is_closed = (N_sq==0 .and. N_cu==0 .and. scan(line(i:i),e_char,kind=pI64) == 1_pI64)
    N_sq = N_sq + merge(1_pI64,0_pI64,line(i:i) == '[')
    N_cu = N_cu + merge(1_pI64,0_pI64,line(i:i) == '{')
    N_sq = N_sq - merge(1_pI64,0_pI64,line(i:i) == ']')
    N_cu = N_cu - merge(1_pI64,0_pI64,line(i:i) == '}')
  end do

end function flow_is_closed


!--------------------------------------------------------------------------------------------------
!> @brief Return a flow-style line without line break.
!--------------------------------------------------------------------------------------------------
subroutine remove_line_break(blck,s_blck,e_char,flow_line)

  character(len=*), intent(in)               :: blck                                                !< YAML in mixed style
  integer(pI64),    intent(inout)            :: s_blck
  character,        intent(in)               :: e_char                                              !< end of list/dict  ( '}' or ']')
  character(len=:), allocatable, intent(out) :: flow_line
  logical :: line_end


  line_end = .false.
  flow_line = ''

  do while (.not. line_end)
    flow_line = flow_line//clean(blck(s_blck:s_blck + index(blck(s_blck:),IO_EOL,kind=pI64) - 2_pI64))//' '
    line_end  = flow_is_closed(flow_line,e_char)
    s_blck    = s_blck + index(blck(s_blck:),IO_EOL,kind=pI64)
  end do

end subroutine remove_line_break


!--------------------------------------------------------------------------------------------------
!> @brief Return a scalar list item without line break.
!--------------------------------------------------------------------------------------------------
subroutine list_item_inline(blck,s_blck,inline,offset)

  character(len=*), intent(in)                 :: blck                                              !< YAML in mixed style
  integer(pI64),    intent(inout)              :: s_blck
  character(len=:), allocatable, intent(out)   :: inline
  integer(pI64),                 intent(inout) :: offset

  character(len=:), allocatable :: line
  integer(pI64) :: indent,indent_next


  indent = indentDepth(blck(s_blck:),offset)
  line   = clean(blck(s_blck:s_blck + index(blck(s_blck:),IO_EOL,kind=pI64) - 2_pI64))
  inline = line(indent-offset+3_pI64:)
  s_blck = s_blck + index(blck(s_blck:),IO_EOL,kind=pI64)

  indent_next = indentDepth(blck(s_blck:))

  do while (indent_next > indent)
    inline = inline//' '//trim(adjustl(clean(blck(s_blck:s_blck + index(blck(s_blck:),IO_EOL,kind=pI64) - 2_pI64))))
    s_blck = s_blck + index(blck(s_blck:),IO_EOL,kind=pI64)
    indent_next = indentDepth(blck(s_blck:))
  end do

  if (scan(inline,",",kind=pI64) > 0_pI64) inline = '"'//inline//'"'

end subroutine list_item_inline


!--------------------------------------------------------------------------------------------------
! @brief Read a line of YAML block that is already in flow style.
! @details A dict should be enclosed within '{}' for it to be consistent with the DAMASK YAML parser.
!--------------------------------------------------------------------------------------------------
recursive subroutine line_isFlow(flow,s_flow,line)

  character(len=*), intent(inout) :: flow                                                           !< YAML in flow style only
  integer(pI64),    intent(inout) :: s_flow                                                         !< start position in flow
  character(len=*), intent(in)    :: line

  integer(pI64) :: &
    s, &
    list_chunk, &
    dict_chunk


  if (index(adjustl(line),'[',kind=pI64) == 1_pI64) then
    s = index(line,'[',kind=pI64)
    flow(s_flow:s_flow) = '['
    s_flow = s_flow + 1_pI64
    do while (s < len_trim(line,pI64))
      list_chunk = s + find_end(line(s+1_pI64:),']')
      if (iskeyValue(line(s+1_pI64:list_chunk-1_pI64))) then
        flow(s_flow:s_flow) = '{'
        s_flow = s_flow + 1_pI64
        call keyValue_toFlow(flow,s_flow,line(s+1_pI64:list_chunk-1_pI64))
        flow(s_flow:s_flow) = '}'
        s_flow = s_flow + 1_pI64
      elseif (isFlow(line(s+1_pI64:list_chunk-1_pI64))) then
        call line_isFlow(flow,s_flow,line(s+1_pI64:list_chunk-1_pI64))
      else
        call line_toFlow(flow,s_flow,line(s+1_pI64:list_chunk-1_pI64))
      end if
      flow(s_flow:s_flow+1_pI64) = ', '
      s_flow = s_flow + 2_pI64
      s = s + find_end(line(s+1_pI64:),']')
    end do
    s_flow = s_flow - 1_pI64
    if (flow(s_flow-1_pI64:s_flow-1_pI64) == ',') s_flow = s_flow - 1_pI64
    flow(s_flow:s_flow) = ']'
    s_flow = s_flow + 1_pI64

  elseif (index(adjustl(line),'{',kind=pI64) == 1_pI64) then
    s = index(line,'{',kind=pI64)
    flow(s_flow:s_flow) = '{'
    s_flow = s_flow + 1_pI64
    do while (s < len_trim(line,pI64))
      dict_chunk = s + find_end(line(s+1_pI64:),'}')
      if (.not. iskeyValue(line(s+1_pI64:dict_chunk-1_pI64))) &
        call IO_error(703_pI16,'unsupported feature')
      call keyValue_toFlow(flow,s_flow,line(s+1_pI64:dict_chunk-1_pI64))
      flow(s_flow:s_flow+1_pI64) = ', '
      s_flow = s_flow + 2_pI64
      s = s + find_end(line(s+1:),'}')
    end do
    s_flow = s_flow - 1_pI64
    if (flow(s_flow-1_pI64:s_flow-1_pI64) == ',') s_flow = s_flow - 1_pI64
    flow(s_flow:s_flow) = '}'
    s_flow = s_flow + 1_pI64
  else
    call line_toFlow(flow,s_flow,line)
  end if

end subroutine line_isFlow


!-------------------------------------------------------------------------------------------------
! @brief Transform a line of YAML of type <key>: <value> to flow style.
! @details Ensures that the <value> is consistent with the input required in the DAMASK YAML parser.
!-------------------------------------------------------------------------------------------------
recursive subroutine keyValue_toFlow(flow,s_flow,line)

  character(len=*), intent(inout) :: flow                                                           !< YAML in flow style only
  integer(pI64),    intent(inout) :: s_flow                                                         !< start position in flow
  character(len=*), intent(in)    :: line

  character(len=:), allocatable   :: line_asStandard                                                ! standard form of <key>: <value>
  integer(pI64) :: &
    d_flow, &
    col_pos, &
    offset_value


  col_pos = index(line,':',kind=pI64)
  if (line(col_pos+1_pI64:col_pos+1_pI64) /= ' ') call IO_error(704,ext_msg=line)
  if (isFlow(line(col_pos+1_pI64:))) then
    d_flow = len_trim(adjustl(line(:col_pos)),pI64)
    flow(s_flow:s_flow+d_flow+1_pI64) = trim(adjustl(line(:col_pos)))//' '
    s_flow = s_flow + d_flow + 1_pI64
    call line_isFlow(flow,s_flow,line(col_pos+1_pI64:))
  else
    offset_value = indentDepth(line(col_pos+2_pI64:))
    line_asStandard = line(:col_pos+1_pI64)//line(col_pos+2_pI64+offset_value:)
    call line_toFlow(flow,s_flow,line_asStandard)
  end if

end subroutine keyValue_toFlow


!-------------------------------------------------------------------------------------------------
! @brief Transform a line of YAML to flow style.
!-------------------------------------------------------------------------------------------------
subroutine line_toFlow(flow,s_flow,line)

  character(len=*), intent(inout) :: flow                                                           !< YAML in flow style only
  integer(pI64),    intent(inout) :: s_flow                                                         !< start position in flow
  character(len=*), intent(in)    :: line

  integer(pI64) :: d_flow


  d_flow = len_trim(adjustl(line),pI64)
  flow(s_flow:s_flow+d_flow) = trim(adjustl(line))
  s_flow = s_flow + d_flow

end subroutine line_toFlow


!-------------------------------------------------------------------------------------------------
! @brief Transform a block-style list to flow style.
! @details enters the function when encountered with the list indicator '- '
! reads each scalar list item and separates each other with a ','
! If list item is non scalar, it stores the offset for that list item block
! Call the 'decide' function if there is an increase in the indentation level or the list item is not a scalar
! decrease in indentation level indicates the end of an indentation block
!-------------------------------------------------------------------------------------------------
recursive subroutine lst(blck,flow,s_blck,s_flow,offset)

  character(len=*), intent(in)    :: blck                                                           !< YAML in mixed style
  character(len=*), intent(inout) :: flow                                                           !< YAML in flow style only
  integer(pI64),    intent(inout) :: s_blck, &                                                      !< start position in blck
                                     s_flow, &                                                      !< start position in flow
                                     offset                                                         !< stores leading '- ' in nested lists
  character(len=:), allocatable :: line,flow_line,inline
  integer(pI64) :: e_blck,indent


  indent = indentDepth(blck(s_blck:),offset)
  do while (s_blck <= len_trim(blck,pI64))
    e_blck = s_blck + index(blck(s_blck:),IO_EOL,kind=pI64) - 2_pI64
    line = clean(blck(s_blck:e_blck))
    if (trim(line) == '---' .or. trim(line) == '...') then
      exit
    elseif (len_trim(line,pI64) == 0_pI64) then
      s_blck = e_blck + 2_pI64                                                                      ! forward to next line
      cycle
    elseif (indentDepth(line,offset) > indent) then
      call decide(blck,flow,s_blck,s_flow,offset)
      offset = 0_pI64
      flow(s_flow:s_flow+1) = ', '
      s_flow = s_flow + 2_pI64
    elseif (indentDepth(line,offset) < indent .or. .not. isListItem(line)) then
      offset = 0_pI64
      exit                                                                                          ! job done (lower level)
    else
      if (trim(adjustl(line)) == '-') then                                                          ! list item in next line
        s_blck = e_blck + 2_pI64
        call skip_empty_lines(blck,s_blck)
        e_blck = s_blck + index(blck(s_blck:),IO_EOL,kind=pI64) - 2_pI64
        line = clean(blck(s_blck:e_blck))
        if (trim(line) == '---') call IO_error(703_pI16,'unexpected end of file')
        if (indentDepth(line) < indent .or. indentDepth(line) == indent) &
          call IO_error(701,ext_msg=line)

        if (isScalar(line)) then
          call line_toFlow(flow,s_flow,line)
          s_blck = e_blck + 2_pI64
          offset = 0_pI64
        elseif (isFlow(line)) then
          if (isFlowList(line)) then
            call remove_line_break(blck,s_blck,']',flow_line)
          else
            call remove_line_break(blck,s_blck,'}',flow_line)
          end if
          call line_isFlow(flow,s_flow,flow_line)
          offset = 0_pI64
        end if
      else                                                                                          ! list item in the same line
        line = line(indentDepth(line)+3_pI64:)
        if (isScalar(line)) then
          call list_item_inline(blck,s_blck,inline,offset)
          offset = 0_pI64
          call line_toFlow(flow,s_flow,inline)
        elseif (isFlow(line)) then
          s_blck = s_blck + index(blck(s_blck:),'-',kind=pI64)
          if (isFlowList(line)) then
            call remove_line_break(blck,s_blck,']',flow_line)
          else
            call remove_line_break(blck,s_blck,'}',flow_line)
          end if
          call line_isFlow(flow,s_flow,flow_line)
          offset = 0_pI64
        else                                                                                        ! non scalar list item
          offset = offset + indentDepth(blck(s_blck:))+1_pI64                                       ! offset in spaces to be ignored
          s_blck = s_blck + index(blck(s_blck:e_blck),'-',kind=pI64)                                ! s_blck after '-' symbol
         end if
      end if
    end if

    if (isScalar(line) .or. isFlow(line)) then
      flow(s_flow:s_flow+1_pI64) = ', '
      s_flow = s_flow + 2_pI64
    end if

  end do

  s_flow = s_flow-1_pI64
  if (flow(s_flow-1_pI64:s_flow-1_pI64) == ',') s_flow = s_flow-1_pI64

end subroutine lst


!--------------------------------------------------------------------------------------------------
! @brief Transform a block-style dict to flow style.
! @details enters the function when encountered with the dictionary indicator ':'
! parses each line in the block and compares indentation of a line with the preceding line
! upon increase in indentation level -> 'decide' function decides if the line is a list or dict
! decrease in indentation indicates the end of an indentation block
!--------------------------------------------------------------------------------------------------
recursive subroutine dct(blck,flow,s_blck,s_flow,offset)

  character(len=*), intent(in)    :: blck                                                           !< YAML in mixed style
  character(len=*), intent(inout) :: flow                                                           !< YAML in flow style only
  integer(pI64),    intent(inout) :: s_blck, &                                                      !< start position in blck
                                     s_flow, &                                                      !< start position in flow
                                     offset

  character(len=:), allocatable :: line,flow_line
  integer(pI64) :: e_blck,indent,col_pos
  logical :: previous_isKey

  previous_isKey = .false.

  indent = indentDepth(blck(s_blck:),offset)

  do while (s_blck <= len_trim(blck,pI64))
    e_blck = s_blck + index(blck(s_blck:),IO_EOL,kind=pI64) - 2_pI64
    line = clean(blck(s_blck:e_blck))
    if (trim(line) == '---' .or. trim(line) == '...') then
      exit
    elseif (len_trim(line,pI64) == 0_pI64) then
      s_blck = e_blck + 2_pI64                                                                      ! forward to next line
      cycle
    elseif (indentDepth(line,offset) < indent) then
      if (isScalar(line) .or. isFlow(line) .and. previous_isKey) &
        call IO_error(701,ext_msg=line)
      offset = 0_pI64
      exit                                                                                          ! job done (lower level)
    elseif (indentDepth(line,offset) > indent .or. isListItem(line)) then
      offset = 0_pI64
      call decide(blck,flow,s_blck,s_flow,offset)
    else
      if (isScalar(line)) call IO_error(701,ext_msg=line)
      if (isFlow(line))   call IO_error(702,ext_msg=line)

      line = line(indentDepth(line)+1_pI64:)
      if (previous_isKey) then
        flow(s_flow-1_pI64:s_flow) = ', '
        s_flow = s_flow + 1_pI64
      end if

      if (isKeyValue(line)) then
        col_pos = index(line,':',kind=pI64)
        if (isFlow(line(col_pos+1_pI64:))) then
          if (isFlowList(line(col_pos+1_pI64:))) then
            call remove_line_break(blck,s_blck,']',flow_line)
          else
            call remove_line_break(blck,s_blck,'}',flow_line)
          end if
          call keyValue_toFlow(flow,s_flow,flow_line)
        else
          call keyValue_toFlow(flow,s_flow,line)
          s_blck = e_blck + 2_pI64
        end if
      else
        call line_toFlow(flow,s_flow,line)
        s_blck = e_blck + 2_pI64
      end if
    end if

    if (isScalar(line) .or. isKeyValue(line)) then
      flow(s_flow:s_flow) = ','
      s_flow = s_flow + 1_pI64
      previous_isKey = .false.
    else
      previous_isKey = .true.
    end if

    flow(s_flow:s_flow) = ' '
    s_flow = s_flow + 1_pI64
    offset = 0_pI64
  end do

  s_flow = s_flow - 1_pI64
  if (flow(s_flow-1_pI64:s_flow-1_pI64) == ',') s_flow = s_flow - 1_pI64

end subroutine dct


!--------------------------------------------------------------------------------------------------
! @brief Decide whether next block is list or dict.
!--------------------------------------------------------------------------------------------------
recursive subroutine decide(blck,flow,s_blck,s_flow,offset)

  character(len=*), intent(in)    :: blck                                                           !< YAML in mixed style
  character(len=*), intent(inout) :: flow                                                           !< YAML in flow style only
  integer(pI64),    intent(inout) :: s_blck, &                                                      !< start position in blck
                                     s_flow, &                                                      !< start position in flow
                                     offset
  integer(pI64) :: e_blck
  character(len=:), allocatable :: line,flow_line


  if (s_blck <= len(blck,kind=pI64)) then
    call skip_empty_lines(blck,s_blck)
    e_blck = s_blck + index(blck(s_blck:),IO_EOL,kind=pI64) - 2_pI64
    line = clean(blck(s_blck:e_blck))
    if (trim(line) == '---' .or. trim(line) == '...') then
      continue                                                                                      ! end parsing at this point but not stop the simulation
    elseif (len_trim(line,pI64) == 0_pI64) then
      s_blck = e_blck + 2_pI64
      call decide(blck,flow,s_blck,s_flow,offset)
    elseif (isListItem(line)) then
      flow(s_flow:s_flow) = '['
      s_flow = s_flow + 1_pI64
      call lst(blck,flow,s_blck,s_flow,offset)
      flow(s_flow:s_flow) = ']'
      s_flow = s_flow + 1_pI64
    elseif (isKey(line) .or. isKeyValue(line)) then
      flow(s_flow:s_flow) = '{'
      s_flow = s_flow + 1_pI64
      call dct(blck,flow,s_blck,s_flow,offset)
      flow(s_flow:s_flow) = '}'
      s_flow = s_flow + 1_pI64
    elseif (isFlow(line)) then
      if (isFlowList(line)) then
        call remove_line_break(blck,s_blck,']',flow_line)
      else
        call remove_line_break(blck,s_blck,'}',flow_line)
      end if
      call line_isFlow(flow,s_flow,line)
    else
      line = line(indentDepth(line)+1:)
      call line_toFlow(flow,s_flow,line)
      s_blck = e_blck + 2_pI64
    end if
  end if

end subroutine decide


!--------------------------------------------------------------------------------------------------
!> @brief Convert all block-style parts to flow style.
!> @details The input needs to end with a newline.
!--------------------------------------------------------------------------------------------------
function to_flow(blck)

  character(len=:), allocatable :: to_flow
  character(len=*), intent(in)  :: blck                                                             !< YAML mixed style

  character(len=:), allocatable :: line
  integer(pI64)                 :: s_blck, &                                                        !< start position in blck
                                   s_flow, &                                                        !< start position in flow
                                   offset, &                                                        !< counts leading '- ' in nested lists
                                   end_line

  allocate(character(len=len(blck,kind=pI64)*2)::to_flow)
  s_flow = 1_pI64
  s_blck = 1_pI64
  offset = 0_pI64

  if (len_trim(blck,pI64) /= 0_pI64) then
    call skip_empty_lines(blck,s_blck)
    call skip_file_header(blck,s_blck)
    line = clean(blck(s_blck:s_blck + index(blck(s_blck:),IO_EOL,kind=pI64) - 2_pI64))
    if (trim(line) == '---') s_blck = s_blck + index(blck(s_blck:),IO_EOL,kind=pI64)
    call decide(blck,to_flow,s_blck,s_flow,offset)
  end if
  line = clean(blck(s_blck:s_blck+index(blck(s_blck:),IO_EOL,kind=pI64)-2_pI64))
  if (trim(line)== '---') call IO_warning(709,'YAML file contains "---" after first line')
  to_flow = trim(to_flow(:s_flow-1_pI64))
  end_line = index(to_flow,IO_EOL,kind=pI64)
  if (end_line > 0_pI64) to_flow = to_flow(:end_line-1_pI64)

end function to_flow


!--------------------------------------------------------------------------------------------------
! @brief Remove comments (characters beyond '#') and trailing space.
!--------------------------------------------------------------------------------------------------
function clean(line)

  character(len=*), intent(in)  :: line
  character(len=:), allocatable :: clean

  integer(pI64) :: split
  character, parameter :: COMMENT_CHAR = '#'


  split = index(line,COMMENT_CHAR,kind=pI64)

  if (split == 0_pI64) then
    clean = trim(line)
  else
    clean = trim(line(:split-1_pI64))
  end if

end function clean


!--------------------------------------------------------------------------------------------------
!> @brief Check correctness of some YAML functions.
!--------------------------------------------------------------------------------------------------
subroutine YAML_selfTest()

  if (indentDepth(' a') /= 1)     error stop 'indentDepth'
  if (indentDepth('a')  /= 0)     error stop 'indentDepth'
  if (indentDepth('x ') /= 0)     error stop 'indentDepth'

  if (.not. quotedStr("'a'"))     error stop 'quotedStr'

  if (      isFlow(' a'))         error stop 'isFLow'
  if (.not. isFlow('{'))          error stop 'isFlow'
  if (.not. isFlow(' ['))         error stop 'isFlow'

  if (      isListItem(' a'))     error stop 'isListItem'
  if (      isListItem(' -b'))    error stop 'isListItem'
  if (.not. isListItem('- a '))   error stop 'isListItem'
  if (.not. isListItem('- -a '))  error stop 'isListItem'

  if (      isKeyValue(' a'))     error stop 'isKeyValue'
  if (      isKeyValue(' a: '))   error stop 'isKeyValue'
  if (.not. isKeyValue(' a: b'))  error stop 'isKeyValue'

  if (      isKey(' a'))          error stop 'isKey'
  if (      isKey('{a:b}'))       error stop 'isKey'
  if (      isKey(' a:b'))        error stop 'isKey'
  if (.not. isKey(' a: '))        error stop 'isKey'
  if (.not. isKey(' a:'))         error stop 'isKey'
  if (.not. isKey(' a: #'))       error stop 'isKey'

  if (       isScalar('a:  '))     error stop 'isScalar'
  if (       isScalar('a: b'))     error stop 'isScalar'
  if (       isScalar('{a:b}'))    error stop 'isScalar'
  if (       isScalar('- a:'))     error stop 'isScalar'
  if (.not.  isScalar('   a'))     error stop 'isScalar'

  basic_list: block
    character(len=*), parameter :: block_list = &
      " - Casablanca"//IO_EOL//&
      " - North by Northwest"//IO_EOL
    character(len=*), parameter :: block_list_newline = &
      " -"//IO_EOL//&
      "   Casablanca"//IO_EOL//&
      " -"//IO_EOL//&
      "   North by Northwest"//IO_EOL
    character(len=*), parameter :: flow_list = &
      "[Casablanca, North by Northwest]"

    if (.not. to_flow(block_list)         == flow_list) error stop 'to_flow'
    if (.not. to_flow(block_list_newline) == flow_list) error stop 'to_flow'
  end block basic_list

  basic_dict: block
    character(len=*), parameter :: block_dict = &
      " aa: Casablanca"//IO_EOL//&
      " bb: North by Northwest"//IO_EOL
    character(len=*), parameter :: block_dict_newline = &
      " aa:"//IO_EOL//&
      "   Casablanca"//IO_EOL//&
      " bb:"//IO_EOL//&
      "   North by Northwest"//IO_EOL
    character(len=*), parameter :: flow_dict = &
      "{aa: Casablanca, bb: North by Northwest}"

    if (.not. to_flow(block_dict)         == flow_dict) error stop 'to_flow'
    if (.not. to_flow(block_dict_newline) == flow_dict) error stop 'to_flow'
  end block basic_dict

  only_flow: block
    character(len=*), parameter :: flow_dict = &
      " {a: [b,c: {d: e}, f: g, e]}"//IO_EOL
    character(len=*), parameter :: flow_list = &
      " [a,b: c,    d,e: {f: g}]"//IO_EOL
    character(len=*), parameter :: flow_1 = &
      "{a: [b, {c: {d: e}}, {f: g}, e]}"
    character(len=*), parameter :: flow_2 = &
      "[a, {b: c}, d, {e: {f: g}}]"

    if (.not. to_flow(flow_dict)        == flow_1) error stop 'to_flow'
    if (.not. to_flow(flow_list)        == flow_2) error stop 'to_flow'
  end block only_flow

  basic_flow: block
    character(len=*), parameter :: flow_braces = &
      " source: [{param: 1}, {param: 2}, {param: 3}, {param: 4}]"//IO_EOL
    character(len=*), parameter :: flow_mixed_braces = &
      " source: [param: 1, {param: 2}, param: 3, {param: 4}]"//IO_EOL
    character(len=*), parameter :: flow = &
      "{source: [{param: 1}, {param: 2}, {param: 3}, {param: 4}]}"

    if (.not. to_flow(flow_braces)        == flow) error stop 'to_flow'
    if (.not. to_flow(flow_mixed_braces)  == flow) error stop 'to_flow'
  end block basic_flow

  multi_line_flow1: block
    character(len=*), parameter :: flow_multi = &
      '%YAML 1.1'//IO_EOL//&
      '---'//IO_EOL//&
      'a:     ["b",'//IO_EOL//&
      'c: '//IO_EOL//&
      '"d",                               "e"]'//IO_EOL

    character(len=*), parameter :: flow = &
      '{a: ["b", {c: "d"}, "e"]}'

    if ( .not. to_flow(flow_multi)        == flow) error stop 'to_flow'
  end block multi_line_flow1

  multi_line_flow2: block
    character(len=*), parameter :: flow_multi = &
      "%YAML 1.1"//IO_EOL//&
      "---"//IO_EOL//&
      "-"//IO_EOL//&
      " a: {b:"//IO_EOL//&
      "[c,"//IO_EOL//&
      "d"//IO_EOL//&
      "e, f]}"//IO_EOL

    character(len=*), parameter :: flow = &
      "[{a: {b: [c, d e, f]}}]"

    if ( .not. to_flow(flow_multi)        == flow) error stop 'to_flow'
  end block multi_line_flow2

  basic_mixed: block
    character(len=*), parameter :: block_flow = &
      "%YAML 1.1"//IO_EOL//&
      " "//IO_EOL//&
      " "//IO_EOL//&
      "---"//IO_EOL//&
      " aa:"//IO_EOL//&
      " - "//IO_EOL//&
      " "//IO_EOL//&
      " "//IO_EOL//&
      "                 param_1: [a:                   b, c, {d: {e: [f: g, h]}}]"//IO_EOL//&
      " - c:d"//IO_EOL//&
      "  e.f,"//IO_EOL//&
      " bb:"//IO_EOL//&
      " "//IO_EOL//&
      "  - "//IO_EOL//&
      "   {param_1: [{a: b}, c, {d: {e: [{f: g}, h]}}]}"//IO_EOL//&
      "..."//IO_EOL
    character(len=*), parameter :: mixed_flow = &
      '{aa: [{param_1: [{a: b}, c, {d: {e: [{f: g}, h]}}]}, "c:d e.f,"], bb: [{param_1: [{a: b}, c, {d: {e: [{f: g}, h]}}]}]}'

    if (.not. to_flow(block_flow) == mixed_flow)    error stop 'to_flow'
  end block basic_mixed

  parse: block

    type(tDict), pointer :: dict
    type(tList), pointer :: list
    character(len=*), parameter :: &
      lst = '[1, 2, 3, 4]', &
      dct = '{a: 1, b: 2}'

    list => YAML_str_asList(lst//IO_EOL)
    if (list%asFormattedStr() /= lst) error stop 'str_asList'
    dict => YAML_str_asDict(dct//IO_EOL)
    if (dict%asFormattedStr() /= dct) error stop 'str_asDict'

  end block parse

  comment: block
    character(len=:),      allocatable :: str,out

    str='#';out=clean(str)
    if (out /= ''   .or. len(out) /= 0)  error stop 'clean/1'
    str=' #';out=clean(str)
    if (out /= ''   .or. len(out) /= 0)  error stop 'clean/2'
    str=' # ';out=clean(str)
    if (out /= ''   .or. len(out) /= 0)  error stop 'clean/3'
    str=' # a';out=clean(str)
    if (out /= ''   .or. len(out) /= 0)  error stop 'clean/4'
    str=' a#';out=clean(str)
    if (out /= ' a' .or. len(out) /= 2)  error stop 'clean/5'
    str=' ab #';out=clean(str)
    if (out /= ' ab'.or. len(out) /= 3)  error stop 'clean/6'
  end block comment

end subroutine YAML_selfTest
#endif

end module YAML

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author David Cereceda, Lawrence Livermore National Laboratory
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief crystal plasticity model for bcc metals, especially Tungsten
!--------------------------------------------------------------------------------------------------
submodule(phase:plastic) dislotungsten

  type :: tParameters
    real(pREAL) :: &
      D    = 1.0_pREAL, &                                                                           !< grain size
      D_0  = 1.0_pREAL, &                                                                           !< prefactor for self-diffusion coefficient
      Q_cl = 1.0_pREAL                                                                              !< activation energy for dislocation climb
    real(pREAL),               allocatable, dimension(:) :: &
      b_sl, &                                                                                       !< magnitude of Burgers vector [m]
      d_caron, &                                                                                    !< distance of spontaneous annhihilation
      i_sl, &                                                                                       !< Adj. parameter for distance between 2 forest dislocations
      f_at, &                                                                                       !< factor to calculate atomic volume
      tau_Peierls, &                                                                                !< Peierls stress
      !* mobility law parameters
      Q_s, &                                                                                        !< activation energy for glide [J]
      p, &                                                                                          !< p-exponent in glide velocity
      q, &                                                                                          !< q-exponent in glide velocity
      B, &                                                                                          !< friction coefficient
      h, &                                                                                          !< height of the kink pair
      w, &                                                                                          !< width of the kink pair
      omega                                                                                         !< attempt frequency for kink pair nucleation
    real(pREAL),               allocatable, dimension(:,:) :: &
      h_sl_sl, &                                                                                    !< slip resistance from slip activity
      forestProjection
    real(pREAL),               allocatable, dimension(:,:,:) :: &
      P_sl, &
      P_nS_pos, &
      P_nS_neg
    integer :: &
      sum_N_sl                                                                                      !< total number of active slip system
    character(len=:),          allocatable               :: &
      isotropic_bound
    character(len=pSTRLEN), allocatable, dimension(:) :: &
      output
    logical :: &
      dipoleFormation                                                                               !< flag indicating consideration of dipole formation
    character(len=:),          allocatable, dimension(:) :: &
      systems_sl
  end type tParameters                                                                              !< container type for internal constitutive parameters

  type :: tIndexDotState
    integer, dimension(2) :: &
      rho_mob, &
      rho_dip, &
      gamma_sl
  end type tIndexDotState

  type :: tDislotungstenState
    real(pREAL), dimension(:,:), pointer :: &
      rho_mob, &
      rho_dip, &
      gamma_sl
  end type tDislotungstenState

  type :: tDislotungstenDependentState
    real(pREAL), dimension(:,:), allocatable :: &
      Lambda_sl, &
      tau_pass
  end type tDislotungstenDependentState

!--------------------------------------------------------------------------------------------------
! containers for parameters and state
  type(tParameters),                  allocatable, dimension(:) :: param
  type(tIndexDotState),               allocatable, dimension(:) :: indexDotState
  type(tDisloTungstenState),          allocatable, dimension(:) :: state
  type(tDisloTungstenDependentState), allocatable, dimension(:) :: dependentState

contains


!--------------------------------------------------------------------------------------------------
!> @brief Perform module initialization.
!> @details reads in material parameters, allocates arrays, and does sanity checks
!--------------------------------------------------------------------------------------------------
module function plastic_dislotungsten_init() result(myPlasticity)

  logical, dimension(:), allocatable :: myPlasticity
  integer :: &
    ph, i, &
    Nmembers, &
    sizeState, sizeDotState, &
    startIndex, endIndex
  integer,    dimension(:), allocatable :: &
    N_sl
  real(pREAL),dimension(:), allocatable :: &
    f_edge, &                                                                                       !< edge character fraction of total dislocation density
    rho_mob_0, &                                                                                    !< initial dislocation density
    rho_dip_0                                                                                       !< initial dipole density
    real(pREAL), dimension(:,:), allocatable :: &
    a_nS                                                                                            !< non-Schmid coefficients
  character(len=:), allocatable :: &
    refs, &
    extmsg
  type(tDict), pointer :: &
    phases, &
    phase, &
    mech, &
    pl


  myPlasticity = plastic_active('dislotungsten')
  if (count(myPlasticity) == 0) return

  print'(/,1x,a)', '<<<+-  phase:mechanical:plastic:dislotungsten init  -+>>>'

  print'(/,1x,a)', 'D. Cereceda et al., International Journal of Plasticity 78:242–256, 2016'
  print'(  1x,a)', 'https://doi.org/10.1016/j.ijplas.2015.09.002'

  print'(/,1x,a,1x,i0)', '# phases:',count(myPlasticity); flush(IO_STDOUT)

  phases => config_material%get_dict('phase')
  allocate(param(size(phases)))
  allocate(indexDotState(size(phases)))
  allocate(state(size(phases)))
  allocate(dependentState(size(phases)))
  extmsg = ''

  do ph = 1, size(phases)
    if (.not. myPlasticity(ph)) cycle

    associate(prm => param(ph), &
              stt => state(ph), dst => dependentState(ph), &
              idx_dot => indexDotState(ph))

    phase => phases%get_dict(ph)
    mech  => phase%get_dict('mechanical')
    pl  => mech%get_dict('plastic')

    print'(/,1x,a,1x,i0,a)', 'phase',ph,': '//phases%key(ph)
    refs = config_listReferences(pl,indent=3)
    if (len(refs) > 0) print'(/,1x,a)', refs

#if defined (__GFORTRAN__)
    prm%output = output_as1dStr(pl)
#else
    prm%output = pl%get_as1dStr('output',defaultVal=emptyStrArray)
#endif

    prm%isotropic_bound = pl%get_asStr('isotropic_bound',defaultVal='isostrain')

!--------------------------------------------------------------------------------------------------
! slip related parameters
    N_sl = pl%get_as1dInt('N_sl',defaultVal=emptyIntArray)
    prm%sum_N_sl = sum(abs(N_sl))
    slipActive: if (prm%sum_N_sl > 0) then
      prm%P_sl = crystal_SchmidMatrix_slip(N_sl,phase_lattice(ph),phase_cOverA(ph))
      prm%systems_sl = crystal_labels_slip(N_sl,phase_lattice(ph))

      a_nS = pl%get_as2dReal('a_non-Schmid',defaultVal=reshape(emptyRealArray,[0,0]))
      prm%P_nS_pos = crystal_SchmidMatrix_slip(N_sl,phase_lattice(ph),phase_cOverA(ph),nonSchmidCoefficients=a_nS,sense=+1)
      prm%P_nS_neg = crystal_SchmidMatrix_slip(N_sl,phase_lattice(ph),phase_cOverA(ph),nonSchmidCoefficients=a_nS,sense=-1)

      prm%h_sl_sl = crystal_interaction_SlipBySlip(N_sl,pl%get_as1dReal('h_sl-sl'), &
                                                   phase_lattice(ph))

      prm%dipoleformation = .not. pl%get_asBool('no_dipole_formation', defaultVal=.false.)

      prm%D    = pl%get_asReal('D')
      prm%D_0  = pl%get_asReal('D_0')
      prm%Q_cl = pl%get_asReal('Q_cl')

      f_edge          = math_expand(pl%get_as1dReal('f_edge',      requiredSize=size(N_sl), &
                                                    defaultVal=[(0.5_pREAL, i=1,size(N_sl))]),N_sl)
      rho_mob_0       = math_expand(pl%get_as1dReal('rho_mob_0',   requiredSize=size(N_sl)),N_sl)
      rho_dip_0       = math_expand(pl%get_as1dReal('rho_dip_0',   requiredSize=size(N_sl)),N_sl)
      prm%b_sl        = math_expand(pl%get_as1dReal('b_sl',        requiredSize=size(N_sl)),N_sl)
      prm%Q_s         = math_expand(pl%get_as1dReal('Q_s',         requiredSize=size(N_sl)),N_sl)
      prm%i_sl        = math_expand(pl%get_as1dReal('i_sl',        requiredSize=size(N_sl)),N_sl)
      prm%tau_Peierls = math_expand(pl%get_as1dReal('tau_Peierls', requiredSize=size(N_sl)),N_sl)
      prm%p           = math_expand(pl%get_as1dReal('p_sl',        requiredSize=size(N_sl)),N_sl)
      prm%q           = math_expand(pl%get_as1dReal('q_sl',        requiredSize=size(N_sl)),N_sl)
      prm%h           = math_expand(pl%get_as1dReal('h',           requiredSize=size(N_sl)),N_sl)
      prm%w           = math_expand(pl%get_as1dReal('w',           requiredSize=size(N_sl)),N_sl)
      prm%omega       = math_expand(pl%get_as1dReal('omega',       requiredSize=size(N_sl)),N_sl)
      prm%B           = math_expand(pl%get_as1dReal('B',           requiredSize=size(N_sl)),N_sl)
      prm%d_caron     = prm%b_sl *  pl%get_asReal('D_a')
      prm%f_at        = prm%b_sl**3*pl%get_asReal('f_at')

      prm%forestProjection = spread(          f_edge,1,prm%sum_N_sl) &
                           * crystal_forestProjection_edge (N_sl,phase_lattice(ph),phase_cOverA(ph)) &
                           + spread(1.0_pREAL-f_edge,1,prm%sum_N_sl) &
                           * crystal_forestProjection_screw(N_sl,phase_lattice(ph),phase_cOverA(ph))

      ! sanity checks
      if (    prm%D_0          <  0.0_pREAL)  extmsg = trim(extmsg)//' D_0'
      if (    prm%Q_cl         <= 0.0_pREAL)  extmsg = trim(extmsg)//' Q_cl'
      if (any(rho_mob_0        <  0.0_pREAL)) extmsg = trim(extmsg)//' rho_mob_0'
      if (any(rho_dip_0        <  0.0_pREAL)) extmsg = trim(extmsg)//' rho_dip_0'
      if (any(prm%b_sl         <= 0.0_pREAL)) extmsg = trim(extmsg)//' b_sl'
      if (any(prm%Q_s          <= 0.0_pREAL)) extmsg = trim(extmsg)//' Q_s'
      if (any(prm%tau_Peierls  <  0.0_pREAL)) extmsg = trim(extmsg)//' tau_Peierls'
      if (any(prm%B            <  0.0_pREAL)) extmsg = trim(extmsg)//' B'
      if (any(prm%d_caron      <  0.0_pREAL)) extmsg = trim(extmsg)//' d_caron(D_a,b_sl)'
      if (any(prm%f_at         <= 0.0_pREAL)) extmsg = trim(extmsg)//' f_at or b_sl'

    else slipActive
      rho_mob_0 = emptyRealArray
      rho_dip_0 = emptyRealArray
      allocate(prm%b_sl, &
               prm%d_caron, &
               prm%i_sl, &
               prm%f_at, &
               prm%tau_Peierls, &
               prm%Q_s, &
               prm%p, &
               prm%q, &
               prm%B, &
               prm%h, &
               prm%w, &
               prm%omega, &
               source = emptyRealArray)
      allocate(prm%forestProjection(0,0))
      allocate(prm%h_sl_sl         (0,0))
    end if slipActive

!--------------------------------------------------------------------------------------------------
! allocate state arrays
    Nmembers = count(material_ID_phase == ph)
    sizeDotState = size(['rho_mob ','rho_dip ','gamma_sl']) * prm%sum_N_sl
    sizeState = sizeDotState

    call phase_allocateState(plasticState(ph),Nmembers,sizeState,sizeDotState,0)
    deallocate(plasticState(ph)%dotState) ! ToDo: remove dotState completely

!--------------------------------------------------------------------------------------------------
! state aliases and initialization
    startIndex = 1
    endIndex   = prm%sum_N_sl
    idx_dot%rho_mob = [startIndex,endIndex]
    stt%rho_mob => plasticState(ph)%state(startIndex:endIndex,:)
    stt%rho_mob = spread(rho_mob_0,2,Nmembers)
    plasticState(ph)%atol(startIndex:endIndex) = pl%get_asReal('atol_rho',defaultVal=1.0_pREAL)
    if (any(plasticState(ph)%atol(startIndex:endIndex) < 0.0_pREAL)) extmsg = trim(extmsg)//' atol_rho'

    startIndex = endIndex + 1
    endIndex   = endIndex + prm%sum_N_sl
    idx_dot%rho_dip = [startIndex,endIndex]
    stt%rho_dip => plasticState(ph)%state(startIndex:endIndex,:)
    stt%rho_dip = spread(rho_dip_0,2,Nmembers)
    plasticState(ph)%atol(startIndex:endIndex) = pl%get_asReal('atol_rho',defaultVal=1.0_pREAL)

    startIndex = endIndex + 1
    endIndex   = endIndex + prm%sum_N_sl
    idx_dot%gamma_sl = [startIndex,endIndex]
    stt%gamma_sl => plasticState(ph)%state(startIndex:endIndex,:)
    plasticState(ph)%atol(startIndex:endIndex) = pl%get_asReal('atol_gamma',defaultVal=1.0e-6_pREAL)
    if (any(plasticState(ph)%atol(startIndex:endIndex) < 0.0_pREAL)) extmsg = trim(extmsg)//' atol_gamma'

    allocate(dst%Lambda_sl(prm%sum_N_sl,Nmembers), source=0.0_pREAL)
    allocate(dst%tau_pass (prm%sum_N_sl,Nmembers), source=0.0_pREAL)

    end associate

!--------------------------------------------------------------------------------------------------
!  exit if any parameter is out of range
    if (extmsg /= '') call IO_error(211,ext_msg=trim(extmsg))

  end do

end function plastic_dislotungsten_init


!--------------------------------------------------------------------------------------------------
!> @brief Calculate plastic velocity gradient and its tangent.
!--------------------------------------------------------------------------------------------------
pure module subroutine dislotungsten_LpAndItsTangent(Lp,dLp_dMp, &
                                                     Mp,ph,en)
  real(pREAL), dimension(3,3),     intent(out) :: &
    Lp                                                                                              !< plastic velocity gradient
  real(pREAL), dimension(3,3,3,3), intent(out) :: &
    dLp_dMp                                                                                         !< derivative of Lp with respect to the Mandel stress
  real(pREAL), dimension(3,3),      intent(in) :: &
    Mp                                                                                              !< Mandel stress
  integer,                          intent(in) :: &
    ph, &
    en

  integer :: &
    i,k,l,m,n
  real(pREAL) :: &
    T                                                                                               !< temperature
  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    dot_gamma, ddot_gamma_dtau
  real(pREAL), dimension(3,3,param(ph)%sum_N_sl) :: &
    P_nS


  T = thermal_T(ph,en)
  Lp = 0.0_pREAL
  dLp_dMp = 0.0_pREAL

  associate(prm => param(ph))

    call kinetics(Mp,T,ph,en, dot_gamma,ddot_gamma_dtau)
    P_nS = merge(prm%P_nS_pos,prm%P_nS_neg, spread(spread(dot_gamma,1,3),2,3)>0.0_pREAL)            ! faster than 'merge' in loop
    do i = 1, prm%sum_N_sl
      Lp = Lp + dot_gamma(i)*prm%P_sl(1:3,1:3,i)
      forall (k=1:3,l=1:3,m=1:3,n=1:3) &
        dLp_dMp(k,l,m,n) = dLp_dMp(k,l,m,n) &
                         + ddot_gamma_dtau(i) * prm%P_sl(k,l,i) * P_nS(m,n,i)
    end do

  end associate

end subroutine dislotungsten_LpAndItsTangent


!--------------------------------------------------------------------------------------------------
!> @brief Calculate the rate of change of microstructure.
!--------------------------------------------------------------------------------------------------
module function dislotungsten_dotState(Mp,ph,en) result(dotState)

  real(pREAL), dimension(3,3),  intent(in) :: &
    Mp                                                                                              !< Mandel stress
  integer,                      intent(in) :: &
    ph, &
    en
  real(pREAL), dimension(plasticState(ph)%sizeDotState) :: &
    dotState

  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    tau_eff, &
    v_cl, &
    dot_rho_dip_formation, &
    dot_rho_dip_climb, &
    d_hat
  real(pREAL) :: &
    mu, nu, T


  associate(prm => param(ph), stt => state(ph), dst => dependentState(ph), &
            dot_rho_mob => dotState(indexDotState(ph)%rho_mob(1):indexDotState(ph)%rho_mob(2)), &
            dot_rho_dip => dotState(indexDotState(ph)%rho_dip(1):indexDotState(ph)%rho_dip(2)), &
            dot_gamma   => dotState(indexDotState(ph)%gamma_sl(1):indexDotState(ph)%gamma_sl(2)))

    mu = elastic_mu(ph,en,prm%isotropic_bound)
    nu = elastic_nu(ph,en,prm%isotropic_bound)
    T = thermal_T(ph,en)

    call kinetics(Mp,T,ph,en,&
                  dot_gamma, tau = tau_eff)

    dot_gamma = abs(dot_gamma)

    where(dEq0(dot_gamma))
      d_hat = dst%Lambda_sl(:,en)                                                                   ! upper limit
      dot_rho_dip_formation = 0.0_pREAL
    else where
      d_hat = mu*prm%b_sl/(8.0_pREAL*PI*(1.0_pREAL-nu)*tau_eff)
      d_hat = math_clip(d_hat, right = dst%Lambda_sl(:,en))                                         ! upper limit
      d_hat = math_clip(d_hat, left  = prm%d_caron)                                                 ! lower limit

      dot_rho_dip_formation = merge(dot_gamma * 2.0_pREAL*(d_hat-prm%d_caron)/prm%b_sl * stt%rho_mob(:,en), &
                                    0.0_pREAL, &
                                    prm%dipoleformation)
    end where

    where(dEq0(d_hat-prm%d_caron))
      dot_rho_dip_climb = 0.0_pREAL
    else where
      v_cl = (3.0_pREAL*mu*prm%D_0*exp(-prm%Q_cl/(K_B*T))*prm%f_at/(2.0_pREAL*PI*K_B*T)) &
           * (1.0_pREAL/(d_hat+prm%d_caron))
      dot_rho_dip_climb = (4.0_pREAL*v_cl*stt%rho_dip(:,en))/(d_hat-prm%d_caron)                      ! ToDo: Discuss with Franz: Stress dependency?
    end where

    dot_rho_mob = dot_gamma / (prm%b_sl*dst%Lambda_sl(:,en)) &                                      ! multiplication
                - dot_rho_dip_formation &
                - dot_gamma * 2.0_pREAL*prm%d_caron/prm%b_sl * stt%rho_mob(:,en)                    ! spontaneous annihilation of 2 edges
    dot_rho_dip = dot_rho_dip_formation &
                - dot_rho_dip_climb &
                - dot_gamma * 2.0_pREAL*prm%d_caron/prm%b_sl * stt%rho_dip(:,en)                    ! spontaneous annihilation of an edge with a dipole

  end associate

end function dislotungsten_dotState


!--------------------------------------------------------------------------------------------------
!> @brief Calculate derived quantities from state.
!--------------------------------------------------------------------------------------------------
module subroutine dislotungsten_dependentState(ph,en)

  integer, intent(in) :: &
    ph, &
    en

  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    Lambda_sl_inv


  associate(prm => param(ph), stt => state(ph), dst => dependentState(ph))

    dst%tau_pass(:,en) = elastic_mu(ph,en,prm%isotropic_bound)*prm%b_sl &
                       * sqrt(matmul(prm%h_sl_sl,stt%rho_mob(:,en)+stt%rho_dip(:,en)))

    Lambda_sl_inv = 1.0_pREAL/prm%D &
                  + sqrt(matmul(prm%forestProjection,stt%rho_mob(:,en)+stt%rho_dip(:,en)))/prm%i_sl
    dst%Lambda_sl(:,en) = Lambda_sl_inv**(-1.0_pREAL)

  end associate

end subroutine dislotungsten_dependentState


!--------------------------------------------------------------------------------------------------
!> @brief Write results to HDF5 output file.
!--------------------------------------------------------------------------------------------------
module subroutine plastic_dislotungsten_result(ph,group)

  integer,          intent(in) :: ph
  character(len=*), intent(in) :: group

  integer :: ou


  associate(prm => param(ph), stt => state(ph), dst => dependentState(ph))

    do ou = 1,size(prm%output)

      select case(trim(prm%output(ou)))

        case('rho_mob')
          call result_writeDataset(stt%rho_mob,group,trim(prm%output(ou)), &
                                   'mobile dislocation density','1/m²',prm%systems_sl)
        case('rho_dip')
          call result_writeDataset(stt%rho_dip,group,trim(prm%output(ou)), &
                                   'dislocation dipole density','1/m²',prm%systems_sl)
        case('gamma_sl')
          call result_writeDataset(stt%gamma_sl,group,trim(prm%output(ou)), &
                                   'plastic shear','1',prm%systems_sl)
        case('Lambda_sl')
          call result_writeDataset(dst%Lambda_sl,group,trim(prm%output(ou)), &
                                   'mean free path for slip','m',prm%systems_sl)
        case('tau_pass')
          call result_writeDataset(dst%tau_pass,group,trim(prm%output(ou)), &
                                   'threshold stress for slip','Pa',prm%systems_sl)
      end select

    end do

  end associate

end subroutine plastic_dislotungsten_result


!--------------------------------------------------------------------------------------------------
!> @brief Calculate shear rates on slip systems, their derivatives with respect to resolved
!         stress, and the resolved stress.
!> @details Derivatives and resolved stress are calculated only optionally.
! NOTE: Contrary to common convention, here the result (i.e. intent(out)) variables have to be put
! at the end since some of them are optional.
!--------------------------------------------------------------------------------------------------
pure subroutine kinetics(Mp,T,ph,en, &
                         dot_gamma,ddot_gamma_dtau,tau)

  real(pREAL), dimension(3,3),                           intent(in) :: &
    Mp                                                                                              !< Mandel stress
  real(pREAL),                                           intent(in) :: &
    T                                                                                               !< temperature
  integer,                                               intent(in) :: &
    ph, &
    en

  real(pREAL), dimension(param(ph)%sum_N_sl),           intent(out) :: &
    dot_gamma
  real(pREAL), dimension(param(ph)%sum_N_sl), optional, intent(out) :: &
    ddot_gamma_dtau, &
    tau

  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    StressRatio, &
    StressRatio_p,StressRatio_pminus1, &
    tau_pos, tau_neg, tau_eff, &
    t_n,t_k, dtk,dtn
  integer :: i


  associate(prm => param(ph), stt => state(ph), dst => dependentState(ph))

    tau_pos = [(math_tensordot(Mp,prm%P_nS_pos(1:3,1:3,i)),i=1,prm%sum_N_sl)]
    tau_neg = [(math_tensordot(Mp,prm%P_nS_neg(1:3,1:3,i)),i=1,prm%sum_N_sl)]
    tau_eff = math_clip(max(tau_pos,tau_neg) - dst%tau_pass(:,en),left = 0.0_pREAL)

    if (present(tau)) tau = tau_eff

    associate(BoltzmannRatio  => prm%Q_s/(K_B*T), &
              b_rho           => stt%rho_mob(:,en) * prm%b_sl, &
              effectiveLength => dst%Lambda_sl(:,en) - prm%w)


      where(tau_eff > tol_math_check)
        StressRatio = tau_eff/prm%tau_Peierls
        StressRatio_p       = StressRatio** prm%p
        StressRatio_pminus1 = StressRatio**(prm%p-1.0_pREAL)

        t_n = prm%b_sl*exp(BoltzmannRatio*(1.0_pREAL-StressRatio_p) ** prm%q) &
            / (prm%omega*effectiveLength)
        t_k = effectiveLength * prm%B /(2.0_pREAL*prm%b_sl*tau_eff)                                 ! corrected eq. (14)

        dot_gamma = b_rho * prm%h/(t_n + t_k) * merge(+1.0_pREAL,-1.0_pREAL, tau_pos>tau_neg)
      else where
        dot_gamma = 0.0_pREAL
      end where

      if (present(ddot_gamma_dtau)) then
        where(tau_eff > tol_math_check)
          dtn = -1.0_pREAL * t_n * BoltzmannRatio * prm%p * prm%q * (1.0_pREAL-StressRatio_p)**(prm%q - 1.0_pREAL) &
              * StressRatio_pminus1 / prm%tau_Peierls
          dtk = -1.0_pREAL * t_k / tau_eff

          ddot_gamma_dtau = -1.0_pREAL * dot_gamma * (dtn + dtk) / (t_n + t_k)
        else where
          ddot_gamma_dtau = 0.0_pREAL
        end where
      end if

    end associate
  end associate

end subroutine kinetics

end submodule dislotungsten

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!----------------------------------------------------------------------------------------------------
!> @brief internal microstructure state for all plasticity constitutive models
!----------------------------------------------------------------------------------------------------
submodule(phase) mechanical

  type(tTensorContainer), dimension(:), allocatable :: &
    ! current value
    phase_mechanical_Fe, &
    phase_mechanical_Fi, &
    phase_mechanical_Fp, &
    phase_mechanical_F, &
    phase_mechanical_Li, &
    phase_mechanical_Lp, &
    phase_mechanical_S, &
    phase_mechanical_P, &
    ! converged value at end of last solver increment
    phase_mechanical_Fi0, &
    phase_mechanical_Fp0, &
    phase_mechanical_F0, &
    phase_mechanical_Li0, &
    phase_mechanical_Lp0, &
    phase_mechanical_S0


  interface

    module subroutine eigen_init(phases)
      type(tDict), pointer :: phases
    end subroutine eigen_init

    module subroutine elastic_init(phases)
      type(tDict), pointer :: phases
    end subroutine elastic_init

    module subroutine plastic_init
    end subroutine plastic_init

    module subroutine phase_hooke_SandItsTangents(S,dS_dFe,dS_dFi,Fe,Fi,ph,en)
      integer, intent(in) :: &
        ph, &
        en
      real(pREAL),   intent(in),  dimension(3,3) :: &
        Fe, &                                                                                       !< elastic deformation gradient
        Fi                                                                                          !< intermediate deformation gradient
      real(pREAL),   intent(out), dimension(3,3) :: &
        S                                                                                           !< 2nd Piola-Kirchhoff stress tensor in lattice configuration
      real(pREAL),   intent(out), dimension(3,3,3,3) :: &
        dS_dFe, &                                                                                   !< derivative of 2nd P-K stress with respect to elastic deformation gradient
        dS_dFi                                                                                      !< derivative of 2nd P-K stress with respect to intermediate deformation gradient
    end subroutine phase_hooke_SandItsTangents

    module subroutine plastic_isotropic_LiAndItsTangent(Li,dLi_dMi,Mi,ph,en)
      real(pREAL), dimension(3,3),     intent(out) :: &
        Li                                                                                          !< inleastic velocity gradient
      real(pREAL), dimension(3,3,3,3), intent(out)  :: &
        dLi_dMi                                                                                     !< derivative of Li with respect to Mandel stress
      real(pREAL), dimension(3,3),     intent(in) :: &
        Mi                                                                                          !< Mandel stress
      integer,                         intent(in) :: &
        ph, &
        en
    end subroutine plastic_isotropic_LiAndItsTangent

    module function plastic_dotState(subdt,ph,en) result(dotState)
      integer, intent(in) :: &
        ph, &
        en
      real(pREAL),  intent(in) :: &
        subdt                                                                                           !< timestep
      real(pREAL), dimension(plasticState(ph)%sizeDotState) :: &
        dotState
    end function plastic_dotState

    module function plastic_deltaState(ph, en) result(status)
      integer, intent(in) :: &
        ph, &
        en
      integer(kind(STATUS_OK)) :: &
        status
    end function plastic_deltaState

    module subroutine phase_LiAndItsTangents(Li, dLi_dS, dLi_dFi, &
                                             S, Fi, ph,en)
      integer, intent(in) :: &
        ph,en
      real(pREAL),   intent(in),  dimension(3,3) :: &
        S                                                                                               !< 2nd Piola-Kirchhoff stress
      real(pREAL),   intent(in),  dimension(3,3) :: &
        Fi                                                                                              !< intermediate deformation gradient
      real(pREAL),   intent(out), dimension(3,3) :: &
        Li                                                                                              !< intermediate velocity gradient
      real(pREAL),   intent(out), dimension(3,3,3,3) :: &
        dLi_dS, &                                                                                       !< derivative of Li with respect to S
        dLi_dFi

    end subroutine phase_LiAndItsTangents


    module subroutine plastic_LpAndItsTangents(Lp, dLp_dS, dLp_dFi, &
                                               S, Fi, ph,en)
      integer, intent(in) :: &
        ph,en
      real(pREAL),   intent(in),  dimension(3,3) :: &
        S, &                                                                                            !< 2nd Piola-Kirchhoff stress
        Fi                                                                                              !< intermediate deformation gradient
      real(pREAL),   intent(out), dimension(3,3) :: &
        Lp                                                                                              !< plastic velocity gradient
      real(pREAL),   intent(out), dimension(3,3,3,3) :: &
        dLp_dS, &
        dLp_dFi                                                                                         !< derivative of Lp with respect to Fi
    end subroutine plastic_LpAndItsTangents


    module subroutine plastic_isotropic_result(ph,group)
      integer,          intent(in) :: ph
      character(len=*), intent(in) :: group
    end subroutine plastic_isotropic_result

    module subroutine plastic_phenopowerlaw_result(ph,group)
      integer,          intent(in) :: ph
      character(len=*), intent(in) :: group
    end subroutine plastic_phenopowerlaw_result

    module subroutine plastic_kinehardening_result(ph,group)
      integer,          intent(in) :: ph
      character(len=*), intent(in) :: group
    end subroutine plastic_kinehardening_result

    module subroutine plastic_dislotwin_result(ph,group)
      integer,          intent(in) :: ph
      character(len=*), intent(in) :: group
    end subroutine plastic_dislotwin_result

    module subroutine plastic_dislotungsten_result(ph,group)
      integer,          intent(in) :: ph
      character(len=*), intent(in) :: group
    end subroutine plastic_dislotungsten_result

    module subroutine plastic_nonlocal_result(ph,group)
      integer,          intent(in) :: ph
      character(len=*), intent(in) :: group
    end subroutine plastic_nonlocal_result

    module function plastic_dislotwin_homogenizedC(ph,en) result(homogenizedC)
      real(pREAL), dimension(6,6) :: homogenizedC
      integer,     intent(in) :: ph,en
    end function plastic_dislotwin_homogenizedC

    pure module function elastic_C66(ph,en) result(C66)
      real(pREAL), dimension(6,6) :: C66
      integer,     intent(in) :: ph, en
    end function elastic_C66

    pure module function elastic_mu(ph,en,isotropic_bound) result(mu)
      real(pREAL) :: mu
      integer, intent(in) :: ph, en
      character(len=*), intent(in) :: isotropic_bound
    end function elastic_mu

    pure module function elastic_nu(ph,en,isotropic_bound) result(nu)
      real(pREAL) :: nu
      integer, intent(in) :: ph, en
      character(len=*), intent(in) :: isotropic_bound
    end function elastic_nu

  end interface

  type :: tOutput                                                                                   !< requested output (per phase)
    character(len=pSTRLEN), allocatable, dimension(:) :: &
      label
  end type tOutput
  type(tOutput), allocatable, dimension(:) :: output_mechanical

  procedure(integrateStateFPI), pointer :: integrateState

contains


!--------------------------------------------------------------------------------------------------
!> @brief Initialize mechanical field related constitutive models
!> @details Initialize elasticity, plasticity and stiffness degradation models.
!--------------------------------------------------------------------------------------------------
module subroutine mechanical_init(phases, num_mech)

  type(tDict), pointer :: &
    phases, &
    num_mech

  integer :: &
    ce, &
    co, &
    ma, &
    ph, &
    en, &
    Nmembers
  type(tDict), pointer :: &
    phase, &
    mech, &
    num_mech_plastic, &
    num_mech_eigen
  character(len=:), allocatable :: extmsg


  print'(/,1x,a)', '<<<+-  phase:mechanical init  -+>>>'

!-------------------------------------------------------------------------------------------------
  allocate(output_mechanical(size(phases)))

  allocate(phase_mechanical_Fe(size(phases)))
  allocate(phase_mechanical_Fi(size(phases)))
  allocate(phase_mechanical_Fi0(size(phases)))
  allocate(phase_mechanical_Fp(size(phases)))
  allocate(phase_mechanical_Fp0(size(phases)))
  allocate(phase_mechanical_F(size(phases)))
  allocate(phase_mechanical_F0(size(phases)))
  allocate(phase_mechanical_Li(size(phases)))
  allocate(phase_mechanical_Li0(size(phases)))
  allocate(phase_mechanical_Lp(size(phases)))
  allocate(phase_mechanical_Lp0(size(phases)))
  allocate(phase_mechanical_S(size(phases)))
  allocate(phase_mechanical_P(size(phases)))
  allocate(phase_mechanical_S0(size(phases)))

  do ph = 1, size(phases)
    Nmembers = count(material_ID_phase == ph)

    allocate(phase_mechanical_Fe(ph)%data(3,3,Nmembers))
    allocate(phase_mechanical_Fi(ph)%data(3,3,Nmembers))
    allocate(phase_mechanical_Fp(ph)%data(3,3,Nmembers))
    allocate(phase_mechanical_F(ph)%data(3,3,Nmembers))
    allocate(phase_mechanical_Li(ph)%data(3,3,Nmembers),source=0.0_pREAL)
    allocate(phase_mechanical_Li0(ph)%data(3,3,Nmembers),source=0.0_pREAL)
    allocate(phase_mechanical_Lp(ph)%data(3,3,Nmembers),source=0.0_pREAL)
    allocate(phase_mechanical_Lp0(ph)%data(3,3,Nmembers),source=0.0_pREAL)
    allocate(phase_mechanical_S(ph)%data(3,3,Nmembers),source=0.0_pREAL)
    allocate(phase_mechanical_P(ph)%data(3,3,Nmembers),source=0.0_pREAL)
    allocate(phase_mechanical_S0(ph)%data(3,3,Nmembers),source=0.0_pREAL)

    phase => phases%get_dict(ph)
    mech  => phase%get_dict('mechanical')
#if defined(__GFORTRAN__)
    output_mechanical(ph)%label = output_as1dStr(mech)
#else
    output_mechanical(ph)%label = mech%get_as1dStr('output',defaultVal=emptyStrArray)
#endif
  end do

  do ce = 1, size(material_ID_phase,2)
    ma = discretization_materialAt((ce-1)/discretization_nIPs+1)
    do co = 1,homogenization_Nconstituents(material_ID_homogenization(ce))
      ph = material_ID_phase(co,ce)
      en = material_entry_phase(co,ce)
      phase_mechanical_F(ph)%data(1:3,1:3,en)  = math_I3
      phase_mechanical_Fp(ph)%data(1:3,1:3,en) = material_O_0(ma)%data(co)%asMatrix()              ! Fp reflects initial orientation (see 10.1016/j.actamat.2006.01.005)
      phase_mechanical_Fe(ph)%data(1:3,1:3,en) = matmul(material_V_e_0(ma)%data(1:3,1:3,co), &
                                                        transpose(phase_mechanical_Fp(ph)%data(1:3,1:3,en)))
      phase_mechanical_Fi(ph)%data(1:3,1:3,en) = material_O_0(ma)%data(co)%rotate(math_inv33(material_V_e_0(ma)%data(1:3,1:3,co)))
    end do
  end do

  do ph = 1, size(phases)
    phase_mechanical_F0(ph)%data  = phase_mechanical_F(ph)%data
    phase_mechanical_Fp0(ph)%data = phase_mechanical_Fp(ph)%data
    phase_mechanical_Fi0(ph)%data = phase_mechanical_Fi(ph)%data
  end do


  call elastic_init(phases)
  allocate(plasticState(size(phases)))
  allocate(mechanical_plasticity_type(size(phases)),source = UNDEFINED)
  call plastic_init()
  do ph = 1,size(phases)
    plasticState(ph)%state0 = plasticState(ph)%state
  end do
  call eigen_init(phases)

  num_mech_plastic => num_mech%get_dict('plastic', defaultVal=emptyDict)
  num_mech_eigen   => num_mech%get_dict('eigen',   defaultVal=emptyDict)

  num%stepMinCryst           = num_mech%get_asReal         ('r_cutback_min',      defaultVal=1.0e-3_pREAL)
  num%stepSizeCryst          = num_mech%get_asReal         ('r_cutback',          defaultVal=0.25_pREAL)
  num%stepIncreaseCryst      = num_mech%get_asReal         ('r_increase',         defaultVal=1.5_pREAL)
  num%rtol_crystalliteState  = num_mech%get_asReal         ('eps_rel_state',      defaultVal=1.0e-6_pREAL)
  num%nState                 = num_mech%get_asInt          ('N_iter_state_max',   defaultVal=20)
  num%nStress_Lp             = num_mech_plastic%get_asInt  ('N_iter_Lp_max',      defaultVal=40)
  num%stepSizeLp             = num_mech_plastic%get_asReal ('r_linesearch_Lp',    defaultVal=0.5_pREAL)
  num%rtol_Lp                = num_mech_plastic%get_asReal ('eps_rel_Lp',         defaultVal=1.0e-6_pREAL)
  num%atol_Lp                = num_mech_plastic%get_asReal ('eps_abs_Lp',         defaultVal=1.0e-8_pREAL)
  num%iJacoLpresiduum        = num_mech_plastic%get_asInt  ('f_update_jacobi_Lp', defaultVal=1)
  num%nStress_Li             = num_mech_eigen%get_asInt    ('N_iter_Li_max',      defaultVal=40)
  num%stepSizeLi             = num_mech_eigen%get_asReal   ('r_linesearch_Li',    defaultVal=0.5_pREAL)
  num%rtol_Li                = num_mech_eigen%get_asReal   ('eps_rel_Li',         defaultVal=num%rtol_Lp)
  num%atol_Li                = num_mech_eigen%get_asReal   ('eps_abs_Li',         defaultVal=num%atol_Lp)
  num%iJacoLiresiduum        = num_mech_eigen%get_asInt    ('f_update_jacobi_Li', defaultVal=num%iJacoLpresiduum)

  extmsg = ''
  if (num%stepMinCryst   <= 0.0_pREAL)     extmsg = trim(extmsg)//' r_cutback_min'
  if (num%stepSizeCryst  <= 0.0_pREAL)     extmsg = trim(extmsg)//' r_cutback'
  if (num%stepIncreaseCryst <= 0.0_pREAL)  extmsg = trim(extmsg)//' r_increase'
  if (num%stepSizeLp <= 0.0_pREAL)         extmsg = trim(extmsg)//' r_linesearch_Lp'
  if (num%stepSizeLi <= 0.0_pREAL)         extmsg = trim(extmsg)//' r_linesearch_Li'
  if (num%rtol_Lp <= 0.0_pREAL)            extmsg = trim(extmsg)//' epl_rel_Lp'
  if (num%atol_Lp <= 0.0_pREAL)            extmsg = trim(extmsg)//' eps_abs_Lp'
  if (num%rtol_Li <= 0.0_pREAL)            extmsg = trim(extmsg)//' eps_rel_Li'
  if (num%atol_Li <= 0.0_pREAL)            extmsg = trim(extmsg)//' eps_abs_Li'
  if (num%iJacoLpresiduum < 1)             extmsg = trim(extmsg)//' f_update_jacobi_Lp'
  if (num%iJacoLiresiduum < 1)             extmsg = trim(extmsg)//' f_update_jacobi_Li'
  if (num%nState  < 1)                     extmsg = trim(extmsg)//' N_iter_state_max'
  if (num%nStress_Lp < 1)                  extmsg = trim(extmsg)//' N_iter_Lp_max'
  if (num%nStress_Li < 1)                  extmsg = trim(extmsg)//' N_iter_Li_max'

  if (extmsg /= '') call IO_error(301,ext_msg=trim(extmsg))

  select case(num_mech_plastic%get_asStr('integrator_state',defaultVal='FPI'))

    case('FPI')
      integrateState => integrateStateFPI

    case('Euler')
      integrateState => integrateStateEuler

    case('Euler_adaptive')
      integrateState => integrateStateEulerAdaptive

    case('RK4')
      integrateState => integrateStateRK4

    case('RKCK45')
      integrateState => integrateStateRKCK45

    case default
     call IO_error(301,ext_msg='integrator')

  end select


end subroutine mechanical_init


module subroutine mechanical_result(group,ph)

  character(len=*), intent(in) :: group
  integer,          intent(in) :: ph


  call results(group,ph)

  select case(mechanical_plasticity_type(ph))

    case(MECHANICAL_PLASTICITY_ISOTROPIC)
      call plastic_isotropic_result(ph,group//'mechanical/')

    case(MECHANICAL_PLASTICITY_PHENOPOWERLAW)
      call plastic_phenopowerlaw_result(ph,group//'mechanical/')

    case(MECHANICAL_PLASTICITY_KINEHARDENING)
      call plastic_kinehardening_result(ph,group//'mechanical/')

    case(MECHANICAL_PLASTICITY_DISLOTWIN)
      call plastic_dislotwin_result(ph,group//'mechanical/')

    case(MECHANICAL_PLASTICITY_DISLOTUNGSTEN)
      call plastic_dislotungsten_result(ph,group//'mechanical/')

    case(MECHANICAL_PLASTICITY_NONLOCAL)
      call plastic_nonlocal_result(ph,group//'mechanical/')

  end select


end subroutine mechanical_result


!--------------------------------------------------------------------------------------------------
!> @brief calculation of stress (P) with time integration based on a residuum in Lp and
!> intermediate acceleration of the Newton-Raphson correction
!--------------------------------------------------------------------------------------------------
function integrateStress(F,Fp0,Fi0,Delta_t,ph,en) result(status)

  real(pREAL), dimension(3,3), intent(in) :: F,Fp0,Fi0
  real(pREAL),                 intent(in) :: Delta_t
  integer, intent(in) :: ph, en
  integer(kind(STATUS_OK)) :: status

  real(pREAL), dimension(3,3)::       Fp_new, &                                                     ! plastic deformation gradient at end of timestep
                                      invFp_new, &                                                  ! inverse of Fp_new
                                      invFp_current, &                                              ! inverse of Fp_current
                                      Lpguess, &                                                    ! current guess for plastic velocity gradient
                                      Lpguess_old, &                                                ! known last good guess for plastic velocity gradient
                                      Lp_constitutive, &                                            ! plastic velocity gradient resulting from constitutive law
                                      residuumLp, &                                                 ! current residuum of plastic velocity gradient
                                      deltaLp, &                                                    ! direction of next guess
                                      Fi_new, &                                                     ! gradient of intermediate deformation stages
                                      invFi_new, &
                                      invFi_current, &                                              ! inverse of Fi_current
                                      Liguess, &                                                    ! current guess for intermediate velocity gradient
                                      Liguess_old, &                                                ! known last good guess for intermediate velocity gradient
                                      Li_constitutive, &                                            ! intermediate velocity gradient resulting from constitutive law
                                      residuumLi, &                                                 ! current residuum of intermediate velocity gradient
                                      deltaLi, &                                                    ! direction of next guess
                                      Fe, &                                                         ! elastic deformation gradient
                                      S, &                                                          ! 2nd Piola-Kirchhoff Stress in plastic (lattice) configuration
                                      A, &
                                      B, &
                                      temp_33
  real(pREAL), dimension(9) ::        temp_9                                                        ! needed for matrix inversion by LAPACK
  integer,     dimension(9) ::        devNull_9                                                     ! needed for matrix inversion by LAPACK
  real(pREAL), dimension(9,9) ::      dRLp_dLp, &                                                   ! partial derivative of residuum (Jacobian for Newton-Raphson scheme)
                                      dRLi_dLi                                                      ! partial derivative of residuumI (Jacobian for Newton-Raphson scheme)
  real(pREAL), dimension(3,3,3,3)::   dS_dFe, &                                                     ! partial derivative of 2nd Piola-Kirchhoff stress
                                      dS_dFi, &
                                      dFe_dLp, &                                                    ! partial derivative of elastic deformation gradient
                                      dFe_dLi, &
                                      dFi_dLi, &
                                      dLp_dFi, &
                                      dLi_dFi, &
                                      dLp_dS, &
                                      dLi_dS
  real(pREAL)                         steplengthLp, &
                                      steplengthLi, &
                                      residuumLi_old_norm, &                                        ! last residuum of intermediate velocity gradient
                                      residuumLp_old_norm, &                                        ! last residuum of plastic velocity gradient
                                      atol_Lp, &
                                      atol_Li
  integer                             NiterationStressLp, &                                         ! number of stress integrations
                                      NiterationStressLi, &                                         ! number of inner stress integrations
                                      ierr, &                                                       ! error indicator for LAPACK
                                      o, &
                                      p, &
                                      jacoCounterLp, &
                                      jacoCounterLi                                                 ! counters to check for Jacobian update
  logical :: error


  status = STATUS_FAIL_PHASE_MECHANICAL_STRESS
  call plastic_dependentState(ph,en)

  Lpguess = phase_mechanical_Lp(ph)%data(1:3,1:3,en)                                                ! take as first guess
  Liguess = phase_mechanical_Li(ph)%data(1:3,1:3,en)                                                ! take as first guess

  call math_invert33(invFp_current,error=error,A=Fp0)
  if (error) return ! error
  call math_invert33(invFi_current,error=error,A=Fi0)
  if (error) return ! error

  A = matmul(F,invFp_current)                                                                       ! intermediate tensor needed later to calculate dFe_dLp

  jacoCounterLi = 0
  steplengthLi  = 1.0_pREAL
  Liguess_old   = Liguess
  residuumLi_old_norm = huge(1.0_pREAL)

  NiterationStressLi = 0
  LiLoop: do
    NiterationStressLi = NiterationStressLi + 1
    if (NiterationStressLi>num%nStress_Li) return ! error

    invFi_new = matmul(invFi_current,math_I3 - Delta_t*Liguess)
    Fi_new    = math_inv33(invFi_new)

    jacoCounterLp = 0
    steplengthLp  = 1.0_pREAL
    Lpguess_old   = Lpguess
    residuumLp_old_norm = huge(1.0_pREAL)

    NiterationStressLp = 0
    LpLoop: do
      NiterationStressLp = NiterationStressLp + 1
      if (NiterationStressLp>num%nStress_Lp) then
        status = STATUS_FAIL_PHASE_MECHANICAL_STRESS_LP_MAXIT
        return
      endif
      B  = math_I3 - Delta_t*Lpguess
      Fe = matmul(matmul(A,B), invFi_new)
      call phase_hooke_SandItsTangents(S, dS_dFe, dS_dFi, &
                                       Fe, Fi_new, ph, en)

      call plastic_LpAndItsTangents(Lp_constitutive, dLp_dS, dLp_dFi, &
                                    S, Fi_new, ph,en)

      !* update current residuum and check for convergence of loop
      atol_Lp = max(num%rtol_Lp * max(norm2(Lpguess),norm2(Lp_constitutive)), &                     ! absolute tolerance from largest acceptable relative error
                    num%atol_Lp)                                                                    ! minimum lower cutoff
      residuumLp = Lpguess - Lp_constitutive

      if (any(IEEE_is_NaN(residuumLp))) then
        status = STATUS_FAIL_PHASE_MECHANICAL_STRESS_LP_NAN
        return
      elseif (norm2(residuumLp) < atol_Lp) then                                                     ! converged if below absolute tolerance
        exit LpLoop
      elseif (norm2(residuumLp) < residuumLp_old_norm) then                                         ! not converged, but improved norm of residuum...
        residuumLp_old_norm = norm2(residuumLp)                                                     ! ...remember old values and...
        Lpguess_old = Lpguess
        steplengthLp = 1.0_pREAL                                                                    ! ...proceed with normal step length (calculate new search direction)
      else                                                                                          ! not converged and residuum not improved...
        steplengthLp = num%stepSizeLp * steplengthLp                                                ! ...try with smaller step length in same direction
        Lpguess      = Lpguess_old &
                     + deltaLp * stepLengthLp
        cycle LpLoop
      end if

      calculateJacobiLp: if (mod(jacoCounterLp, num%iJacoLpresiduum) == 0) then
        jacoCounterLp = jacoCounterLp + 1

        do o=1,3; do p=1,3
          dFe_dLp(o,1:3,p,1:3) = - Delta_t * A(o,p)*transpose(invFi_new)                            ! dFe_dLp(i,j,k,l) = -Delta_t * A(i,k) invFi(l,j)
        end do; end do
        dRLp_dLp = math_eye(9) &
                 - math_3333to99(math_mul3333xx3333(math_mul3333xx3333(dLp_dS,dS_dFe),dFe_dLp))
        temp_9 = math_33to9(residuumLp)
        call dgesv(9,1,dRLp_dLp,9,devNull_9,temp_9,9,ierr)                                          ! solve dRLp/dLp * delta Lp = -res for delta Lp
        if (ierr /= 0) then
          status = STATUS_FAIL_PHASE_MECHANICAL_STRESS_LP_DGESV
          return
        end if
        deltaLp = - math_9to33(temp_9)
      end if calculateJacobiLp

      Lpguess = Lpguess &
              + deltaLp * steplengthLp
    end do LpLoop

    call phase_LiAndItsTangents(Li_constitutive, dLi_dS, dLi_dFi, &
                                S, Fi_new, ph,en)

    !* update current residuum and check for convergence of loop
    atol_Li = max(num%rtol_Li * max(norm2(Liguess),norm2(Li_constitutive)), &                       ! absolute tolerance from largest acceptable relative error
                  num%atol_Li)                                                                      ! minimum lower cutoff
    residuumLi = Liguess - Li_constitutive
    if (any(IEEE_is_NaN(residuumLi))) then
      return ! error
    elseif (norm2(residuumLi) < atol_Li) then                                                       ! converged if below absolute tolerance
      exit LiLoop
    elseif (norm2(residuumLi) < residuumLi_old_norm) then                                           ! not converged, but improved norm of residuum ...
      residuumLi_old_norm = norm2(residuumLi)                                                       ! ...remember old values and...
      Liguess_old = Liguess
      steplengthLi = 1.0_pREAL                                                                      ! ...proceed with normal step length (calculate new search direction)
    else                                                                                            ! not converged and residuum not improved...
      steplengthLi = num%stepSizeLi * steplengthLi                                                  ! ...try with smaller step length in same direction
      Liguess      = Liguess_old &
                   + deltaLi * steplengthLi
      cycle LiLoop
    end if

    calculateJacobiLi: if (mod(jacoCounterLi, num%iJacoLiresiduum) == 0) then
      jacoCounterLi = jacoCounterLi + 1

      temp_33 = matmul(matmul(A,B),invFi_current)
      do o=1,3; do p=1,3
        dFe_dLi(1:3,o,1:3,p) = -Delta_t*math_I3(o,p)*temp_33                                        ! dFe_dLp(i,j,k,l) = -Delta_t * A(i,k) invFi(l,j)
        dFi_dLi(1:3,o,1:3,p) = -Delta_t*math_I3(o,p)*invFi_current
      end do; end do
      do o=1,3; do p=1,3
        dFi_dLi(1:3,1:3,o,p) = matmul(matmul(Fi_new,dFi_dLi(1:3,1:3,o,p)),Fi_new)
      end do; end do
      dRLi_dLi  = math_eye(9) &
                - math_3333to99(math_mul3333xx3333(dLi_dS,  math_mul3333xx3333(dS_dFe, dFe_dLi) &
                                                          + math_mul3333xx3333(dS_dFi, dFi_dLi)))  &
                - math_3333to99(math_mul3333xx3333(dLi_dFi, dFi_dLi))
      temp_9 = math_33to9(residuumLi)
      call dgesv(9,1,dRLi_dLi,9,devNull_9,temp_9,9,ierr)                                            ! solve dRLi/dLp * delta Li = -res for delta Li
      if (ierr /= 0) return ! error
      deltaLi = - math_9to33(temp_9)
    end if calculateJacobiLi

    Liguess = Liguess &
            + deltaLi * steplengthLi
  end do LiLoop

  invFp_new = matmul(invFp_current,B)
  call math_invert33(Fp_new,error=error,A=invFp_new)
  if (error) return ! error

  phase_mechanical_P(ph)%data(1:3,1:3,en)  = matmul(matmul(F,invFp_new),matmul(S,transpose(invFp_new)))
  phase_mechanical_S(ph)%data(1:3,1:3,en)  = S
  phase_mechanical_Lp(ph)%data(1:3,1:3,en) = Lpguess
  phase_mechanical_Li(ph)%data(1:3,1:3,en) = Liguess
  phase_mechanical_Fp(ph)%data(1:3,1:3,en) = Fp_new / math_det33(Fp_new)**(1.0_pREAL/3.0_pREAL)    ! regularize
  phase_mechanical_Fi(ph)%data(1:3,1:3,en) = Fi_new
  phase_mechanical_Fe(ph)%data(1:3,1:3,en) = matmul(matmul(F,invFp_new),invFi_new)
  status = STATUS_OK

end function integrateStress


!--------------------------------------------------------------------------------------------------
!> @brief integrate stress, state with adaptive 1st order explicit Euler method
!> using Fixed Point Iteration to adapt the stepsize
!--------------------------------------------------------------------------------------------------
function integrateStateFPI(F_0,F,Fp0,Fi0,state0,Delta_t,ph,en) result(status)

  real(pREAL), intent(in),dimension(3,3) :: F_0,F,Fp0,Fi0
  real(pREAL), intent(in),dimension(:)   :: state0
  real(pREAL), intent(in) :: Delta_t
  integer, intent(in) :: &
    ph, &
    en
  integer(kind(STATUS_OK)) :: status

  integer :: &
    NiterationState, &                                                                              !< number of iterations in state loop
    sizeDotState
  real(pREAL) :: &
    zeta
  real(pREAL), dimension(plasticState(ph)%sizeDotState) :: &
    r, &                                                                                            ! state residuum
    dotState
  real(pREAL), dimension(plasticState(ph)%sizeDotState,2) :: &
    dotState_last


  status = STATUS_FAIL_PHASE_MECHANICAL_STATE

  dotState = plastic_dotState(Delta_t,ph,en)
  if (any(IEEE_is_NaN(dotState))) return

  sizeDotState = plasticState(ph)%sizeDotState
  plasticState(ph)%state(1:sizeDotState,en) = state0 + dotState * Delta_t

  iteration: do NiterationState = 1, num%nState

    dotState_last(1:sizeDotState,2) = merge(dotState_last(1:sizeDotState,1),0.0_pREAL, nIterationState > 1)
    dotState_last(1:sizeDotState,1) = dotState

    status = integrateStress(F,Fp0,Fi0,Delta_t,ph,en)
    if (status /= STATUS_OK) exit iteration

    dotState = plastic_dotState(Delta_t,ph,en)
    if (any(IEEE_is_NaN(dotState))) exit iteration

    zeta = damper(dotState,dotState_last(1:sizeDotState,1),dotState_last(1:sizeDotState,2))
    dotState = dotState * zeta &
             + dotState_last(1:sizeDotState,1) * (1.0_pREAL - zeta)
    r = plasticState(ph)%state(1:sizeDotState,en) &
      - state0 &
      - dotState * Delta_t
    plasticState(ph)%state(1:sizeDotState,en) = plasticState(ph)%state(1:sizeDotState,en) - r

    if (converged(r,plasticState(ph)%state(1:sizeDotState,en),plasticState(ph)%atol(1:sizeDotState))) then
      status = plastic_deltaState(ph,en)
      exit iteration
    end if

  end do iteration


  contains

  !--------------------------------------------------------------------------------------------------
  !> @brief calculate the damping for correction of state and dot state
  !--------------------------------------------------------------------------------------------------
  real(pREAL) pure function damper(omega_0,omega_1,omega_2)
#ifndef __GFORTRAN__
    use prec
    import, none
#endif

    real(pREAL), dimension(:), intent(in) :: &
      omega_0, omega_1, omega_2

    real(pREAL) :: dot_prod12, dot_prod22


    dot_prod12 = dot_product(omega_0-omega_1, omega_1-omega_2)
    dot_prod22 = dot_product(omega_1-omega_2, omega_1-omega_2)

    if (min(dot_product(omega_0,omega_1),dot_prod12) < 0.0_pREAL .and. dot_prod22 > 0.0_pREAL) then
      damper = 0.75_pREAL + 0.25_pREAL * tanh(2.0_pREAL + 4.0_pREAL * dot_prod12 / dot_prod22)
    else
      damper = 1.0_pREAL
    end if

  end function damper

end function integrateStateFPI


!--------------------------------------------------------------------------------------------------
!> @brief integrate state with 1st order explicit Euler method
!--------------------------------------------------------------------------------------------------
function integrateStateEuler(F_0,F,Fp0,Fi0,state0,Delta_t,ph,en) result(status)

  real(pREAL), intent(in),dimension(3,3) :: F_0,F,Fp0,Fi0
  real(pREAL), intent(in),dimension(:)   :: state0
  real(pREAL), intent(in) :: Delta_t
  integer, intent(in) :: &
    ph, &
    en                                                                                               !< grain index in grain loop
  integer(kind(STATUS_OK)) :: &
    status

  real(pREAL), dimension(plasticState(ph)%sizeDotState) :: &
    dotState
  integer :: &
    sizeDotState


  status = STATUS_FAIL_PHASE_MECHANICAL_STATE

  dotState = plastic_dotState(Delta_t,ph,en)
  if (any(IEEE_is_NaN(dotState))) return

  sizeDotState = plasticState(ph)%sizeDotState
  plasticState(ph)%state(1:sizeDotState,en) = state0 + dotState*Delta_t

  status = plastic_deltaState(ph,en)
  if (status /= STATUS_OK) return

  status = integrateStress(F,Fp0,Fi0,Delta_t,ph,en)

end function integrateStateEuler


!--------------------------------------------------------------------------------------------------
!> @brief integrate stress, state with 1st order Euler method with adaptive step size
!--------------------------------------------------------------------------------------------------
function integrateStateEulerAdaptive(F_0,F,Fp0,Fi0,state0,Delta_t,ph,en) result(status)

  real(pREAL), intent(in),dimension(3,3) :: F_0,F,Fp0,Fi0
  real(pREAL), intent(in),dimension(:)   :: state0
  real(pREAL), intent(in) :: Delta_t
  integer, intent(in) :: &
    ph, &
    en
  integer(kind(STATUS_OK)) :: &
    status

  integer :: &
    sizeDotState
  real(pREAL), dimension(plasticState(ph)%sizeDotState) :: &
    r, &
    dotState


  status = STATUS_FAIL_PHASE_MECHANICAL_STATE

  dotState = plastic_dotState(Delta_t,ph,en)
  if (any(IEEE_is_NaN(dotState))) return

  sizeDotState = plasticState(ph)%sizeDotState

  r = - dotState * 0.5_pREAL * Delta_t
  plasticState(ph)%state(1:sizeDotState,en) = state0 + dotState*Delta_t

  status = plastic_deltaState(ph,en)
  if (status /= STATUS_OK) return

  status = integrateStress(F,Fp0,Fi0,Delta_t,ph,en)
  if (status /= STATUS_OK) return

  dotState = plastic_dotState(Delta_t,ph,en)
  ! ToDo: MD: need to set status to failed
  if (any(IEEE_is_NaN(dotState))) return

  status = merge(STATUS_OK, &
                 STATUS_FAIL_PHASE_MECHANICAL_STATE, &
                 converged(r + 0.5_pREAL * dotState * Delta_t, &
                           plasticState(ph)%state(1:sizeDotState,en), &
                           plasticState(ph)%atol(1:sizeDotState)))

end function integrateStateEulerAdaptive


!---------------------------------------------------------------------------------------------------
!> @brief Integrate state (including stress integration) with the classic Runge Kutta method
!---------------------------------------------------------------------------------------------------
function integrateStateRK4(F_0,F,Fp0,Fi0,state0,Delta_t,ph,en) result(status)

  real(pREAL), intent(in),dimension(3,3) :: F_0,F,Fp0,Fi0
  real(pREAL), intent(in),dimension(:)   :: state0
  real(pREAL), intent(in) :: Delta_t
  integer, intent(in) :: ph, en
  integer(kind(STATUS_OK)) :: status

  real(pREAL), dimension(3,3), parameter :: &
    A = reshape([&
      0.5_pREAL, 0.0_pREAL, 0.0_pREAL, &
      0.0_pREAL, 0.5_pREAL, 0.0_pREAL, &
      0.0_pREAL, 0.0_pREAL, 1.0_pREAL],&
      shape(A))
  real(pREAL), dimension(3), parameter :: &
    C = [0.5_pREAL, 0.5_pREAL, 1.0_pREAL]
  real(pREAL), dimension(4), parameter :: &
    B = [6.0_pREAL, 3.0_pREAL, 3.0_pREAL, 6.0_pREAL]**(-1)


  status = integrateStateRK(F_0,F,Fp0,Fi0,state0,Delta_t,ph,en,A,B,C)

end function integrateStateRK4


!---------------------------------------------------------------------------------------------------
!> @brief Integrate state (including stress integration) with the Cash-Carp method
!---------------------------------------------------------------------------------------------------
function integrateStateRKCK45(F_0,F,Fp0,Fi0,state0,Delta_t,ph,en) result(status)

  real(pREAL), intent(in),dimension(3,3) :: F_0,F,Fp0,Fi0
  real(pREAL), intent(in),dimension(:)   :: state0
  real(pREAL), intent(in) :: Delta_t
  integer, intent(in) :: ph, en
  integer(kind(STATUS_OK)) :: status

  real(pREAL), dimension(5,5), parameter :: &
    A = reshape([&
      1._pREAL/5._pREAL,       .0_pREAL,             .0_pREAL,               .0_pREAL,                  .0_pREAL, &
      3._pREAL/40._pREAL,      9._pREAL/40._pREAL,   .0_pREAL,               .0_pREAL,                  .0_pREAL, &
      3_pREAL/10._pREAL,       -9._pREAL/10._pREAL,  6._pREAL/5._pREAL,      .0_pREAL,                  .0_pREAL, &
      -11._pREAL/54._pREAL,    5._pREAL/2._pREAL,    -70.0_pREAL/27.0_pREAL, 35.0_pREAL/27.0_pREAL,     .0_pREAL, &
      1631._pREAL/55296._pREAL,175._pREAL/512._pREAL,575._pREAL/13824._pREAL,44275._pREAL/110592._pREAL,253._pREAL/4096._pREAL],&
      shape(A))
  real(pREAL), dimension(5), parameter :: &
    C = [0.2_pREAL, 0.3_pREAL, 0.6_pREAL, 1.0_pREAL, 0.875_pREAL]
  real(pREAL), dimension(6), parameter :: &
    B = &
      [37.0_pREAL/378.0_pREAL, .0_pREAL, 250.0_pREAL/621.0_pREAL, &
      125.0_pREAL/594.0_pREAL, .0_pREAL, 512.0_pREAL/1771.0_pREAL], &
    DB = B - &
      [2825.0_pREAL/27648.0_pREAL,    .0_pREAL,                18575.0_pREAL/48384.0_pREAL,&
      13525.0_pREAL/55296.0_pREAL, 277.0_pREAL/14336.0_pREAL,  1._pREAL/4._pREAL]


  status = integrateStateRK(F_0,F,Fp0,Fi0,state0,Delta_t,ph,en,A,B,C,DB)

end function integrateStateRKCK45


!--------------------------------------------------------------------------------------------------
!> @brief Integrate state (including stress integration) with an explicit Runge-Kutta method or an
!! embedded explicit Runge-Kutta method
!--------------------------------------------------------------------------------------------------
function integrateStateRK(F_0,F,Fp0,Fi0,state0,Delta_t,ph,en,A,B,C,DB) result(status)

  real(pREAL), intent(in),dimension(3,3) :: F_0,F,Fp0,Fi0
  real(pREAL), intent(in),dimension(:)   :: state0
  real(pREAL), intent(in) :: Delta_t
  real(pREAL), dimension(:,:), intent(in) :: A
  real(pREAL), dimension(:),   intent(in) :: B, C
  real(pREAL), dimension(:),   intent(in), optional :: DB
  integer, intent(in) :: &
    ph, &
    en
  integer(kind(STATUS_OK)) :: status

  integer :: &
    stage, &                                                                                        ! stage index in integration stage loop
    n, &
    sizeDotState
  real(pREAL), dimension(plasticState(ph)%sizeDotState) :: &
    dotState
  real(pREAL), dimension(plasticState(ph)%sizeDotState,size(B)) :: &
    plastic_RKdotState


  status = STATUS_FAIL_PHASE_MECHANICAL_STATE
  sizeDotState = plasticState(ph)%sizeDotState

  dotState = plastic_dotState(Delta_t,ph,en)                                                        !MD: Delta_t is only used for nonlocal
  if (any(IEEE_is_NaN(dotState))) return

  do stage = 1, size(A,1)

    plastic_RKdotState(1:sizeDotState,stage) = dotState

    dotState = A(1,stage) * plastic_RKdotState(1:sizeDotState,1)
    do n = 2, stage
      dotState = dotState &
               + A(n,stage)*plastic_RKdotState(1:sizeDotState,n)
    end do

    plasticState(ph)%state(1:sizeDotState,en) = state0 &
                                              + dotState*Delta_t

    status = integrateStress(F_0+(F-F_0)*C(stage),Fp0,Fi0,Delta_t*C(stage), ph,en)
    if (status /= STATUS_OK) return

    dotState = plastic_dotState(Delta_t*C(stage), ph,en)                                            !MD: Delta_t is only used for nonlocal and it's unclear whether scaling by C makes sense
    ! ToDo: MD: need to set status to failed
    if (any(IEEE_is_NaN(dotState))) exit

  end do
  if (status /= STATUS_OK) return


  plastic_RKdotState(1:sizeDotState,size(B)) = dotState
  plasticState(ph)%state(1:sizeDotState,en) = state0 &
                                            + matmul(plastic_RKdotState,B)*Delta_t

  if (present(DB)) &
    status = merge(STATUS_OK, &
                   STATUS_FAIL_PHASE_MECHANICAL_STATE, &
                   converged(matmul(plastic_RKdotState(1:sizeDotState,1:size(DB)),DB) * Delta_t, &
                             plasticState(ph)%state(1:sizeDotState,en), &
                             plasticState(ph)%atol(1:sizeDotState)))

  if (status /= STATUS_OK) return

  status = plastic_deltaState(ph,en)
  if (status /= STATUS_OK) return

  status = integrateStress(F,Fp0,Fi0,Delta_t,ph,en)

end function integrateStateRK


!--------------------------------------------------------------------------------------------------
!> @brief Write mechanical results to HDF5 output file.
!--------------------------------------------------------------------------------------------------
subroutine results(group,ph)

  character(len=*), intent(in) :: group
  integer,          intent(in) :: ph

  integer :: ou


  call result_closeGroup(result_addGroup(group//'/mechanical'))

  do ou = 1, size(output_mechanical(ph)%label)

    select case (output_mechanical(ph)%label(ou))
      case('F')
        call result_writeDataset(phase_mechanical_F(ph)%data,group//'/mechanical/','F',&
                                 'deformation gradient','1')
      case('F_e')
        call result_writeDataset(phase_mechanical_Fe(ph)%data,group//'/mechanical/','F_e',&
                                 'elastic deformation gradient','1')
      case('F_p')
        call result_writeDataset(phase_mechanical_Fp(ph)%data,group//'/mechanical/','F_p', &
                                 'plastic deformation gradient','1')
      case('F_i')
        call result_writeDataset(phase_mechanical_Fi(ph)%data,group//'/mechanical/','F_i', &
                                 'inelastic deformation gradient','1')
      case('L_p')
        call result_writeDataset(phase_mechanical_Lp(ph)%data,group//'/mechanical/','L_p', &
                                 'plastic velocity gradient','1/s')
      case('L_i')
        call result_writeDataset(phase_mechanical_Li(ph)%data,group//'/mechanical/','L_i', &
                                 'inelastic velocity gradient','1/s')
      case('P')
        call result_writeDataset(phase_mechanical_P(ph)%data,group//'/mechanical/','P', &
                                 'first Piola-Kirchhoff stress','Pa')
      case('S')
        call result_writeDataset(phase_mechanical_S(ph)%data,group//'/mechanical/','S', &
                                 'second Piola-Kirchhoff stress','Pa')
      case('O')
        call result_writeDataset(to_quaternion(phase_O(ph)%data),group//'/mechanical','O', &
                                 'crystal orientation as quaternion q_0 (q_1 q_2 q_3)','1')
        call result_addAttribute('lattice',phase_lattice(ph),group//'/mechanical/O')
        if (any(phase_lattice(ph) == ['hP', 'tI'])) &
          call result_addAttribute('c/a',phase_cOverA(ph),group//'/mechanical/O')
    end select
  end do


  contains

!--------------------------------------------------------------------------------------------------
!> @brief Convert orientation array to quaternion array.
!--------------------------------------------------------------------------------------------------
  function to_quaternion(dataset)
#ifndef __GFORTRAN__
    use prec
    use rotations
    import, none
#endif

    type(tRotation), dimension(:), intent(in) :: dataset
    real(pREAL), dimension(4,size(dataset,1)) :: to_quaternion

    integer :: i


    do i = 1, size(dataset,1)
      to_quaternion(:,i) = dataset(i)%asQuaternion()
    end do

 end function to_quaternion

end subroutine results


!--------------------------------------------------------------------------------------------------
!> @brief Forward data after successful increment.
! ToDo: Any guessing for the current states possible?
!--------------------------------------------------------------------------------------------------
module subroutine mechanical_forward()

  integer :: ph


  do ph = 1, size(plasticState)
    phase_mechanical_Fi0(ph) = phase_mechanical_Fi(ph)
    phase_mechanical_Fp0(ph) = phase_mechanical_Fp(ph)
    phase_mechanical_F0(ph)  = phase_mechanical_F(ph)
    phase_mechanical_Li0(ph) = phase_mechanical_Li(ph)
    phase_mechanical_Lp0(ph) = phase_mechanical_Lp(ph)
    phase_mechanical_S0(ph)  = phase_mechanical_S(ph)
    plasticState(ph)%state0 = plasticState(ph)%state
  end do

end subroutine mechanical_forward


!--------------------------------------------------------------------------------------------------
!> @brief calculate stress (P)
!--------------------------------------------------------------------------------------------------
module function phase_mechanical_constitutive(Delta_t,co,ce) result(status)

  real(pREAL), intent(in) :: Delta_t
  integer, intent(in) :: &
    co, &
    ce
  integer(kind(STATUS_OK)) :: status

  real(pREAL) :: &
    formerStep
  integer :: &
    ph, en, sizeDotState
  logical :: todo
  real(pREAL) :: stepFrac,step
  real(pREAL), dimension(3,3) :: &
    Fp0, &
    Fi0, &
    Lp0, &
    Li0, &
    F0, &
    F
  real(pREAL), dimension(plasticState(material_ID_phase(co,ce))%sizeState) :: state0


  ph = material_ID_phase(co,ce)
  en = material_entry_phase(co,ce)

  state0 = plasticState(ph)%state0(:,en)
  Li0 = phase_mechanical_Li0(ph)%data(1:3,1:3,en)
  Lp0 = phase_mechanical_Lp0(ph)%data(1:3,1:3,en)
  Fp0 = phase_mechanical_Fp0(ph)%data(1:3,1:3,en)
  Fi0 = phase_mechanical_Fi0(ph)%data(1:3,1:3,en)
  F0  = phase_mechanical_F0(ph)%data(1:3,1:3,en)
  stepFrac = 0.0_pREAL
  todo = .true.
  step = 1.0_pREAL/num%stepSizeCryst                                                                ! pretend failed step of 1/stepSizeCryst
  status = STATUS_ITERATING

  todo = .true.
  cutbackLooping: do while (todo)

    if (status == STATUS_OK) then
      formerStep = step
      stepFrac = stepFrac + step
      step = min(1.0_pREAL - stepFrac, num%stepIncreaseCryst * step)

      todo = step > 0.0_pREAL                        ! still time left to integrate on?

      if (todo) then
        F0  = F
        Lp0 = phase_mechanical_Lp(ph)%data(1:3,1:3,en)
        Li0 = phase_mechanical_Li(ph)%data(1:3,1:3,en)
        Fp0 = phase_mechanical_Fp(ph)%data(1:3,1:3,en)
        Fi0 = phase_mechanical_Fi(ph)%data(1:3,1:3,en)
        state0 = plasticState(ph)%state(:,en)
      end if
!--------------------------------------------------------------------------------------------------
!  cut back (reduced time and restore)
    else
      step = num%stepSizeCryst * step
      phase_mechanical_Fp(ph)%data(1:3,1:3,en) = Fp0
      phase_mechanical_Fi(ph)%data(1:3,1:3,en) = Fi0
      phase_mechanical_S(ph)%data(1:3,1:3,en) = phase_mechanical_S0(ph)%data(1:3,1:3,en)
      if (step < 1.0_pREAL) then                                                                    ! actual (not initial) cutback
        phase_mechanical_Lp(ph)%data(1:3,1:3,en) = Lp0
        phase_mechanical_Li(ph)%data(1:3,1:3,en) = Li0
      end if
      plasticState(ph)%state(:,en) = state0
      todo = step > num%stepMinCryst                                                                ! still on track or already done (beyond repair)
    end if

!--------------------------------------------------------------------------------------------------
!  prepare for integration
    if (todo) then
      sizeDotState = plasticState(ph)%sizeDotState
      F = F0 &
        + step * (phase_mechanical_F(ph)%data(1:3,1:3,en) - phase_mechanical_F0(ph)%data(1:3,1:3,en))
      status = integrateState(F0,F,Fp0,Fi0,state0(1:sizeDotState),step * Delta_t,ph,en)
    end if

  end do cutbackLooping

end function phase_mechanical_constitutive


!--------------------------------------------------------------------------------------------------
!> @brief Restore data after homog cutback.
!--------------------------------------------------------------------------------------------------
module subroutine mechanical_restore(ce)

  integer, intent(in) :: ce

  integer :: &
    co, ph, en


  do co = 1,homogenization_Nconstituents(material_ID_homogenization(ce))
    ph = material_ID_phase(co,ce)
    en = material_entry_phase(co,ce)

    phase_mechanical_Fp(ph)%data(1:3,1:3,en) = phase_mechanical_Fp0(ph)%data(1:3,1:3,en)
    phase_mechanical_Fi(ph)%data(1:3,1:3,en) = phase_mechanical_Fi0(ph)%data(1:3,1:3,en)
    phase_mechanical_S(ph)%data(1:3,1:3,en)  = phase_mechanical_S0(ph)%data(1:3,1:3,en)

    plasticState(ph)%state(:,en) = plasticState(ph)%State0(:,en)
  end do

end subroutine mechanical_restore


!--------------------------------------------------------------------------------------------------
!> @brief Calculate tangent (dPdF).
!--------------------------------------------------------------------------------------------------
module function phase_mechanical_dPdF(Delta_t,co,ce) result(dPdF)

  real(pREAL), intent(in) :: Delta_t
  integer, intent(in) :: &
    co, &                                                                                            !< counter in constituent loop
    ce
  real(pREAL), dimension(3,3,3,3) :: dPdF

  integer :: &
    o, &
    p, ph, en
  real(pREAL), dimension(3,3)     ::   devNull, &
                                       invSubFp0,invSubFi0,invFp,invFi, &
                                       temp_33_1, temp_33_2, temp_33_3
  real(pREAL), dimension(3,3,3,3) ::   dSdFe, &
                                       dSdF, &
                                       dSdFi, &
                                       dLidS, &                                                     ! tangent in lattice configuration
                                       dLidFi, &
                                       dLpdS, &
                                       dLpdFi, &
                                       dFidS, &
                                       dFpinvdF, &
                                       rhs_3333, &
                                       lhs_3333, &
                                       temp_3333
  real(pREAL), dimension(9,9)::        temp_99
  logical :: error


  ph = material_ID_phase(co,ce)
  en = material_entry_phase(co,ce)

  call phase_hooke_SandItsTangents(devNull,dSdFe,dSdFi, &
                                   phase_mechanical_Fe(ph)%data(1:3,1:3,en), &
                                   phase_mechanical_Fi(ph)%data(1:3,1:3,en),ph,en)
  call phase_LiAndItsTangents(devNull,dLidS,dLidFi, &
                              phase_mechanical_S(ph)%data(1:3,1:3,en), &
                              phase_mechanical_Fi(ph)%data(1:3,1:3,en), &
                              ph,en)

  invFp = math_inv33(phase_mechanical_Fp(ph)%data(1:3,1:3,en))
  invFi = math_inv33(phase_mechanical_Fi(ph)%data(1:3,1:3,en))
  invSubFp0 = math_inv33(phase_mechanical_Fp0(ph)%data(1:3,1:3,en))
  invSubFi0 = math_inv33(phase_mechanical_Fi0(ph)%data(1:3,1:3,en))

  if (sum(abs(dLidS)) < tol_math_check) then
    dFidS = 0.0_pREAL
  else
    lhs_3333 = 0.0_pREAL; rhs_3333 = 0.0_pREAL
    do o=1,3; do p=1,3
      lhs_3333(1:3,1:3,o,p) = lhs_3333(1:3,1:3,o,p) &
                            + matmul(invSubFi0,dLidFi(1:3,1:3,o,p)) * Delta_t
      lhs_3333(1:3,o,1:3,p) = lhs_3333(1:3,o,1:3,p) &
                            + invFi*invFi(p,o)
      rhs_3333(1:3,1:3,o,p) = rhs_3333(1:3,1:3,o,p) &
                            - matmul(invSubFi0,dLidS(1:3,1:3,o,p)) * Delta_t
    end do; end do
    call math_invert(temp_99,error,math_3333to99(lhs_3333))
    if (error) then
      call IO_warning(600,'matrix inversion during analytic tangent calculation', IO_EOL, &
                          'at entry', en, 'of phase', ph, 'on MPI rank', worldrank, emph = [4,6,8])
      dFidS = 0.0_pREAL
    else
      dFidS = math_mul3333xx3333(math_99to3333(temp_99),rhs_3333)
    end if
    dLidS = math_mul3333xx3333(dLidFi,dFidS) + dLidS
  end if

  call plastic_LpAndItsTangents(devNull,dLpdS,dLpdFi, &
                                phase_mechanical_S(ph)%data(1:3,1:3,en), &
                                phase_mechanical_Fi(ph)%data(1:3,1:3,en),ph,en)
  dLpdS = math_mul3333xx3333(dLpdFi,dFidS) + dLpdS

!--------------------------------------------------------------------------------------------------
! calculate dSdF
  temp_33_1 = transpose(matmul(invFp,invFi))
  temp_33_2 = matmul(phase_mechanical_F(ph)%data(1:3,1:3,en),invSubFp0)
  temp_33_3 = matmul(matmul(phase_mechanical_F(ph)%data(1:3,1:3,en),invFp), invSubFi0)

  do o=1,3; do p=1,3
    rhs_3333(p,o,1:3,1:3)  = matmul(dSdFe(p,o,1:3,1:3),temp_33_1)
    temp_3333(1:3,1:3,p,o) = matmul(matmul(temp_33_2,dLpdS(1:3,1:3,p,o)), invFi) &
                           + matmul(temp_33_3,dLidS(1:3,1:3,p,o))
  end do; end do
  lhs_3333 = math_mul3333xx3333(dSdFe,temp_3333) * Delta_t &
           + math_mul3333xx3333(dSdFi,dFidS)

  call math_invert(temp_99,error,math_eye(9)+math_3333to99(lhs_3333))
  if (error) then
    call IO_warning(600,'matrix inversion during analytic tangent calculation', IO_EOL, &
                        'at entry', en, 'of phase', ph, 'on MPI rank', worldrank, emph = [4,6,8])
    dSdF = rhs_3333
  else
    dSdF = math_mul3333xx3333(math_99to3333(temp_99),rhs_3333)
  end if

!--------------------------------------------------------------------------------------------------
! calculate dFpinvdF
  temp_3333 = math_mul3333xx3333(dLpdS,dSdF)
  do o=1,3; do p=1,3
    dFpinvdF(1:3,1:3,p,o) = - matmul(invSubFp0, matmul(temp_3333(1:3,1:3,p,o),invFi)) * Delta_t
  end do; end do

!--------------------------------------------------------------------------------------------------
! assemble dPdF
  temp_33_1 = matmul(phase_mechanical_S(ph)%data(1:3,1:3,en),transpose(invFp))
  temp_33_2 = matmul(phase_mechanical_F(ph)%data(1:3,1:3,en),invFp)
  temp_33_3 = matmul(temp_33_2,phase_mechanical_S(ph)%data(1:3,1:3,en))

  dPdF = 0.0_pREAL
  do p=1,3
    dPdF(p,1:3,p,1:3) = transpose(matmul(invFp,temp_33_1))
  end do
  do o=1,3; do p=1,3
    dPdF(1:3,1:3,p,o) = dPdF(1:3,1:3,p,o) &
                      + matmul(matmul(phase_mechanical_F(ph)%data(1:3,1:3,en),dFpinvdF(1:3,1:3,p,o)),temp_33_1) &
                      + matmul(matmul(temp_33_2,dSdF(1:3,1:3,p,o)),transpose(invFp)) &
                      + matmul(temp_33_3,transpose(dFpinvdF(1:3,1:3,p,o)))
  end do; end do

end function phase_mechanical_dPdF


!--------------------------------------------------------------------------------------------------
!< @brief Write restart information to file.
!--------------------------------------------------------------------------------------------------
module subroutine mechanical_restartWrite(groupHandle,ph)

  integer(HID_T), intent(in) :: groupHandle
  integer, intent(in) :: ph


  call HDF5_write(plasticState(ph)%state,groupHandle,'omega_plastic')
  call HDF5_write(phase_mechanical_S(ph)%data,groupHandle,'S')
  call HDF5_write(phase_mechanical_F(ph)%data,groupHandle,'F')
  call HDF5_write(phase_mechanical_Fp(ph)%data,groupHandle,'F_p')
  call HDF5_write(phase_mechanical_Fi(ph)%data,groupHandle,'F_i')
  call HDF5_write(phase_mechanical_Lp(ph)%data,groupHandle,'L_p')
  call HDF5_write(phase_mechanical_Li(ph)%data,groupHandle,'L_i')

end subroutine mechanical_restartWrite


!--------------------------------------------------------------------------------------------------
!< @brief Read restart information from file.
!--------------------------------------------------------------------------------------------------
module subroutine mechanical_restartRead(groupHandle,ph)

  integer(HID_T), intent(in) :: groupHandle
  integer, intent(in) :: ph


  call HDF5_read(plasticState(ph)%state0,groupHandle,'omega_plastic')
  call HDF5_read(phase_mechanical_S0(ph)%data,groupHandle,'S')
  call HDF5_read(phase_mechanical_F0(ph)%data,groupHandle,'F')
  call HDF5_read(phase_mechanical_Fp0(ph)%data,groupHandle,'F_p')
  call HDF5_read(phase_mechanical_Fi0(ph)%data,groupHandle,'F_i')
  call HDF5_read(phase_mechanical_Lp0(ph)%data,groupHandle,'L_p')
  call HDF5_read(phase_mechanical_Li0(ph)%data,groupHandle,'L_i')

end subroutine mechanical_restartRead


!--------------------------------------------------------------------------------------------------
!< @brief Get second Piola-Kirchhoff stress (for use by non-mech physics).
!--------------------------------------------------------------------------------------------------
module function mechanical_S(ph,en) result(S)

  integer, intent(in) :: ph,en
  real(pREAL), dimension(3,3) :: S


  S = phase_mechanical_S(ph)%data(1:3,1:3,en)

end function mechanical_S


!--------------------------------------------------------------------------------------------------
!< @brief Get plastic velocity gradient (for use by non-mech physics).
!--------------------------------------------------------------------------------------------------
module function mechanical_L_p(ph,en) result(L_p)

  integer, intent(in) :: ph,en
  real(pREAL), dimension(3,3) :: L_p


  L_p = phase_mechanical_Lp(ph)%data(1:3,1:3,en)

end function mechanical_L_p


!--------------------------------------------------------------------------------------------------
!< @brief Get elastic deformation gradient (for use by non-mech physics).
!--------------------------------------------------------------------------------------------------
module function mechanical_F_e(ph,en) result(F_e)

  integer, intent(in) :: ph,en
  real(pREAL), dimension(3,3) :: F_e


  F_e = phase_mechanical_Fe(ph)%data(1:3,1:3,en)

end function mechanical_F_e


!--------------------------------------------------------------------------------------------------
!< @brief Get eigen deformation gradient (for use by non-mech physics).
!--------------------------------------------------------------------------------------------------
module function mechanical_F_i(ph,en) result(F_i)

  integer, intent(in) :: ph,en
  real(pREAL), dimension(3,3) :: F_i


  F_i = phase_mechanical_Fi(ph)%data(1:3,1:3,en)

end function mechanical_F_i


!--------------------------------------------------------------------------------------------------
!< @brief Get first Piola-Kirchhoff stress (for use by homogenization).
!--------------------------------------------------------------------------------------------------
module function phase_P(co,ce) result(P)

  integer, intent(in) :: co, ce
  real(pREAL), dimension(3,3) :: P


  P = phase_mechanical_P(material_ID_phase(co,ce))%data(1:3,1:3,material_entry_phase(co,ce))

end function phase_P


!--------------------------------------------------------------------------------------------------
!< @brief Get deformation gradient (for use by homogenization).
!--------------------------------------------------------------------------------------------------
module function phase_F(co,ce) result(F)

  integer, intent(in) :: co, ce
  real(pREAL), dimension(3,3) :: F


  F = phase_mechanical_F(material_ID_phase(co,ce))%data(1:3,1:3,material_entry_phase(co,ce))

end function phase_F


!--------------------------------------------------------------------------------------------------
!< @brief Set deformation gradient (for use by homogenization).
!--------------------------------------------------------------------------------------------------
module subroutine phase_set_F(F,co,ce)

  real(pREAL), dimension(3,3), intent(in) :: F
  integer, intent(in) :: co, ce


  phase_mechanical_F(material_ID_phase(co,ce))%data(1:3,1:3,material_entry_phase(co,ce)) = F

end subroutine phase_set_F

end submodule mechanical

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Handling of UNIX signals.
!--------------------------------------------------------------------------------------------------
module signal
  use prec
  use iso_c_binding

  implicit none(type,external)
  private

  logical(C_BOOL), public, protected, volatile, bind(C, name='f_sigint') :: &
    signal_SIGINT  = .false._C_BOOL
  logical(C_BOOL), public, protected, volatile, bind(C, name='f_sigusr1') :: &
    signal_SIGUSR1 = .false._C_BOOL
  logical(C_BOOL), public, protected, volatile, bind(C, name='f_sigusr2') :: &
    signal_SIGUSR2 = .false._C_BOOL
  public :: &
    signal_init, &
    signal_setSIGINT, &
    signal_setSIGUSR1, &
    signal_setSIGUSR2

  interface

    subroutine init_signal_C() bind(C)
    end subroutine init_signal_C

  end interface

contains


!--------------------------------------------------------------------------------------------------
!> @brief Init C signal handler.
!--------------------------------------------------------------------------------------------------
subroutine signal_init()

  call init_signal_C()

end subroutine signal_init


!--------------------------------------------------------------------------------------------------
!> @brief Set global variable signal_SIGINT.
!--------------------------------------------------------------------------------------------------
subroutine signal_setSIGINT(state)

  logical, intent(in) :: state


  signal_SIGINT = logical(state,C_BOOL)
  print '(/a)', 'SIGINT ' // trim(merge('received', 'cleared ', state))

end subroutine signal_setSIGINT

!--------------------------------------------------------------------------------------------------
!> @brief Set global variable signal_SIGUSR.
!--------------------------------------------------------------------------------------------------
subroutine signal_setSIGUSR1(state)

  logical, intent(in) :: state


  signal_SIGUSR1 = logical(state,C_BOOL)
  print '(/a)', 'SIGUSR1 ' // trim(merge('received', 'cleared ', state))

end subroutine signal_setSIGUSR1

!--------------------------------------------------------------------------------------------------
!> @brief Set global variable signal_SIGUSR2.
!--------------------------------------------------------------------------------------------------
subroutine signal_setSIGUSR2(state)

  logical, intent(in) :: state


  signal_SIGUSR2 = logical(state,C_BOOL)
  print '(/a)', 'SIGUSR2 ' // trim(merge('received', 'cleared ', state))

end subroutine signal_setSIGUSR2

end module signal

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
submodule(phase:mechanical) elastic

  type :: tParameters
    type(tPolynomial) :: &
      C_11, &
      C_12, &
      C_13, &
      C_33, &
      C_44, &
      C_66
  end type tParameters

  type(tParameters), allocatable, dimension(:) :: param

contains


!--------------------------------------------------------------------------------------------------
!> @brief Initialize Elasticity.
!--------------------------------------------------------------------------------------------------
module subroutine elastic_init(phases)

  type(tDict), pointer :: &
    phases

  integer :: &
    ph
  type(tDict), pointer :: &
    phase, &
    mech, &
    elastic
  character(len=:), allocatable :: refs
  real(pREAL), dimension(6,6) :: C_tilde
  real(pREAL) :: C_11, C_12, C_44, C_13, C_33, C_66


  print'(/,1x,a)', '<<<+-  phase:mechanical:elastic init  -+>>>'
  print'(/,1x,a)', '<<<+-  phase:mechanical:elastic:Hooke init  -+>>>'

  print'(/,1x,a,1x,i0)', '# phases:',size(phases); flush(IO_STDOUT)


  allocate(param(size(phases)))

  do ph = 1, size(phases)
    phase   => phases%get_dict(ph)
    mech    => phase%get_dict('mechanical')
    elastic => mech%get_dict('elastic')
    print'(/,1x,a,1x,i0,a)', 'phase',ph,': '//phases%key(ph)
    refs = config_listReferences(elastic,indent=3)
    if (len(refs) > 0) print'(/,1x,a)', refs
    if (elastic%get_asStr('type') /= 'Hooke') &
      call IO_error(200,label1='elasticity',ext_msg=elastic%get_asStr('type'))

    associate(prm => param(ph))

      prm%C_11 = polynomial(elastic,'C_11','T')
      prm%C_12 = polynomial(elastic,'C_12','T')
      prm%C_44 = polynomial(elastic,'C_44','T')
      C_11 = prm%C_11%at(T_ROOM)
      C_12 = prm%C_12%at(T_ROOM)
      C_44 = prm%C_44%at(T_ROOM)

      if (any(phase_lattice(ph) == ['hP','tI'])) then
        prm%C_13 = polynomial(elastic,'C_13','T')
        prm%C_33 = polynomial(elastic,'C_33','T')
        C_13 = prm%C_13%at(T_ROOM)
        C_33 = prm%C_33%at(T_ROOM)
      end if

      if (phase_lattice(ph) == 'tI') then
        prm%C_66 = polynomial(elastic,'C_66','T')
        C_66 = prm%C_66%at(T_ROOM)
      end if

    end associate

    C_tilde = crystal_assembleStiffness(C_11,C_12,C_44,C_13,C_33,C_66,phase_lattice(ph))
    if (.not. stable_stiffness(C_tilde,phase_lattice(ph))) &
      call IO_warning(601, 'phase', ph, 'has unstable stiffness matrix at T =', T_ROOM, emph=[2])
  end do

end subroutine elastic_init


!--------------------------------------------------------------------------------------------------
!> @brief return 6x6 elasticity tensor
!--------------------------------------------------------------------------------------------------
pure module function elastic_C66(ph,en) result(C_tilde)

  integer, intent(in) :: &
    ph, &
    en

  real(pREAL), dimension(6,6) :: C_tilde
  real(pREAL) :: T, C_11, C_12, C_44, C_13, C_33, C_66


  associate(prm => param(ph))

    T = thermal_T(ph,en)

    C_11 = prm%C_11%at(T)
    C_12 = prm%C_12%at(T)
    C_44 = prm%C_44%at(T)

    if (any(phase_lattice(ph) == ['hP','tI'])) then
      C_13 = prm%C_13%at(T)
      C_33 = prm%C_33%at(T)
    end if

    if (phase_lattice(ph) == 'tI') C_66 = prm%C_66%at(T)

    C_tilde = crystal_assembleStiffness(C_11,C_12,C_44,C_13,C_33,C_66,phase_lattice(ph))

  end associate

end function elastic_C66


!--------------------------------------------------------------------------------------------------
!> @brief return shear modulus
!--------------------------------------------------------------------------------------------------
pure module function elastic_mu(ph,en,isotropic_bound) result(mu)

  integer, intent(in) :: &
    ph, &
    en
  character(len=*), intent(in) :: isotropic_bound
  real(pREAL) :: &
    mu


  associate(prm => param(ph))

    mu = crystal_isotropic_mu(elastic_C66(ph,en),isotropic_bound,phase_lattice(ph))

  end associate

end function elastic_mu


!--------------------------------------------------------------------------------------------------
!> @brief return Poisson ratio
!--------------------------------------------------------------------------------------------------
pure module function elastic_nu(ph,en,isotropic_bound) result(nu)

  integer, intent(in) :: &
    ph, &
    en
  character(len=*), intent(in) :: isotropic_bound
  real(pREAL) :: &
    nu


  associate(prm => param(ph))

    nu = crystal_isotropic_nu(elastic_C66(ph,en),isotropic_bound,phase_lattice(ph))

  end associate

end function elastic_nu



!--------------------------------------------------------------------------------------------------
!> @brief return the 2nd Piola-Kirchhoff stress tensor and its tangent with respect to
!> the elastic and intermediate deformation gradients using Hooke's law
! ToDo: Use Voigt matrix directly
!--------------------------------------------------------------------------------------------------
module subroutine phase_hooke_SandItsTangents(S, dS_dFe, dS_dFi, &
                                              Fe, Fi, ph, en)

  integer, intent(in) :: &
    ph, &
    en
  real(pREAL),   intent(in),  dimension(3,3) :: &
    Fe, &                                                                                           !< elastic deformation gradient
    Fi                                                                                              !< intermediate deformation gradient
  real(pREAL),   intent(out), dimension(3,3) :: &
    S                                                                                               !< 2nd Piola-Kirchhoff stress tensor in lattice configuration
  real(pREAL),   intent(out), dimension(3,3,3,3) :: &
    dS_dFe, &                                                                                       !< derivative of 2nd P-K stress with respect to elastic deformation gradient
    dS_dFi                                                                                          !< derivative of 2nd P-K stress with respect to intermediate deformation gradient

  real(pREAL), dimension(3,3) :: E
  real(pREAL), dimension(6,6) :: C66
  real(pREAL), dimension(3,3,3,3) :: C
  integer :: &
    i, j


  C66 = phase_damage_C66(phase_homogenizedC66(ph,en),ph,en)
  C = math_Voigt66to3333_stiffness(C66)

  E = 0.5_pREAL*(matmul(transpose(Fe),Fe)-math_I3)                                                  !< Green-Lagrange strain in eigenstrain configuration
  S = math_Voigt6to33_stress(matmul(C66,math_33toVoigt6_strain(matmul(matmul(transpose(Fi),E),Fi))))!< 2PK stress in lattice configuration in work conjugate with GL strain pulled back to lattice configuration

  do i =1,3; do j=1,3
    dS_dFe(i,j,1:3,1:3) = matmul(Fe,matmul(matmul(Fi,C(i,j,1:3,1:3)),transpose(Fi)))                !< dS_ij/dFe_kl = C_ijmn * Fi_lm * Fi_on * Fe_ko
    dS_dFi(i,j,1:3,1:3) = 2.0_pREAL*matmul(matmul(E,Fi),C(i,j,1:3,1:3))                             !< dS_ij/dFi_kl = C_ijln * E_km * Fe_mn
  end do; end do

end subroutine phase_hooke_SandItsTangents


!--------------------------------------------------------------------------------------------------
!> @brief Return the homogenized elasticity matrix.
!--------------------------------------------------------------------------------------------------
module function phase_homogenizedC66(ph,en) result(C)

  real(pREAL), dimension(6,6) :: C
  integer,      intent(in)    :: ph, en


  plasticType: select case (mechanical_plasticity_type(ph))
    case (MECHANICAL_PLASTICITY_DISLOTWIN) plasticType
     C = plastic_dislotwin_homogenizedC(ph,en)
    case default plasticType
     C = elastic_C66(ph,en)
  end select plasticType

end function phase_homogenizedC66


!--------------------------------------------------------------------------------------------------
!> @brief Check if elasticity matrix is stable.
!> @details https://doi.org/10.1103/PhysRevB.90.224104
!--------------------------------------------------------------------------------------------------
pure logical function stable_stiffness(C66,lattice) result(stable)

  real(pREAL), dimension(6,6), intent(in) :: C66                                                     !< Stiffness matrix in Voigt notation
  character(len=*),            intent(in) :: lattice                                                 !< Bravais lattice (Pearson symbol)


  select case(lattice(1:1))
    case ('c')
      stable = C66(1,1) > abs(C66(1,2)) .and. &
               C66(1,1)+2._pREAL*C66(1,2) > 0._pREAL .and. &
               C66(4,4) > 0._pREAL
    case ('h')
      stable = C66(1,1) > abs(C66(1,2)) .and. &
               2._pREAL*C66(1,3)**2 < C66(3,3)*(C66(1,1)+C66(1,2)) .and. &
               C66(3,3) > 0._pREAL
    case ('t')
      stable = C66(1,1) > abs(C66(1,2)) .and. &
               2._pREAL*C66(1,3)**2 < C66(3,3)*(C66(1,1)+C66(1,2)) .and. &
               C66(3,3) > 0._pREAL .and. &
               2._pREAL*C66(1,6)**2 < C66(6,6)*(C66(1,1)-C66(1,2))
    case default
      stable = .false.
  end select

end function stable_stiffness

end submodule elastic

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Pratheek Shanthraj, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Utilities used by the FEM solver
!--------------------------------------------------------------------------------------------------
#include <petsc/finclude/petsc.h>
module FEM_utilities
  use PETSc
#ifndef PETSC_EXPOSES_MPI
  use MPI_f08
#endif

  use prec
  use config
  use math
  use misc
  use IO
  use parallelization
  use discretization_mesh
  use homogenization
  use constants

#ifndef PETSC_EXPOSES_MPIF90
  implicit none(type,external)
#else
  implicit none
#endif
  private

  logical,     public             :: cutBack = .false.                                              !< cut back of BVP solver in case convergence is not achieved or a material point is terminally ill
  real(pREAL), public, protected  :: wgt                                                            !< weighting factor 1/Nelems

!--------------------------------------------------------------------------------------------------
! field labels information
  character(len=*), parameter, public :: &
    FIELD_MECH_label = 'mechanical'

!--------------------------------------------------------------------------------------------------
! derived types
  type, public :: tSolutionState                                                                    !< return type of solution from FEM solver variants
    logical :: converged      = .true.
    PetscInt :: iter_needed   = 0_pPETSCINT
  end type tSolutionState

  type, public :: tMechBC                                                                           !< boundary conditions data
    real(pREAL), allocatable, dimension(:) :: displacements                                         !< u_dot & u
    real(pREAL), allocatable, dimension(:) :: forces                                                !< f_dot & f
    integer,     allocatable, dimension(:) :: active                                                !< which of u_dot/u/f_dot/f is set
  end type tMechBC

  enum, bind(c); enumerator :: &                                                                    !< allowed BC types
    BC_TYPE_NONE  = int(b'0000'), &
    BC_TYPE_U_DOT = int(b'0001'), &
    BC_TYPE_U     = int(b'0010'), &
    BC_TYPE_F_DOT = int(b'0100'), &
    BC_TYPE_F     = int(b'1000')
  end enum

#if PETSC_VERSION_MINOR<23
  external :: &
    PetscSectionGetFieldComponents, &
    PetscSectionGetFieldDof, &
    PetscSectionGetFieldOffset
#endif

  public :: &
    FEM_utilities_init, &
    utilities_constitutiveResponse, &
    utilities_assembleFext, &
    utilities_assembleU, &
    utilities_projectDisplacementBC, &
    ! enum
    BC_TYPE_NONE, &
    BC_TYPE_U_DOT, &
    BC_TYPE_U , &
    BC_TYPE_F_DOT, &
    BC_TYPE_F


contains

!ToDo: use functions in variable call
!--------------------------------------------------------------------------------------------------
!> @brief Allocate all neccessary fields.
!--------------------------------------------------------------------------------------------------
subroutine FEM_utilities_init(num_mesh)

  type(tDict), pointer, intent(in) :: &
    num_mesh

  type(tDict), pointer :: &
    num_mech
  character(len=:), allocatable :: &
    PETSc_options
  integer :: &
    p_s, &                                                                                          !< order of shape functions
    p_i                                                                                             !< integration order (quadrature rule)
  PetscErrorCode :: err_PETSc


  print'(/,1x,a)',   '<<<+-  FEM_utilities init  -+>>>'

  num_mech => num_mesh%get_dict('mechanical', defaultVal=emptyDict)

  p_s = num_mesh%get_asInt('p_s',defaultVal = 2)
  p_i = num_mesh%get_asInt('p_i',defaultVal = p_s)

  if (p_s < 1) &
    call IO_error(301,ext_msg='shape function order (p_s) out of bounds')
  if (p_i < max(1,p_s-1) .or. p_i > p_s) &
    call IO_error(301,ext_msg='integration order (p_i) out of bounds')

  flush(IO_STDOUT)

  petsc_options = misc_prefixOptions('-snes_type newtonls &
                                     &-ksp_type gmres -ksp_max_it 25 -pc_type eisenstat &
                                     &-snes_ksp_ew &
                                     &-petscspace_degree ' // IO_intAsStr(p_s) // ' &
                                     &-petscdualspace_lagrange_node_type equispaced &
                                     &-petscdualspace_lagrange_node_endpoints 1 '// &
                                     num_mech%get_asStr('PETSc_options',defaultVal=''),&
                                     'mechanical_')
  call PetscOptionsInsertString(PETSC_NULL_OPTIONS,petsc_options,err_PETSc)
  CHKERRQ(err_PETSc)

  call PetscOptionsSetValue(PETSC_NULL_OPTIONS,'-petscds_force_quad','0',err_PETSc)
  CHKERRQ(err_PETSc)

  wgt = real(mesh_maxNips*mesh_nElems,pREAL)**(-1)

end subroutine FEM_utilities_init


!--------------------------------------------------------------------------------------------------
!> @brief Calculate constitutive response.
!--------------------------------------------------------------------------------------------------
subroutine utilities_constitutiveResponse(status, Delta_t,P_av,forwardData)

  integer(kind(STATUS_OK)),  intent(out)  :: status
  real(pREAL), intent(in)                 :: Delta_t                                                !< loading time
  logical,     intent(in)                 :: forwardData                                            !< age results
  real(pREAL),intent(out), dimension(3,3) :: P_av                                                   !< average PK stress

  integer(MPI_INTEGER_KIND) :: err_MPI


  print'(/,1x,a)', '... evaluating constitutive response ......................................'

  call homogenization_mechanical_response(status,Delta_t,1,int(mesh_maxNips*mesh_nElems))           ! calculate P field
  cutBack = .false.

  P_av = sum(homogenization_P,dim=3) * wgt
  call MPI_Allreduce(MPI_IN_PLACE,P_av,9_MPI_INTEGER_KIND,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)

end subroutine utilities_constitutiveResponse


!--------------------------------------------------------------------------------------------------
!> @brief Assemble vector of external forces.
!> @details Build the end-of-step aimed external forces.
!--------------------------------------------------------------------------------------------------
subroutine utilities_assembleFext(f_aim_vec, dm, mechBC, Delta_t)

  Vec,                         intent(inout) :: f_aim_vec                                           !< (local) end-of-step aimed forces
  DM,                          intent(in)    :: dm                                                  !< (local) DM
  type(tMechBC), dimension(:), intent(in)    :: mechBC                                              !< loadstep boundary conditions data
  real(pREAL),                 intent(in)    :: Delta_t                                             !< load step total time

  PetscInt       :: component, boundary, &
                    point, dof, n_field_dof, n_field_comp, offset
  IS             :: BC_points_IS                                                                    ! IS of BC points
  PetscSection   :: section
  PetscErrorCode :: err_PETSc
  PetscInt,    pointer :: BC_points(:)                                                              ! array of IS of BC points
  real(pREAL), pointer :: f_aim(:)                                                                  ! array for f_aim_vec
  character(len=11)    :: BC_label                                                                  ! face/edge/vertex set
  integer, parameter   :: FDOT_OR_F = ior(BC_TYPE_F_DOT, BC_TYPE_F)


  ! Point loads
  call DMGetLocalSection(dm,section,err_PETSc)
  CHKERRQ(err_PETSc)
  call PetscSectionGetFieldComponents(section,0_pPETSCINT,n_field_comp,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecGetArray(f_aim_vec,f_aim,err_PETSc)
  CHKERRQ(err_PETSc)
  do boundary = 1_pPETSCINT, mesh_Nboundaries
    if (any(iand(mechBC(boundary)%active, FDOT_OR_F) > 0)) then
      BC_label = PETSC_GENERIC_LABELS(mesh_boundariesIdx(boundary))
      call DMGetStratumIS(dm,BC_label,mesh_boundariesIS(boundary),BC_points_IS,err_PETSc)
      CHKERRQ(err_PETSc)
      call ISGetIndices(BC_points_IS,BC_points,err_PETSc)
      CHKERRQ(err_PETSc)
      do point = 1_pPETSCINT, size(BC_points)
        call PetscSectionGetFieldDof(section,BC_points(point),0_pPETSCINT,n_field_dof,err_PETSc)
        CHKERRQ(err_PETSc)
        call PetscSectionGetFieldOffset(section,BC_points(point),0_pPETSCINT,offset,err_PETSc)
        CHKERRQ(err_PETSc)
        do component = 1_pPETSCINT, size(mechBC(boundary)%forces)
          if (iand(mechBC(boundary)%active(component), FDOT_OR_F) == 0) cycle
          do dof = offset+component, offset+n_field_dof, n_field_comp
            f_aim(dof) = merge(f_aim(dof) + mechBC(boundary)%forces(component)*Delta_t, &
                               mechBC(boundary)%forces(component), &
                               mechBC(boundary)%active(component) == BC_TYPE_F_DOT)
          end do
        end do
      end do
      call ISRestoreIndices(BC_points_IS,BC_points,err_PETSc)
      CHKERRQ(err_PETSc)
    end if
  end do
  call VecRestoreArray(f_aim_vec,f_aim,err_PETSc)
  CHKERRQ(err_PETSc)
  call ISDestroy(BC_points_IS,err_PETSc)
  CHKERRQ(err_PETSc)

end subroutine utilities_assembleFext


!--------------------------------------------------------------------------------------------------
!> @brief assemble vector of displacement (Dirichlet) boundary conditions
!> @details builds the end-of-step aimed displacement
!--------------------------------------------------------------------------------------------------
subroutine utilities_assembleU(u_aim_vec, dm, mechBC, Delta_t)

  Vec,                         intent(inout) :: u_aim_vec                                           !< aim displacement BC vector
  DM,                          intent(in)    :: dm                                                  !< DM (local)
  type(tMechBC), dimension(:), intent(in)    :: mechBC                                              !< BC data
  real(pREAL),                 intent(in)    :: Delta_t                                             !< load time increment

  PetscInt       :: component, boundary, &
                    point, dof, n_field_dof, n_field_comp, offset
  IS             :: BC_points_IS
  PetscSection   :: section
  PetscErrorCode :: err_PETSc
  PetscInt,    pointer :: BC_points(:)
  real(pREAL), pointer :: u_aim(:)
  character(len=11)    :: BC_label
  integer, parameter   :: UDOT_OR_U = ior(BC_TYPE_U_DOT, BC_TYPE_U)


  ! Displacement BC
  call DMGetLocalSection(dm,section,err_PETSc)
  CHKERRQ(err_PETSc)
  call PetscSectionGetFieldComponents(section,0_pPETSCINT,n_field_comp,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecGetArray(u_aim_vec,u_aim,err_PETSc)
  CHKERRQ(err_PETSc)
  do boundary = 1_pPETSCINT, mesh_Nboundaries
    if (any(iand(mechBC(boundary)%active, UDOT_OR_U) > 0)) then
      BC_label = PETSC_GENERIC_LABELS(mesh_boundariesIdx(boundary))
      call DMGetStratumIS(dm,BC_label,mesh_boundariesIS(boundary),BC_points_IS,err_PETSc)
      CHKERRQ(err_PETSc)
      call ISGetIndices(BC_points_IS,BC_points,err_PETSc)
      CHKERRQ(err_PETSc)
      do point = 1_pPETSCINT, size(BC_points)
        call PetscSectionGetFieldDof(section,BC_points(point),0_pPETSCINT,n_field_dof,err_PETSc)
        CHKERRQ(err_PETSc)
        call PetscSectionGetFieldOffset(section,BC_points(point),0_pPETSCINT,offset,err_PETSc)
        CHKERRQ(err_PETSc)
        do component = 1_pPETSCINT, size(mechBC(boundary)%displacements)
          if (iand(mechBC(boundary)%active(component), UDOT_OR_U) == 0) cycle
          do dof = offset+component, offset+n_field_dof, n_field_comp
            u_aim(dof) = merge(u_aim(dof) + mechBC(boundary)%displacements(component) * Delta_t, &
                               mechBC(boundary)%displacements(component), &
                               mechBC(boundary)%active(component) == BC_TYPE_U_DOT)
          end do
        end do
      end do
      call ISRestoreIndices(BC_points_IS,BC_points,err_PETSc)
      CHKERRQ(err_PETSc)
    end if
  end do
  call VecRestoreArray(u_aim_vec,u_aim,err_PETSc)
  CHKERRQ(err_PETSc)
  call ISDestroy(BC_points_IS,err_PETSc)
  CHKERRQ(err_PETSc)

end subroutine utilities_assembleU


!--------------------------------------------------------------------------------------------------
!> @brief Add displacement boundary conditions onto current coordinates vector.
!> @details Enforce displacement BC onto the appropriate DoF by adding the end-of-step aim
!> @details displacement to current coordinates.
!--------------------------------------------------------------------------------------------------
subroutine utilities_projectDisplacementBC(x_vec, rate_vec, Delta_t)

  Vec,         intent(inout) :: x_vec
  Vec,         intent(in)    :: rate_vec
  real(preal), intent(in)    :: Delta_t

  PetscErrorCode :: err_PETSc


  call VecAXPY(x_vec, Delta_t, rate_vec, err_PETSc)                                                 ! x = x + rate * dt
  CHKERRQ(err_PETSc)

end subroutine utilities_projectDisplacementBC

end module FEM_utilities

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, KU Leuven
!> @brief Read data from image files of the visualization toolkit.
!--------------------------------------------------------------------------------------------------
module VTI
  use prec
  use zlib
  use base64
  use IO

  implicit none(type,external)
  private

  public :: &
    VTI_readDataset_real, &
    VTI_readDataset_int, &
    VTI_readGeometry

contains

!--------------------------------------------------------------------------------------------------
!> @brief Read integer dataset from a VTK image data (*.vti) file.
!> @details https://vtk.org/Wiki/VTK_XML_Formats
!--------------------------------------------------------------------------------------------------
function VTI_readDataset_int(fileContent,label) result(dataset)

  character(len=*), intent(in) :: &
    label, &
    fileContent
  integer, dimension(:), allocatable :: &
    dataset

  character(len=:), allocatable :: dataType, headerType, base64Str
  logical :: compressed


  call VTI_readDataset_raw(base64Str,dataType,headerType,compressed, &
                           fileContent,label)
  dataset = as_Int(base64Str,headerType,compressed,dataType)

end function VTI_readDataset_int


!--------------------------------------------------------------------------------------------------
!> @brief Read real dataset from a VTK image data (*.vti) file.
!> @details https://vtk.org/Wiki/VTK_XML_Formats
!--------------------------------------------------------------------------------------------------
function VTI_readDataset_real(fileContent,label) result(dataset)

  character(len=*), intent(in) :: &
    label, &
    fileContent
  real(pREAL),  dimension(:), allocatable :: &
    dataset

  character(len=:), allocatable :: dataType, headerType, base64Str
  logical :: compressed


  call VTI_readDataset_raw(base64Str,dataType,headerType,compressed, &
                           fileContent,label)
  dataset = as_real(base64Str,headerType,compressed,dataType)

end function VTI_readDataset_real


!--------------------------------------------------------------------------------------------------
!> @brief Read dataset as raw data (base64 string) from a VTK image data (*.vti) file.
!> @details https://vtk.org/Wiki/VTK_XML_Formats
!--------------------------------------------------------------------------------------------------
subroutine VTI_readDataset_raw(base64Str,dataType,headerType,compressed, &
                               fileContent,label)

  character(len=*), intent(in) :: &
    label, &
    fileContent
  character(len=:), allocatable, intent(out) :: dataType, headerType, base64Str
  logical, intent(out) :: compressed

  logical :: inFile, inImage
  integer(pI64) :: &
    startPos, endPos, &
    s


  inFile = .false.
  inImage = .false.
  startPos = 1_pI64
  outer: do while (startPos < len(fileContent,kind=pI64))
    endPos = startPos + index(fileContent(startPos:),IO_EOL,kind=pI64) - 2_pI64
    if (endPos < startPos) endPos = len(fileContent,kind=pI64)                                      ! end of file without new line

    if (.not. inFile) then
      if (index(fileContent(startPos:endPos),'<VTKFile',kind=pI64) /= 0_pI64) then
        inFile = .true.
        call checkFileFormat(fileContent(startPos:endPos))
        headerType = merge('UInt64','UInt32',getXMLValue(fileContent(startPos:endPos),'header_type')=='UInt64')
        compressed  = getXMLValue(fileContent(startPos:endPos),'compressor') == 'vtkZLibDataCompressor'
      end if
    else
      if (.not. inImage) then
        if (index(fileContent(startPos:endPos),'<ImageData',kind=pI64) /= 0_pI64) then
          inImage = .true.
        end if
      else
        if (index(fileContent(startPos:endPos),'<CellData',kind=pI64) /= 0_pI64) then
          do while (index(fileContent(startPos:endPos),'</CellData>',kind=pI64) == 0_pI64)
            if (index(fileContent(startPos:endPos),'<DataArray',kind=pI64) /= 0_pI64 .and. &
                 getXMLValue(fileContent(startPos:endPos),'Name') == label ) then

              if (getXMLValue(fileContent(startPos:endPos),'format') /= 'binary') &
                call IO_error(844_pI16, 'dataset', label, 'not in binary format', emph = [2])
              dataType = getXMLValue(fileContent(startPos:endPos),'type')

              startPos = endPos + 2_pI64
              endPos  = startPos + index(fileContent(startPos:),IO_EOL,kind=pI64) - 2_pI64
              s = startPos + verify(fileContent(startPos:endPos),IO_WHITESPACE,kind=pI64) -1_pI64   ! start (no leading whitespace)
              base64Str = fileContent(s:endPos)
              exit outer
            end if
            startPos = endPos + 2_pI64
            endPos = startPos + index(fileContent(startPos:),IO_EOL,kind=pI64) - 2_pI64
          end do
        end if
      end if
    end if

    startPos = endPos + 2_pI64

  end do outer

  if (.not. allocated(base64Str)) call IO_error(844_pI16, 'dataset', label, 'not found', emph = [2])

end subroutine VTI_readDataset_raw


!--------------------------------------------------------------------------------------------------
!> @brief Read cells, size, and origin, and cell data labels of an VTK image data (*.vti) file.
!> @details https://vtk.org/Wiki/VTK_XML_Formats
!--------------------------------------------------------------------------------------------------
subroutine VTI_readGeometry(cells,geomSize,origin,labels, &
                            fileContent)

  integer,     dimension(3), intent(out) :: &
    cells                                                                                           ! # of cells (across all processes!)
  real(pREAL), dimension(3), intent(out) :: &
    geomSize, &                                                                                     ! size (across all processes!)
    origin                                                                                          ! origin (across all processes!)
  character(len=pSTRLEN), allocatable, dimension(:), intent(out) :: &
    labels                                                                                          ! cell data labels
  character(len=*), intent(in) :: &
    fileContent

  character(len=:), allocatable :: headerType
  logical :: inFile, inImage, compressed
  integer(pI64) :: &
    startPos, endPos


  cells = -1
  geomSize = -1.0_pREAL

  inFile = .false.
  inImage = .false.
  startPos = 1_pI64

  do while (startPos < len(fileContent,kind=pI64))
    endPos = startPos + index(fileContent(startPos:),IO_EOL,kind=pI64) - 2_pI64
    if (endPos < startPos) endPos = len(fileContent,kind=pI64)                                      ! end of file without new line

    if (.not. inFile) then
      if (index(fileContent(startPos:endPos),'<VTKFile',kind=pI64) /= 0_pI64) then
        inFile = .true.
        call checkFileFormat(fileContent(startPos:endPos))
        headerType = merge('UInt64','UInt32',getXMLValue(fileContent(startPos:endPos),'header_type')=='UInt64')
        compressed = getXMLValue(fileContent(startPos:endPos),'compressor') == 'vtkZLibDataCompressor'
      end if
    else
      if (.not. inImage) then
        if (index(fileContent(startPos:endPos),'<ImageData',kind=pI64) /= 0_pI64) then
          inImage = .true.
          call cellsSizeOrigin(cells,geomSize,origin,fileContent(startPos:endPos))
        end if
      else
        if (index(fileContent(startPos:endPos),'<CellData',kind=pI64) /= 0_pI64) then
          call cell_labels(labels,fileContent(startPos:))
          exit
        end if
      end if
    end if

    startPos = endPos + 2_pI64

  end do

  if (any(geomSize<=0)) call IO_error(844_pI16, 'one or more entries <= 0 for', 'size', emph=[2])
  if (any(cells<1))     call IO_error(844_pI16, 'one or more entries < 1 for', 'cells', emph=[2])

end subroutine VTI_readGeometry


!--------------------------------------------------------------------------------------------------
!> @brief Determine size and origin from coordinates.
!--------------------------------------------------------------------------------------------------
subroutine cellsSizeOrigin(c,s,o,header)

  integer, dimension(3),     intent(out) :: c
  real(pREAL), dimension(3), intent(out) :: s,o
  character(len=*),          intent(in) :: header

  character(len=:), allocatable, dimension(:) :: temp
  real(pREAL), dimension(3) :: delta
  integer :: i


  temp = [getXMLValue(header,'Direction')]
  if (temp(1) /= '1 0 0 0 1 0 0 0 1' .and. temp(1) /= '') &                                         ! https://discourse.vtk.org/t/vti-specification/6526
    call IO_error(844_pI16, 'wrong coordinate order', temp(1), emph=[2])

  call tokenize(getXMLValue(header,'WholeExtent'),' ',temp)
  if (any([(IO_strAsInt(temp(i)),i=1,5,2)] /= 0)) &
    call IO_error(844_pI16, 'coordinate start not at 0', getXMLValue(header,'WholeExtent'), emph=[2])
  c = [(IO_strAsInt(temp(i)),i=2,6,2)]

  call tokenize(getXMLValue(header,'Spacing'),' ',temp)
  delta = [(IO_strAsReal(temp(i)),i=1,3)]
  s = delta * real(c,pREAL)

  call tokenize(getXMLValue(header,'Origin'),' ',temp)
  o = [(IO_strAsReal(temp(i)),i=1,3)]

end subroutine cellsSizeOrigin


!--------------------------------------------------------------------------------------------------
!> @brief Get labels of all cell-based datasets.
!--------------------------------------------------------------------------------------------------
subroutine cell_labels(labels,file_content)

  character(len=pSTRLEN), allocatable, dimension(:), intent(out) :: labels                          !< labels of cell data
  character(len=*), intent(in) :: file_content

  character(len=pSTRLEN) :: label
  integer(pI64) :: startPos, endPos


  startPos = 1_pI64
  endPos = startPos + index(file_content(startPos:),IO_EOL,kind=pI64) - 2_pI64

  allocate(labels(0))

  do while (index(file_content(startPos:endPos),'</CellData>',kind=pI64) == 0_pI64)
    if (index(file_content(startPos:endPos),'<DataArray',kind=pI64) /= 0_pI64) then
      label = getXMLValue(file_content(startPos:endPos),'Name')
      if (any(labels == label)) then
        call IO_error(844_pI16, 'repeated label', trim(label), emph = [2])
      else
        labels = [labels, label]
      end if
    end if
    startPos = endPos + 2_pI64
    endPos = startPos + index(file_content(startPos:),IO_EOL,kind=pI64) - 2_pI64
  end do

end subroutine cell_labels


!--------------------------------------------------------------------------------------------------
!> @brief Interpret Base64 string in vtk XML file as integer of default kind.
!--------------------------------------------------------------------------------------------------
function as_Int(base64Str,headerType,compressed,dataType)

  character(len=*), intent(in) :: base64Str, &                                                      ! base64 encoded string
                                  headerType, &                                                     ! header type (UInt32 or Uint64)
                                  dataType                                                          ! data type (Int32, Int64, Float32, Float64)
  logical,          intent(in) :: compressed                                                        ! indicate whether data is zlib compressed

  integer, dimension(:), allocatable :: as_Int


  select case(dataType)
    case('Int32')
      as_Int = int(prec_bytesToC_INT32_T(asBytes(base64Str,headerType,compressed)))
    case('Int64')
      as_Int = int(prec_bytesToC_INT64_T(asBytes(base64Str,headerType,compressed)))
    case('Float32')
      as_Int = int(prec_bytesToC_FLOAT  (asBytes(base64Str,headerType,compressed)))
    case('Float64')
      as_Int = int(prec_bytesToC_DOUBLE (asBytes(base64Str,headerType,compressed)))
    case default
      call IO_error(844_pI16,'unknown data type',trim(dataType), emph=[2])
  end select

end function as_Int


!--------------------------------------------------------------------------------------------------
!> @brief Interpret Base64 string in vtk XML file as real of kind pREAL.
!--------------------------------------------------------------------------------------------------
function as_real(base64Str,headerType,compressed,dataType)

  character(len=*), intent(in) :: base64Str, &                                                      ! base64 encoded string
                                  headerType, &                                                     ! header type (UInt32 or Uint64)
                                  dataType                                                          ! data type (Int32, Int64, Float32, Float64)
  logical,          intent(in) :: compressed                                                        ! indicate whether data is zlib compressed

  real(pREAL), dimension(:), allocatable :: as_real


  select case(dataType)
    case('Int32')
      as_real = real(prec_bytesToC_INT32_T(asBytes(base64Str,headerType,compressed)),pREAL)
    case('Int64')
      as_real = real(prec_bytesToC_INT64_T(asBytes(base64Str,headerType,compressed)),pREAL)
    case('Float32')
      as_real = real(prec_bytesToC_FLOAT  (asBytes(base64Str,headerType,compressed)),pREAL)
    case('Float64')
      as_real = real(prec_bytesToC_DOUBLE (asBytes(base64Str,headerType,compressed)),pREAL)
    case default
      call IO_error(844_pI16,'unknown data type',trim(dataType), emph=[2])
  end select

end function as_real


!--------------------------------------------------------------------------------------------------
!> @brief Interpret Base64 string in vtk XML file as bytes.
!--------------------------------------------------------------------------------------------------
function asBytes(base64Str,headerType,compressed) result(bytes)

  character(len=*), intent(in) :: base64Str, &                                                      ! base64 encoded string
                                  headerType                                                        ! header type (UInt32 or Uint64)
  logical,          intent(in) :: compressed                                                        ! indicate whether data is zlib compressed

  integer(C_SIGNED_CHAR), dimension(:), allocatable :: bytes


  if (compressed) then
    bytes = asBytes_compressed(base64Str,headerType)
  else
    bytes = asBytes_uncompressed(base64Str,headerType)
  end if

end function asBytes


!--------------------------------------------------------------------------------------------------
!> @brief Interpret compressed Base64 string in vtk XML file as bytes.
!> @details A compressed Base64 string consists of a header block and a data block
! [#blocks/#u-size/#p-size/#c-size-1/#c-size-2/.../#c-size-#blocks][DATA-1/DATA-2...]
! #blocks = Number of blocks
! #u-size = Block size before compression
! #p-size = Size of last partial block (zero if it not needed)
! #c-size-i = Size in bytes of block i after compression
!--------------------------------------------------------------------------------------------------
function asBytes_compressed(base64Str,headerType) result(bytes_inflated)

  character(len=*), intent(in) :: base64Str, &                                                      ! base64 encoded string
                                  headerType                                                        ! header type (UInt32 or Uint64)
  integer(C_SIGNED_CHAR), dimension(:), allocatable :: bytes_inflated

  integer(C_SIGNED_CHAR), dimension(:), allocatable :: bytes_deflated
  integer(pI64), dimension(:), allocatable :: temp, size_inflated, size_deflated
  integer(pI64) :: headerLen, nBlock, b,s,e


  if      (headerType == 'UInt32') then
    temp = int(prec_bytesToC_INT32_T(base64_to_bytes(base64Str(:base64_nChar(4_pI64)))),pI64)
    nBlock = int(temp(1),pI64)
    headerLen = 4_pI64 * (3_pI64 + nBlock)
    temp = int(prec_bytesToC_INT32_T(base64_to_bytes(base64Str(:base64_nChar(headerLen)))),pI64)
  else if (headerType == 'UInt64') then
    temp = int(prec_bytesToC_INT64_T(base64_to_bytes(base64Str(:base64_nChar(8_pI64)))),pI64)
    nBlock = int(temp(1),pI64)
    headerLen = 8_pI64 * (3_pI64 + nBlock)
    temp = int(prec_bytesToC_INT64_T(base64_to_bytes(base64Str(:base64_nChar(headerLen)))),pI64)
  end if

  allocate(size_inflated(nBlock),source=temp(2))
  size_inflated(nBlock) = merge(temp(3),temp(2),temp(3)/=0_pI64)
  size_deflated = temp(4:)
  bytes_deflated = base64_to_bytes(base64Str(base64_nChar(headerLen)+1_pI64:))

  allocate(bytes_inflated(sum(size_inflated)))
  e = 0_pI64
  do b = 1, nBlock
    s = e + 1_pI64
    e = s + size_deflated(b) - 1_pI64
    bytes_inflated(sum(size_inflated(:b-1))+1_pI64:sum(size_inflated(:b))) = zlib_inflate(bytes_deflated(s:e),size_inflated(b))
  end do

end function asBytes_compressed


!--------------------------------------------------------------------------------------------------
!> @brief Interprete uncompressed Base64 string in vtk XML file as bytes.
!> @details An uncompressed Base64 string consists of N headers blocks and a N data blocks
![#bytes-1/DATA-1][#bytes-2/DATA-2]...
!--------------------------------------------------------------------------------------------------
function asBytes_uncompressed(base64Str,headerType) result(bytes)

  character(len=*), intent(in) :: base64Str, &                                                      ! base64 encoded string
                                  headerType                                                        ! header type (UInt32 or Uint64)
  integer(C_SIGNED_CHAR), dimension(:), allocatable :: bytes

  integer(pI64) :: s
  integer(pI64), dimension(1) :: nByte


  allocate(bytes(0))

  s=0_pI64
  if      (headerType == 'UInt32') then
    do while(s+base64_nChar(4_pI64)<(len(base64Str,pI64)))
      nByte = int(prec_bytesToC_INT32_T(base64_to_bytes(base64Str(s+1_pI64:s+base64_nChar(4_pI64)))),pI64)
      bytes = [bytes,base64_to_bytes(base64Str(s+1_pI64:s+base64_nChar(4_pI64+nByte(1))),5_pI64)]
      s = s + base64_nChar(4_pI64+nByte(1))
    end do
  else if (headerType == 'UInt64') then
    do while(s+base64_nChar(8_pI64)<(len(base64Str,pI64)))
      nByte = int(prec_bytesToC_INT64_T(base64_to_bytes(base64Str(s+1_pI64:s+base64_nChar(8_pI64)))),pI64)
      bytes = [bytes,base64_to_bytes(base64Str(s+1_pI64:s+base64_nChar(8_pI64+nByte(1))),9_pI64)]
      s = s + base64_nChar(8_pI64+nByte(1))
    end do
  end if

end function asBytes_uncompressed


!--------------------------------------------------------------------------------------------------
!> @brief Get XML string value for given key.
!--------------------------------------------------------------------------------------------------
pure function getXMLValue(line,key)

  character(len=*), intent(in)  :: line, key
  character(len=:), allocatable :: getXMLValue

  integer :: s,e


  s = index(line," "//key,back=.true.)
  if (s==0) then
    getXMLValue = ''
  else
    e = s + 1 + scan(line(s+1:),"'"//'"')
    if (scan(line(s:e-2),'=') == 0) then
      getXMLValue = ''
    else
      s = e
      e = s + index(line(s:),merge("'",'"',line(s-1:s-1)=="'")) - 1
      getXMLValue = line(s:e-1)
    end if
  end if

end function getXMLValue


!--------------------------------------------------------------------------------------------------
!> @brief Check for supported file format variants.
!--------------------------------------------------------------------------------------------------
subroutine checkFileFormat(line)

  character(len=*),intent(in) :: line

  character(len=:), allocatable :: val


  val = getXMLValue(line,'type')
  if (val /= 'ImageData') &
    call IO_error(844_pI16, 'type', val, 'is not', 'ImageData',emph=[2,4])

  val = getXMLValue(line,'byte_order')
  if (val /= 'LittleEndian') &
    call IO_error(844_pI16, 'byte_order', val, 'is not', 'LittleEndian',emph=[2,4])

  val = getXMLValue(line,'compressor')
  if (val /= '' .and. val /= 'vtkZLibDataCompressor') &
    call IO_error(844_pI16, 'compressor', val, 'is not', 'vtkZLibDataCompressor',emph=[2,4])

end subroutine checkFileFormat

end module VTI

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @brief  Inflate zlib compressed data
!--------------------------------------------------------------------------------------------------
module zlib
  use prec
  use IO
  use base64

  implicit none(type,external)
  private

  public :: &
    zlib_init, &
    zlib_inflate

  interface

    subroutine inflate_C(s_deflated,s_inflated,deflated,inflated,stat) bind(C)
      use, intrinsic :: ISO_C_binding, only: C_SIGNED_CHAR, C_INT64_T, C_INT
      implicit none(type,external)

      integer(C_INT64_T),                            intent(in)  :: s_deflated,s_inflated
      integer(C_SIGNED_CHAR), dimension(s_deflated), intent(in)  :: deflated                        ! ok for unsigned char
      integer(C_SIGNED_CHAR), dimension(s_inflated), intent(out) :: inflated                        ! ok for unsigned char
      integer(C_INT),                                intent(out) :: stat
    end subroutine inflate_C

  end interface

contains


!--------------------------------------------------------------------------------------------------
!> @brief Do self test.
!--------------------------------------------------------------------------------------------------
subroutine zlib_init()

  print'(/,1x,a)', '<<<+-  zlib init  -+>>>'; flush(IO_STDOUT)

  call selfTest()

end subroutine zlib_init


!--------------------------------------------------------------------------------------------------
!> @brief Inflate byte-wise representation.
!--------------------------------------------------------------------------------------------------
function zlib_inflate(deflated,size_inflated)

  integer(C_SIGNED_CHAR), dimension(:), intent(in) :: deflated
  integer(pI64),                        intent(in) :: size_inflated
  integer(C_SIGNED_CHAR), dimension(size_inflated) :: zlib_inflate

  integer(C_INT) :: stat


  call inflate_C(size(deflated,kind=C_INT64_T),int(size_inflated,C_INT64_T),deflated,zlib_inflate,stat)
  if (stat /= 0) error stop 'inflate failed'

end function zlib_inflate


!--------------------------------------------------------------------------------------------------
!> @brief Check correctness of zlib inflate.
!> @details From Python: print(base64.b64encode(zlib.compress(b'DAMASK zlib FFTW PETSc fyaml',9))).
!--------------------------------------------------------------------------------------------------
subroutine selfTest()

  character(len=*), parameter :: deflated = 'eNpzcfR1DPZWqMrJTFJwcwsJVwhwDQlOVkirTMzNAQB5gwjS'
  character(len=*), parameter :: inflated = 'DAMASK zlib FFTW PETSc fyaml'
  integer(C_SIGNED_CHAR), dimension(:), allocatable :: bytes_deflated
  integer(C_SIGNED_CHAR), dimension(len(inflated)) :: bytes_inflated


  bytes_deflated = base64_to_bytes(deflated)
  bytes_inflated = zlib_inflate(bytes_deflated,len(inflated,kind=pI64))
  if (inflated /= transfer(bytes_inflated,inflated)) error stop 'zlib_inflate'

end subroutine selfTest

end module zlib

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
module test_HDF5_utilities
  use prec
  use HDF5
  use HDF5_utilities

  implicit none(type,external)

  private
  public :: test_HDF5_utilities_run

  contains

subroutine test_HDF5_utilities_run()

  call read_write()

end subroutine test_HDF5_utilities_run


subroutine read_write()

  integer(HID_T) :: f,g, plist_create_id
  integer :: hdferr, order

  real(pREAL), dimension(3) :: real_d1_in,real_d1_out
  real(pREAL), dimension(3,3) :: real_d2_in,real_d2_out
  real(pREAL), dimension(3,3,3) :: real_d3_in,real_d3_out
  real(pREAL), dimension(3,3,3,3) :: real_d4_in,real_d4_out
  real(pREAL), dimension(3,3,3,3,3) :: real_d5_in,real_d5_out

  integer, dimension(3) :: int_d1_in,int_d1_out
  integer, dimension(3,3) :: int_d2_in,int_d2_out
  integer, dimension(3,3,3) :: int_d3_in,int_d3_out
  integer, dimension(3,3,3,3) :: int_d4_in,int_d4_out
  integer, dimension(3,3,3,3,3) :: int_d5_in,int_d5_out


  call random_number(real_d1_in)
  call random_number(real_d2_in)
  call random_number(real_d3_in)
  call random_number(real_d4_in)
  call random_number(real_d5_in)

  int_d1_in = int(real_d1_in*2048._pREAL)
  int_d2_in = int(real_d2_in*2048._pREAL)
  int_d3_in = int(real_d3_in*2048._pREAL)
  int_d4_in = int(real_d4_in*2048._pREAL)
  int_d5_in = int(real_d5_in*2048._pREAL)


  f = HDF5_openFile('test.hdf5','w')


  call HDF5_write(real_d1_in,f,'real_d1')
  call HDF5_write(real_d2_in,f,'real_d2')
  call HDF5_write(real_d3_in,f,'real_d3')
  call HDF5_write(real_d4_in,f,'real_d4')
  call HDF5_write(real_d5_in,f,'real_d5')

  call HDF5_write(int_d1_in,f,'int_d1')
  call HDF5_write(int_d2_in,f,'int_d2')
  call HDF5_write(int_d3_in,f,'int_d3')
  call HDF5_write(int_d4_in,f,'int_d4')
  call HDF5_write(int_d5_in,f,'int_d5')


  call HDF5_read(real_d1_out,f,'real_d1')
  call HDF5_read(real_d2_out,f,'real_d2')
  call HDF5_read(real_d3_out,f,'real_d3')
  call HDF5_read(real_d4_out,f,'real_d4')
  call HDF5_read(real_d5_out,f,'real_d5')

  call HDF5_read(int_d1_out,f,'int_d1')
  call HDF5_read(int_d2_out,f,'int_d2')
  call HDF5_read(int_d3_out,f,'int_d3')
  call HDF5_read(int_d4_out,f,'int_d4')
  call HDF5_read(int_d5_out,f,'int_d5')


  if (any(real_d1_in /= real_d1_out)) error stop 'test_read_write(w)/real_d1'
  if (any(real_d2_in /= real_d2_out)) error stop 'test_read_write(w)/real_d2'
  if (any(real_d3_in /= real_d3_out)) error stop 'test_read_write(w)/real_d3'
  if (any(real_d4_in /= real_d4_out)) error stop 'test_read_write(w)/real_d4'
  if (any(real_d5_in /= real_d5_out)) error stop 'test_read_write(w)/real_d5'

  if (any(int_d1_in /= int_d1_out)) error stop 'test_read_write(w)/int_d1'
  if (any(int_d2_in /= int_d2_out)) error stop 'test_read_write(w)/int_d2'
  if (any(int_d3_in /= int_d3_out)) error stop 'test_read_write(w)/int_d3'
  if (any(int_d4_in /= int_d4_out)) error stop 'test_read_write(w)/int_d4'
  if (any(int_d5_in /= int_d5_out)) error stop 'test_read_write(w)/int_d5'

  call HDF5_closeGroup(HDF5_addGroup(f,'grp'))

  call HDF5_closeFile(f)


  f = HDF5_openFile('test.hdf5','r')

  call H5Fget_create_plist_f(f,plist_create_id,hdferr)
  call HDF5_chkerr(hdferr)
  call H5Pget_link_creation_order_f(plist_create_id,order,hdferr)
  call HDF5_chkerr(hdferr)
  ! https://github.com/HDFGroup/hdf5/issues/5183
  !if (iand(order,H5P_CRT_ORDER_INDEXED_F) /= H5P_CRT_ORDER_INDEXED_F) error stop 'CRT_ORDER_INDEXED/file'
  !if (iand(order,H5P_CRT_ORDER_TRACKED_F) /= H5P_CRT_ORDER_TRACKED_F) error stop 'CRT_ORDER_TRACKED/file'
  call H5Pclose_f(plist_create_id,hdferr)
  call HDF5_chkerr(hdferr)

  g = HDF5_openGroup(f,'grp')
  call H5Gget_create_plist_f(g,plist_create_id,hdferr)
  call HDF5_chkerr(hdferr,'H5Gget_create_plist_f')
  call H5Pget_link_creation_order_f(plist_create_id,order,hdferr)
  call HDF5_chkerr(hdferr,'H5Pget_link_creation_order_f')
  if (iand(order,H5P_CRT_ORDER_INDEXED_F) /= H5P_CRT_ORDER_INDEXED_F) error stop 'CRT_ORDER_INDEXED/group'
  if (iand(order,H5P_CRT_ORDER_TRACKED_F) /= H5P_CRT_ORDER_TRACKED_F) error stop 'CRT_ORDER_TRACKED/group'
  call H5Pclose_f(plist_create_id,hdferr)
  call HDF5_chkerr(hdferr,'H5Pclose_f')
  call HDF5_closeGroup(g)


  call HDF5_read(real_d1_out,f,'real_d1')
  call HDF5_read(real_d2_out,f,'real_d2')
  call HDF5_read(real_d3_out,f,'real_d3')
  call HDF5_read(real_d4_out,f,'real_d4')
  call HDF5_read(real_d5_out,f,'real_d5')

  call HDF5_read(int_d1_out,f,'int_d1')
  call HDF5_read(int_d2_out,f,'int_d2')
  call HDF5_read(int_d3_out,f,'int_d3')
  call HDF5_read(int_d4_out,f,'int_d4')
  call HDF5_read(int_d5_out,f,'int_d5')


  if (any(real_d1_in /= real_d1_out)) error stop 'test_read_write(r)/real_d1'
  if (any(real_d2_in /= real_d2_out)) error stop 'test_read_write(r)/real_d2'
  if (any(real_d3_in /= real_d3_out)) error stop 'test_read_write(r)/real_d3'
  if (any(real_d4_in /= real_d4_out)) error stop 'test_read_write(r)/real_d4'
  if (any(real_d5_in /= real_d5_out)) error stop 'test_read_write(r)/real_d5'

  if (any(int_d1_in /= int_d1_out)) error stop 'test_read_write(r)/int_d1'
  if (any(int_d2_in /= int_d2_out)) error stop 'test_read_write(r)/int_d2'
  if (any(int_d3_in /= int_d3_out)) error stop 'test_read_write(r)/int_d3'
  if (any(int_d4_in /= int_d4_out)) error stop 'test_read_write(r)/int_d4'
  if (any(int_d5_in /= int_d5_out)) error stop 'test_read_write(r)/int_d5'


  call HDF5_closeFile(f)


end subroutine read_write

end module test_HDF5_utilities

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
module test_rotations
  use rotations

  implicit none(type,external)

  private
  public :: test_rotations_run

  contains

subroutine test_rotations_run()

  call rotations_selfTest()

end subroutine test_rotations_run

end module test_rotations

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Arko Jyoti Bhattacharjee, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @author Pratheek Shanthraj, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Grid solver for mechanics: FEM
!--------------------------------------------------------------------------------------------------
#include <petsc/finclude/petscsnes.h>
#include <petsc/finclude/petscdmda.h>
module grid_mechanical_FEM
  use PETScDMDA
  use PETScSNES
  use PETScMat
#ifndef PETSC_EXPOSES_MPI
  use MPI_f08
#endif
  use HDF5

  use prec
  use parallelization
  use IO
  use misc
  use CLI
  use HDF5_utilities
  use math
  use rotations
  use spectral_utilities
  use grid_utilities
  use config
  use homogenization
  use discretization
  use discretization_grid
  use constants

#ifndef PETSC_EXPOSES_MPIF90
  implicit none(type,external)
#else
  implicit none
#endif
  private

  type(tSolutionParams) :: params

  type :: tNumerics
    integer :: &
      itmin, &                                                                                      !< minimum number of iterations
      itmax                                                                                         !< maximum number of iterations
    real(pREAL) :: &
      eps_div_atol, &                                                                               !< absolute tolerance for equilibrium
      eps_div_rtol, &                                                                               !< relative tolerance for equilibrium
      eps_stress_atol, &                                                                            !< absolute tolerance for fullfillment of stress BC
      eps_stress_rtol                                                                               !< relative tolerance for fullfillment of stress BC
  end type tNumerics

  type(tNumerics) :: num                                                                            ! numerics parameters. Better name?

!--------------------------------------------------------------------------------------------------
! PETSc data
  DM   :: DM_mech
  SNES :: SNES_mech
  Vec  :: u_vec, u_lastinc_vec, u_dot_vec

!--------------------------------------------------------------------------------------------------
! common pointwise data
  real(pREAL), dimension(:,:,:,:,:), allocatable :: F, P_current, F_lastinc
  real(pREAL) :: detJ
  real(pREAL), dimension(3)   :: delta
  real(pREAL), dimension(3,8) :: BMat
  real(pREAL), dimension(8,8) :: HGMat

!--------------------------------------------------------------------------------------------------
! stress, stiffness and compliance average etc.
  real(pREAL), dimension(3,3) :: &
    F_aimDot = 0.0_pREAL, &                                                                         !< assumed rate of average deformation gradient
    F_aim = math_I3, &                                                                              !< current prescribed deformation gradient
    F_aim_lastinc = math_I3, &                                                                      !< previous average deformation gradient
    P_av = 0.0_pREAL, &                                                                             !< average 1st Piola--Kirchhoff stress
    P_aim = 0.0_pREAL
  character(len=:), allocatable :: incInfo                                                          !< time and increment information
  real(pREAL), dimension(3,3,3,3) :: &
    C_volAvg = 0.0_pREAL, &                                                                         !< current volume average stiffness
    C_volAvgLastInc = 0.0_pREAL, &                                                                  !< previous volume average stiffness
    S = 0.0_pREAL                                                                                   !< current compliance (filled up with zeros)

  real(pREAL) :: &
    err_BC                                                                                          !< deviation from stress BC

  integer :: totalIter = 0                                                                          !< total iteration in current increment
  integer(kind(STATUS_OK)) :: status

  public :: &
    grid_mechanical_FEM_init, &
    grid_mechanical_FEM_solution, &
    grid_mechanical_FEM_forward, &
    grid_mechanical_FEM_updateCoords, &
    grid_mechanical_FEM_restartWrite

contains

!--------------------------------------------------------------------------------------------------
!> @brief Allocate all necessary fields and fill them with data, potentially from restart info.
!--------------------------------------------------------------------------------------------------
subroutine grid_mechanical_FEM_init(num_grid_mech)

  type(tDict), pointer, intent(in) :: num_grid_mech

  real(pREAL), parameter :: HGCoeff = 0.0e-2_pREAL
  real(pREAL), parameter, dimension(4,8) :: &
    HGcomp = reshape([ 1.0_pREAL, 1.0_pREAL, 1.0_pREAL,-1.0_pREAL, &
                       1.0_pREAL,-1.0_pREAL,-1.0_pREAL, 1.0_pREAL, &
                      -1.0_pREAL, 1.0_pREAL,-1.0_pREAL, 1.0_pREAL, &
                      -1.0_pREAL,-1.0_pREAL, 1.0_pREAL,-1.0_pREAL, &
                      -1.0_pREAL,-1.0_pREAL, 1.0_pREAL, 1.0_pREAL, &
                      -1.0_pREAL, 1.0_pREAL,-1.0_pREAL,-1.0_pREAL, &
                       1.0_pREAL,-1.0_pREAL,-1.0_pREAL,-1.0_pREAL, &
                       1.0_pREAL, 1.0_pREAL, 1.0_pREAL, 1.0_pREAL], [4,8])
  real(pREAL), dimension(3,3,3,3) :: devNull
  real(pREAL), dimension(3,3,product(cells(1:2))*cells3) :: temp33n
  real(pREAL), dimension(3,product(cells(1:2))*cells3) :: temp3n
  PetscErrorCode :: err_PETSc
  integer(MPI_INTEGER_KIND) :: err_MPI
  PetscReal, pointer, dimension(:,:,:,:) :: &
    u,u_lastinc
  integer(MPI_INTEGER_KIND), dimension(0:worldsize-1) :: cells3_global
  integer(HID_T) :: fileHandle, groupHandle
  character(len=:), allocatable :: &
    extmsg, &
    petsc_options


  print'(/,1x,a)', '<<<+-  grid_mechanical_FEM init  -+>>>'; flush(IO_STDOUT)

!-------------------------------------------------------------------------------------------------
! read numerical parameters and do sanity checks
  num%itmin           = num_grid_mech%get_asInt('N_iter_min',defaultVal=1)
  num%itmax           = num_grid_mech%get_asInt('N_iter_max',defaultVal=100)
  num%eps_div_atol    = num_grid_mech%get_asReal('eps_abs_div(P)',defaultVal=1.0e-4_pREAL)
  num%eps_div_rtol    = num_grid_mech%get_asReal('eps_rel_div(P)',defaultVal=5.0e-4_pREAL)
  num%eps_stress_atol = num_grid_mech%get_asReal('eps_abs_P',     defaultVal=1.0e3_pREAL)
  num%eps_stress_rtol = num_grid_mech%get_asReal('eps_rel_P',     defaultVal=1.0e-3_pREAL)

  extmsg = ''
  if (num%eps_div_atol <= 0.0_pREAL)             extmsg = trim(extmsg)//' eps_abs_div(P)'
  if (num%eps_div_rtol <= 0.0_pREAL)             extmsg = trim(extmsg)//' eps_rel_div(P)'
  if (num%eps_stress_atol <= 0.0_pREAL)          extmsg = trim(extmsg)//' eps_abs_P'
  if (num%eps_stress_rtol <= 0.0_pREAL)          extmsg = trim(extmsg)//' eps_rel_P'
  if (num%itmax < 1)                             extmsg = trim(extmsg)//' N_iter_max'
  if (num%itmin > num%itmax .or. num%itmin < 1)  extmsg = trim(extmsg)//' N_iter_min'

  if (extmsg /= '') call IO_error(301,ext_msg=trim(extmsg))

!--------------------------------------------------------------------------------------------------
! set default and user defined options for PETSc

  petsc_options = misc_prefixOptions('-snes_type newtonls -ksp_type fgmres -ksp_max_it 25 '// &
                                     num_grid_mech%get_asStr('PETSc_options',defaultVal='') ,'mechanical_')
  call PetscOptionsInsertString(PETSC_NULL_OPTIONS,petsc_options,err_PETSc)
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! allocate global fields
  allocate(F (3,3,cells(1),cells(2),cells3),source = 0.0_pREAL)
  allocate(P_current (3,3,cells(1),cells(2),cells3),source = 0.0_pREAL)
  allocate(F_lastinc (3,3,cells(1),cells(2),cells3),source = 0.0_pREAL)

!--------------------------------------------------------------------------------------------------
! initialize solver specific parts of PETSc
  call SNESCreate(PETSC_COMM_WORLD,SNES_mech,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESSetOptionsPrefix(SNES_mech,'mechanical_',err_PETSc)
  CHKERRQ(err_PETSc)
  call MPI_Allgather(int(cells3,MPI_INTEGER_KIND),1_MPI_INTEGER_KIND,MPI_INTEGER,&
                     cells3_global,1_MPI_INTEGER_KIND,MPI_INTEGER,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  call DMDACreate3d(PETSC_COMM_WORLD, &
         DM_BOUNDARY_PERIODIC, DM_BOUNDARY_PERIODIC, DM_BOUNDARY_PERIODIC, &
         DMDA_STENCIL_BOX, &
         int(cells(1),pPETSCINT),int(cells(2),pPETSCINT),int(cells(3),pPETSCINT), &                 ! global cells
         1_pPETSCINT, 1_pPETSCINT, int(worldsize,pPETSCINT), &
         3_pPETSCINT, 1_pPETSCINT, &                                                                ! #dof (u, vector), ghost boundary width (domain overlap)
         [int(cells(1),pPETSCINT)],[int(cells(2),pPETSCINT)],int(cells3_global,pPETSCINT), &        ! local cells
         DM_mech,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMsetFromOptions(DM_mech,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMsetUp(DM_mech,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDASetUniformCoordinates(DM_mech,0.0_pREAL,geomSize(1),0.0_pREAL,geomSize(2),0.0_pREAL,geomSize(3),err_PETSc)
  CHKERRQ(err_PETSc)
  call DMCreateGlobalVector(DM_mech,u_vec,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMCreateGlobalVector(DM_mech,u_lastinc_vec,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMCreateGlobalVector(DM_mech,u_dot_vec,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMSNESSetFunctionLocal(DM_mech,form_residual,PETSC_NULL_SNES,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMSNESSetJacobianLocal(DM_mech,form_jacobian,PETSC_NULL_SNES,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESSetConvergenceTest(SNES_mech,converged,PETSC_NULL_SNES,PETSC_NULL_FUNCTION,err_PETSc)    ! specify custom convergence check function "_converged"
  CHKERRQ(err_PETSc)
  call SNESSetMaxLinearSolveFailures(SNES_mech, huge(1_pPETSCINT), err_PETSc)                       ! ignore linear solve failures
  CHKERRQ(err_PETSc)
  call SNESSetDM(SNES_mech,DM_mech,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESSetFromOptions(SNES_mech,err_PETSc)                                                      ! pull it all together with additional cli arguments
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! init fields
  call VecSet(u_vec,0.0_pREAL,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecSet(u_lastinc_vec,0.0_pREAL,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecSet(u_dot_vec   ,0.0_pREAL,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecGetArray(DM_mech,u_vec,u,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecGetArray(DM_mech,u_lastinc_vec,u_lastinc,err_PETSc)
  CHKERRQ(err_PETSc)

  delta = geomSize/real(cells,pREAL)                                                                ! grid spacing
  detJ = product(delta)                                                                             ! cell volume

  BMat = reshape(real([-delta(1)**(-1),-delta(2)**(-1),-delta(3)**(-1), &
                        delta(1)**(-1),-delta(2)**(-1),-delta(3)**(-1), &
                       -delta(1)**(-1), delta(2)**(-1),-delta(3)**(-1), &
                        delta(1)**(-1), delta(2)**(-1),-delta(3)**(-1), &
                       -delta(1)**(-1),-delta(2)**(-1), delta(3)**(-1), &
                        delta(1)**(-1),-delta(2)**(-1), delta(3)**(-1), &
                       -delta(1)**(-1), delta(2)**(-1), delta(3)**(-1), &
                        delta(1)**(-1), delta(2)**(-1), delta(3)**(-1)],pREAL), [3,8])/4.0_pREAL    ! shape function derivative matrix

  HGMat = matmul(transpose(HGcomp),HGcomp) &
        * HGCoeff*(delta(1)*delta(2) + delta(2)*delta(3) + delta(3)*delta(1))/16.0_pREAL            ! hourglass stabilization matrix

!--------------------------------------------------------------------------------------------------
! init fields
  restartRead: if (CLI_restartInc /= -1) then
    print'(/,1x,a,1x,i0)', 'loading restart data of increment', CLI_restartInc

    fileHandle  = HDF5_openFile(CLI_jobName//'_restart.hdf5','r')
    groupHandle = HDF5_openGroup(fileHandle,'solver')

    call HDF5_read(P_aim,groupHandle,'P_aim',.false.)
    call HDF5_read(F_aim,groupHandle,'F_aim',.false.)
    call HDF5_read(F_aim_lastinc,groupHandle,'F_aim_lastinc',.false.)
    call HDF5_read(F_aimDot,groupHandle,'F_aimDot',.false.)
    call HDF5_read(temp33n,groupHandle,'F')
    F = reshape(temp33n,[3,3,cells(1),cells(2),cells3])
    call HDF5_read(temp33n,groupHandle,'F_lastinc')
    F_lastinc = reshape(temp33n,[3,3,cells(1),cells(2),cells3])
    call HDF5_read(temp3n,groupHandle,'u')
    u = reshape(temp3n,[3,cells(1),cells(2),cells3])
    call HDF5_read(temp3n,groupHandle,'u_lastinc')
    u_lastinc = reshape(temp3n,[3,cells(1),cells(2),cells3])
  else restartRead
    F_lastinc = spread(spread(spread(math_I3,3,cells(1)),4,cells(2)),5,cells3)                      ! initialize to identity
    F         = spread(spread(spread(math_I3,3,cells(1)),4,cells(2)),5,cells3)
  end if restartRead

  call utilities_updateCoords(F)
  call utilities_constitutiveResponse(status,P_current,P_av,C_volAvg,devNull, &                     ! stress field, stress avg, global average of stiffness and (min+max)/2
                                      F, &                                                          ! target F
                                      0.0_pREAL)                                                    ! time increment
  call DMDAVecRestoreArray(DM_mech,u_vec,u,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecRestoreArray(DM_mech,u_lastinc_vec,u_lastinc,err_PETSc)
  CHKERRQ(err_PETSc)

  restartRead2: if (CLI_restartInc /= -1) then
    print'(1x,a,1x,i0)', 'loading additional restart data of increment', CLI_restartInc
    call HDF5_read(C_volAvg,groupHandle,'C_volAvg',.false.)
    call HDF5_read(C_volAvgLastInc,groupHandle,'C_volAvgLastInc',.false.)

    call HDF5_closeGroup(groupHandle)
    call HDF5_closeFile(fileHandle)

  end if restartRead2

end subroutine grid_mechanical_FEM_init


!--------------------------------------------------------------------------------------------------
!> @brief solution for the FEM scheme with internal iterations
!--------------------------------------------------------------------------------------------------
function grid_mechanical_FEM_solution(incInfoIn) result(solution)

!--------------------------------------------------------------------------------------------------
! input data for solution
  character(len=*),            intent(in) :: &
    incInfoIn
  type(tSolutionState)                    :: &
    solution
!--------------------------------------------------------------------------------------------------
! PETSc Data
  PetscErrorCode :: err_PETSc
  SNESConvergedReason :: reason


  incInfo = incInfoIn

  S = utilities_maskedCompliance(params%rotation_BC,params%stress_mask,C_volAvg)

  call SNESsolve(SNES_mech,PETSC_NULL_VEC,u_vec,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESGetConvergedReason(SNES_mech,reason,err_PETSc)
  CHKERRQ(err_PETSc)

#if PETSC_VERSION_MINOR<23
  solution%converged = reason > SNES_CONVERGED_ITERATING
#else
  solution%converged = reason%v > SNES_CONVERGED_ITERATING%v
#endif
  solution%iterationsNeeded = totalIter
  P_aim = merge(P_av,P_aim,params%stress_mask)

end function grid_mechanical_FEM_solution


!--------------------------------------------------------------------------------------------------
!> @brief forwarding routine
!> @details find new boundary conditions and best F estimate for end of current timestep
!--------------------------------------------------------------------------------------------------
subroutine grid_mechanical_FEM_forward(cutBack,guess,Delta_t,Delta_t_old,t_remaining, &
                                       deformation_BC,stress_BC,rotation_BC)

  logical,                  intent(in) :: &
    cutBack, &
    guess
  real(pREAL),              intent(in) :: &
    Delta_t_old, &
    Delta_t, &
    t_remaining                                                                                     !< remaining time of current load case
  type(tBCmech), intent(in) :: &
    stress_BC, &
    deformation_BC
  type(tRotation),          intent(in) :: &
    rotation_BC

  PetscErrorCode :: err_PETSc


  if (cutBack) then
    C_volAvg = C_volAvgLastInc
  else
    C_volAvgLastInc    = C_volAvg

    F_aimDot = merge(merge(.0_pREAL,(F_aim-F_aim_lastinc)/Delta_t_old,stress_BC%mask),.0_pREAL,guess) ! estimate deformation rate for prescribed stress components
    F_aim_lastinc = F_aim

    !-----------------------------------------------------------------------------------------------
    ! calculate rate for aim
    if     (deformation_BC%myType=='L') then                                                        ! calculate F_aimDot from given L and current F
      F_aimDot = F_aimDot &
               + matmul(merge(.0_pREAL,deformation_BC%values,deformation_BC%mask),F_aim_lastinc)
    elseif (deformation_BC%myType=='dot_F') then                                                    ! F_aimDot is prescribed
      F_aimDot = F_aimDot &
               + merge(.0_pREAL,deformation_BC%values,deformation_BC%mask)
    elseif (deformation_BC%myType=='F') then                                                        ! aim at end of load case is prescribed
      F_aimDot = F_aimDot &
               + merge(.0_pREAL,(deformation_BC%values - F_aim_lastinc)/t_remaining,deformation_BC%mask)
    end if

    if (guess) then
      call VecWAXPY(u_dot_vec,-1.0_pREAL,u_lastinc_vec,u_vec,err_PETSc)
      CHKERRQ(err_PETSc)
      call VecScale(u_dot_vec,1.0_pREAL/Delta_t_old,err_PETSc)
      CHKERRQ(err_PETSc)
    else
      call VecSet(u_dot_vec,0.0_pREAL,err_PETSc)
      CHKERRQ(err_PETSc)
    end if
    call VecCopy(u_vec,u_lastinc_vec,err_PETSc)
    CHKERRQ(err_PETSc)

    F_lastinc = F

  end if

!--------------------------------------------------------------------------------------------------
! update average and local deformation gradients
  F_aim = F_aim_lastinc + F_aimDot * Delta_t
  if (stress_BC%myType=='P')     P_aim = P_aim &
                                       + merge(.0_pREAL,(stress_BC%values - P_aim)/t_remaining,stress_BC%mask)*Delta_t
  if (stress_BC%myType=='dot_P') P_aim = P_aim &
                                       + merge(.0_pREAL,stress_BC%values,stress_BC%mask)*Delta_t

  call VecAXPY(u_vec,Delta_t,u_dot_vec,err_PETSc)
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! set module wide available data
  params%stress_mask = stress_BC%mask
  params%rotation_BC = rotation_BC
  params%Delta_t     = Delta_t

end subroutine grid_mechanical_FEM_forward


!--------------------------------------------------------------------------------------------------
!> @brief Update coordinates.
!--------------------------------------------------------------------------------------------------
subroutine grid_mechanical_FEM_updateCoords()

  call utilities_updateCoords(F)

end subroutine grid_mechanical_FEM_updateCoords


!--------------------------------------------------------------------------------------------------
!> @brief Write current solver and constitutive data for restart to file.
!--------------------------------------------------------------------------------------------------
subroutine grid_mechanical_FEM_restartWrite()

  PetscErrorCode :: err_PETSc
  integer(HID_T) :: fileHandle, groupHandle
  PetscReal, dimension(:,:,:,:), pointer :: u,u_lastinc


  call DMDAVecGetArrayRead(DM_mech,u_vec,u,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecGetArrayRead(DM_mech,u_lastinc_vec,u_lastinc,err_PETSc)
  CHKERRQ(err_PETSc)

  print'(1x,a)', 'saving solver data required for restart'; flush(IO_STDOUT)

  fileHandle  = HDF5_openFile(CLI_jobName//'_restart.hdf5','a')
  groupHandle = HDF5_addGroup(fileHandle,'solver')
  call HDF5_write(reshape(F,[3,3,product(shape(F))/9]),groupHandle,'F')
  call HDF5_write(reshape(F_lastinc,[3,3,product(shape(F_lastinc))/9]),groupHandle,'F_lastinc')
  call HDF5_write(reshape(u,[3,product(shape(u))/3]),groupHandle,'u')
  call HDF5_write(reshape(u_lastinc,[3,product(shape(u_lastinc))/3]),groupHandle,'u_lastinc')
  call HDF5_closeGroup(groupHandle)
  call HDF5_closeFile(fileHandle)

  if (worldrank == 0) then
    fileHandle  = HDF5_openFile(CLI_jobName//'_restart.hdf5','a',.false.)
    groupHandle = HDF5_openGroup(fileHandle,'solver')
    call HDF5_write(P_aim,groupHandle,'P_aim',.false.)
    call HDF5_write(F_aim,groupHandle,'F_aim',.false.)
    call HDF5_write(F_aim_lastinc,groupHandle,'F_aim_lastinc',.false.)
    call HDF5_write(F_aimDot,groupHandle,'F_aimDot',.false.)
    call HDF5_write(C_volAvg,groupHandle,'C_volAvg',.false.)
    call HDF5_write(C_volAvgLastInc,groupHandle,'C_volAvgLastInc',.false.)
    call HDF5_closeGroup(groupHandle)
    call HDF5_closeFile(fileHandle)
  end if

  call DMDAVecRestoreArrayRead(DM_mech,u_vec,u,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecRestoreArrayRead(DM_mech,u_lastinc_vec,u_lastinc,err_PETSc)
  CHKERRQ(err_PETSc)

end subroutine grid_mechanical_FEM_restartWrite


!--------------------------------------------------------------------------------------------------
!> @brief convergence check
!--------------------------------------------------------------------------------------------------
subroutine converged(snes_local,PETScIter,devNull1,devNull2,fnorm,reason,dummy,err_PETSc)

  SNES :: snes_local
  PetscInt,  intent(in) :: PETScIter
  PetscReal, intent(in) :: &
    devNull1, &
    devNull2, &
    fnorm
  SNESConvergedReason :: reason
  PetscObject :: dummy
  PetscErrorCode :: err_PETSc
  real(pREAL) :: &
    err_div, &
    divTol, &
    BCTol


  err_div = fnorm*sqrt(wgt)*geomSize(1)/scaledGeomSize(1)/detJ
  divTol = max(maxval(abs(P_av))*num%eps_div_rtol, num%eps_div_atol)
  BCTol  = max(maxval(abs(P_av))*num%eps_stress_rtol, num%eps_stress_atol)

  if (totalIter >= num%itmin .and. all([err_div/divTol, err_BC/BCTol] < 1.0_pREAL) &
       .and. status == STATUS_OK) then
    reason = SNES_CONVERGED_USER
  elseif (totalIter >= num%itmax) then
    reason = SNES_DIVERGED_USER
  else
    reason = SNES_CONVERGED_ITERATING
  end if

  print'(/,1x,a)', '... reporting .............................................................'
  print'(/,1x,a,f12.2,a,es8.2,a,es9.2,a)', 'error divergence = ', &
          err_div/divTol,  ' (',err_div,' / m, tol = ',divTol,')'
  print'(1x,a,f12.2,a,es8.2,a,es9.2,a)',    'error stress BC  = ', &
          err_BC/BCTol,    ' (',err_BC, ' Pa,  tol = ',BCTol,')'
  print'(/,1x,a)', '==========================================================================='
  flush(IO_STDOUT)
  err_PETSc = 0

end subroutine converged


!--------------------------------------------------------------------------------------------------
!> @brief Construct the residual vector.
!--------------------------------------------------------------------------------------------------
subroutine form_residual(da_local,x_local, &
                         f_local,dummy,err_PETSc)

  DM          :: da_local
  Vec         :: x_local, f_local
  PetscObject :: dummy
  PetscErrorCode, intent(out) :: err_PETSc

  real(pREAL), pointer,dimension(:,:,:,:) :: x_scal, r
  real(pREAL), dimension(8,3) :: x_elem,  f_elem
  PetscInt :: i, ii, j, jj, k, kk, ctr, ce, &
    PETScIter, nfuncs
  integer(MPI_INTEGER_KIND) :: err_MPI
  real(pREAL), dimension(3,3,3,3) :: devNull


  call SNESGetNumberFunctionEvals(SNES_mech,nfuncs,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESGetIterationNumber(SNES_mech,PETScIter,err_PETSc)
  CHKERRQ(err_PETSc)


  if (nfuncs == 0 .and. PETScIter == 0) totalIter = 0                                              ! new increment

!--------------------------------------------------------------------------------------------------
! begin of new iteration
  newIteration: if (totalIter <= PETScIter) then
    totalIter = totalIter + 1
    print'(1x,a,3(a,i0))', trim(incInfo), ' @ Iteration ', num%itmin, '≤',totalIter, '≤', num%itmax
    if (any(dNeq(params%rotation_BC%asQuaternion(), real([1.0, 0.0, 0.0, 0.0],pREAL)))) &
      print'(/,1x,a,/,2(3(f12.7,1x)/),3(f12.7,1x))', &
      'deformation gradient aim (lab) =', transpose(params%rotation_BC%rotate(F_aim,active=.true.))
    print'(/,1x,a,/,2(3(f12.7,1x)/),3(f12.7,1x))', &
      'deformation gradient aim       =', transpose(F_aim)
    flush(IO_STDOUT)
  end if newIteration

!--------------------------------------------------------------------------------------------------
! get deformation gradient
  call DMDAVecGetArrayRead(da_local,x_local,x_scal,err_PETSc)
  CHKERRQ(err_PETSc)
  do k = cells3Offset+1, cells3Offset+cells3; do j = 1, cells(2); do i = 1, cells(1)
    ctr = 0
    do kk = -1, 0; do jj = -1, 0; do ii = -1, 0
      ctr = ctr + 1
      x_elem(ctr,1:3) = x_scal(0:2,i+ii,j+jj,k+kk)
    end do; end do; end do
    F(1:3,1:3,i,j,k-cells3Offset) = params%rotation_BC%rotate(F_aim,active=.true.) + transpose(matmul(BMat,x_elem))
  end do; end do; end do
  call DMDAVecRestoreArrayRead(da_local,x_local,x_scal,err_PETSc)
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! evaluate constitutive response
  call utilities_constitutiveResponse(status,P_current,&
                                      P_av,C_volAvg,devNull, &
                                      F,params%Delta_t,params%rotation_BC)
  call MPI_Allreduce(MPI_IN_PLACE,status,1_MPI_INTEGER_KIND,MPI_INTEGER,MPI_MAX,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)

!--------------------------------------------------------------------------------------------------
! stress BC handling
  F_aim = F_aim - math_mul3333xx33(S, P_av - P_aim)                                                 ! S = 0.0 for no bc
  err_BC = maxval(abs(merge(.0_pREAL,P_av - P_aim,params%stress_mask)))

!--------------------------------------------------------------------------------------------------
! constructing residual
  call DMDAVecGetArray(da_local,f_local,r,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecGetArrayRead(da_local,x_local,x_scal,err_PETSc)
  CHKERRQ(err_PETSc)
  ce = 0
  r = 0.0_pREAL
  do k = cells3Offset+1, cells3Offset+cells3; do j = 1, cells(2); do i = 1, cells(1)
    ctr = 0
    do kk = -1, 0; do jj = -1, 0; do ii = -1, 0
      ctr = ctr + 1
      x_elem(ctr,1:3) = x_scal(0:2,i+ii,j+jj,k+kk)
    end do; end do; end do
    ce = ce + 1
    f_elem = matmul(transpose(BMat),transpose(P_current(1:3,1:3,i,j,k-cells3Offset)))*detJ + &
             matmul(HGMat,x_elem)*(homogenization_dPdF(1,1,1,1,ce) + &
                                   homogenization_dPdF(2,2,2,2,ce) + &
                                   homogenization_dPdF(3,3,3,3,ce))/3.0_pREAL
    ctr = 0
    do kk = -1, 0; do jj = -1, 0; do ii = -1, 0
      ctr = ctr + 1
      r(0:2,i+ii,j+jj,k+kk) = r(0:2,i+ii,j+jj,k+kk) + f_elem(ctr,1:3)
    end do; end do; end do
  end do; end do; end do
  call DMDAVecRestoreArrayRead(da_local,x_local,x_scal,err_PETSc)
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! applying boundary conditions
  if (cells3Offset == 0) then
    r(0:2,0,       0,       0) = 0.0_pREAL
    r(0:2,cells(1),0,       0) = 0.0_pREAL
    r(0:2,0,       cells(2),0) = 0.0_pREAL
    r(0:2,cells(1),cells(2),0) = 0.0_pREAL
  end if
  if (cells3+cells3Offset == cells(3)) then
    r(0:2,0,       0,       cells(3)) = 0.0_pREAL
    r(0:2,cells(1),0,       cells(3)) = 0.0_pREAL
    r(0:2,0,       cells(2),cells(3)) = 0.0_pREAL
    r(0:2,cells(1),cells(2),cells(3)) = 0.0_pREAL
  end if
  call DMDAVecRestoreArray(da_local,f_local,r,err_PETSc)
  CHKERRQ(err_PETSc)

end subroutine form_residual


!--------------------------------------------------------------------------------------------------
!> @brief Form the FEM stiffness matrix.
!--------------------------------------------------------------------------------------------------
subroutine form_jacobian(da_local,x_local,Jac_pre,Jac,dummy,err_PETSc)

  DM             :: da_local
  Vec            :: x_local
  Mat            :: Jac_pre, Jac
  PetscObject    :: dummy
  PetscErrorCode :: err_PETSc

#if PETSC_VERSION_MINOR<23
  MatStencil,dimension(4,24) :: row, col
#else
  MatStencil,dimension(24)   :: row, col
#endif
  real(pREAL),pointer,dimension(:,:,:,:) :: x_scal
  PetscReal,dimension(24,24)             :: K_ele
  real(pREAL),dimension(9,24)            :: BMatFull
  PetscInt                               :: i, ii, j, jj, k, kk, ctr, ce
  PetscInt,dimension(3),parameter        :: rows = [0, 1, 2]
  real(pREAL)                            :: diag
  MatNullSpace                           :: matnull
  Vec                                    :: coordinates


  BMatFull = 0.0_pREAL
  BMatFull(1:3,1 :8 ) = BMat
  BMatFull(4:6,9 :16) = BMat
  BMatFull(7:9,17:24) = BMat
  call MatSetOption(Jac,MAT_KEEP_NONZERO_PATTERN,PETSC_TRUE,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatSetOption(Jac,MAT_NEW_NONZERO_ALLOCATION_ERR,PETSC_FALSE,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatZeroEntries(Jac,err_PETSc)
  CHKERRQ(err_PETSc)
  ce = 0
  do k = cells3Offset+1, cells3Offset+cells3; do j = 1, cells(2); do i = 1, cells(1)
    ctr = 0
    do kk = -1, 0; do jj = -1, 0; do ii = -1, 0
      ctr = ctr + 1
#if PETSC_VERSION_MINOR<23
      col(MatStencil_i,ctr   ) = i+ii
      col(MatStencil_j,ctr   ) = j+jj
      col(MatStencil_k,ctr   ) = k+kk
      col(MatStencil_c,ctr   ) = 0
      col(MatStencil_i,ctr+8 ) = i+ii
      col(MatStencil_j,ctr+8 ) = j+jj
      col(MatStencil_k,ctr+8 ) = k+kk
      col(MatStencil_c,ctr+8 ) = 1
      col(MatStencil_i,ctr+16) = i+ii
      col(MatStencil_j,ctr+16) = j+jj
      col(MatStencil_k,ctr+16) = k+kk
      col(MatStencil_c,ctr+16) = 2
#else
      col(ctr   )%i = i+ii
      col(ctr   )%j = j+jj
      col(ctr   )%k = k+kk
      col(ctr   )%c = 0
      col(ctr+8 )%i = i+ii
      col(ctr+8 )%j = j+jj
      col(ctr+8 )%k = k+kk
      col(ctr+8 )%c = 1
      col(ctr+16)%i = i+ii
      col(ctr+16)%j = j+jj
      col(ctr+16)%k = k+kk
      col(ctr+16)%c = 2
#endif
    end do; end do; end do
    row = col
    ce = ce + 1
    K_ele = 0.0_pREAL
    K_ele(1 :8 ,1 :8 ) = HGMat*(homogenization_dPdF(1,1,1,1,ce) + &
                                homogenization_dPdF(2,2,2,2,ce) + &
                                homogenization_dPdF(3,3,3,3,ce))/3.0_pREAL
    K_ele(9 :16,9 :16) = HGMat*(homogenization_dPdF(1,1,1,1,ce) + &
                                homogenization_dPdF(2,2,2,2,ce) + &
                                homogenization_dPdF(3,3,3,3,ce))/3.0_pREAL
    K_ele(17:24,17:24) = HGMat*(homogenization_dPdF(1,1,1,1,ce) + &
                                homogenization_dPdF(2,2,2,2,ce) + &
                                homogenization_dPdF(3,3,3,3,ce))/3.0_pREAL
    K_ele = K_ele + &
            matmul(transpose(BMatFull), &
                   matmul(reshape(reshape(homogenization_dPdF(1:3,1:3,1:3,1:3,ce), &
                                          shape=[3,3,3,3], order=[2,1,4,3]),shape=[9,9]),BMatFull))*detJ
#if PETSC_VERSION_MINOR<23
    call MatSetValuesStencil(Jac,24_pPETSCINT,row,24_pPETSCINT,col,K_ele,ADD_VALUES,err_PETSc)
#else
    call MatSetValuesStencil(Jac,24_pPETSCINT,row,24_pPETSCINT,col,reshape(K_ele,[size(K_ele)]),ADD_VALUES,err_PETSc)
#endif
    CHKERRQ(err_PETSc)
  end do; end do; end do
  call MatAssemblyBegin(Jac,MAT_FINAL_ASSEMBLY,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatAssemblyEnd(Jac,MAT_FINAL_ASSEMBLY,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatAssemblyBegin(Jac_pre,MAT_FINAL_ASSEMBLY,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatAssemblyEnd(Jac_pre,MAT_FINAL_ASSEMBLY,err_PETSc)
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! applying boundary conditions
  diag = (C_volAvg(1,1,1,1)/delta(1)**2 + C_volAvg(2,2,2,2)/delta(2)**2 + C_volAvg(3,3,3,3)/delta(3)**2) &
       * detJ
  call MatZeroRowsColumns(Jac,size(rows,kind=pPETSCINT),rows,diag,PETSC_NULL_VEC,PETSC_NULL_VEC,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGetGlobalVector(da_local,coordinates,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecGetArray(da_local,coordinates,x_scal,err_PETSc)
  CHKERRQ(err_PETSc)
  x_scal = reshape(discretization_IPcoords,[3,cells(1),cells(2),cells3])
  call DMDAVecRestoreArray(da_local,coordinates,x_scal,err_PETSc)                                   ! ToDo: use undeformed or deformed configuration?
  CHKERRQ(err_PETSc)
  call MatNullSpaceCreateRigidBody(coordinates,matnull,err_PETSc)                                   ! get rigid body deformation modes
  CHKERRQ(err_PETSc)
  call DMRestoreGlobalVector(da_local,coordinates,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatSetNullSpace(Jac,matnull,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatSetNearNullSpace(Jac,matnull,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatNullSpaceDestroy(matnull,err_PETSc)
  CHKERRQ(err_PETSc)

end subroutine form_jacobian

end module grid_mechanical_FEM

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Pratheek Shanthraj, Max-Planck-Institut für Eisenforschung GmbH
!> @author Luv Sharma, Max-Planck-Institut für Eisenforschung GmbH
!> @brief material subroutine incoprorating isotropic brittle damage source mechanism
!> @details to be done
!--------------------------------------------------------------------------------------------------
submodule(phase:damage) isobrittle

  type :: tParameters                                                                               !< container type for internal constitutive parameters
    real(pREAL) :: &
      W_crit                                                                                        !< critical elastic strain energy
    character(len=pSTRLEN), allocatable, dimension(:) :: &
      output
  end type tParameters

  type :: tIsobrittleState
    real(pREAL), pointer, dimension(:) :: &                                                         !< vectors along Nmembers
      r_W                                                                                           !< ratio between actual and critical strain energy density
  end type tIsobrittleState

  type(tParameters),      allocatable, dimension(:) :: param                                        !< containers of constitutive parameters (len Ninstances)
  type(tIsobrittleState), allocatable, dimension(:) :: &
    deltaState, &
    state

contains


!--------------------------------------------------------------------------------------------------
!> @brief module initialization
!> @details reads in material parameters, allocates arrays, and does sanity checks
!--------------------------------------------------------------------------------------------------
module function isobrittle_init() result(mySources)

  logical, dimension(:), allocatable :: mySources

  type(tDict), pointer :: &
    phases, &
    phase, &
    src
  integer :: Nmembers,ph
  character(len=:), allocatable :: &
    refs, &
    extmsg


  mySources = source_active('isobrittle')
  if (count(mySources) == 0) return

  print'(/,1x,a)', '<<<+-  phase:damage:isobrittle init  -+>>>'
  print'(/,1x,a,1x,i0)', '# phases:',count(mySources); flush(IO_STDOUT)


  phases => config_material%get_dict('phase')
  allocate(param(size(phases)))
  allocate(state(size(phases)))
  allocate(deltaState(size(phases)))
  extmsg = ''

  do ph = 1, size(phases)
    if (mySources(ph)) then
      phase => phases%get_dict(ph)
      src => phase%get_dict('damage')

      associate(prm => param(ph), dlt => deltaState(ph), stt => state(ph))

        prm%W_crit = src%get_asReal('G_crit')/src%get_asReal('l_c')

        print'(/,1x,a,1x,i0,a)', 'phase',ph,': '//phases%key(ph)
        refs = config_listReferences(src,indent=3)
        if (len(refs) > 0) print'(/,1x,a)', refs

#if defined (__GFORTRAN__)
        prm%output = output_as1dStr(src)
#else
        prm%output = src%get_as1dStr('output',defaultVal=emptyStrArray)
#endif

        ! sanity checks
        if (prm%W_crit <= 0.0_pREAL) extmsg = trim(extmsg)//' W_crit'

        Nmembers = count(material_ID_phase==ph)
        call phase_allocateState(damageState(ph),Nmembers,1,0,1)
        damageState(ph)%atol = src%get_asReal('atol_phi',defaultVal=1.0e-9_pREAL)
        if (any(damageState(ph)%atol < 0.0_pREAL)) extmsg = trim(extmsg)//' atol_phi'

        stt%r_W => damageState(ph)%state(1,:)
        dlt%r_W => damageState(ph)%deltaState(1,:)

      end associate


      if (extmsg /= '') call IO_error(211,ext_msg=trim(extmsg)//'(damage_isobrittle)')
    end if

  end do


end function isobrittle_init


!--------------------------------------------------------------------------------------------------
!> @brief
!--------------------------------------------------------------------------------------------------
module subroutine isobrittle_deltaState(C, Fe, ph,en)

  integer, intent(in) :: ph,en
  real(pREAL),  intent(in), dimension(3,3) :: &
    Fe
  real(pREAL),  intent(in), dimension(6,6) :: &
    C

  real(pREAL), dimension(6) :: &
    epsilon
  real(pREAL) :: &
    r_W


  epsilon = math_33toVoigt6_strain(0.5_pREAL*(matmul(transpose(Fe),Fe)-math_I3))

  associate(prm => param(ph), stt => state(ph), dlt => deltaState(ph))

    r_W = (0.5_pREAL*dot_product(epsilon,matmul(C,epsilon)))/prm%W_crit
    dlt%r_W(en) = merge(r_W - stt%r_W(en), 0.0_pREAL, r_W > stt%r_W(en))

  end associate

end subroutine isobrittle_deltaState


!--------------------------------------------------------------------------------------------------
!> @brief Write results to HDF5 output file.
!--------------------------------------------------------------------------------------------------
module subroutine isobrittle_result(phase,group)

  integer,          intent(in) :: phase
  character(len=*), intent(in) :: group

  integer :: o


  associate(prm => param(phase), stt => damageState(phase)%state) ! point to state and output r_W (is scalar, not 1D vector)

    outputsLoop: do o = 1,size(prm%output)
      select case(trim(prm%output(o)))
        case ('r_W')
          call result_writeDataset(stt,group,trim(prm%output(o)),'ratio between actual and critical strain energy density','-')
      end select
    end do outputsLoop

  end associate

end subroutine isobrittle_result

end submodule isobrittle

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Pratheek Shanthraj, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @author Yi Hu, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Grid solver for mechanics: Spectral Galerkin
!--------------------------------------------------------------------------------------------------
#include <petsc/finclude/petscsnes.h>
#include <petsc/finclude/petscdmda.h>
module grid_mechanical_spectral_Galerkin
  use PETScDMDA
  use PETScSNES
#ifndef PETSC_EXPOSES_MPI
  use MPI_f08
#endif
  use HDF5

  use prec
  use parallelization
  use CLI
  use misc
  use IO
  use HDF5_utilities
  use math
  use rotations
  use spectral_utilities
  use grid_utilities
  use homogenization
  use discretization_grid
  use constants

#ifndef PETSC_EXPOSES_MPIF90
  implicit none(type,external)
#else
  implicit none
#endif
  private

  type(tSolutionParams) :: params

  type :: tNumerics
    integer :: &
      itmin, &                                                                                      !< minimum number of iterations
      itmax                                                                                         !< maximum number of iterations
    real(pREAL) :: &
      eps_div_atol, &                                                                               !< absolute tolerance for equilibrium
      eps_div_rtol, &                                                                               !< relative tolerance for equilibrium
      eps_stress_atol, &                                                                            !< absolute tolerance for fullfillment of stress BC
      eps_stress_rtol                                                                               !< relative tolerance for fullfillment of stress BC
  end type tNumerics

  type(tNumerics) :: num                                                                            ! numerics parameters. Better name?

!--------------------------------------------------------------------------------------------------
! PETSc data
  DM   :: DM_mech
  SNES :: SNES_mech
  Vec  :: F_vec
  Mat  :: J_mat

!--------------------------------------------------------------------------------------------------
! common pointwise data
  real(pREAL), dimension(:,:,:,:,:), allocatable ::  &
    F_lastinc, &                                                                                    !< field of previous compatible deformation gradients
    Fdot                                                                                            !< field of assumed rate of compatible deformation gradient

!--------------------------------------------------------------------------------------------------
! stress, stiffness and compliance average etc.
  real(pREAL), dimension(3,3) :: &
    F_aimDot = 0.0_pREAL, &                                                                         !< assumed rate of average deformation gradient
    F_aim = math_I3, &                                                                              !< current prescribed deformation gradient
    F_aim_lastinc = math_I3, &                                                                      !< previous average deformation gradient
    P_av = 0.0_pREAL, &                                                                             !< average 1st Piola--Kirchhoff stress
    P_aim = 0.0_pREAL
  character(len=:), allocatable :: incInfo                                                          !< time and increment information
  real(pREAL), dimension(3,3,3,3) :: &
    C_volAvg = 0.0_pREAL, &                                                                         !< current volume average stiffness
    C_volAvgLastInc = 0.0_pREAL, &                                                                  !< previous volume average stiffness
    C_minMaxAvg = 0.0_pREAL, &                                                                      !< current (min+max)/2 stiffness
    C_minMaxAvgLastInc = 0.0_pREAL, &                                                               !< previous (min+max)/2 stiffness
    C_minMaxAvgRestart = 0.0_pREAL, &                                                               !< (min+max)/2 stiffnes (restart)
    S = 0.0_pREAL                                                                                   !< current compliance (filled up with zeros)

  real(pREAL) :: &
    err_BC, &                                                                                       !< deviation from stress BC
    err_div                                                                                         !< RMS of div of P

  integer :: totalIter = 0                                                                          !< total iteration in current increment
  integer(kind(STATUS_OK)) :: status

  public :: &
    grid_mechanical_spectral_Galerkin_init, &
    grid_mechanical_spectral_Galerkin_solution, &
    grid_mechanical_spectral_Galerkin_forward, &
    grid_mechanical_spectral_Galerkin_updateCoords, &
    grid_mechanical_spectral_Galerkin_restartWrite

  ! Missing interfaces for some PETSc versions
  interface
#if PETSC_VERSION_MINOR<25
    subroutine MatCreateShell(comm,mloc,nloc,m,n,ctx,mat,ierr)
      use petscmat
      MPI_Comm :: comm
      PetscInt :: mloc,nloc,m,n
      Vec :: ctx
      Mat :: mat
      PetscErrorCode :: ierr
    end subroutine MatCreateShell

    subroutine MatShellSetOperation(mat,op_num,op_callback,ierr)
      use petscmat
      Mat :: mat
#if PETSC_VERSION_MINOR<23
      PetscEnum :: op_num
#else
      TYPE(ematoperation) :: op_num
#endif
      external :: op_callback
      PetscErrorCode :: ierr
    end subroutine MatShellSetOperation
#endif
#if PETSC_VERSION_MINOR<24
    subroutine SNESSetUpdate(snes_mech,upd_callback,ierr)
      use petscsnes
      SNES :: snes_mech
      external :: upd_callback
      PetscErrorCode :: ierr
    end subroutine SNESSetUpdate
#endif

#if PETSC_VERSION_MINOR<23
    subroutine MatShellSetContext(mat,ctx,ierr)
      use petscmat
      Mat :: mat
      Vec :: ctx
      PetscErrorCode :: ierr
    end subroutine MatShellSetContext

    subroutine MatShellGetContext(mat,ctx,ierr)
      use petscmat
      Mat :: mat
      Vec, Pointer :: ctx
      PetscErrorCode :: ierr
    end subroutine MatShellGetContext

#if PETSC_VERSION_MINOR<22
    subroutine SNESSetJacobian(snes_mech,A,P,jac_callback,ctx,ierr)
      use petscsnes
      SNES :: snes_mech
      Mat :: A, P
      external :: jac_callback
      integer :: ctx
      PetscErrorCode :: ierr
    end subroutine SNESSetJacobian
#endif
#endif
  end interface

contains

!--------------------------------------------------------------------------------------------------
!> @brief Allocate all necessary fields and fill them with data, potentially from restart info.
!--------------------------------------------------------------------------------------------------
subroutine grid_mechanical_spectral_Galerkin_init(num_grid_mech)

  type(tDict), pointer, intent(in) :: num_grid_mech

  real(pREAL), dimension(3,3,cells(1),cells(2),cells3) :: P
  PetscErrorCode :: err_PETSc
  integer(MPI_INTEGER_KIND) :: err_MPI
  real(pREAL), pointer, dimension(:,:,:,:) :: &
    F                                                                                               ! pointer to solution data
  integer(MPI_INTEGER_KIND), dimension(0:worldsize-1) :: cells3_global
  real(pREAL), dimension(3,3,product(cells(1:2))*cells3) :: temp33n
  integer(HID_T) :: fileHandle, groupHandle
  character(len=:), allocatable :: &
    extmsg, &
    petsc_options


  print'(/,1x,a)', '<<<+-  grid_mechanical_spectral_Galerkin init  -+>>>'; flush(IO_STDOUT)

  print'(/,1x,a)', 'J. Vondřejc et al., Computers & Mathematics with Applications 68(3):156–173, 2014'
  print'(  1x,a)', 'https://doi.org/10.1016/j.camwa.2014.05.014'//IO_EOL

  print'(  1x,a)', 'T.W.J. de Geus et al., Computer Methods in Applied Mechanics and Engineering 318:412–430, 2017'
  print'(  1x,a)', 'https://doi.org/10.1016/j.cma.2016.12.032'//IO_EOL

  print'(  1x,a)', 'S Lucarini et al., Modelling and Simulation in Materials Science and Engineering 30(2):023002, 2021'
  print'(  1x,a)', 'https://doi.org/10.1088/1361-651X/ac34e1'//IO_EOL

  print'(  1x,a)', 'µSpectre'
  print'(  1x,a)', 'https://gitlab.com/muspectre'

!-------------------------------------------------------------------------------------------------
! read numerical parameters and do sanity checks
  num%itmin           = num_grid_mech%get_asInt('N_iter_min',defaultVal=1)
  num%itmax           = num_grid_mech%get_asInt('N_iter_max',defaultVal=100)
  num%eps_div_atol    = num_grid_mech%get_asReal('eps_abs_div(P)', defaultVal=1.0e-4_pREAL)
  num%eps_div_rtol    = num_grid_mech%get_asReal('eps_rel_div(P)', defaultVal=5.0e-4_pREAL)
  num%eps_stress_atol = num_grid_mech%get_asReal('eps_abs_P',      defaultVal=1.0e3_pREAL)
  num%eps_stress_rtol = num_grid_mech%get_asReal('eps_rel_P',      defaultVal=1.0e-3_pREAL)

  extmsg = ''
  if (num%eps_div_atol <= 0.0_pREAL)             extmsg = trim(extmsg)//' eps_abs_div(P)'
  if (num%eps_div_rtol <= 0.0_pREAL)             extmsg = trim(extmsg)//' eps_rel_div(P)'
  if (num%eps_stress_atol <= 0.0_pREAL)          extmsg = trim(extmsg)//' eps_abs_P'
  if (num%eps_stress_rtol <= 0.0_pREAL)          extmsg = trim(extmsg)//' eps_rel_P'
  if (num%itmax < 1)                             extmsg = trim(extmsg)//' N_iter_max'
  if (num%itmin > num%itmax .or. num%itmin < 1)  extmsg = trim(extmsg)//' N_iter_min'

  if (extmsg /= '') call IO_error(301,ext_msg=trim(extmsg))

!--------------------------------------------------------------------------------------------------
! set default and user defined options for PETSc
  petsc_options = &
    misc_prefixOptions('-snes_type newtonls -ksp_type gmres -snes_linesearch_type bt '// &
                       num_grid_mech%get_asStr('PETSc_options',defaultVal=''), 'mechanical_')
  call PetscOptionsInsertString(PETSC_NULL_OPTIONS,petsc_options,err_PETSc)
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! allocate global fields
  allocate(F_lastinc(3,3,cells(1),cells(2),cells3),source = 0.0_pREAL)
  allocate(Fdot     (3,3,cells(1),cells(2),cells3),source = 0.0_pREAL)

!--------------------------------------------------------------------------------------------------
! initialize solver specific parts of PETSc
  call SNESCreate(PETSC_COMM_WORLD,SNES_mech,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESSetOptionsPrefix(SNES_mech,'mechanical_',err_PETSc)
  CHKERRQ(err_PETSc)
  call MPI_Allgather(int(cells3,MPI_INTEGER_KIND),1_MPI_INTEGER_KIND,MPI_INTEGER,&
                     cells3_global,1_MPI_INTEGER_KIND,MPI_INTEGER,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  call DMDACreate3d(PETSC_COMM_WORLD, &
         DM_BOUNDARY_NONE, DM_BOUNDARY_NONE, DM_BOUNDARY_NONE, &                                    ! cut off stencil at boundary
         DMDA_STENCIL_BOX, &                                                                        ! Moore (26) neighborhood around central point
         int(cells(1),pPETSCINT),int(cells(2),pPETSCINT),int(cells(3),pPETSCINT), &                 ! global cells
         1_pPETSCINT, 1_pPETSCINT, int(worldsize,pPETSCINT), &
         9_pPETSCINT, 0_pPETSCINT, &                                                                ! #dof (F, tensor), ghost boundary width (domain overlap)
         [int(cells(1),pPETSCINT)],[int(cells(2),pPETSCINT)],int(cells3_global,pPETSCINT), &        ! local cells
         DM_mech,err_PETSc)                                                                         ! handle, error
  CHKERRQ(err_PETSc)
  call DMsetFromOptions(DM_mech,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMsetUp(DM_mech,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMcreateGlobalVector(DM_mech,F_vec,err_PETSc)                                                ! global solution vector (cells x 9, i.e. every def grad tensor)
  CHKERRQ(err_PETSc)
  call DMDASNESsetFunctionLocal(DM_mech,INSERT_VALUES,form_residual,PETSC_NULL_SNES,err_PETSc)      ! residual vector of same shape as solution vector
  CHKERRQ(err_PETSc)

  ! Set shell Jacobian
  call MatCreateShell(PETSC_COMM_WORLD,&
                      int(9*product(cells(1:2))*cells3,pPETSCINT),&
                      int(9*product(cells(1:2))*cells3,pPETSCINT),&
                      int(9*product(cells(1:2))*sum(cells3_global),pPETSCINT),&
                      int(9*product(cells(1:2))*sum(cells3_global),pPETSCINT),&
                      F_vec,J_mat,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatShellSetOperation(J_mat,MATOP_MULT,GK_op,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESSetDM(SNES_mech,DM_mech,err_PETSc)                                                       ! associate snes with dm first, otherwise jac_shell not written
  CHKERRQ(err_PETSc)
  call SNESSetJacobian(SNES_mech,J_mat,J_mat,PETSC_NULL_FUNCTION,0,err_PETSc)
  CHKERRQ(err_PETSc)


  call SNESSetUpdate(SNES_mech,set_F_aim,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESsetConvergenceTest(SNES_mech,converged,PETSC_NULL_SNES,PETSC_NULL_FUNCTION,err_PETSc)    ! specify custom convergence check function "converged"
  CHKERRQ(err_PETSc)
  call SNESsetFromOptions(SNES_mech,err_PETSc)                                                      ! pull it all together with additional CLI arguments
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! init fields
  call DMDAVecGetArray(DM_mech,F_vec,F,err_PETSc)                                                   ! places pointer on PETSc data
  CHKERRQ(err_PETSc)

  restartRead: if (CLI_restartInc /= -1) then
    print'(/,1x,a,1x,i0)', 'loading restart data of increment', CLI_restartInc

    fileHandle  = HDF5_openFile(CLI_jobName//'_restart.hdf5','r')
    groupHandle = HDF5_openGroup(fileHandle,'solver')

    call HDF5_read(P_aim,groupHandle,'P_aim',.false.)
    call HDF5_read(F_aim,groupHandle,'F_aim',.false.)
    call HDF5_read(F_aim_lastinc,groupHandle,'F_aim_lastinc',.false.)
    call HDF5_read(F_aimDot,groupHandle,'F_aimDot',.false.)
    call HDF5_read(temp33n,groupHandle,'F')
    F = reshape(temp33n,[9,cells(1),cells(2),cells3])
    call HDF5_read(temp33n,groupHandle,'F_lastinc')
    F_lastinc = reshape(temp33n,[3,3,cells(1),cells(2),cells3])
  else restartRead
    F_lastinc = spread(spread(spread(math_I3,3,cells(1)),4,cells(2)),5,cells3)                      ! initialize to identity
    F = reshape(F_lastinc,[9,cells(1),cells(2),cells3])
  end if restartRead

  call utilities_updateCoords(reshape(F,shape(F_lastinc)))
  call utilities_constitutiveResponse(status,P,P_av,C_volAvg,C_minMaxAvg, &                         ! stress field, stress avg, global average of stiffness and (min+max)/2
                                      reshape(F,shape(F_lastinc)), &                                ! target F
                                      0.0_pREAL)                                                    ! time increment
  call DMDAVecRestoreArray(DM_mech,F_vec,F,err_PETSc)                                             ! deassociate pointer
  CHKERRQ(err_PETSc)

  restartRead2: if (CLI_restartInc /= -1) then
    print'(1x,a,1x,i0)', 'loading additional restart data of increment', CLI_restartInc
    call HDF5_read(C_volAvg,groupHandle,'C_volAvg',.false.)
    call HDF5_read(C_volAvgLastInc,groupHandle,'C_volAvgLastInc',.false.)
    call HDF5_read(C_minMaxAvg,groupHandle,'C_minMaxAvg',.false.)

    call HDF5_closeGroup(groupHandle)
    call HDF5_closeFile(fileHandle)
  end if restartRead2

end subroutine grid_mechanical_spectral_Galerkin_init


!--------------------------------------------------------------------------------------------------
!> @brief solution for the Galerkin scheme with internal iterations
!--------------------------------------------------------------------------------------------------
function grid_mechanical_spectral_Galerkin_solution(incInfoIn) result(solution)

!--------------------------------------------------------------------------------------------------
! input data for solution
  character(len=*),            intent(in) :: &
    incInfoIn
  type(tSolutionState)                    :: &
    solution

!--------------------------------------------------------------------------------------------------
! PETSc Data
  PetscErrorCode :: err_PETSc
  SNESConvergedReason :: reason

  incInfo = incInfoIn

!--------------------------------------------------------------------------------------------------
! update stiffness
  S = utilities_maskedCompliance(params%rotation_BC,params%stress_mask,C_volAvg)

  call SNESsolve(SNES_mech,PETSC_NULL_VEC,F_vec,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESGetConvergedReason(SNES_mech,reason,err_PETSc)
  CHKERRQ(err_PETSc)

#if PETSC_VERSION_MINOR<23
  solution%converged = reason > SNES_CONVERGED_ITERATING
#else
  solution%converged = reason%v > SNES_CONVERGED_ITERATING%v
#endif
  solution%iterationsNeeded = totalIter
  P_aim = merge(P_av,P_aim,params%stress_mask)

end function grid_mechanical_spectral_Galerkin_solution


!--------------------------------------------------------------------------------------------------
!> @brief forwarding routine
!> @details find new boundary conditions and best F estimate for end of current timestep
!--------------------------------------------------------------------------------------------------
subroutine grid_mechanical_spectral_Galerkin_forward(cutBack,guess,Delta_t,Delta_t_old,t_remaining,&
                                                     deformation_BC,stress_BC,rotation_BC)

  logical,                  intent(in) :: &
    cutBack, &
    guess
  real(pREAL),              intent(in) :: &
    Delta_t_old, &
    Delta_t, &
    t_remaining                                                                                     !< remaining time of current load case
  type(tBCmech), intent(in) :: &
    stress_BC, &
    deformation_BC
  type(tRotation),           intent(in) :: &
    rotation_BC
  PetscErrorCode :: err_PETSc
  real(pREAL), pointer, dimension(:,:,:,:) :: F


  call DMDAVecGetArray(DM_mech,F_vec,F,err_PETSc)
  CHKERRQ(err_PETSc)

  if (cutBack) then
    C_volAvg    = C_volAvgLastInc
    C_minMaxAvg = C_minMaxAvgLastInc
  else
    C_volAvgLastInc    = C_volAvg
    C_minMaxAvgLastInc = C_minMaxAvg

    F_aimDot = merge(merge(.0_pREAL,(F_aim-F_aim_lastinc)/Delta_t_old,stress_BC%mask),.0_pREAL,guess) ! estimate deformation rate for prescribed stress components
    F_aim_lastinc = F_aim

    !-----------------------------------------------------------------------------------------------
    ! calculate rate for aim
    if     (deformation_BC%myType=='L') then                                                        ! calculate F_aimDot from given L and current F
      F_aimDot = F_aimDot &
               + matmul(merge(.0_pREAL,deformation_BC%values,deformation_BC%mask),F_aim_lastinc)
    elseif (deformation_BC%myType=='dot_F') then                                                    ! F_aimDot is prescribed
      F_aimDot = F_aimDot &
               + merge(.0_pREAL,deformation_BC%values,deformation_BC%mask)
    elseif (deformation_BC%myType=='F') then                                                        ! aim at end of load case is prescribed
      F_aimDot = F_aimDot &
               + merge(.0_pREAL,(deformation_BC%values - F_aim_lastinc)/t_remaining,deformation_BC%mask)
    end if

    Fdot = utilities_calculateRate(guess, &
                                   F_lastinc,reshape(F,[3,3,cells(1),cells(2),cells3]),Delta_t_old, &
                                   rotation_BC%rotate(F_aimDot,active=.true.))
    F_lastinc = reshape(F,[3,3,cells(1),cells(2),cells3])
  end if

!--------------------------------------------------------------------------------------------------
! update average and local deformation gradients
  F_aim = F_aim_lastinc + F_aimDot * Delta_t

  if (stress_BC%myType=='P')     P_aim = P_aim &
                                       + merge(.0_pREAL,(stress_BC%values - P_aim)/t_remaining,stress_BC%mask)*Delta_t
  if (stress_BC%myType=='dot_P') P_aim = P_aim &
                                       + merge(.0_pREAL,stress_BC%values,stress_BC%mask)*Delta_t

  F = reshape(utilities_forwardTensorField(Delta_t,F_lastinc,Fdot, &                                ! estimate of F at end of time+Delta_t that matches rotated F_aim on average
              rotation_BC%rotate(F_aim,active=.true.)),[9,cells(1),cells(2),cells3])
  call DMDAVecRestoreArray(DM_mech,F_vec,F,err_PETSc)
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! set module wide available data
  params%stress_mask = stress_BC%mask
  params%rotation_BC = rotation_BC
  params%Delta_t     = Delta_t

end subroutine grid_mechanical_spectral_Galerkin_forward


!--------------------------------------------------------------------------------------------------
!> @brief Update coordinates.
!--------------------------------------------------------------------------------------------------
subroutine grid_mechanical_spectral_Galerkin_updateCoords()

  PetscErrorCode :: err_PETSc
  real(pREAL), dimension(:,:,:,:), pointer :: F

  call DMDAVecGetArrayRead(DM_mech,F_vec,F,err_PETSc)
  CHKERRQ(err_PETSc)
  call utilities_updateCoords(reshape(F,[3,3,size(F,2),size(F,3),size(F,4)]))
  call DMDAVecRestoreArrayRead(DM_mech,F_vec,F,err_PETSc)
  CHKERRQ(err_PETSc)

end subroutine grid_mechanical_spectral_Galerkin_updateCoords


!--------------------------------------------------------------------------------------------------
!> @brief Write current solver and constitutive data for restart to file.
!--------------------------------------------------------------------------------------------------
subroutine grid_mechanical_spectral_Galerkin_restartWrite()

  PetscErrorCode :: err_PETSc
  integer(HID_T) :: fileHandle, groupHandle
  real(pREAL), dimension(:,:,:,:), pointer :: F


  call DMDAVecGetArrayRead(DM_mech,F_vec,F,err_PETSc)
  CHKERRQ(err_PETSc)

  print'(1x,a)', 'saving solver data required for restart'; flush(IO_STDOUT)

  fileHandle  = HDF5_openFile(CLI_jobName//'_restart.hdf5','a')
  groupHandle = HDF5_addGroup(fileHandle,'solver')
  call HDF5_write(reshape(F,[3,3,product(shape(F))/9]),groupHandle,'F')
  call HDF5_write(reshape(F_lastinc,[3,3,product(shape(F_lastinc))/9]),groupHandle,'F_lastinc')
  call HDF5_closeGroup(groupHandle)
  call HDF5_closeFile(fileHandle)

  if (worldrank == 0) then
    fileHandle  = HDF5_openFile(CLI_jobName//'_restart.hdf5','a',.false.)
    groupHandle = HDF5_openGroup(fileHandle,'solver')
    call HDF5_write(P_aim,groupHandle,'P_aim',.false.)
    call HDF5_write(F_aim,groupHandle,'F_aim',.false.)
    call HDF5_write(F_aim_lastinc,groupHandle,'F_aim_lastinc',.false.)
    call HDF5_write(F_aimDot,groupHandle,'F_aimDot',.false.)
    call HDF5_write(C_volAvg,groupHandle,'C_volAvg',.false.)
    call HDF5_write(C_volAvgLastInc,groupHandle,'C_volAvgLastInc',.false.)
    call HDF5_write(C_minMaxAvgRestart,groupHandle,'C_minMaxAvg',.false.)
    call HDF5_closeGroup(groupHandle)
    call HDF5_closeFile(fileHandle)
  end if

  call DMDAVecRestoreArrayRead(DM_mech,F_vec,F,err_PETSc)
  CHKERRQ(err_PETSc)

end subroutine grid_mechanical_spectral_Galerkin_restartWrite


!--------------------------------------------------------------------------------------------------
!> @brief convergence check
!--------------------------------------------------------------------------------------------------
subroutine converged(snes_local,PETScIter,devNull1,devNull2,rhs_norm,reason,dummy,err_PETSc)

  SNES :: snes_local
  PetscInt,  intent(in) :: PETScIter
  PetscReal, intent(in) :: &
    devNull1, &
    devNull2, &
    rhs_norm
  SNESConvergedReason :: reason
  PetscObject :: dummy
  PetscErrorCode :: err_PETSc
  real(pREAL) :: &
    divTol, &
    BCTol

  divTol = max(maxval(abs(P_av))*num%eps_div_rtol, num%eps_div_atol)
  BCTol = max(maxval(abs(P_av))*num%eps_stress_rtol, num%eps_stress_atol)

  if (totalIter >= num%itmin .and. all([err_div/divTol, err_BC/BCTol] < 1.0_pREAL) &
       .and. status == STATUS_OK) then
    reason = SNES_CONVERGED_USER
  elseif (totalIter >= num%itmax) then
    reason = SNES_DIVERGED_USER
  else
    reason = SNES_CONVERGED_ITERATING
  end if

  print'(/,1x,a)', '... reporting .............................................................'
  print'(/,1x,a,f12.2,a,es8.2,a,es9.2,a)', 'error divergence = ', &
          err_div/divTol,  ' (',err_div,' / m, tol = ',divTol,')'
  print'(1x,a,f12.2,a,es8.2,a,es9.2,a)',    'error stress BC  = ', &
          err_BC/BCTol,    ' (',err_BC, ' Pa,  tol = ',BCTol,')'
  print'(/,1x,a)', '==========================================================================='
  flush(IO_STDOUT)
  err_PETSc = 0

end subroutine converged


!--------------------------------------------------------------------------------------------------
!> @brief Construct the residual vector.
!--------------------------------------------------------------------------------------------------
subroutine form_residual(residual_subdomain, F, &
                         r, dummy, err_PETSc)

#if PETSC_VERSION_MINOR<22
   DMDALocalInfo, dimension(DMDA_LOCAL_INFO_SIZE) :: &
#else
  DMDALocalInfo :: &
#endif
    residual_subdomain

  real(pREAL), dimension(3,3,cells(1),cells(2),cells3), intent(in) :: &
    F                                                                                               !< deformation gradient field
  real(pREAL), dimension(3,3,cells(1),cells(2),cells3), intent(out) :: &
    r                                                                                               !< residuum field
  PetscObject :: dummy
  PetscErrorCode, intent(out) :: err_PETSc

  real(pREAL), dimension(3,3) :: dP_with_BC

  PetscInt :: &
    PETScIter, &
    nfuncs
  integer(MPI_INTEGER_KIND) :: err_MPI


  call SNESGetNumberFunctionEvals(SNES_mech,nfuncs,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESGetIterationNumber(SNES_mech,PETScIter,err_PETSc)
  CHKERRQ(err_PETSc)

  if (nfuncs == 0 .and. PETScIter == 0) totalIter = -1                                              ! new increment

  newIteration: if (totalIter <= PETScIter) then
    totalIter = totalIter + 1
    print'(1x,a,3(a,i0))', trim(incInfo), ' @ Iteration ', num%itmin, '≤',totalIter, '≤', num%itmax
    if (any(dNeq(params%rotation_BC%asQuaternion(), real([1.0, 0.0, 0.0, 0.0],pREAL)))) &
      print'(/,1x,a,/,2(3(f12.7,1x)/),3(f12.7,1x))', &
      'deformation gradient aim (lab) =', transpose(params%rotation_BC%rotate(F_aim,active=.true.))
    print'(/,1x,a,/,2(3(f12.7,1x)/),3(f12.7,1x))', &
      'deformation gradient aim       =', transpose(F_aim)
    flush(IO_STDOUT)
  end if newIteration

  associate (P => r)
    call utilities_constitutiveResponse(status,P, &
                                        P_av,C_volAvg,C_minMaxAvg, &
                                        F,params%Delta_t,params%rotation_BC)
    call MPI_Allreduce(MPI_IN_PLACE,status,1_MPI_INTEGER_KIND,MPI_LOGICAL,MPI_LOR,MPI_COMM_WORLD,err_MPI)
    call parallelization_chkerr(err_MPI)
    err_div = utilities_divergenceRMS(P)
  end associate

  dP_with_BC = merge(.0_pREAL,P_av-P_aim,params%stress_mask)
  err_BC     = maxval(abs(dP_with_BC))

  ! Yi: TODO: rotation
  r = utilities_G_Convolution(r,params%stress_mask,dP_with_BC)

end subroutine form_residual


!--------------------------------------------------------------------------------------------------
!> @brief Matrix-free operation GK_op -> GK_op(dF) = Fourier_inv( G_hat : Fourier(K:dF) )
!--------------------------------------------------------------------------------------------------
subroutine GK_op(Jac,dF_global,output_vec,err_PETSc)

  DM :: dm_local
  Vec :: dF_global, dF_local, output_vec
  Mat :: Jac                                                                                         !< Jacobian
  PetscErrorCode :: err_PETSc

  real(pREAL), pointer,dimension(:,:,:,:) :: dF_flat, output_flat

  real(pREAL), dimension(3,3,cells(1),cells(2),cells3) :: &
   dF
  real(pREAL), dimension(3,3,cells(1),cells(2),cells3) :: &
   output

  integer :: i, j, k, ce


  call SNESGetDM(SNES_mech,dm_local,err_PETSc)
  CHKERRQ(err_PETSc)

  call DMGetLocalVector(dm_local,dF_local,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGlobalToLocalBegin(dm_local,dF_global,INSERT_VALUES,dF_local,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGlobalToLocalEnd(dm_local,dF_global,INSERT_VALUES,dF_local,err_PETSc)
  CHKERRQ(err_PETSc)

  call DMDAVecGetArrayRead(dm_local,dF_local,dF_flat,err_PETSc)
  CHKERRQ(err_PETSc)
  dF = reshape(dF_flat, [3,3,cells(1),cells(2),cells3])

  ! ===== K:dF operartor, i.e. dP = K:dF =====
  ce = 0
  do k = 1, cells3; do j = 1, cells(2); do i = 1, cells(1)
    ce = ce + 1
    output(1:3,1:3,i,j,k) = &
      math_mul3333xx33(homogenization_dPdF(1:3,1:3,1:3,1:3,ce), dF(1:3,1:3,i,j,k))
  end do; end do; end do

  ! ===== G* operator =====
  output = utilities_G_Convolution(output,params%stress_mask)

  call DMDAVecGetArray(dm_local,output_vec,output_flat,err_PETSc)
  CHKERRQ(err_PETSc)
  output_flat = reshape(output, [9,cells(1),cells(2),cells3])
  call DMDAVecRestoreArray(dm_local,output_vec,output_flat,err_PETSc)
  CHKERRQ(err_PETSc)

  call DMDAVecRestoreArrayRead(dm_local,dF_local,dF_flat,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMRestoreLocalVector(dm_local,dF_local,err_PETSc)
  CHKERRQ(err_PETSc)

end subroutine GK_op


!--------------------------------------------------------------------------------------------------
!> @brief Update F_aim only in newton step (not in line search step)
!--------------------------------------------------------------------------------------------------
subroutine set_F_aim(snes, step, ierr)

  SNES      :: snes
  PetscInt  :: step ! curr completed petsc iter
  PetscErrorCode, intent(out) :: ierr


  real(pREAL), dimension(3,3) :: &
    deltaF_aim

  deltaF_aim = math_mul3333xx33(S, P_av - P_aim)
  F_aim = F_aim - deltaF_aim

  ierr = 0_pPETSCERRORCODE

end subroutine set_F_aim

end module grid_mechanical_spectral_Galerkin

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Pratheek Shanthraj, Max-Planck-Institut für Eisenforschung GmbH
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @brief FEM PETSc solver
!--------------------------------------------------------------------------------------------------
#include <petsc/finclude/petscdmplex.h>
#include <petsc/finclude/petscdm.h>
#include <petsc/finclude/petsc.h>
module mesh_mechanical_FEM
  use PETScSNES
  use PETScDM
  use PETScDMplex
#if PETSC_VERSION_MINOR<23
  use PETScDT
#endif
#ifndef PETSC_EXPOSES_MPI
  use MPI_f08
#endif

  use prec
  use FEM_utilities
  use discretization
  use discretization_mesh
  use homogenization
  use math
  use constants

#ifndef PETSC_EXPOSES_MPIF90
  implicit none(type,external)
#else
  implicit none
#endif
  private

!--------------------------------------------------------------------------------------------------
! derived types
  type tSolutionParams
    type(tMechBC),allocatable, dimension(:)  :: mechBC
    real(pREAL)    :: Delta_t
  end type tSolutionParams

  type(tSolutionParams)  :: params

  type, private :: tNumerics
    PetscInt :: &
      p_i, &                                                                                        !< integration order (quadrature rule)
      itmax
  end type tNumerics

  type(tNumerics), private :: num
!--------------------------------------------------------------------------------------------------
! PETSc data
  SNES                           :: mechanical_snes
  Vec                            :: u, u_local, u_rate, &
                                    u_aim, u_aim_rate, u_aim_prev, &
                                    f_ext, f_aim_rate, f_ext_prev, &
                                    x_local
  PetscInt                       :: dimPlex, cellDof, nBasis
  PetscInt                       :: nQuadrature
  PetscReal, allocatable, dimension(:) :: qWeights
  MatNullSpace                   :: matnull

!--------------------------------------------------------------------------------------------------
! stress, stiffness and compliance average etc.
  character(len=pSTRLEN) :: incInfo
  real(pREAL), dimension(3,3) :: &
    P_av = 0.0_pREAL
  logical :: ForwardData
  integer(kind(STATUS_OK)) :: status
  real(pREAL), parameter :: eps = 1.0e-18_pREAL

#if PETSC_VERSION_MINOR<23
  external :: &                                                                                     ! ToDo: write interfaces
#if PETSC_VERSION_MINOR<22
    DMAddField, &
    SNESConvergedDefault, &
#endif
    PetscSectionGetNumFields, &
    PetscFESetQuadrature, &
    PetscFEGetDimension, &
    PetscFEDestroy, &
    PetscSectionGetDof, &
    PetscFEGetDualSpace, &
    PetscDualSpaceGetFunctional
#endif

  public :: &
    FEM_mechanical_init, &
    FEM_mechanical_solution, &
    FEM_mechanical_forward, &
    FEM_mechanical_assembleFext, &
    FEM_mechanical_assembleU, &
    FEM_mechanical_updateCoords

contains

!--------------------------------------------------------------------------------------------------
!> @brief allocates all neccessary fields and fills them with data
!--------------------------------------------------------------------------------------------------
subroutine FEM_mechanical_init(mechBC,num_mesh)

  type(tMechBC), dimension(:), intent(in) :: mechBC
  type(tDict),   pointer,      intent(in) :: num_mesh

  DM       :: mechanical_mesh
  IS       :: label_points_IS                                                                       ! IS of points in a stratum of a label
  DMLabel  :: dm_label                                                                              ! mesh labels
  PetscFE  :: mechFE
  PetscDS  :: mechDS
  PetscInt :: n_displacement_BC, nc, &
              component, boundary, topologDim, &
              cellStart, cellEnd, &
              nCoords, d
  PetscBool       :: has_label, is_simplex
  PetscSection    :: section
  PetscQuadrature :: mechQuad
  PetscDualSpace  :: mechDualSpace
#if PETSC_VERSION_MINOR>22
  PetscObject     :: obj
#endif
  PetscErrorCode  :: err_PETSc
#if PETSC_VERSION_MINOR<23
  DMLabel,   dimension(:), pointer     :: PETSC_NULL_DMLABEL_ARRAY => NULL()
  PetscReal, dimension(:), pointer     :: PETSC_NULL_REAL_POINTER => NULL()
#endif
  IS,        dimension(:), pointer     :: BC_comps_IS, BC_points_IS
  PetscInt,  dimension(:), pointer     :: n_comp, n_dof, BC_field, label_points
  PetscInt,  dimension(:), allocatable :: idx
  PetscReal, dimension(:), pointer     :: qWeightsP
  real(pREAL), dimension(:), allocatable :: nodeCoords

  integer                     :: n
  character(len=*), parameter :: prefix = 'mechanical_'
  character(len=pSTRLEN)      :: BC_label

  real(pREAL), dimension(3,3) :: devNull
  type(tDict), pointer        :: num_mech

  print'(/,1x,a)', '<<<+-  FEM_mech init  -+>>>'; flush(IO_STDOUT)

!-----------------------------------------------------------------------------
! read numerical parametes and do sanity checks
  num_mech => num_mesh%get_dict('mechanical', defaultVal=emptyDict)

  num%p_i   = int(num_mesh%get_asInt('p_i',defaultVal=2),pPETSCINT)
  num%itmax = int(num_mech%get_asInt('N_iter_max',defaultVal=250),pPETSCINT)

  if (num%itmax <= 1_pPETSCINT) call IO_error(301,ext_msg='N_iter_max')

!--------------------------------------------------------------------------------------------------
! Setup FEM mech mesh
  call DMClone(geomMesh,mechanical_mesh,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGetDimension(mechanical_mesh,dimPlex,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMSetFromOptions(mechanical_mesh,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMPlexIsSimplex(mechanical_mesh,is_simplex,err_PETSc)
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! Setup FEM mech discretization
#if PETSC_VERSION_MINOR>=24
  if (is_simplex) then
    call PetscDTSimplexQuadrature(dimPlex,num%p_i,PETSCDTSIMPLEXQUAD_DEFAULT,mechQuad,err_PETSc)
  else
    num%p_i = num%p_i + 1_pPETSCINT                                                                 ! adjust for quad/hex (non-simplex)
    call PetscDTGaussTensorQuadrature(dimPlex,dimPlex,num%p_i,-1.0_pREAL,1.0_pREAL,mechQuad,err_PETSc)
  end if
#elif PETSC_VERSION_MINOR==23
  if (.not. is_simplex) call IO_error(800_pI16, 'mesh is not a simplex')
  call PetscDTSimplexQuadrature(dimPlex,num%p_i,PETSCDTSIMPLEXQUAD_DEFAULT,mechQuad,err_PETSc)
#else
  if (.not. is_simplex) call IO_error(800_pI16, 'mesh is not a simplex')
  call PetscDTSimplexQuadrature(dimPlex,num%p_i,-1,mechQuad,err_PETSc)
#endif
  CHKERRQ(err_PETSc)

#if PETSC_VERSION_MINOR>21
  call PetscQuadratureGetData(mechQuad,PETSC_NULL_INTEGER,PETSC_NULL_INTEGER, &
                              nQuadrature,PETSC_NULL_REAL_POINTER,qWeightsP,err_PETSc)
  CHKERRQ(err_PETSc)
  qWeights = qWeightsP
  call PetscQuadratureRestoreData(mechQuad,PETSC_NULL_INTEGER,PETSC_NULL_INTEGER, &
                                  PETSC_NULL_INTEGER,PETSC_NULL_REAL_POINTER,qWeightsP, &
                                  err_PETSc)
#else
  call PetscQuadratureGetData(mechQuad,PETSC_NULL_INTEGER(1),PETSC_NULL_INTEGER(1), &
                              nQuadrature,PETSC_NULL_REAL_POINTER,qWeightsP,err_PETSc)
  CHKERRQ(err_PETSc)
  qWeights = qWeightsP
  call PetscQuadratureRestoreData(mechQuad,PETSC_NULL_INTEGER(1),PETSC_NULL_INTEGER(1), &
                                  PETSC_NULL_INTEGER(1),PETSC_NULL_REAL_POINTER,qWeightsP, &
                                  err_PETSc)
#endif
  CHKERRQ(err_PETSc)

  if (.not. is_simplex) qWeights = qWeights(::dimPlex)                                              ! duplicates per component not needed
  nc = dimPlex
  call PetscFECreateDefault(PETSC_COMM_SELF,dimPlex,nc,is_simplex,prefix,num%p_i,mechFE,err_PETSc)
  CHKERRQ(err_PETSc)
  call PetscFESetQuadrature(mechFE,mechQuad,err_PETSc)
  CHKERRQ(err_PETSc)
  call PetscFEGetDimension(mechFE,nBasis,err_PETSc)
  CHKERRQ(err_PETSc)
  nBasis = nBasis/nc
#if PETSC_VERSION_MINOR>22
  call DMAddField(mechanical_mesh,PETSC_NULL_DMLABEL,PetscObjectCast(mechFE),err_PETSc)
#else
  call DMAddField(mechanical_mesh,PETSC_NULL_DMLABEL,mechFE,err_PETSc)
#endif
  CHKERRQ(err_PETSc)
  call DMCreateDS(mechanical_mesh,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGetDS(mechanical_mesh,mechDS,err_PETSc)
  CHKERRQ(err_PETSc)
  call PetscDSGetTotalDimension(mechDS,cellDof,err_PETSc)
  CHKERRQ(err_PETSc)
  call PetscFEDestroy(mechFE,err_PETSc)
  CHKERRQ(err_PETSc)
  call PetscQuadratureDestroy(mechQuad,err_PETSc)
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! Setup FEM mech boundary conditions
  do n = 1, size(PETSC_GENERIC_LABELS) - 1                                                          ! not needed for vertices
    call DMHasLabel(mechanical_mesh, PETSC_GENERIC_LABELS(n), has_label, err_PETSc)
    if (has_label) then
      call DMGetLabel(mechanical_mesh, PETSC_GENERIC_LABELS(n), dm_label, err_PETSc)
      CHKERRQ(err_PETSc)
      call DMPlexLabelComplete(mechanical_mesh, dm_label, err_PETSc)
      CHKERRQ(err_PETSc)
    end if
  end do

  call DMGetLocalSection(mechanical_mesh,section,err_PETSc)
  CHKERRQ(err_PETSc)
  allocate(n_comp(1), source=dimPlex)
  allocate(n_dof(0:dimPlex), source = 0_pPETSCINT)
  do topologDim = 0_pPETSCINT, dimPlex
    call DMPlexGetDepthStratum(mechanical_mesh, topologDim, cellStart, cellEnd, err_PETSc)
    CHKERRQ(err_PETSc)
    call PetscSectionGetDof(section, cellStart, n_dof(topologDim), err_PETSc)
    CHKERRQ(err_PETSc)
  end do
  n_displacement_BC = sum([(count(mechBC(boundary)%active == BC_TYPE_U_DOT .or. &
                                  mechBC(boundary)%active == BC_TYPE_U), boundary = 1, size(mechBC))])
  allocate(BC_field(n_displacement_BC), source = 0_pPETSCINT)
  allocate(BC_comps_IS(n_displacement_BC))
  allocate(BC_points_IS(n_displacement_BC))
  d = 0_pPETSCINT
  do boundary = 1_pPETSCINT, mesh_Nboundaries
    BC_label = PETSC_GENERIC_LABELS(mesh_boundariesIdx(boundary))
    do component = 1_pPETSCINT, dimPlex
      if (mechBC(boundary)%active(component) == BC_TYPE_U_DOT .or. &
          mechBC(boundary)%active(component) == BC_TYPE_U) then
        d = d + 1_pPETSCINT
        call ISCreateGeneral(PETSC_COMM_WORLD,1_pPETSCINT,[component-1_pPETSCINT],PETSC_COPY_VALUES, &
                             BC_comps_IS(d),err_PETSc)
        CHKERRQ(err_PETSc)
        call DMGetStratumIS(mechanical_mesh,BC_label,mesh_boundariesIS(boundary), &
                            label_points_IS,err_PETSc)
        CHKERRQ(err_PETSc)
        call ISGetIndices(label_points_IS,label_points,err_PETSc)
        CHKERRQ(err_PETSc)
        call ISCreateGeneral(PETSC_COMM_WORLD,int(size(label_points),pPETSCINT),label_points, &
                             PETSC_COPY_VALUES,BC_points_IS(d),err_PETSc)
        CHKERRQ(err_PETSc)
        call ISRestoreIndices(label_points_IS,label_points,err_PETSc)
        CHKERRQ(err_PETSc)
        call ISDestroy(label_points_IS,err_PETSc)
        CHKERRQ(err_PETSc)
      end if
    end do
  end do
  call DMPlexCreateSection(mechanical_mesh,PETSC_NULL_DMLABEL_ARRAY,n_comp,n_dof, &
                           n_displacement_BC,BC_field,BC_comps_IS,BC_points_IS,PETSC_NULL_IS,section,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMSetLocalSection(mechanical_mesh,section,err_PETSc)
  CHKERRQ(err_PETSc)
  do boundary = 1_pPETSCINT, n_displacement_BC
    call ISDestroy(BC_points_IS(boundary),err_PETSc)
    CHKERRQ(err_PETSc)
    call ISDestroy(BC_comps_IS(boundary),err_PETSc)
    CHKERRQ(err_PETSc)
  end do
  deallocate(BC_field)

!--------------------------------------------------------------------------------------------------
! initialize solver specific parts of PETSc
  call SNESCreate(PETSC_COMM_WORLD,mechanical_snes,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESSetOptionsPrefix(mechanical_snes,'mechanical_',err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESSetDM(mechanical_snes,mechanical_mesh,err_PETSc)                                         ! set the mesh for non-linear solver
  CHKERRQ(err_PETSc)
  call SNESSetFromOptions(mechanical_snes,err_PETSc)
  CHKERRQ(err_PETSc)
  call SnesSetLagJacobian(mechanical_snes,10_pPETSCINT, err_PETSc)
  CHKERRQ(err_PETSc)
  call DMCreateGlobalVector(mechanical_mesh,u,err_PETSc)                                            ! global solution vector {u}
  CHKERRQ(err_PETSc)
  call DMCreateGlobalVector(mechanical_mesh,u_rate,err_PETSc)                                       ! locally owned velocity Dofs to guess solution at next load step
  CHKERRQ(err_PETSc)
  call DMCreateGlobalVector(mechanical_mesh,f_ext,err_PETSc)                                        ! global external forces vector (used as RHS in K u = f)
  CHKERRQ(err_PETSc)
  call DMCreateGlobalVector(mechanical_mesh,f_aim_rate,err_PETSc)                                   ! global (per step) force rate
  CHKERRQ(err_PETSc)
  call DMCreateGlobalVector(mechanical_mesh,f_ext_prev,err_PETSc)                                   ! previous step global {f_ext}
  CHKERRQ(err_PETSc)
  call DMCreateLocalVector(mechanical_mesh,u_aim,err_PETSc)                                         ! local displacement aim at end of step
  CHKERRQ(err_PETSc)
  call DMCreateLocalVector(mechanical_mesh,u_aim_rate,err_PETSc)                                    ! local (per step) displacement rate
  CHKERRQ(err_PETSc)
  call DMCreateLocalVector(mechanical_mesh,u_aim_prev,err_PETSc)                                    ! previous step {u_aim_rate}
  CHKERRQ(err_PETSc)
  call DMCreateLocalVector(mechanical_mesh,u_local,err_PETSc)                                       ! local solution vector {u}
  CHKERRQ(err_PETSc)
  call DMCreateLocalVector(mechanical_mesh,x_local,err_PETSc)                                       ! current coordinates (with latest solution update)
  CHKERRQ(err_PETSc)
  call DMSNESSetFunctionLocal(mechanical_mesh,FEM_mechanical_formResidual,PETSC_NULL_VEC,err_PETSc) ! function to evaluate residual forces
  CHKERRQ(err_PETSc)
  call DMSNESSetJacobianLocal(mechanical_mesh,FEM_mechanical_formJacobian,PETSC_NULL_VEC,err_PETSc) ! function to evaluate stiffness matrix
  CHKERRQ(err_PETSc)
  call SNESSetMaxLinearSolveFailures(mechanical_snes,huge(1_pPETSCINT),err_PETSc)                   ! ignore linear solve failures
  CHKERRQ(err_PETSc)
  call SNESSetConvergenceTest(mechanical_snes,FEM_mechanical_converged,PETSC_NULL_VEC, &            ! function to check for convergence
                              PETSC_NULL_FUNCTION,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESSetTolerances(mechanical_snes,1.0e-5_pREAL,1.0e-6_pREAL,1.0e-6_pREAL,num%itmax, &        ! tolerances (absolute/relative/update), max func evals, max iters
                         num%itmax,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESSetFromOptions(mechanical_snes,err_PETSc)                                                ! "PETSc_options" flags from numerics file
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! init fields
  call VecZeroEntries(u,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecZeroEntries(u_rate,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecZeroEntries(f_ext,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecZeroEntries(f_aim_rate,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecZeroEntries(u_aim,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecZeroEntries(x_local,err_PETSc)
  CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR>22
  call PetscDSGetDiscretization(mechDS,0_pPETSCINT,obj,err_PETSc)
  PetscObjectSpecificCast(mechFE,obj)
#else
  call PetscDSGetDiscretization(mechDS,0_pPETSCINT,mechFE,err_PETSc)
#endif
  CHKERRQ(err_PETSc)
  call PetscFEGetDualSpace(mechFE,mechDualSpace,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMPlexGetHeightStratum(mechanical_mesh,0_pPETSCINT,cellStart,cellEnd,err_PETSc)
  CHKERRQ(err_PETSc)

  nCoords = size(x_n(1:dimPlex,:),kind=pPETSCINT)
  nodeCoords = pack(x_n(1:dimPlex,:), .true.)
  idx = [(nc, nc = 0_pPETSCINT, nCoords - 1_pPETSCINT)]
  call VecSetValuesLocal(u_local, nCoords, idx, nodeCoords, INSERT_VALUES, err_PETSc)               ! initial node coordinates (undeformed)
  CHKERRQ(err_PETSc)
  call VecAssemblyBegin(u_local, err_PETSc)
  CHKERRQ(err_PETSc)
  call VecAssemblyEnd(u_local, err_PETSc)
  CHKERRQ(err_PETSc)

  call utilities_constitutiveResponse(status,0.0_pREAL,devNull,.true.)

end subroutine FEM_mechanical_init


!--------------------------------------------------------------------------------------------------
!> @brief solution for the FEM load step
!--------------------------------------------------------------------------------------------------
  type(tSolutionState) function FEM_mechanical_solution( &
             incInfoIn,Delta_t,Delta_t_prev,mechBC)

!--------------------------------------------------------------------------------------------------
! input data for solution
  real(pREAL), intent(in) :: &
    Delta_t, &                                                                                      !< increment in time for current solution
    Delta_t_prev                                                                                    !< increment in time of last increment
  type(tMechBC), dimension(:),intent(in) :: &
    mechBC
  character(len=*), intent(in) :: &
    incInfoIn

  PetscErrorCode :: err_PETSc
  SNESConvergedReason :: reason

  incInfo = incInfoIn
  FEM_mechanical_solution%converged = .false.
!--------------------------------------------------------------------------------------------------
! set module wide availabe data
  params%Delta_t = Delta_t
  params%mechBC = mechBC

  call SNESSolve(mechanical_snes,f_ext,u,err_PETSc)                                                 ! solve mechanical_snes (RHS = f_ext, initial guess = u; result in u)
  CHKERRQ(err_PETSc)
  call SNESGetConvergedReason(mechanical_snes,reason,err_PETSc)                                     ! solution converged?
  CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR>22
  if (reason%v <= SNES_CONVERGED_ITERATING%v) then
#else
  if (reason < 1) then                                                                              ! 0: still iterating (will not occur), negative -> convergence error
#endif
    FEM_mechanical_solution%converged = .false.
    FEM_mechanical_solution%iter_needed = num%itmax
  else                                                                                              ! >= 1 proper convergence (or broken)
    FEM_mechanical_solution%converged = .true.
    call SNESGetIterationNumber(mechanical_snes,FEM_mechanical_solution%iter_needed,err_PETSc)
    CHKERRQ(err_PETSc)
  end if

end function FEM_mechanical_solution


!--------------------------------------------------------------------------------------------------
!> @brief Form the FEM residual vector.
!--------------------------------------------------------------------------------------------------
subroutine FEM_mechanical_formResidual(dm_local,delta_u_local,f_internal_vec,dummy,err_PETSc)

  DM,          intent(in) :: dm_local                                                               !> DM
  Vec,         intent(in) :: delta_u_local                                                          !> latest displacement solution increment
  Vec                     :: f_internal_vec                                                         !> (local) internal forces vector
  PetscObject, intent(in) :: dummy
  PetscErrorCode          :: err_PETSc

  integer(MPI_INTEGER_KIND) :: err_MPI
  PetscDS         :: prob
  PetscSection    :: section
#if PETSC_VERSION_MINOR>=24
  PetscQuadrature :: quadrature
#endif
  real(pREAL), dimension(:), pointer      :: x_scal, pf_internal
  real(pREAL), dimension(cellDof), target :: f_internal
  PetscReal,   dimension(dimPlex,dimPlex) :: invCellJ
#if PETSC_VERSION_MINOR>=24
  PetscReal, dimension(:), pointer :: pCellJ, pInvCellJ, pDetJ                                      ! (pointer) cell / inverse / determinant jacobian
#else
  PetscReal, dimension(:), pointer :: pV0, pCellJ, pInvCellJ                                        ! cell first node / jacobian / inverse jacobian
  PetscReal                        :: detJ                                                          ! jacobian determinant
#endif
#if PETSC_VERSION_MINOR>22
  PetscTabulation, pointer :: tab(:)                                                                ! shape function tabulation
#else
  PetscReal, dimension(:), pointer :: basisFieldDer, &                                              ! shape functions first derivative
                                      dev_null
#endif
  PetscInt  :: cellStart, cellEnd, cell, &
               qPt, basis, comp, cidx, &
               numFields, m,i
  PetscReal, dimension(dimPlex*dimPlex,cellDof) :: BMat                                             ! strain-displacement [B] matrix
#if PETSC_VERSION_MINOR>=24
  PetscBool :: is_simplex


  allocate(pCellJ(nQuadrature*dimPlex**2))
  allocate(pInvCellJ(nQuadrature*dimPlex**2))
  allocate(pDetJ(nQuadrature))
#else
  allocate(pV0(dimPlex))
  allocate(pCellJ(dimPlex**2))
  allocate(pInvCellJ(dimPlex**2))
#endif
  allocate(x_scal(cellDof))

  call DMGetLocalSection(dm_local,section,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMPlexGetHeightStratum(dm_local,0_pPETSCINT,cellStart,cellEnd,err_PETSc)
  CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR>=24
  call DMPlexIsSimplex(dm_local,is_simplex,err_PETSc)
  CHKERRQ(err_PETSc)
#endif
  call VecWAXPY(x_local,1.0_pREAL,delta_u_local,u_local,err_PETSc)
  CHKERRQ(err_PETSc)
  call utilities_projectDisplacementBC(x_local,u_aim_rate,params%Delta_t)                           ! enforce displacement BC

!--------------------------------------------------------------------------------------------------
! evaluate field derivatives
  call DMGetDS(dm_local,prob,err_PETSc)
  CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR>22
  call PetscDSGetTabulation(prob,tab,err_PETSc)
#else
  call PetscDSGetTabulation(prob,0_pPETSCINT,dev_null,basisFieldDer,err_PETSc)
#endif
  CHKERRQ(err_PETSc)

#if PETSC_VERSION_MINOR>=24
  if (is_simplex) then
    call PetscDTSimplexQuadrature(dimPlex,num%p_i,PETSCDTSIMPLEXQUAD_DEFAULT, &
                                  quadrature,err_PETSc)
  else
    call PetscDTGaussTensorQuadrature(dimPlex,dimPlex,num%p_i,-1.0_pREAL,1.0_pREAL, &
                                      quadrature,err_PETSc)
  end if
#endif
  CHKERRQ(err_PETSc)

  do cell = cellStart, cellEnd-1_pPETSCINT
    call PetscSectionGetNumFields(section,numFields,err_PETSc)
    CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR>22
    call DMPlexVecGetClosure(dm_local,section,x_local,cell,PETSC_NULL_INTEGER,x_scal,err_PETSc)     ! get Dofs belonging to element
#else
    call DMPlexVecGetClosure(dm_local,section,x_local,cell,x_scal,err_PETSc)                        ! get Dofs belonging to element
#endif
    CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR>=24
    call DMPlexComputeCellGeometryFEM(dm_local,cell,quadrature,PETSC_NULL_REAL_ARRAY,pCellJ, &
                                      pInvCellJ,pDetJ,err_PETSc)
#else
    call DMPlexComputeCellGeometryAffineFEM(dm_local,cell,pV0,pCellJ,pInvCellJ,detJ,err_PETSc)
#endif
    CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR<24
    invCellJ = reshape(pInvCellJ, shape=[dimPlex,dimPlex])
#endif
    do qPt = 0_pPETSCINT, nQuadrature-1_pPETSCINT
      m = cell*nQuadrature + qPt+1_pPETSCINT
      BMat = 0.0_pREAL
#if PETSC_VERSION_MINOR>=24
      invCellJ = reshape(pInvCellJ(qPt*dimPlex**2+1_pPETSCINT:(qPt+1_pPETSCINT)*dimPlex**2), &
                         shape=[dimPlex,dimPlex])
#endif
      do basis = 0_pPETSCINT, nBasis-1_pPETSCINT
        do comp = 0_pPETSCINT, dimPlex-1_pPETSCINT
          cidx = basis*dimPlex+comp
          i = ((qPt*nBasis + basis)*dimPlex + comp)*dimPlex+comp
          BMat(comp*dimPlex+1_pPETSCINT:(comp+1_pPETSCINT)*dimPlex,basis*dimPlex+comp+1_pPETSCINT) = &
#if PETSC_VERSION_MINOR>22
            matmul(invCellJ,tab(1)%ptr%T(2)%ptr(i*dimPlex+1_pPETSCINT:(i+1_pPETSCINT)*dimPlex))
#else
            matmul(invCellJ,basisFieldDer(i*dimPlex+1_pPETSCINT:(i+1_pPETSCINT)*dimPlex))
#endif
        end do
      end do
      homogenization_F(1:dimPlex,1:dimPlex,m) = reshape(matmul(BMat,x_scal),shape=[dimPlex,dimPlex], order=[2,1])
    end do
#if PETSC_VERSION_MINOR>22
    call DMPlexVecRestoreClosure(dm_local,section,x_local,cell,PETSC_NULL_INTEGER,x_scal,err_PETSc)
#else
    call DMPlexVecRestoreClosure(dm_local,section,x_local,cell,x_scal,err_PETSc)
#endif
    CHKERRQ(err_PETSc)
  end do

!--------------------------------------------------------------------------------------------------
! evaluate constitutive response
  call utilities_constitutiveResponse(status,params%Delta_t,P_av,ForwardData)
  call MPI_Allreduce(MPI_IN_PLACE,status,1_MPI_INTEGER_KIND,MPI_INTEGER,MPI_MAX,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  ForwardData = .false.

!--------------------------------------------------------------------------------------------------
! integrating residual
  do cell = cellStart, cellEnd-1_pPETSCINT                                                          ! loop over all elements
#if PETSC_VERSION_MINOR>22
    call DMPlexVecGetClosure(dm_local,section,x_local,cell,PETSC_NULL_INTEGER,x_scal,err_PETSc)     ! get Dofs belonging to element
#else
    call DMPlexVecGetClosure(dm_local,section,x_local,cell,x_scal,err_PETSc)                        ! get Dofs belonging to element
#endif
    CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR>=24
    call DMPlexComputeCellGeometryFEM(dm_local,cell,quadrature,PETSC_NULL_REAL_ARRAY,pCellJ, &
                                      pInvCellJ,pDetJ,err_PETSc)
#else
    call DMPlexComputeCellGeometryAffineFEM(dm_local,cell,pV0,pCellJ,pInvCellJ,detJ,err_PETSc)
#endif
    CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR<24
    invCellJ = reshape(pInvCellJ, shape=[dimPlex,dimPlex])
#endif
    f_internal = 0.0_pREAL
    do qPt = 0_pPETSCINT, nQuadrature-1_pPETSCINT
      m = cell*nQuadrature + qPt+1_pPETSCINT
      BMat = 0.0_pREAL
#if PETSC_VERSION_MINOR>=24
      invCellJ = reshape(pInvCellJ(qPt*dimPlex**2+1_pPETSCINT:(qPt+1_pPETSCINT)*dimPlex**2), &
                         shape=[dimPlex,dimPlex])
#endif
      do basis = 0_pPETSCINT, nBasis-1_pPETSCINT
        do comp = 0_pPETSCINT, dimPlex-1_pPETSCINT
          cidx = basis*dimPlex+comp
          i = ((qPt*nBasis + basis)*dimPlex + comp)*dimPlex+comp
          BMat(comp*dimPlex+1_pPETSCINT:(comp+1_pPETSCINT)*dimPlex,basis*dimPlex+comp+1_pPETSCINT) = &
#if PETSC_VERSION_MINOR>22
            matmul(invCellJ,tab(1)%ptr%T(2)%ptr(i*dimPlex+1_pPETSCINT:(i+1_pPETSCINT)*dimPlex))
#else
            matmul(invCellJ,basisFieldDer(i*dimPlex+1_pPETSCINT:(i+1_pPETSCINT)*dimPlex))
#endif
        end do
      end do
#if PETSC_VERSION_MINOR>=24
      f_internal = f_internal + pDetJ(qPt+1_pPETSCINT) * qWeights(qPt+1_pPETSCINT) &
#else
      f_internal = f_internal + abs(detJ) * qWeights(qPt+1_pPETSCINT) &
#endif
            * matmul(transpose(BMat), &
                     reshape(transpose(homogenization_P(1:dimPlex,1:dimPlex,m)), &
                             shape=[dimPlex*dimPlex]))
    end do
    pf_internal => f_internal
    call DMPlexVecSetClosure(dm_local,section,f_internal_vec,cell,pf_internal,ADD_VALUES,err_PETSc)
    CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR>22
    call DMPlexVecRestoreClosure(dm_local,section,x_local,cell,PETSC_NULL_INTEGER,x_scal,err_PETSc)
#else
    call DMPlexVecRestoreClosure(dm_local,section,x_local,cell,x_scal,err_PETSc)
#endif
    CHKERRQ(err_PETSc)
  end do
#if PETSC_VERSION_MINOR>22
  call PetscDSRestoreTabulation(prob,tab,err_PETSc)
#else
  call PetscDSRestoreTabulation(prob,0_pPETSCINT,dev_null,basisFieldDer,err_PETSc)
#endif
  CHKERRQ(err_PETSc)

end subroutine FEM_mechanical_formResidual


!--------------------------------------------------------------------------------------------------
!> @brief Form the FEM stiffness matrix.
!--------------------------------------------------------------------------------------------------
subroutine FEM_mechanical_formJacobian(dm_local,delta_u_local,J,Jp,dummy,err_PETSc)

  DM                      :: dm_local                                                               !> DM
  Vec                     :: delta_u_local                                                          !> latest displacement solution increment
  Mat                     :: J, Jp                                                                  !> jacobian, preconditioner
  PetscObject, intent(in) :: dummy
  PetscErrorCode          :: err_PETSc


  PetscDS      :: prob
  PetscSection :: section, gSection
#if PETSC_VERSION_MINOR>=24
  PetscQuadrature :: quadrature
#endif

  PetscReal, dimension(1,         cellDof) :: MatB
  PetscReal, dimension(dimPlex**2,cellDof) :: BMat, &                                               ! strain-displacement [B] matrix
                                              MatA
#if PETSC_VERSION_MINOR>=24
  real(pREAL), dimension(:), pointer :: pCellJ, pInvCellJ, pDetJ                                    ! (pointer) cell / inverse / determinant jacobian
#else
  real(pREAL), dimension(:), pointer :: pV0, pCellJ, pInvCellJ                                      ! cell first node / jacobian / inverse jacobian
  PetscReal :: detJ                                                                                 ! jacobian determinant
#endif
#if PETSC_VERSION_MINOR>22
  PetscTabulation, pointer :: tab(:)                                                                ! shape function tabulation
#else
  PetscReal,   dimension(:), pointer :: basisFieldDer, &                                            ! shape functions first derivative
                                        dev_null
#endif
  real(pREAL), dimension(:), pointer :: pK_e                                                        ! (pointer) element tangent stiffness
  real(pREAL), dimension(cellDOF,cellDOF), target :: K_e                                            ! element tangent stiffness
  real(pREAL), dimension(dimPlex,dimPlex)         :: invCellJ                                       ! cell inverse jacobian

  PetscInt :: cellStart, cellEnd, cell, &
              qPt, basis, comp, cidx, ce, i
#if PETSC_VERSION_MINOR>=24
  PetscBool :: is_simplex
#endif

#if PETSC_VERSION_MINOR>=24
  allocate(pCellJ(nQuadrature*dimPlex**2))
  allocate(pInvcellJ(nQuadrature*dimPlex**2))
  allocate(pDetJ(nQuadrature))
#else
  allocate(pV0(dimPlex))
  allocate(pCellJ(dimPlex**2))
  allocate(pInvCellJ(dimPlex**2))
#endif

  call MatSetOption(Jp,MAT_KEEP_NONZERO_PATTERN,PETSC_TRUE,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatSetOption(Jp,MAT_NEW_NONZERO_ALLOCATION_ERR,PETSC_FALSE,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatZeroEntries(Jp,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGetDS(dm_local,prob,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGetLocalSection(dm_local,section,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGetGlobalSection(dm_local,gSection,err_PETSc)
  CHKERRQ(err_PETSc)

#if PETSC_VERSION_MINOR>22
  call PetscDSGetTabulation(prob,tab,err_PETSc)
#else
  call PetscDSGetTabulation(prob,0_pPETSCINT,dev_null,basisFieldDer,err_PETSc)
#endif
  CHKERRQ(err_PETSc)
  call DMPlexGetHeightStratum(dm_local,0_pPETSCINT,cellStart,cellEnd,err_PETSc)
  CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR>=24
  call DMPlexIsSimplex(dm_local,is_simplex,err_PETSc)
  CHKERRQ(err_PETSc)
  if (is_simplex) then
    call PetscDTSimplexQuadrature(dimPlex,num%p_i,PETSCDTSIMPLEXQUAD_DEFAULT, &
                                  quadrature,err_PETSc)
  else
    call PetscDTGaussTensorQuadrature(dimPlex,dimPlex,num%p_i,-1.0_pREAL,1.0_pREAL, &
                                      quadrature,err_PETSc)
  end if
  CHKERRQ(err_PETSc)
#endif
  do cell = cellStart, cellEnd-1_pPETSCINT
#if PETSC_VERSION_MINOR>=24
    call DMPlexComputeCellGeometryFEM(dm_local,cell,quadrature,PETSC_NULL_REAL_ARRAY,pCellJ, &
                                      pInvCellJ,pDetJ,err_PETSc)
#else
    call DMPlexComputeCellGeometryAffineFEM(dm_local,cell,pV0,pCellJ,pInvCellJ,detJ,err_PETSc)
#endif
    CHKERRQ(err_PETSc)
    K_e  =  0.0_pREAL
    MatB = 0.0_pREAL
#if PETSC_VERSION_MINOR<24
    invCellJ = reshape(pInvCellJ, shape=[dimPlex,dimPlex])
#endif
    do qPt = 0_pPETSCINT, nQuadrature-1_pPETSCINT
      ce = cell*nQuadrature + qPt + 1_pPETSCINT
      BMat = 0.0_pREAL
#if PETSC_VERSION_MINOR>=24
      invCellJ = reshape(pInvCellJ(qPt*dimPlex**2+1_pPETSCINT:(qPt+1_pPETSCINT)*dimPlex**2), &
                         shape=[dimPlex,dimPlex])
#endif
      do basis = 0_pPETSCINT, nBasis-1_pPETSCINT
        do comp = 0_pPETSCINT, dimPlex-1_pPETSCINT
          cidx = basis*dimPlex+comp
          i = ((qPt*nBasis + basis)*dimPlex + comp)*dimPlex+comp
          BMat(comp*dimPlex+1_pPETSCINT:(comp+1_pPETSCINT)*dimPlex,basis*dimPlex+comp+1_pPETSCINT) = &
#if PETSC_VERSION_MINOR>22
            matmul(invCellJ,tab(1)%ptr%T(2)%ptr(i*dimPlex+1_pPETSCINT:(i+1_pPETSCINT)*dimPlex))
#else
            matmul(invCellJ,basisFieldDer(i*dimPlex+1_pPETSCINT:(i+1_pPETSCINT)*dimPlex))
#endif
        end do
      end do
#if PETSC_VERSION_MINOR>=24
      MatA = qWeights(qPt+1_pPETSCINT) * pDetJ(qPt+1_pPETSCINT) &
#else
      MatA = qWeights(qPt+1_pPETSCINT) * abs(detJ) &
#endif
           * matmul(reshape(reshape(homogenization_dPdF(1:dimPlex,1:dimPlex,1:dimPlex,1:dimPlex,ce), &
                                    shape=[dimPlex,dimPlex,dimPlex,dimPlex], order=[2,1,4,3]), &
                            shape=[dimPlex*dimPlex,dimPlex*dimPlex]),BMat)

      K_e = K_e + matmul(transpose(BMat),MatA)
    end do
    K_e = K_e + eps*math_eye(int(cellDof))
    pK_e(1:cellDOF**2) => K_e
    call DMPlexMatSetClosure(dm_local,section,gSection,Jp,cell,pK_e,ADD_VALUES,err_PETSc)
    CHKERRQ(err_PETSc)
  end do
  call MatAssemblyBegin(Jp,MAT_FINAL_ASSEMBLY,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatAssemblyEnd(Jp,MAT_FINAL_ASSEMBLY,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatAssemblyBegin(J,MAT_FINAL_ASSEMBLY,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatAssemblyEnd(J,MAT_FINAL_ASSEMBLY,err_PETSc)
  CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR>22
  call PetscDSRestoreTabulation(prob,tab,err_PETSc)
#else
  call PetscDSRestoreTabulation(prob,0_pPETSCINT,dev_null,basisFieldDer,err_PETSc)
#endif
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! apply boundary conditions
  call DMPlexCreateRigidBody(dm_local,0_pPETSCINT,matnull,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatSetNullSpace(Jp,matnull,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatSetNearNullSpace(Jp,matnull,err_PETSc)
  CHKERRQ(err_PETSc)
  call MatNullSpaceDestroy(matnull,err_PETSc)
  CHKERRQ(err_PETSc)

end subroutine FEM_mechanical_formJacobian


!--------------------------------------------------------------------------------------------------
!> @brief forwarding routine
!--------------------------------------------------------------------------------------------------
subroutine FEM_mechanical_forward(guess,Delta_t,Delta_t_prev)

  logical,     intent(in) :: &
    guess
  real(pREAL), intent(in) :: &
    Delta_t_prev, &
    Delta_t

  DM             :: dm_local
  PetscSection   :: section
  PetscErrorCode :: err_PETSc

!--------------------------------------------------------------------------------------------------
! forward last inc
  if (guess .and. .not. cutBack) then
    ForwardData = .True.
    call SNESGetDM(mechanical_snes,dm_local,err_PETSc)                                              ! retrieve mesh info from mechanical_snes into dm_local
    CHKERRQ(err_PETSc)
    call DMGetLocalSection(dm_local,section,err_PETSc)
    CHKERRQ(err_PETSc)
    call VecCopy(x_local, u_local, err_PETSc)                                                       ! update solution (used as starting point for next step)
    CHKERRQ(err_PETSc)
!--------------------------------------------------------------------------------------------------
! update rate and forward last inc
    call VecCopy(u,u_rate,err_PETSc)
    CHKERRQ(err_PETSc)
    call VecScale(u_rate,Delta_t_prev**(-1),err_PETSc)
    CHKERRQ(err_PETSc)
  end if

  if (cutback) then                                                                                 ! adjust (decrease) incremental load
    call VecAXPY(f_ext,-Delta_t_prev,f_aim_rate,err_PETSc)                                          ! back to previous time step value
    CHKERRQ(err_PETSc)
  end if

  call VecCopy(u_rate,u,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecScale(u,Delta_t,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecAXPY(f_ext,Delta_t,f_aim_rate,err_PETSc)                                                  ! f = f + dt * rate
  CHKERRQ(err_PETSc)

end subroutine FEM_mechanical_forward


!--------------------------------------------------------------------------------------------------
!> @brief Build external forces vector.
!> @details Build at the beginning of a load step. Compute the end-of-step aim forces
!> @details f_aim_(local), and the required rate to achieve them (f_aim_rate).
!--------------------------------------------------------------------------------------------------
subroutine FEM_mechanical_assembleFext(mechBC, Delta_t)

  type(tMechBC), dimension(:), intent(in) :: &
    mechBC                                                                                          !< loadcase boundary conditions data
  real(pREAL),                 intent(in) :: &
    Delta_t                                                                                         !< total load step time

  DM             :: dm_local
  Vec            :: f_aim_local                                                                     ! external forces (built from YAML, aim at end of step)
  PetscErrorCode :: err_PETSc


  call SNESGetDM(mechanical_snes,dm_local,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecCopy(f_ext, f_ext_prev, err_PETSc)                                                        ! previous f_ext needed for force rates
  CHKERRQ(err_PETSc)
  call DMGetLocalVector(dm_local, f_aim_local, err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGlobalToLocalBegin(dm_local,f_ext,INSERT_VALUES,f_aim_local,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGlobalToLocalEnd(dm_local,f_ext,INSERT_VALUES,f_aim_local,err_PETSc)
  CHKERRQ(err_PETSc)
  call utilities_assembleFext(f_aim_local, dm_local, mechBC, Delta_t)
  call DMLocalToGlobalBegin(dm_local,f_aim_local,INSERT_VALUES,f_aim_rate,err_PETSc)                ! build global f_aim (into f_aim_rate)
  CHKERRQ(err_PETSc)
  call DMLocalToGlobalEnd(dm_local,f_aim_local,INSERT_VALUES,f_aim_rate,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMRestoreLocalVector(dm_local, f_aim_local, err_PETSc)
  CHKERRQ(err_PETSc)
  call VecAXPY(f_aim_rate,-1.0_pREAL,f_ext_prev,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecScale(f_aim_rate,1.0_pREAL/Delta_t,err_PETSc)                                             ! f rate: f_aim_rate = (f_aim - f_prev) / dt
  CHKERRQ(err_PETSc)

end subroutine FEM_mechanical_assembleFext


!--------------------------------------------------------------------------------------------------
!> @brief Build displacement vector.
!> @details Build at the beginning of a load step. Compute the end-of-step aim displacements
!> @details u_aim, and the required rate to achieve them (u_aim_rate).
!> @details NOTE: All these vectors are local.
!--------------------------------------------------------------------------------------------------
subroutine FEM_mechanical_assembleU(mechBC, Delta_t)

  type(tMechBC), dimension(:), intent(in) :: &
    mechBC                                                                                          !< loadcase boundary conditions data
  real(pREAL),                 intent(in) :: &
    Delta_t                                                                                         !< total load step time

  DM             :: dm_local
  PetscErrorCode :: err_PETSc


  call SNESGetDM(mechanical_snes,dm_local,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecCopy(u_aim, u_aim_prev, err_PETSc)                                                        ! previous u_aim needed for force rates
  CHKERRQ(err_PETSc)
  call utilities_assembleU(u_aim, dm_local, mechBC, Delta_t)
  call VecWAXPY(u_aim_rate,-1.0_pREAL,u_aim_prev,u_aim,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecScale(u_aim_rate,1.0_pREAL/Delta_t,err_PETSc)                                             ! u rate: u_aim_rate = (u_aim - u_prev) / dt
  CHKERRQ(err_PETSc)

end subroutine FEM_mechanical_assembleU


!--------------------------------------------------------------------------------------------------
!> @brief Report solver status: continue iterating, converged or diverged.
!--------------------------------------------------------------------------------------------------
subroutine FEM_mechanical_converged(snes,iter,x_norm,s_norm,f_norm,reason,dummy,err_PETSc)

  SNES :: snes                                                                                      !< (local) SNES
  PetscInt :: iter                                                                                  !< current iteration
  PetscReal :: x_norm, s_norm, f_norm                                                               !< solution / solution update / residual norms
  SNESConvergedReason :: reason                                                                     !< reason of convergence/divergence
  PetscObject :: dummy                                                                              !< PETSc context object (unused)
  PetscErrorCode :: err_PETSc

#if PETSC_VERSION_MINOR>22
  Vec         :: rhs_vec                                                                            ! current step RHS (f_external) vector
#endif
  PetscInt    :: n_f_evals, n_ls_its                                                                ! number of function evaluations/linear solve iterations
  real(pREAL) :: abs_tol, rel_tol, sol_tol, rhs_tol, &                                              ! absolute/relative/update/rhs tolerances
                 r_norm                                                                             ! RHS / ratio norm


  write(IO_STDOUT,'(/,1x,a,a,i0,a)',advance='no') trim(incInfo), ' @ Iteration ', iter

  if (status /= STATUS_OK) then                                                                     ! mechanics failed
    reason = SNES_DIVERGED_USER
    print '(4a,2/,3x,a)', ' ~ ',IO_color([224,0,0]), 'Diverged', IO_color(),  &
      'Divergence reason: evaluation of constitutive law for mechanics failed'
#if PETSC_VERSION_MINOR>22
  else if (reason%v < SNES_CONVERGED_ITERATING%v) then                                              ! diverged
#else
  else if (reason < 0) then                                                                         ! diverged
#endif
    write(IO_STDOUT, '(4a,2/,3x,a)',advance='no') &
      ' ~ ', IO_color([224,0,0]), 'Diverged', IO_color(), 'Divergence reason:'
    if (reason == SNES_DIVERGED_FUNCTION_DOMAIN) then
      print '(1x,a)', 'solution outside the domain of the function'
    else if (reason == SNES_DIVERGED_FUNCTION_COUNT) then
      print '(1x,a,i0,a)', 'function evaluations limit reached (', num%itmax, ')'
    else if (reason == SNES_DIVERGED_LINEAR_SOLVE) then
      print '(1x,a)', 'linear solver failed'
    else if (reason == SNES_DIVERGED_MAX_IT) then
      print '(1x,a,i0,a)', 'linear solver iterations limit reached (', num%itmax, ')'
    else if (reason == SNES_DIVERGED_LINE_SEARCH) then
      print '(1x,a)', 'line search failed'
    else if (reason == SNES_DIVERGED_INNER) then
      print '(1x,a)', 'inner solver failed'
    else if (reason == SNES_DIVERGED_LOCAL_MIN) then
      print '(1x,a)', 'solver stagnated at a non-zero local minimum'
    else if (reason == SNES_DIVERGED_DTOL) then
      call SNESGetDivergenceTolerance(snes, rhs_tol, err_PETSc)
      CHKERRQ(err_PETSc)
      print '(1x,a,es10.3e2)', 'relative residual norm ||r|| / ||r_0|| >', rhs_tol
    else if (reason == SNES_DIVERGED_JACOBIAN_DOMAIN) then
      print '(1x,a)', 'invalid jacobian'
    else if (reason == SNES_DIVERGED_USER) then
      print '(1x,a)', 'user-defined'
    else if (reason == SNES_DIVERGED_JACOBIAN_DOMAIN) then
      print '(1x,a)', "the jacobian evaluation ocurred outside the function's domain"
#if PETSC_VERSION_MINOR>24
    else if (reason == SNES_DIVERGED_FUNCTION_NANORINF) then
      print '(1x,a)', 'residual norm is NaN or Inf'
    else if (reason == SNES_DIVERGED_OBJECTIVE_DOMAIN) then
      print '(1x,a)', "the object function evaluation ocurred outside the function's domain"
#endif
    end if
  else                                                                                              ! converged
    call SNESConvergedDefault(snes, iter, x_norm, s_norm, f_norm, reason, dummy, err_PETSc)
    CHKERRQ(err_PETSc)
    call SNESGetTolerances(snes, abs_tol, rel_tol, sol_tol, PETSC_NULL_INTEGER, &
                           PETSC_NULL_INTEGER, err_PETSc)
    CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR>22
    call SNESGetRhs(snes, rhs_vec, err_PETSc)
    CHKERRQ(err_PETSc)
    call VecNorm(rhs_vec, NORM_2, r_norm, err_PETSc)
    CHKERRQ(err_PETSc)
    rhs_tol = max(rel_tol * r_norm, abs_tol)
#else
    rhs_tol = abs_tol
#endif
    if (reason == SNES_CONVERGED_FNORM_RELATIVE) then                                               ! overwrite RELATIVE_FNORM convergence reason
      if (f_norm > rhs_tol) then
        if (s_norm < sol_tol * x_norm) then
          reason = SNES_CONVERGED_SNORM_RELATIVE
        else
          reason = SNES_CONVERGED_ITERATING
        end if
      end if
    end if
    if (iter > 0_pPETSCINT .and. s_norm < 1.0e-13_pREAL) reason = SNES_CONVERGED_USER
    if (reason == SNES_CONVERGED_ITERATING) then
      print '(2/,2(3x,3(a,es10.3e2),a))', &
        '- Residual       =', f_norm / rhs_tol, ' (||r||        =', f_norm, ', tol =', rhs_tol, ')'
      if (iter > 0_pPETSCINT) then
        r_norm = s_norm / x_norm
        print '(3x,3(a,es10.3e2),a))', &
          '- Solution ratio =', r_norm / sol_tol, ' (||Δu||/||u|| =', r_norm, ', tol =', sol_tol, ')'
      end if
    else                                                                                            ! convergence
      call SNESGetTolerances(snes, abs_tol, rel_tol, sol_tol, PETSC_NULL_INTEGER, &
                             PETSC_NULL_INTEGER, err_PETSc)
      CHKERRQ(err_PETSc)
      call SNESGetNumberFunctionEvals(snes, n_f_evals, err_PETSc)
      CHKERRQ(err_PETSc)
      call SNESGetLinearSolveIterations(snes, n_ls_its, err_PETSc)
      CHKERRQ(err_PETSc)
      write(IO_STDOUT, '(4a,2/,3x,a)',advance='no') &
        ' ~ ', IO_color([0,192,0]), 'Converged', IO_color(), 'Convergence reason:'
      if (reason == SNES_CONVERGED_FNORM_ABS) then
        print '(1x,a,es10.3e2)', 'residual norm ||r|| <', abs_tol
      else if (reason == SNES_CONVERGED_FNORM_RELATIVE) then
        print '(1x,a)', 'residual norm ||r|| < max(abs,rel*||RHS||)'
      else if (reason == SNES_CONVERGED_SNORM_RELATIVE) then
        print '(1x,a,es10.3e2)', 'ratio ||Δu||/||u|| <', sol_tol
      else if (reason == SNES_CONVERGED_USER) then
        print '(1x,a)', '(near) zero update norm ||Δu||'
      end if
      r_norm = s_norm / x_norm
      print '(/,2(3x,3(a,es10.3e2),a,/),/,2(3x,a,es10.3e2,/))', &
        '- Residual       =', f_norm / rhs_tol, ' (||r||        =', f_norm, ', tol =', rhs_tol, ')', &
        '- Solution ratio =', r_norm / sol_tol, ' (||Δu||/||u|| =', r_norm, ', tol =', sol_tol, ')', &
        '- Final residual ||r|| =', f_norm, &
        '- Final update  ||Δu|| =', s_norm
      print '(2(3x,a,i0,:,/))', &
        '- # function evaluations     = ', n_f_evals, &
        '- # linear solver iterations = ', n_ls_its
    end if
  end if
  flush(IO_STDOUT)

end subroutine FEM_mechanical_converged


!--------------------------------------------------------------------------------------------------
!> @brief Calculate current coordinates (both nodal and ip coordinates)
!--------------------------------------------------------------------------------------------------
subroutine FEM_mechanical_updateCoords()

  PetscReal, pointer, dimension(:,:) :: &
    nodeCoords                                                                                      !< nodal coordinates (3,nNodes)
  real(pREAL), pointer, dimension(:,:,:) :: &
    ipCoords                                                                                        !< ip coordinates (3,nQuadrature,mesh_nElems)

  integer :: &
    qPt, &
    comp, &
    qOffset, &
    nOffset

  DM  :: dm_local
  PetscErrorCode :: err_PETSc
  PetscInt :: nNodes, cellStart, cellEnd, q, c, n
  PetscSection :: section
  PetscDS :: mechDS
#if PETSC_VERSION_MINOR>22
  PetscTabulation, pointer :: tab(:)
#else
  PetscReal,   dimension(:), pointer :: basisField, &
                                        dev_null
#endif
  PetscReal,   dimension(:), pointer :: nodeCoordsDM                                                ! nodal coordinates read from DM (dimPlex*nNodes)
  real(pREAL), dimension(:), pointer :: x_scal

  call SNESGetDM(mechanical_snes,dm_local,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGetDS(dm_local,mechDS,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGetLocalSection(dm_local,section,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMGetDimension(dm_local,dimPlex,err_PETSc)
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! get current coordinates
  call VecGetArray(x_local,nodeCoordsDM,err_PETSc)
  CHKERRQ(err_PETSc)
  nNodes = size(nodeCoordsDM,kind=pPETSCINT)/dimPlex
  allocate(nodeCoords(3,nNodes),source=0.0_pREAL)
  nodeCoords(1:dimPlex,:) = reshape(nodeCoordsDM, [dimPlex, nNodes])
  call discretization_setNodeCoords(nodeCoords)
  call VecRestoreArray(x_local,nodeCoordsDM,err_PETSc)
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! write IP displacements
  call DMPlexGetHeightStratum(dm_local,0_pPETSCINT,cellStart,cellEnd,err_PETSc)
  CHKERRQ(err_PETSc)
#if PETSC_VERSION_MINOR>22
  call PetscDSGetTabulation(mechDS,tab,err_PETSc)
#else
  call PetscDSGetTabulation(mechDS,0_pPETSCINT,basisField,dev_null,err_PETSc)
#endif
  CHKERRQ(err_PETSc)
  allocate(ipCoords(3,nQuadrature,mesh_nElems),source=0.0_pREAL)
  do c = cellStart, cellEnd - 1_pPETSCINT
    qOffset=0
#if PETSC_VERSION_MINOR>22
    call DMPlexVecGetClosure(dm_local,section,x_local,c,PETSC_NULL_INTEGER,x_scal,err_PETSc)        ! get nodal coordinates of each element
#else
    call DMPlexVecGetClosure(dm_local,section,x_local,c,x_scal,err_PETSc)                           ! get nodal coordinates of each element
#endif
    CHKERRQ(err_PETSc)
    do qPt=0,nQuadrature-1
#if PETSC_VERSION_MINOR>22
      qOffset = qPt * (size(tab(1)%ptr%T(1)%ptr)/nQuadrature)
#else
      qOffset = qPt * (size(basisField)/nQuadrature)
#endif
      do comp=0,dimPlex-1                                                                           ! loop over components
        nOffset=0
        q = comp
        do n=0,nBasis-1
          ipCoords(comp+1,qPt+1,c+1)=ipCoords(comp+1,qPt+1,c+1)+&
#if PETSC_VERSION_MINOR>22
                                     sum(tab(1)%ptr%T(1)%ptr(qOffset+(q*dimPlex)+1:qOffset+(q*dimPlex)+dimPlex)*&
#else
                                     sum(basisField(qOffset+(q*dimPlex)+1:qOffset+(q*dimPlex)+dimPlex)*&
#endif
                                     x_scal(nOffset+1:nOffset+dimPlex))
          q = q+dimPlex
          nOffset = nOffset+dimPlex
        end do
      end do
    end do
#if PETSC_VERSION_MINOR>22
    call DMPlexVecRestoreClosure(dm_local,section,x_local,c,PETSC_NULL_INTEGER,x_scal,err_PETSc)
#else
    call DMPlexVecRestoreClosure(dm_local,section,x_local,c,x_scal,err_PETSc)
#endif
    CHKERRQ(err_PETSc)
  end do
  call discretization_setIPcoords(reshape(ipCoords,[3,int(mesh_nElems*nQuadrature)]))
#if PETSC_VERSION_MINOR>22
  call PetscDSRestoreTabulation(mechDS,tab,err_PETSc)
#else
  call PetscDSRestoreTabulation(mechDS,0_pPETSCINT,basisField,dev_null,err_PETSc)
#endif
  CHKERRQ(err_PETSc)

end subroutine FEM_mechanical_updateCoords

end module mesh_mechanical_FEM

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @author Pratheek Shanthraj, Max-Planck-Institut für Eisenforschung GmbH
!> @author Shaokang Zhang, Max-Planck-Institut für Eisenforschung GmbH
!> @brief Spectral solver for nonlocal damage
!--------------------------------------------------------------------------------------------------
#include <petsc/finclude/petscsnes.h>
#include <petsc/finclude/petscdmda.h>
module grid_damage_spectral
  use PETScDMDA
  use PETScSNES
#ifndef PETSC_EXPOSES_MPI
  use MPI_f08
#endif
  use HDF5

  use prec
  use parallelization
  use IO
  use misc
  use CLI
  use HDF5_utilities
  use spectral_utilities
  use discretization_grid
  use homogenization
  use types
  use config

#ifndef PETSC_EXPOSES_MPIF90
  implicit none(type,external)
#else
  implicit none
#endif
  private

  type :: tNumerics
    integer :: &
      itmax                                                                                         !< maximum number of iterations
    real(pREAL) :: &
      phi_min, &                                                                                    !< non-zero residual damage
      eps_damage_atol, &                                                                            !< absolute tolerance for damage evolution
      eps_damage_rtol                                                                               !< relative tolerance for damage evolution
  end type tNumerics

  type(tNumerics) :: num

!--------------------------------------------------------------------------------------------------
! PETSc data
  SNES :: SNES_damage
  Vec :: phi_vec
  real(pREAL), dimension(:,:,:), allocatable :: &
    phi_lastinc, &                                                                                  !< field of previous damage
    phi_staginc                                                                                     !< field of staggered damage

!--------------------------------------------------------------------------------------------------
! reference diffusion tensor, mobility etc.
  integer                     :: totalIter = 0                                                      !< total iteration in current increment
  real(pREAL), dimension(3,3) :: K_ref
  real(pREAL)                 :: mu_ref, Delta_t_

  public :: &
    grid_damage_spectral_init, &
    grid_damage_spectral_solution, &
    grid_damage_spectral_restartWrite, &
    grid_damage_spectral_forward

contains

!--------------------------------------------------------------------------------------------------
!> @brief Allocate all necessary fields and fill them with data, potentially from restart file.
!--------------------------------------------------------------------------------------------------
subroutine grid_damage_spectral_init(num_grid_damage)

  type(tDict), pointer, intent(in) :: num_grid_damage

  integer(MPI_INTEGER_KIND), dimension(0:worldsize-1) :: cells3_global
  DM :: DM_damage
  real(pREAL), dimension(:,:,:), pointer :: phi                                                     ! 0-indexed
  Vec :: bound_u, bound_l
  integer(MPI_INTEGER_KIND) :: err_MPI
  PetscErrorCode :: err_PETSc
  integer(HID_T) :: fileHandle, groupHandle
  real(pREAL), dimension(1,product(cells(1:2))*cells3) :: tempN
  character(len=pSTRLEN) :: &
    snes_type
  character(len=:), allocatable :: &
    extmsg, &
    petsc_options


  print'(/,1x,a)', '<<<+-  grid_spectral_damage init  -+>>>'

  print'(/,1x,a)', 'P. Shanthraj et al., Handbook of Mechanics of Materials, 2019'
  print'(  1x,a)', 'https://doi.org/10.1007/978-981-10-6884-3_80'

  if (.not. homogenization_damage_active()) call IO_error(501,ext_msg='damage')

!-------------------------------------------------------------------------------------------------
! read numerical parameters and do sanity checks
  num%itmax           = num_grid_damage%get_asInt ('N_iter_max', defaultVal=100)
  num%eps_damage_atol = num_grid_damage%get_asReal('eps_abs_phi',defaultVal=1.0e-2_pREAL)
  num%eps_damage_rtol = num_grid_damage%get_asReal('eps_rel_phi',defaultVal=1.0e-6_pREAL)
  num%phi_min         = num_grid_damage%get_asReal('phi_min',    defaultVal=1.0e-6_pREAL)

  extmsg = ''
  if (num%eps_damage_atol <= 0.0_pREAL) extmsg = trim(extmsg)//' eps_abs_phi'
  if (num%eps_damage_rtol <= 0.0_pREAL) extmsg = trim(extmsg)//' eps_rel_phi'
  if (num%phi_min <= 0.0_pREAL)         extmsg = trim(extmsg)//' phi_min'
  if (num%itmax < 1)                    extmsg = trim(extmsg)//' N_iter_max'

  if (extmsg /= '') call IO_error(301,ext_msg=trim(extmsg))

!--------------------------------------------------------------------------------------------------
! set default and user defined options for PETSc
  petsc_options = misc_prefixOptions('-snes_type newtonls -snes_mf -snes_ksp_ew -ksp_type fgmres '// &
                                     num_grid_damage%get_asStr('PETSc_options',defaultVal=''),'damage_')
  call PetscOptionsInsertString(PETSC_NULL_OPTIONS,petsc_options,err_PETSc)
  CHKERRQ(err_PETSc)

!--------------------------------------------------------------------------------------------------
! initialize solver specific parts of PETSc
  call SNESCreate(PETSC_COMM_WORLD,SNES_damage,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESSetOptionsPrefix(SNES_damage,'damage_',err_PETSc)
  CHKERRQ(err_PETSc)
  call MPI_Allgather(int(cells3,MPI_INTEGER_KIND),1_MPI_INTEGER_KIND,MPI_INTEGER,&
                     cells3_global,1_MPI_INTEGER_KIND,MPI_INTEGER,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  call DMDACreate3D(PETSC_COMM_WORLD, &
         DM_BOUNDARY_NONE, DM_BOUNDARY_NONE, DM_BOUNDARY_NONE, &                                    ! cut off stencil at boundary
         DMDA_STENCIL_BOX, &                                                                        ! Moore (26) neighborhood around central point
         int(cells(1),pPETSCINT),int(cells(2),pPETSCINT),int(cells(3),pPETSCINT), &                 ! global cells
         1_pPETSCINT, 1_pPETSCINT, int(worldsize,pPETSCINT), &
         1_pPETSCINT, 0_pPETSCINT, &                                                                ! #dof (phi, scalar), ghost boundary width (domain overlap)
         [int(cells(1),pPETSCINT)],[int(cells(2),pPETSCINT)],int(cells3_global,pPETSCINT), &        ! local cells
         DM_damage,err_PETSc)                                                                       ! handle, error
  CHKERRQ(err_PETSc)
  call DMsetFromOptions(DM_damage,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMsetUp(DM_damage,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMCreateGlobalVector(DM_damage,phi_vec,err_PETSc)                                            ! global solution vector (cells x 1, i.e. every def grad tensor)
  CHKERRQ(err_PETSc)
  call DMDASNESSetFunctionLocal(DM_damage,INSERT_VALUES,form_residual,PETSC_NULL_SNES,err_PETSc)    ! residual vector of same shape as solution vector
  CHKERRQ(err_PETSc)
  call SNESSetDM(SNES_damage,DM_damage,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESSetFromOptions(SNES_damage,err_PETSc)                                                    ! pull it all together with additional CLI arguments
  CHKERRQ(err_PETSc)
  call SNESGetType(SNES_damage,snes_type,err_PETSc)
  CHKERRQ(err_PETSc)
  if (trim(snes_type) == 'vinewtonrsls' .or. &
      trim(snes_type) == 'vinewtonssls') then
    call DMGetGlobalVector(DM_damage,bound_l,err_PETSc)
    CHKERRQ(err_PETSc)
    call DMGetGlobalVector(DM_damage,bound_u,err_PETSc)
    CHKERRQ(err_PETSc)
    call VecSet(bound_l,0.0_pREAL,err_PETSc)
    CHKERRQ(err_PETSc)
    call VecSet(bound_u,1.0_pREAL,err_PETSc)
    CHKERRQ(err_PETSc)
    call SNESVISetVariableBounds(SNES_damage,bound_l,bound_u,err_PETSc)                             ! variable bounds for variational inequalities
    CHKERRQ(err_PETSc)
    call DMRestoreGlobalVector(DM_damage,bound_l,err_PETSc)
    CHKERRQ(err_PETSc)
    call DMRestoreGlobalVector(DM_damage,bound_u,err_PETSc)
    CHKERRQ(err_PETSc)
  end if

  call DMDAVecGetArray(DM_damage,phi_vec,phi,err_PETSc)                                             ! returns 0-indexed phi
  CHKERRQ(err_PETSc)

  restartRead: if (CLI_restartInc /= -1) then
    print'(/,1x,a,1x,i0)', 'loading restart data of increment', CLI_restartInc

    fileHandle  = HDF5_openFile(CLI_jobName//'_restart.hdf5','r')
    groupHandle = HDF5_openGroup(fileHandle,'solver')

    call HDF5_read(tempN,groupHandle,'phi',.false.)
    phi = reshape(tempN,[cells(1),cells(2),cells3])
    call HDF5_read(tempN,groupHandle,'phi_lastinc',.false.)
    phi_lastinc = reshape(tempN,[cells(1),cells(2),cells3])
    phi_staginc = phi_lastinc
  else
    phi = discretization_grid_getScalarInitialCondition('phi')
    phi_lastinc = phi(0:,0:,lbound(phi,3):)
    phi_staginc = phi_lastinc
  end if restartRead

  call homogenization_set_phi(reshape(phi,[product(cells(1:2))*cells3]))

  call DMDAVecRestoreArray(DM_damage,phi_vec,phi,err_PETSc)
  CHKERRQ(err_PETSc)

  call updateReference()

end subroutine grid_damage_spectral_init


!--------------------------------------------------------------------------------------------------
!> @brief solution for the spectral damage scheme with internal iterations
!--------------------------------------------------------------------------------------------------
function grid_damage_spectral_solution(Delta_t) result(solution)

  real(pREAL), intent(in) :: Delta_t                                                                !< increment in time for current solution

  type(tSolutionState) :: solution
  PetscInt  :: devNull
  PetscReal :: phi_min, phi_max, stagNorm
  DM :: DM_damage
  real(pREAL), dimension(:,:,:), pointer :: phi                                                     ! 0-indexed
  integer(MPI_INTEGER_KIND) :: err_MPI
  PetscErrorCode :: err_PETSc
  SNESConvergedReason :: reason


!--------------------------------------------------------------------------------------------------
! set module wide availabe data
  Delta_t_ = Delta_t

  call SNESSolve(SNES_damage,PETSC_NULL_VEC,phi_vec,err_PETSc)
  CHKERRQ(err_PETSc)
  call SNESGetConvergedReason(SNES_damage,reason,err_PETSc)
  CHKERRQ(err_PETSc)

#if PETSC_VERSION_MINOR<23
  solution%converged = reason > SNES_CONVERGED_ITERATING
#else
  solution%converged = reason%v > SNES_CONVERGED_ITERATING%v
#endif
  solution%iterationsNeeded = merge(totalIter,num%itmax,solution%converged)

  call VecMin(phi_vec,devNull,phi_min,err_PETSc)
  CHKERRQ(err_PETSc)
  call VecMax(phi_vec,devNull,phi_max,err_PETSc)
  CHKERRQ(err_PETSc)

  call SNESGetDM(SNES_damage,DM_damage,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecGetArrayRead(DM_damage,phi_vec,phi,err_PETSc)                                         ! returns 0-indexed phi
  CHKERRQ(err_PETSc)

  stagNorm = maxval(abs(phi - phi_staginc))
  call MPI_Allreduce(MPI_IN_PLACE,stagNorm,1_MPI_INTEGER_KIND,MPI_DOUBLE,MPI_MAX,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  solution%stagConverged = stagNorm < max(num%eps_damage_atol, num%eps_damage_rtol*phi_max)
  call MPI_Allreduce(MPI_IN_PLACE,solution%stagConverged,1_MPI_INTEGER_KIND,MPI_LOGICAL,MPI_LAND,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  phi_staginc = phi

  call homogenization_set_phi(reshape(phi,[product(cells(1:2))*cells3]))

  call DMDAVecRestoreArrayRead(DM_damage,phi_vec,phi,err_PETSc)
  CHKERRQ(err_PETSc)

  if (solution%converged) &
    print'(/,1x,a)', '... nonlocal damage converged .....................................'
  print'(/,1x,a,f8.6,2x,f8.6,2x,e11.4)', 'Minimum|Maximum|Delta Damage      = ', phi_min, phi_max, stagNorm
  print'(/,1x,a)', '==========================================================================='
  flush(IO_STDOUT)

end function grid_damage_spectral_solution


!--------------------------------------------------------------------------------------------------
!> @brief Set DAMASK data to current solver status.
!--------------------------------------------------------------------------------------------------
subroutine grid_damage_spectral_forward(cutBack)

  logical, intent(in) :: cutBack

  DM :: DM_damage
  real(pREAL),  dimension(:,:,:), pointer :: phi                                                    ! 0-indexed
  PetscErrorCode :: err_PETSc


  call SNESGetDM(SNES_damage,DM_damage,err_PETSc)
    CHKERRQ(err_PETSc)
  call DMDAVecGetArray(DM_damage,phi_vec,phi,err_PETSc)                                             ! returns 0-indexed T
    CHKERRQ(err_PETSc)

  if (cutBack) then
    call homogenization_set_phi(reshape(phi_lastinc,[product(cells(1:2))*cells3]))
    phi = phi_lastinc
    phi_staginc = phi_lastinc
  else
    phi_lastinc = phi
    call updateReference()
  end if

  call DMDAVecRestoreArray(DM_damage,phi_vec,phi,err_PETSc)
  CHKERRQ(err_PETSc)

end subroutine grid_damage_spectral_forward


!--------------------------------------------------------------------------------------------------
!> @brief Write current solver and constitutive data for restart to file.
!--------------------------------------------------------------------------------------------------
subroutine grid_damage_spectral_restartWrite()

  PetscErrorCode :: err_PETSc
  DM :: DM_damage
  integer(HID_T) :: fileHandle, groupHandle
  real(pREAL), dimension(:,:,:), pointer :: phi                                                     ! 0-indexed


  call SNESGetDM(SNES_damage,DM_damage,err_PETSc)
  CHKERRQ(err_PETSc)
  call DMDAVecGetArrayRead(DM_damage,phi_vec,phi,err_PETSc)                                         ! returns 0-indexed T
  CHKERRQ(err_PETSc)

  print'(1x,a)', 'saving damage solver data required for restart'; flush(IO_STDOUT)

  fileHandle  = HDF5_openFile(CLI_jobName//'_restart.hdf5','a')
  groupHandle = HDF5_openGroup(fileHandle,'solver')
  call HDF5_write(reshape(phi,[1,product(shape(phi))]),groupHandle,'phi')
  call HDF5_write(reshape(phi_lastinc,[1,product(shape(phi_lastinc))]),groupHandle,'phi_lastinc')
  call HDF5_closeGroup(groupHandle)
  call HDF5_closeFile(fileHandle)

  call DMDAVecRestoreArrayRead(DM_damage,phi_vec,phi,err_PETSc);
  CHKERRQ(err_PETSc)

end subroutine grid_damage_spectral_restartWrite


!--------------------------------------------------------------------------------------------------
!> @brief Construct the residual vector.
!--------------------------------------------------------------------------------------------------
subroutine form_residual(residual_subdomain,phi,r,dummy,err_PETSc)

#if PETSC_VERSION_MINOR<22
  DMDALocalInfo, dimension(DMDA_LOCAL_INFO_SIZE) :: &
#else
  DMDALocalInfo :: &
#endif
    residual_subdomain
  real(pREAL), dimension(cells(1),cells(2),cells3), intent(in) :: &
    phi                                                                                             !< phase field
  real(pREAL), dimension(cells(1),cells(2),cells3), intent(out) :: &
    r                                                                                               !< residual
  PetscObject :: dummy
  PetscErrorCode, intent(out) :: err_PETSc

  integer :: i, j, k, ce
  real(pREAL), dimension(3,cells(1),cells(2),cells3) :: vector_field


  vector_field = utilities_ScalarGradient(phi)
  ce = 0
  do k = 1, cells3;  do j = 1, cells(2);  do i = 1,cells(1)
    ce = ce + 1
    vector_field(1:3,i,j,k) = matmul(homogenization_K_phi(ce) - K_ref, vector_field(1:3,i,j,k))
  end do; end do; end do
  r = utilities_VectorDivergence(vector_field)
  ce = 0
  do k = 1, cells3;  do j = 1, cells(2);  do i = 1,cells(1)
    ce = ce + 1
    r(i,j,k) = Delta_t_*(r(i,j,k) + homogenization_f_phi(phi(i,j,k),ce)) &
             + homogenization_mu_phi(ce)*(phi_lastinc(i,j,k) - phi(i,j,k)) &
             + mu_ref*phi(i,j,k)
  end do; end do; end do

  r = phi - max(min(utilities_GreenConvolution(r, K_ref, mu_ref, Delta_t_),phi_lastinc),num%phi_min)
  err_PETSc = 0

end subroutine form_residual


!--------------------------------------------------------------------------------------------------
!> @brief Update reference viscosity and conductivity.
!--------------------------------------------------------------------------------------------------
subroutine updateReference()

  integer :: ce
  integer(MPI_INTEGER_KIND) :: err_MPI


  K_ref = 0.0_pREAL
  mu_ref = 0.0_pREAL
  do ce = 1, product(cells(1:2))*cells3
    K_ref  = K_ref  + homogenization_K_phi(ce)
    mu_ref = mu_ref + homogenization_mu_phi(ce)
  end do

  K_ref = K_ref*wgt
  call MPI_Allreduce(MPI_IN_PLACE,K_ref,9_MPI_INTEGER_KIND,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)
  mu_ref = mu_ref*wgt
  call MPI_Allreduce(MPI_IN_PLACE,mu_ref,1_MPI_INTEGER_KIND,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD,err_MPI)
  call parallelization_chkerr(err_MPI)

end subroutine updateReference


end module grid_damage_spectral

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
submodule(phase:chemical) quadenergy

  real(pREAL), parameter :: &
    R = 8.314459848_pREAL                                                                           !< gas constant. Not sure where the exact value comes from, check https://en.wikipedia.org/wiki/Gas_constant
    ! R = N_A * K_B

  type :: tParameters                                                                               !< container type for internal constitutive parameters
    integer :: &
      N_components
    real(pREAL) :: &
      coeff_constant                                                                                !< constant energy
    real(pREAL), dimension(:), allocatable :: &
      Mobility, &
      c_0, &
      c_eq, &
      coeff_linear, &
      coeff_quadratic
  end type tParameters

  type(tParameters), dimension(:),   allocatable :: param                                           !< containers of constitutive parameters (len Ninstances)

contains

!--------------------------------------------------------------------------------------------------
!> @brief module initialization
!> @details reads in material parameters, allocates arrays, and does sanity checks
!--------------------------------------------------------------------------------------------------
module function quadenergy_init() result(myChemicalEnergy)

  logical, dimension(:), allocatable :: myChemicalEnergy

  type(tDict), pointer :: &
    phases, &
    phase, &
    chemical, components, component
  integer :: Nmembers,ph,com


  myChemicalEnergy = chemical_active('quadenergy')
  if (count(myChemicalEnergy) == 0) return
  print'(/,a)', ' <<<+-  phase:chemical:quadenergy init  -+>>>'
  print'(/,1x,a,1x,i0)', '# phases:',count(myChemicalEnergy); flush(IO_STDOUT)

  phases => config_material%get_dict('phase')

  allocate(param(size(phases)))

  do ph = 1, size(phases)
    if ( .not. myChemicalEnergy(ph)) cycle

    print'(/,1x,a,1x,i0,a)', 'phase',ph,': '//phases%key(ph)

    associate(prm  => param(ph))
      phase => phases%get_dict(ph)
      chemical => phase%get_dict('chemical')

      ! read params
      components => chemical%get_dict('components',defaultVal=emptyDict)

      prm%N_components = size(components)

      Nmembers = count(material_ID_phase == ph)
      allocate(prm%c_0(size(components)),                     source=0.0_pREAL)
      allocate(prm%Mobility(size(components)),                source=0.0_pREAL)
      allocate(prm%c_eq(size(components)),                    source=0.0_pREAL)
      allocate(prm%coeff_linear(size(components)),            source=0.0_pREAL)
      allocate(prm%coeff_quadratic(size(components)),         source=0.0_pREAL)

      do com = 1, size(components)
        component => components%get_dict(com)
        prm%Mobility(com)           = component%get_asReal('M')
        prm%c_0     (com)           = component%get_asReal('c_0')
        prm%c_eq    (com)           = component%get_asReal('c_eq', defaultVal=0.0_pREAL)
        prm%coeff_linear (com)      = component%get_asReal('G,c',  defaultVal=0.0_pREAL)
        prm%coeff_quadratic (com)   = component%get_asReal('G,c^2',defaultVal=0.0_pREAL)
      end do

      Nmembers = count(material_ID_phase == ph)
      allocate(current(ph)%C(prm%N_components,Nmembers),source=spread(prm%c_0,2,Nmembers))
      allocate(current(ph)%dot_C(prm%N_components,Nmembers),source=0.0_pREAL)
      allocate(current(ph)%C0(prm%N_components,Nmembers),source=spread(prm%c_0,2,Nmembers))

    end associate
  end do

end function quadenergy_init


module function quadenergy_composition(mu_chemical,ph,en) result(comp)
  integer, intent(in) :: &
    ph, &
    en
  real(pREAL), dimension(:), intent(in) :: mu_chemical
  real(pREAL), dimension(:), allocatable :: comp

  integer :: com

  associate(prm => param(ph))
    allocate(comp(prm%N_components))

    do com = 1, prm%N_components - 1
      comp(com) = prm%c_eq(com) + 0.5_pREAL *(mu_chemical(com) - prm%coeff_linear(com))/prm%coeff_quadratic(com)
    end do
    comp(prm%N_components) = 1.0_pREAL - sum(comp(1:prm%N_components-1))

  end associate

end function quadenergy_composition


module function quadenergy_compositionTangent(mu_chemical,ph,en) result(comp_tangent)
  real(pREAL), dimension(:), intent(in) :: mu_chemical
  integer, intent(in) :: &
    ph, &
    en
  real(pREAL), dimension(:,:),allocatable :: comp_tangent

  integer :: com

  associate(prm => param(ph))

    allocate(comp_tangent(prm%N_components-1,prm%N_components-1), source = 0.0_pREAL)

    do com = 1, prm%N_components-1
      comp_tangent(com,com) = 0.5_pREAL/prm%coeff_quadratic(com)
    end do

  end associate

end function quadenergy_compositionTangent


!--------------------------------------------------------------------------------------------------
!> @brief Return mobility.
!--------------------------------------------------------------------------------------------------
module function quadenergy_mobility(ph,en) result(mobility)
  integer, intent(in) :: ph, en
  real(pREAL), dimension(:,:), allocatable :: mobility

  integer :: com

  associate(prm => param(ph))

    allocate(mobility(prm%N_components-1,prm%N_components-1), source=0.0_pREAL)
    do com = 1, prm%N_components-1
      mobility(com,com) = prm%Mobility(com)
    end do

  end associate

end function quadenergy_mobility


end submodule quadenergy

! SPDX-License-Identifier: AGPL-3.0-or-later
! Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
! Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
!
! DAMASK is free software: you can redistribute it and/or modify
! it under the terms of the GNU Affero General Public License as
! published by the Free Software Foundation, either version 3 of the
! License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Affero General Public License for more details.
!
! You should have received a copy of the GNU Affero General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
!--------------------------------------------------------------------------------------------------
!> @author Martin Diehl, Max-Planck-Institut für Eisenforschung GmbH
!> @author Su Leen Wong, Max-Planck-Institut für Eisenforschung GmbH
!> @author Nan Jia, Max-Planck-Institut für Eisenforschung GmbH
!> @author Franz Roters, Max-Planck-Institut für Eisenforschung GmbH
!> @author Philip Eisenlohr, Max-Planck-Institut für Eisenforschung GmbH
!> @brief material subroutine incoprorating dislocation and twinning physics
!> @details to be done
!--------------------------------------------------------------------------------------------------
submodule(phase:plastic) dislotwin

  real(pREAL), parameter :: gamma_char_tr = sqrt(0.125_pREAL)                                       !< Characteristic shear for transformation
  type :: tParameters
    real(pREAL) :: &
      Q_cl       = 1.0_pREAL, &                                                                     !< activation energy for dislocation climb
      omega      = 1.0_pREAL, &                                                                     !< frequency factor for dislocation climb
      D          = 1.0_pREAL, &                                                                     !< grain size
      p_sb       = 1.0_pREAL, &                                                                     !< p-exponent in shear band velocity
      q_sb       = 1.0_pREAL, &                                                                     !< q-exponent in shear band velocity
      i_tw       = 1.0_pREAL, &                                                                     !< adjustment parameter to calculate MFP for twinning
      i_tr       = 1.0_pREAL, &                                                                     !< adjustment parameter to calculate MFP for transformation
      L_tw       = 1.0_pREAL, &                                                                     !< length of twin nuclei
      L_tr       = 1.0_pREAL, &                                                                     !< length of trans nuclei
      x_c        = 1.0_pREAL, &                                                                     !< critical distance for formation of twin/trans nucleus
      V_cs       = 1.0_pREAL, &                                                                     !< cross slip volume
      tau_sb     = 1.0_pREAL, &                                                                     !< value for shearband resistance
      gamma_0_sb = 1.0_pREAL, &                                                                     !< value for shearband velocity_0
      E_sb       = 1.0_pREAL, &                                                                     !< activation energy for shear bands
      h          = 1.0_pREAL, &                                                                     !< stack height of hex nucleus
      cOverA_hP  = 1.0_pREAL, &
      V_mol      = 1.0_pREAL, &
      rho        = 1.0_pREAL
    type(tPolynomial) :: &
      Gamma_sf, &                                                                                   !< stacking fault energy
      Delta_G                                                                                       !< free energy difference between austensite and martensite
    real(pREAL),               allocatable, dimension(:) :: &
      b_sl, &                                                                                       !< magnitude of Burgers vector (m) for each slip system
      b_tw, &                                                                                       !< magnitude of Burgers vector (m) for each twin system
      b_tr, &                                                                                       !< magnitude of Burgers vector (m) for each transformation system
      Q_sl,&                                                                                        !< activation energy for glide (J) for each slip system
      v_0, &                                                                                        !< dislocation velocity prefactor (m/s) for each slip system
      dot_N_0_tw, &                                                                                 !< twin nucleation rate (1/m³s) for each twin system
      t_tw, &                                                                                       !< twin thickness (m) for each twin system
      i_sl, &                                                                                       !< Adj. parameter for distance between 2 forest dislocations for each slip system
      t_tr, &                                                                                       !< martensite lamellar thickness (m) for each trans system
      p, &                                                                                          !< p-exponent in glide velocity
      q, &                                                                                          !< q-exponent in glide velocity
      r, &                                                                                          !< exponent in twin nucleation rate
      s, &                                                                                          !< exponent in trans nucleation rate
      tau_0, &                                                                                      !< strength due to elements in solid solution
      gamma_char_tw, &                                                                              !< characteristic shear for twins
      B, &                                                                                          !< drag coefficient
      d_caron                                                                                       !< distance of spontaneous annhihilation
    real(pREAL),               allocatable, dimension(:,:) :: &
      h_sl_sl, &                                                                                    !< components of slip-slip interaction matrix
      h_sl_tw, &                                                                                    !< components of slip-twin interaction matrix
      h_sl_tr, &                                                                                    !< components of slip-trans interaction matrix
      h_tw_tw, &                                                                                    !< components of twin-twin interaction matrix
      h_tr_tr, &                                                                                    !< components of trans-trans interaction matrix
      n0_sl, &                                                                                      !< slip system normal
      forestProjection
    real(pREAL),               allocatable, dimension(:,:,:) :: &
      P_sl, &
      P_tw, &
      P_tr
    integer :: &
      sum_N_sl, &                                                                                   !< total number of active slip systems
      sum_N_tw, &                                                                                   !< total number of active twin systems
      sum_N_tr                                                                                      !< total number of active transformation systems
    integer,                   allocatable, dimension(:) :: &
      N_tw, &
      N_tr
    integer,                   allocatable, dimension(:,:) :: &
      fcc_twinNucleationSlipPair                                                                    ! ToDo: Better name? Is also used for trans
    character(len=:),          allocatable :: &
      crystal_tr, &
      isotropic_bound
    character(len=pSTRLEN),    allocatable, dimension(:) :: &
      output
    logical :: &
      extendedDislocations = .false., &                                                             !< consider split into partials for climb calculation
      fccTwinTransNucleation = .false., &                                                           !< twinning and transformation models are for fcc
      omitDipoles = .false.                                                                         !< flag controlling consideration of dipole formation
    character(len=:),          allocatable, dimension(:) :: &
      systems_sl, &
      systems_tw
  end type tParameters                                                                              !< container type for internal constitutive parameters

  type :: tIndexDotState
    integer, dimension(2) :: &
      rho_mob, &
      rho_dip, &
      gamma_sl, &
      f_tw, &
      f_tr
  end type tIndexDotState

  type :: tDislotwinState
    real(pREAL),                  dimension(:,:),   pointer :: &
      rho_mob, &
      rho_dip, &
      gamma_sl, &
      f_tw, &
      f_tr
  end type tDislotwinState

  type :: tDislotwinDependentState
    real(pREAL),                  dimension(:,:),   allocatable :: &
      Lambda_sl, &                                                                                  !< mean free path between 2 obstacles seen by a moving dislocation
      Lambda_tw, &                                                                                  !< mean free path between 2 obstacles seen by a growing twin
      Lambda_tr, &                                                                                  !< mean free path between 2 obstacles seen by a growing martensite
      tau_pass                                                                                      !< threshold stress for slip
  end type tDislotwinDependentState

!--------------------------------------------------------------------------------------------------
! containers for parameters and state
  type(tParameters),              allocatable, dimension(:) :: param
  type(tIndexDotState),           allocatable, dimension(:) :: indexDotState
  type(tDislotwinState),          allocatable, dimension(:) :: state
  type(tDislotwinDependentState), allocatable, dimension(:) :: dependentState

contains


!--------------------------------------------------------------------------------------------------
!> @brief Perform module initialization.
!> @details reads in material parameters, allocates arrays, and does sanity checks
!--------------------------------------------------------------------------------------------------
module function plastic_dislotwin_init() result(myPlasticity)

  logical, dimension(:), allocatable :: myPlasticity
  integer :: &
    ph, i, &
    Nmembers, &
    sizeState, sizeDotState, &
    startIndex, endIndex
  integer,     dimension(:), allocatable :: &
    N_sl
  real(pREAL) :: a_cF
  real(pREAL), allocatable, dimension(:) :: &
    f_edge, &                                                                                       !< edge character fraction of total dislocation density
    rho_mob_0, &                                                                                    !< initial unipolar dislocation density per slip system
    rho_dip_0                                                                                       !< initial dipole dislocation density per slip system
  character(len=:), allocatable :: &
    refs, &
    extmsg
  type(tDict), pointer :: &
    phases, &
    phase, &
    mech, &
    pl


  myPlasticity = plastic_active('dislotwin')
  if (count(myPlasticity) == 0) return

  print'(/,1x,a)', '<<<+-  phase:mechanical:plastic:dislotwin init  -+>>>'

  print'(/,1x,a)', 'A. Ma and F. Roters, Acta Materialia 52(12):3603–3612, 2004'
  print'(  1x,a)', 'https://doi.org/10.1016/j.actamat.2004.04.012'

  print'(/,1x,a)', 'F. Roters et al., Computational Materials Science 39:91–95, 2007'
  print'(  1x,a)', 'https://doi.org/10.1016/j.commatsci.2006.04.014'

  print'(/,1x,a)', 'S.L. Wong et al., Acta Materialia 118:140–151, 2016'
  print'(  1x,a)', 'https://doi.org/10.1016/j.actamat.2016.07.032'

  print'(/,1x,a,1x,i0)', '# phases:',count(myPlasticity); flush(IO_STDOUT)

  phases => config_material%get_dict('phase')
  allocate(param(size(phases)))
  allocate(indexDotState(size(phases)))
  allocate(state(size(phases)))
  allocate(dependentState(size(phases)))
  extmsg = ''

  do ph = 1, size(phases)
    if (.not. myPlasticity(ph)) cycle

    associate(prm => param(ph), &
              stt => state(ph), dst => dependentState(ph), &
              idx_dot => indexDotState(ph))

    phase => phases%get_dict(ph)
    mech => phase%get_dict('mechanical')
    pl => mech%get_dict('plastic')

    print'(/,1x,a,1x,i0,a)', 'phase',ph,': '//phases%key(ph)
    refs = config_listReferences(pl,indent=3)
    if (len(refs) > 0) print'(/,1x,a)', refs

#if defined (__GFORTRAN__)
    prm%output = output_as1dStr(pl)
#else
    prm%output = pl%get_as1dStr('output',defaultVal=emptyStrArray)
#endif
   if (any(prm%output == 'f_tw')) call IO_warning(10,'f_tw (twinned volume fraction)',IO_EOL, &
                                                     'use gamma_tw (twinning shear)')

   prm%isotropic_bound = pl%get_asStr('isotropic_bound',defaultVal='isostrain')

!--------------------------------------------------------------------------------------------------
! slip related parameters
    N_sl = pl%get_as1dInt('N_sl',defaultVal=emptyIntArray)
    prm%sum_N_sl = sum(abs(N_sl))
    slipActive: if (prm%sum_N_sl > 0) then
      prm%P_sl = crystal_SchmidMatrix_slip(N_sl,phase_lattice(ph),phase_cOverA(ph))
      prm%systems_sl = crystal_labels_slip(N_sl,phase_lattice(ph))
      prm%n0_sl = crystal_slip_normal(N_sl,phase_lattice(ph),phase_cOverA(ph))

      prm%h_sl_sl = crystal_interaction_SlipBySlip(N_sl,pl%get_as1dReal('h_sl-sl'),phase_lattice(ph))

      prm%extendedDislocations = pl%get_asBool('extend_dislocations',defaultVal=prm%extendedDislocations)
      prm%omitDipoles          = pl%get_asBool('omit_dipoles',       defaultVal=prm%omitDipoles)

      prm%Q_cl                 = pl%get_asReal('Q_cl')

      f_edge       = math_expand(pl%get_as1dReal('f_edge',    requiredSize=size(N_sl), &
                                                 defaultVal=[(0.5_pREAL,i=1,size(N_sl))]),N_sl)

#ifdef __GFORTRAN__
      rho_mob_0    = pl%get_as1dReal('rho_mob_0', requiredChunks=N_sl)
      rho_dip_0    = pl%get_as1dReal('rho_dip_0', requiredChunks=N_sl)
#else
      rho_mob_0    = math_expand(pl%get_as1dReal('rho_mob_0', requiredSize=size(N_sl)),N_sl)
      rho_dip_0    = math_expand(pl%get_as1dReal('rho_dip_0', requiredSize=size(N_sl)),N_sl)
#endif

      prm%v_0      = math_expand(pl%get_as1dReal('v_0',       requiredSize=size(N_sl)),N_sl)
      prm%b_sl     = math_expand(pl%get_as1dReal('b_sl',      requiredSize=size(N_sl)),N_sl)
      prm%Q_sl     = math_expand(pl%get_as1dReal('Q_sl',      requiredSize=size(N_sl)),N_sl)
      prm%i_sl     = math_expand(pl%get_as1dReal('i_sl',      requiredSize=size(N_sl)),N_sl)
      prm%p        = math_expand(pl%get_as1dReal('p_sl',      requiredSize=size(N_sl)),N_sl)
      prm%q        = math_expand(pl%get_as1dReal('q_sl',      requiredSize=size(N_sl)),N_sl)
      prm%tau_0    = math_expand(pl%get_as1dReal('tau_0',     requiredSize=size(N_sl)),N_sl)
      prm%B        = math_expand(pl%get_as1dReal('B',         requiredSize=size(N_sl), &
                                                 defaultVal=[(0.0_pREAL,i=1,size(N_sl))]),N_sl)
      prm%d_caron  = prm%b_sl * pl%get_asReal('D_a')


      prm%forestProjection = spread(          f_edge,1,prm%sum_N_sl) &
                           * crystal_forestProjection_edge (N_sl,phase_lattice(ph),phase_cOverA(ph)) &
                           + spread(1.0_pREAL-f_edge,1,prm%sum_N_sl) &
                           * crystal_forestProjection_screw(N_sl,phase_lattice(ph),phase_cOverA(ph))

      prm%fccTwinTransNucleation = phase_lattice(ph) == 'cF' .and. N_sl(1) == 12
      if (prm%fccTwinTransNucleation) prm%fcc_twinNucleationSlipPair = crystal_CF_TWINNUCLEATIONSLIPPAIR

      ! multiplication factor according to crystal structure (nearest neighbors bcc vs fcc/hex)
      ! details: Argon & Moffat, Acta Metallurgica, Vol. 29, pg 293 to 299, 1981
      prm%omega = pl%get_asReal('omega', defaultVal=1000.0_pREAL) &
                * merge(12.0_pREAL,8.0_pREAL,any(phase_lattice(ph) == ['cF','hP']))

      ! sanity checks
      if (    prm%Q_cl          <= 0.0_pREAL)          extmsg = trim(extmsg)//' Q_cl'
      if (any(rho_mob_0         <  0.0_pREAL))         extmsg = trim(extmsg)//' rho_mob_0'
      if (any(rho_dip_0         <  0.0_pREAL))         extmsg = trim(extmsg)//' rho_dip_0'
      if (any(prm%v_0           <  0.0_pREAL))         extmsg = trim(extmsg)//' v_0'
      if (any(prm%b_sl          <= 0.0_pREAL))         extmsg = trim(extmsg)//' b_sl'
      if (any(prm%Q_sl          <= 0.0_pREAL))         extmsg = trim(extmsg)//' Q_sl'
      if (any(prm%i_sl          <= 0.0_pREAL))         extmsg = trim(extmsg)//' i_sl'
      if (any(prm%B             <  0.0_pREAL))         extmsg = trim(extmsg)//' B'
      if (any(prm%d_caron       <  0.0_pREAL))         extmsg = trim(extmsg)//' d_caron(D_a,b_sl)'
      if (any(prm%p<=0.0_pREAL .or. prm%p>1.0_pREAL))  extmsg = trim(extmsg)//' p_sl'
      if (any(prm%q< 1.0_pREAL .or. prm%q>2.0_pREAL))  extmsg = trim(extmsg)//' q_sl'
    else slipActive
      rho_mob_0 = emptyRealArray
      rho_dip_0 = emptyRealArray
      allocate(prm%v_0, &
               prm%b_sl, &
               prm%Q_sl, &
               prm%i_sl, &
               prm%p, &
               prm%q, &
               prm%tau_0, &
               prm%B, &
               prm%d_caron, &
               source=emptyRealArray)
      allocate(prm%forestProjection(0,0), &
               prm%h_sl_sl(0,0)) ! PE: What about P_sl and systems_sl?
    end if slipActive

!--------------------------------------------------------------------------------------------------
! twin related parameters
    prm%N_tw = pl%get_as1dInt('N_tw', defaultVal=emptyIntArray)
    prm%sum_N_tw = sum(abs(prm%N_tw))
    twinActive: if (prm%sum_N_tw > 0) then
      prm%P_tw = crystal_SchmidMatrix_twin(prm%N_tw,phase_lattice(ph),phase_cOverA(ph))
      prm%systems_tw = crystal_labels_twin(prm%N_tw,phase_lattice(ph))
      prm%gamma_char_tw = abs(crystal_characteristicShear_twin(prm%N_tw,phase_lattice(ph),phase_cOverA(ph)))

      prm%h_tw_tw = crystal_interaction_TwinByTwin(prm%N_tw,pl%get_as1dReal('h_tw-tw'), phase_lattice(ph))

      prm%L_tw = pl%get_asReal('L_tw')
      prm%i_tw = pl%get_asReal('i_tw')

      prm%b_tw = math_expand(pl%get_as1dReal('b_tw', requiredSize=size(prm%N_tw)),prm%N_tw)
      prm%t_tw = math_expand(pl%get_as1dReal('t_tw', requiredSize=size(prm%N_tw)),prm%N_tw)
      prm%r    = math_expand(pl%get_as1dReal('p_tw', requiredSize=size(prm%N_tw)),prm%N_tw)

      ! sanity checks
      if (.not. prm%fccTwinTransNucleation)   extmsg = trim(extmsg)//' TWIP for non-fcc'
      if (    prm%L_tw          < 0.0_pREAL)  extmsg = trim(extmsg)//' L_tw'
      if (    prm%i_tw          < 0.0_pREAL)  extmsg = trim(extmsg)//' i_tw'
      if (any(prm%b_tw          < 0.0_pREAL)) extmsg = trim(extmsg)//' b_tw'
      if (any(prm%t_tw          < 0.0_pREAL)) extmsg = trim(extmsg)//' t_tw'
      if (any(prm%r             < 0.0_pREAL)) extmsg = trim(extmsg)//' p_tw'
    else twinActive
      allocate(prm%gamma_char_tw, &
               prm%b_tw, &
               prm%t_tw, &
               prm%r, &
               source=emptyRealArray)
      allocate(prm%h_tw_tw(0,0))
    end if twinActive

!--------------------------------------------------------------------------------------------------
! transformation related parameters
    prm%N_tr = pl%get_as1dInt('N_tr', defaultVal=emptyIntArray)
    prm%sum_N_tr = sum(abs(prm%N_tr))
    transActive: if (prm%sum_N_tr > 0) then
      prm%P_tr = crystal_SchmidMatrix_trans(prm%N_tr,'hP',prm%cOverA_hP)
      prm%h_tr_tr = crystal_interaction_TransByTrans(prm%N_tr,pl%get_as1dReal('h_tr-tr'),phase_lattice(ph))

      prm%Delta_G = polynomial(pl,'Delta_G','T')
      prm%i_tr            = pl%get_asReal('i_tr')
      prm%L_tr            = pl%get_asReal('L_tr')
      prm%cOverA_hP       = pl%get_asReal('c/a_hP')
      prm%V_mol           = pl%get_asReal('V_mol')

      prm%b_tr = math_expand(pl%get_as1dReal('b_tr'),prm%N_tr)
      prm%t_tr = math_expand(pl%get_as1dReal('t_tr'),prm%N_tr)
      prm%s    = math_expand(pl%get_as1dReal('p_tr'),prm%N_tr)

      a_cF           = prm%b_tr(1)*sqrt(6.0_pREAL)                                                  ! b_tr is Shockley partial
      prm%h          = 5.0_pREAL * a_cF/sqrt(3.0_pREAL)
      prm%rho        = 4.0_pREAL/(sqrt(3.0_pREAL)*a_cF**2)/N_A

      ! sanity checks
      if (.not. prm%fccTwinTransNucleation)   extmsg = trim(extmsg)//' TRIP for non-fcc'
      if (    prm%L_tr          < 0.0_pREAL)  extmsg = trim(extmsg)//' L_tr'
      if (    prm%V_mol         < 0.0_pREAL)  extmsg = trim(extmsg)//' V_mol'
      if (    prm%i_tr          < 0.0_pREAL)  extmsg = trim(extmsg)//' i_tr'
      if (any(prm%t_tr          < 0.0_pREAL)) extmsg = trim(extmsg)//' t_tr'
      if (any(prm%s             < 0.0_pREAL)) extmsg = trim(extmsg)//' p_tr'
    else transActive
      allocate(prm%s,prm%b_tr,prm%t_tr,source=emptyRealArray)
      allocate(prm%h_tr_tr(0,0))
    end if transActive

!--------------------------------------------------------------------------------------------------
! shearband related parameters
    prm%gamma_0_sb = pl%get_asReal('gamma_0_sb',defaultVal=0.0_pREAL)
    if (prm%gamma_0_sb > 0.0_pREAL) then
      prm%tau_sb   = pl%get_asReal('tau_sb')
      prm%E_sb     = pl%get_asReal('Q_sb')
      prm%p_sb     = pl%get_asReal('p_sb')
      prm%q_sb     = pl%get_asReal('q_sb')

      ! sanity checks
      if (prm%tau_sb <  0.0_pREAL) extmsg = trim(extmsg)//' tau_sb'
      if (prm%E_sb   <  0.0_pREAL) extmsg = trim(extmsg)//' Q_sb'
      if (prm%p_sb   <= 0.0_pREAL) extmsg = trim(extmsg)//' p_sb'
      if (prm%q_sb   <= 0.0_pREAL) extmsg = trim(extmsg)//' q_sb'
    end if

!--------------------------------------------------------------------------------------------------
! parameters required for several mechanisms and their interactions
    if (prm%sum_N_sl + prm%sum_N_tw + prm%sum_N_tr > 0) &
      prm%D    = pl%get_asReal('D')

    if (prm%sum_N_tw + prm%sum_N_tr > 0) then
      prm%x_c  = pl%get_asReal('x_c')
      prm%V_cs = pl%get_asReal('V_cs')
      if (prm%x_c  < 0.0_pREAL)  extmsg = trim(extmsg)//' x_c'
      if (prm%V_cs < 0.0_pREAL)  extmsg = trim(extmsg)//' V_cs'
    end if

    if (prm%sum_N_tw + prm%sum_N_tr > 0 .or. prm%extendedDislocations) &
      prm%Gamma_sf = polynomial(pl,'Gamma_sf','T')

    slipAndTwinActive: if (prm%sum_N_sl * prm%sum_N_tw > 0) then
      prm%h_sl_tw = crystal_interaction_SlipByTwin(N_sl,prm%N_tw,pl%get_as1dReal('h_sl-tw'), &
                                                   phase_lattice(ph))
      if (prm%fccTwinTransNucleation .and. size(prm%N_tw) /= 1) extmsg = trim(extmsg)//' N_tw: nucleation'
    end if slipAndTwinActive

    slipAndTransActive: if (prm%sum_N_sl * prm%sum_N_tr > 0) then
      prm%h_sl_tr = crystal_interaction_SlipByTrans(N_sl,prm%N_tr,pl%get_as1dReal('h_sl-tr'), &
                                                    phase_lattice(ph))
      if (prm%fccTwinTransNucleation .and. size(prm%N_tr) /= 1) extmsg = trim(extmsg)//' N_tr: nucleation'
    end if slipAndTransActive

    twinAndTransActive: if (prm%sum_N_tw * prm%sum_N_tr > 0) then
      if (dNeq(prm%b_tw(1),prm%b_tr(1))) extmsg = trim(extmsg)//' b_tw != b_tr'
    end if twinAndTransActive

!--------------------------------------------------------------------------------------------------
! allocate state arrays
    Nmembers  = count(material_ID_phase == ph)
    sizeDotState = size(['rho_mob ','rho_dip ','gamma_sl']) * prm%sum_N_sl &
                 + size(['f_tw'])                           * prm%sum_N_tw &
                 + size(['f_tr'])                           * prm%sum_N_tr
    sizeState = sizeDotState

    call phase_allocateState(plasticState(ph),Nmembers,sizeState,sizeDotState,0)
    deallocate(plasticState(ph)%dotState) ! ToDo: remove dotState completely

!--------------------------------------------------------------------------------------------------
! state aliases and initialization
    startIndex = 1
    endIndex   = prm%sum_N_sl
    idx_dot%rho_mob = [startIndex,endIndex]
    stt%rho_mob => plasticState(ph)%state(startIndex:endIndex,:)
    stt%rho_mob = spread(rho_mob_0,2,Nmembers)
    plasticState(ph)%atol(startIndex:endIndex) = pl%get_asReal('atol_rho',defaultVal=1.0_pREAL)
    if (any(plasticState(ph)%atol(startIndex:endIndex) < 0.0_pREAL)) extmsg = trim(extmsg)//' atol_rho'

    startIndex = endIndex + 1
    endIndex   = endIndex + prm%sum_N_sl
    idx_dot%rho_dip = [startIndex,endIndex]
    stt%rho_dip => plasticState(ph)%state(startIndex:endIndex,:)
    stt%rho_dip = spread(rho_dip_0,2,Nmembers)
    plasticState(ph)%atol(startIndex:endIndex) = pl%get_asReal('atol_rho',defaultVal=1.0_pREAL)

    startIndex = endIndex + 1
    endIndex   = endIndex + prm%sum_N_sl
    idx_dot%gamma_sl = [startIndex,endIndex]
    stt%gamma_sl => plasticState(ph)%state(startIndex:endIndex,:)
    plasticState(ph)%atol(startIndex:endIndex) = pl%get_asReal('atol_gamma',defaultVal=1.0e-6_pREAL)
    if (any(plasticState(ph)%atol(startIndex:endIndex) < 0.0_pREAL)) extmsg = trim(extmsg)//' atol_gamma'

    startIndex = endIndex + 1
    endIndex   = endIndex + prm%sum_N_tw
    idx_dot%f_tw = [startIndex,endIndex]
    stt%f_tw => plasticState(ph)%state(startIndex:endIndex,:)
    plasticState(ph)%atol(startIndex:endIndex) = pl%get_asReal('atol_f_tw',defaultVal=1.0e-6_pREAL)
    if (any(plasticState(ph)%atol(startIndex:endIndex) < 0.0_pREAL)) extmsg = trim(extmsg)//' atol_f_tw'

    startIndex = endIndex + 1
    endIndex   = endIndex + prm%sum_N_tr
    idx_dot%f_tr = [startIndex,endIndex]
    stt%f_tr => plasticState(ph)%state(startIndex:endIndex,:)
    plasticState(ph)%atol(startIndex:endIndex) = pl%get_asReal('atol_f_tr',defaultVal=1.0e-6_pREAL)
    if (any(plasticState(ph)%atol(startIndex:endIndex) < 0.0_pREAL)) extmsg = trim(extmsg)//' atol_f_tr'

    allocate(dst%tau_pass (prm%sum_N_sl,Nmembers),source=0.0_pREAL)
    allocate(dst%Lambda_sl(prm%sum_N_sl,Nmembers),source=0.0_pREAL)
    allocate(dst%Lambda_tw(prm%sum_N_tw,Nmembers),source=0.0_pREAL)
    allocate(dst%Lambda_tr(prm%sum_N_tr,Nmembers),source=0.0_pREAL)

    end associate

!--------------------------------------------------------------------------------------------------
!  exit if any parameter is out of range
    if (extmsg /= '') call IO_error(211,ext_msg=trim(extmsg))

  end do

end function plastic_dislotwin_init


!--------------------------------------------------------------------------------------------------
!> @brief Return the homogenized elasticity matrix.
!--------------------------------------------------------------------------------------------------
module function plastic_dislotwin_homogenizedC(ph,en) result(homogenizedC)

  integer,     intent(in) :: &
    ph, en
  real(pREAL), dimension(6,6) :: &
    homogenizedC, &
    C
  real(pREAL), dimension(:,:,:), allocatable :: &
    C66_tw, &
    C66_tr
  integer :: i
  real(pREAL) :: f_matrix


  C = elastic_C66(ph,en)

  associate(prm => param(ph), stt => state(ph))

    f_matrix = 1.0_pREAL &
             - sum(stt%f_tw(1:prm%sum_N_tw,en)) &
             - sum(stt%f_tr(1:prm%sum_N_tr,en))

    homogenizedC = f_matrix * C

    twinActive: if (prm%sum_N_tw > 0) then
      C66_tw = crystal_C66_twin(prm%N_tw,C,phase_lattice(ph),phase_cOverA(ph))
      do i = 1, prm%sum_N_tw
        homogenizedC = homogenizedC &
                     + stt%f_tw(i,en)*C66_tw(1:6,1:6,i)
      end do
     end if twinActive

    transActive: if (prm%sum_N_tr > 0) then
      C66_tr = crystal_C66_trans(prm%N_tr,C,'hP',prm%cOverA_hP)
      do i = 1, prm%sum_N_tr
        homogenizedC = homogenizedC &
                     + stt%f_tr(i,en)*C66_tr(1:6,1:6,i)
      end do
    end if transActive

  end associate

end function plastic_dislotwin_homogenizedC


!--------------------------------------------------------------------------------------------------
!> @brief Calculate plastic velocity gradient and its tangent.
!--------------------------------------------------------------------------------------------------
module subroutine dislotwin_LpAndItsTangent(Lp,dLp_dMp,Mp,ph,en)

  real(pREAL), dimension(3,3),     intent(out) :: Lp
  real(pREAL), dimension(3,3,3,3), intent(out) :: dLp_dMp
  real(pREAL), dimension(3,3),     intent(in)  :: Mp
  integer,                         intent(in)  :: ph,en

  integer :: i,k,l,m,n
  real(pREAL) :: &
    f_matrix,StressRatio_p,&
    E_kB_T, &
    ddot_gamma_dtau, &
    tau, &
    T
  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    dot_gamma_sl,ddot_gamma_dtau_sl
  real(pREAL), dimension(param(ph)%sum_N_tw) :: &
    dot_gamma_tw,ddot_gamma_dtau_tw
  real(pREAL), dimension(param(ph)%sum_N_tr) :: &
    dot_gamma_tr,ddot_gamma_dtau_tr
  real(pREAL):: dot_gamma_sb
  real(pREAL), dimension(3,3) :: eigVectors, P_sb
  real(pREAL), dimension(3)   :: eigValues
  real(pREAL), dimension(3,6), parameter :: &
    sb_sComposition = &
      reshape(real([&
         1, 0, 1, &
         1, 0,-1, &
         1, 1, 0, &
         1,-1, 0, &
         0, 1, 1, &
         0, 1,-1  &
         ],pREAL),[ 3,6]), &
    sb_mComposition = &
      reshape(real([&
         1, 0,-1, &
         1, 0,+1, &
         1,-1, 0, &
         1, 1, 0, &
         0, 1,-1, &
         0, 1, 1  &
         ],pREAL),[ 3,6])


  T = thermal_T(ph,en)
  Lp = 0.0_pREAL
  dLp_dMp = 0.0_pREAL

  associate(prm => param(ph), stt => state(ph))

    f_matrix = 1.0_pREAL &
             - sum(stt%f_tw(1:prm%sum_N_tw,en)) &
             - sum(stt%f_tr(1:prm%sum_N_tr,en))

    call kinetics_sl(Mp,T,ph,en,dot_gamma_sl,ddot_gamma_dtau_sl)
    slipContribution: do i = 1, prm%sum_N_sl
      Lp = Lp + dot_gamma_sl(i)*prm%P_sl(1:3,1:3,i)
      forall (k=1:3,l=1:3,m=1:3,n=1:3) &
        dLp_dMp(k,l,m,n) = dLp_dMp(k,l,m,n) &
                         + ddot_gamma_dtau_sl(i) * prm%P_sl(k,l,i) * prm%P_sl(m,n,i)
    end do slipContribution

    if (prm%sum_N_tw > 0) call kinetics_tw(Mp,T,dot_gamma_sl,ph,en,dot_gamma_tw,ddot_gamma_dtau_tw)
    twinContibution: do i = 1, prm%sum_N_tw
      Lp = Lp + dot_gamma_tw(i)*prm%P_tw(1:3,1:3,i)
      forall (k=1:3,l=1:3,m=1:3,n=1:3) &
        dLp_dMp(k,l,m,n) = dLp_dMp(k,l,m,n) &
                         + ddot_gamma_dtau_tw(i)* prm%P_tw(k,l,i)*prm%P_tw(m,n,i)
    end do twinContibution

    if (prm%sum_N_tr > 0) call kinetics_tr(Mp,T,dot_gamma_sl,ph,en,dot_gamma_tr,ddot_gamma_dtau_tr)
    transContibution: do i = 1, prm%sum_N_tr
      Lp = Lp + dot_gamma_tr(i)*prm%P_tr(1:3,1:3,i)
      forall (k=1:3,l=1:3,m=1:3,n=1:3) &
        dLp_dMp(k,l,m,n) = dLp_dMp(k,l,m,n) &
                         + ddot_gamma_dtau_tr(i)* prm%P_tr(k,l,i)*prm%P_tr(m,n,i)
    end do transContibution

    Lp      = Lp      * f_matrix
    dLp_dMp = dLp_dMp * f_matrix

    shearBandingContribution: if (dNeq0(prm%gamma_0_sb)) then

      E_kB_T = prm%E_sb/(K_B*T)
      call math_eigh33(eigValues,eigVectors,Mp)                                                     ! is Mp symmetric by design?

      do i = 1,6
        P_sb = 0.5_pREAL * math_outer(matmul(eigVectors,sb_sComposition(1:3,i)),&
                                      matmul(eigVectors,sb_mComposition(1:3,i)))
        tau = math_tensordot(Mp,P_sb)

        significantShearBandStress: if (abs(tau) > tol_math_check) then
          StressRatio_p = (abs(tau)/prm%tau_sb)**prm%p_sb
          dot_gamma_sb = sign(prm%gamma_0_sb*exp(-E_kB_T*(1-StressRatio_p)**prm%q_sb), tau)
          ddot_gamma_dtau = abs(dot_gamma_sb)*E_kB_T*prm%p_sb*prm%q_sb/prm%tau_sb &
                          * (abs(tau)/prm%tau_sb)**(prm%p_sb-1.0_pREAL) &
                          * (1.0_pREAL-StressRatio_p)**(prm%q_sb-1.0_pREAL)

          Lp = Lp + dot_gamma_sb * P_sb
          forall (k=1:3,l=1:3,m=1:3,n=1:3) &
            dLp_dMp(k,l,m,n) = dLp_dMp(k,l,m,n) &
                             + ddot_gamma_dtau * P_sb(k,l) * P_sb(m,n)
        end if significantShearBandStress
      end do

    end if shearBandingContribution

    end associate

end subroutine dislotwin_LpAndItsTangent


!--------------------------------------------------------------------------------------------------
!> @brief Calculate the rate of change of microstructure.
!--------------------------------------------------------------------------------------------------
module function dislotwin_dotState(Mp,ph,en) result(dotState)

  real(pREAL), dimension(3,3),  intent(in):: &
    Mp                                                                                              !< Mandel stress
  integer,                      intent(in) :: &
    ph, &
    en
  real(pREAL), dimension(plasticState(ph)%sizeDotState) :: &
    dotState

  integer :: i
  real(pREAL) :: &
    f_matrix, &
    d_hat, &
    v_cl, &                                                                                         !< climb velocity
    tau, &
    sigma_cl, &                                                                                     !< climb stress
    b_d                                                                                             !< ratio of Burgers vector to stacking fault width
  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    dot_rho_dip_formation, &
    dot_rho_dip_climb, &
    dot_gamma_sl
  real(pREAL), dimension(param(ph)%sum_N_tw) :: &
    dot_gamma_tw
  real(pREAL), dimension(param(ph)%sum_N_tr) :: &
    dot_gamma_tr
  real(pREAL) :: &
    mu, nu, &
    T


  associate(prm => param(ph), stt => state(ph), dst => dependentState(ph), &
            dot_rho_mob => dotState(indexDotState(ph)%rho_mob(1):indexDotState(ph)%rho_mob(2)), &
            dot_rho_dip => dotState(indexDotState(ph)%rho_dip(1):indexDotState(ph)%rho_dip(2)), &
            abs_dot_gamma_sl => dotState(indexDotState(ph)%gamma_sl(1):indexDotState(ph)%gamma_sl(2)), &
            dot_f_tw => dotState(indexDotState(ph)%f_tw(1):indexDotState(ph)%f_tw(2)), &
            dot_f_tr => dotState(indexDotState(ph)%f_tr(1):indexDotState(ph)%f_tr(2)))

    mu = elastic_mu(ph,en,prm%isotropic_bound)
    nu = elastic_nu(ph,en,prm%isotropic_bound)
    T = thermal_T(ph,en)

    f_matrix = 1.0_pREAL &
             - sum(stt%f_tw(1:prm%sum_N_tw,en)) &
             - sum(stt%f_tr(1:prm%sum_N_tr,en))

    call kinetics_sl(Mp,T,ph,en,dot_gamma_sl)
    abs_dot_gamma_sl = abs(dot_gamma_sl)

    slipState: do i = 1, prm%sum_N_sl
      tau = math_tensordot(Mp,prm%P_sl(1:3,1:3,i))

      significantSlipStress: if (dEq0(tau) .or. prm%omitDipoles) then
        d_hat = dst%Lambda_sl(i,en)
        dot_rho_dip_formation(i) = 0.0_pREAL
      else significantSlipStress
        d_hat = 3.0_pREAL*mu*prm%b_sl(i)/(16.0_pREAL*PI*abs(tau))
        d_hat = math_clip(d_hat, right = dst%Lambda_sl(i,en))
        d_hat = math_clip(d_hat, left  = prm%d_caron(i))

        dot_rho_dip_formation(i) = 2.0_pREAL*(d_hat-prm%d_caron(i))/prm%b_sl(i) &
                                 * stt%rho_mob(i,en)*abs_dot_gamma_sl(i)
      end if significantSlipStress

      if (dEq(d_hat,prm%d_caron(i))) then
        dot_rho_dip_climb(i) = 0.0_pREAL
      else
        ! Argon & Moffat, Acta Metallurgica, Vol. 29, pg 293 to 299, 1981
        sigma_cl = dot_product(prm%n0_sl(1:3,i),matmul(Mp,prm%n0_sl(1:3,i)))
        if (prm%extendedDislocations) then
          b_d = 24.0_pREAL*PI*(1.0_pREAL - nu)/(2.0_pREAL + nu) * prm%Gamma_sf%at(T) / (mu*prm%b_sl(i))
        else
          b_d = 1.0_pREAL
        end if
        v_cl = 2.0_pREAL*prm%omega*b_d**2*exp(-prm%Q_cl/(K_B*T)) &
             * (exp(abs(sigma_cl)*prm%b_sl(i)**3/(K_B*T)) - 1.0_pREAL)
        dot_rho_dip_climb(i) = 4.0_pREAL*v_cl*stt%rho_dip(i,en) &
                             / (d_hat-prm%d_caron(i))
      end if
    end do slipState

    dot_rho_mob = abs_dot_gamma_sl/(prm%b_sl*dst%Lambda_sl(:,en)) &
                - dot_rho_dip_formation &
                - 2.0_pREAL*prm%d_caron/prm%b_sl * stt%rho_mob(:,en)*abs_dot_gamma_sl

    dot_rho_dip = dot_rho_dip_formation &
                - 2.0_pREAL*prm%d_caron/prm%b_sl * stt%rho_dip(:,en)*abs_dot_gamma_sl &
                - dot_rho_dip_climb

    if (prm%sum_N_tw > 0) call kinetics_tw(Mp,T,abs_dot_gamma_sl,ph,en,dot_gamma_tw)
    dot_f_tw = f_matrix*dot_gamma_tw/prm%gamma_char_tw

    if (prm%sum_N_tr > 0) call kinetics_tr(Mp,T,abs_dot_gamma_sl,ph,en,dot_gamma_tr)
    dot_f_tr = f_matrix*dot_gamma_tr/gamma_char_tr

  end associate

end function dislotwin_dotState


!--------------------------------------------------------------------------------------------------
!> @brief Calculate derived quantities from state.
!--------------------------------------------------------------------------------------------------
module subroutine dislotwin_dependentState(ph,en)

  integer,       intent(in) :: &
    ph, &
    en

  real(pREAL) :: &
    sumf_tw, sumf_tr
  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    inv_lambda_sl
  real(pREAL), dimension(param(ph)%sum_N_tw) :: &
    inv_lambda_tw_tw, &                                                                             !< 1/mean free distance between 2 twin stacks from different systems seen by a growing twin
    f_over_t_tw
   real(pREAL), dimension(param(ph)%sum_N_tr) :: &
    inv_lambda_tr_tr, &                                                                             !< 1/mean free distance between 2 martensite stacks from different systems seen by a growing martensite
    f_over_t_tr
  real(pREAL) :: &
    mu


  associate(prm => param(ph), stt => state(ph), dst => dependentState(ph))

    mu = elastic_mu(ph,en,prm%isotropic_bound)
    sumf_tw = sum(stt%f_tw(1:prm%sum_N_tw,en))
    sumf_tr = sum(stt%f_tr(1:prm%sum_N_tr,en))

    ! rescaled volume fraction for topology
    f_over_t_tw = stt%f_tw(1:prm%sum_N_tw,en)/prm%t_tw                                              ! this is per system ...
    f_over_t_tr = sumf_tr/prm%t_tr                                                                  ! but this not
                                                                                                    ! ToDo ...Physically correct, but naming could be adjusted

    inv_lambda_sl = sqrt(matmul(prm%forestProjection,stt%rho_mob(:,en)+stt%rho_dip(:,en)))/prm%i_sl
    if (prm%sum_N_tw > 0 .and. prm%sum_N_sl > 0) &
      inv_lambda_sl = inv_lambda_sl + matmul(prm%h_sl_tw,f_over_t_tw)/(1.0_pREAL-sumf_tw)
    if (prm%sum_N_tr > 0 .and. prm%sum_N_sl > 0) &
      inv_lambda_sl = inv_lambda_sl + matmul(prm%h_sl_tr,f_over_t_tr)/(1.0_pREAL-sumf_tr)
    dst%Lambda_sl(:,en) = prm%D / (1.0_pREAL+prm%D*inv_lambda_sl)

    inv_lambda_tw_tw = matmul(prm%h_tw_tw,f_over_t_tw)/(1.0_pREAL-sumf_tw)
    dst%Lambda_tw(:,en) = prm%i_tw*prm%D/(1.0_pREAL+prm%D*inv_lambda_tw_tw)

    inv_lambda_tr_tr = matmul(prm%h_tr_tr,f_over_t_tr)/(1.0_pREAL-sumf_tr)
    dst%Lambda_tr(:,en) = prm%i_tr*prm%D/(1.0_pREAL+prm%D*inv_lambda_tr_tr)

    !* threshold stress for dislocation motion
    dst%tau_pass(:,en) = mu*prm%b_sl* sqrt(matmul(prm%h_sl_sl,stt%rho_mob(:,en)+stt%rho_dip(:,en)))

  end associate

end subroutine dislotwin_dependentState


!--------------------------------------------------------------------------------------------------
!> @brief Write results to HDF5 output file.
!--------------------------------------------------------------------------------------------------
module subroutine plastic_dislotwin_result(ph,group)

  integer,          intent(in) :: ph
  character(len=*), intent(in) :: group

  integer :: ou


  associate(prm => param(ph), stt => state(ph), dst => dependentState(ph))

    do ou = 1,size(prm%output)

      select case(trim(prm%output(ou)))

        case('rho_mob')
          call result_writeDataset(stt%rho_mob,group,trim(prm%output(ou)), &
                                   'mobile dislocation density','1/m²',prm%systems_sl)
        case('rho_dip')
          call result_writeDataset(stt%rho_dip,group,trim(prm%output(ou)), &
                                   'dislocation dipole density','1/m²',prm%systems_sl)
        case('gamma_sl')
          call result_writeDataset(stt%gamma_sl,group,trim(prm%output(ou)), &
                                   'plastic shear','1',prm%systems_sl)
        case('Lambda_sl')
          call result_writeDataset(dst%Lambda_sl,group,trim(prm%output(ou)), &
                                   'mean free path for slip','m',prm%systems_sl)
        case('tau_pass')
          call result_writeDataset(dst%tau_pass,group,trim(prm%output(ou)), &
                                   'passing stress for slip','Pa',prm%systems_sl)

        case('gamma_tw')
          call result_writeDataset(stt%f_tw*spread(prm%gamma_char_tw,2,size(stt%f_tw,2)), &
                                   group,trim(prm%output(ou)), &
                                   'twinning shear','1',prm%systems_tw)
        case('f_tw')
          call result_writeDataset(stt%f_tw,group,trim(prm%output(ou)), &
                                   'twinned volume fraction','m³/m³',prm%systems_tw)
        case('Lambda_tw')
          call result_writeDataset(dst%Lambda_tw,group,trim(prm%output(ou)), &
                                   'mean free path for twinning','m',prm%systems_tw)

        case('f_tr')
          if (prm%sum_N_tr>0) call result_writeDataset(stt%f_tr,group,trim(prm%output(ou)), &
                                                       'martensite volume fraction','m³/m³')

      end select

    end do

  end associate

end subroutine plastic_dislotwin_result


!--------------------------------------------------------------------------------------------------
!> @brief Calculate shear rates on slip systems, their derivatives with respect to resolved
!         stress, and the resolved stress.
!> @details Derivatives and resolved stress are calculated only optionally.
! NOTE: Contrary to common convention, here the result (i.e. intent(out)) variables have to be put
! at the end since some of them are optional.
!--------------------------------------------------------------------------------------------------
pure subroutine kinetics_sl(Mp,T,ph,en, &
                            dot_gamma_sl,ddot_gamma_dtau_sl,tau_sl)

  real(pREAL), dimension(3,3),  intent(in) :: &
    Mp                                                                                              !< Mandel stress
  real(pREAL),                  intent(in) :: &
    T                                                                                               !< temperature
  integer,                      intent(in) :: &
    ph, &
    en
  real(pREAL), dimension(param(ph)%sum_N_sl), intent(out) :: &
    dot_gamma_sl
  real(pREAL), dimension(param(ph)%sum_N_sl), optional, intent(out) :: &
    ddot_gamma_dtau_sl, &
    tau_sl

  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    ddot_gamma_dtau
  real(pREAL), dimension(param(ph)%sum_N_sl) :: &
    tau, &
    stressRatio, &
    StressRatio_p, &
    Q_kB_T, &
    v_wait_inverse, &                                                                               !< inverse of the effective velocity of a dislocation waiting at obstacles (unsigned)
    v_run_inverse, &                                                                                !< inverse of the velocity of a free moving dislocation (unsigned)
    dV_wait_inverse_dTau, &
    dV_run_inverse_dTau, &
    dV_dTau, &
    tau_eff                                                                                         !< effective resolved stress
  integer :: i


  associate(prm => param(ph), stt => state(ph), dst => dependentState(ph))

    tau = [(math_tensordot(Mp,prm%P_sl(1:3,1:3,i)),i = 1, prm%sum_N_sl)]

    tau_eff = abs(tau)-dst%tau_pass(:,en)

    significantStress: where(tau_eff > tol_math_check)
      stressRatio    = tau_eff/prm%tau_0
      StressRatio_p  = stressRatio** prm%p
      Q_kB_T = prm%Q_sl/(K_B*T)
      v_wait_inverse = exp(Q_kB_T*(1.0_pREAL-StressRatio_p)** prm%q) &
                     / prm%v_0
      v_run_inverse  = prm%B/(tau_eff*prm%b_sl)

      dot_gamma_sl = sign(stt%rho_mob(:,en)*prm%b_sl/(v_wait_inverse+v_run_inverse),tau)

      dV_wait_inverse_dTau = -1.0_pREAL * v_wait_inverse * prm%p * prm%q * Q_kB_T &
                           * (stressRatio**(prm%p-1.0_pREAL)) &
                           * (1.0_pREAL-StressRatio_p)**(prm%q-1.0_pREAL) &
                           / prm%tau_0
      dV_run_inverse_dTau  = -1.0_pREAL * v_run_inverse/tau_eff
      dV_dTau              = -1.0_pREAL * (dV_wait_inverse_dTau+dV_run_inverse_dTau) &
                           / (v_wait_inverse+v_run_inverse)**2
      ddot_gamma_dtau = dV_dTau*stt%rho_mob(:,en)*prm%b_sl
    else where significantStress
      dot_gamma_sl    = 0.0_pREAL
      ddot_gamma_dtau = 0.0_pREAL
    end where significantStress

  end associate

  if (present(ddot_gamma_dtau_sl)) ddot_gamma_dtau_sl = ddot_gamma_dtau
  if (present(tau_sl))             tau_sl             = tau

end subroutine kinetics_sl


!--------------------------------------------------------------------------------------------------
!> @brief Calculate shear rates on twin systems and their derivatives with respect to resolved
!         stress.
!> @details Derivatives are calculated only optionally.
! NOTE: Contrary to common convention, here the result (i.e. intent(out)) variables have to be put
! at the end since some of them are optional.
!--------------------------------------------------------------------------------------------------
pure subroutine kinetics_tw(Mp,T,abs_dot_gamma_sl,ph,en,&
                            dot_gamma_tw,ddot_gamma_dtau_tw)

  real(pREAL), dimension(3,3),  intent(in) :: &
    Mp                                                                                              !< Mandel stress
  real(pREAL),                  intent(in) :: &
    T                                                                                               !< temperature
  integer,                      intent(in) :: &
    ph, &
    en
  real(pREAL), dimension(param(ph)%sum_N_sl), intent(in) :: &
    abs_dot_gamma_sl
  real(pREAL), dimension(param(ph)%sum_N_tw), intent(out) :: &
    dot_gamma_tw
  real(pREAL), dimension(param(ph)%sum_N_tw), optional, intent(out) :: &
    ddot_gamma_dtau_tw

  real(pREAL) :: &
    tau, tau_r, tau_hat, &
    dot_N_0, &
    x0, V, &
    Gamma_sf, &
    mu, nu, &
    P_ncs, dP_ncs_dtau, &
    P, dP_dtau
  integer, dimension(2) :: &
    s
  integer :: i


  associate(prm => param(ph), stt => state(ph), dst => dependentState(ph))

    mu = elastic_mu(ph,en,prm%isotropic_bound)
    nu = elastic_nu(ph,en,prm%isotropic_bound)
    Gamma_sf = prm%Gamma_sf%at(T)

    tau_hat = 3.0_pREAL*prm%b_tw(1)*mu/prm%L_tw &
            + Gamma_sf/(3.0_pREAL*prm%b_tw(1))
    x0 = mu*prm%b_sl(1)**2*(2.0_pREAL+nu)/(Gamma_sf*8.0_pREAL*PI*(1.0_pREAL-nu))
    tau_r = mu*prm%b_sl(1)/(2.0_pREAL*PI)*(1.0_pREAL/(x0+prm%x_c)+cos(PI/3.0_pREAL)/x0)

    do i = 1, prm%sum_N_tw
      tau = math_tensordot(Mp,prm%P_tw(1:3,1:3,i))

      if (tau > tol_math_check .and. tau < tau_r) then
        P = exp(-(tau_hat/tau)**prm%r(i))
        dP_dTau = prm%r(i) * (tau_hat/tau)**prm%r(i)/tau * P

        s = prm%fcc_twinNucleationSlipPair(1:2,i)
        dot_N_0 = sum(abs_dot_gamma_sl(s(2:1:-1))*(stt%rho_mob(s,en)+stt%rho_dip(s,en)))/(prm%L_tw*3.0_pREAL)

        P_ncs = 1.0_pREAL-exp(-prm%V_cs/(K_B*T)*(tau_r-tau))
        dP_ncs_dtau = prm%V_cs / (K_B * T) * (P_ncs - 1.0_pREAL)

        V = PI/4.0_pREAL*dst%Lambda_tw(i,en)**2*prm%t_tw(i)
        dot_gamma_tw(i) = V*dot_N_0*P_ncs*P*prm%gamma_char_tw(i)
        if (present(ddot_gamma_dtau_tw)) &
          ddot_gamma_dtau_tw(i) = V*dot_N_0*(P*dP_ncs_dtau + P_ncs*dP_dtau)*prm%gamma_char_tw(i)
      else
        dot_gamma_tw(i) = 0.0_pREAL
        if (present(ddot_gamma_dtau_tw)) ddot_gamma_dtau_tw(i) = 0.0_pREAL
      end if
    end do

  end associate

end subroutine kinetics_tw


!--------------------------------------------------------------------------------------------------
!> @brief Calculate shear rates on transformation systems and their derivatives with respect to
!         resolved stress.
!> @details Derivatives are calculated only optionally.
! NOTE: Contrary to common convention, here the result (i.e. intent(out)) variables have to be put
! at the end since some of them are optional.
!--------------------------------------------------------------------------------------------------
pure subroutine kinetics_tr(Mp,T,abs_dot_gamma_sl,ph,en,&
                            dot_gamma_tr,ddot_gamma_dtau_tr)

  real(pREAL), dimension(3,3),  intent(in) :: &
    Mp                                                                                              !< Mandel stress
  real(pREAL),                  intent(in) :: &
    T                                                                                               !< temperature
  integer,                      intent(in) :: &
    ph, &
    en
  real(pREAL), dimension(param(ph)%sum_N_sl), intent(in) :: &
    abs_dot_gamma_sl
  real(pREAL), dimension(param(ph)%sum_N_tr), intent(out) :: &
    dot_gamma_tr
  real(pREAL), dimension(param(ph)%sum_N_tr), optional, intent(out) :: &
    ddot_gamma_dtau_tr

  real(pREAL) :: &
    tau, tau_r, tau_hat, &
    dot_N_0, &
    x0, V, &
    Gamma_sf, &
    mu, nu, &
    P_ncs, dP_ncs_dtau, &
    P, dP_dtau
  integer, dimension(2) :: &
    s
  integer :: i


  associate(prm => param(ph), stt => state(ph), dst => dependentState(ph))

    mu = elastic_mu(ph,en,prm%isotropic_bound)
    nu = elastic_nu(ph,en,prm%isotropic_bound)
    Gamma_sf = prm%Gamma_sf%at(T)

    tau_hat = 3.0_pREAL*prm%b_tr(1)*mu/prm%L_tr &
            + (Gamma_sf + (prm%h/prm%V_mol - 2.0_pREAL*prm%rho)*prm%Delta_G%at(T))/(3.0_pREAL*prm%b_tr(1))
    x0 = mu*prm%b_sl(1)**2*(2.0_pREAL+nu)/(Gamma_sf*8.0_pREAL*PI*(1.0_pREAL-nu))
    tau_r = mu*prm%b_sl(1)/(2.0_pREAL*PI)*(1.0_pREAL/(x0+prm%x_c)+cos(PI/3.0_pREAL)/x0)

    do i = 1, prm%sum_N_tr
      tau = math_tensordot(Mp,prm%P_tr(1:3,1:3,i))

      if (tau > tol_math_check .and. tau < tau_r) then
        P = exp(-(tau_hat/tau)**prm%s(i))
        dP_dTau = prm%s(i) * (tau_hat/tau)**prm%s(i)/tau * P

        s = prm%fcc_twinNucleationSlipPair(1:2,i)
        dot_N_0 = sum(abs_dot_gamma_sl(s(2:1:-1))*(stt%rho_mob(s,en)+stt%rho_dip(s,en)))/(prm%L_tr*3.0_pREAL)

        P_ncs = 1.0_pREAL-exp(-prm%V_cs/(K_B*T)*(tau_r-tau))
        dP_ncs_dtau = prm%V_cs / (K_B * T) * (P_ncs - 1.0_pREAL)

        V = PI/4.0_pREAL*dst%Lambda_tr(i,en)**2*prm%t_tr(i)
        dot_gamma_tr(i) = V*dot_N_0*P_ncs*P*gamma_char_tr
        if (present(ddot_gamma_dtau_tr)) &
          ddot_gamma_dtau_tr(i) = V*dot_N_0*(P*dP_ncs_dtau + P_ncs*dP_dtau)*gamma_char_tr
      else
        dot_gamma_tr(i) = 0.0_pREAL
        if (present(ddot_gamma_dtau_tr)) ddot_gamma_dtau_tr(i) = 0.0_pREAL
      end if
    end do

  end associate

end subroutine kinetics_tr

end submodule dislotwin
